Imports CQG
Imports System.Runtime.InteropServices
Imports System.Xml

Public Class frmAccountsInfo
   Inherits System.Windows.Forms.Form

   ' GUID of algorithmic order.
   Private Const ORDER_GUID As String = "{EC391CF3-F663-4fdd-8CDD-F8CE4809B928}"

   ' XML file name accounts to load.
   Public Const XML_FILE_NAME As String = "Accounts.xml"

   ' Main account Id.
   Private m_MainAccountId As Integer

   Private Structure AccountProperties

      Public AccountID As Integer
      Public OrderRatio As Integer

   End Structure

   ' Collection of replication accounts ids and ratios.
   Private m_RepAccountProps As ArrayList

   ' Flag indicates whether algorithmic order is registered.
   Private m_isAlgorithmicOrderRegistered As Boolean

   ' CQGCEL object.
   Private WithEvents m_CEL As CQGCEL

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()

      'Add any initialization after the InitializeComponent() call

   End Sub

   'Form overrides dispose to clean up the component list.
   Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If disposing Then
         If Not (components Is Nothing) Then
            components.Dispose()
         End If
      End If
      MyBase.Dispose(disposing)
   End Sub

   'Required by the Windows Form Designer
   Private components As System.ComponentModel.IContainer

   'NOTE: The following procedure is required by the Windows Form Designer
   'It can be modified using the Windows Form Designer.  
   'Do not modify it using the code editor.
   Friend WithEvents llWeb As System.Windows.Forms.LinkLabel
   Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
   Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
   Friend WithEvents btnExportXML As System.Windows.Forms.Button
   Friend WithEvents grpMainAccount As System.Windows.Forms.GroupBox
   Friend WithEvents grpRepAccounts As System.Windows.Forms.GroupBox
   Friend WithEvents ColumnHeader5 As System.Windows.Forms.ColumnHeader
   Friend WithEvents ColumnHeader6 As System.Windows.Forms.ColumnHeader
   Friend WithEvents ColumnHeader7 As System.Windows.Forms.ColumnHeader
   Friend WithEvents ColumnHeader8 As System.Windows.Forms.ColumnHeader
   Friend WithEvents lvRepAccounts As System.Windows.Forms.ListView
   Friend WithEvents lblGWConnection As System.Windows.Forms.Label
   Friend WithEvents ColumnHeader1 As System.Windows.Forms.ColumnHeader
   Friend WithEvents ColumnHeader2 As System.Windows.Forms.ColumnHeader
   Friend WithEvents ColumnHeader3 As System.Windows.Forms.ColumnHeader
   Friend WithEvents ColumnHeader4 As System.Windows.Forms.ColumnHeader
   Friend WithEvents lvMainAccount As System.Windows.Forms.ListView
   Friend WithEvents ColumnHeader9 As System.Windows.Forms.ColumnHeader
   Friend WithEvents cmRatio As System.Windows.Forms.ContextMenu
   Friend WithEvents miChangeRatio As System.Windows.Forms.MenuItem
   Friend WithEvents chkWorkingMode As System.Windows.Forms.CheckBox
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.llWeb = New System.Windows.Forms.LinkLabel()
      Me.grpMainAccount = New System.Windows.Forms.GroupBox()
      Me.lvMainAccount = New System.Windows.Forms.ListView()
      Me.ColumnHeader1 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader2 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader3 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader4 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.GroupBox4 = New System.Windows.Forms.GroupBox()
      Me.PictureBox1 = New System.Windows.Forms.PictureBox()
      Me.btnExportXML = New System.Windows.Forms.Button()
      Me.grpRepAccounts = New System.Windows.Forms.GroupBox()
      Me.lvRepAccounts = New System.Windows.Forms.ListView()
      Me.ColumnHeader5 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader6 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader7 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader8 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.ColumnHeader9 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
      Me.cmRatio = New System.Windows.Forms.ContextMenu()
      Me.miChangeRatio = New System.Windows.Forms.MenuItem()
      Me.lblGWConnection = New System.Windows.Forms.Label()
      Me.chkWorkingMode = New System.Windows.Forms.CheckBox()
      Me.grpMainAccount.SuspendLayout()
      CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
      Me.grpRepAccounts.SuspendLayout()
      Me.SuspendLayout()
      '
      'llWeb
      '
      Me.llWeb.LinkArea = New System.Windows.Forms.LinkArea(18, 40)
      Me.llWeb.Location = New System.Drawing.Point(352, 16)
      Me.llWeb.Name = "llWeb"
      Me.llWeb.Size = New System.Drawing.Size(336, 16)
      Me.llWeb.TabIndex = 22
      Me.llWeb.TabStop = True
      Me.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx"
      Me.llWeb.UseCompatibleTextRendering = True
      '
      'grpMainAccount
      '
      Me.grpMainAccount.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
      Me.grpMainAccount.Controls.Add(Me.lvMainAccount)
      Me.grpMainAccount.Font = New System.Drawing.Font("Arial", 9.75!)
      Me.grpMainAccount.Location = New System.Drawing.Point(8, 48)
      Me.grpMainAccount.Name = "grpMainAccount"
      Me.grpMainAccount.Size = New System.Drawing.Size(688, 200)
      Me.grpMainAccount.TabIndex = 51
      Me.grpMainAccount.TabStop = False
      Me.grpMainAccount.Text = "Main Account"
      '
      'lvMainAccount
      '
      Me.lvMainAccount.AllowDrop = True
      Me.lvMainAccount.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
      Me.lvMainAccount.CheckBoxes = True
      Me.lvMainAccount.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader1, Me.ColumnHeader2, Me.ColumnHeader3, Me.ColumnHeader4})
      Me.lvMainAccount.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lvMainAccount.FullRowSelect = True
      Me.lvMainAccount.GridLines = True
      Me.lvMainAccount.Location = New System.Drawing.Point(8, 24)
      Me.lvMainAccount.Name = "lvMainAccount"
      Me.lvMainAccount.Size = New System.Drawing.Size(672, 168)
      Me.lvMainAccount.TabIndex = 4
      Me.lvMainAccount.UseCompatibleStateImageBehavior = False
      Me.lvMainAccount.View = System.Windows.Forms.View.Details
      '
      'ColumnHeader1
      '
      Me.ColumnHeader1.Text = "GWAccountID"
      Me.ColumnHeader1.Width = 152
      '
      'ColumnHeader2
      '
      Me.ColumnHeader2.Text = "GWAccountName"
      Me.ColumnHeader2.Width = 172
      '
      'ColumnHeader3
      '
      Me.ColumnHeader3.Text = "FcmAccountID"
      Me.ColumnHeader3.Width = 142
      '
      'ColumnHeader4
      '
      Me.ColumnHeader4.Text = "FcmId"
      Me.ColumnHeader4.Width = 111
      '
      'GroupBox4
      '
      Me.GroupBox4.Location = New System.Drawing.Point(8, 296)
      Me.GroupBox4.Name = "GroupBox4"
      Me.GroupBox4.Size = New System.Drawing.Size(816, 240)
      Me.GroupBox4.TabIndex = 45
      Me.GroupBox4.TabStop = False
      '
      'PictureBox1
      '
      Me.PictureBox1.Location = New System.Drawing.Point(0, 32)
      Me.PictureBox1.Name = "PictureBox1"
      Me.PictureBox1.Size = New System.Drawing.Size(1208, 8)
      Me.PictureBox1.TabIndex = 59
      Me.PictureBox1.TabStop = False
      '
      'btnExportXML
      '
      Me.btnExportXML.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
      Me.btnExportXML.Location = New System.Drawing.Point(8, 496)
      Me.btnExportXML.Name = "btnExportXML"
      Me.btnExportXML.Size = New System.Drawing.Size(144, 32)
      Me.btnExportXML.TabIndex = 60
      Me.btnExportXML.Text = "Export  XML"
      '
      'grpRepAccounts
      '
      Me.grpRepAccounts.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
            Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
      Me.grpRepAccounts.Controls.Add(Me.lvRepAccounts)
      Me.grpRepAccounts.Font = New System.Drawing.Font("Arial", 9.75!)
      Me.grpRepAccounts.Location = New System.Drawing.Point(8, 256)
      Me.grpRepAccounts.Name = "grpRepAccounts"
      Me.grpRepAccounts.Size = New System.Drawing.Size(688, 200)
      Me.grpRepAccounts.TabIndex = 61
      Me.grpRepAccounts.TabStop = False
      Me.grpRepAccounts.Text = "Replication Accounts"
      '
      'lvRepAccounts
      '
      Me.lvRepAccounts.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
            Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
      Me.lvRepAccounts.CheckBoxes = True
      Me.lvRepAccounts.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader5, Me.ColumnHeader6, Me.ColumnHeader7, Me.ColumnHeader8, Me.ColumnHeader9})
      Me.lvRepAccounts.ContextMenu = Me.cmRatio
      Me.lvRepAccounts.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lvRepAccounts.FullRowSelect = True
      Me.lvRepAccounts.GridLines = True
      Me.lvRepAccounts.Location = New System.Drawing.Point(8, 24)
      Me.lvRepAccounts.Name = "lvRepAccounts"
      Me.lvRepAccounts.Size = New System.Drawing.Size(672, 168)
      Me.lvRepAccounts.TabIndex = 0
      Me.lvRepAccounts.UseCompatibleStateImageBehavior = False
      Me.lvRepAccounts.View = System.Windows.Forms.View.Details
      '
      'ColumnHeader5
      '
      Me.ColumnHeader5.Text = "GWAccountID"
      Me.ColumnHeader5.Width = 152
      '
      'ColumnHeader6
      '
      Me.ColumnHeader6.Text = "GWAccountName"
      Me.ColumnHeader6.Width = 172
      '
      'ColumnHeader7
      '
      Me.ColumnHeader7.Text = "FcmAccountID"
      Me.ColumnHeader7.Width = 142
      '
      'ColumnHeader8
      '
      Me.ColumnHeader8.Text = "FcmId"
      Me.ColumnHeader8.Width = 111
      '
      'ColumnHeader9
      '
      Me.ColumnHeader9.Text = "OrderRatio"
      Me.ColumnHeader9.Width = 75
      '
      'cmRatio
      '
      Me.cmRatio.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miChangeRatio})
      '
      'miChangeRatio
      '
      Me.miChangeRatio.Index = 0
      Me.miChangeRatio.Text = "Set Order Ratio"
      '
      'lblGWConnection
      '
      Me.lblGWConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
      Me.lblGWConnection.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lblGWConnection.Location = New System.Drawing.Point(8, 16)
      Me.lblGWConnection.Name = "lblGWConnection"
      Me.lblGWConnection.Size = New System.Drawing.Size(216, 16)
      Me.lblGWConnection.TabIndex = 62
      Me.lblGWConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'chkWorkingMode
      '
      Me.chkWorkingMode.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
      Me.chkWorkingMode.Font = New System.Drawing.Font("Arial", 9.75!)
      Me.chkWorkingMode.Location = New System.Drawing.Point(8, 464)
      Me.chkWorkingMode.Name = "chkWorkingMode"
      Me.chkWorkingMode.Size = New System.Drawing.Size(216, 24)
      Me.chkWorkingMode.TabIndex = 0
      Me.chkWorkingMode.Text = "Multiply order quantity by ratio"
      '
      'frmAccountsInfo
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.ClientSize = New System.Drawing.Size(702, 541)
      Me.Controls.Add(Me.chkWorkingMode)
      Me.Controls.Add(Me.lblGWConnection)
      Me.Controls.Add(Me.grpRepAccounts)
      Me.Controls.Add(Me.btnExportXML)
      Me.Controls.Add(Me.PictureBox1)
      Me.Controls.Add(Me.grpMainAccount)
      Me.Controls.Add(Me.llWeb)
      Me.MaximizeBox = False
      Me.MinimumSize = New System.Drawing.Size(718, 579)
      Me.Name = "frmAccountsInfo"
      Me.Text = "Accounts Info"
      Me.grpMainAccount.ResumeLayout(False)
      CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
      Me.grpRepAccounts.ResumeLayout(False)
      Me.ResumeLayout(False)

   End Sub

#End Region

   ''' <summary>
   ''' Creates an m_CEL object, change its configurations, starts up and initializes HashTable and grids.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub frmAccountsInfo_Load( _
                        ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles MyBase.Load
      Try
         CEL_GWConnectionStatusChanged(eConnectionStatus.csConnectionDown)

         m_CEL = New CQGCEL
         m_isAlgorithmicOrderRegistered = False
         m_CEL.APIConfiguration.CollectionsThrowException = False
         m_CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff
         m_CEL.Startup()
      Catch ex As Exception
         HandleError("frmAccountsInfo", "frmAccountsInfo_Load", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Shuts down m_CEL.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A CancelEventArgs that contains the event data.
   ''' </param>
   Private Sub frmAccountsInfo_Closing( _
                        ByVal sender As Object, _
                        ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
      Try
         If m_isAlgorithmicOrderRegistered Then
            UnRegisterAlgorithmicOrder()
         End If

         m_CEL.Shutdown()
      Catch ex As Exception
         HandleError("frmAccountsInfo", "frmAccountsInfo_Closing", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired when the status of the connection with the CQG Gateway is changed.
   ''' </summary>
   ''' <param name="newStatus">
   ''' The current status of the connection with CQG Gateway.
   ''' </param>
   Private Sub CEL_GWConnectionStatusChanged( _
               ByVal newStatus As CQG.eConnectionStatus) Handles m_CEL.GWConnectionStatusChanged
      Try
         Dim info As String
         Dim BackCol As System.Drawing.Color

         If newStatus <> eConnectionStatus.csConnectionUp Then
            BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
            info = "GW Connection is " & IIf(newStatus = eConnectionStatus.csConnectionDelayed, _
                                                                  "Delayed", "Down").ToString()
            ' Clearing all shown data, because after GW connection up we will receive all data again.
            ClearRecords()
         Else
            BackCol = System.Drawing.Color.FromArgb(192, 209, 205)
            info = "GW Connection is UP"
            If Not m_isAlgorithmicOrderRegistered Then
               RegisterAlgorithmicOrder()
            Else
               m_CEL.AccountSubscriptionLevel = eAccountSubscriptionLevel.aslAccountsOnly
            End If
         End If

         lblGWConnection.BackColor = BackCol
         lblGWConnection.Text = info
      Catch ex As Exception
         HandleError("frmAccountsInfo", "CEL_GWConnectionStatusChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when the account or position information is changed.
   ''' </summary>
   ''' <param name="change">
   ''' Account change type, which allows to differentiate the occurred changes. 
   ''' </param>
   ''' <param name="Account">
   ''' A CQGAccount object, representing the account to which the current change refers.
   ''' </param>
   ''' <param name="position">
   ''' A CQGPosition object, representing the position to which the current change refers.
   ''' </param>
   Private Sub CEL_AccountChanged( _
               ByVal change As CQG.eAccountChangeType, _
               ByVal account As CQGAccount, _
               ByVal position As CQG.CQGPosition) Handles m_CEL.AccountChanged
      Try
         Select Case change
            Case eAccountChangeType.actAccountsReloaded
               ClearRecords()
               For Each acc As CQGAccount In m_CEL.Accounts
                  DumpRecords(lvMainAccount, acc)
                  DumpRecords(lvRepAccounts, acc)
               Next
         End Select
      Catch ex As Exception
         HandleError("frmAccountsInfo", "CEL_AccountChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
   ''' </summary>
   ''' <param name="obj">
   ''' Object, in which the error occurred.
   ''' </param>
   ''' <param name="errorDescription">
   ''' String, describing the error.
   ''' </param>
   Private Sub CEL_DataError( _
               ByVal obj As Object, _
               ByVal errorDescription As String) Handles m_CEL.DataError
      Try
         Dim cqgErr As CQGError = TryCast(obj, CQGError)
         If m_CEL.IsValid(cqgErr) Then
            If cqgErr.Code = 102 Then
               errorDescription &= " Restart the application."
            ElseIf cqgErr.Code = 125 Then
               errorDescription &= " Turn on CQG Client and restart the application."
            End If
         End If

         MessageBox.Show(errorDescription, "AccountsInfo", MessageBoxButtons.OK, MessageBoxIcon.Information)
      Catch ex As Exception
         HandleError("frmAccountsInfo", "CEL_DataError", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when algorithmic order registration is completed.
   ''' </summary>
   ''' <param name="guid_">
   ''' Order's guid
   ''' </param>
   ''' <param name="cqg_error">
   ''' Error object
   ''' </param>
   Private Sub CEL_AlgorithmicOrderRegistrationComplete( _
               ByVal guid_ As String, _
               ByVal cqg_error As CQG.CQGError) Handles m_CEL.AlgorithmicOrderRegistrationComplete

      Try
         If Not m_CEL.IsValid(cqg_error) Then
            m_CEL.AccountSubscriptionLevel = eAccountSubscriptionLevel.aslAccountsOnly
            m_isAlgorithmicOrderRegistered = True
         Else
            MessageBox.Show(cqg_error.Description, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
         End If
      Catch ex As Exception
         HandleError("frmAccountsInfo", "CEL_AlgorithmicOrderRegistrationComplete", ex)
      End Try

   End Sub

   ''' <summary>
   ''' Open CQG API web page.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A LinkLabelLinkClickedEventArgs that contains the event data.
   ''' </param>
   Private Sub llWeb_LinkClicked( _
                 ByVal sender As System.Object, _
                 ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles llWeb.LinkClicked
      Try
         System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx")
      Catch ex As Exception
         HandleError("frmAccountsInfo", "llWeb_LinkClicked", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Exports selected accounts' ids into xml file
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub btnExportXML_Click( _
                      ByVal sender As System.Object, _
                      ByVal e As System.EventArgs) Handles btnExportXML.Click

      Try
         ' Validate data selected for export
         If Not ValidateAndPutSelectedMainAccount() OrElse _
              Not ValidateAndPutReplicationAccounts() Then
            Return
         End If

         ' Get directory to export
         With New FolderBrowserDialog
            .Description = "Select the directory where the file will be exported."
            .SelectedPath = Application.StartupPath

            If .ShowDialog(Me) = DialogResult.OK Then
               Dim path As String = .SelectedPath & "\" & XML_FILE_NAME
               Dim proceed As Boolean = True
               If System.IO.File.Exists(path) Then
                  ' Check for replace confirmation
                  proceed = MessageBox.Show("Selected directory already contains export file." & vbCrLf & _
                                      "Would you like to replace the existing file?", _
                                      "Confirm File Replace", MessageBoxButtons.YesNo, _
                                      MessageBoxIcon.Question) = DialogResult.Yes
               End If

               If proceed Then
                  ' Dump files to the file
                  DumpAccounts(path)
               End If
            End If
         End With
      Catch ex As Exception
         HandleError("frmAccountsInfo", "btnExportXML_Click", ex)
      End Try
   End Sub

   Protected Overrides Sub Finalize()
      MyBase.Finalize()
   End Sub

   ''' <summary> 
   ''' Registers algorithmic order.
   ''' </summary>
   Private Sub RegisterAlgorithmicOrder()

      Dim aoDefinitions As CQG.CQGAlgorithmicOrderDefinitions = m_CEL.CreateAlgorithmicOrderDefinitions()

      ' Registering REP order
      m_CEL.RegisterAlgorithmicOrder( _
                  ORDER_GUID, _
                  "XX", _
                  "XX", _
                  "", _
                  aoDefinitions, _
                  1)

   End Sub

   ''' <summary>
   ''' Unregisters algorithmic order from CQGIC.
   ''' </summary>
   Private Sub UnRegisterAlgorithmicOrder()

      ' UnRegistering algorithmic order
      m_CEL.UnregisterAlgorithmicOrder(ORDER_GUID)
      m_isAlgorithmicOrderRegistered = False

   End Sub

   ''' <summary>
   ''' Dumps accounts into xml file
   ''' </summary>
   Private Sub DumpAccounts(ByVal path As String)

      Dim xmlWriter As New XmlTextWriter(path, Nothing)
      xmlWriter.Formatting = Formatting.Indented

      xmlWriter.WriteStartDocument()
      xmlWriter.WriteStartElement("accounts")

      xmlWriter.WriteString(Environment.NewLine)
      xmlWriter.WriteStartElement("main_account")
      xmlWriter.WriteString(m_MainAccountId.ToString())
      xmlWriter.WriteEndElement()

      xmlWriter.WriteString(Environment.NewLine)
      xmlWriter.WriteStartElement("multiply_by_ratio")
      xmlWriter.WriteString(IIf(chkWorkingMode.Checked, Boolean.TrueString, Boolean.FalseString))
      xmlWriter.WriteEndElement()

      xmlWriter.WriteString(Environment.NewLine)
      xmlWriter.WriteStartElement("rep_accounts")
      xmlWriter.WriteString(Environment.NewLine)

      For Each curAccProp As AccountProperties In m_RepAccountProps
         xmlWriter.WriteStartElement("rep_account")
         xmlWriter.WriteStartElement("rep_id")
         xmlWriter.WriteString(curAccProp.AccountID.ToString())
         xmlWriter.WriteEndElement()
         xmlWriter.WriteStartElement("rep_ratio")
         xmlWriter.WriteString(curAccProp.OrderRatio.ToString())
         xmlWriter.WriteEndElement()
         xmlWriter.WriteEndElement()
      Next

      xmlWriter.WriteEndElement()
      xmlWriter.WriteEndElement()
      xmlWriter.WriteEndDocument()
      xmlWriter.Close()

   End Sub

   ''' <summary>
   ''' Dumps one record's values to the listview.
   ''' </summary>
   ''' <param name="lv">
   ''' Listview, in which data must be shown.
   ''' </param>
   ''' <param name="account">
   ''' Record, which values must be shown.
   ''' </param>
   Private Sub DumpRecords(ByVal lv As ListView, _
                     ByVal account As CQGAccount)

      Dim item As ListViewItem = lv.Items.Add(New ListViewItem)
      item.Text = account.GWAccountID.ToString()
      item.SubItems.Add("GWAccountName").Text = account.GWAccountName.ToString()
      item.SubItems.Add("FcmAccountID").Text = account.FcmAccountID.ToString()
      item.SubItems.Add("FcmId").Text = account.FcmID.ToString()

      If lv.Name = "lvRepAccounts" Then
         item.SubItems.Add("OrderRatio").Text = "1"
      End If

   End Sub

   ''' <summary>
   ''' Clears records from the listviews.
   ''' </summary>
   Private Sub ClearRecords()
      Try
         lvMainAccount.Items.Clear()
         lvRepAccounts.Items.Clear()
      Catch ex As Exception
         HandleError("frmAccountsInfo", "ClearRecords", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Validates and sets main account Id.
   ''' </summary>
   ''' <Returns> 
   ''' Returns true if only one account is selected, false otherwise
   ''' </Returns>
   Private Function ValidateAndPutSelectedMainAccount() As Boolean

      If lvMainAccount.CheckedItems.Count = 0 Then
         MessageBox.Show("Main account is not selected.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning)
         Return False
      End If

      If lvMainAccount.CheckedItems.Count > 1 Then
         MessageBox.Show("Only one account can be main.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning)
         Return False
      End If

      ' Only one account is checked as main account
      m_MainAccountId = CInt(lvMainAccount.CheckedItems.Item(0).SubItems(0).Text)

      Return True

   End Function

   ''' <summary>
   ''' Validates replication accounts' ids and adds them into collection of replication accounts.
   ''' </summary>
   ''' <Returns> 
   ''' Returns true if replication accounts are valid(replication and main accounts are not the same),false otherwise
   ''' </Returns>
   Private Function ValidateAndPutReplicationAccounts() As Boolean

      Dim checkedIndices As ListView.CheckedIndexCollection = lvRepAccounts.CheckedIndices

      If checkedIndices.Count = 0 Then
         MessageBox.Show("No replication account selected.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning)
         Return False
      End If

      m_RepAccountProps = New ArrayList

      For Each index As Integer In checkedIndices
         Dim accProp As AccountProperties = New AccountProperties
         accProp.AccountID = CInt(lvRepAccounts.Items(index).SubItems(0).Text)
         accProp.OrderRatio = CInt(lvRepAccounts.Items(index).SubItems(4).Text)
         If accProp.AccountID = m_MainAccountId Then
            MessageBox.Show("Main account can not be selected as replication one.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Return False
         End If
         m_RepAccountProps.Add(accProp)
      Next

      Return True

   End Function

   ''' <summary>
   ''' Sets ratio for selected replication account
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub miChangeRatio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miChangeRatio.Click

      Try
         If lvRepAccounts.SelectedIndices(0) > -1 Then
            Dim repRatioDialog As frmReplicationRatioDlg = New frmReplicationRatioDlg
            If repRatioDialog.ShowDialog(Me) = DialogResult.OK Then
               lvRepAccounts.SelectedItems(0).SubItems(4).Text = repRatioDialog.RepRatio.ToString()
               lvRepAccounts.SelectedItems(0).Checked = True
            End If
         End If
      Catch ex As Exception
         HandleError("frmAccountsInfo", "miChangeRatio_Click", ex)
      End Try

   End Sub

End Class