using System;
using System.Windows.Forms;
using CQG;

namespace AutoTrader
{
	public class frmAutoTrader : System.Windows.Forms.Form
	{

		[STAThread]
		static void Main()
		{
			Application.Run(new frmAutoTrader());
		}

		public AutoTraderCollection g_ATC;

		// The CQGCEL object, which encapsulates the main functionality of CQG API
		public CQGCEL CEL;

		// Currently requested TradingSystem definitions object
		private CQGTradingSystemDefinitions m_CurTradingSystemDefs;

		// Current tarder name
		private string m_LogonName;

		// Current tarder name
		private bool m_IgnoreChanges;

		// Specifies the not available string
		private const string N_A = "N/A";

		#region " Windows Form Designer generated code "

		public frmAutoTrader()
		{

			//This call is required by the Windows Form Designer.
			InitializeComponent();

			//Add any initialization after the InitializeComponent() call

		}

		//Form overrides dispose to clean up the component list.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(components == null))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		//Required by the Windows Form Designer
		private System.ComponentModel.Container components = null;

		//NOTE: The following procedure is required by the Windows Form Designer
		//It can be modified using the Windows Form Designer.
		//Do not modify it using the code editor.
		internal System.Windows.Forms.PictureBox PictureBox1;
		internal System.Windows.Forms.LinkLabel llWeb;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label17;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Label Label23;
		internal System.Windows.Forms.Label Label25;
		internal System.Windows.Forms.Label Label27;
		internal System.Windows.Forms.Label Label29;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.TabControl tcAutoTrader;
		internal System.Windows.Forms.GroupBox GroupBox14;
		internal System.Windows.Forms.Label lblGWConnection;
		internal System.Windows.Forms.Label lblAccounts;
		internal System.Windows.Forms.Label lblDefinitions;
		internal System.Windows.Forms.ListView lvAutoTrader;
		internal System.Windows.Forms.Button btnAdd;
		internal System.Windows.Forms.ColumnHeader On_;
		internal System.Windows.Forms.ColumnHeader TurnedOnAt;
		internal System.Windows.Forms.ColumnHeader OpenPositions;
		internal System.Windows.Forms.ColumnHeader WorkingMode;
		internal System.Windows.Forms.ColumnHeader Name_;
		internal System.Windows.Forms.ColumnHeader TradingSystem;
		internal System.Windows.Forms.ColumnHeader Symbol;
		internal System.Windows.Forms.ColumnHeader AccountID;
		internal System.Windows.Forms.ColumnHeader AccountName;
		internal System.Windows.Forms.ColumnHeader FullName;
		internal System.Windows.Forms.ColumnHeader TradingSystemPreferences;
		internal System.Windows.Forms.ColumnHeader TradingSystemParameters;
		internal System.Windows.Forms.Label lblDataConnection;
		internal System.Windows.Forms.Button btnRemove;
		internal System.Windows.Forms.TabPage tpAutoTrades;
		internal System.Windows.Forms.TabPage tpExecutedOrders;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.ListView lvOrders;
		internal System.Windows.Forms.ColumnHeader AutoTradeName;
		internal System.Windows.Forms.ColumnHeader Account;
		internal System.Windows.Forms.ColumnHeader Instrument;
		internal System.Windows.Forms.ColumnHeader Side;
		internal System.Windows.Forms.ColumnHeader Quantity;
		internal System.Windows.Forms.ColumnHeader PlaceTime;
		internal System.Windows.Forms.ColumnHeader Type;
		internal System.Windows.Forms.ColumnHeader OrderID;
		internal System.Windows.Forms.ColumnHeader UEName;
		internal System.Windows.Forms.ColumnHeader GUID;
		internal System.Windows.Forms.ColumnHeader FilledQuantity;
		internal System.Windows.Forms.ColumnHeader GWStatus;
		internal System.Windows.Forms.ColumnHeader State;
		internal System.Windows.Forms.ColumnHeader Error_;
		[System.Diagnostics.DebuggerStepThrough()]
		private void InitializeComponent()
		{
			this.PictureBox1 = new System.Windows.Forms.PictureBox();
			this.llWeb = new System.Windows.Forms.LinkLabel();
			this.Label11 = new System.Windows.Forms.Label();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label27 = new System.Windows.Forms.Label();
			this.Label29 = new System.Windows.Forms.Label();
			this.Label23 = new System.Windows.Forms.Label();
			this.Label25 = new System.Windows.Forms.Label();
			this.Label17 = new System.Windows.Forms.Label();
			this.Label21 = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.Label13 = new System.Windows.Forms.Label();
			this.tcAutoTrader = new System.Windows.Forms.TabControl();
			this.tpAutoTrades = new System.Windows.Forms.TabPage();
			this.GroupBox14 = new System.Windows.Forms.GroupBox();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnAdd = new System.Windows.Forms.Button();
			this.lvAutoTrader = new System.Windows.Forms.ListView();
			this.On_ = new System.Windows.Forms.ColumnHeader();
			this.TurnedOnAt = new System.Windows.Forms.ColumnHeader();
			this.OpenPositions = new System.Windows.Forms.ColumnHeader();
			this.WorkingMode = new System.Windows.Forms.ColumnHeader();
			this.Name_ = new System.Windows.Forms.ColumnHeader();
			this.TradingSystem = new System.Windows.Forms.ColumnHeader();
			this.Symbol = new System.Windows.Forms.ColumnHeader();
			this.AccountID = new System.Windows.Forms.ColumnHeader();
			this.AccountName = new System.Windows.Forms.ColumnHeader();
			this.FullName = new System.Windows.Forms.ColumnHeader();
			this.TradingSystemPreferences = new System.Windows.Forms.ColumnHeader();
			this.TradingSystemParameters = new System.Windows.Forms.ColumnHeader();
			this.tpExecutedOrders = new System.Windows.Forms.TabPage();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.lvOrders = new System.Windows.Forms.ListView();
			this.AutoTradeName = new System.Windows.Forms.ColumnHeader();
			this.Account = new System.Windows.Forms.ColumnHeader();
			this.Instrument = new System.Windows.Forms.ColumnHeader();
			this.Side = new System.Windows.Forms.ColumnHeader();
			this.Quantity = new System.Windows.Forms.ColumnHeader();
			this.FilledQuantity = new System.Windows.Forms.ColumnHeader();
			this.PlaceTime = new System.Windows.Forms.ColumnHeader();
			this.Type = new System.Windows.Forms.ColumnHeader();
			this.OrderID = new System.Windows.Forms.ColumnHeader();
			this.GWStatus = new System.Windows.Forms.ColumnHeader();
			this.State = new System.Windows.Forms.ColumnHeader();
			this.UEName = new System.Windows.Forms.ColumnHeader();
			this.Error_ = new System.Windows.Forms.ColumnHeader();
			this.GUID = new System.Windows.Forms.ColumnHeader();
			this.lblGWConnection = new System.Windows.Forms.Label();
			this.lblDefinitions = new System.Windows.Forms.Label();
			this.lblAccounts = new System.Windows.Forms.Label();
			this.lblDataConnection = new System.Windows.Forms.Label();
			this.tcAutoTrader.SuspendLayout();
			this.tpAutoTrades.SuspendLayout();
			this.GroupBox14.SuspendLayout();
			this.tpExecutedOrders.SuspendLayout();
			this.GroupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// PictureBox1
			// 
			this.PictureBox1.BackColor = System.Drawing.Color.Black;
			this.PictureBox1.Location = new System.Drawing.Point(0, 56);
			this.PictureBox1.Name = "PictureBox1";
			this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox1.TabIndex = 23;
			this.PictureBox1.TabStop = false;
			// 
			// llWeb
			// 
			this.llWeb.BackColor = System.Drawing.SystemColors.Control;
			this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
			this.llWeb.Location = new System.Drawing.Point(632, 16);
			this.llWeb.Name = "llWeb";
			this.llWeb.Size = new System.Drawing.Size(408, 16);
			this.llWeb.TabIndex = 1;
			this.llWeb.TabStop = true;
			this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
			this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
			// 
			// Label11
			// 
			this.Label11.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label11.Location = new System.Drawing.Point(280, 24);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(120, 24);
			this.Label11.TabIndex = 60;
			this.Label11.Text = "Parameters :";
			this.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label6
			// 
			this.Label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label6.Location = new System.Drawing.Point(16, 24);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(120, 24);
			this.Label6.TabIndex = 58;
			this.Label6.Text = "Definition Name :";
			this.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label27
			// 
			this.Label27.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label27.Location = new System.Drawing.Point(272, 216);
			this.Label27.Name = "Label27";
			this.Label27.Size = new System.Drawing.Size(128, 24);
			this.Label27.TabIndex = 56;
			this.Label27.Text = "Days Before Exp. :";
			this.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label29
			// 
			this.Label29.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label29.Location = new System.Drawing.Point(16, 216);
			this.Label29.Name = "Label29";
			this.Label29.Size = new System.Drawing.Size(120, 24);
			this.Label29.TabIndex = 54;
			this.Label29.Text = "Equalize Closes :";
			this.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label23
			// 
			this.Label23.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label23.Location = new System.Drawing.Point(304, 184);
			this.Label23.Name = "Label23";
			this.Label23.Size = new System.Drawing.Size(96, 24);
			this.Label23.TabIndex = 52;
			this.Label23.Text = "Continuation :";
			this.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label25
			// 
			this.Label25.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label25.Location = new System.Drawing.Point(24, 248);
			this.Label25.Name = "Label25";
			this.Label25.Size = new System.Drawing.Size(112, 24);
			this.Label25.TabIndex = 50;
			this.Label25.Text = "Sessions Filter :";
			this.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label17
			// 
			this.Label17.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label17.Location = new System.Drawing.Point(304, 152);
			this.Label17.Name = "Label17";
			this.Label17.Size = new System.Drawing.Size(96, 24);
			this.Label17.TabIndex = 48;
			this.Label17.Text = "Include End :";
			this.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label21
			// 
			this.Label21.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label21.Location = new System.Drawing.Point(8, 152);
			this.Label21.Name = "Label21";
			this.Label21.Size = new System.Drawing.Size(124, 24);
			this.Label21.TabIndex = 46;
			this.Label21.Text = "Updates Enabled :";
			this.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label9
			// 
			this.Label9.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label9.Location = new System.Drawing.Point(280, 120);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(120, 24);
			this.Label9.TabIndex = 44;
			this.Label9.Text = "Historical Period :";
			this.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label13
			// 
			this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label13.Location = new System.Drawing.Point(16, 120);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(120, 24);
			this.Label13.TabIndex = 42;
			this.Label13.Text = "Intraday Period :";
			this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tcAutoTrader
			// 
			this.tcAutoTrader.Alignment = System.Windows.Forms.TabAlignment.Bottom;
			this.tcAutoTrader.Controls.Add(this.tpAutoTrades);
			this.tcAutoTrader.Controls.Add(this.tpExecutedOrders);
			this.tcAutoTrader.Location = new System.Drawing.Point(0, 64);
			this.tcAutoTrader.Name = "tcAutoTrader";
			this.tcAutoTrader.SelectedIndex = 0;
			this.tcAutoTrader.Size = new System.Drawing.Size(1056, 496);
			this.tcAutoTrader.TabIndex = 0;
			// 
			// tpAutoTrades
			// 
			this.tpAutoTrades.Controls.Add(this.GroupBox14);
			this.tpAutoTrades.Location = new System.Drawing.Point(4, 4);
			this.tpAutoTrades.Name = "tpAutoTrades";
			this.tpAutoTrades.Size = new System.Drawing.Size(1048, 467);
			this.tpAutoTrades.TabIndex = 1;
			this.tpAutoTrades.Text = "Auto Trade";
			// 
			// GroupBox14
			// 
			this.GroupBox14.Controls.Add(this.btnRemove);
			this.GroupBox14.Controls.Add(this.btnAdd);
			this.GroupBox14.Controls.Add(this.lvAutoTrader);
			this.GroupBox14.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox14.Location = new System.Drawing.Point(0, 0);
			this.GroupBox14.Name = "GroupBox14";
			this.GroupBox14.Size = new System.Drawing.Size(1032, 464);
			this.GroupBox14.TabIndex = 0;
			this.GroupBox14.TabStop = false;
			// 
			// btnRemove
			// 
			this.btnRemove.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemove.Location = new System.Drawing.Point(88, 432);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.TabIndex = 2;
			this.btnRemove.Text = "Remove";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnAdd
			// 
			this.btnAdd.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnAdd.Location = new System.Drawing.Point(8, 432);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 1;
			this.btnAdd.Text = "Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// lvAutoTrader
			// 
			this.lvAutoTrader.CheckBoxes = true;
			this.lvAutoTrader.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                           this.On_,
                                                                                           this.TurnedOnAt,
                                                                                           this.OpenPositions,
                                                                                           this.WorkingMode,
                                                                                           this.Name_,
                                                                                           this.TradingSystem,
                                                                                           this.Symbol,
                                                                                           this.AccountID,
                                                                                           this.AccountName,
                                                                                           this.FullName,
                                                                                           this.TradingSystemPreferences,
                                                                                           this.TradingSystemParameters});
			this.lvAutoTrader.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvAutoTrader.FullRowSelect = true;
			this.lvAutoTrader.GridLines = true;
			this.lvAutoTrader.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvAutoTrader.Location = new System.Drawing.Point(8, 20);
			this.lvAutoTrader.MultiSelect = false;
			this.lvAutoTrader.Name = "lvAutoTrader";
			this.lvAutoTrader.Size = new System.Drawing.Size(1016, 404);
			this.lvAutoTrader.TabIndex = 0;
			this.lvAutoTrader.View = System.Windows.Forms.View.Details;
			this.lvAutoTrader.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.lvAutoTrader_ItemCheck);
			// 
			// On_
			// 
			this.On_.Text = "On";
			this.On_.Width = 30;
			// 
			// TurnedOnAt
			// 
			this.TurnedOnAt.Text = "Turned On At";
			this.TurnedOnAt.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.TurnedOnAt.Width = 100;
			// 
			// OpenPositions
			// 
			this.OpenPositions.Text = "Open Positions";
			this.OpenPositions.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.OpenPositions.Width = 102;
			// 
			// WorkingMode
			// 
			this.WorkingMode.Text = "Working Mode";
			this.WorkingMode.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.WorkingMode.Width = 100;
			// 
			// Name_
			// 
			this.Name_.Text = "Name";
			this.Name_.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Name_.Width = 89;
			// 
			// TradingSystem
			// 
			this.TradingSystem.Text = "Trading System";
			this.TradingSystem.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.TradingSystem.Width = 121;
			// 
			// Symbol
			// 
			this.Symbol.Text = "Symbol";
			this.Symbol.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Symbol.Width = 78;
			// 
			// AccountID
			// 
			this.AccountID.Text = "Account ID";
			this.AccountID.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.AccountID.Width = 95;
			// 
			// AccountName
			// 
			this.AccountName.Text = "Account Name";
			this.AccountName.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.AccountName.Width = 106;
			// 
			// FullName
			// 
			this.FullName.Text = "Full Name";
			this.FullName.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.FullName.Width = 82;
			// 
			// TradingSystemPreferences
			// 
			this.TradingSystemPreferences.Text = "Trading System Preferences";
			this.TradingSystemPreferences.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.TradingSystemPreferences.Width = 193;
			// 
			// TradingSystemParameters
			// 
			this.TradingSystemParameters.Text = "Trading System Parameters";
			this.TradingSystemParameters.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.TradingSystemParameters.Width = 189;
			// 
			// tpExecutedOrders
			// 
			this.tpExecutedOrders.Controls.Add(this.GroupBox1);
			this.tpExecutedOrders.Location = new System.Drawing.Point(4, 4);
			this.tpExecutedOrders.Name = "tpExecutedOrders";
			this.tpExecutedOrders.Size = new System.Drawing.Size(1048, 470);
			this.tpExecutedOrders.TabIndex = 2;
			this.tpExecutedOrders.Text = "Executed Orders";
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.lvOrders);
			this.GroupBox1.Location = new System.Drawing.Point(8, 8);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(1032, 456);
			this.GroupBox1.TabIndex = 0;
			this.GroupBox1.TabStop = false;
			// 
			// lvOrders
			// 
			this.lvOrders.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                       this.AutoTradeName,
                                                                                       this.Account,
                                                                                       this.Instrument,
                                                                                       this.Side,
                                                                                       this.Quantity,
                                                                                       this.FilledQuantity,
                                                                                       this.PlaceTime,
                                                                                       this.Type,
                                                                                       this.OrderID,
                                                                                       this.GWStatus,
                                                                                       this.State,
                                                                                       this.UEName,
                                                                                       this.Error_,
                                                                                       this.GUID});
			this.lvOrders.FullRowSelect = true;
			this.lvOrders.GridLines = true;
			this.lvOrders.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvOrders.Location = new System.Drawing.Point(8, 16);
			this.lvOrders.Name = "lvOrders";
			this.lvOrders.Size = new System.Drawing.Size(1016, 432);
			this.lvOrders.TabIndex = 0;
			this.lvOrders.View = System.Windows.Forms.View.Details;
			// 
			// AutoTradeName
			// 
			this.AutoTradeName.Text = "Auto Trade Name";
			this.AutoTradeName.Width = 122;
			// 
			// Account
			// 
			this.Account.Text = "Account";
			this.Account.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Account.Width = 80;
			// 
			// Instrument
			// 
			this.Instrument.Text = "Instrument";
			this.Instrument.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Instrument.Width = 103;
			// 
			// Side
			// 
			this.Side.Text = "Side";
			this.Side.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Side.Width = 63;
			// 
			// Quantity
			// 
			this.Quantity.Text = "Quantity";
			this.Quantity.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Quantity.Width = 80;
			// 
			// FilledQuantity
			// 
			this.FilledQuantity.Text = "FilledQuantity";
			this.FilledQuantity.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.FilledQuantity.Width = 80;
			// 
			// PlaceTime
			// 
			this.PlaceTime.Text = "PlaceTime";
			this.PlaceTime.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.PlaceTime.Width = 86;
			// 
			// Type
			// 
			this.Type.Text = "Type";
			this.Type.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.Type.Width = 70;
			// 
			// OrderID
			// 
			this.OrderID.Text = "Order ID";
			this.OrderID.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.OrderID.Width = 84;
			// 
			// GWStatus
			// 
			this.GWStatus.Text = "GWStatus";
			this.GWStatus.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.GWStatus.Width = 78;
			// 
			// State
			// 
			this.State.Text = "State";
			this.State.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// UEName
			// 
			this.UEName.Text = "UEName";
			this.UEName.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.UEName.Width = 106;
			// 
			// Error_
			// 
			this.Error_.Text = "Error";
			this.Error_.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// GUID
			// 
			this.GUID.Text = "GUID";
			this.GUID.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.GUID.Width = 0;
			// 
			// lblGWConnection
			// 
			this.lblGWConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblGWConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblGWConnection.Location = new System.Drawing.Point(232, 8);
			this.lblGWConnection.Name = "lblGWConnection";
			this.lblGWConnection.Size = new System.Drawing.Size(216, 16);
			this.lblGWConnection.TabIndex = 24;
			this.lblGWConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblDefinitions
			// 
			this.lblDefinitions.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblDefinitions.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDefinitions.Location = new System.Drawing.Point(8, 32);
			this.lblDefinitions.Name = "lblDefinitions";
			this.lblDefinitions.Size = new System.Drawing.Size(216, 16);
			this.lblDefinitions.TabIndex = 25;
			this.lblDefinitions.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblAccounts
			// 
			this.lblAccounts.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblAccounts.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblAccounts.Location = new System.Drawing.Point(232, 32);
			this.lblAccounts.Name = "lblAccounts";
			this.lblAccounts.Size = new System.Drawing.Size(216, 16);
			this.lblAccounts.TabIndex = 26;
			this.lblAccounts.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblDataConnection
			// 
			this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
			this.lblDataConnection.Name = "lblDataConnection";
			this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
			this.lblDataConnection.TabIndex = 27;
			this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// frmAutoTrader
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(1054, 564);
			this.Controls.Add(this.lblDataConnection);
			this.Controls.Add(this.lblAccounts);
			this.Controls.Add(this.lblDefinitions);
			this.Controls.Add(this.lblGWConnection);
			this.Controls.Add(this.tcAutoTrader);
			this.Controls.Add(this.PictureBox1);
			this.Controls.Add(this.llWeb);
			this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmAutoTrader";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "AutoTrader";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmAutoTrader_Closing);
			this.Load += new System.EventHandler(this.frmAutoTrader_Load);
			this.tcAutoTrader.ResumeLayout(false);
			this.tpAutoTrades.ResumeLayout(false);
			this.GroupBox14.ResumeLayout(false);
			this.tpExecutedOrders.ResumeLayout(false);
			this.GroupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion


		/// <summary>
		/// Creates a CEL object, changes its configurations, and starts up the created CEL object.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void frmAutoTrader_Load(System.Object sender, System.EventArgs e)
		{
			try
			{
				CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
				CEL_GWConnectionStatusChanged(eConnectionStatus.csConnectionDown);
				CEL_TradingSystemDefinitionsResolved(null, null);
				CEL_AccountChanged(eAccountChangeType.actAccountsReloaded, null, null);

				// Creates the CQGCEL object
				CEL = new CQGCEL();
				CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
				CEL.GWConnectionStatusChanged += new CQG._ICQGCELEvents_GWConnectionStatusChangedEventHandler(CEL_GWConnectionStatusChanged);
				CEL.AccountChanged += new CQG._ICQGCELEvents_AccountChangedEventHandler(CEL_AccountChanged);
				CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
				CEL.OrderChanged += new CQG._ICQGCELEvents_OrderChangedEventHandler(CEL_OrderChanged);
				CEL.TradingSystemDefinitionsResolved += new CQG._ICQGCELEvents_TradingSystemDefinitionsResolvedEventHandler(CEL_TradingSystemDefinitionsResolved);
				CEL.TradingSystemResolved += new CQG._ICQGCELEvents_TradingSystemResolvedEventHandler(CEL_TradingSystemResolved);
				CEL.TradingSystemAddNotification += new CQG._ICQGCELEvents_TradingSystemAddNotificationEventHandler(CEL_TradingSystemAddNotification);
				CEL.TradingSystemUpdateNotification += new CQG._ICQGCELEvents_TradingSystemUpdateNotificationEventHandler(CEL_TradingSystemUpdateNotification);
				CEL.InstrumentResolved += new CQG._ICQGCELEvents_InstrumentResolvedEventHandler(CEL_InstrumentResolved);
				CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
				CEL.APIConfiguration.CollectionsThrowException = false;
				CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;
				CEL.APIConfiguration.UseOrderSide = true;
				CEL.APIConfiguration.DefaultInstrumentSubscriptionLevel = eDataSubscriptionLevel.dsNone;

				// Starts up the CQGCEL
				CEL.Startup();

				m_LogonName = "";
				m_IgnoreChanges = false;
				g_ATC = new AutoTraderCollection(CEL, lvAutoTrader, lvOrders);

			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "frmAutoTrader_Load", ex);
				this.Close();
			}
		}

		/// <summary>
		/// Shuts down CEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A CancelEventArgs that contains the event data.
		/// </param>
		private void frmAutoTrader_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (CEL != null)
			{
				CEL.Shutdown();
			}
		}

		/// <summary>
		/// Opens CQG API web page.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A LinkLabelLinkClickedEventArgs that contains the event data.
		/// </param>
		private void llWeb_LinkClicked(System.Object sender, LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "llWeb_LinkClicked", ex);
			}
		}

		/// <summary>
		/// This event is fired, when some changes occur
		/// in the connection with CQG data server.
		/// </summary>
		/// <param name="newStatus">
		/// The current status of the connection with the data server.
		/// </param>
		private void CEL_DataConnectionStatusChanged(eConnectionStatus new_status)
		{
			try
			{
				if (new_status == eConnectionStatus.csConnectionUp)
				{
					CEL.RequestTradingSystemDefinitions();
					lblDataConnection.BackColor = System.Drawing.Color.FromArgb(192, 209, 205);
				}
				else
				{
					lblDataConnection.BackColor = System.Drawing.Color.FromArgb(255, 114, 0);
				}
				lblDataConnection.Text = "DATA " + ConnectionStatusToString(new_status);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_DataConnectionStatusChanged", ex);
			}
		}

		/// <summary>
		/// This event is fired, when some changes occur
		/// in the connection with CQG data server.
		/// </summary>
		/// <param name="newStatus">
		/// The current status of the connection with the data server.
		/// </param>
		private void CEL_GWConnectionStatusChanged(eConnectionStatus new_status)
		{
			try
			{
				if (new_status == eConnectionStatus.csConnectionUp)
				{
					CEL.AccountSubscriptionLevel = eAccountSubscriptionLevel.aslAccountUpdatesAndOrders;
					lblGWConnection.BackColor = System.Drawing.Color.FromArgb(192, 209, 205);
					if (m_LogonName == "")
					{
						m_LogonName = CEL.Environment.GWLogonName;
					}
					else if (m_LogonName != CEL.Environment.GWLogonName)
					{
						MessageBox.Show("Logon name has been changed. Please reconnect with logon name application was started or reopen the application.", "Incorrect logon name", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						m_IgnoreChanges = true;
					}
					else
					{
						m_IgnoreChanges = false;
					}
					btnAdd.Enabled = !m_IgnoreChanges;
					btnRemove.Enabled = !m_IgnoreChanges;
					lvAutoTrader.Enabled = !m_IgnoreChanges;
				}
				else
				{
					lblGWConnection.BackColor = System.Drawing.Color.FromArgb(255, 114, 0);

					lblAccounts.BackColor = System.Drawing.Color.FromArgb(255, 114, 0);
					lblAccounts.Text = "Accounts Not Resolved";
				}

				lblGWConnection.Text = "GW " + ConnectionStatusToString(new_status);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_GWConnectionStatusChanged", ex);
			}
		}

		/// <summary>
		/// This event is fired when the account or
		/// position information is changed.
		/// </summary>
		/// <param name="change_type">
		/// Account change type which allows to
		/// differentiate the occurred changes.
		/// </param>
		/// <param name="cqg_account">
		/// A CQGAccount object representing the account
		/// to which the current change refers.
		/// </param>
		/// <param name="cqg_position">
		/// A CQGPosition object representing the position
		/// to which the current change refers.
		/// </param>
		private void CEL_AccountChanged(eAccountChangeType change_type, CQGAccount cqg_account, CQGPosition cqg_position)
		{
			try
			{
				if (change_type != eAccountChangeType.actAccountsReloaded)
				{
					return;
				}

				if (CEL != null)
				{
					lblAccounts.BackColor = System.Drawing.Color.FromArgb(192, 209, 205);
					lblAccounts.Text = "Accounts Resolved";
				}
				else
				{
					lblAccounts.BackColor = System.Drawing.Color.FromArgb(255, 114, 0);
					lblAccounts.Text = "Accounts Not Resolved";
					return;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_AccountChanged", ex);
			}
		}

		/// <summary>
		/// This event is fired, when CQGCEL detects some abnormal
		/// discrepancy between data expected and data received.
		/// </summary>
		/// <param name="cqg_error">
		/// The object, in which the error has occurred.
		/// </param>
		/// <param name="error_description">
		/// The string, describing the error.
		/// </param>
		private void CEL_DataError(object cqg_error, string error_description)
		{
			try
			{
				CQGError cqgErr = cqg_error as CQGError;
				if (CEL.IsValid(cqgErr))
				{
					if (cqgErr.Code == 102)
					{
						error_description += " Restart the application.";
					}
					else if (cqgErr.Code == 125)
					{
						error_description += " Turn on CQG Client and restart the application.";
					}
				}

				MessageBox.Show(error_description, "AutoTrader", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_DataError", ex);
			}
		}

		/// <summary>
		///
		/// </summary>
		/// <param name="change_type">
		/// The type of the occurred change.
		/// </param>
		/// <param name="cqg_order">
		/// CQGOrder object representing the order to which the change refers.
		/// </param>
		/// <param name="old_properties">
		/// CQGOrderProperties collection representing the
		/// old values of the changed order properties.
		/// </param>
		/// <param name="cqg_fill">
		/// CQGFill object representing the last fill of the order,
		/// i.e. the last item of order's Fills collection.
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object representing either an error sent by CQG Gateway
		/// or an intermediate error. If the error is final the same instance
		/// of CQGError will be set to order's LastError property.
		/// </param>
		private void CEL_OrderChanged(eChangeType change_type, CQGOrder cqg_order, CQGOrderProperties old_properties, CQGFill cqg_fill, CQGError cqg_error)
		{
			try
			{
				if (cqg_order != null)
				{
					for (int i = 0; i <= lvOrders.Items.Count - 1; i++)
					{
						if (lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocGUID)].Text == cqg_order.GUID)
						{
							lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocPlaceTime)].Text = modCommon.GetValueAsString(cqg_order.PlaceTime, CEL);
							lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocState)].Text = modCommon.GetValueAsString(cqg_order.State, CEL);
							lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocOrderID)].Text = modCommon.GetValueAsString(cqg_order.OriginalOrderID, CEL);
							lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocFilledQuantity)].Text = modCommon.GetValueAsString(Math.Abs(cqg_order.FilledQuantity), CEL);
							lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocGWStatus)].Text = modCommon.GetValueAsString(cqg_order.GWStatus, CEL);
							if (CEL.IsValid(cqg_error))
							{
								lvOrders.Items[i].SubItems[System.Convert.ToInt32(modCommon.eExecutedOrdersColumns.eocError)].Text = cqg_error.Description;
							}
							break;
						}
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_OrderChanged", ex);
			}
		}

		/// <summary>
		/// Occurs when the requested trading system definitions are resolved.
		/// </summary>
		/// <param name="cqg_trading_system_definitions">
		/// Collection of trading system definitions.
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object describing last error occurred
		/// during processing request or Nothing in case of no error.
		/// </param>
		private void CEL_TradingSystemDefinitionsResolved(CQGTradingSystemDefinitions cqg_trading_system_definitions, CQGError cqg_error)
		{
			try
			{
				if (CEL != null && CEL.IsValid(cqg_error))
				{
					MessageBox.Show(cqg_error.Description, "AutoTrader", MessageBoxButtons.OK, MessageBoxIcon.Information);
					return;
				}

				if (CEL != null)
				{
					lblDefinitions.BackColor = System.Drawing.Color.FromArgb(192, 209, 205);
					lblDefinitions.Text = "Definitions Resolved";
					m_CurTradingSystemDefs = cqg_trading_system_definitions;
				}
				else
				{
					lblDefinitions.BackColor = System.Drawing.Color.FromArgb(255, 114, 0);
					lblDefinitions.Text = "Definitions Not Resolved";
					m_CurTradingSystemDefs = null;
					return;
				}

			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_AutoTraderDefinitionsResolved", ex);
			}
		}

		/// <summary>
		/// Occurs when the requested trading system is resolved.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object describing last error occurred
		/// during processing trading system request or Nothing
		/// in case of no error.
		/// </param>
		private void CEL_TradingSystemResolved(CQGTradingSystem cqg_trading_system, CQGError cqg_error)
		{
			try
			{
				if (CEL.IsValid(cqg_error))
				{
					MessageBox.Show(cqg_error.Description, "AutoTrader", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					return;
				}

				g_ATC.TradingSystemResolved(cqg_trading_system);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_TradingSystemResolved", ex);
			}
		}

		/// <summary>
		/// Occurs when the new trading system row is added.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_trading_system_add_info">
		/// CQGTradingSystemAddInfo object containing
		/// additional info about added rows.
		/// </param>
		private void CEL_TradingSystemAddNotification(CQGTradingSystem cqg_trading_system, CQGTradingSystemAddInfo cqg_trading_system_add_info)
		{
			try
			{
				if (!m_IgnoreChanges)
				{
					g_ATC.TradingSystemAddNotification(cqg_trading_system);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_TradingSystemAddNotification", ex);
			}
		}

		/// <summary>
		/// Occurs when the new trading system row is added.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_trading_system_update_info">
		/// CQGTradingSystemUpdateInfo object containing
		/// additional info about updated rows.
		/// </param>
		private void CEL_TradingSystemUpdateNotification(CQGTradingSystem cqg_trading_system, CQGTradingSystemUpdateInfo cqg_trading_system_update_info)
		{
			try
			{
				if (!m_IgnoreChanges)
				{
					g_ATC.TradingSystemUpdateNotification(cqg_trading_system);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_TradingSystemUpdateNotification", ex);
			}
		}

		/// <summary>
		/// This event is fired when a new instrument is resolved and subscribed.
		/// </summary>
		/// <param name="symbol_">
		/// The commodity symbol that was requested by user in NewInstrument method.
		/// </param>
		/// <param name="cqg_instrument">
		/// Resolved CQGInstrument object, null if resolution failed.
		/// </param>
		/// <param name= "cqg_error">
		/// Error happened during a resolution process, null if resolution succeeded.
		/// </param>
		private void CEL_InstrumentResolved(string symbol_, CQG.CQGInstrument cqg_instrument, CQG.CQGError cqg_error)
		{
			try
			{
				g_ATC.InstrumentResolved(symbol_, cqg_instrument);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "CEL_InstrumentResolved", ex);
			}
		}

		/// <summary>
		/// Enables AutoTrader.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void lvAutoTrader_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
		{
			if (g_ATC != null)
			{
				System.Windows.Forms.CheckState temp_SystemWindowsFormsCheckState = e.NewValue;
				g_ATC.CheckBoxClicked(e.Index, ref temp_SystemWindowsFormsCheckState);
				e.NewValue = temp_SystemWindowsFormsCheckState;
			}
		}

		/// <summary>
		/// Adds new item.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnAdd_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				frmLoadInfoSpecifier frmLoadInfo = new frmLoadInfoSpecifier(CEL, m_CurTradingSystemDefs);
				frmLoadInfo.ShowDialog();
				if (frmLoadInfo.DialogResult == DialogResult.OK)
				{
					int newItemRow = lvAutoTrader.Items.Count;
					g_ATC.AddItem(newItemRow);

					string tsdName = frmLoadInfo.cmbDefinition.Text;
					g_ATC.TradingSystemDefName(tsdName, newItemRow);
					g_ATC.SetName(frmLoadInfo.txtName.Text, newItemRow);
					string accGWid = frmLoadInfo.cmbAccount.Text;
					accGWid = accGWid.Substring(0, accGWid.IndexOf(" / "));
					g_ATC.AccountChanged(System.Convert.ToInt32(accGWid), newItemRow);

					frmTradingSystemRequestSettings frmSysReq = new frmTradingSystemRequestSettings();
					// Create CQGCEL trading system request object
					CQGTradingSystemRequest req = CEL.CreateTradingSystemRequest(m_CurTradingSystemDefs.get_ItemByName(tsdName).Abbreviation);
					req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".
					// Initialize form's properties and show
					frmSysReq.TradingSystemRequest = req;
					frmSysReq.ShowDialog();

					if (frmSysReq.DialogResult != DialogResult.OK)
					{
						lvAutoTrader.Items.RemoveAt(newItemRow);
						g_ATC.DeleteItem(newItemRow, newItemRow);
					}
					else
					{
						g_ATC.SetTradingSystem(null, newItemRow);

						// If user confirms request send it to CQGCEL
						CQGTradingSystem tradingSystem = CEL.RequestTradingSystem(req);
						tradingSystem.set_Tag(modCommon.ROW_TAG, newItemRow);

						g_ATC.SetSymbol(req.BaseExpression, newItemRow);
						g_ATC.SetWorkingMode(frmLoadInfo.btnSignals.Checked, newItemRow);
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "btnAdd_Click", ex);
			}
		}

		/// <summary>
		/// Removes selected item from list.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemove_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				if (lvAutoTrader.SelectedIndices.Count == 0)
				{
					MessageBox.Show("Please specify item to remove.", "Item is not specified", MessageBoxButtons.OK, MessageBoxIcon.Information);
					return;
				}
				int selectedItem = lvAutoTrader.SelectedIndices[0];
				lvAutoTrader.Items.RemoveAt(selectedItem);
				g_ATC.DeleteItem(selectedItem, lvAutoTrader.Items.Count);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmAutoTrader", "btnRemove_Click", ex);
			}
		}

		/// <summary>
		/// Converts enum of connection status to appropriate string.
		/// </summary>
		/// <param name="connectionStatus">
		/// Enum which will be converted.
		/// </param>
		/// <returns>
		/// String which describes connection status.
		/// </returns>
		public string ConnectionStatusToString(eConnectionStatus connectionStatus)
		{
			string sConnectionStatus = "";
			switch (connectionStatus)
			{
				case eConnectionStatus.csConnectionUp:
					sConnectionStatus = "Connection Up";
					break;
				case eConnectionStatus.csConnectionDown:
					sConnectionStatus = "Connection Down";
					break;
				case eConnectionStatus.csConnectionDelayed:
					sConnectionStatus = "Connection Delayed";
					break;
			}
			return sConnectionStatus;

		}

	}

}
