Imports CQG
Public Class frmCondition
    Inherits System.Windows.Forms.Form

    ' The CQGCEL object, which encapsulates the main functionality of CQG API
    Public WithEvents CEL As CQGCEL

    ' The currently selected Condition object in the combo box
    Private m_CurCondition As CQGCondition

    ' Currently requested condition definitions object
    Private m_ConditionDefinitions As CQGConditionDefinitions

    ' Specifies the not available string
    Private Const N_A As String = "N/A"

    ' Specifies the max records count
    Private Const MAX_NUMBER_OF_RECORDS As Integer = 5

    ' Specifies the max index interval
    Private Const MAX_INDEX_INTERVAL As Integer = 500

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblDataConnection As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents llWeb As System.Windows.Forms.LinkLabel
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox3 As System.Windows.Forms.PictureBox
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label18 As System.Windows.Forms.Label
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents Label20 As System.Windows.Forms.Label
    Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
    Friend WithEvents cmbCondition As System.Windows.Forms.ComboBox
    Friend WithEvents lblRPRangeEnd As System.Windows.Forms.Label
    Friend WithEvents lblRPRangeStart As System.Windows.Forms.Label
    Friend WithEvents lblOEnd As System.Windows.Forms.Label
    Friend WithEvents lblOStart As System.Windows.Forms.Label
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents txtTagName As System.Windows.Forms.TextBox
    Friend WithEvents txtTagValue As System.Windows.Forms.TextBox
    Friend WithEvents btnRequest As System.Windows.Forms.Button
    Friend WithEvents btnRemove As System.Windows.Forms.Button
    Friend WithEvents btnRemoveAll As System.Windows.Forms.Button
    Friend WithEvents GroupBox5 As System.Windows.Forms.GroupBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents gbIndexInterval As System.Windows.Forms.GroupBox
    Friend WithEvents gbTimeInterval As System.Windows.Forms.GroupBox
    Friend WithEvents dtpStartRange As System.Windows.Forms.DateTimePicker
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents btnShow As System.Windows.Forms.Button
    Friend WithEvents optTimeInterval As System.Windows.Forms.RadioButton
    Friend WithEvents optIndexInterval As System.Windows.Forms.RadioButton
    Friend WithEvents nudEnd As System.Windows.Forms.NumericUpDown
    Friend WithEvents nudStart As System.Windows.Forms.NumericUpDown
    Friend WithEvents GroupBox6 As System.Windows.Forms.GroupBox
    Friend WithEvents dtpEndRange As System.Windows.Forms.DateTimePicker
    Friend WithEvents lblError As System.Windows.Forms.Label
    Friend WithEvents ColumnHeader1 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader2 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader3 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader4 As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvCondition As System.Windows.Forms.ListView
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents Label21 As System.Windows.Forms.Label
    Friend WithEvents Label23 As System.Windows.Forms.Label
    Friend WithEvents Label25 As System.Windows.Forms.Label
    Friend WithEvents Label27 As System.Windows.Forms.Label
    Friend WithEvents Label29 As System.Windows.Forms.Label
    Friend WithEvents lblRPSessionFlags As System.Windows.Forms.Label
    Friend WithEvents lblRPHistoricalPeriod As System.Windows.Forms.Label
    Friend WithEvents lblRPIntradayPeriod As System.Windows.Forms.Label
    Friend WithEvents lblRPIncludeEnd As System.Windows.Forms.Label
    Friend WithEvents lblRPUpdatesEnabled As System.Windows.Forms.Label
    Friend WithEvents lblRPContinuation As System.Windows.Forms.Label
    Friend WithEvents lblRPSessionsFilter As System.Windows.Forms.Label
    Friend WithEvents lblRPDaysBeforeExpiration As System.Windows.Forms.Label
    Friend WithEvents lblRPEqualizeCloses As System.Windows.Forms.Label
    Friend WithEvents lblRPBaseExpression As System.Windows.Forms.Label
    Friend WithEvents txtConditionName As System.Windows.Forms.TextBox
    Friend WithEvents lblRPConditionDefinitionName As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents GroupBox7 As System.Windows.Forms.GroupBox
    Friend WithEvents lblParameterDefaultValue As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents lblParameterType As System.Windows.Forms.Label
    Friend WithEvents Label22 As System.Windows.Forms.Label
    Friend WithEvents btnReqConditionDefinitions As System.Windows.Forms.Button
    Friend WithEvents cmbDefinition As System.Windows.Forms.ComboBox
    Friend WithEvents Label24 As System.Windows.Forms.Label
    Friend WithEvents lblParameterComment As System.Windows.Forms.Label
    Friend WithEvents Label28 As System.Windows.Forms.Label
    Friend WithEvents cmbParameter As System.Windows.Forms.ComboBox
    Friend WithEvents lstRPParameters As System.Windows.Forms.ListBox
    Friend WithEvents lvShownCondition As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader5 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader6 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader7 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader8 As System.Windows.Forms.ColumnHeader
    Friend WithEvents lblRPRecalcPeriod As System.Windows.Forms.Label
    Friend WithEvents Label19 As System.Windows.Forms.Label
    Friend WithEvents lblRPSubscriptionLevel As System.Windows.Forms.Label
    Friend WithEvents Label30 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.lblDataConnection = New System.Windows.Forms.Label
Me.PictureBox1 = New System.Windows.Forms.PictureBox
Me.llWeb = New System.Windows.Forms.LinkLabel
Me.cmbCondition = New System.Windows.Forms.ComboBox
Me.btnRequest = New System.Windows.Forms.Button
Me.btnRemove = New System.Windows.Forms.Button
Me.btnRemoveAll = New System.Windows.Forms.Button
Me.lblStatus = New System.Windows.Forms.Label
Me.GroupBox1 = New System.Windows.Forms.GroupBox
Me.lstRPParameters = New System.Windows.Forms.ListBox
Me.Label11 = New System.Windows.Forms.Label
Me.lblRPConditionDefinitionName = New System.Windows.Forms.Label
Me.Label6 = New System.Windows.Forms.Label
Me.lblRPDaysBeforeExpiration = New System.Windows.Forms.Label
Me.Label27 = New System.Windows.Forms.Label
Me.lblRPEqualizeCloses = New System.Windows.Forms.Label
Me.Label29 = New System.Windows.Forms.Label
Me.lblRPContinuation = New System.Windows.Forms.Label
Me.Label23 = New System.Windows.Forms.Label
Me.lblRPSessionsFilter = New System.Windows.Forms.Label
Me.Label25 = New System.Windows.Forms.Label
Me.lblRPIncludeEnd = New System.Windows.Forms.Label
Me.Label17 = New System.Windows.Forms.Label
Me.lblRPUpdatesEnabled = New System.Windows.Forms.Label
Me.Label21 = New System.Windows.Forms.Label
Me.lblRPHistoricalPeriod = New System.Windows.Forms.Label
Me.Label9 = New System.Windows.Forms.Label
Me.lblRPIntradayPeriod = New System.Windows.Forms.Label
Me.Label13 = New System.Windows.Forms.Label
Me.lblRPRangeEnd = New System.Windows.Forms.Label
Me.Label12 = New System.Windows.Forms.Label
Me.lblRPSessionFlags = New System.Windows.Forms.Label
Me.Label10 = New System.Windows.Forms.Label
Me.lblRPRangeStart = New System.Windows.Forms.Label
Me.Label8 = New System.Windows.Forms.Label
Me.lblRPBaseExpression = New System.Windows.Forms.Label
Me.Label4 = New System.Windows.Forms.Label
Me.PictureBox2 = New System.Windows.Forms.PictureBox
Me.PictureBox3 = New System.Windows.Forms.PictureBox
Me.GroupBox2 = New System.Windows.Forms.GroupBox
Me.txtTagValue = New System.Windows.Forms.TextBox
Me.txtTagName = New System.Windows.Forms.TextBox
Me.Label14 = New System.Windows.Forms.Label
Me.Label18 = New System.Windows.Forms.Label
Me.GroupBox3 = New System.Windows.Forms.GroupBox
Me.lblOEnd = New System.Windows.Forms.Label
Me.Label16 = New System.Windows.Forms.Label
Me.lblOStart = New System.Windows.Forms.Label
Me.Label20 = New System.Windows.Forms.Label
Me.GroupBox4 = New System.Windows.Forms.GroupBox
Me.lvCondition = New System.Windows.Forms.ListView
Me.ColumnHeader1 = New System.Windows.Forms.ColumnHeader
Me.ColumnHeader2 = New System.Windows.Forms.ColumnHeader
Me.ColumnHeader3 = New System.Windows.Forms.ColumnHeader
Me.ColumnHeader4 = New System.Windows.Forms.ColumnHeader
Me.GroupBox5 = New System.Windows.Forms.GroupBox
Me.lvShownCondition = New System.Windows.Forms.ListView
Me.ColumnHeader5 = New System.Windows.Forms.ColumnHeader
Me.ColumnHeader6 = New System.Windows.Forms.ColumnHeader
Me.ColumnHeader7 = New System.Windows.Forms.ColumnHeader
Me.ColumnHeader8 = New System.Windows.Forms.ColumnHeader
Me.btnShow = New System.Windows.Forms.Button
Me.gbTimeInterval = New System.Windows.Forms.GroupBox
Me.Label7 = New System.Windows.Forms.Label
Me.dtpEndRange = New System.Windows.Forms.DateTimePicker
Me.Label5 = New System.Windows.Forms.Label
Me.dtpStartRange = New System.Windows.Forms.DateTimePicker
Me.gbIndexInterval = New System.Windows.Forms.GroupBox
Me.Label3 = New System.Windows.Forms.Label
Me.nudEnd = New System.Windows.Forms.NumericUpDown
Me.Label2 = New System.Windows.Forms.Label
Me.nudStart = New System.Windows.Forms.NumericUpDown
Me.optTimeInterval = New System.Windows.Forms.RadioButton
Me.optIndexInterval = New System.Windows.Forms.RadioButton
Me.GroupBox6 = New System.Windows.Forms.GroupBox
Me.lblError = New System.Windows.Forms.Label
Me.txtConditionName = New System.Windows.Forms.TextBox
Me.GroupBox7 = New System.Windows.Forms.GroupBox
Me.cmbParameter = New System.Windows.Forms.ComboBox
Me.lblParameterComment = New System.Windows.Forms.Label
Me.Label28 = New System.Windows.Forms.Label
Me.Label24 = New System.Windows.Forms.Label
Me.cmbDefinition = New System.Windows.Forms.ComboBox
Me.btnReqConditionDefinitions = New System.Windows.Forms.Button
Me.lblParameterDefaultValue = New System.Windows.Forms.Label
Me.Label15 = New System.Windows.Forms.Label
Me.lblParameterType = New System.Windows.Forms.Label
Me.Label22 = New System.Windows.Forms.Label
Me.lblRPRecalcPeriod = New System.Windows.Forms.Label
Me.Label19 = New System.Windows.Forms.Label
Me.lblRPSubscriptionLevel = New System.Windows.Forms.Label
Me.Label30 = New System.Windows.Forms.Label
Me.GroupBox1.SuspendLayout()
Me.GroupBox2.SuspendLayout()
Me.GroupBox3.SuspendLayout()
Me.GroupBox4.SuspendLayout()
Me.GroupBox5.SuspendLayout()
Me.gbTimeInterval.SuspendLayout()
Me.gbIndexInterval.SuspendLayout()
CType(Me.nudEnd, System.ComponentModel.ISupportInitialize).BeginInit()
CType(Me.nudStart, System.ComponentModel.ISupportInitialize).BeginInit()
Me.GroupBox6.SuspendLayout()
Me.GroupBox7.SuspendLayout()
Me.SuspendLayout()
'
'lblDataConnection
'
Me.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblDataConnection.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblDataConnection.Location = New System.Drawing.Point(8, 8)
Me.lblDataConnection.Name = "lblDataConnection"
Me.lblDataConnection.Size = New System.Drawing.Size(216, 16)
Me.lblDataConnection.TabIndex = 24
Me.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
'
'PictureBox1
'
Me.PictureBox1.BackColor = System.Drawing.Color.Black
Me.PictureBox1.Location = New System.Drawing.Point(0, 40)
Me.PictureBox1.Name = "PictureBox1"
Me.PictureBox1.Size = New System.Drawing.Size(1272, 3)
Me.PictureBox1.TabIndex = 23
Me.PictureBox1.TabStop = False
'
'llWeb
'
Me.llWeb.BackColor = System.Drawing.SystemColors.Control
Me.llWeb.LinkArea = New System.Windows.Forms.LinkArea(18, 58)
Me.llWeb.Location = New System.Drawing.Point(632, 8)
Me.llWeb.Name = "llWeb"
Me.llWeb.Size = New System.Drawing.Size(408, 16)
Me.llWeb.TabIndex = 25
Me.llWeb.TabStop = True
Me.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx"
Me.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
'
'cmbCondition
'
Me.cmbCondition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
Me.cmbCondition.Location = New System.Drawing.Point(16, 208)
Me.cmbCondition.Name = "cmbCondition"
Me.cmbCondition.Size = New System.Drawing.Size(448, 24)
Me.cmbCondition.TabIndex = 5
'
'btnRequest
'
Me.btnRequest.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.btnRequest.Location = New System.Drawing.Point(16, 240)
Me.btnRequest.Name = "btnRequest"
Me.btnRequest.Size = New System.Drawing.Size(96, 40)
Me.btnRequest.TabIndex = 2
Me.btnRequest.Text = "Request"
'
'btnRemove
'
Me.btnRemove.Enabled = False
Me.btnRemove.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.btnRemove.Location = New System.Drawing.Point(120, 240)
Me.btnRemove.Name = "btnRemove"
Me.btnRemove.Size = New System.Drawing.Size(96, 40)
Me.btnRemove.TabIndex = 3
Me.btnRemove.Text = "Remove"
'
'btnRemoveAll
'
Me.btnRemoveAll.Enabled = False
Me.btnRemoveAll.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.btnRemoveAll.Location = New System.Drawing.Point(224, 240)
Me.btnRemoveAll.Name = "btnRemoveAll"
Me.btnRemoveAll.Size = New System.Drawing.Size(96, 40)
Me.btnRemoveAll.TabIndex = 4
Me.btnRemoveAll.Text = "Remove All"
'
'lblStatus
'
Me.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblStatus.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblStatus.Location = New System.Drawing.Point(8, 16)
Me.lblStatus.Name = "lblStatus"
Me.lblStatus.Size = New System.Drawing.Size(120, 24)
Me.lblStatus.TabIndex = 31
Me.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'GroupBox1
'
Me.GroupBox1.Controls.Add(Me.lblRPRecalcPeriod)
Me.GroupBox1.Controls.Add(Me.Label19)
Me.GroupBox1.Controls.Add(Me.lblRPSubscriptionLevel)
Me.GroupBox1.Controls.Add(Me.Label30)
Me.GroupBox1.Controls.Add(Me.lstRPParameters)
Me.GroupBox1.Controls.Add(Me.Label11)
Me.GroupBox1.Controls.Add(Me.lblRPConditionDefinitionName)
Me.GroupBox1.Controls.Add(Me.Label6)
Me.GroupBox1.Controls.Add(Me.lblRPDaysBeforeExpiration)
Me.GroupBox1.Controls.Add(Me.Label27)
Me.GroupBox1.Controls.Add(Me.lblRPEqualizeCloses)
Me.GroupBox1.Controls.Add(Me.Label29)
Me.GroupBox1.Controls.Add(Me.lblRPContinuation)
Me.GroupBox1.Controls.Add(Me.Label23)
Me.GroupBox1.Controls.Add(Me.lblRPSessionsFilter)
Me.GroupBox1.Controls.Add(Me.Label25)
Me.GroupBox1.Controls.Add(Me.lblRPIncludeEnd)
Me.GroupBox1.Controls.Add(Me.Label17)
Me.GroupBox1.Controls.Add(Me.lblRPUpdatesEnabled)
Me.GroupBox1.Controls.Add(Me.Label21)
Me.GroupBox1.Controls.Add(Me.lblRPHistoricalPeriod)
Me.GroupBox1.Controls.Add(Me.Label9)
Me.GroupBox1.Controls.Add(Me.lblRPIntradayPeriod)
Me.GroupBox1.Controls.Add(Me.Label13)
Me.GroupBox1.Controls.Add(Me.lblRPRangeEnd)
Me.GroupBox1.Controls.Add(Me.Label12)
Me.GroupBox1.Controls.Add(Me.lblRPSessionFlags)
Me.GroupBox1.Controls.Add(Me.Label10)
Me.GroupBox1.Controls.Add(Me.lblRPRangeStart)
Me.GroupBox1.Controls.Add(Me.Label8)
Me.GroupBox1.Controls.Add(Me.lblRPBaseExpression)
Me.GroupBox1.Controls.Add(Me.Label4)
Me.GroupBox1.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.GroupBox1.Location = New System.Drawing.Point(480, 168)
Me.GroupBox1.Name = "GroupBox1"
Me.GroupBox1.Size = New System.Drawing.Size(576, 312)
Me.GroupBox1.TabIndex = 6
Me.GroupBox1.TabStop = False
Me.GroupBox1.Text = "Request Parameters"
'
'lstRPParameters
'
Me.lstRPParameters.BackColor = System.Drawing.SystemColors.Control
Me.lstRPParameters.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lstRPParameters.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lstRPParameters.ItemHeight = 15
Me.lstRPParameters.Location = New System.Drawing.Point(432, 22)
Me.lstRPParameters.Name = "lstRPParameters"
Me.lstRPParameters.Size = New System.Drawing.Size(136, 62)
Me.lstRPParameters.TabIndex = 0
'
'Label11
'
Me.Label11.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label11.Location = New System.Drawing.Point(328, 24)
Me.Label11.Name = "Label11"
Me.Label11.Size = New System.Drawing.Size(96, 24)
Me.Label11.TabIndex = 60
Me.Label11.Text = "Parameters :"
Me.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPConditionDefinitionName
'
Me.lblRPConditionDefinitionName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPConditionDefinitionName.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPConditionDefinitionName.Location = New System.Drawing.Point(152, 24)
Me.lblRPConditionDefinitionName.Name = "lblRPConditionDefinitionName"
Me.lblRPConditionDefinitionName.Size = New System.Drawing.Size(144, 24)
Me.lblRPConditionDefinitionName.TabIndex = 59
Me.lblRPConditionDefinitionName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label6
'
Me.Label6.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label6.Location = New System.Drawing.Point(24, 24)
Me.Label6.Name = "Label6"
Me.Label6.Size = New System.Drawing.Size(120, 24)
Me.Label6.TabIndex = 58
Me.Label6.Text = "Definition Name :"
Me.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPDaysBeforeExpiration
'
Me.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPDaysBeforeExpiration.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPDaysBeforeExpiration.Location = New System.Drawing.Point(432, 216)
Me.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration"
Me.lblRPDaysBeforeExpiration.Size = New System.Drawing.Size(136, 24)
Me.lblRPDaysBeforeExpiration.TabIndex = 57
Me.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label27
'
Me.Label27.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label27.Location = New System.Drawing.Point(296, 216)
Me.Label27.Name = "Label27"
Me.Label27.Size = New System.Drawing.Size(128, 24)
Me.Label27.TabIndex = 56
Me.Label27.Text = "Days Before Exp. :"
Me.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPEqualizeCloses
'
Me.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPEqualizeCloses.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPEqualizeCloses.Location = New System.Drawing.Point(152, 216)
Me.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses"
Me.lblRPEqualizeCloses.Size = New System.Drawing.Size(144, 24)
Me.lblRPEqualizeCloses.TabIndex = 55
Me.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label29
'
Me.Label29.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label29.Location = New System.Drawing.Point(24, 216)
Me.Label29.Name = "Label29"
Me.Label29.Size = New System.Drawing.Size(120, 24)
Me.Label29.TabIndex = 54
Me.Label29.Text = "Equalize Closes :"
Me.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPContinuation
'
Me.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPContinuation.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPContinuation.Location = New System.Drawing.Point(432, 184)
Me.lblRPContinuation.Name = "lblRPContinuation"
Me.lblRPContinuation.Size = New System.Drawing.Size(136, 24)
Me.lblRPContinuation.TabIndex = 53
Me.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label23
'
Me.Label23.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label23.Location = New System.Drawing.Point(328, 184)
Me.Label23.Name = "Label23"
Me.Label23.Size = New System.Drawing.Size(96, 24)
Me.Label23.TabIndex = 52
Me.Label23.Text = "Continuation :"
Me.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPSessionsFilter
'
Me.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPSessionsFilter.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPSessionsFilter.Location = New System.Drawing.Point(152, 280)
Me.lblRPSessionsFilter.Name = "lblRPSessionsFilter"
Me.lblRPSessionsFilter.Size = New System.Drawing.Size(416, 24)
Me.lblRPSessionsFilter.TabIndex = 51
Me.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label25
'
Me.Label25.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label25.Location = New System.Drawing.Point(32, 280)
Me.Label25.Name = "Label25"
Me.Label25.Size = New System.Drawing.Size(112, 24)
Me.Label25.TabIndex = 50
Me.Label25.Text = "Sessions Filter :"
Me.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPIncludeEnd
'
Me.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPIncludeEnd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPIncludeEnd.Location = New System.Drawing.Point(432, 152)
Me.lblRPIncludeEnd.Name = "lblRPIncludeEnd"
Me.lblRPIncludeEnd.Size = New System.Drawing.Size(136, 24)
Me.lblRPIncludeEnd.TabIndex = 49
Me.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label17
'
Me.Label17.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label17.Location = New System.Drawing.Point(328, 152)
Me.Label17.Name = "Label17"
Me.Label17.Size = New System.Drawing.Size(96, 24)
Me.Label17.TabIndex = 48
Me.Label17.Text = "Include End :"
Me.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPUpdatesEnabled
'
Me.lblRPUpdatesEnabled.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPUpdatesEnabled.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPUpdatesEnabled.Location = New System.Drawing.Point(152, 152)
Me.lblRPUpdatesEnabled.Name = "lblRPUpdatesEnabled"
Me.lblRPUpdatesEnabled.Size = New System.Drawing.Size(144, 24)
Me.lblRPUpdatesEnabled.TabIndex = 47
Me.lblRPUpdatesEnabled.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label21
'
Me.Label21.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label21.Location = New System.Drawing.Point(16, 152)
Me.Label21.Name = "Label21"
Me.Label21.Size = New System.Drawing.Size(124, 24)
Me.Label21.TabIndex = 46
Me.Label21.Text = "Updates Enabled :"
Me.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPHistoricalPeriod
'
Me.lblRPHistoricalPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPHistoricalPeriod.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPHistoricalPeriod.Location = New System.Drawing.Point(432, 120)
Me.lblRPHistoricalPeriod.Name = "lblRPHistoricalPeriod"
Me.lblRPHistoricalPeriod.Size = New System.Drawing.Size(136, 24)
Me.lblRPHistoricalPeriod.TabIndex = 45
Me.lblRPHistoricalPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label9
'
Me.Label9.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label9.Location = New System.Drawing.Point(304, 120)
Me.Label9.Name = "Label9"
Me.Label9.Size = New System.Drawing.Size(120, 24)
Me.Label9.TabIndex = 44
Me.Label9.Text = "Historical Period :"
Me.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPIntradayPeriod
'
Me.lblRPIntradayPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPIntradayPeriod.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPIntradayPeriod.Location = New System.Drawing.Point(152, 120)
Me.lblRPIntradayPeriod.Name = "lblRPIntradayPeriod"
Me.lblRPIntradayPeriod.Size = New System.Drawing.Size(144, 24)
Me.lblRPIntradayPeriod.TabIndex = 43
Me.lblRPIntradayPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label13
'
Me.Label13.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label13.Location = New System.Drawing.Point(24, 120)
Me.Label13.Name = "Label13"
Me.Label13.Size = New System.Drawing.Size(120, 24)
Me.Label13.TabIndex = 42
Me.Label13.Text = "Intraday Period :"
Me.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPRangeEnd
'
Me.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPRangeEnd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPRangeEnd.Location = New System.Drawing.Point(432, 88)
Me.lblRPRangeEnd.Name = "lblRPRangeEnd"
Me.lblRPRangeEnd.Size = New System.Drawing.Size(136, 24)
Me.lblRPRangeEnd.TabIndex = 41
Me.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label12
'
Me.Label12.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label12.Location = New System.Drawing.Point(336, 88)
Me.Label12.Name = "Label12"
Me.Label12.Size = New System.Drawing.Size(88, 24)
Me.Label12.TabIndex = 40
Me.Label12.Text = "Range End :"
Me.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPSessionFlags
'
Me.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPSessionFlags.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPSessionFlags.Location = New System.Drawing.Point(152, 184)
Me.lblRPSessionFlags.Name = "lblRPSessionFlags"
Me.lblRPSessionFlags.Size = New System.Drawing.Size(144, 24)
Me.lblRPSessionFlags.TabIndex = 39
Me.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label10
'
Me.Label10.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label10.Location = New System.Drawing.Point(32, 184)
Me.Label10.Name = "Label10"
Me.Label10.Size = New System.Drawing.Size(112, 24)
Me.Label10.TabIndex = 38
Me.Label10.Text = "Session Flags :"
Me.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPRangeStart
'
Me.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPRangeStart.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPRangeStart.Location = New System.Drawing.Point(152, 88)
Me.lblRPRangeStart.Name = "lblRPRangeStart"
Me.lblRPRangeStart.Size = New System.Drawing.Size(144, 24)
Me.lblRPRangeStart.TabIndex = 37
Me.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label8
'
Me.Label8.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label8.Location = New System.Drawing.Point(24, 88)
Me.Label8.Name = "Label8"
Me.Label8.Size = New System.Drawing.Size(120, 24)
Me.Label8.TabIndex = 36
Me.Label8.Text = "Range Start :"
Me.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPBaseExpression
'
Me.lblRPBaseExpression.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPBaseExpression.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPBaseExpression.Location = New System.Drawing.Point(152, 56)
Me.lblRPBaseExpression.Name = "lblRPBaseExpression"
Me.lblRPBaseExpression.Size = New System.Drawing.Size(144, 24)
Me.lblRPBaseExpression.TabIndex = 33
Me.lblRPBaseExpression.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label4
'
Me.Label4.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label4.Location = New System.Drawing.Point(16, 56)
Me.Label4.Name = "Label4"
Me.Label4.Size = New System.Drawing.Size(128, 24)
Me.Label4.TabIndex = 32
Me.Label4.Text = "Base Expression :"
Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'PictureBox2
'
Me.PictureBox2.BackColor = System.Drawing.Color.Black
Me.PictureBox2.Location = New System.Drawing.Point(-96, 488)
Me.PictureBox2.Name = "PictureBox2"
Me.PictureBox2.Size = New System.Drawing.Size(1272, 1)
Me.PictureBox2.TabIndex = 33
Me.PictureBox2.TabStop = False
'
'PictureBox3
'
Me.PictureBox3.BackColor = System.Drawing.Color.Black
Me.PictureBox3.Location = New System.Drawing.Point(-96, 560)
Me.PictureBox3.Name = "PictureBox3"
Me.PictureBox3.Size = New System.Drawing.Size(1272, 3)
Me.PictureBox3.TabIndex = 34
Me.PictureBox3.TabStop = False
'
'GroupBox2
'
Me.GroupBox2.Controls.Add(Me.txtTagValue)
Me.GroupBox2.Controls.Add(Me.txtTagName)
Me.GroupBox2.Controls.Add(Me.Label14)
Me.GroupBox2.Controls.Add(Me.Label18)
Me.GroupBox2.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.GroupBox2.Location = New System.Drawing.Point(8, 496)
Me.GroupBox2.Name = "GroupBox2"
Me.GroupBox2.Size = New System.Drawing.Size(472, 59)
Me.GroupBox2.TabIndex = 7
Me.GroupBox2.TabStop = False
Me.GroupBox2.Text = "Tags"
'
'txtTagValue
'
Me.txtTagValue.Location = New System.Drawing.Point(312, 24)
Me.txtTagValue.Name = "txtTagValue"
Me.txtTagValue.Size = New System.Drawing.Size(144, 25)
Me.txtTagValue.TabIndex = 1
Me.txtTagValue.Text = ""
'
'txtTagName
'
Me.txtTagName.Location = New System.Drawing.Point(72, 24)
Me.txtTagName.Name = "txtTagName"
Me.txtTagName.Size = New System.Drawing.Size(144, 25)
Me.txtTagName.TabIndex = 0
Me.txtTagName.Text = ""
'
'Label14
'
Me.Label14.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label14.Location = New System.Drawing.Point(248, 24)
Me.Label14.Name = "Label14"
Me.Label14.Size = New System.Drawing.Size(56, 24)
Me.Label14.TabIndex = 40
Me.Label14.Text = "Value :"
Me.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'Label18
'
Me.Label18.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label18.Location = New System.Drawing.Point(8, 24)
Me.Label18.Name = "Label18"
Me.Label18.Size = New System.Drawing.Size(56, 24)
Me.Label18.TabIndex = 36
Me.Label18.Text = "Name :"
Me.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'GroupBox3
'
Me.GroupBox3.Controls.Add(Me.lblOEnd)
Me.GroupBox3.Controls.Add(Me.Label16)
Me.GroupBox3.Controls.Add(Me.lblOStart)
Me.GroupBox3.Controls.Add(Me.Label20)
Me.GroupBox3.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.GroupBox3.Location = New System.Drawing.Point(488, 496)
Me.GroupBox3.Name = "GroupBox3"
Me.GroupBox3.Size = New System.Drawing.Size(568, 59)
Me.GroupBox3.TabIndex = 8
Me.GroupBox3.TabStop = False
Me.GroupBox3.Text = "Output Parameters"
'
'lblOEnd
'
Me.lblOEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblOEnd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblOEnd.Location = New System.Drawing.Point(400, 24)
Me.lblOEnd.Name = "lblOEnd"
Me.lblOEnd.Size = New System.Drawing.Size(136, 24)
Me.lblOEnd.TabIndex = 1
Me.lblOEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label16
'
Me.Label16.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label16.Location = New System.Drawing.Point(320, 24)
Me.Label16.Name = "Label16"
Me.Label16.Size = New System.Drawing.Size(72, 24)
Me.Label16.TabIndex = 40
Me.Label16.Text = "End :"
Me.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblOStart
'
Me.lblOStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblOStart.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblOStart.Location = New System.Drawing.Point(136, 24)
Me.lblOStart.Name = "lblOStart"
Me.lblOStart.Size = New System.Drawing.Size(128, 24)
Me.lblOStart.TabIndex = 0
Me.lblOStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label20
'
Me.Label20.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label20.Location = New System.Drawing.Point(56, 24)
Me.Label20.Name = "Label20"
Me.Label20.Size = New System.Drawing.Size(72, 24)
Me.Label20.TabIndex = 36
Me.Label20.Text = "Start :"
Me.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'GroupBox4
'
Me.GroupBox4.Controls.Add(Me.lvCondition)
Me.GroupBox4.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.GroupBox4.Location = New System.Drawing.Point(8, 576)
Me.GroupBox4.Name = "GroupBox4"
Me.GroupBox4.Size = New System.Drawing.Size(1048, 136)
Me.GroupBox4.TabIndex = 9
Me.GroupBox4.TabStop = False
Me.GroupBox4.Text = "Last 5 Resolved Condition"
'
'lvCondition
'
Me.lvCondition.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader1, Me.ColumnHeader2, Me.ColumnHeader3, Me.ColumnHeader4})
Me.lvCondition.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lvCondition.FullRowSelect = True
Me.lvCondition.GridLines = True
Me.lvCondition.Location = New System.Drawing.Point(8, 20)
Me.lvCondition.MultiSelect = False
Me.lvCondition.Name = "lvCondition"
Me.lvCondition.Size = New System.Drawing.Size(1032, 108)
Me.lvCondition.TabIndex = 0
Me.lvCondition.View = System.Windows.Forms.View.Details
'
'ColumnHeader1
'
Me.ColumnHeader1.Text = ""
Me.ColumnHeader1.Width = 0
'
'ColumnHeader2
'
Me.ColumnHeader2.Text = "Index"
Me.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
Me.ColumnHeader2.Width = 49
'
'ColumnHeader3
'
Me.ColumnHeader3.Text = "Timestamp"
Me.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
Me.ColumnHeader3.Width = 162
'
'ColumnHeader4
'
Me.ColumnHeader4.Text = "Value"
Me.ColumnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
Me.ColumnHeader4.Width = 112
'
'GroupBox5
'
Me.GroupBox5.Controls.Add(Me.lvShownCondition)
Me.GroupBox5.Controls.Add(Me.btnShow)
Me.GroupBox5.Controls.Add(Me.gbTimeInterval)
Me.GroupBox5.Controls.Add(Me.gbIndexInterval)
Me.GroupBox5.Controls.Add(Me.optTimeInterval)
Me.GroupBox5.Controls.Add(Me.optIndexInterval)
Me.GroupBox5.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.GroupBox5.Location = New System.Drawing.Point(8, 712)
Me.GroupBox5.Name = "GroupBox5"
Me.GroupBox5.Size = New System.Drawing.Size(1048, 216)
Me.GroupBox5.TabIndex = 10
Me.GroupBox5.TabStop = False
Me.GroupBox5.Text = "Condition Filtered by Index or Time Interval"
'
'lvShownCondition
'
Me.lvShownCondition.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader5, Me.ColumnHeader6, Me.ColumnHeader7, Me.ColumnHeader8})
Me.lvShownCondition.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lvShownCondition.FullRowSelect = True
Me.lvShownCondition.GridLines = True
Me.lvShownCondition.Location = New System.Drawing.Point(8, 80)
Me.lvShownCondition.MultiSelect = False
Me.lvShownCondition.Name = "lvShownCondition"
Me.lvShownCondition.Size = New System.Drawing.Size(1032, 128)
Me.lvShownCondition.TabIndex = 5
Me.lvShownCondition.View = System.Windows.Forms.View.Details
'
'ColumnHeader5
'
Me.ColumnHeader5.Text = ""
Me.ColumnHeader5.Width = 0
'
'ColumnHeader6
'
Me.ColumnHeader6.Text = "Index"
Me.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
Me.ColumnHeader6.Width = 49
'
'ColumnHeader7
'
Me.ColumnHeader7.Text = "Timestamp"
Me.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
Me.ColumnHeader7.Width = 162
'
'ColumnHeader8
'
Me.ColumnHeader8.Text = "Value"
Me.ColumnHeader8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
Me.ColumnHeader8.Width = 112
'
'btnShow
'
Me.btnShow.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.btnShow.Location = New System.Drawing.Point(760, 48)
Me.btnShow.Name = "btnShow"
Me.btnShow.Size = New System.Drawing.Size(96, 24)
Me.btnShow.TabIndex = 4
Me.btnShow.Text = "Show"
'
'gbTimeInterval
'
Me.gbTimeInterval.Controls.Add(Me.Label7)
Me.gbTimeInterval.Controls.Add(Me.dtpEndRange)
Me.gbTimeInterval.Controls.Add(Me.Label5)
Me.gbTimeInterval.Controls.Add(Me.dtpStartRange)
Me.gbTimeInterval.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.gbTimeInterval.Location = New System.Drawing.Point(352, 16)
Me.gbTimeInterval.Name = "gbTimeInterval"
Me.gbTimeInterval.Size = New System.Drawing.Size(400, 56)
Me.gbTimeInterval.TabIndex = 2
Me.gbTimeInterval.TabStop = False
Me.gbTimeInterval.Text = "Time Interval"
'
'Label7
'
Me.Label7.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label7.Location = New System.Drawing.Point(200, 24)
Me.Label7.Name = "Label7"
Me.Label7.Size = New System.Drawing.Size(48, 24)
Me.Label7.TabIndex = 73
Me.Label7.Text = "End: "
Me.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'dtpEndRange
'
Me.dtpEndRange.CustomFormat = "dd/MM/yyyy HH:mm"
Me.dtpEndRange.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.dtpEndRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom
Me.dtpEndRange.Location = New System.Drawing.Point(256, 24)
Me.dtpEndRange.Name = "dtpEndRange"
Me.dtpEndRange.Size = New System.Drawing.Size(128, 22)
Me.dtpEndRange.TabIndex = 1
'
'Label5
'
Me.Label5.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label5.Location = New System.Drawing.Point(8, 24)
Me.Label5.Name = "Label5"
Me.Label5.Size = New System.Drawing.Size(48, 24)
Me.Label5.TabIndex = 71
Me.Label5.Text = "Start: "
Me.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'dtpStartRange
'
Me.dtpStartRange.CustomFormat = "dd/MM/yyyy HH:mm"
Me.dtpStartRange.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.dtpStartRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom
Me.dtpStartRange.Location = New System.Drawing.Point(64, 24)
Me.dtpStartRange.Name = "dtpStartRange"
Me.dtpStartRange.Size = New System.Drawing.Size(128, 22)
Me.dtpStartRange.TabIndex = 0
'
'gbIndexInterval
'
Me.gbIndexInterval.Controls.Add(Me.Label3)
Me.gbIndexInterval.Controls.Add(Me.nudEnd)
Me.gbIndexInterval.Controls.Add(Me.Label2)
Me.gbIndexInterval.Controls.Add(Me.nudStart)
Me.gbIndexInterval.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.gbIndexInterval.Location = New System.Drawing.Point(352, 16)
Me.gbIndexInterval.Name = "gbIndexInterval"
Me.gbIndexInterval.Size = New System.Drawing.Size(400, 56)
Me.gbIndexInterval.TabIndex = 3
Me.gbIndexInterval.TabStop = False
Me.gbIndexInterval.Text = "Index Interval"
'
'Label3
'
Me.Label3.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label3.Location = New System.Drawing.Point(200, 24)
Me.Label3.Name = "Label3"
Me.Label3.Size = New System.Drawing.Size(48, 24)
Me.Label3.TabIndex = 74
Me.Label3.Text = "End: "
Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'nudEnd
'
Me.nudEnd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.nudEnd.Location = New System.Drawing.Point(256, 24)
Me.nudEnd.Maximum = New Decimal(New Integer() {10000000, 0, 0, 0})
Me.nudEnd.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
Me.nudEnd.Name = "nudEnd"
Me.nudEnd.Size = New System.Drawing.Size(128, 22)
Me.nudEnd.TabIndex = 1
Me.nudEnd.Value = New Decimal(New Integer() {1, 0, 0, 0})
'
'Label2
'
Me.Label2.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label2.Location = New System.Drawing.Point(8, 24)
Me.Label2.Name = "Label2"
Me.Label2.Size = New System.Drawing.Size(48, 24)
Me.Label2.TabIndex = 70
Me.Label2.Text = "Start: "
Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'nudStart
'
Me.nudStart.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.nudStart.Location = New System.Drawing.Point(64, 24)
Me.nudStart.Maximum = New Decimal(New Integer() {10000000, 0, 0, 0})
Me.nudStart.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
Me.nudStart.Name = "nudStart"
Me.nudStart.Size = New System.Drawing.Size(128, 22)
Me.nudStart.TabIndex = 0
Me.nudStart.Value = New Decimal(New Integer() {1, 0, 0, 0})
'
'optTimeInterval
'
Me.optTimeInterval.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.optTimeInterval.Location = New System.Drawing.Point(200, 48)
Me.optTimeInterval.Name = "optTimeInterval"
Me.optTimeInterval.Size = New System.Drawing.Size(168, 24)
Me.optTimeInterval.TabIndex = 1
Me.optTimeInterval.TabStop = True
Me.optTimeInterval.Text = "Show by Time Interval"
'
'optIndexInterval
'
Me.optIndexInterval.Checked = True
Me.optIndexInterval.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.optIndexInterval.Location = New System.Drawing.Point(200, 24)
Me.optIndexInterval.Name = "optIndexInterval"
Me.optIndexInterval.Size = New System.Drawing.Size(168, 24)
Me.optIndexInterval.TabIndex = 0
Me.optIndexInterval.TabStop = True
Me.optIndexInterval.Text = "Show by Index Interval"
'
'GroupBox6
'
Me.GroupBox6.Controls.Add(Me.lblStatus)
Me.GroupBox6.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold)
Me.GroupBox6.Location = New System.Drawing.Point(328, 232)
Me.GroupBox6.Name = "GroupBox6"
Me.GroupBox6.Size = New System.Drawing.Size(136, 48)
Me.GroupBox6.TabIndex = 45
Me.GroupBox6.TabStop = False
Me.GroupBox6.Text = "Status"
'
'lblError
'
Me.lblError.ForeColor = System.Drawing.Color.Red
Me.lblError.Location = New System.Drawing.Point(16, 296)
Me.lblError.Name = "lblError"
Me.lblError.Size = New System.Drawing.Size(448, 152)
Me.lblError.TabIndex = 46
'
'txtConditionName
'
Me.txtConditionName.Location = New System.Drawing.Point(16, 176)
Me.txtConditionName.Name = "txtConditionName"
Me.txtConditionName.Size = New System.Drawing.Size(448, 22)
Me.txtConditionName.TabIndex = 1
Me.txtConditionName.Text = ""
'
'GroupBox7
'
Me.GroupBox7.Controls.Add(Me.cmbParameter)
Me.GroupBox7.Controls.Add(Me.lblParameterComment)
Me.GroupBox7.Controls.Add(Me.Label28)
Me.GroupBox7.Controls.Add(Me.Label24)
Me.GroupBox7.Controls.Add(Me.cmbDefinition)
Me.GroupBox7.Controls.Add(Me.btnReqConditionDefinitions)
Me.GroupBox7.Controls.Add(Me.lblParameterDefaultValue)
Me.GroupBox7.Controls.Add(Me.Label15)
Me.GroupBox7.Controls.Add(Me.lblParameterType)
Me.GroupBox7.Controls.Add(Me.Label22)
Me.GroupBox7.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.GroupBox7.Location = New System.Drawing.Point(8, 48)
Me.GroupBox7.Name = "GroupBox7"
Me.GroupBox7.Size = New System.Drawing.Size(1048, 112)
Me.GroupBox7.TabIndex = 0
Me.GroupBox7.TabStop = False
Me.GroupBox7.Text = "Condition Definitions"
'
'cmbParameter
'
Me.cmbParameter.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
Me.cmbParameter.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.cmbParameter.Location = New System.Drawing.Point(640, 16)
Me.cmbParameter.Name = "cmbParameter"
Me.cmbParameter.Size = New System.Drawing.Size(400, 25)
Me.cmbParameter.TabIndex = 2
'
'lblParameterComment
'
Me.lblParameterComment.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblParameterComment.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblParameterComment.Location = New System.Drawing.Point(640, 48)
Me.lblParameterComment.Name = "lblParameterComment"
Me.lblParameterComment.Size = New System.Drawing.Size(400, 24)
Me.lblParameterComment.TabIndex = 46
Me.lblParameterComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label28
'
Me.Label28.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label28.Location = New System.Drawing.Point(544, 48)
Me.Label28.Name = "Label28"
Me.Label28.Size = New System.Drawing.Size(88, 24)
Me.Label28.TabIndex = 45
Me.Label28.Text = "Comment :"
Me.Label28.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'Label24
'
Me.Label24.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label24.Location = New System.Drawing.Point(552, 16)
Me.Label24.Name = "Label24"
Me.Label24.Size = New System.Drawing.Size(80, 24)
Me.Label24.TabIndex = 44
Me.Label24.Text = "Parameter :"
Me.Label24.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'cmbDefinition
'
Me.cmbDefinition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
Me.cmbDefinition.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.cmbDefinition.Location = New System.Drawing.Point(112, 24)
Me.cmbDefinition.Name = "cmbDefinition"
Me.cmbDefinition.Size = New System.Drawing.Size(352, 25)
Me.cmbDefinition.TabIndex = 1
'
'btnReqConditionDefinitions
'
Me.btnReqConditionDefinitions.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.btnReqConditionDefinitions.Location = New System.Drawing.Point(8, 24)
Me.btnReqConditionDefinitions.Name = "btnReqConditionDefinitions"
Me.btnReqConditionDefinitions.Size = New System.Drawing.Size(96, 26)
Me.btnReqConditionDefinitions.TabIndex = 0
Me.btnReqConditionDefinitions.Text = "Request"
'
'lblParameterDefaultValue
'
Me.lblParameterDefaultValue.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblParameterDefaultValue.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblParameterDefaultValue.Location = New System.Drawing.Point(904, 80)
Me.lblParameterDefaultValue.Name = "lblParameterDefaultValue"
Me.lblParameterDefaultValue.Size = New System.Drawing.Size(136, 24)
Me.lblParameterDefaultValue.TabIndex = 41
Me.lblParameterDefaultValue.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label15
'
Me.Label15.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label15.Location = New System.Drawing.Point(784, 80)
Me.Label15.Name = "Label15"
Me.Label15.Size = New System.Drawing.Size(112, 24)
Me.Label15.TabIndex = 40
Me.Label15.Text = "Default Value :"
Me.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblParameterType
'
Me.lblParameterType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblParameterType.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblParameterType.Location = New System.Drawing.Point(640, 80)
Me.lblParameterType.Name = "lblParameterType"
Me.lblParameterType.Size = New System.Drawing.Size(128, 24)
Me.lblParameterType.TabIndex = 37
Me.lblParameterType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label22
'
Me.Label22.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label22.Location = New System.Drawing.Point(560, 80)
Me.Label22.Name = "Label22"
Me.Label22.Size = New System.Drawing.Size(72, 24)
Me.Label22.TabIndex = 36
Me.Label22.Text = "Type :"
Me.Label22.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPRecalcPeriod
'
Me.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPRecalcPeriod.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPRecalcPeriod.Location = New System.Drawing.Point(432, 248)
Me.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod"
Me.lblRPRecalcPeriod.Size = New System.Drawing.Size(136, 24)
Me.lblRPRecalcPeriod.TabIndex = 64
Me.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label19
'
Me.Label19.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label19.Location = New System.Drawing.Point(320, 248)
Me.Label19.Name = "Label19"
Me.Label19.Size = New System.Drawing.Size(104, 24)
Me.Label19.TabIndex = 63
Me.Label19.Text = "Recalc Period :"
Me.Label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'lblRPSubscriptionLevel
'
Me.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
Me.lblRPSubscriptionLevel.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.lblRPSubscriptionLevel.Location = New System.Drawing.Point(152, 248)
Me.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel"
Me.lblRPSubscriptionLevel.Size = New System.Drawing.Size(144, 24)
Me.lblRPSubscriptionLevel.TabIndex = 62
Me.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
'
'Label30
'
Me.Label30.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.Label30.Location = New System.Drawing.Point(8, 248)
Me.Label30.Name = "Label30"
Me.Label30.Size = New System.Drawing.Size(136, 24)
Me.Label30.TabIndex = 61
Me.Label30.Text = "Subscription Level :"
Me.Label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight
'
'frmCondition
'
Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
Me.ClientSize = New System.Drawing.Size(1062, 931)
Me.Controls.Add(Me.PictureBox1)
Me.Controls.Add(Me.GroupBox7)
Me.Controls.Add(Me.txtConditionName)
Me.Controls.Add(Me.lblError)
Me.Controls.Add(Me.GroupBox6)
Me.Controls.Add(Me.GroupBox5)
Me.Controls.Add(Me.GroupBox4)
Me.Controls.Add(Me.GroupBox2)
Me.Controls.Add(Me.PictureBox3)
Me.Controls.Add(Me.PictureBox2)
Me.Controls.Add(Me.GroupBox1)
Me.Controls.Add(Me.btnRemoveAll)
Me.Controls.Add(Me.btnRemove)
Me.Controls.Add(Me.btnRequest)
Me.Controls.Add(Me.cmbCondition)
Me.Controls.Add(Me.lblDataConnection)
Me.Controls.Add(Me.llWeb)
Me.Controls.Add(Me.GroupBox3)
Me.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
Me.MaximizeBox = False
Me.Name = "frmCondition"
Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
Me.Text = "Condition"
Me.GroupBox1.ResumeLayout(False)
Me.GroupBox2.ResumeLayout(False)
Me.GroupBox3.ResumeLayout(False)
Me.GroupBox4.ResumeLayout(False)
Me.GroupBox5.ResumeLayout(False)
Me.gbTimeInterval.ResumeLayout(False)
Me.gbIndexInterval.ResumeLayout(False)
CType(Me.nudEnd, System.ComponentModel.ISupportInitialize).EndInit()
CType(Me.nudStart, System.ComponentModel.ISupportInitialize).EndInit()
Me.GroupBox6.ResumeLayout(False)
Me.GroupBox7.ResumeLayout(False)
Me.ResumeLayout(False)

    End Sub

#End Region

    ''' <summary>
    ''' Creates a CEL object, changes its configurations, and starts up the created CEL object.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub frmCondition_Load(ByVal sender As System.Object, _
                                  ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            ' Creates the CQGCEL object
            CEL = New CQGCEL
            CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff
            CEL.APIConfiguration.CollectionsThrowException = False
            CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral

            ' Disables the controls
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown)
            ' Starts up the CQGCEL
            CEL.Startup()

            cmbCondition.Items.Clear()
            cmbCondition.SelectedIndex = -1

            ClearAllData()

            m_CurCondition = Nothing
        Catch ex As Exception
            ShowError("frmCondition", "frmCondition_Load", ex)
            Me.Close()
        End Try
    End Sub

    ''' <summary>
    ''' Shuts down CEL.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A CancelEventArgs that contains the event data.
    ''' </param>
    Private Sub frmCondition_Closing(ByVal sender As Object, _
                                     ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If Not CEL Is Nothing Then
            CEL.Shutdown()
        End If
    End Sub

    ''' <summary>
    ''' Clears all old info regarding to old ConditionDefinitions and requests new ConditionDefinitions. 
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnReqConditionDefinitions_Click(ByVal sender As System.Object, _
                                                 ByVal e As System.EventArgs) Handles btnReqConditionDefinitions.Click
        Try
            CEL.RequestConditionDefinitions()
            ClearDefinitionData()
        Catch ex As Exception
            ShowError("frmCondition", "btnReqConditionDefinitions_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Opens frmConditionRequestSettings and with passed values requests Condition.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnRequest_Click(ByVal sender As System.Object, _
                                 ByVal e As System.EventArgs) Handles btnRequest.Click
        Dim frmConditionReq As frmConditionRequestSettings
        Dim Condition As CQGCondition

        Try
            ' Opens the form to fill up request data
            frmConditionReq = New frmConditionRequestSettings
            Dim req As CQGConditionRequest = CEL.CreateConditionRequest(txtConditionName.Text)

            req.SessionsFilter = 31 ' In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

            frmConditionReq.ConditionRequest = req
            frmConditionReq.LineTime = CEL.Environment.LineTime

            ' If the user confirms, request is sent to CQGCEL and added to the requests list
            If frmConditionReq.ShowDialog(Me) = DialogResult.OK Then
                Condition = CEL.RequestCondition(req)

                cmbCondition.Items.Add(Condition.Id)
                cmbCondition.SelectedIndex = cmbCondition.Items.Count - 1

                ChangeControlsStatuses()
            End If
        Catch ex As Exception
            ShowError("frmCondition", "btnRequest_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected Condition info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbCondition_SelectedIndexChanged(ByVal sender As System.Object, _
                                                  ByVal e As System.EventArgs) Handles cmbCondition.SelectedIndexChanged
        Try
            With cmbCondition
                If .SelectedIndex > -1 Then
                    ' Gets the selected Condition object from CQGCEL by it's ID
                    m_CurCondition = CEL.AllConditions.ItemById(.Text)

                    ClearAllData()
                    DumpAllData()

                    DumpFilterInfo()
                End If
            End With

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmCondition", "cmbCondition_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes the visibility of groupboxes.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub optIndexOrTimeInterval_CheckedChanged(ByVal sender As System.Object, _
                                                      ByVal e As System.EventArgs) Handles optIndexInterval.CheckedChanged, _
                                                                                           optTimeInterval.CheckedChanged
        Try
            gbIndexInterval.Visible = optIndexInterval.Checked
            gbTimeInterval.Visible = optTimeInterval.Checked
        Catch ex As Exception
            ShowError("frmCondition", "optIndexOrTimeInterval_CheckedChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected Definition info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbDefinition_SelectedIndexChanged(ByVal sender As System.Object, _
                                                   ByVal e As System.EventArgs) Handles cmbDefinition.SelectedIndexChanged
        Try
            Dim definition As CQGConditionDefinition = m_ConditionDefinitions.ItemByName(cmbDefinition.Text)

            If definition Is Nothing Then
                Exit Sub
            End If

            With cmbParameter
                .Items.Clear()

                For Each param As CQGParameterDefinition In definition.ParameterDefinitions
                    .Items.Add(param.Name)
                Next

                If .Items.Count > 0 Then
                    .SelectedIndex = 0
                Else
                    lblParameterComment.Text = ""
                    lblParameterType.Text = ""
                    lblParameterDefaultValue.Text = ""
                End If
            End With

            txtConditionName.Text = cmbDefinition.Text
        Catch ex As Exception
            ShowError("frmCondition", "cmbDefinition_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected Parameter info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbParameter_SelectedIndexChanged(ByVal sender As System.Object, _
                                                  ByVal e As System.EventArgs) Handles cmbParameter.SelectedIndexChanged
        Try
            If cmbParameter.SelectedIndex > -1 Then
                Dim conditionDef As CQGConditionDefinition = m_ConditionDefinitions.ItemByName(cmbDefinition.Text)
                Dim param As CQGParameterDefinition = conditionDef.ParameterDefinitions.ItemByName(cmbParameter.Text)

                lblParameterComment.Text = param.Comment
                lblParameterType.Text = param.Type.ToString()
                lblParameterDefaultValue.Text = param.DefaultValue.ToString()
            Else
                lblParameterComment.Text = ""
                lblParameterType.Text = ""
                lblParameterDefaultValue.Text = ""
            End If
        Catch ex As Exception
            ShowError("frmCondition", "cmbParameter_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Opens CQG API web page.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A LinkLabelLinkClickedEventArgs that contains the event data.
    ''' </param>
    Private Sub llWeb_LinkClicked(ByVal sender As System.Object, _
                                  ByVal e As LinkLabelLinkClickedEventArgs) Handles llWeb.LinkClicked
        Try
            System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx")
        Catch ex As Exception
            ShowError("frmCondition", "llWeb_LinkClicked", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows few data from the selected Condition collection.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnShow_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles btnShow.Click
        Dim iStart As Integer
        Dim iEnd As Integer
        Dim dStart As Date
        Dim dEnd As Date

        Try
            lvShownCondition.Items.Clear()

            If optIndexInterval.Checked Then
                iStart = CInt(nudStart.Value) - 1
                iEnd = CInt(nudEnd.Value) - 1
                If iStart > iEnd Or iEnd > m_CurCondition.Count - 1 Or _
                   iEnd - iStart >= MAX_INDEX_INTERVAL Then
                    MessageBox.Show("The start index must be smaller than the end index," & Environment.NewLine & _
                                    "their range must indicate to no more than " & MAX_INDEX_INTERVAL & " records," & Environment.NewLine & _
                                    "and no more than the returned records count.", _
                                    "Incorrect range", _
                                    MessageBoxButtons.OK, _
                                    MessageBoxIcon.Exclamation)
                    Exit Sub
                End If
            Else
                ' To get time with 00 seconds
                dStart = dtpStartRange.Value.AddSeconds(-dtpStartRange.Value.Second)
                dEnd = dtpEndRange.Value.AddSeconds(-dtpEndRange.Value.Second)
                iStart = m_CurCondition.IndexForDate(dStart)
                iEnd = m_CurCondition.IndexForDate(dEnd)
                If dStart > dEnd Or Not (CEL.IsValid(iStart) And CEL.IsValid(iEnd)) Or _
                    iEnd - iStart >= MAX_INDEX_INTERVAL Then
                    MessageBox.Show("The start time must be earlier than the end time and their" & Environment.NewLine & _
                                    "range must indicate to no more than " & MAX_INDEX_INTERVAL & " records.", _
                                    "Incorrect range", _
                                    MessageBoxButtons.OK, _
                                    MessageBoxIcon.Exclamation)
                    Exit Sub
                End If
            End If

            lvShownCondition.SuspendLayout()
            For i As Integer = iEnd To iStart Step -1
                DumpRecord(lvShownCondition, m_CurCondition(i), i + 1)
            Next
            lvShownCondition.ResumeLayout(False)
        Catch ex As Exception
            ShowError("frmCondition", "btnShow_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Removes the selected Condition from the list and the CQGCEL.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnRemove_Click(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) Handles btnRemove.Click
        Try
            ' Removes Condition from the collection
            CEL.RemoveCondition(m_CurCondition)

            With cmbCondition
                ' Removes Condition from the combo box
                .Items.RemoveAt(.SelectedIndex)

                .SelectedIndex = .Items.Count - 1

                If .Items.Count = 0 Then
                    .SelectedIndex = -1
                    ClearAllData()
                    m_CurCondition = Nothing
                End If
            End With

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmCondition", "btnRemove_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Removes all Condition from the list and the CQGCEL.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnRemoveAll_Click(ByVal sender As System.Object, _
                                   ByVal e As System.EventArgs) Handles btnRemoveAll.Click
        Try
            ' Clears the combo box
            cmbCondition.Items.Clear()
            cmbCondition.SelectedIndex = -1

            ' Removes all Condition from the collection
            CEL.RemoveAllConditions()

            m_CurCondition = Nothing

            ClearAllData()

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmCondition", "btnRemoveAll_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows tag value of the current Condition corresponding to the entered name.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A KeyEventArgs that contains the event data.
    ''' </param>
    Private Sub txtTagName_KeyDown(ByVal sender As Object, _
                                   ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtTagName.KeyDown
        Try
            If txtTagName.Text.Trim.Length = 0 Then
                Exit Sub
            End If

            If e.KeyCode = Keys.Return Then
                txtTagValue.Text = CStr(m_CurCondition.Tag(txtTagName.Text))
            End If
        Catch ex As Exception
            ShowError("frmCondition", "txtTagName_KeyDown", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Sets the tag value of the current Condition corresponding to the entered name.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A KeyEventArgs that contains the event data.
    ''' </param>
    Private Sub txtTagValue_KeyDown(ByVal sender As Object, _
                                    ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtTagValue.KeyDown
        Try
            If txtTagName.Text.Trim.Length = 0 Then
                Exit Sub
            End If

            If e.KeyCode = Keys.Return Then
                If Len(Trim(txtTagValue.Text)) = 0 Then
                    m_CurCondition.Tag(txtTagName.Text) = Nothing
                Else
                    m_CurCondition.Tag(txtTagName.Text) = txtTagValue.Text
                End If
                txtTagName.Text = ""
                txtTagValue.Text = ""
            End If
        Catch ex As Exception
            ShowError("frmCondition", "txtTagValue_KeyDown", ex)
        End Try
    End Sub

    ''' <summary>
    ''' This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
    ''' </summary>
    ''' <param name="cqg_error">
    ''' The object, in which the error has occurred.
    ''' </param>
    ''' <param name="error_description">
    ''' The string, describing the error.
    ''' </param>
    Private Sub CEL_DataError(ByVal cqg_error As Object, _
                              ByVal error_description As String) Handles CEL.DataError
        Try
            Dim cqgErr As CQGError = TryCast(cqg_error, CQGError)
            If CEL.IsValid(cqgErr) Then
                If cqgErr.Code = 102 Then
                    error_description &= " Restart the application."
                ElseIf cqgErr.Code = 125 Then
                    error_description &= " Turn on CQG Client and restart the application."
                End If
            End If

            MessageBox.Show(error_description, "Condition", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            ShowError("frmCondition", "CEL_DataError", ex)
        End Try
    End Sub

    ''' <summary>
    ''' This event is fired, when some changes occur in the connection with CQG data server.
    ''' </summary>
   ''' <param name="new_status">
    ''' The current status of the connection with the data server.
    ''' </param>
    Private Sub CEL_DataConnectionStatusChanged(ByVal new_status As CQG.eConnectionStatus) Handles CEL.DataConnectionStatusChanged
        Dim sInfo As String
        Dim BackCol As System.Drawing.Color

        Try
            If new_status = eConnectionStatus.csConnectionUp Then
                BackCol = System.Drawing.Color.FromArgb(192, 209, 205)
                sInfo = "DATA Connection is UP"
            ElseIf new_status = eConnectionStatus.csConnectionDelayed Then
                BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
                sInfo = "DATA Connection is Delayed"
            Else
                BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
                sInfo = "DATA Connection is Down"
            End If

            lblDataConnection.BackColor = BackCol
            lblDataConnection.Text = sInfo

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmCondition", "CEL_DataConnectionStatusChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Displays resolved condition definitions.
    ''' </summary>
    ''' <param name="cqg_condition_definitions">
    ''' The resolved CQGConditionDefinitions object.
    ''' </param>
    ''' <param name="cqg_error">
    ''' CQGError object describing last error occurred
    ''' during processing request or Nothing in case of no error.
    ''' </param>
    Private Sub CEL_ConditionDefinitionsResolved(ByVal cqg_condition_definitions As CQGConditionDefinitions, _
                                                 ByVal cqg_error As CQGError) Handles CEL.ConditionDefinitionsResolved
        Try
            ' Set the resolved object
            m_ConditionDefinitions = cqg_condition_definitions

            ' Notifying when any error occurred during request
            If CEL.IsValid(cqg_error) Then
                MessageBox.Show(cqg_error.Description, "Condition", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            ' Fill up new data
            With cmbDefinition
                For Each definition As CQGConditionDefinition In cqg_condition_definitions
                    .Items.Add(definition.Name)
                Next

                If .Items.Count > 0 Then
                    .SelectedIndex = 0
                End If
            End With
        Catch ex As Exception
            ShowError("frmCondition", "CEL_ConditionDefinitionsResolved", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Fired when the condition (CQGCondition) is resolved or when some 
    ''' error has occurred during the condition request processing.
    ''' </summary>
    ''' <param name="cqg_condition">
    ''' Reference to resolved CQGCondition
    ''' </param>
    ''' <param name="cqg_error">
    ''' The CQGError object that describes the last error occurred 
    ''' while processing the Condition request or
    ''' Nothing/Invalid_Error in case of no error.
    ''' </param>
    Private Sub CEL_ConditionResolved(ByVal cqg_condition As CQGCondition, _
                                      ByVal cqg_error As CQGError) Handles CEL.ConditionResolved
        Try
            If cqg_condition.Id = m_CurCondition.Id Then
                ClearAllData()
                DumpAllData()
                DumpFilterInfo()
            End If
        Catch ex As Exception
            ShowError("frmCondition", "CEL_ConditionResolved", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Fired when CQGConditionResult item is added to the end of the CQGCondition.
    ''' </summary>
    ''' <param name="cqg_condition">
    ''' Reference to changed CQGCondition.
    ''' </param>
    Private Sub CEL_ConditionAdded(ByVal cqg_condition As CQGCondition) Handles CEL.ConditionAdded
        Try
            If cqg_condition.Id = m_CurCondition.Id Then
                ShowChangedData(cqg_condition.Count)
            End If
        Catch ex As Exception
            ShowError("frmCondition", "CEL_ConditionAdded", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Fired when a CQGConditionResult item is inserted into CQGCondition.
    ''' </summary>
    ''' <param name="cqg_condition">
    ''' Reference to changed CQGCondition 
    ''' </param>
    ''' <param name="index_">
    ''' Specifies the changed CQGConditionResult index.
    ''' </param>
    Private Sub CEL_ConditionInserted(ByVal cqg_condition As CQGCondition, _
                                      ByVal index_ As Integer) Handles CEL.ConditionInserted
        Try
            If cqg_condition.Id = m_CurCondition.Id Then
                ShowChangedData(cqg_condition.Count)
            End If
        Catch ex As Exception
            ShowError("frmCondition", "CEL_ConditionInserted", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Fired when a CQGConditionResult item is removed from CQGCondition.
    ''' </summary>
    ''' <param name="cqg_condition">
    ''' Reference to changed CQGCondition 
    ''' </param>
    ''' <param name="index_">
    ''' Specifies the changed CQGConditionResult index.
    ''' </param>
    Private Sub CEL_ConditionRemoved(ByVal cqg_condition As CQGCondition, _
                                     ByVal index_ As Integer) Handles CEL.ConditionRemoved
        Try
            If cqg_condition.Id = m_CurCondition.Id Then
                ShowChangedData(cqg_condition.Count)
            End If
        Catch ex As Exception
            ShowError("frmCondition", "CEL_ConditionRemoved", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Fired when a CQGConditionResult item is updated.
    ''' </summary>
    ''' <param name="cqg_condition">
    ''' Reference to changed CQGCondition 
    ''' </param>
    ''' <param name="index_">
    ''' Specifies the updated CQGConditionResult index.
    ''' </param>
    Private Sub CEL_ConditionUpdated(ByVal cqg_condition As CQG.CQGCondition, _
                                     ByVal index_ As Integer) Handles CEL.ConditionUpdated
        Try
            If cqg_condition.Id = m_CurCondition.Id Then
                If index_ > m_CurCondition.Count - MAX_NUMBER_OF_RECORDS Then
                    UpdateRecord(lvCondition, m_CurCondition(index_), index_ + 1)
                End If
            End If
        Catch ex As Exception
            ShowError("frmCondition", "CEL_ConditionUpdated", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows the selected request parameters on the listview.
    ''' </summary>
    Private Sub DumpRequestParams()
        Dim parameterDefinitionName As String
        Try
            Dim req As CQGConditionRequest = m_CurCondition.Request

            lblRPConditionDefinitionName.Text = req.Definition.Name

            ' Adding parameters to the corresponding combo list
            For i As Integer = 0 To req.Definition.ParameterDefinitions.Count - 1
                parameterDefinitionName = req.Definition.ParameterDefinitions.Item(i).Name
                lstRPParameters.Items.Add(parameterDefinitionName & " - " & _
                                            req.Parameter(parameterDefinitionName).ToString())
            Next

            lblRPBaseExpression.Text = req.BaseExpression
            lblRPRangeStart.Text = GetValueAsString(req.RangeStart)
            lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd)
            lblRPIntradayPeriod.Text = req.IntradayPeriod.ToString()
            lblRPHistoricalPeriod.Text = req.HistoricalPeriod.ToString()
            lblRPUpdatesEnabled.Text = req.UpdatesEnabled.ToString()
            lblRPIncludeEnd.Text = req.IncludeEnd.ToString()

            Dim sessionsFilter As String
            sessionsFilter = req.SessionsFilter.ToString()
            Select Case sessionsFilter
                Case "0"
                    sessionsFilter = "Primary session only (0)"
                Case "31"
                    sessionsFilter = "All sessions (31)"
            End Select

            lblRPSessionsFilter.Text = sessionsFilter
            lblRPContinuation.Text = req.Continuation.ToString()
            lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString()
            lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString()
            lblRPSessionFlags.Text = req.SessionFlags.ToString()
            lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString()
            If req.SubscriptionLevel = eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod Then
                lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString()
            End If

            If Not m_CurCondition.LastError Is Nothing Then
                lblError.Text = m_CurCondition.LastError.Description
            End If
        Catch ex As Exception
            ShowError("frmCondition", "DumpRequestParams", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows the selected request outputs on the listview.
    ''' </summary>
    Private Sub DumpOutputParams()
        Try
            lblOStart.Text = GetValueAsString(m_CurCondition.StartTimestamp)
            lblOEnd.Text = GetValueAsString(m_CurCondition.EndTimestamp)
        Catch ex As Exception
            ShowError("frmCondition", "DumpOutputParams", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows the selected request outputs on the listview after changes.
    ''' </summary>
    ''' <param name="count">
    ''' Count of Condition that will be shown.
    ''' </param>
    Private Sub ShowChangedData(ByVal count As Integer)
        ClearOutputParams()
        DumpOutputParams()

        DumpRecords(count)
    End Sub

    ''' <summary>
    ''' Shows added Condition for the selected request records on the listview.
    ''' </summary>
    ''' <param name="addedConditionCount">
    ''' Count of Condition that will be shown.
    ''' </param>
    Private Sub DumpRecords(ByVal addedConditionCount As Integer)
        Try
            ' Clears all records
            ClearRecords()

            If m_CurCondition.Count = 0 Then
                Exit Sub
            End If

            If addedConditionCount = m_CurCondition.Count Then
                addedConditionCount = CInt(IIf(addedConditionCount >= MAX_NUMBER_OF_RECORDS, MAX_NUMBER_OF_RECORDS, m_CurCondition.Count))
            End If
            For i As Integer = m_CurCondition.Count - 1 To m_CurCondition.Count - addedConditionCount Step -1
                DumpRecord(lvCondition, m_CurCondition(i), i + 1)
            Next
        Catch ex As Exception
            ShowError("frmCondition", "DumpRecords", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Dumps one record's values to the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview, in which data must be shown.
    ''' </param>
    ''' <param name="conditionResult">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be shown.
    ''' </param>
    Private Sub DumpRecord(ByVal lv As ListView, _
                           ByVal conditionResult As CQGConditionResult, _
                           ByVal recordIndex As Long)
        Try
            Dim item As ListViewItem = lv.Items.Add(New ListViewItem)
            item.SubItems.Add("Index").Text = recordIndex.ToString()
            item.SubItems.Add("Timestamp").Text = GetValueAsString(conditionResult.Timestamp, True)
            item.SubItems.Add("Value").Text = GetValueAsString(conditionResult.Value)
        Catch ex As Exception
            ShowError("frmCondition", "DumpRecord", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Updates one record's values to the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview, in which data must be shown.
    ''' </param>
    ''' <param name="conditionResult">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be updated.
    ''' </param>
    Private Sub UpdateRecord(ByVal lv As ListView, _
                             ByVal conditionResult As CQGConditionResult, _
                             ByVal recordIndex As Integer)
        Try
            Dim item As ListViewItem = New ListViewItem
            item.SubItems.Add("Index").Text = recordIndex.ToString()
            item.SubItems.Add("Timestamp").Text = GetValueAsString(conditionResult.Timestamp, True)
            item.SubItems.Add("Value").Text = GetValueAsString(conditionResult.Value)
            lv.Items(m_CurCondition.Count - recordIndex) = item
        Catch ex As Exception
            ShowError("frmCondition", "UpdateRecord", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Dumps all request data (outputs\parameters\records)
    ''' </summary>
    Private Sub DumpAllData()
        Try
            DumpRequestParams()

            lblStatus.Text = m_CurCondition.Status.ToString()

            If m_CurCondition.Status = eRequestStatus.rsSuccess Then
                DumpOutputParams()
                DumpRecords(m_CurCondition.Count)
            End If

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmCondition", "DumpAllData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Initializes the filter-related controls.
    ''' </summary>
    Private Sub DumpFilterInfo()
        Try
            If Not m_CurCondition Is Nothing And m_CurCondition.Status = eRequestStatus.rsSuccess Then
                dtpStartRange.Value = m_CurCondition.StartTimestamp
                dtpEndRange.Value = m_CurCondition.EndTimestamp
            Else
                dtpStartRange.Value = Now
                dtpEndRange.Value = Now
            End If
            nudStart.Value = 1
            nudEnd.Value = 1
        Catch ex As Exception
            ShowError("frmCondition", "DumpFilterInfo", ex)
        End Try
    End Sub

    ''' <summary>
    '''  Clears all data connected to condition definitions.
    ''' </summary>
    Private Sub ClearDefinitionData()
        Try
            cmbDefinition.Items.Clear()
            cmbDefinition.SelectedIndex = -1

            cmbParameter.Items.Clear()
            cmbParameter.SelectedIndex = -1

            lblParameterComment.Text = ""
            lblParameterType.Text = ""
            lblParameterDefaultValue.Text = ""

            txtConditionName.Text = ""
        Catch ex As Exception
            ShowError("frmCondition", "ClearAllData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears all request data.
    ''' </summary>
    Private Sub ClearAllData()
        Try
            lblStatus.Text = ""

            ClearRequestParams()
            ClearOutputParams()
            ClearTags()
            ClearRecords()

            lvShownCondition.Items.Clear()
        Catch ex As Exception
            ShowError("frmCondition", "ClearAllData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears the request parameters from the listview.
    ''' </summary>
    Private Sub ClearRequestParams()
        Try
            lblRPConditionDefinitionName.Text = ""

            lstRPParameters.Items.Clear()

            lblRPBaseExpression.Text = ""
            lblRPRangeStart.Text = ""
            lblRPRangeEnd.Text = ""
            lblRPIntradayPeriod.Text = ""
            lblRPHistoricalPeriod.Text = ""
            lblRPUpdatesEnabled.Text = ""
            lblRPIncludeEnd.Text = ""
            lblRPSessionsFilter.Text = ""
            lblRPContinuation.Text = ""
            lblRPEqualizeCloses.Text = ""
            lblRPDaysBeforeExpiration.Text = ""
            lblRPSessionFlags.Text = ""
            lblRPSubscriptionLevel.Text = ""
            lblRPRecalcPeriod.Text = ""

            lblError.Text = ""
        Catch ex As Exception
            ShowError("frmCondition", "ClearRequestParams", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears request outputs from the listview.
    ''' </summary>
    Private Sub ClearOutputParams()
        Try
            lblOStart.Text = ""
            lblOEnd.Text = ""
        Catch ex As Exception
            ShowError("frmCondition", "ClearOutputParams", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears request tags.
    ''' </summary>
    Private Sub ClearTags()
        Try
            txtTagName.Text = ""
            txtTagValue.Text = ""
        Catch ex As Exception
            ShowError("frmCondition", "ClearTags", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears records from the listview.
    ''' </summary>
    Private Sub ClearRecords()
        Try
            lvCondition.Items.Clear()
        Catch ex As Exception
            ShowError("frmCondition", "ClearRecords", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Enables\disables the controls, based on the connection status.
    ''' </summary>
    Private Sub ChangeControlsStatuses()
        Dim bIsDataConnectionUp As Boolean = False
        Dim bIsConditionSelected As Boolean
        Dim bIsConditionSucceded As Boolean = False

        Try
            If CEL.IsStarted Then
                bIsDataConnectionUp = (CEL.Environment.DataConnectionStatus = eConnectionStatus.csConnectionUp)
            End If

            btnReqConditionDefinitions.Enabled = bIsDataConnectionUp

            btnRequest.Enabled = bIsDataConnectionUp

            bIsConditionSelected = (Not m_CurCondition Is Nothing)

            btnRemove.Enabled = bIsConditionSelected And bIsDataConnectionUp
            btnRemoveAll.Enabled = bIsConditionSelected And bIsDataConnectionUp

            txtTagName.Enabled = bIsConditionSelected
            txtTagValue.Enabled = bIsConditionSelected

            If bIsConditionSelected Then
                bIsConditionSucceded = (m_CurCondition.Status = eRequestStatus.rsSuccess)
            End If

            dtpEndRange.Enabled = bIsConditionSucceded
            dtpStartRange.Enabled = bIsConditionSucceded

            nudEnd.Enabled = bIsConditionSucceded
            nudStart.Enabled = bIsConditionSucceded

            optIndexInterval.Enabled = bIsConditionSucceded
            optTimeInterval.Enabled = bIsConditionSucceded

            btnShow.Enabled = bIsConditionSucceded
        Catch ex As Exception
            ShowError("frmCondition", "ChangeControlsStatuses", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Validates the specified value and converts it to string.
    ''' </summary>
    ''' <param name="val">
    ''' The value that will be validated and converted
   ''' </param>
   ''' <param name="includeMilliseconds">
   ''' Whether to include seconds and milliseconds to string, valid only for DateTime
   ''' </param>
    ''' <returns>
    ''' Value converted to string or "N/A" if the value is invalid.
    ''' </returns>
    Private Function GetValueAsString(ByVal val As Object, 
                                      Optional ByVal includeMilliseconds As Boolean = False) As String
        Dim sResult As String = ""

        Try
            If CEL.IsValid(val) Then
                If val.GetType().FullName = "System.DateTime" Then
                     Dim format As String = If(includeMilliseconds, "dd/MM/yyyy HH:mm:ss.fff", "dd/MM/yyyy HH:mm")
                     sResult = CDate(val).ToString(format)
                Else
                    sResult = val.ToString()
                End If
            Else
                sResult = N_A
            End If
        Catch
            sResult = N_A
        End Try

        Return sResult
    End Function

End Class
