// CustomSessions.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <cassert>
#include "Helper.h"

const CString CHelper::m_N_A = _T("N/A");

CString CHelper::ConnectionStatusToString(
                        eConnectionStatus connectionStatus)
{
   CString connectionStatusStr;

   switch (connectionStatus)
   {
   case csConnectionUp:
      connectionStatusStr = _T("Connection Up");
      break;
   case csConnectionDown:
      connectionStatusStr = _T("Connection Down");
      break;
   case csConnectionDelayed:
      connectionStatusStr = _T("Connection Delayed");
      break;
   default:
      assert(!"Unknown connection status");
   }

   return connectionStatusStr;
}

CString CHelper::SymbolSessionTypeToString(
                        eSymbolSessionType symbolSessionType)
{
   CString symbolSessionTypeStr;

   switch (symbolSessionType)
   {
   case sstAll:
      symbolSessionTypeStr = _T("All");
      break;
   case sstCustom:
      symbolSessionTypeStr = _T("Custom");
      break;
   case sstDefault:
      symbolSessionTypeStr = _T("Default");
      break;
   default:
      assert(!"Unknown symbol session type");
   }

   return symbolSessionTypeStr;
}
