using System;
using System.Windows.Forms;
using CQG;

namespace CustomSessions
{
   public class frmCustomSessions : System.Windows.Forms.Form
   {

      [STAThread]
      static void Main()
      {
         Application.Run(new frmCustomSessions());
      }

      // The CQGCEL object, which encapsulates the main functionality of CQG API
      [field: System.CLSCompliant(false)]
      public CQGCEL CEL;

      // Current custom sessions collection
      private CQGSessionsCollection m_SessionsCollection;

      // Specifies the not available string
      private const string N_A = "N/A";

      #region " Windows Form Designer generated code "

      public frmCustomSessions()
      {

         //This call is required by the Windows Form Designer.
         InitializeComponent();

         //Add any initialization after the InitializeComponent() call

      }

      //Form overrides dispose to clean up the component list.
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (!(components == null))
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      //Required by the Windows Form Designer
      private System.ComponentModel.Container components = null;

      //NOTE: The following procedure is required by the Windows Form Designer
      //It can be modified using the Windows Form Designer.
      //Do not modify it using the code editor.
      internal System.Windows.Forms.Label lblDataConnection;
      internal System.Windows.Forms.PictureBox PictureBox1;
      internal System.Windows.Forms.LinkLabel llWeb;
      internal System.Windows.Forms.GroupBox GroupBox3;
      internal System.Windows.Forms.Button btnQueryCustomSessions;
      internal System.Windows.Forms.Label Label1;
      internal System.Windows.Forms.Label Label3;
      internal System.Windows.Forms.Label Label7;
      internal System.Windows.Forms.Label Label10;
      internal System.Windows.Forms.Label lblStart;
      internal System.Windows.Forms.Label lblType;
      internal System.Windows.Forms.Label lblWorkingDays;
      internal System.Windows.Forms.ComboBox cmbSessionsCollection;
      internal System.Windows.Forms.Label Label12;
      internal System.Windows.Forms.Label lblActivationDate;
      internal System.Windows.Forms.Label Label8;
      internal System.Windows.Forms.Label lblPrimaryFlag;
      internal System.Windows.Forms.Label Label6;
      internal System.Windows.Forms.Label lblNumber;
      internal System.Windows.Forms.Label Label4;
      internal System.Windows.Forms.ComboBox cmbName;
      internal System.Windows.Forms.GroupBox GroupBox1;
      internal System.Windows.Forms.Label lblEnd;
      internal System.Windows.Forms.Label Label5;
      [System.Diagnostics.DebuggerStepThrough()]
      private void InitializeComponent()
      {
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.PictureBox1 = new System.Windows.Forms.PictureBox();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.btnQueryCustomSessions = new System.Windows.Forms.Button();
         this.GroupBox3 = new System.Windows.Forms.GroupBox();
         this.lblEnd = new System.Windows.Forms.Label();
         this.Label5 = new System.Windows.Forms.Label();
         this.lblStart = new System.Windows.Forms.Label();
         this.Label3 = new System.Windows.Forms.Label();
         this.Label1 = new System.Windows.Forms.Label();
         this.lblType = new System.Windows.Forms.Label();
         this.Label7 = new System.Windows.Forms.Label();
         this.lblWorkingDays = new System.Windows.Forms.Label();
         this.Label10 = new System.Windows.Forms.Label();
         this.cmbSessionsCollection = new System.Windows.Forms.ComboBox();
         this.Label12 = new System.Windows.Forms.Label();
         this.lblActivationDate = new System.Windows.Forms.Label();
         this.Label8 = new System.Windows.Forms.Label();
         this.lblPrimaryFlag = new System.Windows.Forms.Label();
         this.Label6 = new System.Windows.Forms.Label();
         this.lblNumber = new System.Windows.Forms.Label();
         this.Label4 = new System.Windows.Forms.Label();
         this.cmbName = new System.Windows.Forms.ComboBox();
         this.GroupBox1 = new System.Windows.Forms.GroupBox();
         this.GroupBox3.SuspendLayout();
         this.GroupBox1.SuspendLayout();
         this.SuspendLayout();
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
         this.lblDataConnection.TabIndex = 0;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // PictureBox1
         // 
         this.PictureBox1.BackColor = System.Drawing.Color.Black;
         this.PictureBox1.Location = new System.Drawing.Point(0, 40);
         this.PictureBox1.Name = "PictureBox1";
         this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
         this.PictureBox1.TabIndex = 23;
         this.PictureBox1.TabStop = false;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.SystemColors.Control;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
         this.llWeb.Location = new System.Drawing.Point(280, 8);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(408, 16);
         this.llWeb.TabIndex = 1;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
         // 
         // btnQueryCustomSessions
         // 
         this.btnQueryCustomSessions.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.btnQueryCustomSessions.Location = new System.Drawing.Point(8, 56);
         this.btnQueryCustomSessions.Name = "btnQueryCustomSessions";
         this.btnQueryCustomSessions.Size = new System.Drawing.Size(200, 32);
         this.btnQueryCustomSessions.TabIndex = 2;
         this.btnQueryCustomSessions.Text = "Query Custom Sessions >>";
         this.btnQueryCustomSessions.Click += new System.EventHandler(this.btnQueryCustomSessions_Click);
         // 
         // GroupBox3
         // 
         this.GroupBox3.Controls.Add(this.lblEnd);
         this.GroupBox3.Controls.Add(this.Label5);
         this.GroupBox3.Controls.Add(this.lblStart);
         this.GroupBox3.Controls.Add(this.Label3);
         this.GroupBox3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox3.Location = new System.Drawing.Point(8, 152);
         this.GroupBox3.Name = "GroupBox3";
         this.GroupBox3.Size = new System.Drawing.Size(488, 96);
         this.GroupBox3.TabIndex = 8;
         this.GroupBox3.TabStop = false;
         this.GroupBox3.Text = "Session Time Range";
         // 
         // lblEnd
         // 
         this.lblEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblEnd.Location = new System.Drawing.Point(128, 56);
         this.lblEnd.Name = "lblEnd";
         this.lblEnd.Size = new System.Drawing.Size(352, 24);
         this.lblEnd.TabIndex = 3;
         this.lblEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label5
         // 
         this.Label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label5.Location = new System.Drawing.Point(16, 56);
         this.Label5.Name = "Label5";
         this.Label5.Size = new System.Drawing.Size(104, 24);
         this.Label5.TabIndex = 2;
         this.Label5.Text = "End :";
         this.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblStart
         // 
         this.lblStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblStart.Location = new System.Drawing.Point(128, 24);
         this.lblStart.Name = "lblStart";
         this.lblStart.Size = new System.Drawing.Size(352, 24);
         this.lblStart.TabIndex = 1;
         this.lblStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label3
         // 
         this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label3.Location = new System.Drawing.Point(16, 24);
         this.Label3.Name = "Label3";
         this.Label3.Size = new System.Drawing.Size(104, 24);
         this.Label3.TabIndex = 0;
         this.Label3.Text = "Start :";
         this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // Label1
         // 
         this.Label1.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label1.Location = new System.Drawing.Point(232, 64);
         this.Label1.Name = "Label1";
         this.Label1.Size = new System.Drawing.Size(144, 24);
         this.Label1.TabIndex = 3;
         this.Label1.Text = "Sessions Collection :";
         this.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblType
         // 
         this.lblType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblType.Location = new System.Drawing.Point(384, 96);
         this.lblType.Name = "lblType";
         this.lblType.Size = new System.Drawing.Size(328, 24);
         this.lblType.TabIndex = 6;
         this.lblType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label7
         // 
         this.Label7.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label7.Location = new System.Drawing.Point(320, 96);
         this.Label7.Name = "Label7";
         this.Label7.Size = new System.Drawing.Size(56, 24);
         this.Label7.TabIndex = 5;
         this.Label7.Text = "Type :";
         this.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblWorkingDays
         // 
         this.lblWorkingDays.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblWorkingDays.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblWorkingDays.Location = new System.Drawing.Point(136, 256);
         this.lblWorkingDays.Name = "lblWorkingDays";
         this.lblWorkingDays.Size = new System.Drawing.Size(360, 24);
         this.lblWorkingDays.TabIndex = 10;
         this.lblWorkingDays.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label10
         // 
         this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label10.Location = new System.Drawing.Point(8, 256);
         this.Label10.Name = "Label10";
         this.Label10.Size = new System.Drawing.Size(120, 24);
         this.Label10.TabIndex = 9;
         this.Label10.Text = "Working Days :";
         this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // cmbSessionsCollection
         // 
         this.cmbSessionsCollection.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbSessionsCollection.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.cmbSessionsCollection.Location = new System.Drawing.Point(384, 64);
         this.cmbSessionsCollection.Name = "cmbSessionsCollection";
         this.cmbSessionsCollection.Size = new System.Drawing.Size(328, 25);
         this.cmbSessionsCollection.TabIndex = 4;
         this.cmbSessionsCollection.SelectedIndexChanged += new System.EventHandler(this.cmbSessionsCollection_SelectedIndexChanged);
         // 
         // Label12
         // 
         this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label12.Location = new System.Drawing.Point(32, 88);
         this.Label12.Name = "Label12";
         this.Label12.Size = new System.Drawing.Size(96, 24);
         this.Label12.TabIndex = 4;
         this.Label12.Text = "Primary Flag :";
         this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblActivationDate
         // 
         this.lblActivationDate.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblActivationDate.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblActivationDate.Location = new System.Drawing.Point(136, 120);
         this.lblActivationDate.Name = "lblActivationDate";
         this.lblActivationDate.Size = new System.Drawing.Size(360, 24);
         this.lblActivationDate.TabIndex = 7;
         this.lblActivationDate.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label8
         // 
         this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label8.Location = new System.Drawing.Point(16, 120);
         this.Label8.Name = "Label8";
         this.Label8.Size = new System.Drawing.Size(112, 24);
         this.Label8.TabIndex = 6;
         this.Label8.Text = "Activation Date :";
         this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblPrimaryFlag
         // 
         this.lblPrimaryFlag.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblPrimaryFlag.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblPrimaryFlag.Location = new System.Drawing.Point(136, 88);
         this.lblPrimaryFlag.Name = "lblPrimaryFlag";
         this.lblPrimaryFlag.Size = new System.Drawing.Size(360, 24);
         this.lblPrimaryFlag.TabIndex = 5;
         this.lblPrimaryFlag.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label6
         // 
         this.Label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label6.Location = new System.Drawing.Point(72, 24);
         this.Label6.Name = "Label6";
         this.Label6.Size = new System.Drawing.Size(56, 24);
         this.Label6.TabIndex = 0;
         this.Label6.Text = "Name :";
         this.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblNumber
         // 
         this.lblNumber.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblNumber.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblNumber.Location = new System.Drawing.Point(136, 56);
         this.lblNumber.Name = "lblNumber";
         this.lblNumber.Size = new System.Drawing.Size(360, 24);
         this.lblNumber.TabIndex = 3;
         this.lblNumber.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label4
         // 
         this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label4.Location = new System.Drawing.Point(48, 56);
         this.Label4.Name = "Label4";
         this.Label4.Size = new System.Drawing.Size(80, 24);
         this.Label4.TabIndex = 2;
         this.Label4.Text = "Number :";
         this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // cmbName
         // 
         this.cmbName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbName.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.cmbName.ItemHeight = 17;
         this.cmbName.Location = new System.Drawing.Point(136, 24);
         this.cmbName.Name = "cmbName";
         this.cmbName.Size = new System.Drawing.Size(360, 25);
         this.cmbName.TabIndex = 0;
         this.cmbName.SelectedIndexChanged += new System.EventHandler(this.cmbName_SelectedIndexChanged);
         // 
         // GroupBox1
         // 
         this.GroupBox1.Controls.Add(this.Label12);
         this.GroupBox1.Controls.Add(this.lblActivationDate);
         this.GroupBox1.Controls.Add(this.Label8);
         this.GroupBox1.Controls.Add(this.lblPrimaryFlag);
         this.GroupBox1.Controls.Add(this.Label6);
         this.GroupBox1.Controls.Add(this.lblNumber);
         this.GroupBox1.Controls.Add(this.Label4);
         this.GroupBox1.Controls.Add(this.cmbName);
         this.GroupBox1.Controls.Add(this.Label10);
         this.GroupBox1.Controls.Add(this.lblWorkingDays);
         this.GroupBox1.Controls.Add(this.GroupBox3);
         this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox1.Location = new System.Drawing.Point(224, 128);
         this.GroupBox1.Name = "GroupBox1";
         this.GroupBox1.Size = new System.Drawing.Size(504, 288);
         this.GroupBox1.TabIndex = 7;
         this.GroupBox1.TabStop = false;
         this.GroupBox1.Text = "Data Sources";
         // 
         // frmCustomSessions
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
         this.ClientSize = new System.Drawing.Size(734, 428);
         this.Controls.Add(this.GroupBox1);
         this.Controls.Add(this.lblDataConnection);
         this.Controls.Add(this.PictureBox1);
         this.Controls.Add(this.llWeb);
         this.Controls.Add(this.btnQueryCustomSessions);
         this.Controls.Add(this.Label1);
         this.Controls.Add(this.lblType);
         this.Controls.Add(this.Label7);
         this.Controls.Add(this.cmbSessionsCollection);
         this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
         this.MaximizeBox = false;
         this.Name = "frmCustomSessions";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "CustomSessions";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmCustomSessions_Closing);
         this.Load += new System.EventHandler(this.frmCustomSessions_Load);
         this.GroupBox3.ResumeLayout(false);
         this.GroupBox1.ResumeLayout(false);
         this.ResumeLayout(false);

      }

      #endregion

      /// <summary>
      /// Creates a CEL object, changes its configurations,
      /// and starts up the created CEL object.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void frmCustomSessions_Load(Object sender,
                                 EventArgs e)
      {
         try
         {
            // Creates the CQGCEL object
            CEL = new CQGCEL();
            CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
            CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
            CEL.CustomSessionsResolved += new CQG._ICQGCELEvents_CustomSessionsResolvedEventHandler(CEL_CustomSessionsResolved);
            CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
            CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
            CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
            CEL.APIConfiguration.CollectionsThrowException = false;
            CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;
            // Disables the controls
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
            // Starts up the CQGCEL
            CEL.Startup();

            // Clearing all sessions
            ClearSessions();

            m_SessionsCollection = null;

            // Changing buttons enablements
            EnableControls();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "frmCustomSessions_Load", ex);
            this.Close();
         }
      }

      /// <summary>
      /// Shuts down CEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A CancelEventArgs that contains the event data.
      /// </param>
      private void frmCustomSessions_Closing(object sender,
                                    System.ComponentModel.CancelEventArgs e)
      {
         if (CEL != null)
         {
            CEL.Shutdown();
         }
      }

      /// <summary>
      /// This event is fired, when CQGCEL detects some abnormal
      /// discrepancy between data expected and data received.
      /// </summary>
      /// <param name="cqg_error">
      /// The object, in which the error has occurred.
      /// </param>
      /// <param name="error_description">
      /// The string, describing the error.
      /// </param>
      private void CEL_DataError(object cqg_error,
                           string error_description)
      {
         try
         {
            CQGError cqgErr = cqg_error as CQGError;
            if (CEL.IsValid(cqgErr))
            {
               if (cqgErr.Code == 102)
               {
                  error_description += " Restart the application.";
               }
               else if (cqgErr.Code == 125)
               {
                  error_description += " Turn on CQG Client and restart the application.";
               }
            }

            MessageBox.Show(error_description, "CustomSessions", MessageBoxButtons.OK, MessageBoxIcon.Information);
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "CEL_DataError", ex);
         }
      }

      /// <summary>
      /// This event is fired, when some changes occur in the connection with CQG data server.
      /// Depending from connection status changes enablements of buttons.
      /// </summary>
      /// <param name="newStatus">
      /// The current status of the connection with the data server.
      /// </param>
      private void CEL_DataConnectionStatusChanged(eConnectionStatus new_status)
      {
         try
         {
            string sInfo;
            System.Drawing.Color BackCol;

            if (new_status == eConnectionStatus.csConnectionUp)
            {
               BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
               sInfo = "DATA Connection is UP";
            }
            else if (new_status == eConnectionStatus.csConnectionDelayed)
            {
               BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
               sInfo = "DATA Connection is Delayed";
            }
            else
            {
               BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
               sInfo = "DATA Connection is Down";
            }

            lblDataConnection.BackColor = BackCol;
            lblDataConnection.Text = sInfo;

            EnableControls();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "CEL_DataConnectionStatusChanged", ex);
         }
      }

      /// <summary>
      /// This event is fired as a response to a custom
      /// sessions request either when the collection is
      /// resolved or when an error has occurred during
      /// the request processing.
      /// </summary>
      /// <param name="cqg_sessions_collection">
      /// Collection of resolved custom sessions.
      /// </param>
      /// <param name="cqg_error">
      /// CQGError object representing the error occurred
      /// during the custom sessions request.
      /// </param>
      private void CEL_CustomSessionsResolved(CQGSessionsCollection cqg_sessions_collection,
                                    CQGError cqg_error)
      {
         try
         {
            // Clearing sessions
            ClearSessions();

            // Notifying when any error occurred during request
            if (CEL.IsValid(cqg_error))
            {
               MessageBox.Show(cqg_error.Description, "CustomSessions", MessageBoxButtons.OK, MessageBoxIcon.Information);
               return;
            }

            m_SessionsCollection = cqg_sessions_collection;

            if (m_SessionsCollection.Count == 0)
            {
               return;
            }

            // Adding sessions to the combo box
            for (int i = 0; i <= m_SessionsCollection.Count - 1; i++)
            {
               cmbSessionsCollection.Items.Add(m_SessionsCollection[i].Name);
            }

            cmbSessionsCollection.SelectedIndex = 0;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "CEL_CustomSessionsResolved", ex);
         }
      }

      /// <summary>
      /// Open CQG API web page.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A LinkLabelLinkClickedEventArgs that contains the event data.
      /// </param>
      private void llWeb_LinkClicked(System.Object sender,
         LinkLabelLinkClickedEventArgs e)
      {
         try
         {
            System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "llWeb_LinkClicked", ex);
         }
      }

      /// <summary>
      /// Clears sessions and requests new sessions.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnQueryCustomSessions_Click(Object sender,
                                      EventArgs e)
      {
         try
         {
            // Clearing current sessions
            ClearSessions();

            // Requesting new sessions
            CEL.RequestCustomSessions();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "btnQueryCustomSessions_Click", ex);
         }
      }

      /// <summary>
      /// Sets current custom sessions to chosen and dumps all necessary information.
      /// </summary>
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data
      /// </param>
      private void cmbSessionsCollection_SelectedIndexChanged(Object sender,
                                                EventArgs e)
      {
         try
         {
            ClearSession();

            if (cmbSessionsCollection.SelectedIndex == -1)
            {
               return;
            }

            CQGSessions sessions = m_SessionsCollection[cmbSessionsCollection.SelectedIndex];

            lblType.Text = sessions.Type.ToString();

            if (sessions.Count == 0)
            {
               return;
            }

            for (int i = 0; i <= sessions.Count - 1; i++)
            {
               cmbName.Items.Add(sessions[i].Name);
            }

            cmbName.SelectedIndex = 0;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "cmbSessionsCollection_SelectedIndexChanged", ex);
         }
      }

      /// <summary>
      /// Dumps all necessary information for chosen custom session.
      /// </summary>
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data
      /// </param>
      private void cmbName_SelectedIndexChanged(Object sender,
                                      EventArgs e)
      {
         try
         {
            ClearSessionData();

            if (cmbName.SelectedIndex == -1)
            {
               return;
            }

            CQGSessions sessions = m_SessionsCollection[cmbSessionsCollection.SelectedIndex];
            CQGSession session = sessions[cmbName.SelectedIndex];

            lblNumber.Text = session.Number.ToString();
            lblPrimaryFlag.Text = session.PrimaryFlag.ToString();
            lblActivationDate.Text = GetValueAsString(session.ActivationDate, true);
            lblStart.Text = GetValueAsString(session.StartTime, false);
            lblEnd.Text = GetValueAsString(session.EndTime, false);
            lblWorkingDays.Text = GetSessionWorkingDays(session.WorkingWeekDays);
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "cmbName_SelectedIndexChanged", ex);
         }
      }

      /// <summary>
      /// Clears all custom sessions.
      /// </summary>
      private void ClearSessions()
      {
         try
         {
            m_SessionsCollection = null;

            cmbSessionsCollection.Items.Clear();

            lblType.Text = "";

            ClearSession();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "ClearSessions", ex);
         }
      }

      /// <summary>
      /// Clears custom session.
      /// </summary>
      private void ClearSession()
      {
         try
         {
            cmbName.Items.Clear();

            ClearSessionData();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "ClearSession", ex);
         }
      }

      /// <summary>
      /// Clears data connected with session.
      /// </summary>
      private void ClearSessionData()
      {
         try
         {
            lblNumber.Text = "";
            lblActivationDate.Text = "";
            lblPrimaryFlag.Text = "";
            lblStart.Text = "";
            lblEnd.Text = "";
            lblWorkingDays.Text = "";
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "ClearSessionData", ex);
         }
      }

      /// <summary>
      /// Changes controls enablements.
      /// </summary>
      private void EnableControls()
      {
         try
         {
            bool isDataConnectionUp = false;

            if (CEL.IsStarted)
            {
               isDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
            }

            btnQueryCustomSessions.Enabled = isDataConnectionUp;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmCustomSessions", "EnableControls", ex);
         }
      }

      /// <summary>
      /// Returns string, which contains custom session's working days information.
      /// </summary>
      /// <param name="weekDay">
      /// Custom session working days
      /// </param>
      /// <returns>
      /// String in "SMTWTFS" format.
      /// </returns>
      private string GetSessionWorkingDays(eSessionWeekDays weekDay)
      {

         string sWorkingDays = "";

         if ((weekDay & eSessionWeekDays.swdSunday) == eSessionWeekDays.swdSunday)
         {
            sWorkingDays += "S";
         }
         else
         {
            sWorkingDays += "-";
         }
         if ((weekDay & eSessionWeekDays.swdMonday) == eSessionWeekDays.swdMonday)
         {
            sWorkingDays += "M";
         }
         else
         {
            sWorkingDays += "-";
         }
         if ((weekDay & eSessionWeekDays.swdTuesday) == eSessionWeekDays.swdTuesday)
         {
            sWorkingDays += "T";
         }
         else
         {
            sWorkingDays += "-";
         }
         if ((weekDay & eSessionWeekDays.swdWednesday) == eSessionWeekDays.swdWednesday)
         {
            sWorkingDays += "W";
         }
         else
         {
            sWorkingDays += "-";
         }
         if ((weekDay & eSessionWeekDays.swdThursday) == eSessionWeekDays.swdThursday)
         {
            sWorkingDays += "T";
         }
         else
         {
            sWorkingDays += "-";
         }
         if ((weekDay & eSessionWeekDays.swdFriday) == eSessionWeekDays.swdFriday)
         {
            sWorkingDays += "F";
         }
         else
         {
            sWorkingDays += "-";
         }
         if ((weekDay & eSessionWeekDays.swdSaturday) == eSessionWeekDays.swdSaturday)
         {
            sWorkingDays += "S";
         }
         else
         {
            sWorkingDays += "-";
         }

         return sWorkingDays;
      }

      /// <summary>
      /// Validates the specified value and converts it to string.
      /// </summary>
      /// <param name="val">
      /// The value that will be validated and converted
      /// </param>
      /// <param name="withDate">
      /// The string presentation of the date value
      /// </param>
      /// <returns>
      /// Value converted to string or "N/A" if the value is invalid.
      /// </returns>
      private string GetValueAsString(object val,
                        bool withDate)
      {
         string sResult = string.Empty;

         try
         {
            if (val.GetType().FullName == "System.DateTime")
            {
               if (withDate)
               {
                  sResult = System.Convert.ToDateTime(val).ToString("dd/MM/yyyy HH:mm");
               }
               else
               {
                  sResult = System.Convert.ToDateTime(val).ToString("HH:mm");
               }
            }
            else
            {
               sResult = val.ToString();
            }
         }
         catch
         {
            sResult = N_A;
         }

         return sResult;
      }

   }

}
