// CustomStudyDlg.cpp : implementation file
//

#include "stdafx.h"
#include <cassert>
#include "Common.h"
#include "Helper.h"
#include "CustomStudy.h"
#include "CustomStudyDlg.h"
#include "CustomStudyReqDlg.h"

const long CCustomStudyDlg::SHOW_COUNT = 5;
const long CCustomStudyDlg::MAX_INTERVAL = 500;

CCustomStudyDlg::CCustomStudyDlg(CWnd* pParent /*=NULL*/)
                           : CDialog(CCustomStudyDlg::IDD, pParent),
                           m_FilterType(ftByIndices)
{
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCustomStudyDlg::DoDataExchange(
                           CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_LBL_DATA_CONNECTION, m_lblDataConnection);



   DDX_Control(pDX, IDC_BTN_REQUEST_DEFINITION, m_btnRequestDefinition);
   DDX_Control(pDX, IDC_CMB_DEFINITION, m_cmbDefinition);
   DDX_Control(pDX, IDC_LSV_DEF_PARAMETERS, m_lvDefParameters);
   DDX_Control(pDX, IDC_LSV_DEF_CURVES, m_lvDefCurves);
   DDX_Control(pDX, IDC_LBL_DEF_ABBREVIATION, m_lblDefAbbreviation);

   DDX_Control(pDX, IDC_CMB_CUSTOM_STUDY, m_cmbCustomStudy);

   DDX_Control(pDX, IDC_ED_DEFINITION_NAME, m_edDefinitionName);

   DDX_Control(pDX, IDC_BTN_REQUEST, m_btnRequest);
   DDX_Control(pDX, IDC_BTN_REMOVE, m_btnRemove);
   DDX_Control(pDX, IDC_BTN_REMOVE_ALL, m_btnRemoveAll);

   DDX_Control(pDX, IDC_LBL_STATUS, m_lblStatus);

   DDX_Text(pDX, IDC_LBL_DEFINITION_NAME, m_DefinitionName);
   DDX_Control(pDX, IDC_LSV_PARAMETERS, m_lvParameters);
   DDX_Text(pDX, IDC_LBL_BASE_EXPRESSION, m_BaseExpression);
   DDX_Text(pDX, IDC_LBL_RANGE_START, m_RangeStart);
   DDX_Text(pDX, IDC_LBL_RANGE_END, m_RangeEnd);
   DDX_Text(pDX, IDC_LBL_INTRADAY_PERIOD, m_IntradayPeriod);
   DDX_Text(pDX, IDC_LBL_HISTORICAL_PERIOD, m_HistoricalPeriod);
   DDX_Text(pDX, IDC_LBL_UPDATES_ENABLED, m_UpdatesEnabled);
   DDX_Text(pDX, IDC_LBL_INCLUDE_END, m_IncludeEnd);
   DDX_Text(pDX, IDC_LBL_SESSIONS_FILTER, m_SessionsFilter);
   DDX_Text(pDX, IDC_LBL_CONTINUATION, m_Continuation);
   DDX_Text(pDX, IDC_LBL_EQUALIZE_CLOSES, m_EqualizeCloses);
   DDX_Text(pDX, IDC_LBL_DAYS_BEFORE_EXPIRATION, m_DaysBeforeExpiration);
   DDX_Text(pDX, IDC_LBL_SESSION_FLAGS, m_SessionFlags);
   DDX_Text(pDX, IDC_LBL_SUBSCRIPTION_LEVEL, m_SubscriptionLevel);
   DDX_Text(pDX, IDC_LBL_RECALC_PERIOD, m_RecalcPeriod);

   DDX_Text(pDX, IDC_LBL_OUTPUT_START, m_OutputStart);
   DDX_Text(pDX, IDC_LBL_OUTPUT_END, m_OutputEnd);

   DDX_Control(pDX, IDC_LBL_ERROR, m_lblError);

   DDX_Control(pDX, IDC_LSV_LAST_CUSTOM_STUDY, m_lvLastCustomStudy);
   DDX_Control(pDX, IDC_LSV_CUSTOM_STUDY, m_lvCustomStudy);

   DDX_Control(pDX, IDC_ED_TAG_NAME, m_edTagName);
   DDX_Control(pDX, IDC_ED_TAG_VALUE, m_edTagValue);

   DDX_Control(pDX, IDC_RD_INDICES, m_rdIndices);
   DDX_Control(pDX, IDC_RD_DATES, m_rdDates);
   DDX_Radio(pDX, IDC_RD_INDICES, m_FilterType);

   DDX_Control(pDX, IDC_DTP_FILTER_START_DATE, m_dtpStart);
   DDX_Control(pDX, IDC_ED_FILTER_START_INDEX, m_edStart);
   DDX_Control(pDX, IDC_SPN_FILTER_START_INDEX, m_spnStart);
   DDX_Control(pDX, IDC_DTP_FILTER_END_DATE, m_dtpEnd);
   DDX_Control(pDX, IDC_ED_FILTER_END_INDEX, m_edEnd);
   DDX_Control(pDX, IDC_SPN_FILTER_END_INDEX, m_spnEnd);

   DDX_Control(pDX, IDC_BTN_SHOW, m_btnShow);

   DDX_Control(pDX, IDC_LBL_RECS_COUNT, m_lblFltrRecsCount);
   DDX_Control(pDX, IDC_LBL_ALL_RECS_COUNT, m_lblAllRecsCount);
}

BEGIN_MESSAGE_MAP(CCustomStudyDlg, CDialog)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_DESTROY()
   ON_BN_CLICKED(IDC_BTN_REMOVE, OnBnClickedBtnRemove)
   ON_BN_CLICKED(IDC_BTN_REMOVE_ALL, OnBnClickedBtnRemoveAll)
   ON_BN_CLICKED(IDC_BTN_REQUEST, OnBnClickedBtnRequest)
   ON_BN_CLICKED(IDC_BTN_SHOW, OnBnClickedBtnShow)
   ON_BN_CLICKED(IDC_RD_INDICES, OnBnClickedRdIndices)
   ON_BN_CLICKED(IDC_RD_DATES, OnBnClickedRdDate)
   ON_CBN_SELCHANGE(IDC_CMB_CUSTOM_STUDY, OnCbnSelChangeCmbCustomStudy)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_START_INDEX, OnDeltaposSpnStart)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_END_INDEX, OnDeltaposSpnEnd)
   ON_BN_CLICKED(IDC_BTN_REQUEST_DEFINITION, OnBnClickedBtnRequestDefinition)
   ON_CBN_SELCHANGE(IDC_CMB_DEFINITION, OnCbnSelchangeCmbDefinition)
   ON_STN_DBLCLK(IDC_LBL_ERROR, OnStnDblclickLblError)
END_MESSAGE_MAP()

BOOL CCustomStudyDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon

   try
   {
      InitializeControls();
      InitializeCQGCEL();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCustomStudyDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

HCURSOR CCustomStudyDlg::OnQueryDragIcon()
{
   return static_cast<HCURSOR>(m_hIcon);
}

void CCustomStudyDlg::OnOK()
{
   // If enter clicked when one of the tag edit boxes is active
   // then call corresponding function
   CWnd* pWnd = GetFocus();

   if (pWnd == &m_edTagName)
   {
      OnEnterEdTagName();
   }
   else if (pWnd == &m_edTagValue)
   {
      OnEnterEdTagValue();
   }
}

void CCustomStudyDlg::OnDestroy()
{
   try
   {
      if (m_spCQGCEL)
      {
         HRESULT hr = ICQGCELDispEventImpl::DispEventUnadvise(m_spCQGCEL);
         assert(SUCCEEDED(hr));

         hr = m_spCQGCEL->Shutdown();
         Common::ThrowOnCOMError(m_spCQGCEL, hr);
      }
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   CDialog::OnDestroy();
}

void CCustomStudyDlg::OnBnClickedBtnRemove()
{
   try
   {
      // Remove selected custom study from the collection
      HRESULT hr = m_spCQGCEL->RemoveCustomStudy(m_spCustomStudy);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      // Remove item from combo box
      const int row = m_cmbCustomStudy.GetCurSel();
      const int count = m_cmbCustomStudy.DeleteString(row);

      if (count == 0)
      {
         ClearAllData();
         m_spCustomStudy = NULL;

         // Clear combo box
         m_cmbCustomStudy.ResetContent();
      }
      else
      {
         m_cmbCustomStudy.SetCurSel((row >= count ? (count - 1) : row));
         OnCbnSelChangeCmbCustomStudy();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnBnClickedBtnRemoveAll()
{
   try
   {
      // Clear combo box
      m_cmbCustomStudy.ResetContent();

      // Remove all custom studies from CQGCEL
      HRESULT hr = m_spCQGCEL->RemoveAllCustomStudies();
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      m_spCustomStudy = NULL;

      ClearAllData();

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnCbnSelChangeCmbCustomStudy()
{
   try
   {
      ClearAllData();

      if (m_cmbCustomStudy.GetCount() > 0)
      {
         // Get GUID from combo box
         CString id;
         m_cmbCustomStudy.GetWindowText(id);

         // Get item from CQGCEL by GUID
         ATL::CComPtr<ICQGCustomStudies> spCustomStudies;
         HRESULT hr = m_spCQGCEL->get_AllCustomStudies(&spCustomStudies);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         m_spCustomStudy.Release();
         hr = spCustomStudies->get_ItemById(ATL::CT2W(id), &m_spCustomStudy);
         Common::ThrowOnCOMError(spCustomStudies, hr);

         // Show corresponding items all data
         ShowAllData();

         // Initialize parameters for filtering
         UpdateData();
         m_FilterType = ftByIndices;
         UpdateData(FALSE);
         FilterTypeChanged();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnBnClickedBtnRequestDefinition()
{
   try
   {
      HRESULT hr = m_spCQGCEL->RequestCustomStudyDefinitions();
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      ClearAllDefinitionsData();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnCbnSelchangeCmbDefinition()
{
   try
   {
      const long idx = static_cast<long>(m_cmbDefinition.GetItemData(m_cmbDefinition.GetCurSel()));

      // Get selected custom study definition
      ATL::CComPtr<ICQGCustomStudyDefinition> spCustomStudyDefinition;
      HRESULT hr = m_spCustomStudyDefinitions->get_Item(idx, &spCustomStudyDefinition);
      Common::ThrowOnCOMError(m_spCustomStudyDefinitions, hr);

      // Set definition name in the edit box
      ATL::CComBSTR name;
      hr = spCustomStudyDefinition->get_Name(&name);
      Common::ThrowOnCOMError(spCustomStudyDefinition, hr);

      m_edDefinitionName.SetWindowText(ATL::CW2T(name));

      // Clear definition fields
      ClearDefinitionData();

      // Fill up curves
      ATL::CComPtr<ICQGCurveDefinitions> spCurveDefinitions;
      hr = spCustomStudyDefinition->get_CurveDefinitions(&spCurveDefinitions);
      Common::ThrowOnCOMError(spCustomStudyDefinition, hr);

      long count;
      hr = spCurveDefinitions->get_Count(&count);
      Common::ThrowOnCOMError(spCurveDefinitions, hr);

      for (long i = 0; i < count; ++i)
      {
         ATL::CComPtr<ICQGCurveDefinition> spCurveDefinition;
         hr = spCurveDefinitions->get_Item(i, &spCurveDefinition);
         Common::ThrowOnCOMError(spCurveDefinitions, hr);

         ATL::CComBSTR name;
         hr = spCurveDefinition->get_Name(&name);
         Common::ThrowOnCOMError(spCurveDefinition, hr);

         const int row = m_lvDefCurves.InsertItem(m_lvDefCurves.GetItemCount(), _T(""));
         m_lvDefCurves.SetItemText(row, 0, ATL::CW2T(name));
      }

      // Show abbreviation
      ATL::CComBSTR abbreviation;
      hr = spCustomStudyDefinition->get_Abbreviation(&abbreviation);
      Common::ThrowOnCOMError(spCustomStudyDefinition, hr);

      m_lblDefAbbreviation.SetWindowText(ATL::CW2T(abbreviation));

      // Fill up parameters
      ATL::CComPtr<ICQGParameterDefinitions> spParameterDefinitions;
      hr = spCustomStudyDefinition->get_ParameterDefinitions(&spParameterDefinitions);
      Common::ThrowOnCOMError(spCustomStudyDefinition, hr);

      hr = spParameterDefinitions->get_Count(&count);
      Common::ThrowOnCOMError(spParameterDefinitions, hr);

      for (long i = 0; i < count; ++i)
      {
         ATL::CComPtr<ICQGParameterDefinition> spParameterDefinition;
         hr = spParameterDefinitions->get_Item(i, &spParameterDefinition);
         Common::ThrowOnCOMError(spParameterDefinitions, hr);

         ATL::CComBSTR name;
         hr = spParameterDefinition->get_Name(&name);
         Common::ThrowOnCOMError(spCustomStudyDefinition, hr);

         ATL::CComBSTR comment;
         hr = spParameterDefinition->get_Comment(&comment);
         Common::ThrowOnCOMError(spParameterDefinition, hr);

         eUserFormulaParameterType parameterType;
         hr = spParameterDefinition->get_Type(&parameterType);
         Common::ThrowOnCOMError(spParameterDefinition, hr);

         ATL::CComVariant defaultValue;
         hr = spParameterDefinition->get_DefaultValue(&defaultValue);
         Common::ThrowOnCOMError(spParameterDefinition, hr);

         const int row = m_lvDefParameters.InsertItem(m_lvDefParameters.GetItemCount(), _T(""));
         m_lvDefParameters.SetItemText(row, dpcName, ATL::CW2T(name));
         m_lvDefParameters.SetItemText(row, dpcComment, ATL::CW2T(comment));
         m_lvDefParameters.SetItemText(row, dpcType, CHelper::ParameterTypeToString(parameterType));
         m_lvDefParameters.SetItemText(row, dpcDefaultValue, 
            Common::VariantToString(defaultValue, CHelper::PARAM_FRAC_PART_LENGTH));
      }
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnBnClickedBtnRequest()
{
   try
   {
      // Get custom study definition name
      CString customStudyName;
      m_edDefinitionName.GetWindowText(customStudyName);

      // Create empty request
      ATL::CComPtr<ICQGCustomStudyRequest> spRequest;
      HRESULT hr = m_spCQGCEL->CreateCustomStudyRequest(ATL::CT2W(customStudyName), &spRequest);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      spRequest->put_SessionsFilter(ATL::CComVariant(31));  // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

      // Get line time from CQGCEL->Environment
      ATL::CComPtr<ICQGEnvironment> spEnvironment;
      hr = m_spCQGCEL->get_Environment(&spEnvironment);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      DATE lineTime;
      hr = spEnvironment->get_LineTime(&lineTime);
      Common::ThrowOnCOMError(spEnvironment, hr);

      // Open form to fill up request data
      CCustomStudyReqDlg dlg(spRequest, lineTime);
      if (dlg.DoModal() == IDOK)
      {
         // Send request to CQGCEL
         ATL::CComPtr<ICQGCustomStudy> spCustomStudy;
         hr = m_spCQGCEL->RequestCustomStudy(spRequest, &spCustomStudy);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         // Add ID to the requests combo box
         ATL::CComBSTR customStudyID;
         hr = spCustomStudy->get_Id(&customStudyID);
         Common::ThrowOnCOMError(spCustomStudy, hr);

         const int row = m_cmbCustomStudy.AddString(ATL::CW2T(customStudyID));
         m_cmbCustomStudy.SetCurSel(row);
         OnCbnSelChangeCmbCustomStudy();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnBnClickedBtnShow()
{
   try
   {
      // Clear records and records count
      ClearRecords(m_lvCustomStudy);
      m_lblFltrRecsCount.SetWindowText(_T(""));

      long startIndex;
      long endIndex;
      bool isValid;

      UpdateData();

      if (m_FilterType == ftByIndices)
      {
         isValid = GetIndices(startIndex, endIndex);
      }
      else
      {
         isValid = GetIndicesForDates(startIndex, endIndex);
      }

      // Show filtered records and its' count when range is valid
      if (isValid)
      {
         m_lblFltrRecsCount.SetWindowText(GetValueAsString(endIndex - startIndex + 1));
         ShowRecords(startIndex, endIndex, m_lvCustomStudy);
      }
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

bool CCustomStudyDlg::GetIndices(
                           long& startIndex,
                           long& endIndex)
{
   startIndex = m_edStart.GetValue();
   endIndex = m_edEnd.GetValue();

   // Check for valid indices
   if (endIndex < startIndex)
   {
      AfxMessageBox(_T("Start index must be smaller than end index."), MB_ICONWARNING);
      return false;
   }

   if (startIndex < 1)
   {
      AfxMessageBox(_T("Start index must be greater than zero."), MB_ICONWARNING);
      return false;
   }

   long count;
   HRESULT hr = m_spCustomStudy->get_Count(&count);
   Common::ThrowOnCOMError<ICQGCustomStudy>(m_spCustomStudy, hr);

   if (endIndex > count)
   {
      AfxMessageBox(_T("End index must be smaller than records count."), MB_ICONWARNING);
      return false;
   }

   if (endIndex - startIndex >= MAX_INTERVAL)
   {
      CString msgText;
      msgText.Format(_T("Range must indicate to no more than %d records."), MAX_INTERVAL);
      AfxMessageBox(msgText, MB_ICONWARNING);
      return false;
   }

   return true;
}

bool CCustomStudyDlg::GetIndicesForDates(
                           long& startIndex,
                           long& endIndex)
{
   // Get start and end dates and remove seconds from them: to retrieve same data for same requests
   COleDateTime startTime;
   m_dtpStart.GetTime(startTime);

   COleDateTime startTimeNS(startTime.GetYear(), startTime.GetMonth(), startTime.GetDay(), 
      startTime.GetHour(), startTime.GetMinute(), 0);

   COleDateTime endTime;
   m_dtpEnd.GetTime(endTime);

   COleDateTime endTimeNS(endTime.GetYear(), endTime.GetMonth(), endTime.GetDay(), 
      endTime.GetHour(), endTime.GetMinute(), 0);

   // Check for valid date range
   if (CHelper::CompareDates(startTimeNS, endTimeNS) > 0)
   {
      AfxMessageBox(_T("Start date must be earlier than end date."), MB_ICONWARNING);
      return false;
   }

   // Get start and end indices for specified dates
   HRESULT hr = m_spCustomStudy->IndexForDate(startTimeNS.m_dt, &startIndex);
   Common::ThrowOnCOMError(m_spCustomStudy, hr);

   hr = m_spCustomStudy->IndexForDate(endTimeNS.m_dt, &endIndex);
   Common::ThrowOnCOMError(m_spCustomStudy, hr);

   // Check for valid dates
   VARIANT_BOOL isValid;
   hr = m_spCQGCEL->IsValid(ATL::CComVariant(startIndex), &isValid);
   Common::ThrowOnCOMError(m_spCQGCEL, hr);

   if (!isValid)
   {
      AfxMessageBox(_T("Start date is invalid: there isn't any record with this timestamp"), MB_ICONINFORMATION);
      return false;
   }

   hr = m_spCQGCEL->IsValid(ATL::CComVariant(endIndex), &isValid);
   Common::ThrowOnCOMError(m_spCQGCEL, hr);

   if (!isValid)
   {
      AfxMessageBox(_T("End date is invalid: there isn't any record with this timestamp"), MB_ICONINFORMATION);
      return false;
   }

   if (endIndex - startIndex >= MAX_INTERVAL)
   {
      CString msgText;
      msgText.Format(_T("Range must indicate to no more than %d records."), MAX_INTERVAL);
      AfxMessageBox(msgText, MB_ICONWARNING);
      return false;
   }

   // IndicesForDates function returns 0 based indices, so expanding them by 1
   startIndex += 1;
   endIndex += 1;

   return true;
}

void CCustomStudyDlg::OnDeltaposSpnStart(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edStart.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CCustomStudyDlg::OnDeltaposSpnEnd(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edEnd.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CCustomStudyDlg::OnBnClickedRdIndices()
{
   try
   {
      FilterTypeChanged();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnBnClickedRdDate()
{
   try
   {
      FilterTypeChanged();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnEnterEdTagName()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty()) 
      {
         return;
      }

      ATL::CComVariant tagValue;
      HRESULT hr = m_spCustomStudy->get_Tag(ATL::CT2W(tagName), &tagValue);
      Common::ThrowOnCOMError(m_spCustomStudy, hr);

      // If there is no tag with specified tag name, tag value will be VT_EMPTY
      m_edTagValue.SetWindowText((tagValue.vt != VT_EMPTY) ? GetValueAsString(tagValue) : _T(""));
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnEnterEdTagValue()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty())
      {
         return;
      }

      CString tagValue;
      m_edTagValue.GetWindowText(tagValue);

      // If there is no tag value specified, then remove tag with specified tag name
      HRESULT hr = m_spCustomStudy->put_Tag(ATL::CT2W(tagName), 
         tagValue.IsEmpty() ? ATL::CComVariant() : ATL::CComVariant(tagValue));
      Common::ThrowOnCOMError(m_spCustomStudy, hr);

      m_edTagName.SetWindowText(_T(""));
      m_edTagValue.SetWindowText(_T(""));

      m_edTagName.SetFocus();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CCustomStudyDlg::OnStnDblclickLblError()
{
   try
   {
      // If there is no custom study selected do nothing
      if (m_spCustomStudy == NULL)
      {
         return;
      }
   
      // Get request from custom study
      ATL::CComPtr<ICQGCustomStudyRequest> spRequest;
      HRESULT hr = m_spCustomStudy->get_Request(&spRequest);
      Common::ThrowOnCOMError(m_spCustomStudy, hr);

      // Get error from custom study and show it if exist
      ATL::CComPtr<ICQGError> spError;
      hr = m_spCustomStudy->get_LastError(&spError);
      Common::ThrowOnCOMError(m_spCustomStudy, hr);

      if (spError)
      {
         ATL::CComBSTR errDescription;
         hr = spError->get_Description(&errDescription);
         Common::ThrowOnCOMError(spError, hr);

         m_lblError.SetWindowText(ATL::CW2T(errDescription));

         AfxMessageBox(ATL::CW2T(errDescription), MB_ICONEXCLAMATION);
      }
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}