using System;
using System.Windows.Forms;
using CQG;

namespace CustomStudy
{
	public class frmCustomStudy : System.Windows.Forms.Form
	{

		[STAThread]
		static void Main()
		{
			Application.Run(new frmCustomStudy());
		}

		// The CQGCEL object, which encapsulates the main functionality of CQG API
		[field: System.CLSCompliant(false)]
		public CQGCEL CEL;

		// The currently selected CustomStudy object in the combo box
		private CQGCustomStudy m_CurCustomStudy;

		// Currently requested CustomStudy definitions object
		private CQGCustomStudyDefinitions m_CustomStudyDefinitions;

		// Specifies the not available string
		private const string N_A = "N/A";

		// Specifies the header of index column
		private const string INDEX_HEADER = "Index";

		// Specifies the header of timestamp column
		private const string TIMESTAMP_HEADER = "Timestamp";

		// Specifies the max records count
		private const int MAX_NUMBER_OF_RECORDS = 5;

		// Specifies the max index interval
		private const int MAX_INDEX_INTERVAL = 500;

		#region " Windows Form Designer generated code "

		public frmCustomStudy()
		{

			//This call is required by the Windows Form Designer.
			InitializeComponent();

			//Add any initialization after the InitializeComponent() call

		}

		//Form overrides dispose to clean up the component list.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(components == null))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		//Required by the Windows Form Designer
		private System.ComponentModel.Container components = null;

		//NOTE: The following procedure is required by the Windows Form Designer
		//It can be modified using the Windows Form Designer.
		//Do not modify it using the code editor.
		internal System.Windows.Forms.Label lblDataConnection;
		internal System.Windows.Forms.PictureBox PictureBox1;
		internal System.Windows.Forms.LinkLabel llWeb;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.PictureBox PictureBox2;
		internal System.Windows.Forms.PictureBox PictureBox3;
		internal System.Windows.Forms.GroupBox GroupBox2;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.Label Label18;
		internal System.Windows.Forms.GroupBox GroupBox3;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.GroupBox GroupBox4;
		internal System.Windows.Forms.ComboBox cmbCustomStudy;
		internal System.Windows.Forms.Label lblRPRangeEnd;
		internal System.Windows.Forms.Label lblRPRangeStart;
		internal System.Windows.Forms.Label lblOEnd;
		internal System.Windows.Forms.Label lblOStart;
		internal System.Windows.Forms.Label lblStatus;
		internal System.Windows.Forms.TextBox txtTagName;
		internal System.Windows.Forms.TextBox txtTagValue;
		internal System.Windows.Forms.Button btnRequest;
		internal System.Windows.Forms.Button btnRemove;
		internal System.Windows.Forms.Button btnRemoveAll;
		internal System.Windows.Forms.GroupBox GroupBox5;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.GroupBox gbIndexInterval;
		internal System.Windows.Forms.GroupBox gbTimeInterval;
		internal System.Windows.Forms.DateTimePicker dtpStartRange;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Button btnShow;
		internal System.Windows.Forms.RadioButton optTimeInterval;
		internal System.Windows.Forms.RadioButton optIndexInterval;
		internal System.Windows.Forms.NumericUpDown nudEnd;
		internal System.Windows.Forms.NumericUpDown nudStart;
		internal System.Windows.Forms.GroupBox GroupBox6;
		internal System.Windows.Forms.DateTimePicker dtpEndRange;
		internal System.Windows.Forms.Label lblError;
		internal System.Windows.Forms.ColumnHeader ColumnHeader1;
		internal System.Windows.Forms.ColumnHeader ColumnHeader2;
		internal System.Windows.Forms.ColumnHeader ColumnHeader3;
		internal System.Windows.Forms.ColumnHeader ColumnHeader4;
		internal System.Windows.Forms.ListView lvCustomStudy;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label17;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Label Label23;
		internal System.Windows.Forms.Label Label25;
		internal System.Windows.Forms.Label Label27;
		internal System.Windows.Forms.Label Label29;
		internal System.Windows.Forms.Label lblRPSessionFlags;
		internal System.Windows.Forms.Label lblRPHistoricalPeriod;
		internal System.Windows.Forms.Label lblRPIntradayPeriod;
		internal System.Windows.Forms.Label lblRPIncludeEnd;
		internal System.Windows.Forms.Label lblRPUpdatesEnabled;
		internal System.Windows.Forms.Label lblRPContinuation;
		internal System.Windows.Forms.Label lblRPSessionsFilter;
		internal System.Windows.Forms.Label lblRPDaysBeforeExpiration;
		internal System.Windows.Forms.Label lblRPEqualizeCloses;
		internal System.Windows.Forms.Label lblRPBaseExpression;
		internal System.Windows.Forms.TextBox txtCustomStudyName;
		internal System.Windows.Forms.Label lblRPCustomStudyDefinitionName;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.GroupBox GroupBox7;
		internal System.Windows.Forms.Label lblParameterDefaultValue;
		internal System.Windows.Forms.Label Label15;
		internal System.Windows.Forms.Label lblParameterType;
		internal System.Windows.Forms.Label Label22;
		internal System.Windows.Forms.Button btnReqCustomStudyDefinitions;
		internal System.Windows.Forms.ComboBox cmbDefinition;
		internal System.Windows.Forms.Label Label24;
		internal System.Windows.Forms.Label lblParameterComment;
		internal System.Windows.Forms.Label Label28;
		internal System.Windows.Forms.ComboBox cmbParameter;
		internal System.Windows.Forms.ListBox lstRPParameters;
		internal System.Windows.Forms.ListView lvShownCustomStudy;
		internal System.Windows.Forms.ColumnHeader ColumnHeader5;
		internal System.Windows.Forms.ColumnHeader ColumnHeader6;
		internal System.Windows.Forms.ColumnHeader ColumnHeader7;
		internal System.Windows.Forms.ColumnHeader ColumnHeader8;
		internal System.Windows.Forms.Label lblAbbreviation;
		internal System.Windows.Forms.Label Label19;
		internal System.Windows.Forms.ListBox lstCurve;
		internal System.Windows.Forms.Label Label26;
		internal System.Windows.Forms.Label lblRPRecalcPeriod;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.Label lblRPSubscriptionLevel;
		internal System.Windows.Forms.Label label30;
		[System.Diagnostics.DebuggerStepThrough()]
		private void InitializeComponent()
		{
			this.lblDataConnection = new System.Windows.Forms.Label();
			this.PictureBox1 = new System.Windows.Forms.PictureBox();
			this.llWeb = new System.Windows.Forms.LinkLabel();
			this.cmbCustomStudy = new System.Windows.Forms.ComboBox();
			this.btnRequest = new System.Windows.Forms.Button();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnRemoveAll = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.lblRPRecalcPeriod = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.lblRPSubscriptionLevel = new System.Windows.Forms.Label();
			this.label30 = new System.Windows.Forms.Label();
			this.lstRPParameters = new System.Windows.Forms.ListBox();
			this.Label11 = new System.Windows.Forms.Label();
			this.lblRPCustomStudyDefinitionName = new System.Windows.Forms.Label();
			this.Label6 = new System.Windows.Forms.Label();
			this.lblRPDaysBeforeExpiration = new System.Windows.Forms.Label();
			this.Label27 = new System.Windows.Forms.Label();
			this.lblRPEqualizeCloses = new System.Windows.Forms.Label();
			this.Label29 = new System.Windows.Forms.Label();
			this.lblRPContinuation = new System.Windows.Forms.Label();
			this.Label23 = new System.Windows.Forms.Label();
			this.lblRPSessionsFilter = new System.Windows.Forms.Label();
			this.Label25 = new System.Windows.Forms.Label();
			this.lblRPIncludeEnd = new System.Windows.Forms.Label();
			this.Label17 = new System.Windows.Forms.Label();
			this.lblRPUpdatesEnabled = new System.Windows.Forms.Label();
			this.Label21 = new System.Windows.Forms.Label();
			this.lblRPHistoricalPeriod = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.lblRPIntradayPeriod = new System.Windows.Forms.Label();
			this.Label13 = new System.Windows.Forms.Label();
			this.lblRPRangeEnd = new System.Windows.Forms.Label();
			this.Label12 = new System.Windows.Forms.Label();
			this.lblRPSessionFlags = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.lblRPRangeStart = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.lblRPBaseExpression = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.PictureBox2 = new System.Windows.Forms.PictureBox();
			this.PictureBox3 = new System.Windows.Forms.PictureBox();
			this.GroupBox2 = new System.Windows.Forms.GroupBox();
			this.txtTagValue = new System.Windows.Forms.TextBox();
			this.txtTagName = new System.Windows.Forms.TextBox();
			this.Label14 = new System.Windows.Forms.Label();
			this.Label18 = new System.Windows.Forms.Label();
			this.GroupBox3 = new System.Windows.Forms.GroupBox();
			this.lblOEnd = new System.Windows.Forms.Label();
			this.Label16 = new System.Windows.Forms.Label();
			this.lblOStart = new System.Windows.Forms.Label();
			this.Label20 = new System.Windows.Forms.Label();
			this.GroupBox4 = new System.Windows.Forms.GroupBox();
			this.lvCustomStudy = new System.Windows.Forms.ListView();
			this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.GroupBox5 = new System.Windows.Forms.GroupBox();
			this.lvShownCustomStudy = new System.Windows.Forms.ListView();
			this.ColumnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader7 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader8 = new System.Windows.Forms.ColumnHeader();
			this.btnShow = new System.Windows.Forms.Button();
			this.gbIndexInterval = new System.Windows.Forms.GroupBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.nudEnd = new System.Windows.Forms.NumericUpDown();
			this.Label2 = new System.Windows.Forms.Label();
			this.nudStart = new System.Windows.Forms.NumericUpDown();
			this.optTimeInterval = new System.Windows.Forms.RadioButton();
			this.optIndexInterval = new System.Windows.Forms.RadioButton();
			this.gbTimeInterval = new System.Windows.Forms.GroupBox();
			this.Label7 = new System.Windows.Forms.Label();
			this.dtpEndRange = new System.Windows.Forms.DateTimePicker();
			this.Label5 = new System.Windows.Forms.Label();
			this.dtpStartRange = new System.Windows.Forms.DateTimePicker();
			this.GroupBox6 = new System.Windows.Forms.GroupBox();
			this.lblError = new System.Windows.Forms.Label();
			this.txtCustomStudyName = new System.Windows.Forms.TextBox();
			this.GroupBox7 = new System.Windows.Forms.GroupBox();
			this.lstCurve = new System.Windows.Forms.ListBox();
			this.Label26 = new System.Windows.Forms.Label();
			this.lblAbbreviation = new System.Windows.Forms.Label();
			this.Label19 = new System.Windows.Forms.Label();
			this.cmbParameter = new System.Windows.Forms.ComboBox();
			this.lblParameterComment = new System.Windows.Forms.Label();
			this.Label28 = new System.Windows.Forms.Label();
			this.Label24 = new System.Windows.Forms.Label();
			this.cmbDefinition = new System.Windows.Forms.ComboBox();
			this.btnReqCustomStudyDefinitions = new System.Windows.Forms.Button();
			this.lblParameterDefaultValue = new System.Windows.Forms.Label();
			this.Label15 = new System.Windows.Forms.Label();
			this.lblParameterType = new System.Windows.Forms.Label();
			this.Label22 = new System.Windows.Forms.Label();
			this.GroupBox1.SuspendLayout();
			this.GroupBox2.SuspendLayout();
			this.GroupBox3.SuspendLayout();
			this.GroupBox4.SuspendLayout();
			this.GroupBox5.SuspendLayout();
			this.gbIndexInterval.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nudEnd)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStart)).BeginInit();
			this.gbTimeInterval.SuspendLayout();
			this.GroupBox6.SuspendLayout();
			this.GroupBox7.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblDataConnection
			// 
			this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
			this.lblDataConnection.Name = "lblDataConnection";
			this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
			this.lblDataConnection.TabIndex = 24;
			this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// PictureBox1
			// 
			this.PictureBox1.BackColor = System.Drawing.Color.Black;
			this.PictureBox1.Location = new System.Drawing.Point(0, 40);
			this.PictureBox1.Name = "PictureBox1";
			this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox1.TabIndex = 23;
			this.PictureBox1.TabStop = false;
			// 
			// llWeb
			// 
			this.llWeb.BackColor = System.Drawing.SystemColors.Control;
			this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
			this.llWeb.Location = new System.Drawing.Point(632, 8);
			this.llWeb.Name = "llWeb";
			this.llWeb.Size = new System.Drawing.Size(408, 16);
			this.llWeb.TabIndex = 25;
			this.llWeb.TabStop = true;
			this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
			this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
			// 
			// cmbCustomStudy
			// 
			this.cmbCustomStudy.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbCustomStudy.Location = new System.Drawing.Point(24, 208);
			this.cmbCustomStudy.Name = "cmbCustomStudy";
			this.cmbCustomStudy.Size = new System.Drawing.Size(448, 24);
			this.cmbCustomStudy.TabIndex = 2;
			this.cmbCustomStudy.SelectedIndexChanged += new System.EventHandler(this.cmbCustomStudy_SelectedIndexChanged);
			// 
			// btnRequest
			// 
			this.btnRequest.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRequest.Location = new System.Drawing.Point(24, 240);
			this.btnRequest.Name = "btnRequest";
			this.btnRequest.Size = new System.Drawing.Size(96, 40);
			this.btnRequest.TabIndex = 3;
			this.btnRequest.Text = "Request";
			this.btnRequest.Click += new System.EventHandler(this.btnRequest_Click);
			// 
			// btnRemove
			// 
			this.btnRemove.Enabled = false;
			this.btnRemove.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemove.Location = new System.Drawing.Point(128, 240);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.Size = new System.Drawing.Size(96, 40);
			this.btnRemove.TabIndex = 4;
			this.btnRemove.Text = "Remove";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnRemoveAll
			// 
			this.btnRemoveAll.Enabled = false;
			this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemoveAll.Location = new System.Drawing.Point(232, 240);
			this.btnRemoveAll.Name = "btnRemoveAll";
			this.btnRemoveAll.Size = new System.Drawing.Size(96, 40);
			this.btnRemoveAll.TabIndex = 5;
			this.btnRemoveAll.Text = "Remove All";
			this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblStatus.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblStatus.Location = new System.Drawing.Point(8, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(120, 24);
			this.lblStatus.TabIndex = 31;
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.lblRPRecalcPeriod);
			this.GroupBox1.Controls.Add(this.label1);
			this.GroupBox1.Controls.Add(this.lblRPSubscriptionLevel);
			this.GroupBox1.Controls.Add(this.label30);
			this.GroupBox1.Controls.Add(this.lstRPParameters);
			this.GroupBox1.Controls.Add(this.Label11);
			this.GroupBox1.Controls.Add(this.lblRPCustomStudyDefinitionName);
			this.GroupBox1.Controls.Add(this.Label6);
			this.GroupBox1.Controls.Add(this.lblRPDaysBeforeExpiration);
			this.GroupBox1.Controls.Add(this.Label27);
			this.GroupBox1.Controls.Add(this.lblRPEqualizeCloses);
			this.GroupBox1.Controls.Add(this.Label29);
			this.GroupBox1.Controls.Add(this.lblRPContinuation);
			this.GroupBox1.Controls.Add(this.Label23);
			this.GroupBox1.Controls.Add(this.lblRPSessionsFilter);
			this.GroupBox1.Controls.Add(this.Label25);
			this.GroupBox1.Controls.Add(this.lblRPIncludeEnd);
			this.GroupBox1.Controls.Add(this.Label17);
			this.GroupBox1.Controls.Add(this.lblRPUpdatesEnabled);
			this.GroupBox1.Controls.Add(this.Label21);
			this.GroupBox1.Controls.Add(this.lblRPHistoricalPeriod);
			this.GroupBox1.Controls.Add(this.Label9);
			this.GroupBox1.Controls.Add(this.lblRPIntradayPeriod);
			this.GroupBox1.Controls.Add(this.Label13);
			this.GroupBox1.Controls.Add(this.lblRPRangeEnd);
			this.GroupBox1.Controls.Add(this.Label12);
			this.GroupBox1.Controls.Add(this.lblRPSessionFlags);
			this.GroupBox1.Controls.Add(this.Label10);
			this.GroupBox1.Controls.Add(this.lblRPRangeStart);
			this.GroupBox1.Controls.Add(this.Label8);
			this.GroupBox1.Controls.Add(this.lblRPBaseExpression);
			this.GroupBox1.Controls.Add(this.Label4);
			this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox1.Location = new System.Drawing.Point(488, 168);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(576, 320);
			this.GroupBox1.TabIndex = 32;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Request Parameters";
			// 
			// lblRPRecalcPeriod
			// 
			this.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRecalcPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRecalcPeriod.Location = new System.Drawing.Point(432, 248);
			this.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod";
			this.lblRPRecalcPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPRecalcPeriod.TabIndex = 72;
			this.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.Location = new System.Drawing.Point(320, 248);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 24);
			this.label1.TabIndex = 71;
			this.label1.Text = "Recalc Period :";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSubscriptionLevel
			// 
			this.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSubscriptionLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSubscriptionLevel.Location = new System.Drawing.Point(144, 248);
			this.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel";
			this.lblRPSubscriptionLevel.Size = new System.Drawing.Size(152, 24);
			this.lblRPSubscriptionLevel.TabIndex = 70;
			this.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label30
			// 
			this.label30.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label30.Location = new System.Drawing.Point(8, 248);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(136, 24);
			this.label30.TabIndex = 69;
			this.label30.Text = "Subscription Level :";
			this.label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lstRPParameters
			// 
			this.lstRPParameters.BackColor = System.Drawing.SystemColors.Control;
			this.lstRPParameters.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lstRPParameters.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lstRPParameters.ItemHeight = 16;
			this.lstRPParameters.Location = new System.Drawing.Point(432, 24);
			this.lstRPParameters.Name = "lstRPParameters";
			this.lstRPParameters.Size = new System.Drawing.Size(136, 50);
			this.lstRPParameters.TabIndex = 62;
			// 
			// Label11
			// 
			this.Label11.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label11.Location = new System.Drawing.Point(304, 24);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(120, 24);
			this.Label11.TabIndex = 60;
			this.Label11.Text = "Parameters :";
			this.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPCustomStudyDefinitionName
			// 
			this.lblRPCustomStudyDefinitionName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPCustomStudyDefinitionName.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPCustomStudyDefinitionName.Location = new System.Drawing.Point(144, 24);
			this.lblRPCustomStudyDefinitionName.Name = "lblRPCustomStudyDefinitionName";
			this.lblRPCustomStudyDefinitionName.Size = new System.Drawing.Size(152, 24);
			this.lblRPCustomStudyDefinitionName.TabIndex = 59;
			this.lblRPCustomStudyDefinitionName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label6
			// 
			this.Label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label6.Location = new System.Drawing.Point(16, 24);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(120, 24);
			this.Label6.TabIndex = 58;
			this.Label6.Text = "Definition Name :";
			this.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPDaysBeforeExpiration
			// 
			this.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPDaysBeforeExpiration.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPDaysBeforeExpiration.Location = new System.Drawing.Point(432, 216);
			this.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration";
			this.lblRPDaysBeforeExpiration.Size = new System.Drawing.Size(136, 24);
			this.lblRPDaysBeforeExpiration.TabIndex = 57;
			this.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label27
			// 
			this.Label27.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label27.Location = new System.Drawing.Point(296, 216);
			this.Label27.Name = "Label27";
			this.Label27.Size = new System.Drawing.Size(128, 24);
			this.Label27.TabIndex = 56;
			this.Label27.Text = "Days Before Exp. :";
			this.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPEqualizeCloses
			// 
			this.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPEqualizeCloses.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPEqualizeCloses.Location = new System.Drawing.Point(144, 216);
			this.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses";
			this.lblRPEqualizeCloses.Size = new System.Drawing.Size(152, 24);
			this.lblRPEqualizeCloses.TabIndex = 55;
			this.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label29
			// 
			this.Label29.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label29.Location = new System.Drawing.Point(16, 216);
			this.Label29.Name = "Label29";
			this.Label29.Size = new System.Drawing.Size(120, 24);
			this.Label29.TabIndex = 54;
			this.Label29.Text = "Equalize Closes :";
			this.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPContinuation
			// 
			this.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPContinuation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPContinuation.Location = new System.Drawing.Point(432, 184);
			this.lblRPContinuation.Name = "lblRPContinuation";
			this.lblRPContinuation.Size = new System.Drawing.Size(136, 24);
			this.lblRPContinuation.TabIndex = 53;
			this.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label23
			// 
			this.Label23.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label23.Location = new System.Drawing.Point(328, 184);
			this.Label23.Name = "Label23";
			this.Label23.Size = new System.Drawing.Size(96, 24);
			this.Label23.TabIndex = 52;
			this.Label23.Text = "Continuation :";
			this.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionsFilter
			// 
			this.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionsFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionsFilter.Location = new System.Drawing.Point(144, 280);
			this.lblRPSessionsFilter.Name = "lblRPSessionsFilter";
			this.lblRPSessionsFilter.Size = new System.Drawing.Size(424, 24);
			this.lblRPSessionsFilter.TabIndex = 51;
			this.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label25
			// 
			this.Label25.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label25.Location = new System.Drawing.Point(24, 280);
			this.Label25.Name = "Label25";
			this.Label25.Size = new System.Drawing.Size(112, 24);
			this.Label25.TabIndex = 50;
			this.Label25.Text = "Sessions Filter :";
			this.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIncludeEnd
			// 
			this.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIncludeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIncludeEnd.Location = new System.Drawing.Point(432, 152);
			this.lblRPIncludeEnd.Name = "lblRPIncludeEnd";
			this.lblRPIncludeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPIncludeEnd.TabIndex = 49;
			this.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label17
			// 
			this.Label17.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label17.Location = new System.Drawing.Point(328, 152);
			this.Label17.Name = "Label17";
			this.Label17.Size = new System.Drawing.Size(96, 24);
			this.Label17.TabIndex = 48;
			this.Label17.Text = "Include End :";
			this.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPUpdatesEnabled
			// 
			this.lblRPUpdatesEnabled.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPUpdatesEnabled.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPUpdatesEnabled.Location = new System.Drawing.Point(144, 152);
			this.lblRPUpdatesEnabled.Name = "lblRPUpdatesEnabled";
			this.lblRPUpdatesEnabled.Size = new System.Drawing.Size(152, 24);
			this.lblRPUpdatesEnabled.TabIndex = 47;
			this.lblRPUpdatesEnabled.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label21
			// 
			this.Label21.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label21.Location = new System.Drawing.Point(8, 152);
			this.Label21.Name = "Label21";
			this.Label21.Size = new System.Drawing.Size(124, 24);
			this.Label21.TabIndex = 46;
			this.Label21.Text = "Updates Enabled :";
			this.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPHistoricalPeriod
			// 
			this.lblRPHistoricalPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPHistoricalPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPHistoricalPeriod.Location = new System.Drawing.Point(432, 120);
			this.lblRPHistoricalPeriod.Name = "lblRPHistoricalPeriod";
			this.lblRPHistoricalPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPHistoricalPeriod.TabIndex = 45;
			this.lblRPHistoricalPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label9
			// 
			this.Label9.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label9.Location = new System.Drawing.Point(304, 120);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(120, 24);
			this.Label9.TabIndex = 44;
			this.Label9.Text = "Historical Period :";
			this.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIntradayPeriod
			// 
			this.lblRPIntradayPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIntradayPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIntradayPeriod.Location = new System.Drawing.Point(144, 120);
			this.lblRPIntradayPeriod.Name = "lblRPIntradayPeriod";
			this.lblRPIntradayPeriod.Size = new System.Drawing.Size(152, 24);
			this.lblRPIntradayPeriod.TabIndex = 43;
			this.lblRPIntradayPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label13
			// 
			this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label13.Location = new System.Drawing.Point(16, 120);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(120, 24);
			this.Label13.TabIndex = 42;
			this.Label13.Text = "Intraday Period :";
			this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeEnd
			// 
			this.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeEnd.Location = new System.Drawing.Point(432, 88);
			this.lblRPRangeEnd.Name = "lblRPRangeEnd";
			this.lblRPRangeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPRangeEnd.TabIndex = 41;
			this.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label12
			// 
			this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label12.Location = new System.Drawing.Point(336, 88);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(88, 24);
			this.Label12.TabIndex = 40;
			this.Label12.Text = "Range End :";
			this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionFlags
			// 
			this.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionFlags.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionFlags.Location = new System.Drawing.Point(144, 184);
			this.lblRPSessionFlags.Name = "lblRPSessionFlags";
			this.lblRPSessionFlags.Size = new System.Drawing.Size(152, 24);
			this.lblRPSessionFlags.TabIndex = 39;
			this.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label10
			// 
			this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label10.Location = new System.Drawing.Point(24, 184);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(112, 24);
			this.Label10.TabIndex = 38;
			this.Label10.Text = "Session Flags :";
			this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeStart
			// 
			this.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeStart.Location = new System.Drawing.Point(144, 88);
			this.lblRPRangeStart.Name = "lblRPRangeStart";
			this.lblRPRangeStart.Size = new System.Drawing.Size(152, 24);
			this.lblRPRangeStart.TabIndex = 37;
			this.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label8
			// 
			this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label8.Location = new System.Drawing.Point(16, 88);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(120, 24);
			this.Label8.TabIndex = 36;
			this.Label8.Text = "Range Start :";
			this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPBaseExpression
			// 
			this.lblRPBaseExpression.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPBaseExpression.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPBaseExpression.Location = new System.Drawing.Point(144, 56);
			this.lblRPBaseExpression.Name = "lblRPBaseExpression";
			this.lblRPBaseExpression.Size = new System.Drawing.Size(152, 24);
			this.lblRPBaseExpression.TabIndex = 33;
			this.lblRPBaseExpression.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label4
			// 
			this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label4.Location = new System.Drawing.Point(8, 56);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(128, 24);
			this.Label4.TabIndex = 32;
			this.Label4.Text = "Base Expression :";
			this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// PictureBox2
			// 
			this.PictureBox2.BackColor = System.Drawing.Color.Black;
			this.PictureBox2.Location = new System.Drawing.Point(-96, 496);
			this.PictureBox2.Name = "PictureBox2";
			this.PictureBox2.Size = new System.Drawing.Size(1272, 1);
			this.PictureBox2.TabIndex = 33;
			this.PictureBox2.TabStop = false;
			// 
			// PictureBox3
			// 
			this.PictureBox3.BackColor = System.Drawing.Color.Black;
			this.PictureBox3.Location = new System.Drawing.Point(-96, 568);
			this.PictureBox3.Name = "PictureBox3";
			this.PictureBox3.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox3.TabIndex = 34;
			this.PictureBox3.TabStop = false;
			// 
			// GroupBox2
			// 
			this.GroupBox2.Controls.Add(this.txtTagValue);
			this.GroupBox2.Controls.Add(this.txtTagName);
			this.GroupBox2.Controls.Add(this.Label14);
			this.GroupBox2.Controls.Add(this.Label18);
			this.GroupBox2.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox2.Location = new System.Drawing.Point(0, 504);
			this.GroupBox2.Name = "GroupBox2";
			this.GroupBox2.Size = new System.Drawing.Size(472, 59);
			this.GroupBox2.TabIndex = 6;
			this.GroupBox2.TabStop = false;
			this.GroupBox2.Text = "Tags";
			// 
			// txtTagValue
			// 
			this.txtTagValue.Location = new System.Drawing.Point(312, 24);
			this.txtTagValue.Name = "txtTagValue";
			this.txtTagValue.Size = new System.Drawing.Size(144, 25);
			this.txtTagValue.TabIndex = 1;
			this.txtTagValue.Text = "";
			this.txtTagValue.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagValue_KeyDown);
			// 
			// txtTagName
			// 
			this.txtTagName.Location = new System.Drawing.Point(72, 24);
			this.txtTagName.Name = "txtTagName";
			this.txtTagName.Size = new System.Drawing.Size(144, 25);
			this.txtTagName.TabIndex = 0;
			this.txtTagName.Text = "";
			this.txtTagName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagName_KeyDown);
			// 
			// Label14
			// 
			this.Label14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label14.Location = new System.Drawing.Point(248, 24);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(56, 24);
			this.Label14.TabIndex = 40;
			this.Label14.Text = "Value :";
			this.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label18
			// 
			this.Label18.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label18.Location = new System.Drawing.Point(8, 24);
			this.Label18.Name = "Label18";
			this.Label18.Size = new System.Drawing.Size(56, 24);
			this.Label18.TabIndex = 36;
			this.Label18.Text = "Name :";
			this.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox3
			// 
			this.GroupBox3.Controls.Add(this.lblOEnd);
			this.GroupBox3.Controls.Add(this.Label16);
			this.GroupBox3.Controls.Add(this.lblOStart);
			this.GroupBox3.Controls.Add(this.Label20);
			this.GroupBox3.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox3.Location = new System.Drawing.Point(480, 504);
			this.GroupBox3.Name = "GroupBox3";
			this.GroupBox3.Size = new System.Drawing.Size(584, 59);
			this.GroupBox3.TabIndex = 42;
			this.GroupBox3.TabStop = false;
			this.GroupBox3.Text = "Output Parameters";
			// 
			// lblOEnd
			// 
			this.lblOEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblOEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblOEnd.Location = new System.Drawing.Point(408, 24);
			this.lblOEnd.Name = "lblOEnd";
			this.lblOEnd.Size = new System.Drawing.Size(136, 24);
			this.lblOEnd.TabIndex = 41;
			this.lblOEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label16
			// 
			this.Label16.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label16.Location = new System.Drawing.Point(328, 24);
			this.Label16.Name = "Label16";
			this.Label16.Size = new System.Drawing.Size(72, 24);
			this.Label16.TabIndex = 40;
			this.Label16.Text = "End :";
			this.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblOStart
			// 
			this.lblOStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblOStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblOStart.Location = new System.Drawing.Point(144, 24);
			this.lblOStart.Name = "lblOStart";
			this.lblOStart.Size = new System.Drawing.Size(128, 24);
			this.lblOStart.TabIndex = 37;
			this.lblOStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label20
			// 
			this.Label20.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label20.Location = new System.Drawing.Point(64, 24);
			this.Label20.Name = "Label20";
			this.Label20.Size = new System.Drawing.Size(72, 24);
			this.Label20.TabIndex = 36;
			this.Label20.Text = "Start :";
			this.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox4
			// 
			this.GroupBox4.Controls.Add(this.lvCustomStudy);
			this.GroupBox4.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox4.Location = new System.Drawing.Point(0, 584);
			this.GroupBox4.Name = "GroupBox4";
			this.GroupBox4.Size = new System.Drawing.Size(1064, 136);
			this.GroupBox4.TabIndex = 7;
			this.GroupBox4.TabStop = false;
			this.GroupBox4.Text = "Last 5 Resolved CustomStudies";
			// 
			// lvCustomStudy
			// 
			this.lvCustomStudy.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                            this.ColumnHeader1,
                                                                                            this.ColumnHeader2,
                                                                                            this.ColumnHeader3,
                                                                                            this.ColumnHeader4});
			this.lvCustomStudy.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvCustomStudy.FullRowSelect = true;
			this.lvCustomStudy.GridLines = true;
			this.lvCustomStudy.Location = new System.Drawing.Point(8, 20);
			this.lvCustomStudy.MultiSelect = false;
			this.lvCustomStudy.Name = "lvCustomStudy";
			this.lvCustomStudy.Size = new System.Drawing.Size(1048, 108);
			this.lvCustomStudy.TabIndex = 0;
			this.lvCustomStudy.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader1
			// 
			this.ColumnHeader1.Text = "";
			this.ColumnHeader1.Width = 0;
			// 
			// ColumnHeader2
			// 
			this.ColumnHeader2.Text = "Index";
			this.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader2.Width = 49;
			// 
			// ColumnHeader3
			// 
			this.ColumnHeader3.Text = "Timestamp";
			this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader3.Width = 162;
			// 
			// ColumnHeader4
			// 
			this.ColumnHeader4.Text = "Value";
			this.ColumnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader4.Width = 112;
			// 
			// GroupBox5
			// 
			this.GroupBox5.Controls.Add(this.lvShownCustomStudy);
			this.GroupBox5.Controls.Add(this.btnShow);
			this.GroupBox5.Controls.Add(this.gbIndexInterval);
			this.GroupBox5.Controls.Add(this.optTimeInterval);
			this.GroupBox5.Controls.Add(this.optIndexInterval);
			this.GroupBox5.Controls.Add(this.gbTimeInterval);
			this.GroupBox5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox5.Location = new System.Drawing.Point(0, 720);
			this.GroupBox5.Name = "GroupBox5";
			this.GroupBox5.Size = new System.Drawing.Size(1064, 216);
			this.GroupBox5.TabIndex = 8;
			this.GroupBox5.TabStop = false;
			this.GroupBox5.Text = "CustomStudies Filtered by Index or Time Interval";
			// 
			// lvShownCustomStudy
			// 
			this.lvShownCustomStudy.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                                 this.ColumnHeader5,
                                                                                                 this.ColumnHeader6,
                                                                                                 this.ColumnHeader7,
                                                                                                 this.ColumnHeader8});
			this.lvShownCustomStudy.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvShownCustomStudy.FullRowSelect = true;
			this.lvShownCustomStudy.GridLines = true;
			this.lvShownCustomStudy.Location = new System.Drawing.Point(8, 80);
			this.lvShownCustomStudy.MultiSelect = false;
			this.lvShownCustomStudy.Name = "lvShownCustomStudy";
			this.lvShownCustomStudy.Size = new System.Drawing.Size(1048, 128);
			this.lvShownCustomStudy.TabIndex = 5;
			this.lvShownCustomStudy.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader5
			// 
			this.ColumnHeader5.Text = "";
			this.ColumnHeader5.Width = 0;
			// 
			// ColumnHeader6
			// 
			this.ColumnHeader6.Text = "Index";
			this.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader6.Width = 49;
			// 
			// ColumnHeader7
			// 
			this.ColumnHeader7.Text = "Timestamp";
			this.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader7.Width = 162;
			// 
			// ColumnHeader8
			// 
			this.ColumnHeader8.Text = "Value";
			this.ColumnHeader8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader8.Width = 112;
			// 
			// btnShow
			// 
			this.btnShow.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnShow.Location = new System.Drawing.Point(760, 48);
			this.btnShow.Name = "btnShow";
			this.btnShow.Size = new System.Drawing.Size(96, 24);
			this.btnShow.TabIndex = 4;
			this.btnShow.Text = "Show";
			this.btnShow.Click += new System.EventHandler(this.btnShow_Click);
			// 
			// gbIndexInterval
			// 
			this.gbIndexInterval.Controls.Add(this.Label3);
			this.gbIndexInterval.Controls.Add(this.nudEnd);
			this.gbIndexInterval.Controls.Add(this.Label2);
			this.gbIndexInterval.Controls.Add(this.nudStart);
			this.gbIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbIndexInterval.Location = new System.Drawing.Point(352, 16);
			this.gbIndexInterval.Name = "gbIndexInterval";
			this.gbIndexInterval.Size = new System.Drawing.Size(400, 56);
			this.gbIndexInterval.TabIndex = 3;
			this.gbIndexInterval.TabStop = false;
			this.gbIndexInterval.Text = "Index Interval";
			// 
			// Label3
			// 
			this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label3.Location = new System.Drawing.Point(200, 24);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(48, 24);
			this.Label3.TabIndex = 74;
			this.Label3.Text = "End: ";
			this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudEnd
			// 
			this.nudEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudEnd.Location = new System.Drawing.Point(256, 24);
			this.nudEnd.Maximum = new System.Decimal(new int[] {
                                                                   10000000,
                                                                   0,
                                                                   0,
                                                                   0});
			this.nudEnd.Minimum = new System.Decimal(new int[] {
                                                                   1,
                                                                   0,
                                                                   0,
                                                                   0});
			this.nudEnd.Name = "nudEnd";
			this.nudEnd.Size = new System.Drawing.Size(128, 22);
			this.nudEnd.TabIndex = 1;
			this.nudEnd.Value = new System.Decimal(new int[] {
                                                                 1,
                                                                 0,
                                                                 0,
                                                                 0});
			// 
			// Label2
			// 
			this.Label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label2.Location = new System.Drawing.Point(8, 24);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(48, 24);
			this.Label2.TabIndex = 70;
			this.Label2.Text = "Start: ";
			this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudStart
			// 
			this.nudStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudStart.Location = new System.Drawing.Point(64, 24);
			this.nudStart.Maximum = new System.Decimal(new int[] {
                                                                     10000000,
                                                                     0,
                                                                     0,
                                                                     0});
			this.nudStart.Minimum = new System.Decimal(new int[] {
                                                                     1,
                                                                     0,
                                                                     0,
                                                                     0});
			this.nudStart.Name = "nudStart";
			this.nudStart.Size = new System.Drawing.Size(128, 22);
			this.nudStart.TabIndex = 0;
			this.nudStart.Value = new System.Decimal(new int[] {
                                                                   1,
                                                                   0,
                                                                   0,
                                                                   0});
			// 
			// optTimeInterval
			// 
			this.optTimeInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.optTimeInterval.Location = new System.Drawing.Point(200, 48);
			this.optTimeInterval.Name = "optTimeInterval";
			this.optTimeInterval.Size = new System.Drawing.Size(168, 24);
			this.optTimeInterval.TabIndex = 1;
			this.optTimeInterval.TabStop = true;
			this.optTimeInterval.Text = "Show by Time Interval";
			this.optTimeInterval.CheckedChanged += new System.EventHandler(this.optIndexOrTimeInterval_CheckedChanged);
			// 
			// optIndexInterval
			// 
			this.optIndexInterval.Checked = true;
			this.optIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.optIndexInterval.Location = new System.Drawing.Point(200, 24);
			this.optIndexInterval.Name = "optIndexInterval";
			this.optIndexInterval.Size = new System.Drawing.Size(168, 24);
			this.optIndexInterval.TabIndex = 0;
			this.optIndexInterval.TabStop = true;
			this.optIndexInterval.Text = "Show by Index Interval";
			this.optIndexInterval.CheckedChanged += new System.EventHandler(this.optIndexOrTimeInterval_CheckedChanged);
			// 
			// gbTimeInterval
			// 
			this.gbTimeInterval.Controls.Add(this.Label7);
			this.gbTimeInterval.Controls.Add(this.dtpEndRange);
			this.gbTimeInterval.Controls.Add(this.Label5);
			this.gbTimeInterval.Controls.Add(this.dtpStartRange);
			this.gbTimeInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbTimeInterval.Location = new System.Drawing.Point(352, 16);
			this.gbTimeInterval.Name = "gbTimeInterval";
			this.gbTimeInterval.Size = new System.Drawing.Size(400, 56);
			this.gbTimeInterval.TabIndex = 2;
			this.gbTimeInterval.TabStop = false;
			this.gbTimeInterval.Text = "Time Interval";
			// 
			// Label7
			// 
			this.Label7.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label7.Location = new System.Drawing.Point(200, 24);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(48, 24);
			this.Label7.TabIndex = 73;
			this.Label7.Text = "End: ";
			this.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dtpEndRange
			// 
			this.dtpEndRange.CustomFormat = "dd/MM/yyyy HH:mm";
			this.dtpEndRange.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.dtpEndRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpEndRange.Location = new System.Drawing.Point(256, 24);
			this.dtpEndRange.Name = "dtpEndRange";
			this.dtpEndRange.Size = new System.Drawing.Size(128, 22);
			this.dtpEndRange.TabIndex = 1;
			// 
			// Label5
			// 
			this.Label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label5.Location = new System.Drawing.Point(8, 24);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(48, 24);
			this.Label5.TabIndex = 71;
			this.Label5.Text = "Start: ";
			this.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dtpStartRange
			// 
			this.dtpStartRange.CustomFormat = "dd/MM/yyyy HH:mm";
			this.dtpStartRange.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.dtpStartRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpStartRange.Location = new System.Drawing.Point(64, 24);
			this.dtpStartRange.Name = "dtpStartRange";
			this.dtpStartRange.Size = new System.Drawing.Size(128, 22);
			this.dtpStartRange.TabIndex = 0;
			// 
			// GroupBox6
			// 
			this.GroupBox6.Controls.Add(this.lblStatus);
			this.GroupBox6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.GroupBox6.Location = new System.Drawing.Point(336, 232);
			this.GroupBox6.Name = "GroupBox6";
			this.GroupBox6.Size = new System.Drawing.Size(136, 48);
			this.GroupBox6.TabIndex = 45;
			this.GroupBox6.TabStop = false;
			this.GroupBox6.Text = "Status";
			// 
			// lblError
			// 
			this.lblError.ForeColor = System.Drawing.Color.Red;
			this.lblError.Location = new System.Drawing.Point(24, 296);
			this.lblError.Name = "lblError";
			this.lblError.Size = new System.Drawing.Size(448, 152);
			this.lblError.TabIndex = 46;
			// 
			// txtCustomStudyName
			// 
			this.txtCustomStudyName.Location = new System.Drawing.Point(24, 176);
			this.txtCustomStudyName.Name = "txtCustomStudyName";
			this.txtCustomStudyName.Size = new System.Drawing.Size(448, 22);
			this.txtCustomStudyName.TabIndex = 1;
			this.txtCustomStudyName.Text = "";
			// 
			// GroupBox7
			// 
			this.GroupBox7.Controls.Add(this.lstCurve);
			this.GroupBox7.Controls.Add(this.Label26);
			this.GroupBox7.Controls.Add(this.lblAbbreviation);
			this.GroupBox7.Controls.Add(this.Label19);
			this.GroupBox7.Controls.Add(this.cmbParameter);
			this.GroupBox7.Controls.Add(this.lblParameterComment);
			this.GroupBox7.Controls.Add(this.Label28);
			this.GroupBox7.Controls.Add(this.Label24);
			this.GroupBox7.Controls.Add(this.cmbDefinition);
			this.GroupBox7.Controls.Add(this.btnReqCustomStudyDefinitions);
			this.GroupBox7.Controls.Add(this.lblParameterDefaultValue);
			this.GroupBox7.Controls.Add(this.Label15);
			this.GroupBox7.Controls.Add(this.lblParameterType);
			this.GroupBox7.Controls.Add(this.Label22);
			this.GroupBox7.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox7.Location = new System.Drawing.Point(8, 48);
			this.GroupBox7.Name = "GroupBox7";
			this.GroupBox7.Size = new System.Drawing.Size(1056, 112);
			this.GroupBox7.TabIndex = 0;
			this.GroupBox7.TabStop = false;
			this.GroupBox7.Text = "CustomStudy Definitions";
			// 
			// lstCurve
			// 
			this.lstCurve.BackColor = System.Drawing.SystemColors.Control;
			this.lstCurve.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lstCurve.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lstCurve.ItemHeight = 16;
			this.lstCurve.Location = new System.Drawing.Point(328, 56);
			this.lstCurve.Name = "lstCurve";
			this.lstCurve.Size = new System.Drawing.Size(136, 50);
			this.lstCurve.TabIndex = 3;
			// 
			// Label26
			// 
			this.Label26.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label26.Location = new System.Drawing.Point(248, 56);
			this.Label26.Name = "Label26";
			this.Label26.Size = new System.Drawing.Size(72, 24);
			this.Label26.TabIndex = 63;
			this.Label26.Text = "Curves :";
			this.Label26.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblAbbreviation
			// 
			this.lblAbbreviation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblAbbreviation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblAbbreviation.Location = new System.Drawing.Point(112, 56);
			this.lblAbbreviation.Name = "lblAbbreviation";
			this.lblAbbreviation.Size = new System.Drawing.Size(128, 24);
			this.lblAbbreviation.TabIndex = 49;
			this.lblAbbreviation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label19
			// 
			this.Label19.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label19.Location = new System.Drawing.Point(8, 56);
			this.Label19.Name = "Label19";
			this.Label19.Size = new System.Drawing.Size(96, 24);
			this.Label19.TabIndex = 48;
			this.Label19.Text = "Abbreviation :";
			this.Label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmbParameter
			// 
			this.cmbParameter.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbParameter.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbParameter.Location = new System.Drawing.Point(624, 16);
			this.cmbParameter.Name = "cmbParameter";
			this.cmbParameter.Size = new System.Drawing.Size(424, 25);
			this.cmbParameter.TabIndex = 2;
			this.cmbParameter.SelectedIndexChanged += new System.EventHandler(this.cmbParameter_SelectedIndexChanged);
			// 
			// lblParameterComment
			// 
			this.lblParameterComment.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblParameterComment.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblParameterComment.Location = new System.Drawing.Point(624, 48);
			this.lblParameterComment.Name = "lblParameterComment";
			this.lblParameterComment.Size = new System.Drawing.Size(424, 24);
			this.lblParameterComment.TabIndex = 46;
			this.lblParameterComment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label28
			// 
			this.Label28.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label28.Location = new System.Drawing.Point(528, 48);
			this.Label28.Name = "Label28";
			this.Label28.Size = new System.Drawing.Size(88, 24);
			this.Label28.TabIndex = 45;
			this.Label28.Text = "Comment :";
			this.Label28.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label24
			// 
			this.Label24.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label24.Location = new System.Drawing.Point(536, 16);
			this.Label24.Name = "Label24";
			this.Label24.Size = new System.Drawing.Size(80, 24);
			this.Label24.TabIndex = 44;
			this.Label24.Text = "Parameter :";
			this.Label24.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmbDefinition
			// 
			this.cmbDefinition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbDefinition.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbDefinition.Location = new System.Drawing.Point(112, 24);
			this.cmbDefinition.Name = "cmbDefinition";
			this.cmbDefinition.Size = new System.Drawing.Size(352, 25);
			this.cmbDefinition.TabIndex = 1;
			this.cmbDefinition.SelectedIndexChanged += new System.EventHandler(this.cmbDefinition_SelectedIndexChanged);
			// 
			// btnReqCustomStudyDefinitions
			// 
			this.btnReqCustomStudyDefinitions.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnReqCustomStudyDefinitions.Location = new System.Drawing.Point(8, 24);
			this.btnReqCustomStudyDefinitions.Name = "btnReqCustomStudyDefinitions";
			this.btnReqCustomStudyDefinitions.Size = new System.Drawing.Size(96, 26);
			this.btnReqCustomStudyDefinitions.TabIndex = 0;
			this.btnReqCustomStudyDefinitions.Text = "Request";
			this.btnReqCustomStudyDefinitions.Click += new System.EventHandler(this.btnReqCustomStudyDefinitions_Click);
			// 
			// lblParameterDefaultValue
			// 
			this.lblParameterDefaultValue.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblParameterDefaultValue.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblParameterDefaultValue.Location = new System.Drawing.Point(912, 80);
			this.lblParameterDefaultValue.Name = "lblParameterDefaultValue";
			this.lblParameterDefaultValue.Size = new System.Drawing.Size(136, 24);
			this.lblParameterDefaultValue.TabIndex = 41;
			this.lblParameterDefaultValue.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label15
			// 
			this.Label15.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label15.Location = new System.Drawing.Point(792, 80);
			this.Label15.Name = "Label15";
			this.Label15.Size = new System.Drawing.Size(112, 24);
			this.Label15.TabIndex = 40;
			this.Label15.Text = "Default Value :";
			this.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblParameterType
			// 
			this.lblParameterType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblParameterType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblParameterType.Location = new System.Drawing.Point(624, 80);
			this.lblParameterType.Name = "lblParameterType";
			this.lblParameterType.Size = new System.Drawing.Size(128, 24);
			this.lblParameterType.TabIndex = 37;
			this.lblParameterType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label22
			// 
			this.Label22.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label22.Location = new System.Drawing.Point(544, 80);
			this.Label22.Name = "Label22";
			this.Label22.Size = new System.Drawing.Size(72, 24);
			this.Label22.TabIndex = 36;
			this.Label22.Text = "Type :";
			this.Label22.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// frmCustomStudy
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(1070, 939);
			this.Controls.Add(this.PictureBox1);
			this.Controls.Add(this.GroupBox7);
			this.Controls.Add(this.txtCustomStudyName);
			this.Controls.Add(this.lblError);
			this.Controls.Add(this.GroupBox6);
			this.Controls.Add(this.GroupBox5);
			this.Controls.Add(this.GroupBox4);
			this.Controls.Add(this.GroupBox2);
			this.Controls.Add(this.PictureBox3);
			this.Controls.Add(this.PictureBox2);
			this.Controls.Add(this.GroupBox1);
			this.Controls.Add(this.btnRemoveAll);
			this.Controls.Add(this.btnRemove);
			this.Controls.Add(this.btnRequest);
			this.Controls.Add(this.cmbCustomStudy);
			this.Controls.Add(this.lblDataConnection);
			this.Controls.Add(this.llWeb);
			this.Controls.Add(this.GroupBox3);
			this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmCustomStudy";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "CustomStudy";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmCustomStudy_Closing);
			this.Load += new System.EventHandler(this.frmCustomStudy_Load);
			this.GroupBox1.ResumeLayout(false);
			this.GroupBox2.ResumeLayout(false);
			this.GroupBox3.ResumeLayout(false);
			this.GroupBox4.ResumeLayout(false);
			this.GroupBox5.ResumeLayout(false);
			this.gbIndexInterval.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nudEnd)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStart)).EndInit();
			this.gbTimeInterval.ResumeLayout(false);
			this.GroupBox6.ResumeLayout(false);
			this.GroupBox7.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// Creates a CEL object, changes its configurations, and starts up the created CEL object.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void frmCustomStudy_Load(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Creates the CQGCEL object
				CEL = new CQGCEL();
				CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
				CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
				CEL.CustomStudyDefinitionsResolved += new CQG._ICQGCELEvents_CustomStudyDefinitionsResolvedEventHandler(CEL_CustomStudyDefinitionsResolved);
				CEL.CustomStudyResolved += new CQG._ICQGCELEvents_CustomStudyResolvedEventHandler(CEL_CustomStudyResolved);
				CEL.CustomStudyAdded += new CQG._ICQGCELEvents_CustomStudyAddedEventHandler(CEL_CustomStudyAdded);
				CEL.CustomStudyUpdated += new CQG._ICQGCELEvents_CustomStudyUpdatedEventHandler(CEL_CustomStudyUpdated);
				CEL.CustomStudyInserted += new CQG._ICQGCELEvents_CustomStudyInsertedEventHandler(CEL_CustomStudyInserted);
				CEL.CustomStudyRemoved += new CQG._ICQGCELEvents_CustomStudyRemovedEventHandler(CEL_CustomStudyRemoved);
				CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
				CEL.APIConfiguration.CollectionsThrowException = false;
				CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;

				// Disables the controls
				CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
				// Starts up the CQGCEL
				CEL.Startup();

				cmbCustomStudy.Items.Clear();
				cmbCustomStudy.SelectedIndex = -1;

				ClearAllData();

				m_CurCustomStudy = null;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "frmCustomStudy_Load", ex);
				this.Close();
			}
		}

		/// <summary>
		/// Shuts down CEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A CancelEventArgs that contains the event data.
		/// </param>
		private void frmCustomStudy_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (CEL != null)
			{
				CEL.Shutdown();
			}
		}

		/// <summary>
		/// Clears all old info regarding to old CustomStudyDefinitions and requests new CustomStudyDefinitions.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnReqCustomStudyDefinitions_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				CEL.RequestCustomStudyDefinitions();
				ClearDefinitionData();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "btnReqCustomStudyDefinitions_Click", ex);
			}
		}

		/// <summary>
		/// Opens frmCustomStudyRequestSettings and with passed values requests CustomStudy.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRequest_Click(System.Object sender, System.EventArgs e)
		{
			frmCustomStudyRequestSettings frmCustomStudyReq;
			CQGCustomStudy CustomStudy;

			try
			{
				// Opens the form to fill up request data
				frmCustomStudyReq = new frmCustomStudyRequestSettings();
				CQGCustomStudyRequest req = CEL.CreateCustomStudyRequest(txtCustomStudyName.Text);
				req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".
				frmCustomStudyReq.CustomStudyRequest = req;
				frmCustomStudyReq.LineTime = CEL.Environment.LineTime;

				// If the user confirms, request is sent to CQGCEL and added to the requests list
				if (frmCustomStudyReq.ShowDialog(this) == DialogResult.OK)
				{
					CustomStudy = CEL.RequestCustomStudy(req);

					cmbCustomStudy.Items.Add(CustomStudy.Id);
					cmbCustomStudy.SelectedIndex = cmbCustomStudy.Items.Count - 1;

					ChangeControlsStatuses();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "btnRequest_Click", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected CustomStudy info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbCustomStudy_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				if (cmbCustomStudy.SelectedIndex > -1)
				{
					// Gets the selected CustomStudy object from CQGCEL by it's ID
					m_CurCustomStudy = CEL.AllCustomStudies.get_ItemById(cmbCustomStudy.Text);

					ClearAllData();
					DumpAllData();

					DumpFilterInfo();
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "cmbCustomStudy_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes the visibility of groupboxes.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void optIndexOrTimeInterval_CheckedChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				gbIndexInterval.Visible = optIndexInterval.Checked;
				gbTimeInterval.Visible = optTimeInterval.Checked;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "optIndexOrTimeInterval_CheckedChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Definition info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbDefinition_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				CQGCustomStudyDefinition definition = m_CustomStudyDefinitions.get_ItemByName(cmbDefinition.Text);

				if (definition == null)
				{
					return;
				}

				lblAbbreviation.Text = definition.Abbreviation;

				cmbParameter.Items.Clear();

				foreach (CQGParameterDefinition param in definition.ParameterDefinitions)
				{
					cmbParameter.Items.Add(param.Name);
				}

				if (cmbParameter.Items.Count > 0)
				{
					cmbParameter.SelectedIndex = 0;
				}
				else
				{
					lblParameterComment.Text = "";
					lblParameterType.Text = "";
					lblParameterDefaultValue.Text = "";
				}

				lstCurve.Items.Clear();
				foreach (CQGCurveDefinition curve in definition.CurveDefinitions)
				{
					lstCurve.Items.Add(curve.Name);
				}

				txtCustomStudyName.Text = cmbDefinition.Text;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "cmbDefinition_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Parameter info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbParameter_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				if (cmbParameter.SelectedIndex > -1)
				{
					CQGCustomStudyDefinition CustomStudyDef = m_CustomStudyDefinitions.get_ItemByName(cmbDefinition.Text);
					CQGParameterDefinition param = CustomStudyDef.ParameterDefinitions.get_ItemByName(cmbParameter.Text);

					lblParameterComment.Text = param.Comment;
					lblParameterType.Text = param.Type.ToString();
					lblParameterDefaultValue.Text = param.DefaultValue.ToString();
				}
				else
				{
					lblParameterComment.Text = "";
					lblParameterType.Text = "";
					lblParameterDefaultValue.Text = "";
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "cmbParameter_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Open CQG API web page.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A LinkLabelLinkClickedEventArgs that contains the event data.
		/// </param>
		private void llWeb_LinkClicked(System.Object sender,
			LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "llWeb_LinkClicked", ex);
			}
		}

		/// <summary>
		/// Shows few data from the selected CustomStudy collection.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnShow_Click(System.Object sender, System.EventArgs e)
		{
			int iStart;
			int iEnd;
			DateTime dStart;
			DateTime dEnd;

			try
			{
				lvShownCustomStudy.Items.Clear();

				if (optIndexInterval.Checked)
				{
					iStart = System.Convert.ToInt32(nudStart.Value) - 1;
					iEnd = System.Convert.ToInt32(nudEnd.Value) - 1;
					if (iStart > iEnd || iEnd > m_CurCustomStudy.Count - 1 || iEnd - iStart >= MAX_INDEX_INTERVAL)
					{
						MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " records," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						return;
					}
				}
				else
				{
					// To get time with 00 seconds
					dStart = dtpStartRange.Value.AddSeconds(-dtpStartRange.Value.Second);
					dEnd = dtpEndRange.Value.AddSeconds(-dtpEndRange.Value.Second);
					iStart = m_CurCustomStudy.IndexForDate(dStart);
					iEnd = m_CurCustomStudy.IndexForDate(dEnd);
					if (dStart > dEnd || !(CEL.IsValid(iStart) && CEL.IsValid(iEnd)) || iEnd - iStart >= MAX_INDEX_INTERVAL)
					{
						MessageBox.Show("The start time must be earlier than the end time and their" + Environment.NewLine + "range must indicate to no more than " + MAX_INDEX_INTERVAL + " records.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						return;
					}
				}

				lvShownCustomStudy.SuspendLayout();
				for (int i = iEnd; i >= iStart; i--)
				{
					DumpRecord(lvShownCustomStudy, m_CurCustomStudy[i], i + 1);
				}
				lvShownCustomStudy.ResumeLayout(false);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "btnShow_Click", ex);
			}
		}

		/// <summary>
		/// Removes the selected CustomStudy from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemove_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Removes CustomStudy from the collection
				CEL.RemoveCustomStudy(m_CurCustomStudy);

				// Removes CustomStudy from the combo box
				cmbCustomStudy.Items.RemoveAt(cmbCustomStudy.SelectedIndex);

				cmbCustomStudy.SelectedIndex = cmbCustomStudy.Items.Count - 1;

				if (cmbCustomStudy.Items.Count == 0)
				{
					cmbCustomStudy.SelectedIndex = -1;
					ClearAllData();
					m_CurCustomStudy = null;
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "btnRemove_Click", ex);
			}
		}

		/// <summary>
		/// Removes all CustomStudy from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clears the combo box
				cmbCustomStudy.Items.Clear();
				cmbCustomStudy.SelectedIndex = -1;

				// Removes all CustomStudy from the collection
				CEL.RemoveAllCustomStudies();

				m_CurCustomStudy = null;

				ClearAllData();

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "btnRemoveAll_Click", ex);
			}
		}

		/// <summary>
		/// Shows tag value of the current CustomStudy corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagName_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					object tagValue = m_CurCustomStudy.get_Tag(txtTagName.Text);
					if (tagValue != null)
					{
						txtTagValue.Text = tagValue.ToString();
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "txtTagName_KeyDown", ex);
			}
		}

		/// <summary>
		/// Sets the tag value of the current CustomStudy corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagValue_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					if (txtTagValue.Text.Trim().Length == 0)
					{
						m_CurCustomStudy.set_Tag(txtTagName.Text, null);
					}
					else
					{
						m_CurCustomStudy.set_Tag(txtTagName.Text, txtTagValue.Text);
					}
					txtTagName.Text = "";
					txtTagValue.Text = "";
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "txtTagValue_KeyDown", ex);
			}
		}

		/// <summary>
		/// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
		/// </summary>
		/// <param name="cqg_error">
		/// The object, in which the error has occurred.
		/// </param>
		/// <param name="error_description">
		/// The string, describing the error.
		/// </param>
		private void CEL_DataError(object cqg_error, string error_description)
		{
			try
			{
				CQGError cqgErr = cqg_error as CQGError;
				if (CEL.IsValid(cqg_error))
				{
					if (cqgErr.Code == 102)
					{
						error_description += " Restart the application.";
					}
					else if (cqgErr.Code == 125)
					{
						error_description += " Turn on CQG Client and restart the application.";
					}
				}

				MessageBox.Show(error_description, "CustomStudy", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_DataError", ex);
			}
		}

		/// <summary>
		/// This event is fired, when some changes occur in the connection with CQG data server.
		/// </summary>
		/// <param name="newStatus">
		/// The current status of the connection with the data server.
		/// </param>
		private void CEL_DataConnectionStatusChanged(CQG.eConnectionStatus new_status)
		{
			string sInfo;
			System.Drawing.Color BackCol;

			try
			{
				if (new_status == eConnectionStatus.csConnectionUp)
				{
					BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
					sInfo = "DATA Connection is UP";
				}
				else if (new_status == eConnectionStatus.csConnectionDelayed)
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Delayed";
				}
				else
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Down";
				}

				lblDataConnection.BackColor = BackCol;
				lblDataConnection.Text = sInfo;

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_DataConnectionStatusChanged", ex);
			}
		}

		/// <summary>
		/// Displays resolved CustomStudy definitions.
		/// </summary>
		/// <param name="cqg_custom_study_definitions">
		/// The resolved CQGCustomStudyDefinitions object.
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object describing last error occurred
		/// during processing request or Nothing in case of no error.
		/// </param>
		private void CEL_CustomStudyDefinitionsResolved(CQGCustomStudyDefinitions cqg_custom_study_definitions, CQGError cqg_error)
		{
			try
			{
				// Set the resolved object
				m_CustomStudyDefinitions = cqg_custom_study_definitions;

				// Notifying when any error occurred during request
				if (CEL.IsValid(cqg_error))
				{
					MessageBox.Show(cqg_error.Description, "CustomStudy", MessageBoxButtons.OK, MessageBoxIcon.Information);
					return;
				}

				// Fill up new data
				foreach (CQGCustomStudyDefinition definition in cqg_custom_study_definitions)
				{
					cmbDefinition.Items.Add(definition.Name);
				}

				if (cmbDefinition.Items.Count > 0)
				{
					cmbDefinition.SelectedIndex = 0;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_CustomStudyDefinitionsResolved", ex);
			}
		}

		/// <summary>
		/// This event is fired when the custom study (CQGCustomStudy) is resolved
		/// or when some error has occurred during the custom studies request processing.
		/// </summary>
		/// <param name="cqg_custom_study">
		/// Reference to resolved CQGCustomStudy.
		/// </param>
		/// <param name="cqg_error">
		/// The CQGError object that describes the last error occurred
		/// while processing the CustomStudy request or
		/// Nothing/Invalid_Error in case of no error.
		/// </param>
		private void CEL_CustomStudyResolved(CQGCustomStudy cqg_custom_study, CQGError cqg_error)
		{
			try
			{
				if (cqg_custom_study.Id == m_CurCustomStudy.Id)
				{
					ClearAllData();
					DumpAllData();
					DumpFilterInfo();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_CustomStudyResolved", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGCurves item is added to the end of CQGCustomStudy.
		/// </summary>
		/// <param name="cqg_custom_study">
		/// Reference to changed CQGCustomStudy.
		/// </param>
		private void CEL_CustomStudyAdded(CQGCustomStudy cqg_custom_study)
		{
			try
			{
				if (cqg_custom_study.Id == m_CurCustomStudy.Id)
				{
					ShowChangedData(cqg_custom_study.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_CustomStudyAdded", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGCurves item is removed from CQGCustomStudy.
		/// </summary>
		/// <param name="cqg_custom_study">
		/// Reference to changed CQGCustomStudy.
		/// </param>
		/// <param name="index_">
		/// Specifies the changed CQGCurves index.
		/// </param>
		private void CEL_CustomStudyRemoved(CQGCustomStudy cqg_custom_study, int index_)
		{
			try
			{
				if (cqg_custom_study.Id == m_CurCustomStudy.Id)
				{
					ShowChangedData(cqg_custom_study.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_CustomStudyRemoved", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGCurves item is inserted into CQGCustomStudy.
		/// </summary>
		/// <param name="cqg_custom_study">
		/// Reference to changed CQGCustomStudy.
		/// </param>
		/// <param name="index_">
		/// Specifies the changed CQGCurves index.
		/// </param>
		private void CEL_CustomStudyInserted(CQGCustomStudy cqg_custom_study, int index_)
		{
			try
			{
				if (cqg_custom_study.Id == m_CurCustomStudy.Id)
				{
					ShowChangedData(cqg_custom_study.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_CustomStudyInserted", ex);
			}
		}

		/// <summary>
		/// Fired when the CQGCurves item is updated.
		/// </summary>
		/// <param name="cqg_custom_study">
		/// Reference to changed CQGCustomStudy
		/// </param>
		/// <param name="index_">
		/// Specifies the updated CQGCurves index.
		/// </param>
		private void CEL_CustomStudyUpdated(CQGCustomStudy cqg_custom_study, int index_)
		{
			try
			{
				if (cqg_custom_study.Id == m_CurCustomStudy.Id)
				{
					if (index_ > m_CurCustomStudy.Count - MAX_NUMBER_OF_RECORDS)
					{
						UpdateRecord(lvCustomStudy, m_CurCustomStudy[index_], index_ + 1);
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "CEL_CustomStudyUpdated", ex);
			}
		}

		/// <summary>
		/// Shows the selected request parameters on the listview.
		/// </summary>
		private void DumpRequestParams()
		{
			string parameterDefinitionName;
			try
			{
				CQGCustomStudyRequest req = m_CurCustomStudy.Request;

				lblRPCustomStudyDefinitionName.Text = req.Definition.Name;

				// Adding parameters to the corresponding combo list
				for (int i = 0; i <= req.Definition.ParameterDefinitions.Count - 1; i++)
				{
					parameterDefinitionName = req.Definition.ParameterDefinitions[i].Name;
					lstRPParameters.Items.Add(parameterDefinitionName + " - " + req.get_Parameter(parameterDefinitionName).ToString());
				}

				lblRPBaseExpression.Text = req.BaseExpression;
				lblRPRangeStart.Text = GetValueAsString(req.RangeStart);
				lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd);
				lblRPIntradayPeriod.Text = req.IntradayPeriod.ToString();
				lblRPHistoricalPeriod.Text = req.HistoricalPeriod.ToString();
				lblRPUpdatesEnabled.Text = req.UpdatesEnabled.ToString();
				lblRPIncludeEnd.Text = req.IncludeEnd.ToString();

				var sessionFilter = req.SessionsFilter.ToString();
				switch (sessionFilter)
				{
					case "0": sessionFilter = "Primary session only (0)"; break;
					case "31": sessionFilter = "All sessions (31)"; break;
				}
				lblRPSessionsFilter.Text = sessionFilter;
				lblRPContinuation.Text = req.Continuation.ToString();
				lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString();
				lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString();
				lblRPSessionFlags.Text = req.SessionFlags.ToString();
				lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString();
				if (req.SubscriptionLevel == eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod)
				{
					lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString();
				}

				if (m_CurCustomStudy.LastError != null)
				{
					lblError.Text = m_CurCustomStudy.LastError.Description;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "DumpRequestParams", ex);
			}
		}

		/// <summary>
		/// Shows the selected request outputs on the listview after changes.
		/// </summary>
		/// <param name="count">
		/// Count of CustomStudy that will be shown.
		/// </param>
		private void ShowChangedData(int count)
		{
			ClearOutputParams();
			DumpOutputParams();

			DumpRecords(count);
		}

		/// <summary>
		/// Shows the selected request outputs on the listview.
		/// </summary>
		private void DumpOutputParams()
		{
			try
			{
				lblOStart.Text = GetValueAsString(m_CurCustomStudy.StartTimestamp);
				lblOEnd.Text = GetValueAsString(m_CurCustomStudy.EndTimestamp);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "DumpOutputParams", ex);
			}
		}

		/// <summary>
		/// Shows added CustomStudy for the selected request records on the listview.
		/// </summary>
		/// <param name="addedCustomStudyCount">
		/// Count of CustomStudy that will be shown.
		/// </param>
		private void DumpRecords(int addedCustomStudyCount)
		{
			try
			{
				// Clears all records
				ClearRecords();

				// Clears headers
				ClearHeaders(lvCustomStudy);

				// Clears headers of filter listview
				ClearHeaders(lvShownCustomStudy);

				// Dumps headers
				DumpHeaders(lvCustomStudy);

				// Dumps headers of filter listview
				DumpHeaders(lvShownCustomStudy);

				if (m_CurCustomStudy.Count == 0)
				{
					return;
				}

				if (addedCustomStudyCount == m_CurCustomStudy.Count)
				{
					addedCustomStudyCount = System.Convert.ToInt32(addedCustomStudyCount >= MAX_NUMBER_OF_RECORDS ? MAX_NUMBER_OF_RECORDS : m_CurCustomStudy.Count);
				}
				for (int i = m_CurCustomStudy.Count - 1; i >= m_CurCustomStudy.Count - addedCustomStudyCount; i--)
				{
					DumpRecord(lvCustomStudy, m_CurCustomStudy[i], i + 1);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "DumpRecords", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="curves">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void DumpRecord(ListView lv, CQGCurves curves, long recordIndex)
		{
			try
			{
				ListViewItem item = lv.Items.Add(new ListViewItem());
				item.SubItems.Add("Index").Text = recordIndex.ToString();
				item.SubItems.Add("Timestamp").Text = GetValueAsString(curves.Timestamp, true);
				for (int i = 0; i <= curves.Count - 1; i++)
				{
					item.SubItems.Add(m_CurCustomStudy.CurveHeaders[i]).Text = GetValueAsString(curves[i]);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "DumpRecord", ex);
			}
		}

		/// <summary>
		/// Updates one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="curves">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be updated.
		/// </param>
		private void UpdateRecord(ListView lv, CQGCurves curves, int recordIndex)
		{
			try
			{
				ListViewItem item = new ListViewItem();
				item.SubItems.Add("Index").Text = recordIndex.ToString();
				item.SubItems.Add("Timestamp").Text = GetValueAsString(curves.Timestamp, true);

				for (int i = 0; i <= curves.Count - 1; i++)
				{
					item.SubItems.Add(m_CurCustomStudy.CurveHeaders[i]).Text = GetValueAsString(curves[i]);
				}

				lv.Items[m_CurCustomStudy.Count - recordIndex] = item;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "UpdateRecord", ex);
			}
		}

		/// <summary>
		/// Dumps all request data (outputs\parameters\records)
		/// </summary>
		private void DumpAllData()
		{
			try
			{
				DumpRequestParams();

				lblStatus.Text = m_CurCustomStudy.Status.ToString();

				if (m_CurCustomStudy.Status == eRequestStatus.rsSuccess)
				{
					DumpOutputParams();
					DumpRecords(m_CurCustomStudy.Count);
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "DumpAllData", ex);
			}
		}

		/// <summary>
		/// Initializes the filter-related controls.
		/// </summary>
		private void DumpFilterInfo()
		{
			try
			{
				if (m_CurCustomStudy != null && m_CurCustomStudy.Status == eRequestStatus.rsSuccess)
				{
					dtpStartRange.Value = m_CurCustomStudy.StartTimestamp;
					dtpEndRange.Value = m_CurCustomStudy.EndTimestamp;
				}
				else
				{
					dtpStartRange.Value = DateTime.Now;
					dtpEndRange.Value = DateTime.Now;
				}
				nudStart.Value = 1;
				nudEnd.Value = 1;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "DumpFilterInfo", ex);
			}
		}

		/// <summary>
		///  Clears all data connected to CustomStudy definitions.
		/// </summary>
		private void ClearDefinitionData()
		{
			try
			{
				cmbDefinition.Items.Clear();
				cmbDefinition.SelectedIndex = -1;

				cmbParameter.Items.Clear();
				cmbParameter.SelectedIndex = -1;

				lblParameterComment.Text = "";
				lblParameterType.Text = "";
				lblParameterDefaultValue.Text = "";

				txtCustomStudyName.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ClearAllData", ex);
			}
		}

		/// <summary>
		/// Clears all request data.
		/// </summary>
		private void ClearAllData()
		{
			try
			{
				lblStatus.Text = "";

				ClearRequestParams();
				ClearOutputParams();
				ClearTags();
				ClearHeaders(lvCustomStudy);
				ClearHeaders(lvShownCustomStudy);
				ClearRecords();

				lvShownCustomStudy.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ClearAllData", ex);
			}
		}

		/// <summary>
		/// Clears the request parameters from the listview.
		/// </summary>
		private void ClearRequestParams()
		{
			try
			{
				lblRPCustomStudyDefinitionName.Text = "";

				lstRPParameters.Items.Clear();

				lblRPBaseExpression.Text = "";
				lblRPRangeStart.Text = "";
				lblRPRangeEnd.Text = "";
				lblRPIntradayPeriod.Text = "";
				lblRPHistoricalPeriod.Text = "";
				lblRPUpdatesEnabled.Text = "";
				lblRPIncludeEnd.Text = "";
				lblRPSessionsFilter.Text = "";
				lblRPContinuation.Text = "";
				lblRPEqualizeCloses.Text = "";
				lblRPDaysBeforeExpiration.Text = "";
				lblRPSessionFlags.Text = "";
				lblRPSubscriptionLevel.Text = "";
				lblRPRecalcPeriod.Text = "";

				lblError.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ClearRequestParams", ex);
			}
		}

		/// <summary>
		/// Clears request outputs from the listview.
		/// </summary>
		private void ClearOutputParams()
		{
			try
			{
				lblOStart.Text = "";
				lblOEnd.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ClearOutputParams", ex);
			}
		}

		/// <summary>
		/// Clears request tags.
		/// </summary>
		private void ClearTags()
		{
			try
			{
				txtTagName.Text = "";
				txtTagValue.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ClearTags", ex);
			}
		}

		/// <summary>
		/// Clears records from the listview.
		/// </summary>
		private void ClearRecords()
		{
			try
			{
				lvCustomStudy.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ClearRecords", ex);
			}
		}

		/// <summary>
		/// Clears records from the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be cleared.
		/// </param>
		private void ClearHeaders(ListView lv)
		{
			try
			{
				lv.Columns.Clear();
				lv.Columns.Add("ID", 0, HorizontalAlignment.Center);
				lv.Columns.Add(INDEX_HEADER, 49, HorizontalAlignment.Center);
				lv.Columns.Add(TIMESTAMP_HEADER, 162, HorizontalAlignment.Center);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearHeaders", ex);
			}
		}

		/// <summary>
		/// Shows selected request output headers in listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be dumped.
		/// </param>
		private void DumpHeaders(ListView lv)
		{
			try
			{
				for (int i = 0; i <= m_CurCustomStudy.CurveHeaders.Count - 1; i++)
				{
					lv.Columns.Add(m_CurCustomStudy.CurveHeaders[i], 60, HorizontalAlignment.Center);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpHeaders", ex);
			}
		}

		/// <summary>
		/// Enables\disables the controls, based on the connection status.
		/// </summary>
		private void ChangeControlsStatuses()
		{
			bool bIsDataConnectionUp = false;
			bool bIsCustomStudySelected;
			bool bIsCustomStudySucceded = false;

			try
			{
				if (CEL.IsStarted)
				{
					bIsDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
				}

				btnReqCustomStudyDefinitions.Enabled = bIsDataConnectionUp;

				btnRequest.Enabled = bIsDataConnectionUp;

				bIsCustomStudySelected = m_CurCustomStudy != null;

				btnRemove.Enabled = bIsCustomStudySelected && bIsDataConnectionUp;
				btnRemoveAll.Enabled = bIsCustomStudySelected && bIsDataConnectionUp;

				txtTagName.Enabled = bIsCustomStudySelected;
				txtTagValue.Enabled = bIsCustomStudySelected;

				if (bIsCustomStudySelected)
				{
					bIsCustomStudySucceded = m_CurCustomStudy.Status == eRequestStatus.rsSuccess;
				}

				dtpEndRange.Enabled = bIsCustomStudySucceded;
				dtpStartRange.Enabled = bIsCustomStudySucceded;

				nudEnd.Enabled = bIsCustomStudySucceded;
				nudStart.Enabled = bIsCustomStudySucceded;

				optIndexInterval.Enabled = bIsCustomStudySucceded;
				optTimeInterval.Enabled = bIsCustomStudySucceded;

				btnShow.Enabled = bIsCustomStudySucceded;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmCustomStudy", "ChangeControlsStatuses", ex);
			}
		}

		/// <summary>
		/// Validates the specified value and converts it to string.
		/// </summary>
		/// <param name="val">
		/// The value that will be validated and converted
		/// </param>
		/// <param name="includeMilliseconds">
		/// Whether to include seconds and milliseconds to string, valid only for DateTime
		/// </param>
		/// <returns>
		/// Value converted to string or "N/A" if the value is invalid.
		/// </returns>
		private string GetValueAsString(object val, bool includeMilliseconds = false)
		{
			string sResult = "";

			try
			{
				if (CEL.IsValid(val))
				{
					if (val.GetType().FullName == "System.DateTime")
					{
						string format = includeMilliseconds ? "dd/MM/yyyy HH:mm:ss.fff" : "dd/MM/yyyy HH:mm";
						sResult = System.Convert.ToDateTime(val).ToString(format);
					}
					else
					{
						sResult = val.ToString();
					}
				}
				else
				{
					sResult = N_A;
				}
			}
			catch
			{
				sResult = N_A;
			}

			return sResult;
		}

	}

}
