// DataSources.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <cassert>
#include "Helper.h"

const CString CHelper::m_N_A = _T("N/A");

CString CHelper::ConnectionStatusToString(
                        eConnectionStatus connectionStatus)
{
   CString connectionStatusStr;

   switch (connectionStatus)
   {
   case csConnectionUp:
      connectionStatusStr = _T("Connection Up");
      break;
   case csConnectionDown:
      connectionStatusStr = _T("Connection Down");
      break;
   case csConnectionDelayed:
      connectionStatusStr = _T("Connection Delayed");
      break;
   default:
      assert(!"Unknown connection status");
   }

   return connectionStatusStr;
}

CString CHelper::DataSourceStatusToString(
                        eDataSourceStatus dataSourceStatus)
{
   CString dataSourceStatusStr;

   switch (dataSourceStatus)
   {
   case dssDisabled:
      dataSourceStatusStr = _T("Disabled");
      break;
   case dssAvailable:
      dataSourceStatusStr = _T("Available");
      break;
   case dssDelay:
      dataSourceStatusStr = _T("Delay");
      break;
   case dssExtraDelay:
      dataSourceStatusStr = _T("ExtraDelay");
      break;
   case dssSnapshot:
      dataSourceStatusStr = _T("Snapshot");
      break;
   default:
      assert(!"Unknown data source status");
   }

   return dataSourceStatusStr;
}

CString CHelper::SymbolTypeToString(
                        eSymbolType symbolType)
{
   CString symbolTypeStr;

   if ((symbolType & stFuture) == stFuture)
   {
      symbolTypeStr.Append(_T("Future, "));
   }
   if ((symbolType & stOption) == stOption)
   {
      symbolTypeStr.Append(_T("Option, "));
   }
   if ((symbolType & stStock) == stStock)
   {
      symbolTypeStr.Append(_T("Stock, "));
   }
   if ((symbolType & stTreasury) == stTreasury)
   {
      symbolTypeStr.Append(_T("Treasury, "));
   }
   if ((symbolType & stCash) == stCash)
   {
      symbolTypeStr.Append(_T("Cash, "));
   }
   if ((symbolType & stCurrency) == stCurrency)
   {
      symbolTypeStr.Append(_T("Currency, "));
   }
   if ((symbolType & stIndex) == stIndex)
   {
      symbolTypeStr.Append(_T("Index, "));
   }
   if ((symbolType & stReport) == stReport)
   {
      symbolTypeStr.Append(_T("Report, "));
   }

   if (symbolTypeStr.IsEmpty())
   {
      return _T("Undefined");
   }
   else
   {
      return symbolTypeStr.Left(symbolTypeStr.GetLength() - 2);
   }
}
