/*
* =====================================================================
*  Filename: Helper.h
*    Author: Sevada Gyurjyan
*   Company: CQG, Inc.
* Copyright: (c)2008 by CQG,Inc. All rights reserved.
* =====================================================================
*/

#pragma once

class CHelper
{

private:

   /// \brief CHelper constructor.
   CHelper();

public:

   /// \brief Converts enum of connection status to appropriate string.
   /// \param connectionStatus - enum which will be converted
   /// \return String which describes dataSources request type
   static CString ConnectionStatusToString(
                     eConnectionStatus connectionStatus);

   /// \brief Converts enum of data source status to appropriate string.
   /// \param dataSourceStatus - enum which will be converted
   /// \return String which describes data source status
   static CString DataSourceStatusToString(
                     eDataSourceStatus dataSourceStatus);

   /// \brief Converts bitmap of symbol type to appropriate string.
   /// \param symbolType - bitmap which will be converted
   /// \return String which describes symbol type
   static CString SymbolTypeToString(
                     eSymbolType symbolType);

public:

   /// \brief Not available string.
   static const CString m_N_A;
};
