using System.Diagnostics;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;

namespace Expression
{
	public class frmExpression : System.Windows.Forms.Form
	{

		[STAThread]
		static void Main()
		{
			Application.Run(new frmExpression());
		}

		// The CQGCEL object, which encapsulates the main functionality of CQG API
		private CQGCEL CEL;

		// The currently selected Expression object in the combo box
		private CQGExpression m_CurExpression;

		// Specifies the not available string
		private const string N_A = "N/A";

		// Specifies the header of index column
		private const string INDEX_HEADER = "Index";

		// Specifies the header of timestamp column
		private const string TIMESTAMP_HEADER = "Timestamp";

		// Specifies the max records count
		private const int MAX_NUMBER_OF_RECORDS = 5;

		// Specifies the max index interval
		private const int MAX_INDEX_INTERVAL = 500;

		#region " Windows Form Designer generated code "

		public frmExpression()
		{

			//This call is required by the Windows Form Designer.
			InitializeComponent();

			//Add any initialization after the InitializeComponent() call

		}

		//Form overrides dispose to clean up the component list.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(components == null))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		//Required by the Windows Form Designer
		private System.ComponentModel.Container components = null;

		//NOTE: The following procedure is required by the Windows Form Designer
		//It can be modified using the Windows Form Designer.
		//Do not modify it using the code editor.
		internal System.Windows.Forms.Label lblDataConnection;
		internal System.Windows.Forms.PictureBox PictureBox1;
		internal System.Windows.Forms.LinkLabel llWeb;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.PictureBox PictureBox2;
		internal System.Windows.Forms.PictureBox PictureBox3;
		internal System.Windows.Forms.GroupBox GroupBox2;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.Label Label18;
		internal System.Windows.Forms.GroupBox GroupBox3;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.GroupBox GroupBox4;
		internal System.Windows.Forms.ComboBox cmbExpression;
		internal System.Windows.Forms.Label lblRPRangeEnd;
		internal System.Windows.Forms.Label lblRPRangeStart;
		internal System.Windows.Forms.Label lblOEnd;
		internal System.Windows.Forms.Label lblOStart;
		internal System.Windows.Forms.Label lblStatus;
		internal System.Windows.Forms.TextBox txtTagName;
		internal System.Windows.Forms.TextBox txtTagValue;
		internal System.Windows.Forms.Button btnRequest;
		internal System.Windows.Forms.Button btnRemove;
		internal System.Windows.Forms.Button btnRemoveAll;
		internal System.Windows.Forms.GroupBox GroupBox5;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.GroupBox gbIndexInterval;
		internal System.Windows.Forms.GroupBox gbTimeInterval;
		internal System.Windows.Forms.DateTimePicker dtpStartRange;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Button btnShow;
		internal System.Windows.Forms.RadioButton optTimeInterval;
		internal System.Windows.Forms.RadioButton optIndexInterval;
		internal System.Windows.Forms.NumericUpDown nudEnd;
		internal System.Windows.Forms.NumericUpDown nudStart;
		internal System.Windows.Forms.GroupBox GroupBox6;
		internal System.Windows.Forms.DateTimePicker dtpEndRange;
		internal System.Windows.Forms.Label lblError;
		internal System.Windows.Forms.ListView lvShownExpression;
		internal System.Windows.Forms.ColumnHeader ColumnHeader13;
		internal System.Windows.Forms.ColumnHeader ColumnHeader14;
		internal System.Windows.Forms.ColumnHeader ColumnHeader15;
		internal System.Windows.Forms.ColumnHeader ColumnHeader1;
		internal System.Windows.Forms.ColumnHeader ColumnHeader2;
		internal System.Windows.Forms.ColumnHeader ColumnHeader3;
		internal System.Windows.Forms.ListView lvExpression;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label17;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Label Label23;
		internal System.Windows.Forms.Label Label25;
		internal System.Windows.Forms.Label Label27;
		internal System.Windows.Forms.Label Label29;
		internal System.Windows.Forms.Label lblRPSessionFlags;
		internal System.Windows.Forms.Label lblRPHistoricalPeriod;
		internal System.Windows.Forms.Label lblRPIntradayPeriod;
		internal System.Windows.Forms.Label lblRPIncludeEnd;
		internal System.Windows.Forms.Label lblRPUpdatesEnabled;
		internal System.Windows.Forms.Label lblRPContinuation;
		internal System.Windows.Forms.Label lblRPSessionsFilter;
		internal System.Windows.Forms.Label lblRPDaysBeforeExpiration;
		internal System.Windows.Forms.Label lblRPEqualizeCloses;
		internal System.Windows.Forms.Label lblRPSubExpressionAlias;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.ComboBox cmbRPSubExpression;
		internal System.Windows.Forms.Label lblRPRecalcPeriod;
		internal System.Windows.Forms.Label label6;
		internal System.Windows.Forms.Label lblRPSubscriptionLevel;
		internal System.Windows.Forms.Label label30;
		[System.Diagnostics.DebuggerStepThrough()]
		private void InitializeComponent()
		{
			this.lblDataConnection = new System.Windows.Forms.Label();
			this.PictureBox1 = new System.Windows.Forms.PictureBox();
			this.llWeb = new System.Windows.Forms.LinkLabel();
			this.cmbExpression = new System.Windows.Forms.ComboBox();
			this.btnRequest = new System.Windows.Forms.Button();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnRemoveAll = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.cmbRPSubExpression = new System.Windows.Forms.ComboBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.lblRPDaysBeforeExpiration = new System.Windows.Forms.Label();
			this.Label27 = new System.Windows.Forms.Label();
			this.lblRPEqualizeCloses = new System.Windows.Forms.Label();
			this.Label29 = new System.Windows.Forms.Label();
			this.lblRPContinuation = new System.Windows.Forms.Label();
			this.Label23 = new System.Windows.Forms.Label();
			this.lblRPSessionsFilter = new System.Windows.Forms.Label();
			this.Label25 = new System.Windows.Forms.Label();
			this.lblRPIncludeEnd = new System.Windows.Forms.Label();
			this.Label17 = new System.Windows.Forms.Label();
			this.lblRPUpdatesEnabled = new System.Windows.Forms.Label();
			this.Label21 = new System.Windows.Forms.Label();
			this.lblRPHistoricalPeriod = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.lblRPIntradayPeriod = new System.Windows.Forms.Label();
			this.Label13 = new System.Windows.Forms.Label();
			this.lblRPRangeEnd = new System.Windows.Forms.Label();
			this.Label12 = new System.Windows.Forms.Label();
			this.lblRPSessionFlags = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.lblRPRangeStart = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.lblRPSubExpressionAlias = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.PictureBox2 = new System.Windows.Forms.PictureBox();
			this.PictureBox3 = new System.Windows.Forms.PictureBox();
			this.GroupBox2 = new System.Windows.Forms.GroupBox();
			this.txtTagValue = new System.Windows.Forms.TextBox();
			this.txtTagName = new System.Windows.Forms.TextBox();
			this.Label14 = new System.Windows.Forms.Label();
			this.Label18 = new System.Windows.Forms.Label();
			this.GroupBox3 = new System.Windows.Forms.GroupBox();
			this.lblOEnd = new System.Windows.Forms.Label();
			this.Label16 = new System.Windows.Forms.Label();
			this.lblOStart = new System.Windows.Forms.Label();
			this.Label20 = new System.Windows.Forms.Label();
			this.GroupBox4 = new System.Windows.Forms.GroupBox();
			this.lvExpression = new System.Windows.Forms.ListView();
			this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.GroupBox5 = new System.Windows.Forms.GroupBox();
			this.lvShownExpression = new System.Windows.Forms.ListView();
			this.ColumnHeader13 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader14 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader15 = new System.Windows.Forms.ColumnHeader();
			this.btnShow = new System.Windows.Forms.Button();
			this.gbIndexInterval = new System.Windows.Forms.GroupBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.nudEnd = new System.Windows.Forms.NumericUpDown();
			this.Label2 = new System.Windows.Forms.Label();
			this.nudStart = new System.Windows.Forms.NumericUpDown();
			this.optTimeInterval = new System.Windows.Forms.RadioButton();
			this.optIndexInterval = new System.Windows.Forms.RadioButton();
			this.gbTimeInterval = new System.Windows.Forms.GroupBox();
			this.Label7 = new System.Windows.Forms.Label();
			this.dtpEndRange = new System.Windows.Forms.DateTimePicker();
			this.Label5 = new System.Windows.Forms.Label();
			this.dtpStartRange = new System.Windows.Forms.DateTimePicker();
			this.GroupBox6 = new System.Windows.Forms.GroupBox();
			this.lblError = new System.Windows.Forms.Label();
			this.lblRPRecalcPeriod = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.lblRPSubscriptionLevel = new System.Windows.Forms.Label();
			this.label30 = new System.Windows.Forms.Label();
			this.GroupBox1.SuspendLayout();
			this.GroupBox2.SuspendLayout();
			this.GroupBox3.SuspendLayout();
			this.GroupBox4.SuspendLayout();
			this.GroupBox5.SuspendLayout();
			this.gbIndexInterval.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nudEnd)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStart)).BeginInit();
			this.gbTimeInterval.SuspendLayout();
			this.GroupBox6.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblDataConnection
			// 
			this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
			this.lblDataConnection.Name = "lblDataConnection";
			this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
			this.lblDataConnection.TabIndex = 24;
			this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// PictureBox1
			// 
			this.PictureBox1.BackColor = System.Drawing.Color.Black;
			this.PictureBox1.Location = new System.Drawing.Point(0, 40);
			this.PictureBox1.Name = "PictureBox1";
			this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox1.TabIndex = 23;
			this.PictureBox1.TabStop = false;
			// 
			// llWeb
			// 
			this.llWeb.BackColor = System.Drawing.SystemColors.Control;
			this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
			this.llWeb.Location = new System.Drawing.Point(632, 8);
			this.llWeb.Name = "llWeb";
			this.llWeb.Size = new System.Drawing.Size(408, 16);
			this.llWeb.TabIndex = 25;
			this.llWeb.TabStop = true;
			this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
			this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmbExpression
			// 
			this.cmbExpression.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbExpression.Location = new System.Drawing.Point(24, 56);
			this.cmbExpression.Name = "cmbExpression";
			this.cmbExpression.Size = new System.Drawing.Size(448, 24);
			this.cmbExpression.TabIndex = 0;
			this.cmbExpression.SelectedIndexChanged += new System.EventHandler(this.cmbExpression_SelectedIndexChanged);
			// 
			// btnRequest
			// 
			this.btnRequest.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRequest.Location = new System.Drawing.Point(24, 88);
			this.btnRequest.Name = "btnRequest";
			this.btnRequest.Size = new System.Drawing.Size(96, 40);
			this.btnRequest.TabIndex = 1;
			this.btnRequest.Text = "Request";
			this.btnRequest.Click += new System.EventHandler(this.btnRequest_Click);
			// 
			// btnRemove
			// 
			this.btnRemove.Enabled = false;
			this.btnRemove.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemove.Location = new System.Drawing.Point(128, 88);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.Size = new System.Drawing.Size(96, 40);
			this.btnRemove.TabIndex = 2;
			this.btnRemove.Text = "Remove";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnRemoveAll
			// 
			this.btnRemoveAll.Enabled = false;
			this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemoveAll.Location = new System.Drawing.Point(232, 88);
			this.btnRemoveAll.Name = "btnRemoveAll";
			this.btnRemoveAll.Size = new System.Drawing.Size(96, 40);
			this.btnRemoveAll.TabIndex = 3;
			this.btnRemoveAll.Text = "Remove All";
			this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblStatus.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblStatus.Location = new System.Drawing.Point(8, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(120, 24);
			this.lblStatus.TabIndex = 31;
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.lblRPRecalcPeriod);
			this.GroupBox1.Controls.Add(this.label6);
			this.GroupBox1.Controls.Add(this.lblRPSubscriptionLevel);
			this.GroupBox1.Controls.Add(this.label30);
			this.GroupBox1.Controls.Add(this.cmbRPSubExpression);
			this.GroupBox1.Controls.Add(this.Label1);
			this.GroupBox1.Controls.Add(this.lblRPDaysBeforeExpiration);
			this.GroupBox1.Controls.Add(this.Label27);
			this.GroupBox1.Controls.Add(this.lblRPEqualizeCloses);
			this.GroupBox1.Controls.Add(this.Label29);
			this.GroupBox1.Controls.Add(this.lblRPContinuation);
			this.GroupBox1.Controls.Add(this.Label23);
			this.GroupBox1.Controls.Add(this.lblRPSessionsFilter);
			this.GroupBox1.Controls.Add(this.Label25);
			this.GroupBox1.Controls.Add(this.lblRPIncludeEnd);
			this.GroupBox1.Controls.Add(this.Label17);
			this.GroupBox1.Controls.Add(this.lblRPUpdatesEnabled);
			this.GroupBox1.Controls.Add(this.Label21);
			this.GroupBox1.Controls.Add(this.lblRPHistoricalPeriod);
			this.GroupBox1.Controls.Add(this.Label9);
			this.GroupBox1.Controls.Add(this.lblRPIntradayPeriod);
			this.GroupBox1.Controls.Add(this.Label13);
			this.GroupBox1.Controls.Add(this.lblRPRangeEnd);
			this.GroupBox1.Controls.Add(this.Label12);
			this.GroupBox1.Controls.Add(this.lblRPSessionFlags);
			this.GroupBox1.Controls.Add(this.Label10);
			this.GroupBox1.Controls.Add(this.lblRPRangeStart);
			this.GroupBox1.Controls.Add(this.Label8);
			this.GroupBox1.Controls.Add(this.lblRPSubExpressionAlias);
			this.GroupBox1.Controls.Add(this.Label4);
			this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox1.Location = new System.Drawing.Point(488, 48);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(576, 280);
			this.GroupBox1.TabIndex = 4;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Request Parameters";
			// 
			// cmbRPSubExpression
			// 
			this.cmbRPSubExpression.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbRPSubExpression.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbRPSubExpression.Location = new System.Drawing.Point(144, 24);
			this.cmbRPSubExpression.Name = "cmbRPSubExpression";
			this.cmbRPSubExpression.Size = new System.Drawing.Size(152, 24);
			this.cmbRPSubExpression.TabIndex = 0;
			this.cmbRPSubExpression.SelectedIndexChanged += new System.EventHandler(this.cmbRPSubExpression_SelectedIndexChanged);
			// 
			// Label1
			// 
			this.Label1.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label1.Location = new System.Drawing.Point(16, 24);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(120, 24);
			this.Label1.TabIndex = 58;
			this.Label1.Text = "Sub Expression :";
			this.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPDaysBeforeExpiration
			// 
			this.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPDaysBeforeExpiration.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPDaysBeforeExpiration.Location = new System.Drawing.Point(432, 184);
			this.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration";
			this.lblRPDaysBeforeExpiration.Size = new System.Drawing.Size(136, 24);
			this.lblRPDaysBeforeExpiration.TabIndex = 57;
			this.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label27
			// 
			this.Label27.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label27.Location = new System.Drawing.Point(296, 184);
			this.Label27.Name = "Label27";
			this.Label27.Size = new System.Drawing.Size(128, 24);
			this.Label27.TabIndex = 56;
			this.Label27.Text = "Days Before Exp. :";
			this.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPEqualizeCloses
			// 
			this.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPEqualizeCloses.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPEqualizeCloses.Location = new System.Drawing.Point(144, 184);
			this.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses";
			this.lblRPEqualizeCloses.Size = new System.Drawing.Size(152, 24);
			this.lblRPEqualizeCloses.TabIndex = 55;
			this.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label29
			// 
			this.Label29.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label29.Location = new System.Drawing.Point(16, 184);
			this.Label29.Name = "Label29";
			this.Label29.Size = new System.Drawing.Size(120, 24);
			this.Label29.TabIndex = 54;
			this.Label29.Text = "Equalize Closes :";
			this.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPContinuation
			// 
			this.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPContinuation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPContinuation.Location = new System.Drawing.Point(432, 152);
			this.lblRPContinuation.Name = "lblRPContinuation";
			this.lblRPContinuation.Size = new System.Drawing.Size(136, 24);
			this.lblRPContinuation.TabIndex = 53;
			this.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label23
			// 
			this.Label23.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label23.Location = new System.Drawing.Point(328, 152);
			this.Label23.Name = "Label23";
			this.Label23.Size = new System.Drawing.Size(96, 24);
			this.Label23.TabIndex = 52;
			this.Label23.Text = "Continuation :";
			this.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionsFilter
			// 
			this.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionsFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionsFilter.Location = new System.Drawing.Point(144, 248);
			this.lblRPSessionsFilter.Name = "lblRPSessionsFilter";
			this.lblRPSessionsFilter.Size = new System.Drawing.Size(424, 24);
			this.lblRPSessionsFilter.TabIndex = 51;
			this.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label25
			// 
			this.Label25.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label25.Location = new System.Drawing.Point(24, 248);
			this.Label25.Name = "Label25";
			this.Label25.Size = new System.Drawing.Size(112, 24);
			this.Label25.TabIndex = 50;
			this.Label25.Text = "Sessions Filter :";
			this.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIncludeEnd
			// 
			this.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIncludeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIncludeEnd.Location = new System.Drawing.Point(432, 120);
			this.lblRPIncludeEnd.Name = "lblRPIncludeEnd";
			this.lblRPIncludeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPIncludeEnd.TabIndex = 49;
			this.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label17
			// 
			this.Label17.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label17.Location = new System.Drawing.Point(328, 120);
			this.Label17.Name = "Label17";
			this.Label17.Size = new System.Drawing.Size(96, 24);
			this.Label17.TabIndex = 48;
			this.Label17.Text = "Include End :";
			this.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPUpdatesEnabled
			// 
			this.lblRPUpdatesEnabled.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPUpdatesEnabled.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPUpdatesEnabled.Location = new System.Drawing.Point(144, 120);
			this.lblRPUpdatesEnabled.Name = "lblRPUpdatesEnabled";
			this.lblRPUpdatesEnabled.Size = new System.Drawing.Size(152, 24);
			this.lblRPUpdatesEnabled.TabIndex = 47;
			this.lblRPUpdatesEnabled.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label21
			// 
			this.Label21.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label21.Location = new System.Drawing.Point(8, 120);
			this.Label21.Name = "Label21";
			this.Label21.Size = new System.Drawing.Size(124, 24);
			this.Label21.TabIndex = 46;
			this.Label21.Text = "Updates Enabled :";
			this.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPHistoricalPeriod
			// 
			this.lblRPHistoricalPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPHistoricalPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPHistoricalPeriod.Location = new System.Drawing.Point(432, 88);
			this.lblRPHistoricalPeriod.Name = "lblRPHistoricalPeriod";
			this.lblRPHistoricalPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPHistoricalPeriod.TabIndex = 45;
			this.lblRPHistoricalPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label9
			// 
			this.Label9.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label9.Location = new System.Drawing.Point(304, 88);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(120, 24);
			this.Label9.TabIndex = 44;
			this.Label9.Text = "Historical Period :";
			this.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIntradayPeriod
			// 
			this.lblRPIntradayPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIntradayPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIntradayPeriod.Location = new System.Drawing.Point(144, 88);
			this.lblRPIntradayPeriod.Name = "lblRPIntradayPeriod";
			this.lblRPIntradayPeriod.Size = new System.Drawing.Size(152, 24);
			this.lblRPIntradayPeriod.TabIndex = 43;
			this.lblRPIntradayPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label13
			// 
			this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label13.Location = new System.Drawing.Point(16, 88);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(120, 24);
			this.Label13.TabIndex = 42;
			this.Label13.Text = "Intraday Period :";
			this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeEnd
			// 
			this.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeEnd.Location = new System.Drawing.Point(432, 56);
			this.lblRPRangeEnd.Name = "lblRPRangeEnd";
			this.lblRPRangeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPRangeEnd.TabIndex = 41;
			this.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label12
			// 
			this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label12.Location = new System.Drawing.Point(336, 56);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(88, 24);
			this.Label12.TabIndex = 40;
			this.Label12.Text = "Range End :";
			this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionFlags
			// 
			this.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionFlags.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionFlags.Location = new System.Drawing.Point(144, 152);
			this.lblRPSessionFlags.Name = "lblRPSessionFlags";
			this.lblRPSessionFlags.Size = new System.Drawing.Size(152, 24);
			this.lblRPSessionFlags.TabIndex = 39;
			this.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label10
			// 
			this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label10.Location = new System.Drawing.Point(24, 152);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(112, 24);
			this.Label10.TabIndex = 38;
			this.Label10.Text = "Session Flags :";
			this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeStart
			// 
			this.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeStart.Location = new System.Drawing.Point(144, 56);
			this.lblRPRangeStart.Name = "lblRPRangeStart";
			this.lblRPRangeStart.Size = new System.Drawing.Size(152, 24);
			this.lblRPRangeStart.TabIndex = 37;
			this.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label8
			// 
			this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label8.Location = new System.Drawing.Point(16, 56);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(120, 24);
			this.Label8.TabIndex = 36;
			this.Label8.Text = "Range Start :";
			this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSubExpressionAlias
			// 
			this.lblRPSubExpressionAlias.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSubExpressionAlias.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSubExpressionAlias.Location = new System.Drawing.Point(432, 24);
			this.lblRPSubExpressionAlias.Name = "lblRPSubExpressionAlias";
			this.lblRPSubExpressionAlias.Size = new System.Drawing.Size(136, 24);
			this.lblRPSubExpressionAlias.TabIndex = 33;
			this.lblRPSubExpressionAlias.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label4
			// 
			this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label4.Location = new System.Drawing.Point(344, 24);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(80, 24);
			this.Label4.TabIndex = 32;
			this.Label4.Text = "Alias :";
			this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// PictureBox2
			// 
			this.PictureBox2.BackColor = System.Drawing.Color.Black;
			this.PictureBox2.Location = new System.Drawing.Point(-88, 336);
			this.PictureBox2.Name = "PictureBox2";
			this.PictureBox2.Size = new System.Drawing.Size(1272, 1);
			this.PictureBox2.TabIndex = 33;
			this.PictureBox2.TabStop = false;
			// 
			// PictureBox3
			// 
			this.PictureBox3.BackColor = System.Drawing.Color.Black;
			this.PictureBox3.Location = new System.Drawing.Point(-88, 416);
			this.PictureBox3.Name = "PictureBox3";
			this.PictureBox3.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox3.TabIndex = 34;
			this.PictureBox3.TabStop = false;
			// 
			// GroupBox2
			// 
			this.GroupBox2.Controls.Add(this.txtTagValue);
			this.GroupBox2.Controls.Add(this.txtTagName);
			this.GroupBox2.Controls.Add(this.Label14);
			this.GroupBox2.Controls.Add(this.Label18);
			this.GroupBox2.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox2.Location = new System.Drawing.Point(8, 344);
			this.GroupBox2.Name = "GroupBox2";
			this.GroupBox2.Size = new System.Drawing.Size(472, 59);
			this.GroupBox2.TabIndex = 5;
			this.GroupBox2.TabStop = false;
			this.GroupBox2.Text = "Tags";
			// 
			// txtTagValue
			// 
			this.txtTagValue.Location = new System.Drawing.Point(312, 24);
			this.txtTagValue.Name = "txtTagValue";
			this.txtTagValue.Size = new System.Drawing.Size(144, 25);
			this.txtTagValue.TabIndex = 1;
			this.txtTagValue.Text = "";
			this.txtTagValue.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagValue_KeyDown);
			// 
			// txtTagName
			// 
			this.txtTagName.Location = new System.Drawing.Point(72, 24);
			this.txtTagName.Name = "txtTagName";
			this.txtTagName.Size = new System.Drawing.Size(144, 25);
			this.txtTagName.TabIndex = 0;
			this.txtTagName.Text = "";
			this.txtTagName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagName_KeyDown);
			// 
			// Label14
			// 
			this.Label14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label14.Location = new System.Drawing.Point(248, 24);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(56, 24);
			this.Label14.TabIndex = 40;
			this.Label14.Text = "Value :";
			this.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label18
			// 
			this.Label18.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label18.Location = new System.Drawing.Point(8, 24);
			this.Label18.Name = "Label18";
			this.Label18.Size = new System.Drawing.Size(56, 24);
			this.Label18.TabIndex = 36;
			this.Label18.Text = "Name :";
			this.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox3
			// 
			this.GroupBox3.Controls.Add(this.lblOEnd);
			this.GroupBox3.Controls.Add(this.Label16);
			this.GroupBox3.Controls.Add(this.lblOStart);
			this.GroupBox3.Controls.Add(this.Label20);
			this.GroupBox3.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox3.Location = new System.Drawing.Point(488, 344);
			this.GroupBox3.Name = "GroupBox3";
			this.GroupBox3.Size = new System.Drawing.Size(576, 59);
			this.GroupBox3.TabIndex = 42;
			this.GroupBox3.TabStop = false;
			this.GroupBox3.Text = "Output Parameters";
			// 
			// lblOEnd
			// 
			this.lblOEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblOEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblOEnd.Location = new System.Drawing.Point(400, 24);
			this.lblOEnd.Name = "lblOEnd";
			this.lblOEnd.Size = new System.Drawing.Size(136, 24);
			this.lblOEnd.TabIndex = 41;
			this.lblOEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label16
			// 
			this.Label16.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label16.Location = new System.Drawing.Point(320, 24);
			this.Label16.Name = "Label16";
			this.Label16.Size = new System.Drawing.Size(72, 24);
			this.Label16.TabIndex = 40;
			this.Label16.Text = "End :";
			this.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblOStart
			// 
			this.lblOStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblOStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblOStart.Location = new System.Drawing.Point(136, 24);
			this.lblOStart.Name = "lblOStart";
			this.lblOStart.Size = new System.Drawing.Size(128, 24);
			this.lblOStart.TabIndex = 37;
			this.lblOStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label20
			// 
			this.Label20.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label20.Location = new System.Drawing.Point(56, 24);
			this.Label20.Name = "Label20";
			this.Label20.Size = new System.Drawing.Size(72, 24);
			this.Label20.TabIndex = 36;
			this.Label20.Text = "Start :";
			this.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox4
			// 
			this.GroupBox4.Controls.Add(this.lvExpression);
			this.GroupBox4.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox4.Location = new System.Drawing.Point(8, 424);
			this.GroupBox4.Name = "GroupBox4";
			this.GroupBox4.Size = new System.Drawing.Size(1056, 136);
			this.GroupBox4.TabIndex = 6;
			this.GroupBox4.TabStop = false;
			this.GroupBox4.Text = "Last 5 Resolved Expression";
			// 
			// lvExpression
			// 
			this.lvExpression.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                           this.ColumnHeader1,
                                                                                           this.ColumnHeader2,
                                                                                           this.ColumnHeader3});
			this.lvExpression.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvExpression.FullRowSelect = true;
			this.lvExpression.GridLines = true;
			this.lvExpression.Location = new System.Drawing.Point(8, 20);
			this.lvExpression.MultiSelect = false;
			this.lvExpression.Name = "lvExpression";
			this.lvExpression.Size = new System.Drawing.Size(1040, 108);
			this.lvExpression.TabIndex = 7;
			this.lvExpression.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader1
			// 
			this.ColumnHeader1.Text = "";
			this.ColumnHeader1.Width = 0;
			// 
			// ColumnHeader2
			// 
			this.ColumnHeader2.Text = "Index";
			this.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader2.Width = 49;
			// 
			// ColumnHeader3
			// 
			this.ColumnHeader3.Text = "Timestamp";
			this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader3.Width = 162;
			// 
			// GroupBox5
			// 
			this.GroupBox5.Controls.Add(this.lvShownExpression);
			this.GroupBox5.Controls.Add(this.btnShow);
			this.GroupBox5.Controls.Add(this.gbIndexInterval);
			this.GroupBox5.Controls.Add(this.optTimeInterval);
			this.GroupBox5.Controls.Add(this.optIndexInterval);
			this.GroupBox5.Controls.Add(this.gbTimeInterval);
			this.GroupBox5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox5.Location = new System.Drawing.Point(8, 560);
			this.GroupBox5.Name = "GroupBox5";
			this.GroupBox5.Size = new System.Drawing.Size(1056, 216);
			this.GroupBox5.TabIndex = 7;
			this.GroupBox5.TabStop = false;
			this.GroupBox5.Text = "Expression Filtered by Index or Time Interval";
			// 
			// lvShownExpression
			// 
			this.lvShownExpression.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                                this.ColumnHeader13,
                                                                                                this.ColumnHeader14,
                                                                                                this.ColumnHeader15});
			this.lvShownExpression.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvShownExpression.FullRowSelect = true;
			this.lvShownExpression.GridLines = true;
			this.lvShownExpression.Location = new System.Drawing.Point(8, 80);
			this.lvShownExpression.MultiSelect = false;
			this.lvShownExpression.Name = "lvShownExpression";
			this.lvShownExpression.Size = new System.Drawing.Size(1040, 128);
			this.lvShownExpression.TabIndex = 6;
			this.lvShownExpression.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader13
			// 
			this.ColumnHeader13.Text = "";
			this.ColumnHeader13.Width = 0;
			// 
			// ColumnHeader14
			// 
			this.ColumnHeader14.Text = "Index";
			this.ColumnHeader14.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader14.Width = 49;
			// 
			// ColumnHeader15
			// 
			this.ColumnHeader15.Text = "Timestamp";
			this.ColumnHeader15.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader15.Width = 162;
			// 
			// btnShow
			// 
			this.btnShow.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnShow.Location = new System.Drawing.Point(760, 48);
			this.btnShow.Name = "btnShow";
			this.btnShow.Size = new System.Drawing.Size(96, 24);
			this.btnShow.TabIndex = 4;
			this.btnShow.Text = "Show";
			this.btnShow.Click += new System.EventHandler(this.btnShow_Click);
			// 
			// gbIndexInterval
			// 
			this.gbIndexInterval.Controls.Add(this.Label3);
			this.gbIndexInterval.Controls.Add(this.nudEnd);
			this.gbIndexInterval.Controls.Add(this.Label2);
			this.gbIndexInterval.Controls.Add(this.nudStart);
			this.gbIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbIndexInterval.Location = new System.Drawing.Point(352, 16);
			this.gbIndexInterval.Name = "gbIndexInterval";
			this.gbIndexInterval.Size = new System.Drawing.Size(400, 56);
			this.gbIndexInterval.TabIndex = 3;
			this.gbIndexInterval.TabStop = false;
			this.gbIndexInterval.Text = "Index Interval";
			// 
			// Label3
			// 
			this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label3.Location = new System.Drawing.Point(200, 24);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(48, 24);
			this.Label3.TabIndex = 74;
			this.Label3.Text = "End: ";
			this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudEnd
			// 
			this.nudEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudEnd.Location = new System.Drawing.Point(256, 24);
			this.nudEnd.Maximum = new System.Decimal(new int[] {
                                                                   10000000,
                                                                   0,
                                                                   0,
                                                                   0});
			this.nudEnd.Minimum = new System.Decimal(new int[] {
                                                                   1,
                                                                   0,
                                                                   0,
                                                                   0});
			this.nudEnd.Name = "nudEnd";
			this.nudEnd.Size = new System.Drawing.Size(128, 22);
			this.nudEnd.TabIndex = 1;
			this.nudEnd.Value = new System.Decimal(new int[] {
                                                                 1,
                                                                 0,
                                                                 0,
                                                                 0});
			// 
			// Label2
			// 
			this.Label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label2.Location = new System.Drawing.Point(8, 24);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(48, 24);
			this.Label2.TabIndex = 70;
			this.Label2.Text = "Start: ";
			this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudStart
			// 
			this.nudStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudStart.Location = new System.Drawing.Point(64, 24);
			this.nudStart.Maximum = new System.Decimal(new int[] {
                                                                     10000000,
                                                                     0,
                                                                     0,
                                                                     0});
			this.nudStart.Minimum = new System.Decimal(new int[] {
                                                                     1,
                                                                     0,
                                                                     0,
                                                                     0});
			this.nudStart.Name = "nudStart";
			this.nudStart.Size = new System.Drawing.Size(128, 22);
			this.nudStart.TabIndex = 0;
			this.nudStart.Value = new System.Decimal(new int[] {
                                                                   1,
                                                                   0,
                                                                   0,
                                                                   0});
			// 
			// optTimeInterval
			// 
			this.optTimeInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.optTimeInterval.Location = new System.Drawing.Point(192, 48);
			this.optTimeInterval.Name = "optTimeInterval";
			this.optTimeInterval.Size = new System.Drawing.Size(160, 24);
			this.optTimeInterval.TabIndex = 1;
			this.optTimeInterval.TabStop = true;
			this.optTimeInterval.Text = "Show by Time Interval";
			this.optTimeInterval.CheckedChanged += new System.EventHandler(this.optIndexOrTimeInterval_CheckedChanged);
			// 
			// optIndexInterval
			// 
			this.optIndexInterval.Checked = true;
			this.optIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.optIndexInterval.Location = new System.Drawing.Point(192, 24);
			this.optIndexInterval.Name = "optIndexInterval";
			this.optIndexInterval.Size = new System.Drawing.Size(160, 24);
			this.optIndexInterval.TabIndex = 0;
			this.optIndexInterval.TabStop = true;
			this.optIndexInterval.Text = "Show by Index Interval";
			this.optIndexInterval.CheckedChanged += new System.EventHandler(this.optIndexOrTimeInterval_CheckedChanged);
			// 
			// gbTimeInterval
			// 
			this.gbTimeInterval.Controls.Add(this.Label7);
			this.gbTimeInterval.Controls.Add(this.dtpEndRange);
			this.gbTimeInterval.Controls.Add(this.Label5);
			this.gbTimeInterval.Controls.Add(this.dtpStartRange);
			this.gbTimeInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbTimeInterval.Location = new System.Drawing.Point(352, 16);
			this.gbTimeInterval.Name = "gbTimeInterval";
			this.gbTimeInterval.Size = new System.Drawing.Size(400, 56);
			this.gbTimeInterval.TabIndex = 2;
			this.gbTimeInterval.TabStop = false;
			this.gbTimeInterval.Text = "Time Interval";
			// 
			// Label7
			// 
			this.Label7.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label7.Location = new System.Drawing.Point(200, 24);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(48, 24);
			this.Label7.TabIndex = 73;
			this.Label7.Text = "End: ";
			this.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dtpEndRange
			// 
			this.dtpEndRange.CustomFormat = "dd/MM/yyyy HH:mm";
			this.dtpEndRange.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.dtpEndRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpEndRange.Location = new System.Drawing.Point(256, 24);
			this.dtpEndRange.Name = "dtpEndRange";
			this.dtpEndRange.Size = new System.Drawing.Size(128, 22);
			this.dtpEndRange.TabIndex = 1;
			// 
			// Label5
			// 
			this.Label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label5.Location = new System.Drawing.Point(8, 24);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(48, 24);
			this.Label5.TabIndex = 71;
			this.Label5.Text = "Start: ";
			this.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dtpStartRange
			// 
			this.dtpStartRange.CustomFormat = "dd/MM/yyyy HH:mm";
			this.dtpStartRange.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.dtpStartRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpStartRange.Location = new System.Drawing.Point(64, 24);
			this.dtpStartRange.Name = "dtpStartRange";
			this.dtpStartRange.Size = new System.Drawing.Size(128, 22);
			this.dtpStartRange.TabIndex = 0;
			// 
			// GroupBox6
			// 
			this.GroupBox6.Controls.Add(this.lblStatus);
			this.GroupBox6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.GroupBox6.Location = new System.Drawing.Point(336, 80);
			this.GroupBox6.Name = "GroupBox6";
			this.GroupBox6.Size = new System.Drawing.Size(136, 48);
			this.GroupBox6.TabIndex = 45;
			this.GroupBox6.TabStop = false;
			this.GroupBox6.Text = "Status";
			// 
			// lblError
			// 
			this.lblError.ForeColor = System.Drawing.Color.Red;
			this.lblError.Location = new System.Drawing.Point(24, 136);
			this.lblError.Name = "lblError";
			this.lblError.Size = new System.Drawing.Size(448, 160);
			this.lblError.TabIndex = 46;
			// 
			// lblRPRecalcPeriod
			// 
			this.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRecalcPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRecalcPeriod.Location = new System.Drawing.Point(432, 216);
			this.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod";
			this.lblRPRecalcPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPRecalcPeriod.TabIndex = 76;
			this.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label6.Location = new System.Drawing.Point(320, 216);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(104, 24);
			this.label6.TabIndex = 75;
			this.label6.Text = "Recalc Period :";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSubscriptionLevel
			// 
			this.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSubscriptionLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSubscriptionLevel.Location = new System.Drawing.Point(144, 216);
			this.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel";
			this.lblRPSubscriptionLevel.Size = new System.Drawing.Size(152, 24);
			this.lblRPSubscriptionLevel.TabIndex = 74;
			this.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label30
			// 
			this.label30.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label30.Location = new System.Drawing.Point(8, 216);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(136, 24);
			this.label30.TabIndex = 73;
			this.label30.Text = "Subscription Level :";
			this.label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// frmExpression
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(1070, 779);
			this.Controls.Add(this.lblError);
			this.Controls.Add(this.GroupBox6);
			this.Controls.Add(this.GroupBox5);
			this.Controls.Add(this.GroupBox4);
			this.Controls.Add(this.GroupBox2);
			this.Controls.Add(this.PictureBox3);
			this.Controls.Add(this.PictureBox2);
			this.Controls.Add(this.GroupBox1);
			this.Controls.Add(this.btnRemoveAll);
			this.Controls.Add(this.btnRemove);
			this.Controls.Add(this.btnRequest);
			this.Controls.Add(this.cmbExpression);
			this.Controls.Add(this.lblDataConnection);
			this.Controls.Add(this.PictureBox1);
			this.Controls.Add(this.llWeb);
			this.Controls.Add(this.GroupBox3);
			this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmExpression";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Expression";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmExpression_Closing);
			this.Load += new System.EventHandler(this.frmExpression_Load);
			this.GroupBox1.ResumeLayout(false);
			this.GroupBox2.ResumeLayout(false);
			this.GroupBox3.ResumeLayout(false);
			this.GroupBox4.ResumeLayout(false);
			this.GroupBox5.ResumeLayout(false);
			this.gbIndexInterval.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nudEnd)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStart)).EndInit();
			this.gbTimeInterval.ResumeLayout(false);
			this.GroupBox6.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// Creates a CEL object, changes its configurations, and starts up the created CEL object.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void frmExpression_Load(object sender, System.EventArgs e)
		{
			try
			{
				// Creates the CQGCEL object
				CEL = new CQGCEL();
				CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
				CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
				CEL.ExpressionResolved += new CQG._ICQGCELEvents_ExpressionResolvedEventHandler(CEL_ExpressionResolved);
				CEL.ExpressionAdded += new CQG._ICQGCELEvents_ExpressionAddedEventHandler(CEL_ExpressionAdded);
				CEL.ExpressionUpdated += new CQG._ICQGCELEvents_ExpressionUpdatedEventHandler(CEL_ExpressionUpdated);
				CEL.ExpressionInserted += new CQG._ICQGCELEvents_ExpressionInsertedEventHandler(CEL_ExpressionInserted);
				CEL.ExpressionRemoved += new CQG._ICQGCELEvents_ExpressionRemovedEventHandler(CEL_ExpressionRemoved);
				CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
				CEL.APIConfiguration.CollectionsThrowException = false;
				CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;

				// Disables the controls
				CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
				// Starts up the CQGCEL
				CEL.Startup();

				cmbExpression.Items.Clear();
				cmbExpression.SelectedIndex = -1;

				ClearAllData();

				m_CurExpression = null;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "frmExpression_Load", ex);
				this.Close();
			}
		}

		/// <summary>
		/// Shuts down CEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A CancelEventArgs that contains the event data.
		/// </param>
		private void frmExpression_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (CEL != null)
			{
				CEL.Shutdown();
			}
		}

		/// <summary>
		/// Opens frmExpressionRequestSettings and with passed values requests Expression.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRequest_Click(object sender, System.EventArgs e)
		{
			frmExpressionRequestSettings frmExpressionReq;
			CQGExpression expression;
			CQGExpressionRequest req;

			try
			{
				// Opens the form to fill up request data
				frmExpressionReq = new frmExpressionRequestSettings();
				req = CEL.CreateExpressionRequest();
				req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".
				frmExpressionReq.ExpressionRequest = req;
				frmExpressionReq.LineTime = CEL.Environment.LineTime;

				// If the user confirms, request is sent to CQGCEL and added to the requests list
				if (frmExpressionReq.ShowDialog(this) == DialogResult.OK)
				{
					expression = CEL.RequestExpression(req);

					cmbExpression.Items.Add(expression.Id);
					cmbExpression.SelectedIndex = cmbExpression.Items.Count - 1;

					ChangeControlsStatuses();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "btnRequest_Click", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Expression info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbExpression_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				if (cmbExpression.SelectedIndex > -1)
				{
					// Gets the selected Expression object from CQGCEL by it's ID
					m_CurExpression = CEL.AllExpressions.get_ItemById(cmbExpression.Text);

					ClearAllData();
					DumpAllData();

					DumpFilterInfo();
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "cmbExpression_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Occurs when the another sub-expression item is selected in the combo.
		/// Updates selected sub-expression alias on the sheet.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbRPSubExpression_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//			string expressionAlias;

			try
			{
				if (cmbRPSubExpression.SelectedIndex == -1)
				{
					lblRPSubExpressionAlias.Text = "";
				}
				else
				{
					lblRPSubExpressionAlias.Text = m_CurExpression.Request.get_SubExpressionAlias(cmbRPSubExpression.SelectedIndex);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "cmbRPSubExpression_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes the visibility of groupboxes.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void optIndexOrTimeInterval_CheckedChanged(object sender, System.EventArgs e)
		{
			try
			{
				gbIndexInterval.Visible = optIndexInterval.Checked;
				gbTimeInterval.Visible = optTimeInterval.Checked;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "optIndexOrTimeInterval_CheckedChanged", ex);
			}
		}

		/// <summary>
		/// Shows few data from the selected Expression collection.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnShow_Click(object sender, System.EventArgs e)
		{
			int indexStart = 0;
			int indexEnd = 0;
			DateTime dateStart;
			DateTime dateEnd;

			try
			{
				lvShownExpression.Items.Clear();

				if (optIndexInterval.Checked)
				{
					indexStart = System.Convert.ToInt32(nudStart.Value) - 1;
					indexEnd = System.Convert.ToInt32(nudEnd.Value) - 1;
					if (indexStart > indexEnd || indexEnd > m_CurExpression.Count - 1 || indexEnd - indexStart >= MAX_INDEX_INTERVAL)
					{
						MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " records," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						return;
					}
				}
				else
				{
					// To get time with 00 seconds
					dateStart = dtpStartRange.Value.AddSeconds(-dtpStartRange.Value.Second);
					dateEnd = dtpEndRange.Value.AddSeconds(-dtpEndRange.Value.Second);
					if (!CheckDateInterval(dateStart, dateEnd, ref indexStart, ref indexEnd))
					{
						MessageBox.Show("The start time must be earlier than the end time." + Environment.NewLine + "The range must indicate to no more than " + MAX_INDEX_INTERVAL + " records." + Environment.NewLine + "The start time and end time must belong to the available records.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						return;
					}
				}

				lvShownExpression.SuspendLayout();
				for (int i = indexEnd; i >= indexStart; i--)
				{
					DumpRecord(lvShownExpression, m_CurExpression[i], i + 1);
				}
				lvShownExpression.ResumeLayout(false);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "btnShow_Click", ex);
			}
		}

		/// <summary>
		/// Removes the selected Expression from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemove_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Removes Expression from the collection
				CEL.RemoveExpression(m_CurExpression);

				// Removes Expression from the combo box
				cmbExpression.Items.RemoveAt(cmbExpression.SelectedIndex);

				cmbExpression.SelectedIndex = cmbExpression.Items.Count - 1;

				if (cmbExpression.Items.Count == 0)
				{
					cmbExpression.SelectedIndex = -1;
					ClearAllData();
					m_CurExpression = null;
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "btnRemove_Click", ex);
			}
		}

		/// <summary>
		/// Removes all Expression from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemoveAll_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Clears the combo box
				cmbExpression.Items.Clear();
				cmbExpression.SelectedIndex = -1;

				// Removes all Expression from the collection
				CEL.RemoveAllExpressions();

				m_CurExpression = null;

				ClearAllData();

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "btnRemoveAll_Click", ex);
			}
		}

		/// <summary>
		/// Shows tag value of the current Expression corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagName_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					object tagValue = m_CurExpression.get_Tag(txtTagName.Text);
					if (tagValue != null)
					{
						txtTagValue.Text = tagValue.ToString();
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "txtTagName_KeyDown", ex);
			}
		}

		/// <summary>
		/// Sets the tag value of the current Expression corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagValue_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					if (txtTagValue.Text.Trim().Length == 0)
					{
						m_CurExpression.set_Tag(txtTagName.Text, null);
					}
					else
					{
						m_CurExpression.set_Tag(txtTagName.Text, txtTagValue.Text);
					}
					txtTagName.Text = "";
					txtTagValue.Text = "";
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "txtTagValue_KeyDown", ex);
			}
		}

		/// <summary>
		/// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
		/// </summary>
		/// <param name="cqg_error">
		/// The object, in which the error has occurred.
		/// </param>
		/// <param name="error_description">
		/// The string, describing the error.
		/// </param>
		private void CEL_DataError(object cqg_error, string error_description)
		{
			try
			{
				CQGError cqgErr = cqg_error as CQGError;
				if (CEL.IsValid(cqg_error))
				{
					if (cqgErr.Code == 102)
					{
						error_description += " Restart the application.";
					}
					else if (cqgErr.Code == 125)
					{
						error_description += " Turn on CQG Client and restart the application.";
					}
				}

				MessageBox.Show(error_description, "Expression", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_DataError", ex);
			}
		}

		/// <summary>
		/// This event is fired, when some changes occur in the connection with CQG data server.
		/// </summary>
		/// <param name="newStatus">
		/// The current status of the connection with the data server.
		/// </param>
		private void CEL_DataConnectionStatusChanged(CQG.eConnectionStatus new_status)
		{
			string sInfo;
			System.Drawing.Color BackCol;

			try
			{
				if (new_status == eConnectionStatus.csConnectionUp)
				{
					BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
					sInfo = "DATA Connection is UP";
				}
				else if (new_status == eConnectionStatus.csConnectionDelayed)
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Delayed";
				}
				else
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Down";
				}

				lblDataConnection.BackColor = BackCol;
				lblDataConnection.Text = sInfo;

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_DataConnectionStatusChanged", ex);
			}
		}

		/// <summary>
		/// This event is fired when the expression (CQGExpression) is resolved or
		/// when some error has occurred during the expression request processing.
		/// </summary>
		/// <param name="cqg_expression">
		/// Reference to resolved CQGExpression
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object describing the last error occurred during the expression
		/// request processing or Nothing/Invalid_Error in case of no error.
		/// CQGCEL.IsValid(Invalid_Error) returns False.
		/// </param>
		private void CEL_ExpressionResolved(CQG.CQGExpression cqg_expression, CQG.CQGError cqg_error)
		{
			try
			{
				if (cqg_expression.Id == m_CurExpression.Id)
				{
					ClearAllData();
					DumpAllData();
					DumpFilterInfo();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_ExpressionResolved", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGExpressionOutputs item is added to the end of CQGExpression.
		/// </summary>
		/// <param name="cqg_expression">
		/// Reference to changed CQGExpression.
		/// </param>
		private void CEL_ExpressionAdded(CQG.CQGExpression cqg_expression)
		{
			try
			{
				if (cqg_expression.Id == m_CurExpression.Id)
				{
					ShowChagedData(cqg_expression.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_ExpressionAdded", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGExpressionOutputs item is inserted into CQGExpression.
		/// </summary>
		/// <param name="cqg_expression">
		/// Reference to changed CQGExpression.
		/// </param>
		/// <param name="index_">
		/// Specifies the changed CQGExprssionOutputs index.
		/// </param>
		private void CEL_ExpressionInserted(CQG.CQGExpression cqg_expression, int index_)
		{
			try
			{
				if (cqg_expression.Id == m_CurExpression.Id)
				{
					ShowChagedData(cqg_expression.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_ExpressionInserted", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGExpressionOutputs item is removed from CQGExpression.
		/// </summary>
		/// <param name="cqg_expression">
		/// Reference to changed CQGExpression.
		/// </param>
		/// <param name="index_">
		/// Specifies the changed CQGExprssionOutputs index.
		/// </param>
		private void CEL_ExpressionRemoved(CQG.CQGExpression cqg_expression, int index_)
		{
			try
			{
				if (cqg_expression.Id == m_CurExpression.Id)
				{
					ShowChagedData(cqg_expression.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_ExpressionRemoved", ex);
			}
		}

		/// <summary>
		/// Fired when a CQGExpressionOutputs item is updated.
		/// </summary>
		/// <param name="cqg_expression">
		/// Reference to changed CQGExpression
		/// </param>
		/// <param name="index_">
		/// Specifies the updated CQGExpressionOutputs index.
		/// </param>
		private void CEL_ExpressionUpdated(CQG.CQGExpression cqg_expression, int index_)
		{
			try
			{
				if (cqg_expression.Id == m_CurExpression.Id)
				{
					if (index_ > m_CurExpression.Count - MAX_NUMBER_OF_RECORDS)
					{
						UpdateRecord(lvExpression, m_CurExpression[index_], index_ + 1);
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "CEL_ExpressionUpdated", ex);
			}
		}

		/// <summary>
		/// Shows the selected request parameters on the listview.
		/// </summary>
		private void DumpRequestParams()
		{
			int i;

			try
			{
				CQGExpressionRequest req = m_CurExpression.Request;

				// Adding sub-expressions to the corresponding combo list
				cmbRPSubExpression.Items.Clear();
				cmbRPSubExpression.SelectedIndex = -1;

				for (i = 0; i <= req.SubExpressionCount - 1; i++)
				{
					cmbRPSubExpression.Items.Add(req.get_SubExpression(i));
				}
				if (cmbRPSubExpression.Items.Count > 0)
				{
					cmbRPSubExpression.SelectedIndex = 0;
				}
				lblRPRangeStart.Text = GetValueAsString(req.RangeStart);
				lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd);
				lblRPIntradayPeriod.Text = req.IntradayPeriod.ToString();
				lblRPHistoricalPeriod.Text = req.HistoricalPeriod.ToString();
				lblRPUpdatesEnabled.Text = req.UpdatesEnabled.ToString();
				lblRPIncludeEnd.Text = req.IncludeEnd.ToString();

				var sessionFilter = req.SessionsFilter.ToString();
				switch (sessionFilter)
				{
					case "0": sessionFilter = "Primary session only (0)"; break;
					case "31": sessionFilter = "All sessions (31)"; break;
				}
				lblRPSessionsFilter.Text = sessionFilter;
				lblRPContinuation.Text = req.Continuation.ToString();
				lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString();
				lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString();
				lblRPSessionFlags.Text = req.SessionFlags.ToString();
				lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString();
				if (req.SubscriptionLevel == eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod)
				{
					lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString();
				}

				if (m_CurExpression.LastError != null)
				{
					lblError.Text = m_CurExpression.LastError.Description;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpRequestParams", ex);
			}
		}

		/// <summary>
		/// Shows the selected request outputs on the listview after changes.
		/// </summary>
		/// <param>
		/// Count of Expression that will be shown.
		/// </param>
		private void ShowChagedData(int count)
		{
			ClearOutputParams();
			DumpOutputParams();

			DumpRecords(count);
		}

		/// <summary>
		/// Shows the selected request outputs on the listview.
		/// </summary>
		private void DumpOutputParams()
		{
			try
			{
				lblOStart.Text = GetValueAsString(m_CurExpression.StartTimestamp);
				lblOEnd.Text = GetValueAsString(m_CurExpression.EndTimestamp);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpOutputParams", ex);
			}
		}

		/// <summary>
		/// Shows added Expression for the selected request records on the listview.
		/// </summary>
		/// <param name="addedExpressionCount">
		/// Count of Expression that will be shown.
		/// </param>
		private void DumpRecords(int addedExpressionCount)
		{
			try
			{
				// Clears all records
				ClearRecords();

				// Clears headers
				ClearHeaders(lvExpression);

				// Clears headers of filter listview
				ClearHeaders(lvShownExpression);

				// Dumps headers
				DumpHeaders(lvExpression);

				// Dumps headers of filter listview
				DumpHeaders(lvShownExpression);

				if (m_CurExpression.Count == 0)
				{
					return;
				}

				if (addedExpressionCount == m_CurExpression.Count)
				{
					addedExpressionCount = System.Convert.ToInt32(addedExpressionCount >= MAX_NUMBER_OF_RECORDS ? MAX_NUMBER_OF_RECORDS : m_CurExpression.Count);
				}
				for (int i = m_CurExpression.Count - 1; i >= m_CurExpression.Count - addedExpressionCount; i--)
				{
					DumpRecord(lvExpression, m_CurExpression[i], i + 1);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpRecords", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="expressionOutputs">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void DumpRecord(ListView lv, CQGExpressionOutputs expressionOutputs, long recordIndex)
		{
			try
			{
				ListViewItem item = lv.Items.Add(new ListViewItem());
				item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString();
				item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(expressionOutputs.Timestamp, true);
				for (int i = 0; i <= expressionOutputs.Count - 1; i++)
				{
					item.SubItems.Add(m_CurExpression.OutputHeaders[i]).Text = GetValueAsString(expressionOutputs[i]);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpRecord", ex);
			}
		}

		/// <summary>
		/// Updates one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="expressionOutputs">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be updated.
		/// </param>
		private void UpdateRecord(ListView lv, CQGExpressionOutputs expressionOutputs, int recordIndex)
		{
			try
			{
				ListViewItem item = new ListViewItem();
				item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString();
				item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(expressionOutputs.Timestamp, true);
				for (int i = 0; i <= expressionOutputs.Count - 1; i++)
				{
					item.SubItems.Add(m_CurExpression.OutputHeaders[i]).Text = GetValueAsString(expressionOutputs[i]);
				}

				lv.Items[m_CurExpression.Count - recordIndex] = item;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "UpdateRecord", ex);
			}
		}

		/// <summary>
		/// Dumps all request data (outputs\parameters\records)
		/// </summary>
		private void DumpAllData()
		{
			try
			{
				DumpRequestParams();

				lblStatus.Text = m_CurExpression.Status.ToString();

				if (m_CurExpression.Status == eRequestStatus.rsSuccess)
				{
					DumpOutputParams();
					DumpRecords(m_CurExpression.Count);
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpAllData", ex);
			}
		}

		/// <summary>
		/// Initializes the filter-related controls.
		/// </summary>
		private void DumpFilterInfo()
		{
			try
			{
				if (m_CurExpression != null && m_CurExpression.Status == eRequestStatus.rsSuccess)
				{
					dtpStartRange.Value = m_CurExpression.StartTimestamp;
					dtpEndRange.Value = m_CurExpression.EndTimestamp;
				}
				else
				{
					dtpStartRange.Value = DateTime.Now;
					dtpEndRange.Value = DateTime.Now;
				}
				nudStart.Value = 1;
				nudEnd.Value = 1;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpFilterInfo", ex);
			}
		}

		/// <summary>
		/// Clears all request data.
		/// </summary>
		private void ClearAllData()
		{
			try
			{
				lblStatus.Text = "";

				ClearRequestParams();
				ClearOutputParams();
				ClearTags();
				ClearHeaders(lvExpression);
				ClearHeaders(lvShownExpression);
				ClearRecords();

				lvShownExpression.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearAllData", ex);
			}
		}

		/// <summary>
		/// Clears the request parameters from the listview.
		/// </summary>
		private void ClearRequestParams()
		{
			try
			{
				cmbRPSubExpression.Items.Clear();
				cmbRPSubExpression.SelectedIndex = -1;

				lblRPSubExpressionAlias.Text = "";
				lblRPRangeStart.Text = "";
				lblRPRangeEnd.Text = "";
				lblRPIntradayPeriod.Text = "";
				lblRPHistoricalPeriod.Text = "";
				lblRPUpdatesEnabled.Text = "";
				lblRPIncludeEnd.Text = "";
				lblRPSessionsFilter.Text = "";
				lblRPContinuation.Text = "";
				lblRPEqualizeCloses.Text = "";
				lblRPDaysBeforeExpiration.Text = "";
				lblRPSessionFlags.Text = "";
				lblRPSubscriptionLevel.Text = "";
				lblRPRecalcPeriod.Text = "";

				lblError.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearRequestParams", ex);
			}
		}

		/// <summary>
		/// Clears request outputs from the listview.
		/// </summary>
		private void ClearOutputParams()
		{
			try
			{
				lblOStart.Text = "";
				lblOEnd.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearOutputParams", ex);
			}
		}

		/// <summary>
		/// Clears request tags.
		/// </summary>
		private void ClearTags()
		{
			try
			{
				txtTagName.Text = "";
				txtTagValue.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearTags", ex);
			}
		}

		/// <summary>
		/// Clears request headers from the listview.
		/// </summary>
		private void ClearRecords()
		{
			try
			{
				lvExpression.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearRecords", ex);
			}
		}

		/// <summary>
		/// Clears records from the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be cleared.
		/// </param>
		private void ClearHeaders(ListView lv)
		{
			try
			{
				lv.Columns.Clear();
				lv.Columns.Add("ID", 0, HorizontalAlignment.Center);
				lv.Columns.Add(INDEX_HEADER, 49, HorizontalAlignment.Center);
				lv.Columns.Add(TIMESTAMP_HEADER, 162, HorizontalAlignment.Center);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ClearHeaders", ex);
			}
		}

		/// <summary>
		/// Shows selected request output headers in listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be dumped.
		/// </param>
		private void DumpHeaders(ListView lv)
		{
			try
			{
				for (int i = 0; i <= m_CurExpression.OutputHeaders.Count - 1; i++)
				{
					lv.Columns.Add(m_CurExpression.OutputHeaders[i], 60, HorizontalAlignment.Center);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "DumpHeaders", ex);
			}
		}

		/// <summary>
		/// Enables\disables the controls, based on the connection status.
		/// </summary>
		private void ChangeControlsStatuses()
		{
			bool bIsDataConnectionUp = false;
			bool bIsExpressionSelected;
			bool bIsExpressionSucceded = false;

			try
			{
				if (CEL.IsStarted)
				{
					bIsDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
				}

				btnRequest.Enabled = bIsDataConnectionUp;

				bIsExpressionSelected = m_CurExpression != null;

				btnRemove.Enabled = bIsExpressionSelected && bIsDataConnectionUp;
				btnRemoveAll.Enabled = bIsExpressionSelected && bIsDataConnectionUp;

				txtTagName.Enabled = bIsExpressionSelected;
				txtTagValue.Enabled = bIsExpressionSelected;

				if (bIsExpressionSelected)
				{
					bIsExpressionSucceded = m_CurExpression.Status == eRequestStatus.rsSuccess;
				}

				dtpEndRange.Enabled = bIsExpressionSucceded;
				dtpStartRange.Enabled = bIsExpressionSucceded;

				nudEnd.Enabled = bIsExpressionSucceded;
				nudStart.Enabled = bIsExpressionSucceded;

				optIndexInterval.Enabled = bIsExpressionSucceded;
				optTimeInterval.Enabled = bIsExpressionSucceded;

				btnShow.Enabled = bIsExpressionSucceded;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmExpression", "ChangeControlsStatuses", ex);
			}
		}

		/// <summary>
		/// Validates the specified value and converts it to string.
		/// </summary>
		/// <param name="val">
		/// The value that will be validated and converted
		/// </param>
		/// <param name="includeMilliseconds">
		/// Whether to include seconds and milliseconds to string, valid only for DateTime
		/// </param>
		/// <returns>
		/// Value converted to string or "N/A" if the value is invalid.
		/// </returns>
		private string GetValueAsString(object val, bool includeMilliseconds = false)
		{
			string sResult = "";

			try
			{
				if (CEL.IsValid(val))
				{
					if (val.GetType().FullName == "System.DateTime")
					{
						string format = includeMilliseconds ? "dd/MM/yyyy HH:mm:ss.fff" : "dd/MM/yyyy HH:mm";
						sResult = System.Convert.ToDateTime(val).ToString(format);
					}
					else
					{
						sResult = val.ToString();
					}
				}
				else
				{
					sResult = N_A;
				}
			}
			catch
			{
				sResult = N_A;
			}

			return sResult;
		}

		/// <summary>
		/// Checks if the given time interval is correct for current time bar.
		/// </summary>
		/// <param name="dStart">
		/// The start date which is passed to function.
		/// </param>
		/// <param name="dEnd">
		/// The end date which is passed to function.
		/// </param>
		/// <param name="iStart">
		/// Returns start index in case of correct range.
		/// </param>
		/// <param name="iEnd">
		/// Returns end index in case of correct range.
		/// </param>
		/// <returns>
		/// Returns true if the interval is correct and iStart/iEnd can be used.
		/// </returns>
		private bool CheckDateInterval(DateTime dateStart, DateTime dateEnd, ref int indexStart, ref int indexEnd)
		{

			bool bResult = true;

			indexStart = m_CurExpression.IndexForDate(dateStart);
			indexEnd = m_CurExpression.IndexForDate(dateEnd);
			if (dateStart > dateEnd || !(CEL.IsValid(indexStart) && CEL.IsValid(indexEnd)))
			{
				bResult = false;
			}
			else
			{
				if (indexEnd - indexStart >= MAX_INDEX_INTERVAL)
				{
					bResult = true;
				}
			}

			return bResult;
		}

	}

}
