using System.Diagnostics;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;
using System.Runtime.InteropServices;


namespace InstrumentProperties
{
   public class frmInstrumentProperties : System.Windows.Forms.Form
   {

      [STAThread]
      static void Main()
      {
         Application.Run(new frmInstrumentProperties());
      }

      private const string N_A = "N/A";

      private CQGCEL m_CEL;

      /// Grids for dumping properties/sessions/quotes/DOM values
      private CQGMiniGrid m_PropertiesGrid;
      private CQGMiniGrid m_QuotesGrid;
      private CQGMiniGrid m_DOMGrid;
      private CQGMiniGrid m_SessionsGrid;

      /// Status of controls. This is used to cover case when DataConnection has been lost
      private bool m_Status;
      /// FullName of selected instrument
      private string m_InstrumentFullName;
      /// HashTable which maps properties types with their data
      private Hashtable m_PropTypeToData;
      /// HashTable which maps quote types with their data
      private Hashtable m_QuoteTypeToData;

      /// <summary>
      /// Data holder for instrument properties/quotes
      /// </summary>
      struct DataHolder
      {
         public DataHolder(int row, string name)
         {
            Row = row;
            Name = name;
         }
         // Row number of the property/quote in the grid
         public int Row;
         // Property/Quote name
         public string Name;
      }


      #region " Windows Form Designer generated code "

      public frmInstrumentProperties()
      {

         //This call is required by the Windows Form Designer.
         InitializeComponent();

         //Add any initialization after the InitializeComponent() call

      }

      //Form overrides dispose to clean up the component list.
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (!(components == null))
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      //Required by the Windows Form Designer
      private System.ComponentModel.Container components = null;

      //NOTE: The following procedure is required by the Windows Form Designer
      //It can be modified using the Windows Form Designer.
      //Do not modify it using the code editor.
      internal System.Windows.Forms.Label lblDataConnection;
      internal System.Windows.Forms.PictureBox PictureBox1;
      internal System.Windows.Forms.LinkLabel llWeb;
      internal System.Windows.Forms.GroupBox GroupBox2;
      internal System.Windows.Forms.ListBox lstInstruments;
      internal System.Windows.Forms.Button btnRemoveAll;
      internal System.Windows.Forms.Button btnRemove;
      internal System.Windows.Forms.TextBox txtSymbol;
      internal System.Windows.Forms.Label Label4;
      internal System.Windows.Forms.Button btnSubscribe;
      internal System.Windows.Forms.GroupBox GroupBox1;
      internal System.Windows.Forms.GroupBox GroupBox5;
      internal System.Windows.Forms.ComboBox cmbDataSubscriptionLevel;
      internal System.Windows.Forms.Button btnApply;
      internal System.Windows.Forms.GroupBox GroupBox6;
      internal System.Windows.Forms.ComboBox cmbBBAType;
      internal System.Windows.Forms.GroupBox gbProperties;
      internal System.Windows.Forms.GroupBox gbQuotes;
      internal System.Windows.Forms.GroupBox gbDOM;
      internal System.Windows.Forms.GroupBox gbSessions;
      internal System.Windows.Forms.GroupBox GroupBox3;
      internal System.Windows.Forms.NumericUpDown nudDOMBookLimit;
      [System.Diagnostics.DebuggerStepThrough()]
      private void InitializeComponent()
      {
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.PictureBox1 = new System.Windows.Forms.PictureBox();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.GroupBox2 = new System.Windows.Forms.GroupBox();
         this.GroupBox1 = new System.Windows.Forms.GroupBox();
         this.GroupBox3 = new System.Windows.Forms.GroupBox();
         this.nudDOMBookLimit = new System.Windows.Forms.NumericUpDown();
         this.GroupBox6 = new System.Windows.Forms.GroupBox();
         this.cmbBBAType = new System.Windows.Forms.ComboBox();
         this.GroupBox5 = new System.Windows.Forms.GroupBox();
         this.cmbDataSubscriptionLevel = new System.Windows.Forms.ComboBox();
         this.btnApply = new System.Windows.Forms.Button();
         this.txtSymbol = new System.Windows.Forms.TextBox();
         this.Label4 = new System.Windows.Forms.Label();
         this.btnSubscribe = new System.Windows.Forms.Button();
         this.btnRemoveAll = new System.Windows.Forms.Button();
         this.btnRemove = new System.Windows.Forms.Button();
         this.lstInstruments = new System.Windows.Forms.ListBox();
         this.gbProperties = new System.Windows.Forms.GroupBox();
         this.gbQuotes = new System.Windows.Forms.GroupBox();
         this.gbDOM = new System.Windows.Forms.GroupBox();
         this.gbSessions = new System.Windows.Forms.GroupBox();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox1)).BeginInit();
         this.GroupBox2.SuspendLayout();
         this.GroupBox1.SuspendLayout();
         this.GroupBox3.SuspendLayout();
         ((System.ComponentModel.ISupportInitialize)(this.nudDOMBookLimit)).BeginInit();
         this.GroupBox6.SuspendLayout();
         this.GroupBox5.SuspendLayout();
         this.SuspendLayout();
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblDataConnection.Location = new System.Drawing.Point(16, 8);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
         this.lblDataConnection.TabIndex = 17;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // PictureBox1
         // 
         this.PictureBox1.BackColor = System.Drawing.Color.Black;
         this.PictureBox1.Location = new System.Drawing.Point(0, 32);
         this.PictureBox1.Name = "PictureBox1";
         this.PictureBox1.Size = new System.Drawing.Size(1272, 8);
         this.PictureBox1.TabIndex = 15;
         this.PictureBox1.TabStop = false;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.SystemColors.Control;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
         this.llWeb.Location = new System.Drawing.Point(656, 8);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(408, 16);
         this.llWeb.TabIndex = 22;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.UseCompatibleTextRendering = true;
         this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
         // 
         // GroupBox2
         // 
         this.GroupBox2.Controls.Add(this.GroupBox1);
         this.GroupBox2.Controls.Add(this.txtSymbol);
         this.GroupBox2.Controls.Add(this.Label4);
         this.GroupBox2.Controls.Add(this.btnSubscribe);
         this.GroupBox2.Controls.Add(this.btnRemoveAll);
         this.GroupBox2.Controls.Add(this.btnRemove);
         this.GroupBox2.Controls.Add(this.lstInstruments);
         this.GroupBox2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox2.Location = new System.Drawing.Point(8, 48);
         this.GroupBox2.Name = "GroupBox2";
         this.GroupBox2.Size = new System.Drawing.Size(232, 827);
         this.GroupBox2.TabIndex = 43;
         this.GroupBox2.TabStop = false;
         this.GroupBox2.Text = "Instruments";
         // 
         // GroupBox1
         // 
         this.GroupBox1.Controls.Add(this.GroupBox3);
         this.GroupBox1.Controls.Add(this.GroupBox6);
         this.GroupBox1.Controls.Add(this.GroupBox5);
         this.GroupBox1.Controls.Add(this.btnApply);
         this.GroupBox1.Location = new System.Drawing.Point(16, 508);
         this.GroupBox1.Name = "GroupBox1";
         this.GroupBox1.Size = new System.Drawing.Size(200, 216);
         this.GroupBox1.TabIndex = 44;
         this.GroupBox1.TabStop = false;
         // 
         // GroupBox3
         // 
         this.GroupBox3.Controls.Add(this.nudDOMBookLimit);
         this.GroupBox3.Location = new System.Drawing.Point(8, 112);
         this.GroupBox3.Name = "GroupBox3";
         this.GroupBox3.Size = new System.Drawing.Size(184, 48);
         this.GroupBox3.TabIndex = 45;
         this.GroupBox3.TabStop = false;
         this.GroupBox3.Text = "DOMBookLimit";
         // 
         // nudDOMBookLimit
         // 
         this.nudDOMBookLimit.Location = new System.Drawing.Point(8, 16);
         this.nudDOMBookLimit.Maximum = new decimal(new int[] {
            10000,
            0,
            0,
            0});
         this.nudDOMBookLimit.Name = "nudDOMBookLimit";
         this.nudDOMBookLimit.Size = new System.Drawing.Size(168, 22);
         this.nudDOMBookLimit.TabIndex = 0;
         this.nudDOMBookLimit.ValueChanged += new System.EventHandler(this.nudDOMBookLimit_ValueChanged);
         // 
         // GroupBox6
         // 
         this.GroupBox6.Controls.Add(this.cmbBBAType);
         this.GroupBox6.Location = new System.Drawing.Point(8, 64);
         this.GroupBox6.Name = "GroupBox6";
         this.GroupBox6.Size = new System.Drawing.Size(184, 48);
         this.GroupBox6.TabIndex = 44;
         this.GroupBox6.TabStop = false;
         this.GroupBox6.Text = "BBAType";
         // 
         // cmbBBAType
         // 
         this.cmbBBAType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbBBAType.Location = new System.Drawing.Point(8, 16);
         this.cmbBBAType.Name = "cmbBBAType";
         this.cmbBBAType.Size = new System.Drawing.Size(168, 24);
         this.cmbBBAType.TabIndex = 43;
         this.cmbBBAType.SelectedIndexChanged += new System.EventHandler(this.cmbBBAType_SelectedIndexChanged);
         // 
         // GroupBox5
         // 
         this.GroupBox5.Controls.Add(this.cmbDataSubscriptionLevel);
         this.GroupBox5.Location = new System.Drawing.Point(8, 16);
         this.GroupBox5.Name = "GroupBox5";
         this.GroupBox5.Size = new System.Drawing.Size(184, 48);
         this.GroupBox5.TabIndex = 43;
         this.GroupBox5.TabStop = false;
         this.GroupBox5.Text = "DataSubscriptionLevel";
         // 
         // cmbDataSubscriptionLevel
         // 
         this.cmbDataSubscriptionLevel.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbDataSubscriptionLevel.Location = new System.Drawing.Point(8, 16);
         this.cmbDataSubscriptionLevel.Name = "cmbDataSubscriptionLevel";
         this.cmbDataSubscriptionLevel.Size = new System.Drawing.Size(168, 24);
         this.cmbDataSubscriptionLevel.TabIndex = 43;
         this.cmbDataSubscriptionLevel.SelectedIndexChanged += new System.EventHandler(this.cmbDataSubscriptionLevel_SelectedIndexChanged);
         // 
         // btnApply
         // 
         this.btnApply.BackColor = System.Drawing.SystemColors.Control;
         this.btnApply.Enabled = false;
         this.btnApply.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.btnApply.Location = new System.Drawing.Point(56, 168);
         this.btnApply.Name = "btnApply";
         this.btnApply.Size = new System.Drawing.Size(96, 32);
         this.btnApply.TabIndex = 19;
         this.btnApply.Text = "Apply";
         this.btnApply.UseVisualStyleBackColor = false;
         this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
         // 
         // txtSymbol
         // 
         this.txtSymbol.Enabled = false;
         this.txtSymbol.Location = new System.Drawing.Point(80, 24);
         this.txtSymbol.Name = "txtSymbol";
         this.txtSymbol.Size = new System.Drawing.Size(136, 22);
         this.txtSymbol.TabIndex = 42;
         this.txtSymbol.TextChanged += new System.EventHandler(this.txtSymbol_TextChanged);
         this.txtSymbol.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtSymbol_KeyDown);
         // 
         // Label4
         // 
         this.Label4.BackColor = System.Drawing.SystemColors.Control;
         this.Label4.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label4.ForeColor = System.Drawing.SystemColors.ControlText;
         this.Label4.Location = new System.Drawing.Point(16, 24);
         this.Label4.Name = "Label4";
         this.Label4.Size = new System.Drawing.Size(64, 21);
         this.Label4.TabIndex = 43;
         this.Label4.Text = "Symbol :";
         this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // btnSubscribe
         // 
         this.btnSubscribe.BackColor = System.Drawing.SystemColors.Control;
         this.btnSubscribe.Enabled = false;
         this.btnSubscribe.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.btnSubscribe.Location = new System.Drawing.Point(32, 56);
         this.btnSubscribe.Name = "btnSubscribe";
         this.btnSubscribe.Size = new System.Drawing.Size(168, 25);
         this.btnSubscribe.TabIndex = 41;
         this.btnSubscribe.Text = "Subscribe";
         this.btnSubscribe.UseVisualStyleBackColor = false;
         this.btnSubscribe.Click += new System.EventHandler(this.btnSubscribe_Click);
         // 
         // btnRemoveAll
         // 
         this.btnRemoveAll.BackColor = System.Drawing.SystemColors.Control;
         this.btnRemoveAll.Enabled = false;
         this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.btnRemoveAll.Location = new System.Drawing.Point(64, 779);
         this.btnRemoveAll.Name = "btnRemoveAll";
         this.btnRemoveAll.Size = new System.Drawing.Size(104, 25);
         this.btnRemoveAll.TabIndex = 38;
         this.btnRemoveAll.Text = "Remove All";
         this.btnRemoveAll.UseVisualStyleBackColor = false;
         this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
         // 
         // btnRemove
         // 
         this.btnRemove.BackColor = System.Drawing.SystemColors.Control;
         this.btnRemove.Enabled = false;
         this.btnRemove.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.btnRemove.Location = new System.Drawing.Point(64, 748);
         this.btnRemove.Name = "btnRemove";
         this.btnRemove.Size = new System.Drawing.Size(104, 25);
         this.btnRemove.TabIndex = 37;
         this.btnRemove.Text = "Remove Selected";
         this.btnRemove.UseVisualStyleBackColor = false;
         this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
         // 
         // lstInstruments
         // 
         this.lstInstruments.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lstInstruments.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lstInstruments.ItemHeight = 16;
         this.lstInstruments.Location = new System.Drawing.Point(8, 88);
         this.lstInstruments.Name = "lstInstruments";
         this.lstInstruments.Size = new System.Drawing.Size(216, 418);
         this.lstInstruments.TabIndex = 32;
         this.lstInstruments.SelectedIndexChanged += new System.EventHandler(this.lstInstruments_SelectedIndexChanged);
         // 
         // gbProperties
         // 
         this.gbProperties.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbProperties.Location = new System.Drawing.Point(248, 48);
         this.gbProperties.Name = "gbProperties";
         this.gbProperties.Size = new System.Drawing.Size(448, 708);
         this.gbProperties.TabIndex = 44;
         this.gbProperties.TabStop = false;
         this.gbProperties.Text = "Instrument Properties";
         // 
         // gbQuotes
         // 
         this.gbQuotes.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbQuotes.Location = new System.Drawing.Point(704, 48);
         this.gbQuotes.Name = "gbQuotes";
         this.gbQuotes.Size = new System.Drawing.Size(368, 352);
         this.gbQuotes.TabIndex = 45;
         this.gbQuotes.TabStop = false;
         this.gbQuotes.Text = "Quotes";
         // 
         // gbDOM
         // 
         this.gbDOM.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbDOM.ForeColor = System.Drawing.SystemColors.ControlText;
         this.gbDOM.Location = new System.Drawing.Point(704, 456);
         this.gbDOM.Name = "gbDOM";
         this.gbDOM.Size = new System.Drawing.Size(368, 296);
         this.gbDOM.TabIndex = 46;
         this.gbDOM.TabStop = false;
         this.gbDOM.Text = "Depth Of Market(DOM)";
         // 
         // gbSessions
         // 
         this.gbSessions.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbSessions.Location = new System.Drawing.Point(248, 759);
         this.gbSessions.Name = "gbSessions";
         this.gbSessions.Size = new System.Drawing.Size(824, 116);
         this.gbSessions.TabIndex = 47;
         this.gbSessions.TabStop = false;
         this.gbSessions.Text = "Sessions";
         // 
         // frmInstrumentProperties
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.BackColor = System.Drawing.SystemColors.Control;
         this.ClientSize = new System.Drawing.Size(1082, 883);
         this.Controls.Add(this.gbSessions);
         this.Controls.Add(this.gbDOM);
         this.Controls.Add(this.gbQuotes);
         this.Controls.Add(this.gbProperties);
         this.Controls.Add(this.GroupBox2);
         this.Controls.Add(this.lblDataConnection);
         this.Controls.Add(this.PictureBox1);
         this.Controls.Add(this.llWeb);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
         this.MaximizeBox = false;
         this.Name = "frmInstrumentProperties";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "Instrument Properties";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmInstrumentProperties_Closing);
         this.Load += new System.EventHandler(this.frmInstrumentProperties_Load);
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox1)).EndInit();
         this.GroupBox2.ResumeLayout(false);
         this.GroupBox2.PerformLayout();
         this.GroupBox1.ResumeLayout(false);
         this.GroupBox3.ResumeLayout(false);
         ((System.ComponentModel.ISupportInitialize)(this.nudDOMBookLimit)).EndInit();
         this.GroupBox6.ResumeLayout(false);
         this.GroupBox5.ResumeLayout(false);
         this.ResumeLayout(false);

      }

      #endregion

      /// <summary>
      /// Create an m_CEL object, change its configurations, start up and initialize HashTable and grids.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void frmInstrumentProperties_Load(System.Object sender, System.EventArgs e)
      {
         try
         {
            m_Status = true;
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);

            m_CEL = new CQGCEL();
            m_CEL.DataConnectionStatusChanged += new _ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
            m_CEL.InstrumentResolved += new _ICQGCELEvents_InstrumentResolvedEventHandler(CEL_InstrumentResolved);
            m_CEL.InstrumentChanged += new _ICQGCELEvents_InstrumentChangedEventHandler(CEL_InstrumentChanged);
            m_CEL.InstrumentDOMChanged += new _ICQGCELEvents_InstrumentDOMChangedEventHandler(CEL_InstrumentDOMChanged);
            m_CEL.DataError += new _ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
            m_CEL.APIConfiguration.CollectionsThrowException = false;
            m_CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
            m_CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;
            m_CEL.Startup();

            InitPropertyFields();
            InitQuoteFields();
            InitDOMFields();
            InitSessionsFields();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "frmInstrumentProperties_Load", ex);
         }
      }

      /// <summary>
      /// Initialize the properties hash table.
      /// </summary>
      private void InitPropertiesTable()
      {
         m_PropTypeToData = new Hashtable();

         int row = 0;

         m_PropTypeToData.Add(eInstrumentProperty.ipFullName, new DataHolder(row++, "FullName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDetailedName, new DataHolder(row++, "DetailedName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDescription, new DataHolder(row++, "Description"));
         m_PropTypeToData.Add(eInstrumentProperty.ipInstrumentID, new DataHolder(row++, "InstrumentID"));
         m_PropTypeToData.Add(eInstrumentProperty.ipCurrency, new DataHolder(row++, "Currency"));
         m_PropTypeToData.Add(eInstrumentProperty.ipExpirationDate, new DataHolder(row++, "ExpirationDate"));
         m_PropTypeToData.Add(eInstrumentProperty.ipFirstNoticeDate, new DataHolder(row++, "FirstNoticeDate"));
         m_PropTypeToData.Add(eInstrumentProperty.ipInitialMargin, new DataHolder(row++, "InitialMargin"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMaintenanceMargin, new DataHolder(row++, "MaintenanceMargin"));
         m_PropTypeToData.Add(eInstrumentProperty.ipSessionMask, new DataHolder(row++, "SessionMask"));
         m_PropTypeToData.Add(eInstrumentProperty.ipCommodity, new DataHolder(row++, "Commodity"));
         m_PropTypeToData.Add(eInstrumentProperty.ipCountry, new DataHolder(row++, "Country"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMonthChar, new DataHolder(row++, "MonthChar"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMonth, new DataHolder(row++, "Month"));
         m_PropTypeToData.Add(eInstrumentProperty.ipStrike, new DataHolder(row++, "Strike"));
         m_PropTypeToData.Add(eInstrumentProperty.ipInstrumentType, new DataHolder(row++, "InstrumentType"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYear, new DataHolder(row++, "Year"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYearString, new DataHolder(row++, "YearString"));
         m_PropTypeToData.Add(eInstrumentProperty.ipTickSize, new DataHolder(row++, "TickSize"));
         m_PropTypeToData.Add(eInstrumentProperty.ipSessionNumber, new DataHolder(row++, "SessionNumber"));
         m_PropTypeToData.Add(eInstrumentProperty.ipNetChange, new DataHolder(row++, "NetChange"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDTE, new DataHolder(row++, "DTE"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYCOI, new DataHolder(row++, "YCOI"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsDownTick, new DataHolder(row++, "IsDownTick"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsUpTick, new DataHolder(row++, "IsUpTick"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsFastMarket, new DataHolder(row++, "IsFastMarket"));
         m_PropTypeToData.Add(eInstrumentProperty.ipTodayCTotalVolume, new DataHolder(row++, "TodayCTotalVolume"));
         m_PropTypeToData.Add(eInstrumentProperty.ipTodayCTotalVolumeFractional, new DataHolder(row++, "TodayCTotalVolumeFractional"));
         m_PropTypeToData.Add(eInstrumentProperty.ipPreferredSessionName, new DataHolder(row++, "PreferredSessionName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDelayTime, new DataHolder(row++, "DelayTime"));
         m_PropTypeToData.Add(eInstrumentProperty.ipExchangeAbbreviation, new DataHolder(row++, "ExchangeAbbreviation"));
         m_PropTypeToData.Add(eInstrumentProperty.ipExchangeID, new DataHolder(row++, "ExchangeID"));
         m_PropTypeToData.Add(eInstrumentProperty.ipLeadingContractName, new DataHolder(row++, "LeadingContractName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYesterdayCTotalVolume, new DataHolder(row++, "YesterdayCTotalVolume"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYesterdayCTotalVolumeFractional, new DataHolder(row++, "YesterdayCTotalVolumeFractional"));
         m_PropTypeToData.Add(eInstrumentProperty.ipWorkup, new DataHolder(row++, "Workup"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsFutureStyleOption, new DataHolder(row++, "Future Style Option"));
      }

      /// <summary>
      /// Initialize the quotes hash table.
      /// </summary>
      private void InitQuotesTable()
      {
         m_QuoteTypeToData = new Hashtable();

         int row = 0;

         m_QuoteTypeToData.Add(eQuoteType.qtAsk, new DataHolder(row++, "Ask"));
         m_QuoteTypeToData.Add(eQuoteType.qtBid, new DataHolder(row++, "Bid"));
         m_QuoteTypeToData.Add(eQuoteType.qtTrade, new DataHolder(row++, "Trade"));
         m_QuoteTypeToData.Add(eQuoteType.qtCohUndAsk, new DataHolder(row++, "CohUndAsk"));
         m_QuoteTypeToData.Add(eQuoteType.qtCohUndBid, new DataHolder(row++, "CohUndBid"));
         m_QuoteTypeToData.Add(eQuoteType.qtImpliedAsk, new DataHolder(row++, "ImpliedAsk"));
         m_QuoteTypeToData.Add(eQuoteType.qtImpliedBid, new DataHolder(row++, "ImpliedBid"));
         m_QuoteTypeToData.Add(eQuoteType.qtOutrightAsk, new DataHolder(row++, "OutrightAsk"));
         m_QuoteTypeToData.Add(eQuoteType.qtOutrightBid, new DataHolder(row++, "OutrightBid"));
         m_QuoteTypeToData.Add(eQuoteType.qtDayOpen, new DataHolder(row++, "DayOpen"));
         m_QuoteTypeToData.Add(eQuoteType.qtDayHigh, new DataHolder(row++, "DayHigh"));
         m_QuoteTypeToData.Add(eQuoteType.qtDayLow, new DataHolder(row++, "DayLow"));
         m_QuoteTypeToData.Add(eQuoteType.qtIndicativeOpen, new DataHolder(row++, "IndicativeOpen"));
         m_QuoteTypeToData.Add(eQuoteType.qtSettlement, new DataHolder(row++, "Settlement"));
         m_QuoteTypeToData.Add(eQuoteType.qtYesterdaySettlement, new DataHolder(row++, "YesterdaySettlement"));
         m_QuoteTypeToData.Add(eQuoteType.qtMarker, new DataHolder(row++, "Marker"));
         m_QuoteTypeToData.Add(eQuoteType.qtTodayMarker, new DataHolder(row++, "TodayMarker"));
      }

      /// <summary>
      /// Create and initialize the grid of properties.
      /// </summary>
      private void InitPropertyFields()
      {
         InitPropertiesTable();

         m_PropertiesGrid = new CQGMiniGrid(2, m_PropTypeToData.Count, gbProperties);

         m_PropertiesGrid.SetColumnWidth(0, 172);
         m_PropertiesGrid.SetColumnWidth(1, 262);

         m_PropertiesGrid.SetHeaderValue(0, "Property Name");
         m_PropertiesGrid.SetHeaderValue(1, "Value");

         DataHolder propHld;
         foreach (DictionaryEntry item in m_PropTypeToData)
         {
            propHld = (DataHolder)item.Value;
            m_PropertiesGrid[propHld.Row, 0].Text = propHld.Name;
         }
      }

      /// <summary>
      /// Create and initialize the grid of quotes.
      /// </summary>
      private void InitQuoteFields()
      {
         InitQuotesTable();

         m_QuotesGrid = new CQGMiniGrid(4, 17, gbQuotes);

         m_QuotesGrid.SetColumnWidth(0, 135);
         m_QuotesGrid.SetHeaderValue(0, "Quote Name");
         m_QuotesGrid.SetColumnWidth(1, 70);
         m_QuotesGrid.SetHeaderValue(1, "Price");
         m_QuotesGrid.SetColumnWidth(2, 63);
         m_QuotesGrid.SetHeaderValue(2, "Volume");
         m_QuotesGrid.SetColumnWidth(3, 90);
         m_QuotesGrid.SetHeaderValue(3, "Display Price");

         DataHolder quoteHld;
         foreach (DictionaryEntry item in m_QuoteTypeToData)
         {
            quoteHld = (DataHolder)item.Value;
            m_QuotesGrid[quoteHld.Row, 0].Text = quoteHld.Name;
         }
      }

      /// <summary>
      /// Create and initialize the grid of DOM.
      /// </summary>
      private void InitDOMFields()
      {
         m_DOMGrid = new CQGMiniGrid(3, 14, gbDOM);

         m_DOMGrid.SetColumnWidth(0, 119);
         m_DOMGrid.SetColumnAlign(0, ContentAlignment.MiddleRight);
         m_DOMGrid.SetHeaderValue(0, "Ask Volume");
         m_DOMGrid.SetColumnWidth(1, 115);
         m_DOMGrid.SetColumnAlign(1, ContentAlignment.MiddleCenter);
         m_DOMGrid.SetHeaderValue(1, "Price");
         m_DOMGrid.SetColumnWidth(2, 120);
         m_DOMGrid.SetColumnAlign(2, ContentAlignment.MiddleLeft);
         m_DOMGrid.SetHeaderValue(2, "Bid Volume");
      }

      /// <summary>
      /// Create and initialize the grid of sessions.
      /// </summary>
      private void InitSessionsFields()
      {
         m_SessionsGrid = new CQGMiniGrid(8, 4, gbSessions);

         m_SessionsGrid.SetColumnWidth(0, 170);
         m_SessionsGrid.SetHeaderValue(0, "Name");

         m_SessionsGrid.SetColumnWidth(1, 57);
         m_SessionsGrid.SetColumnAlign(1, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(1, "Number");

         m_SessionsGrid.SetColumnWidth(2, 156);
         m_SessionsGrid.SetColumnAlign(2, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(2, "Activation Date");

         m_SessionsGrid.SetColumnWidth(3, 69);
         m_SessionsGrid.SetColumnAlign(3, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(3, "Start Time");

         m_SessionsGrid.SetColumnWidth(4, 69);
         m_SessionsGrid.SetColumnAlign(4, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(4, "End Time");

         m_SessionsGrid.SetColumnWidth(5, 72);
         m_SessionsGrid.SetColumnAlign(5, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(5, "Is Primary");

         m_SessionsGrid.SetColumnWidth(6, 82);
         m_SessionsGrid.SetColumnAlign(6, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(6, "Type");

         m_SessionsGrid.SetColumnWidth(7, 125);
         m_SessionsGrid.SetColumnAlign(7, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(7, "Working Week Days");
      }

      /// <summary>
      /// Shut down m_CEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A CancelEventArgs that contains the event data.
      /// </param>
      private void frmInstrumentProperties_Closing(object sender, System.ComponentModel.CancelEventArgs e)
      {
         try
         {
            m_CEL.Shutdown();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "frmInstrumentProperties_Closing", ex);
         }
      }

      /// <summary>
      /// This event is fired, when some changes occur in the connection with the CQG data server.
      /// </summary>
      /// <param name="newStatus">
      /// The current status of the connection with the data server.
      /// </param>
      private void CEL_DataConnectionStatusChanged(eConnectionStatus newStatus)
      {
         try
         {
            string info;
            System.Drawing.Color BackCol;

            if (newStatus != eConnectionStatus.csConnectionUp)
            {
               BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
               info = "DATA Connection is " + (newStatus == eConnectionStatus.csConnectionDelayed ?
                                                                     "Delayed" : "Down").ToString();

               txtSymbol.Text = "";
               txtSymbol.Enabled = false;
               btnSubscribe.Enabled = false;
            }
            else
            {
               BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
               info = "DATA Connection is UP";

               txtSymbol.Enabled = m_Status;
               btnSubscribe.Enabled = false;
            }

            lblDataConnection.BackColor = BackCol;
            lblDataConnection.Text = info;
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "CEL_DataConnectionStatusChanged", ex);
         }
      }

      /// <summary>
      /// Failed symbol resolution processing.
      /// </summary>
      /// <param name="error">
      /// CQGError instance. It is null in case resolution success.
      /// </param>
      private void incorrectSymbolProcessing(CQGError error)
      {
         ErrorHandler.HandleError("frmInstrumentProperties", "incorrectSymbolProcessing", error);
         txtSymbol.Clear();
         m_Status = true;
         txtSymbol.Enabled = (m_CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp);
         btnSubscribe.Enabled = false;
         txtSymbol.Focus();
      }

      /// <summary>
      /// This event is fired when a new instrument is resolved and subscribed or resolution failed.
      /// </summary>
      /// <param name="symbl">
      /// The commodity symbol that was requested by the user in the NewInstrument method.
      /// </param>
      /// <param name="instrument">
      /// The resolved CQGInstrument object.
      /// </param>
      /// <param name="error">
      /// CQGError instance. It is null in case resolution success.
      /// </param>
      private void CEL_InstrumentResolved(string symbl, CQGInstrument instrument, CQGError error)
      {
         try
         {
            if (m_CEL.IsValid(error))
            {
               incorrectSymbolProcessing(error);
               return;
            }
            instrumentSubscribed(symbl, instrument);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "CEL_InstrumentResolved", ex);
         }
      }

      /// <summary>
      /// Instrument is resolved and subscribed processing.
      /// </summary>
      /// <param name="symbl">
      /// The commodity symbol that was requested by the user in the NewInstrument method.
      /// </param>
      /// <param name="instrument">
      /// The resolved CQGInstrument object.
      /// </param>
      private void instrumentSubscribed(string symbl, CQGInstrument instrument)
      {
         int index = lstInstruments.Items.IndexOf(instrument.FullName);
         if (index == -1)
         {
            lstInstruments.Items.Add(instrument.FullName);
            lstInstruments.SelectedIndex = lstInstruments.Items.Count - 1;
         }
         else
         {
            lstInstruments.SelectedIndex = index;
         }

         m_Status = true;
         btnSubscribe.Enabled = (m_CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp);
         txtSymbol.Enabled = (m_CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp);
         txtSymbol.Text = "";
      }

      /// <summary>
      /// This event is fired when any of the instrument quotes or dynamic instrument properties are changed.
      /// </summary>
      /// <param name="Instrument">
      /// The changed instrument.
      /// </param>
      /// <param name="Quotes">
      /// The collection of changed quotes.
      /// </param>
      /// <param name="props">
      /// The collection of changed dynamic properties.
      /// </param>
      private void CEL_InstrumentChanged(CQGInstrument instrument,
                                 CQGQuotes quotes,
                                 CQGInstrumentProperties props)
      {
         try
         {
            if (instrument.FullName == m_InstrumentFullName)
            {
               DisplayProperties(props);
               DisplayQuotes(quotes);
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "CEL_InstrumentChanged", ex);
         }
      }

      /// <summary>
      /// This event is fired when instrument's DOM is updated.
      /// </summary>
      /// <param name="Instrument">
      /// Changed instrument: its DOMAsks and DOMBids collections contain new DOM book.
      /// </param>
      /// <param name="prevAsks">
      /// The collection of asks from the previous DOM book.
      /// </param>
      /// <param name="prevBids">
      /// The collection of bids from the previous DOM book.
      /// </param>
      private void CEL_InstrumentDOMChanged(CQGInstrument instrument,
                                    CQGDOMQuotes prevAsks,
                                    CQGDOMQuotes prevBids)
      {
         try
         {
            if (instrument.FullName == m_InstrumentFullName)
            {
               DisplayDOM(instrument);
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "CEL_InstrumentDOMChanged", ex);
         }
      }

      /// <summary>
      /// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
      /// </summary>
      /// <param name="obj">
      /// Object, in which the error occurred.
      /// </param>
      /// <param name="errorDescription">
      /// String, describing the error.
      /// </param>
      private void CEL_DataError(object obj, string errorDescription)
      {
         try
         {
            CQGError cqgErr = obj as CQGError;
            if (m_CEL.IsValid(cqgErr))
            {
               if (cqgErr.Code == 102)
               {
                  errorDescription += " Restart the application.";
               }
               else if (cqgErr.Code == 125)
               {
                  errorDescription += " Turn on CQG Client and restart the application.";
               }
            }

            MessageBox.Show(errorDescription, "Historical Data", MessageBoxButtons.OK, MessageBoxIcon.Information);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "CEL_DataError", ex);
         }
      }

      /// <summary>
      /// Subscribe to a new instrument
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnSubscribe_Click(System.Object sender, System.EventArgs e)
      {
         try
         {

            if (txtSymbol.Text.Trim().Length > 0)
            {
               m_CEL.NewInstrument(txtSymbol.Text.Trim());
            }
            m_Status = false;
            btnSubscribe.Enabled = false;
            txtSymbol.Enabled = false;
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "btnSubscribe_Click", ex);
         }
      }

      /// <summary>
      /// Enable/disable the "Subscribe" button's status, if the Symbol's textbox is full/empty.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void txtSymbol_TextChanged(System.Object sender, System.EventArgs e)
      {
         btnSubscribe.Enabled = txtSymbol.Text.Trim().Length > 0;
      }

      /// <summary>
      /// When the "Enter" button is clicked, call btnSubscribe_Click sub, which subscribes to a new instrument.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A KeyEventArgs that contains the event data.
      /// </param>
      private void txtSymbol_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
      {
         if (e.KeyCode == Keys.Enter)
         {
            btnSubscribe_Click(sender, e);
         }
      }

      /// <summary>
      /// Open CQG API web page.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A LinkLabelLinkClickedEventArgs that contains the event data.
      /// </param>
      private void llWeb_LinkClicked(System.Object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
      {
         try
         {
            System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "llWeb_LinkClicked", ex);
         }
      }

      /// <summary>
      /// Remove the selected instrument.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRemove_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            m_CEL.RemoveInstrument(m_CEL.Instruments[m_InstrumentFullName]);
            lstInstruments.Items.RemoveAt(lstInstruments.SelectedIndex);
            if (lstInstruments.Items.Count > 0)
            {
               if (lstInstruments.SelectedIndex == -1)
               {
                  lstInstruments.SelectedIndex = 0;
               }
            }
            else
            {
               OnInstrumentsListBoxChange();
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "btnRemove_Click", ex);
         }
      }

      /// <summary>
      /// Remove all instrument.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            m_CEL.RemoveAllInstruments();
            lstInstruments.Items.Clear();
            OnInstrumentsListBoxChange();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "btnRemoveAll_Click", ex);
         }
      }

      /// <summary>
      /// Applies new DataSubscriptionLevel and/or BBAType.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnApply_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];

            if (cmbDataSubscriptionLevel.Text == "dsNone")
            {
               instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsNone;
            }
            else if (cmbDataSubscriptionLevel.Text == "dsQuotes")
            {
               instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsQuotes;
            }
            else if (cmbDataSubscriptionLevel.Text == "dsQuotesAndBBA")
            {
               instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsQuotesAndBBA;
            }
            else if (cmbDataSubscriptionLevel.Text == "dsQuotesAndDOM")
            {
               instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsQuotesAndDOM;
            }


            if (cmbBBAType.Text == "dbtCombined")
            {
               instrument.BBAType = eDOMandBBAType.dbtCombined;
            }
            else if (cmbBBAType.Text == "dbtImplied")
            {
               instrument.BBAType = eDOMandBBAType.dbtImplied;
            }
            else if (cmbBBAType.Text == "dbtOutright")
            {
               instrument.BBAType = eDOMandBBAType.dbtOutright;
            }

            instrument.DOMBookLimit = Decimal.ToInt32(nudDOMBookLimit.Value);

            btnApply.Enabled = false;
         }
         catch (System.Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "btnApply_Click", ex);
         }
      }

      /// <summary>
      /// This event is fired when new DataSubscriptionLevel is selected
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data
      /// </param>
      private void cmbDataSubscriptionLevel_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         OnDataSubscriptionLevelOrBBATypeChange();
      }

      /// <summary>
      /// This event is fired when a new BBAType is selected.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void cmbBBAType_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         OnDataSubscriptionLevelOrBBATypeChange();
      }

      /// <summary>
      /// This event is fired when a new Instrument is selected in the Instruments listbox.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void lstInstruments_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         try
         {
            OnInstrumentsListBoxChange();
            DataSubscriptionLevelAndBBATypeComboInit();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "lstInstruments_SelectedIndexChanged", ex);
         }
      }

      /// <summary>
      /// Initialize new DataSubscriptionLevel and BBAType combo boxes.
      /// </summary>
      private void DataSubscriptionLevelAndBBATypeComboInit()
      {
         if (lstInstruments.SelectedIndex > -1)
         {
            if (cmbDataSubscriptionLevel.Items.Count == 0)
            {
               cmbDataSubscriptionLevel.Items.Add("dsNone");
               cmbDataSubscriptionLevel.Items.Add("dsQuotes");
               cmbDataSubscriptionLevel.Items.Add("dsQuotesAndBBA");
               cmbDataSubscriptionLevel.Items.Add("dsQuotesAndDOM");
            }

            if (cmbBBAType.Items.Count == 0)
            {
               cmbBBAType.Items.Add("dbtCombined");
               cmbBBAType.Items.Add("dbtImplied");
               cmbBBAType.Items.Add("dbtOutright");
            }

            CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];
            cmbDataSubscriptionLevel.Text = instrument.DataSubscriptionLevel.ToString();
            cmbBBAType.Text = instrument.BBAType.ToString();
            nudDOMBookLimit.Value = instrument.DOMBookLimit;
         }
      }

      /// <summary>
      /// Enable the "Apply" button, if new DataSubscriptionLevel and/or BBAType is selected.
      /// </summary>
      private void OnDataSubscriptionLevelOrBBATypeChange()
      {
         try
         {
            if (cmbDataSubscriptionLevel.Items.Count > 0 && cmbBBAType.Items.Count > 0)
            {
               CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];
               btnApply.Enabled = (cmbDataSubscriptionLevel.Text != instrument.DataSubscriptionLevel.ToString())
                                 || (cmbBBAType.Text != instrument.BBAType.ToString())
                                 || (nudDOMBookLimit.Value != instrument.DOMBookLimit);
            }
            else
            {
               btnApply.Enabled = false;
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentProperties", "OnDataSubscriptionLevelOrBBATypeChange", ex);
         }
      }

      /// <summary>
      /// Clear the grid, if an instrument is not selected, 
      /// otherwise fill/update params for the selected instrument.
      /// </summary>
      /// <param name="props">
      /// The collection of params, which were changed.
      /// </param>
      private void DisplayProperties(CQGInstrumentProperties props)
      {
         if (props == null)
         {
            m_PropertiesGrid.ClearColumn(1);
            return;
         }

         if (props.Count == 0)
         {
            return;
         }

         DataHolder propHld;
         string dispVal;
         foreach (DictionaryEntry item in m_PropTypeToData)
         {
            try
            {
               CQGInstrumentProperty prop = props[(eInstrumentProperty)item.Key];

               if (prop != null)
               {
                  dispVal = N_A;
                  if (m_CEL.IsValid(prop.Value))
                  {
                     if (prop.Type == eInstrumentProperty.ipInstrumentType)
                     {
                        dispVal = ((eInstrumentType)prop.Value).ToString();
                     }
                     else
                     {
                        dispVal = prop.Value.ToString();
                     }
                  }

                  propHld = (DataHolder)item.Value;
                  m_PropertiesGrid[propHld.Row, 1].Text = dispVal;
               }
            }
            catch (System.Exception ex)
            {
               string msg = "ERROR: " + ex.Message;
               if ((eInstrumentProperty)item.Key == eInstrumentProperty.ipTickSize)
               {
                  msg = "Variable tick size";
               }
               propHld = (DataHolder)item.Value;
               m_PropertiesGrid[propHld.Row, 1].Text = msg;
            }
         }
      }

      /// <summary>
      /// Clear the grid, if an instrument is not selected, 
      /// otherwise fill/update quotes for selected instrument.
      /// </summary>
      /// <param name="Quotes">
      /// The collection of quotes, which were changed.
      /// </param>
      private void DisplayQuotes(CQGQuotes quotes)
      {
         if (quotes == null)
         {
            m_QuotesGrid.ClearColumn(1);
            m_QuotesGrid.ClearColumn(2);
            m_QuotesGrid.ClearColumn(3);
            return;
         }

         CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];
         string dispPrice;
         string dispVol;
         string dispDisplayPrice;

         foreach (DictionaryEntry item in m_QuoteTypeToData)
         {
            CQGQuote quote = quotes[(eQuoteType)item.Key];

            if (quote != null)
            {
               if (quote.IsValid)
               {
                  dispPrice = quote.Price.ToString();
                  dispVol = quote.HasVolume ? quote.VolumeFractional.ToString() : N_A;
                  dispDisplayPrice = instrument.ToDisplayPrice(quote.Price);
               }
               else
               {
                  dispPrice = N_A;
                  dispVol = N_A;
                  dispDisplayPrice = N_A;
               }

               DataHolder quoteHld = (DataHolder)item.Value;
               m_QuotesGrid[quoteHld.Row, 1].Text = dispPrice;
               m_QuotesGrid[quoteHld.Row, 2].Text = dispVol;
               m_QuotesGrid[quoteHld.Row, 3].Text = dispDisplayPrice;
            }
         }
      }

      /// <summary>
      /// Display information about sessions.
      /// </summary>
      private void DisplaySessions(CQGSessions sessions)
      {
         m_SessionsGrid.Clear();
         if (sessions == null)
         {
            return;
         }
         int i = -1;
         foreach (CQGSession session in sessions)
         {
            i++;
            if (i <= m_SessionsGrid.Rows)
            {
               m_SessionsGrid[i, 0].Text = session.Name;
               m_SessionsGrid[i, 1].Text = session.Number.ToString();
               if (m_CEL.IsValid(session.ActivationDate))
               {
                  m_SessionsGrid[i, 2].Text = session.ActivationDate.ToString();
               }
               else
               {
                  m_SessionsGrid[i, 2].Text = N_A;
               }
               if (m_CEL.IsValid(session.StartTime))
               {
                  m_SessionsGrid[i, 3].Text = session.StartTime.ToShortTimeString();
               }
               else
               {
                  m_SessionsGrid[i, 3].Text = N_A;
               }
               if (m_CEL.IsValid(session.EndTime))
               {
                  m_SessionsGrid[i, 4].Text = session.EndTime.ToShortTimeString();
               }
               else
               {
                  m_SessionsGrid[i, 4].Text = N_A;
               }
               m_SessionsGrid[i, 5].Text = (session.PrimaryFlag ? "Yes" : "No").ToString();
               m_SessionsGrid[i, 6].Text = session.Type.ToString();
               m_SessionsGrid[i, 7].Text = GetSessionWorkingDays(session.WorkingWeekDays);
            }
         }
      }

      /// <summary>
      /// Clear the grid, if an instrument is not selected, 
      /// otherwise fill/update DOMs for the selected instrument.
      /// </summary>
      /// <param name="Instrument">
      /// The instument, for which DOM was updated.
      /// </param>
      private void DisplayDOM(CQGInstrument instrument)
      {
         if (instrument == null)
         {
            m_DOMGrid.Clear();
            return;
         }
         int r = (int)(m_DOMGrid.Rows / 2);

         string dispPrice;
         string dispVol;
         CQGQuote qt;

         for (int i = 0; i < r; i++)
         {
            if (i < instrument.DOMAsks.Count)
            {
               qt = instrument.DOMAsks[i];
               if (qt.IsValid)
               {
                  dispPrice = instrument.ToDisplayPrice(qt.Price);
                  dispVol = qt.VolumeFractional.ToString();
               }
               else
               {
                  dispPrice = N_A;
                  dispVol = N_A;
               }
            }
            else
            {
               dispPrice = "";
               dispVol = "";
            }

            m_DOMGrid[r - 1 - i, 0].Text = dispVol;
            m_DOMGrid[r - 1 - i, 0].ForeColor = Color.Red;
            m_DOMGrid[r - 1 - i, 1].Text = dispPrice;
         }

         for (int i = r; i < m_DOMGrid.Rows; i++)
         {
            if (i - m_DOMGrid.Rows / 2 < instrument.DOMBids.Count)
            {
               qt = instrument.DOMBids[i - r];
               if (qt.IsValid)
               {
                  dispPrice = instrument.ToDisplayPrice(qt.Price);
                  dispVol = qt.VolumeFractional.ToString();
               }
               else
               {
                  dispPrice = N_A;
                  dispVol = N_A;
               }
            }
            else
            {
               dispPrice = "";
               dispVol = "";
            }

            m_DOMGrid[i, 1].Text = dispPrice;
            m_DOMGrid[i, 2].Text = dispVol;
            m_DOMGrid[i, 2].ForeColor = Color.Green;
         }
      }

      /// <summary>
      /// This sub is called, if there was any change connected with the 
      /// instruments (Add/Remove/Remove All/Selection Change).
      /// </summary>
      private void OnInstrumentsListBoxChange()
      {
         if (lstInstruments.Items.Count == 0)
         {
            btnRemoveAll.Enabled = false;
            cmbDataSubscriptionLevel.Items.Clear();
            cmbBBAType.Items.Clear();
            OnDataSubscriptionLevelOrBBATypeChange();
         }
         else
         {
            btnRemoveAll.Enabled = true;
         }

         ClearAll();

         if (lstInstruments.SelectedIndex > -1)
         {
            btnRemove.Enabled = true;
            m_InstrumentFullName = lstInstruments.Items[lstInstruments.SelectedIndex].ToString();

            CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];
            DisplayProperties(instrument.Properties);
            DisplayQuotes(instrument.Quotes);
            DisplayDOM(instrument);
            DisplaySessions(instrument.Sessions);
         }
      }

      /// <summary>
      /// Return the session's week working days in this format: "SMTWTFS".
      /// </summary>
      /// <param name="weekDay">
      /// eSessionWeekDays bitmask, which contains information about working days.
      /// </param>
      /// <returns>
      /// String, which contains working days.
      /// </returns>
      private static string GetSessionWorkingDays(eSessionWeekDays weekDay)
      {
         string sResult;

         sResult = (((weekDay & eSessionWeekDays.swdSunday) == eSessionWeekDays.swdSunday) ? "S" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdMonday) == eSessionWeekDays.swdMonday) ? "M" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdTuesday) == eSessionWeekDays.swdTuesday) ? "T" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdWednesday) == eSessionWeekDays.swdWednesday) ? "W" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdThursday) == eSessionWeekDays.swdThursday) ? "T" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdFriday) == eSessionWeekDays.swdFriday) ? "F" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdSaturday) == eSessionWeekDays.swdSaturday) ? "S" : "-").ToString();

         return sResult;
      }

      /// <summary>
      /// This event is fired when DOM book limit is changed
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param> 
      /// <param name="e">
      /// An EventArgs that contains the event data
      /// </param>
      private void nudDOMBookLimit_ValueChanged(object sender, System.EventArgs e)
      {
         OnDataSubscriptionLevelOrBBATypeChange();
      }

      /// <summary>
      /// Clears all data
      /// </summary>
      private void ClearAll()
      {
         btnRemove.Enabled = false;

         m_InstrumentFullName = "";
         DisplayProperties(null);
         DisplayQuotes(null);
         DisplayDOM(null);
         DisplaySessions(null);
      }

   }

}
