using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;

namespace InstrumentPropertiesNewMode
{
   public class frmInstrumentPropertiesNewMode : System.Windows.Forms.Form
   {
      
      [STAThread]
      static void Main()
      {
         Application.Run(new frmInstrumentPropertiesNewMode());
      }
      
      private const string N_A = "N/A";
      
      private CQGCEL m_CEL;
      
      /// Grids for dumping properties/sessions/quotes/DOM values
      private CQGMiniGrid m_PropertiesGrid;
      private CQGMiniGrid m_QuotesGrid;
      private CQGMiniGrid m_DOMGrid;
      private CQGMiniGrid m_SessionsGrid;
      
      /// FullName of selected instrument
      private string m_InstrumentFullName;
      /// HashTable which maps properties types with their data
      private Hashtable m_PropTypeToData;
      /// HashTable which maps quote types with their data
      private Hashtable m_QuoteTypeToData;

      /// <summary>
      /// Data holder for instrument properties/quotes
      /// </summary>
      struct DataHolder
      {
         public DataHolder(int row, string name) 
         {
            Row = row;
            Name = name;
         }
         // Row number of the property/quote in the grid
         public int Row;
         // Property/Quote name
         public string Name;
      }
      
      
      #region " Windows Form Designer generated code "
      
      public frmInstrumentPropertiesNewMode()
      {
         
         //This call is required by the Windows Form Designer.
         InitializeComponent();
         
         //Add any initialization after the InitializeComponent() call
         
      }
      
      //Form overrides dispose to clean up the component list.
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (!(components == null))
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }
      
      //Required by the Windows Form Designer
      private System.ComponentModel.Container components = null;
      
      //NOTE: The following procedure is required by the Windows Form Designer
      //It can be modified using the Windows Form Designer.
      //Do not modify it using the code editor.
      internal System.Windows.Forms.Label lblDataConnection;
      internal System.Windows.Forms.PictureBox PictureBox1;
      internal System.Windows.Forms.LinkLabel llWeb;
      internal System.Windows.Forms.GroupBox GroupBox2;
      internal System.Windows.Forms.ListBox lstInstruments;
      internal System.Windows.Forms.Button btnRemoveAll;
      internal System.Windows.Forms.Button btnRemove;
      internal System.Windows.Forms.TextBox txtSymbol;
      internal System.Windows.Forms.Label Label4;
      internal System.Windows.Forms.Button btnSubscribe;
      internal System.Windows.Forms.GroupBox GroupBox1;
      internal System.Windows.Forms.GroupBox GroupBox5;
      internal System.Windows.Forms.Button btnApply;
      internal System.Windows.Forms.GroupBox GroupBox6;
      internal System.Windows.Forms.GroupBox gbProperties;
      internal System.Windows.Forms.GroupBox gbQuotes;
      internal System.Windows.Forms.GroupBox gbDOM;
      internal System.Windows.Forms.GroupBox gbSessions;
      internal System.Windows.Forms.CheckBox chkDOMStatus;
      internal System.Windows.Forms.GroupBox groupBox4;
      internal System.Windows.Forms.GroupBox groupBox7;
      internal System.Windows.Forms.CheckBox chkQuotes;
      internal System.Windows.Forms.CheckBox chkBBA;
      internal System.Windows.Forms.CheckBox chkMarketState;
      internal System.Windows.Forms.CheckBox chkNetChange;
      internal System.Windows.Forms.CheckBox chkTotalVolumes;
      internal System.Windows.Forms.RadioButton chkImplied;
      internal System.Windows.Forms.RadioButton chkOutright;
      internal System.Windows.Forms.RadioButton chkCombined;

      [System.Diagnostics.DebuggerStepThrough()]private void InitializeComponent()
      {
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.PictureBox1 = new System.Windows.Forms.PictureBox();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.GroupBox2 = new System.Windows.Forms.GroupBox();
         this.GroupBox1 = new System.Windows.Forms.GroupBox();
         this.GroupBox5 = new System.Windows.Forms.GroupBox();
         this.groupBox4 = new System.Windows.Forms.GroupBox();
         this.chkMarketState = new System.Windows.Forms.CheckBox();
         this.chkNetChange = new System.Windows.Forms.CheckBox();
         this.chkTotalVolumes = new System.Windows.Forms.CheckBox();
         this.chkDOMStatus = new System.Windows.Forms.CheckBox();
         this.groupBox7 = new System.Windows.Forms.GroupBox();
         this.chkQuotes = new System.Windows.Forms.CheckBox();
         this.chkBBA = new System.Windows.Forms.CheckBox();
         this.GroupBox6 = new System.Windows.Forms.GroupBox();
         this.chkImplied = new System.Windows.Forms.RadioButton();
         this.chkOutright = new System.Windows.Forms.RadioButton();
         this.chkCombined = new System.Windows.Forms.RadioButton();
         this.btnApply = new System.Windows.Forms.Button();
         this.txtSymbol = new System.Windows.Forms.TextBox();
         this.Label4 = new System.Windows.Forms.Label();
         this.btnSubscribe = new System.Windows.Forms.Button();
         this.btnRemoveAll = new System.Windows.Forms.Button();
         this.btnRemove = new System.Windows.Forms.Button();
         this.lstInstruments = new System.Windows.Forms.ListBox();
         this.gbProperties = new System.Windows.Forms.GroupBox();
         this.gbQuotes = new System.Windows.Forms.GroupBox();
         this.gbDOM = new System.Windows.Forms.GroupBox();
         this.gbSessions = new System.Windows.Forms.GroupBox();
         this.GroupBox2.SuspendLayout();
         this.GroupBox1.SuspendLayout();
         this.GroupBox5.SuspendLayout();
         this.groupBox4.SuspendLayout();
         this.groupBox7.SuspendLayout();
         this.GroupBox6.SuspendLayout();
         this.SuspendLayout();
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblDataConnection.Location = new System.Drawing.Point(16, 8);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
         this.lblDataConnection.TabIndex = 17;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // PictureBox1
         // 
         this.PictureBox1.BackColor = System.Drawing.Color.Black;
         this.PictureBox1.Location = new System.Drawing.Point(0, 32);
         this.PictureBox1.Name = "PictureBox1";
         this.PictureBox1.Size = new System.Drawing.Size(1272, 8);
         this.PictureBox1.TabIndex = 15;
         this.PictureBox1.TabStop = false;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.SystemColors.Control;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
         this.llWeb.Location = new System.Drawing.Point(656, 8);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(408, 16);
         this.llWeb.TabIndex = 22;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
         // 
         // GroupBox2
         // 
         this.GroupBox2.Controls.Add(this.GroupBox1);
         this.GroupBox2.Controls.Add(this.txtSymbol);
         this.GroupBox2.Controls.Add(this.Label4);
         this.GroupBox2.Controls.Add(this.btnSubscribe);
         this.GroupBox2.Controls.Add(this.btnRemoveAll);
         this.GroupBox2.Controls.Add(this.btnRemove);
         this.GroupBox2.Controls.Add(this.lstInstruments);
         this.GroupBox2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox2.Location = new System.Drawing.Point(8, 48);
         this.GroupBox2.Name = "GroupBox2";
         this.GroupBox2.Size = new System.Drawing.Size(232, 792);
         this.GroupBox2.TabIndex = 43;
         this.GroupBox2.TabStop = false;
         this.GroupBox2.Text = "Instruments";
         // 
         // GroupBox1
         // 
         this.GroupBox1.Controls.Add(this.GroupBox5);
         this.GroupBox1.Controls.Add(this.btnApply);
         this.GroupBox1.Location = new System.Drawing.Point(16, 288);
         this.GroupBox1.Name = "GroupBox1";
         this.GroupBox1.Size = new System.Drawing.Size(208, 416);
         this.GroupBox1.TabIndex = 3;
         this.GroupBox1.TabStop = false;
         // 
         // GroupBox5
         // 
         this.GroupBox5.Controls.Add(this.groupBox4);
         this.GroupBox5.Controls.Add(this.chkDOMStatus);
         this.GroupBox5.Controls.Add(this.groupBox7);
         this.GroupBox5.Controls.Add(this.GroupBox6);
         this.GroupBox5.Location = new System.Drawing.Point(8, 16);
         this.GroupBox5.Name = "GroupBox5";
         this.GroupBox5.Size = new System.Drawing.Size(192, 352);
         this.GroupBox5.TabIndex = 4;
         this.GroupBox5.TabStop = false;
         this.GroupBox5.Text = "Data Subscription Options";
         // 
         // groupBox4
         // 
         this.groupBox4.Controls.Add(this.chkMarketState);
         this.groupBox4.Controls.Add(this.chkNetChange);
         this.groupBox4.Controls.Add(this.chkTotalVolumes);
         this.groupBox4.Location = new System.Drawing.Point(8, 24);
         this.groupBox4.Name = "groupBox4";
         this.groupBox4.Size = new System.Drawing.Size(176, 104);
         this.groupBox4.TabIndex = 5;
         this.groupBox4.TabStop = false;
         this.groupBox4.Text = "Property Level Options";
         // 
         // chkMarketState
         // 
         this.chkMarketState.Location = new System.Drawing.Point(8, 24);
         this.chkMarketState.Name = "chkMarketState";
         this.chkMarketState.TabIndex = 6;
         this.chkMarketState.Text = "Market State";
         this.chkMarketState.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // chkNetChange
         // 
         this.chkNetChange.Location = new System.Drawing.Point(8, 48);
         this.chkNetChange.Name = "chkNetChange";
         this.chkNetChange.TabIndex = 7;
         this.chkNetChange.Text = "Net Change";
         this.chkNetChange.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // chkTotalVolumes
         // 
         this.chkTotalVolumes.Location = new System.Drawing.Point(8, 72);
         this.chkTotalVolumes.Name = "chkTotalVolumes";
         this.chkTotalVolumes.Size = new System.Drawing.Size(120, 24);
         this.chkTotalVolumes.TabIndex = 8;
         this.chkTotalVolumes.Text = "Total Volumes";
         this.chkTotalVolumes.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // chkDOMStatus
         // 
         this.chkDOMStatus.Location = new System.Drawing.Point(16, 320);
         this.chkDOMStatus.Name = "chkDOMStatus";
         this.chkDOMStatus.TabIndex = 12;
         this.chkDOMStatus.Text = "DOM Status";
         this.chkDOMStatus.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // groupBox7
         // 
         this.groupBox7.Controls.Add(this.chkQuotes);
         this.groupBox7.Controls.Add(this.chkBBA);
         this.groupBox7.Location = new System.Drawing.Point(8, 128);
         this.groupBox7.Name = "groupBox7";
         this.groupBox7.Size = new System.Drawing.Size(176, 80);
         this.groupBox7.TabIndex = 9;
         this.groupBox7.TabStop = false;
         this.groupBox7.Text = "Quote Level Options";
         // 
         // chkQuotes
         // 
         this.chkQuotes.Location = new System.Drawing.Point(8, 24);
         this.chkQuotes.Name = "chkQuotes";
         this.chkQuotes.TabIndex = 10;
         this.chkQuotes.Text = "Quotes";
         this.chkQuotes.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // chkBBA
         // 
         this.chkBBA.Location = new System.Drawing.Point(8, 48);
         this.chkBBA.Name = "chkBBA";
         this.chkBBA.TabIndex = 11;
         this.chkBBA.Text = "BBA";
         this.chkBBA.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // GroupBox6
         // 
         this.GroupBox6.Controls.Add(this.chkImplied);
         this.GroupBox6.Controls.Add(this.chkOutright);
         this.GroupBox6.Controls.Add(this.chkCombined);
         this.GroupBox6.Location = new System.Drawing.Point(8, 208);
         this.GroupBox6.Name = "GroupBox6";
         this.GroupBox6.Size = new System.Drawing.Size(176, 104);
         this.GroupBox6.TabIndex = 44;
         this.GroupBox6.TabStop = false;
         this.GroupBox6.Text = "BBAType";
         // 
         // chkImplied
         // 
         this.chkImplied.Location = new System.Drawing.Point(8, 24);
         this.chkImplied.Name = "chkImplied";
         this.chkImplied.TabIndex = 0;
         this.chkImplied.Text = "Implied";
         this.chkImplied.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // chkOutright
         // 
         this.chkOutright.Location = new System.Drawing.Point(8, 48);
         this.chkOutright.Name = "chkOutright";
         this.chkOutright.TabIndex = 0;
         this.chkOutright.Text = "Outright";
         this.chkOutright.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // chkCombined
         // 
         this.chkCombined.Location = new System.Drawing.Point(8, 72);
         this.chkCombined.Name = "chkCombined";
         this.chkCombined.TabIndex = 0;
         this.chkCombined.Text = "Combined";
         this.chkCombined.CheckedChanged += new System.EventHandler(this.DataSubscriptionOptionsChanged);
         // 
         // btnApply
         // 
         this.btnApply.BackColor = System.Drawing.SystemColors.Control;
         this.btnApply.Enabled = false;
         this.btnApply.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
         this.btnApply.Location = new System.Drawing.Point(56, 376);
         this.btnApply.Name = "btnApply";
         this.btnApply.Size = new System.Drawing.Size(96, 32);
         this.btnApply.TabIndex = 11;
         this.btnApply.Text = "Apply";
         this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
         // 
         // txtSymbol
         // 
         this.txtSymbol.Enabled = false;
         this.txtSymbol.Location = new System.Drawing.Point(80, 24);
         this.txtSymbol.Name = "txtSymbol";
         this.txtSymbol.Size = new System.Drawing.Size(136, 22);
         this.txtSymbol.TabIndex = 0;
         this.txtSymbol.Text = "";
         this.txtSymbol.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtSymbol_KeyDown);
         this.txtSymbol.TextChanged += new System.EventHandler(this.txtSymbol_TextChanged);
         // 
         // Label4
         // 
         this.Label4.BackColor = System.Drawing.SystemColors.Control;
         this.Label4.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Label4.ForeColor = System.Drawing.SystemColors.ControlText;
         this.Label4.Location = new System.Drawing.Point(16, 24);
         this.Label4.Name = "Label4";
         this.Label4.Size = new System.Drawing.Size(64, 21);
         this.Label4.TabIndex = 43;
         this.Label4.Text = "Symbol :";
         this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // btnSubscribe
         // 
         this.btnSubscribe.BackColor = System.Drawing.SystemColors.Control;
         this.btnSubscribe.Enabled = false;
         this.btnSubscribe.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
         this.btnSubscribe.Location = new System.Drawing.Point(32, 56);
         this.btnSubscribe.Name = "btnSubscribe";
         this.btnSubscribe.Size = new System.Drawing.Size(168, 25);
         this.btnSubscribe.TabIndex = 1;
         this.btnSubscribe.Text = "Subscribe";
         this.btnSubscribe.Click += new System.EventHandler(this.btnSubscribe_Click);
         // 
         // btnRemoveAll
         // 
         this.btnRemoveAll.BackColor = System.Drawing.SystemColors.Control;
         this.btnRemoveAll.Enabled = false;
         this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
         this.btnRemoveAll.Location = new System.Drawing.Point(120, 736);
         this.btnRemoveAll.Name = "btnRemoveAll";
         this.btnRemoveAll.Size = new System.Drawing.Size(104, 25);
         this.btnRemoveAll.TabIndex = 13;
         this.btnRemoveAll.Text = "Remove All";
         this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
         // 
         // btnRemove
         // 
         this.btnRemove.BackColor = System.Drawing.SystemColors.Control;
         this.btnRemove.Enabled = false;
         this.btnRemove.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
         this.btnRemove.Location = new System.Drawing.Point(8, 736);
         this.btnRemove.Name = "btnRemove";
         this.btnRemove.Size = new System.Drawing.Size(104, 25);
         this.btnRemove.TabIndex = 12;
         this.btnRemove.Text = "Remove Selected";
         this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
         // 
         // lstInstruments
         // 
         this.lstInstruments.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lstInstruments.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lstInstruments.ItemHeight = 16;
         this.lstInstruments.Location = new System.Drawing.Point(8, 88);
         this.lstInstruments.Name = "lstInstruments";
         this.lstInstruments.Size = new System.Drawing.Size(216, 194);
         this.lstInstruments.TabIndex = 2;
         this.lstInstruments.SelectedIndexChanged += new System.EventHandler(this.lstInstruments_SelectedIndexChanged);
         // 
         // gbProperties
         // 
         this.gbProperties.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.gbProperties.Location = new System.Drawing.Point(248, 48);
         this.gbProperties.Name = "gbProperties";
         this.gbProperties.Size = new System.Drawing.Size(448, 672);
         this.gbProperties.TabIndex = 44;
         this.gbProperties.TabStop = false;
         this.gbProperties.Text = "Instrument Properties";
         // 
         // gbQuotes
         // 
         this.gbQuotes.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.gbQuotes.Location = new System.Drawing.Point(704, 48);
         this.gbQuotes.Name = "gbQuotes";
         this.gbQuotes.Size = new System.Drawing.Size(368, 352);
         this.gbQuotes.TabIndex = 45;
         this.gbQuotes.TabStop = false;
         this.gbQuotes.Text = "Quotes";
         // 
         // gbDOM
         // 
         this.gbDOM.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.gbDOM.ForeColor = System.Drawing.SystemColors.ControlText;
         this.gbDOM.Location = new System.Drawing.Point(704, 400);
         this.gbDOM.Name = "gbDOM";
         this.gbDOM.Size = new System.Drawing.Size(368, 320);
         this.gbDOM.TabIndex = 46;
         this.gbDOM.TabStop = false;
         this.gbDOM.Text = "Depth Of Market(DOM)";
         // 
         // gbSessions
         // 
         this.gbSessions.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.gbSessions.Location = new System.Drawing.Point(248, 720);
         this.gbSessions.Name = "gbSessions";
         this.gbSessions.Size = new System.Drawing.Size(824, 120);
         this.gbSessions.TabIndex = 47;
         this.gbSessions.TabStop = false;
         this.gbSessions.Text = "Sessions";
         // 
         // frmInstrumentPropertiesNewMode
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.BackColor = System.Drawing.SystemColors.Control;
         this.ClientSize = new System.Drawing.Size(1082, 848);
         this.Controls.Add(this.gbSessions);
         this.Controls.Add(this.gbDOM);
         this.Controls.Add(this.gbQuotes);
         this.Controls.Add(this.gbProperties);
         this.Controls.Add(this.GroupBox2);
         this.Controls.Add(this.lblDataConnection);
         this.Controls.Add(this.PictureBox1);
         this.Controls.Add(this.llWeb);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
         this.MaximizeBox = false;
         this.Name = "frmInstrumentPropertiesNewMode";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "Instrument Properties (New Mode)";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmInstrumentProperties_Closing);
         this.Load += new System.EventHandler(this.frmInstrumentProperties_Load);
         this.GroupBox2.ResumeLayout(false);
         this.GroupBox1.ResumeLayout(false);
         this.GroupBox5.ResumeLayout(false);
         this.groupBox4.ResumeLayout(false);
         this.groupBox7.ResumeLayout(false);
         this.GroupBox6.ResumeLayout(false);
         this.ResumeLayout(false);

      }
      
      #endregion
      
      /// <summary>
      /// Create an m_CEL object, change its configurations, start up and initialize HashTable and grids.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void frmInstrumentProperties_Load(System.Object sender, System.EventArgs e)
      {
         try
         {
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
            
            m_CEL = new CQGCEL();
            m_CEL.DataConnectionStatusChanged += new _ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
            m_CEL.InstrumentResolved += CEL_InstrumentResolved;
            m_CEL.InstrumentChanged += new _ICQGCELEvents_InstrumentChangedEventHandler(CEL_InstrumentChanged);
            m_CEL.InstrumentDOMChanged += new _ICQGCELEvents_InstrumentDOMChangedEventHandler(CEL_InstrumentDOMChanged);
            m_CEL.DataError += new _ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
            m_CEL.APIConfiguration.CollectionsThrowException = false;
            m_CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
            m_CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;
            m_CEL.APIConfiguration.NewInstrumentMode = true;
            m_CEL.APIConfiguration.GatewayEnabled = false;

            m_CEL.Startup();
            
            InitPropertyFields();
            InitQuoteFields();
            InitDOMFields();
            InitSessionsFields();
            OnInstrumentsListBoxChange();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "frmInstrumentProperties_Load", ex);
         }
      }

      /// <summary>
      /// Initialize the properties hash table.
      /// </summary>
      private void InitPropertiesTable()
      {
         m_PropTypeToData = new Hashtable();
         
         int row = 0;

         m_PropTypeToData.Add(eInstrumentProperty.ipFullName, new DataHolder(row++, "FullName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDescription, new DataHolder(row++, "Description"));
         m_PropTypeToData.Add(eInstrumentProperty.ipInstrumentID, new DataHolder(row++, "InstrumentID"));
         m_PropTypeToData.Add(eInstrumentProperty.ipCurrency, new DataHolder(row++, "Currency"));
         m_PropTypeToData.Add(eInstrumentProperty.ipExpirationDate, new DataHolder(row++, "ExpirationDate"));
         m_PropTypeToData.Add(eInstrumentProperty.ipFirstNoticeDate, new DataHolder(row++, "FirstNoticeDate"));
         m_PropTypeToData.Add(eInstrumentProperty.ipInitialMargin, new DataHolder(row++, "InitialMargin"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMaintenanceMargin, new DataHolder(row++, "MaintenanceMargin"));
         m_PropTypeToData.Add(eInstrumentProperty.ipSessionMask, new DataHolder(row++, "SessionMask"));
         m_PropTypeToData.Add(eInstrumentProperty.ipCommodity, new DataHolder(row++, "Commodity"));
         m_PropTypeToData.Add(eInstrumentProperty.ipCountry, new DataHolder(row++, "Country"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMonthChar, new DataHolder(row++, "MonthChar"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMonth, new DataHolder(row++, "Month"));
         m_PropTypeToData.Add(eInstrumentProperty.ipStrike, new DataHolder(row++, "Strike"));
         m_PropTypeToData.Add(eInstrumentProperty.ipInstrumentType, new DataHolder(row++, "InstrumentType"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYear, new DataHolder(row++, "Year"));
         m_PropTypeToData.Add(eInstrumentProperty.ipTickSize, new DataHolder(row++, "TickSize"));
         m_PropTypeToData.Add(eInstrumentProperty.ipTickValue, new DataHolder(row++, "TickValue"));
         m_PropTypeToData.Add(eInstrumentProperty.ipSessionNumber, new DataHolder(row++, "SessionNumber"));
         m_PropTypeToData.Add(eInstrumentProperty.ipNetChange, new DataHolder(row++, "NetChange"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDTE, new DataHolder(row++, "DTE"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYCOI, new DataHolder(row++, "CYOI"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsDownTick, new DataHolder(row++, "IsDownTick"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsUpTick, new DataHolder(row++, "IsUpTick"));         
         m_PropTypeToData.Add(eInstrumentProperty.ipIsFastMarket, new DataHolder(row++, "IsFastMarket"));
         m_PropTypeToData.Add(eInstrumentProperty.ipMarketState, new DataHolder(row++, "MarketState"));
         m_PropTypeToData.Add(eInstrumentProperty.ipTodayCTotalVolume, new DataHolder(row++, "TodayCTotalVolume"));
         m_PropTypeToData.Add(eInstrumentProperty.ipPreferredSessionName, new DataHolder(row++, "PreferredSessionName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipDelayTime, new DataHolder(row++, "DelayTime"));
         m_PropTypeToData.Add(eInstrumentProperty.ipExchangeAbbreviation, new DataHolder(row++, "ExchangeAbbreviation"));
         m_PropTypeToData.Add(eInstrumentProperty.ipExchangeID, new DataHolder(row++, "ExchangeID"));
         m_PropTypeToData.Add(eInstrumentProperty.ipLeadingContractName, new DataHolder(row++, "LeadingContractName"));
         m_PropTypeToData.Add(eInstrumentProperty.ipYesterdayCTotalVolume, new DataHolder(row++, "YesterdayCTotalVolume"));
         m_PropTypeToData.Add(eInstrumentProperty.ipWorkup, new DataHolder(row++, "Workup"));
         m_PropTypeToData.Add(eInstrumentProperty.ipIsFutureStyleOption, new DataHolder(row++, "Future Style Option"));
      }
      
      /// <summary>
      /// Initialize the quotes hash table.
      /// </summary>
      private void InitQuotesTable()
      {
         m_QuoteTypeToData = new Hashtable();
         
         int row = 0;

         m_QuoteTypeToData.Add(eQuoteType.qtAsk, new DataHolder(row++, "Ask"));
         m_QuoteTypeToData.Add(eQuoteType.qtBid, new DataHolder(row++, "Bid"));
         m_QuoteTypeToData.Add(eQuoteType.qtTrade, new DataHolder(row++, "Trade"));
         m_QuoteTypeToData.Add(eQuoteType.qtCohUndAsk, new DataHolder(row++, "CohUndAsk"));
         m_QuoteTypeToData.Add(eQuoteType.qtCohUndBid, new DataHolder(row++, "CohUndBid"));
         m_QuoteTypeToData.Add(eQuoteType.qtImpliedAsk, new DataHolder(row++, "ImpliedAsk"));
         m_QuoteTypeToData.Add(eQuoteType.qtImpliedBid, new DataHolder(row++, "ImpliedBid"));
         m_QuoteTypeToData.Add(eQuoteType.qtOutrightAsk, new DataHolder(row++, "OutrightAsk"));
         m_QuoteTypeToData.Add(eQuoteType.qtOutrightBid, new DataHolder(row++, "OutrightBid"));
         m_QuoteTypeToData.Add(eQuoteType.qtDayOpen, new DataHolder(row++, "DayOpen"));
         m_QuoteTypeToData.Add(eQuoteType.qtDayHigh, new DataHolder(row++, "DayHigh"));
         m_QuoteTypeToData.Add(eQuoteType.qtDayLow, new DataHolder(row++, "DayLow"));
         m_QuoteTypeToData.Add(eQuoteType.qtIndicativeOpen, new DataHolder(row++, "IndicativeOpen"));
         m_QuoteTypeToData.Add(eQuoteType.qtSettlement, new DataHolder(row++, "Settlement"));
         m_QuoteTypeToData.Add(eQuoteType.qtYesterdaySettlement, new DataHolder(row++, "YesterdaySettlement"));
         m_QuoteTypeToData.Add(eQuoteType.qtMarker, new DataHolder(row++, "Marker"));
         m_QuoteTypeToData.Add(eQuoteType.qtTodayMarker, new DataHolder(row++, "TodayMarker"));
      }

      /// <summary>
      /// Create and initialize the grid of properties.
      /// </summary>
      private void InitPropertyFields()
      {
         InitPropertiesTable();
     
         m_PropertiesGrid = new CQGMiniGrid(2, m_PropTypeToData.Count, gbProperties);
         
         m_PropertiesGrid.SetColumnWidth(0, 152);
         m_PropertiesGrid.SetColumnWidth(1, 282);
         
         m_PropertiesGrid.SetHeaderValue(0, "Property Name");
         m_PropertiesGrid.SetHeaderValue(1, "Value");

         DataHolder propHld;
         foreach (DictionaryEntry item in m_PropTypeToData)
         {
            propHld = (DataHolder)item.Value;
            m_PropertiesGrid[propHld.Row, 0].Text = propHld.Name;
         }
      }
      
      /// <summary>
      /// Create and initialize the grid of quotes.
      /// </summary>
      private void InitQuoteFields()
      {
         InitQuotesTable();
     
         m_QuotesGrid = new CQGMiniGrid(4, 17, gbQuotes);
         
         m_QuotesGrid.SetColumnWidth(0, 135);
         m_QuotesGrid.SetHeaderValue(0, "Quote Name");
         m_QuotesGrid.SetColumnWidth(1, 70);
         m_QuotesGrid.SetHeaderValue(1, "Price");
         m_QuotesGrid.SetColumnWidth(2, 63);
         m_QuotesGrid.SetHeaderValue(2, "Volume");
         m_QuotesGrid.SetColumnWidth(3, 90);
         m_QuotesGrid.SetHeaderValue(3, "Display Price");

         DataHolder quoteHld;
         foreach (DictionaryEntry item in m_QuoteTypeToData)
         {
            quoteHld = (DataHolder)item.Value;
            m_QuotesGrid[quoteHld.Row, 0].Text = quoteHld.Name;
         }
      }
      
      /// <summary>
      /// Create and initialize the grid of DOM.
      /// </summary>
      private void InitDOMFields()
      {
         m_DOMGrid = new CQGMiniGrid(3, 14, gbDOM);
         
         m_DOMGrid.SetColumnWidth(0, 119);
         m_DOMGrid.SetColumnAlign(0, ContentAlignment.MiddleRight);
         m_DOMGrid.SetHeaderValue(0, "Ask Volume");
         m_DOMGrid.SetColumnWidth(1, 115);
         m_DOMGrid.SetColumnAlign(1, ContentAlignment.MiddleCenter);
         m_DOMGrid.SetHeaderValue(1, "Price");
         m_DOMGrid.SetColumnWidth(2, 120);
         m_DOMGrid.SetColumnAlign(2, ContentAlignment.MiddleLeft);
         m_DOMGrid.SetHeaderValue(2, "Bid Volume");
      }
      
      /// <summary>
      /// Create and initialize the grid of sessions.
      /// </summary>
      private void InitSessionsFields()
      {
         m_SessionsGrid = new CQGMiniGrid(8, 4, gbSessions);
         
         m_SessionsGrid.SetColumnWidth(0, 170);
         m_SessionsGrid.SetHeaderValue(0, "Name");
         
         m_SessionsGrid.SetColumnWidth(1, 57);
         m_SessionsGrid.SetColumnAlign(1, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(1, "Number");
         
         m_SessionsGrid.SetColumnWidth(2, 156);
         m_SessionsGrid.SetColumnAlign(2, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(2, "Activation Date");
         
         m_SessionsGrid.SetColumnWidth(3, 69);
         m_SessionsGrid.SetColumnAlign(3, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(3, "Start Time");
         
         m_SessionsGrid.SetColumnWidth(4, 69);
         m_SessionsGrid.SetColumnAlign(4, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(4, "End Time");
         
         m_SessionsGrid.SetColumnWidth(5, 72);
         m_SessionsGrid.SetColumnAlign(5, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(5, "Is Primary");
         
         m_SessionsGrid.SetColumnWidth(6, 82);
         m_SessionsGrid.SetColumnAlign(6, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(6, "Type");
         
         m_SessionsGrid.SetColumnWidth(7, 125);
         m_SessionsGrid.SetColumnAlign(7, ContentAlignment.MiddleCenter);
         m_SessionsGrid.SetHeaderValue(7, "Working Week Days");
      }
      
      /// <summary>
      /// Shut down m_CEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A CancelEventArgs that contains the event data.
      /// </param>
      private void frmInstrumentProperties_Closing(object sender, System.ComponentModel.CancelEventArgs e)
      {
         try
         {
            m_CEL.Shutdown();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "frmInstrumentProperties_Closing", ex);
         }
      }
      
      /// <summary>
      /// This event is fired, when some changes occur in the connection with the CQG data server.
      /// </summary>
      /// <param name="newStatus">
      /// The current status of the connection with the data server.
      /// </param>
      private void CEL_DataConnectionStatusChanged(eConnectionStatus newStatus)
      {
         try
         {
            string info;
            System.Drawing.Color BackCol;

            if (newStatus != eConnectionStatus.csConnectionUp)
            {
               BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
               info= "DATA Connection is " + (newStatus == eConnectionStatus.csConnectionDelayed ? 
                                                                     "Delayed" : "Down").ToString();
               
               txtSymbol.Text = "";
               txtSymbol.Enabled = false;
            }
            else
            {
               BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
               info= "DATA Connection is UP";
               
               txtSymbol.Enabled = true;
            }
            
            lblDataConnection.BackColor = BackCol;
            lblDataConnection.Text = info;
            btnSubscribe.Enabled = false;
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "CEL_DataConnectionStatusChanged", ex);
         }
      }

      /// <summary>
      /// This event is fired when a new instrument is resolved and subscribed or resolution failed.
      /// </summary>
      /// <param name="symbl">
      /// The commodity symbol that was requested by the user in the NewInstrument method.
      /// </param>
      /// <param name="instrument">
      /// The resolved CQGInstrument object.
      /// </param>
      /// <param name="error">
      /// CQGError instance. It is null in case resolution success.
      /// </param>
      private void CEL_InstrumentResolved(string symbl, CQGInstrument instrument, CQGError error)
      {
         try
         {
            if (m_CEL.IsValid(error))
            {
               incorrectSymbolProcessing(symbl, error);
               return;
            }

            instrumentSubscribed(symbl, instrument);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "CEL_InstrumentResolved", ex);
         }
      }

      /// <summary>
      /// Failed symbol resolution processing.
      /// </summary>
      /// <param name="symbl">
      /// The name of the incorrect symbol, i.e., what was passed to the NewInstrument method.
      /// </param>
      /// <param name="error">
      /// CQGError instance. It is null in case resolution success.
      /// </param>
      private void incorrectSymbolProcessing(string symbl, CQGError error)
      {
         ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "incorrectSymbolProcessing", error);

         txtSymbol.Clear();
         txtSymbol.Enabled = (m_CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp);
         btnSubscribe.Enabled = false;
         txtSymbol.Focus();
      }
      
      /// <summary>
      /// Instrument is resolved and subscribed processing.
      /// </summary>
      /// <param name="symbl">
      /// The commodity symbol that was requested by the user in the NewInstrument method.
      /// </param>
      /// <param name="instrument">
      /// The resolved CQGInstrument object.
      /// </param>
      private void instrumentSubscribed(string symbl, CQGInstrument instrument)
      {
         int index = lstInstruments.Items.IndexOf(instrument.FullName);
         if (index == - 1)
         {
            lstInstruments.Items.Add(instrument.FullName);
            lstInstruments.SelectedIndex = lstInstruments.Items.Count - 1;
         }
         else
         {
            lstInstruments.SelectedIndex = index;
            OnInstrumentsListBoxChange();
         }
      }
      
      /// <summary>
      /// This event is fired when any of the instrument quotes or dynamic instrument properties are changed.
      /// </summary>
      /// <param name="Instrument">
      /// The changed instrument.
      /// </param>
      /// <param name="Quotes">
      /// The collection of changed quotes.
      /// </param>
      /// <param name="props">
      /// The collection of changed dynamic properties.
      /// </param>
      private void CEL_InstrumentChanged(CQGInstrument instrument, 
                                 CQGQuotes quotes, 
                                 CQGInstrumentProperties props)
      {
         try
         {
            if (instrument.FullName == m_InstrumentFullName)
            {
               DisplayProperties(props);
               DisplayQuotes(quotes);
               if (props[eInstrumentProperty.ipSessionNumber] != null)
               {
                  DisplaySessions(instrument.Sessions);
               }
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "CEL_InstrumentChanged", ex);
         }
      }
      
      /// <summary>
      /// This event is fired when instrument's DOM is updated.
      /// </summary>
      /// <param name="Instrument">
      /// Changed instrument: its DOMAsks and DOMBids collections contain new DOM book.
      /// </param>
      /// <param name="prevAsks">
      /// The collection of asks from the previous DOM book.
      /// </param>
      /// <param name="prevBids">
      /// The collection of bids from the previous DOM book.
      /// </param>
      private void CEL_InstrumentDOMChanged(CQGInstrument instrument, 
                                            CQGDOMQuotes prevAsks, 
                                            CQGDOMQuotes prevBids)
      {
         try
         {
            if (instrument.FullName == m_InstrumentFullName)
            {
               DisplayDOM(instrument);
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "CEL_InstrumentDOMChanged", ex);
         }
      }
      
      /// <summary>
      /// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
      /// </summary>
      /// <param name="obj">
      /// Object, in which the error occurred.
      /// </param>
      /// <param name="errorDescription">
      /// String, describing the error.
      /// </param>
      private void CEL_DataError(object obj, string errorDescription)
      {
         try
         {
            CQGError cqgErr = obj as CQGError;
            if (m_CEL.IsValid(cqgErr))
            {
               if (cqgErr.Code == 102)
               {
                  errorDescription += " Restart the application.";
               }
               else if (cqgErr.Code == 125)
               {
                  errorDescription += " Turn on CQG Client and restart the application.";
               }
            }
            
            MessageBox.Show(errorDescription, "InstrumentProperties", MessageBoxButtons.OK, MessageBoxIcon.Information);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "CEL_DataError", ex);
         }
      }
      
      /// <summary>
      /// Subscribe to a new instrument
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnSubscribe_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            if (txtSymbol.Text.Trim().Length > 0)
            {
               CQGInstrumentSubscriptionRequest rqst = m_CEL.CreateInstrumentRequest();
               rqst.DOMBBAType = CombineBBAType();
               rqst.DOMStatus = (chkDOMStatus.CheckState == CheckState.Checked);
               rqst.PropertyLevel = CombinePropertyLevel();
               rqst.QuoteLevel = CombineQuoteLevel();
               rqst.Symbol = txtSymbol.Text.Trim();
               m_CEL.SubscribeNewInstrument(rqst);
            }
            txtSymbol.Clear();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "btnSubscribe_Click", ex);
         }
      }
      
      /// <summary>
      /// Enable/disable the "Subscribe" button's status, if the Symbol's textbox is full/empty.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void txtSymbol_TextChanged(System.Object sender, System.EventArgs e)
      {
         btnSubscribe.Enabled = txtSymbol.Text.Trim().Length > 0;
      }
      
      /// <summary>
      /// When the "Enter" button is clicked, call btnSubscribe_Click sub, which subscribes to a new instrument.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A KeyEventArgs that contains the event data.
      /// </param>
      private void txtSymbol_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
      {
         if (e.KeyCode == Keys.Enter)
         {
            btnSubscribe_Click(sender, e);
         }
      }
      
      /// <summary>
      /// Open CQG API web page.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A LinkLabelLinkClickedEventArgs that contains the event data.
      /// </param>
      private void llWeb_LinkClicked(System.Object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
      {
         try
         {
            System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "llWeb_LinkClicked", ex);
         }
      }
      
      /// <summary>
      /// Remove the selected instrument.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRemove_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            RemoveInstrument();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "btnRemove_Click", ex);
         }
      }
      
      /// <summary>
      /// Remove all instrument.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            m_CEL.RemoveAllInstruments();
            lstInstruments.Items.Clear();
            OnInstrumentsListBoxChange();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "btnRemoveAll_Click", ex);
         }
      }
      
      /// <summary>
      /// Applies new DataSubscriptionLevel and/or BBAType.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnApply_Click(System.Object sender, System.EventArgs e)
      {
         try
         {  
            CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];

            ePropertySubscriptionLevel ePropLevel = CombinePropertyLevel();
            eQuoteSubscriptionLevel eQuoteLevel = CombineQuoteLevel();
            eDOMandBBAType eBBAtype = CombineBBAType();
            if (instrument.QuoteLevel != eQuoteLevel 
               || instrument.PropertyLevel != ePropLevel
               || instrument.DOMStatus != (chkDOMStatus.CheckState == CheckState.Checked)
               || instrument.BBAType != eBBAtype)
            {
               ResubscribeCurrentInstrument();
            }
               
            btnApply.Enabled = false;
         }
         catch (System.Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "btnApply_Click", ex);
         }
      }

      /// <summary>
      /// Applies new changed read-only data subscription options by removing subscribed instrument 
      /// and subscribing with new options.
      /// </summary>
      private void ResubscribeCurrentInstrument()
      {
         try
         {  
            CQGInstrumentSubscriptionRequest rqst = m_CEL.CreateInstrumentRequest();
            rqst.Symbol = m_InstrumentFullName;
            rqst.DOMBBAType = CombineBBAType();
            rqst.DOMStatus = (chkDOMStatus.CheckState == CheckState.Checked);
            rqst.PropertyLevel = CombinePropertyLevel();
            rqst.QuoteLevel = CombineQuoteLevel();
            DisplayProperties(null);
            DisplayQuotes(null);
            DisplayDOM(null);
            DisplaySessions(null);

            // Need to remove instrument before subscribing again
            RemoveInstrument();
            m_CEL.SubscribeNewInstrument(rqst);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "ResubscribeCurrentInstrument", ex);
         }
      }

      /// <summary>
      /// Removes instrument from CQGCEL instrument's collection and instruments' list
      /// </summary>
      private void RemoveInstrument() 
      {
         m_CEL.RemoveInstrument(m_CEL.Instruments[m_InstrumentFullName]);
         lstInstruments.Items.RemoveAt(lstInstruments.SelectedIndex);
         if (lstInstruments.Items.Count > 0)
         {
            if (lstInstruments.SelectedIndex == - 1)
            {
               lstInstruments.SelectedIndex = 0;
            }
         }
         else
         {
            OnInstrumentsListBoxChange();
         }
      }

      /// <summary>
      /// Combines the BBA Type according to checkboxes' state.
      /// </summary>
      /// <returns>
      /// The combined value
      /// </returns>
      private eDOMandBBAType CombineBBAType()
      {
         eDOMandBBAType res = eDOMandBBAType.dbtCombined;
         if (chkCombined.Checked)
         {
            res = eDOMandBBAType.dbtCombined;
         }
         else if (chkImplied.Checked)
         {
            res = eDOMandBBAType.dbtImplied;
         }
         else if (chkOutright.Checked)
         {
            res = eDOMandBBAType.dbtOutright;
         }
         return res;
      }

      /// <summary>
      /// Combines the Property subscription level according to checkboxes' state.
      /// </summary>
      /// <returns>
      /// The combined value
      /// </returns>
      private ePropertySubscriptionLevel CombinePropertyLevel()
      {
         ePropertySubscriptionLevel res = ePropertySubscriptionLevel.psNone;
         if (chkMarketState.Checked)
         {
            res |= ePropertySubscriptionLevel.psMarketState;
         }
         if (chkNetChange.Checked)
         {
            res |= ePropertySubscriptionLevel.psNetChange;
         }
         if (chkTotalVolumes.Checked)
         {
            res |= ePropertySubscriptionLevel.psTotalVolumes;
         }
         return res;
      }

      /// <summary>
      /// Combines the Quote subscription level according to checkboxes' state.
      /// </summary>
      /// <returns>
      /// The combined value
      /// </returns>
      private eQuoteSubscriptionLevel CombineQuoteLevel()
      {
         eQuoteSubscriptionLevel res = eQuoteSubscriptionLevel.qsNone;
         if (chkQuotes.Checked)
         {
            res |= eQuoteSubscriptionLevel.qsQuotes;
         }
         if (chkBBA.Checked)
         {
            res |= eQuoteSubscriptionLevel.qsBBA;
         }
         return res;
      }
      
      /// <summary>
      /// This event is fired when new DataSubscriptionLevel is selected
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data
      /// </param>
      private void DataSubscriptionOptionsChanged(System.Object sender, System.EventArgs e)
      {
         OnDataSubscriptionOptionsOrBBATypeChange();
      }
      
      /// <summary>
      /// This event is fired when a new Instrument is selected in the Instruments listbox.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void lstInstruments_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         try
         {
            OnInstrumentsListBoxChange();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "lstInstruments_SelectedIndexChanged", ex);
         }
      }
            
      /// <summary>
      /// Enable the "Apply" button, if new DataSubscriptionLevel and/or BBAType is selected.
      /// </summary>
      private void OnDataSubscriptionOptionsOrBBATypeChange()
      {
         try
         {
            CQGInstrument instrument = null;
            if (m_CEL == null || !m_CEL.IsStarted || (instrument = m_CEL.Instruments[m_InstrumentFullName]) == null)
            {
               return;
            }
            
            btnApply.Enabled = (CombinePropertyLevel() != instrument.PropertyLevel) 
                              || (CombineQuoteLevel() != instrument.QuoteLevel)
                              || (CombineBBAType() != instrument.BBAType)
                              || ((chkDOMStatus.CheckState == CheckState.Checked) != instrument.DOMStatus)
                              || (CombineBBAType() != instrument.BBAType);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmInstrumentPropertiesNewMode", "OnDataSubscriptionOptionsOrBBATypeChange", ex);
         }
      }
      
      /// <summary>
      /// Clear the grid, if an instrument is not selected, 
      /// otherwise fill/update params for the selected instrument.
      /// </summary>
      /// <param name="props">
      /// The collection of params, which were changed.
      /// </param>
      private void DisplayProperties(CQGInstrumentProperties props)
      {
         if (props == null)
         {
            m_PropertiesGrid.ClearColumn(1);
            return;
         }

         if (props.Count == 0)
         {
            return;
         }

         
         DataHolder propHld;
         string dispVal;
         foreach (DictionaryEntry item in m_PropTypeToData)
         {
            try
            {
               CQGInstrumentProperty prop = props[(eInstrumentProperty)item.Key];

               if (prop != null)
               {
                  dispVal = N_A;
                  if (m_CEL.IsValid(prop.Value))
                  {
                     if (prop.Type == eInstrumentProperty.ipInstrumentType)
                     {
                        dispVal = ((eInstrumentType)prop.Value).ToString();
                     }
                     else
                     {
                        dispVal = prop.Value.ToString();
                     }
                  }

                  propHld = (DataHolder)item.Value;
                  m_PropertiesGrid[propHld.Row, 1].Text = dispVal;
               }
            }
            catch (System.Exception ex)
            {
               string msg = "ERROR: " + ex.Message;
               if ((eInstrumentProperty)item.Key == eInstrumentProperty.ipTickSize)
               {
                  msg = "Variable tick size";
               }
               else if ((eInstrumentProperty)item.Key == eInstrumentProperty.ipTickValue)
               {
                  msg = "Variable tick value";
               }
               propHld = (DataHolder)item.Value;
               m_PropertiesGrid[propHld.Row, 1].Text = msg;
            }
         }
      }
      
      /// <summary>
      /// Clear the grid, if an instrument is not selected, 
      /// otherwise fill/update quotes for selected instrument.
      /// </summary>
      /// <param name="Quotes">
      /// The collection of quotes, which were changed.
      /// </param>
      private void DisplayQuotes(CQGQuotes quotes)
      {
         if (quotes == null)
         {
            m_QuotesGrid.ClearColumn(1);
            m_QuotesGrid.ClearColumn(2);
            m_QuotesGrid.ClearColumn(3);
            return;
         }
         
         CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];
         string dispPrice;
         string dispVol;
         string dispDisplayPrice;
         
         foreach (DictionaryEntry item in m_QuoteTypeToData)
         {
            CQGQuote quote = quotes[(eQuoteType)item.Key];

            if (quote != null)
            {
               if (quote.IsValid)
               {
                  dispPrice = quote.Price.ToString();
                  dispVol = quote.Volume.ToString();
                  dispDisplayPrice = instrument.ToDisplayPrice(quote.Price);
               }
               else
               {
                  dispPrice = N_A;
                  dispVol = N_A;
                  dispDisplayPrice = N_A;
               }

               DataHolder quoteHld = (DataHolder)item.Value;
               m_QuotesGrid[quoteHld.Row, 1].Text = dispPrice;
               m_QuotesGrid[quoteHld.Row, 2].Text = dispVol;
               m_QuotesGrid[quoteHld.Row, 3].Text = dispDisplayPrice;
            }
         }
      }
      
      /// <summary>
      /// Display information about sessions.
      /// </summary>
      private void DisplaySessions(CQGSessions sessions)
      {
         m_SessionsGrid.Clear();
         if (sessions == null)
         {
            return;
         }
         int i = -1;
         foreach (CQGSession session in sessions)
         {
            i++;
            if (i <= m_SessionsGrid.Rows)
            {
               m_SessionsGrid[i, 0].Text = session.Name;
               m_SessionsGrid[i, 1].Text = session.Number.ToString();
               if (m_CEL.IsValid(session.ActivationDate))
               {
                  m_SessionsGrid[i, 2].Text = session.ActivationDate.ToString();
               }
               else
               {
                  m_SessionsGrid[i, 2].Text = N_A;
               }
               if (m_CEL.IsValid(session.StartTime))
               {
                  m_SessionsGrid[i, 3].Text = session.StartTime.ToShortTimeString();
               }
               else
               {
                  m_SessionsGrid[i, 3].Text = N_A;
               }
               if (m_CEL.IsValid(session.EndTime))
               {
                  m_SessionsGrid[i, 4].Text = session.EndTime.ToShortTimeString();
               }
               else
               {
                  m_SessionsGrid[i, 4].Text = N_A;
               }
               m_SessionsGrid[i, 5].Text = (session.PrimaryFlag ? "Yes" : "No").ToString();
               m_SessionsGrid[i, 6].Text = session.Type.ToString();
               m_SessionsGrid[i, 7].Text = GetSessionWorkingDays(session.WorkingWeekDays);
            }
         }
      }
      
      /// <summary>
      /// Clear the grid, if an instrument is not selected, 
      /// otherwise fill/update DOMs for the selected instrument.
      /// </summary>
      /// <param name="Instrument">
      /// The instument, for which DOM was updated.
      /// </param>
      private void DisplayDOM(CQGInstrument instrument)
      {
         if (instrument == null)
         {
            m_DOMGrid.Clear();
            return;
         }
         int r = (int)(m_DOMGrid.Rows / 2);
         
         string dispPrice;
         string dispVol;
         CQGQuote qt;

         for (int i = 0; i < r; i++)
         {
            if (i < instrument.DOMAsks.Count)
            {
               qt = instrument.DOMAsks[i];
               if (qt.IsValid)
               {
                  dispPrice = instrument.ToDisplayPrice(qt.Price);
                  dispVol = qt.Volume.ToString();
               }
               else
               {
                  dispPrice = N_A;
                  dispVol = N_A;
               }
            }
            else
            {
               dispPrice = "";
               dispVol = "";
            }
            
            m_DOMGrid[r - 1 - i, 0].Text = dispVol;
            m_DOMGrid[r - 1 - i, 0].ForeColor = Color.Red;
            m_DOMGrid[r - 1 - i, 1].Text = dispPrice;
         }
         
         for (int i = r; i < m_DOMGrid.Rows; i++)
         {
            if (i - m_DOMGrid.Rows / 2 < instrument.DOMBids.Count)
            {
               qt = instrument.DOMBids[i - r];
               if (qt.IsValid)
               {
                  dispPrice = instrument.ToDisplayPrice(qt.Price);
                  dispVol = qt.Volume.ToString();
               }
               else
               {
                  dispPrice = N_A;
                  dispVol = N_A;
               }
            }
            else
            {
               dispPrice = "";
               dispVol = "";
            }
            
            m_DOMGrid[i, 1].Text = dispPrice;
            m_DOMGrid[i, 2].Text = dispVol;
            m_DOMGrid[i, 2].ForeColor = Color.Green;
         }
      }
      
      /// <summary>
      /// This sub is called, if there was any change connected with the 
      /// instruments (Add/Remove/Remove All/Selection Change).
      /// </summary>
      private void OnInstrumentsListBoxChange()
      {
         if (lstInstruments.Items.Count == 0)
         {
            ResetOptionValues(null);
         }
         else
         {
            btnRemoveAll.Enabled = true;
         }
         
         ClearAll();

         if (lstInstruments.SelectedIndex > - 1)
         {
            btnRemove.Enabled = true;
            m_InstrumentFullName = lstInstruments.Items[lstInstruments.SelectedIndex].ToString();
            
            CQGInstrument instrument = m_CEL.Instruments[m_InstrumentFullName];
            DisplayProperties(instrument.Properties);
            DisplayQuotes(instrument.Quotes);
            DisplayDOM(instrument);
            DisplaySessions(instrument.Sessions);
            ResetOptionValues(instrument);
         }
      }
      
      /// <summary>
      /// Return the session's week working days in this format: "SMTWTFS".
      /// </summary>
      /// <param name="weekDay">
      /// eSessionWeekDays bitmask, which contains information about working days.
      /// </param>
      /// <returns>
      /// String, which contains working days.
      /// </returns>
      private static string GetSessionWorkingDays(eSessionWeekDays weekDay)
      {
         string sResult;
         
         sResult = (((weekDay & eSessionWeekDays.swdSunday) == eSessionWeekDays.swdSunday) ? "S" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdMonday) == eSessionWeekDays.swdMonday) ? "M" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdTuesday) == eSessionWeekDays.swdTuesday) ? "T" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdWednesday) == eSessionWeekDays.swdWednesday) ? "W" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdThursday) == eSessionWeekDays.swdThursday) ? "T" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdFriday) == eSessionWeekDays.swdFriday) ? "F" : "-").ToString();
         sResult += (((weekDay & eSessionWeekDays.swdSaturday) == eSessionWeekDays.swdSaturday) ? "S" : "-").ToString();
         
         return sResult;
      }

      /// <summary>
      /// Clears all data
      /// </summary>
      private void ClearAll()
      {
         btnRemove.Enabled = false;

         m_InstrumentFullName = "";
         DisplayProperties(null);
         DisplayQuotes(null);
         DisplayDOM(null);
         DisplaySessions(null);
      }

      /// <summary>
      /// Resets all the options to their default values
      /// </summary>
      private void ResetOptionValues(CQGInstrument instrument)
      {
         chkMarketState.Checked = instrument != null && ((instrument.PropertyLevel & ePropertySubscriptionLevel.psMarketState) == ePropertySubscriptionLevel.psMarketState);
         chkNetChange.Checked = instrument != null && ((instrument.PropertyLevel & ePropertySubscriptionLevel.psNetChange) == ePropertySubscriptionLevel.psNetChange);
         chkTotalVolumes.Checked = instrument != null && ((instrument.PropertyLevel & ePropertySubscriptionLevel.psTotalVolumes) == ePropertySubscriptionLevel.psTotalVolumes);

         chkQuotes.Checked = instrument != null && ((instrument.QuoteLevel & eQuoteSubscriptionLevel.qsQuotes) == eQuoteSubscriptionLevel.qsQuotes);
         chkBBA.Checked = instrument != null && ((instrument.QuoteLevel & eQuoteSubscriptionLevel.qsBBA) == eQuoteSubscriptionLevel.qsBBA);
      
         if (instrument != null)
         {
            chkCombined.Checked = (instrument.BBAType & eDOMandBBAType.dbtCombined) == eDOMandBBAType.dbtCombined;
            chkImplied.Checked = (instrument.BBAType & eDOMandBBAType.dbtImplied) == eDOMandBBAType.dbtImplied;
            chkOutright.Checked = (instrument.BBAType & eDOMandBBAType.dbtOutright) == eDOMandBBAType.dbtOutright;
         }
         else
         {
            chkCombined.Checked = true;
            chkImplied.Checked = false;
            chkOutright.Checked = false;
         }

         chkDOMStatus.CheckState = instrument != null && instrument.DOMStatus ? CheckState.Checked : CheckState.Unchecked;
      }
   }
   
}
