﻿using System;
using System.Windows.Forms;

namespace OrderPlacingSample
{
   partial class frmOrderPlacing
   {
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container m_Components = null;

      #region GUI Control-fields

      private Label lblAskName;
      private Label lblAskPrice;
      private Label lblAskVolume;
      private Label lblBidName;
      private Label lblBidPrice;
      private Label lblBidVolume;
      private Label lblDataConnection;
      private Label lblGWConnection;
      private Label lblInstrumentDescription;
      private Label lblLimitPrice;
      private Label lblLineTime;
      private Label lblOrderType;
      private Label lblPriceName;
      private Label lblQuantity;
      private Label lblStopPrice;
      private Label lblTradeName;
      private Label lblTradePrice;
      private Label lblTradeVolume;
      private Label lblVolumeName;
      private Button btnActivate;
      private Button btnActivateAll;
      private Button btnBuy;
      private Button btnCancel;
      private Button btnCancelAll;
      private Button btnModify;
      private Button btnQuantity100;
      private Button btnQuantity10;
      private Button btnQuantity1;
      private Button btnQuantity20;
      private Button btnQuantity50;
      private Button btnQuantity5;
      private Button btnRemoveInstrument;
      private Button btnSell;
      private Button btnSubscribe;
      private TextBox txtLimitPrice;
      private TextBox txtStopPrice;
      private TextBox txtSymbolName;
      private VScrollBar vsbLimitPrice;
      private VScrollBar vsbStopPrice;
      private GroupBox grbAccounts;
      private GroupBox grbDuration;
      private GroupBox grbInstruments;
      private GroupBox grbOrderProperties;
      private GroupBox grbQuotes;
      private CheckBox chkParked;
      private ComboBox cmbAccounts;
      private ComboBox cmbDuration;
      private ComboBox cmbOrderTypes;
      private DateTimePicker dtpOrderGoodTill;
      private LinkLabel llWeb;
      private ListBox lstInstruments;
      private ListView lsvOrders;
      private NumericUpDown nudQuantity;
      private Button btnManualFill;
      private ListView lsvManualFills;
      private TabControl tabControlOrders;
      private ComboBox cmbOpenCloseInstruction;
      private Label lblOpenClose;
      private CheckBox chkBracket;
      private TableLayoutPanel pnlQuotes;
      private TableLayoutPanel pnlInstruments;
      private TableLayoutPanel pnlBuySellQuotes;
      private Panel pnlStopPrice;
      private Panel pnlLimitPrice;
      private TableLayoutPanel pnlOrderProps;
      private Panel pnlTabsAndLists;
      private TableLayoutPanel pnlOrdersAndControls;
      private TableLayoutPanel pnlOrderControls;
      private Panel pnlGWInfo;
      private TableLayoutPanel pnlMainForm;
      private TableLayoutPanel pnlQtyDuration;
      private TableLayoutPanel pnlQty;

      #endregion

      /// <summary>
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (m_Components != null)
            {
               m_Components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      #region Windows Form Designer generated code

      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent()
      {
         this.btnActivate = new System.Windows.Forms.Button();
         this.btnActivateAll = new System.Windows.Forms.Button();
         this.btnBuy = new System.Windows.Forms.Button();
         this.btnCancel = new System.Windows.Forms.Button();
         this.btnCancelAll = new System.Windows.Forms.Button();
         this.btnModify = new System.Windows.Forms.Button();
         this.btnQuantity1 = new System.Windows.Forms.Button();
         this.btnQuantity10 = new System.Windows.Forms.Button();
         this.btnQuantity100 = new System.Windows.Forms.Button();
         this.btnQuantity20 = new System.Windows.Forms.Button();
         this.btnQuantity5 = new System.Windows.Forms.Button();
         this.btnQuantity50 = new System.Windows.Forms.Button();
         this.btnRemoveInstrument = new System.Windows.Forms.Button();
         this.btnSell = new System.Windows.Forms.Button();
         this.btnSubscribe = new System.Windows.Forms.Button();
         this.chkParked = new System.Windows.Forms.CheckBox();
         this.cmbAccounts = new System.Windows.Forms.ComboBox();
         this.cmbDuration = new System.Windows.Forms.ComboBox();
         this.cmbOrderTypes = new System.Windows.Forms.ComboBox();
         this.dtpOrderGoodTill = new System.Windows.Forms.DateTimePicker();
         this.grbAccounts = new System.Windows.Forms.GroupBox();
         this.grbDuration = new System.Windows.Forms.GroupBox();
         this.grbInstruments = new System.Windows.Forms.GroupBox();
         this.pnlInstruments = new System.Windows.Forms.TableLayoutPanel();
         this.lstInstruments = new System.Windows.Forms.ListBox();
         this.txtSymbolName = new System.Windows.Forms.TextBox();
         this.grbOrderProperties = new System.Windows.Forms.GroupBox();
         this.pnlQtyDuration = new System.Windows.Forms.TableLayoutPanel();
         this.pnlQty = new System.Windows.Forms.TableLayoutPanel();
         this.nudQuantity = new System.Windows.Forms.NumericUpDown();
         this.lblQuantity = new System.Windows.Forms.Label();
         this.pnlOrdersAndControls = new System.Windows.Forms.TableLayoutPanel();
         this.pnlOrderControls = new System.Windows.Forms.TableLayoutPanel();
         this.pnlTabsAndLists = new System.Windows.Forms.Panel();
         this.lsvOrders = new System.Windows.Forms.ListView();
         this.lsvManualFills = new System.Windows.Forms.ListView();
         this.tabControlOrders = new System.Windows.Forms.TabControl();
         this.pnlOrderProps = new System.Windows.Forms.TableLayoutPanel();
         this.lblOrderType = new System.Windows.Forms.Label();
         this.chkBracket = new System.Windows.Forms.CheckBox();
         this.pnlStopPrice = new System.Windows.Forms.Panel();
         this.vsbStopPrice = new System.Windows.Forms.VScrollBar();
         this.txtStopPrice = new System.Windows.Forms.TextBox();
         this.lblLimitPrice = new System.Windows.Forms.Label();
         this.lblStopPrice = new System.Windows.Forms.Label();
         this.lblOpenClose = new System.Windows.Forms.Label();
         this.btnManualFill = new System.Windows.Forms.Button();
         this.cmbOpenCloseInstruction = new System.Windows.Forms.ComboBox();
         this.pnlLimitPrice = new System.Windows.Forms.Panel();
         this.vsbLimitPrice = new System.Windows.Forms.VScrollBar();
         this.txtLimitPrice = new System.Windows.Forms.TextBox();
         this.grbQuotes = new System.Windows.Forms.GroupBox();
         this.pnlQuotes = new System.Windows.Forms.TableLayoutPanel();
         this.lblBidVolume = new System.Windows.Forms.Label();
         this.lblBidPrice = new System.Windows.Forms.Label();
         this.lblTradePrice = new System.Windows.Forms.Label();
         this.lblAskPrice = new System.Windows.Forms.Label();
         this.lblTradeVolume = new System.Windows.Forms.Label();
         this.lblBidName = new System.Windows.Forms.Label();
         this.lblTradeName = new System.Windows.Forms.Label();
         this.lblAskVolume = new System.Windows.Forms.Label();
         this.lblPriceName = new System.Windows.Forms.Label();
         this.lblVolumeName = new System.Windows.Forms.Label();
         this.lblAskName = new System.Windows.Forms.Label();
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.lblGWConnection = new System.Windows.Forms.Label();
         this.lblInstrumentDescription = new System.Windows.Forms.Label();
         this.lblLineTime = new System.Windows.Forms.Label();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.pnlBuySellQuotes = new System.Windows.Forms.TableLayoutPanel();
         this.pnlGWInfo = new System.Windows.Forms.Panel();
         this.pnlMainForm = new System.Windows.Forms.TableLayoutPanel();
         this.grbAccounts.SuspendLayout();
         this.grbDuration.SuspendLayout();
         this.grbInstruments.SuspendLayout();
         this.pnlInstruments.SuspendLayout();
         this.grbOrderProperties.SuspendLayout();
         this.pnlQtyDuration.SuspendLayout();
         this.pnlQty.SuspendLayout();
         ((System.ComponentModel.ISupportInitialize)(this.nudQuantity)).BeginInit();
         this.pnlOrdersAndControls.SuspendLayout();
         this.pnlOrderControls.SuspendLayout();
         this.pnlTabsAndLists.SuspendLayout();
         this.pnlOrderProps.SuspendLayout();
         this.pnlStopPrice.SuspendLayout();
         this.pnlLimitPrice.SuspendLayout();
         this.grbQuotes.SuspendLayout();
         this.pnlQuotes.SuspendLayout();
         this.pnlBuySellQuotes.SuspendLayout();
         this.pnlGWInfo.SuspendLayout();
         this.pnlMainForm.SuspendLayout();
         this.SuspendLayout();
         // 
         // btnActivate
         // 
         this.btnActivate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
         this.btnActivate.Location = new System.Drawing.Point(3, 140);
         this.btnActivate.Name = "btnActivate";
         this.btnActivate.Size = new System.Drawing.Size(90, 28);
         this.btnActivate.TabIndex = 67;
         this.btnActivate.Text = "Activate";
         this.btnActivate.Click += new System.EventHandler(this.btnActivate_Click);
         // 
         // btnActivateAll
         // 
         this.btnActivateAll.Location = new System.Drawing.Point(3, 175);
         this.btnActivateAll.Name = "btnActivateAll";
         this.btnActivateAll.Size = new System.Drawing.Size(90, 28);
         this.btnActivateAll.TabIndex = 68;
         this.btnActivateAll.Text = "Activate All";
         this.btnActivateAll.Click += new System.EventHandler(this.btnActivateAll_Click);
         // 
         // btnBuy
         // 
         this.btnBuy.Dock = System.Windows.Forms.DockStyle.Fill;
         this.btnBuy.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.btnBuy.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(192)))), ((int)(((byte)(0)))));
         this.btnBuy.Location = new System.Drawing.Point(3, 3);
         this.btnBuy.Name = "btnBuy";
         this.btnBuy.Size = new System.Drawing.Size(76, 188);
         this.btnBuy.TabIndex = 15;
         this.btnBuy.Text = "Buy";
         this.btnBuy.Click += new System.EventHandler(this.btnBuy_Click);
         // 
         // btnCancel
         // 
         this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
         this.btnCancel.Location = new System.Drawing.Point(3, 54);
         this.btnCancel.Name = "btnCancel";
         this.btnCancel.Size = new System.Drawing.Size(90, 28);
         this.btnCancel.TabIndex = 65;
         this.btnCancel.Text = "Cancel";
         this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
         // 
         // btnCancelAll
         // 
         this.btnCancelAll.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.btnCancelAll.Location = new System.Drawing.Point(3, 89);
         this.btnCancelAll.Name = "btnCancelAll";
         this.btnCancelAll.Size = new System.Drawing.Size(90, 28);
         this.btnCancelAll.TabIndex = 66;
         this.btnCancelAll.Text = "Cancel All";
         this.btnCancelAll.Click += new System.EventHandler(this.btnCancelAll_Click);
         // 
         // btnModify
         // 
         this.btnModify.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.btnModify.Location = new System.Drawing.Point(3, 3);
         this.btnModify.Name = "btnModify";
         this.btnModify.Size = new System.Drawing.Size(90, 27);
         this.btnModify.TabIndex = 64;
         this.btnModify.Text = "Modify";
         this.btnModify.Click += new System.EventHandler(this.btnModify_Click);
         // 
         // btnQuantity1
         // 
         this.btnQuantity1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.btnQuantity1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
         this.btnQuantity1.Location = new System.Drawing.Point(180, 3);
         this.btnQuantity1.Name = "btnQuantity1";
         this.btnQuantity1.Size = new System.Drawing.Size(48, 42);
         this.btnQuantity1.TabIndex = 50;
         this.btnQuantity1.Text = "1";
         this.btnQuantity1.Click += new System.EventHandler(this.btnQuantities_CheckedChanged);
         // 
         // btnQuantity10
         // 
         this.btnQuantity10.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.btnQuantity10.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
         this.btnQuantity10.Location = new System.Drawing.Point(292, 3);
         this.btnQuantity10.Name = "btnQuantity10";
         this.btnQuantity10.Size = new System.Drawing.Size(48, 42);
         this.btnQuantity10.TabIndex = 52;
         this.btnQuantity10.Text = "10";
         this.btnQuantity10.Click += new System.EventHandler(this.btnQuantities_CheckedChanged);
         // 
         // btnQuantity100
         // 
         this.btnQuantity100.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.btnQuantity100.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
         this.btnQuantity100.Location = new System.Drawing.Point(460, 3);
         this.btnQuantity100.Name = "btnQuantity100";
         this.btnQuantity100.Size = new System.Drawing.Size(48, 42);
         this.btnQuantity100.TabIndex = 55;
         this.btnQuantity100.Text = "100";
         this.btnQuantity100.Click += new System.EventHandler(this.btnQuantities_CheckedChanged);
         // 
         // btnQuantity20
         // 
         this.btnQuantity20.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.btnQuantity20.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
         this.btnQuantity20.Location = new System.Drawing.Point(348, 3);
         this.btnQuantity20.Name = "btnQuantity20";
         this.btnQuantity20.Size = new System.Drawing.Size(48, 42);
         this.btnQuantity20.TabIndex = 53;
         this.btnQuantity20.Text = "20";
         this.btnQuantity20.Click += new System.EventHandler(this.btnQuantities_CheckedChanged);
         // 
         // btnQuantity5
         // 
         this.btnQuantity5.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.btnQuantity5.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
         this.btnQuantity5.Location = new System.Drawing.Point(236, 3);
         this.btnQuantity5.Name = "btnQuantity5";
         this.btnQuantity5.Size = new System.Drawing.Size(48, 42);
         this.btnQuantity5.TabIndex = 51;
         this.btnQuantity5.Text = "5";
         this.btnQuantity5.Click += new System.EventHandler(this.btnQuantities_CheckedChanged);
         // 
         // btnQuantity50
         // 
         this.btnQuantity50.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.btnQuantity50.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
         this.btnQuantity50.Location = new System.Drawing.Point(404, 3);
         this.btnQuantity50.Name = "btnQuantity50";
         this.btnQuantity50.Size = new System.Drawing.Size(48, 42);
         this.btnQuantity50.TabIndex = 54;
         this.btnQuantity50.Text = "50";
         this.btnQuantity50.Click += new System.EventHandler(this.btnQuantities_CheckedChanged);
         // 
         // btnRemoveInstrument
         // 
         this.btnRemoveInstrument.Location = new System.Drawing.Point(251, 145);
         this.btnRemoveInstrument.Name = "btnRemoveInstrument";
         this.btnRemoveInstrument.Size = new System.Drawing.Size(90, 25);
         this.btnRemoveInstrument.TabIndex = 13;
         this.btnRemoveInstrument.Text = "Remove";
         this.btnRemoveInstrument.Click += new System.EventHandler(this.btnRemoveInstrument_Click);
         // 
         // btnSell
         // 
         this.btnSell.Dock = System.Windows.Forms.DockStyle.Fill;
         this.btnSell.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.btnSell.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
         this.btnSell.Location = new System.Drawing.Point(451, 3);
         this.btnSell.Name = "btnSell";
         this.btnSell.Size = new System.Drawing.Size(76, 188);
         this.btnSell.TabIndex = 29;
         this.btnSell.Text = "Sell";
         this.btnSell.Click += new System.EventHandler(this.btnSell_Click);
         // 
         // btnSubscribe
         // 
         this.btnSubscribe.Location = new System.Drawing.Point(251, 3);
         this.btnSubscribe.Name = "btnSubscribe";
         this.btnSubscribe.Size = new System.Drawing.Size(90, 27);
         this.btnSubscribe.TabIndex = 11;
         this.btnSubscribe.Text = "Subscribe";
         this.btnSubscribe.Click += new System.EventHandler(this.btnSubscribe_Click);
         // 
         // chkParked
         // 
         this.chkParked.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.chkParked.Location = new System.Drawing.Point(583, 21);
         this.chkParked.Name = "chkParked";
         this.chkParked.Size = new System.Drawing.Size(101, 28);
         this.chkParked.TabIndex = 44;
         this.chkParked.Text = "Parked";
         // 
         // cmbAccounts
         // 
         this.cmbAccounts.Dock = System.Windows.Forms.DockStyle.Fill;
         this.cmbAccounts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbAccounts.Location = new System.Drawing.Point(3, 18);
         this.cmbAccounts.Name = "cmbAccounts";
         this.cmbAccounts.Size = new System.Drawing.Size(344, 21);
         this.cmbAccounts.TabIndex = 6;
         this.cmbAccounts.SelectedIndexChanged += new System.EventHandler(this.cmbAccounts_SelectedIndexChanged);
         // 
         // cmbDuration
         // 
         this.cmbDuration.Dock = System.Windows.Forms.DockStyle.Left;
         this.cmbDuration.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbDuration.Location = new System.Drawing.Point(3, 18);
         this.cmbDuration.Name = "cmbDuration";
         this.cmbDuration.Size = new System.Drawing.Size(163, 21);
         this.cmbDuration.TabIndex = 57;
         this.cmbDuration.SelectedIndexChanged += new System.EventHandler(this.cmbDuration_SelectedIndexChanged);
         // 
         // cmbOrderTypes
         // 
         this.cmbOrderTypes.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.cmbOrderTypes.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbOrderTypes.Location = new System.Drawing.Point(3, 21);
         this.cmbOrderTypes.Name = "cmbOrderTypes";
         this.cmbOrderTypes.Size = new System.Drawing.Size(154, 21);
         this.cmbOrderTypes.TabIndex = 33;
         this.cmbOrderTypes.SelectedIndexChanged += new System.EventHandler(this.cmbOrderTypes_SelectedIndexChanged);
         // 
         // dtpOrderGoodTill
         // 
         this.dtpOrderGoodTill.Dock = System.Windows.Forms.DockStyle.Right;
         this.dtpOrderGoodTill.Location = new System.Drawing.Point(172, 18);
         this.dtpOrderGoodTill.Name = "dtpOrderGoodTill";
         this.dtpOrderGoodTill.ShowUpDown = true;
         this.dtpOrderGoodTill.Size = new System.Drawing.Size(160, 22);
         this.dtpOrderGoodTill.TabIndex = 58;
         // 
         // grbAccounts
         // 
         this.grbAccounts.Controls.Add(this.cmbAccounts);
         this.grbAccounts.Dock = System.Windows.Forms.DockStyle.Fill;
         this.grbAccounts.Location = new System.Drawing.Point(3, 38);
         this.grbAccounts.Name = "grbAccounts";
         this.grbAccounts.Size = new System.Drawing.Size(350, 45);
         this.grbAccounts.TabIndex = 5;
         this.grbAccounts.TabStop = false;
         this.grbAccounts.Text = "Accounts";
         // 
         // grbDuration
         // 
         this.grbDuration.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
         this.grbDuration.Controls.Add(this.cmbDuration);
         this.grbDuration.Controls.Add(this.dtpOrderGoodTill);
         this.grbDuration.Location = new System.Drawing.Point(532, 3);
         this.grbDuration.Name = "grbDuration";
         this.grbDuration.Size = new System.Drawing.Size(335, 51);
         this.grbDuration.TabIndex = 56;
         this.grbDuration.TabStop = false;
         this.grbDuration.Text = "Duration";
         // 
         // grbInstruments
         // 
         this.grbInstruments.Controls.Add(this.pnlInstruments);
         this.grbInstruments.Dock = System.Windows.Forms.DockStyle.Fill;
         this.grbInstruments.Location = new System.Drawing.Point(3, 89);
         this.grbInstruments.Name = "grbInstruments";
         this.grbInstruments.Size = new System.Drawing.Size(350, 194);
         this.grbInstruments.TabIndex = 8;
         this.grbInstruments.TabStop = false;
         this.grbInstruments.Text = "Instruments";
         // 
         // pnlInstruments
         // 
         this.pnlInstruments.ColumnCount = 2;
         this.pnlInstruments.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
         this.pnlInstruments.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlInstruments.Controls.Add(this.btnRemoveInstrument, 1, 2);
         this.pnlInstruments.Controls.Add(this.btnSubscribe, 1, 0);
         this.pnlInstruments.Controls.Add(this.lstInstruments, 0, 1);
         this.pnlInstruments.Controls.Add(this.txtSymbolName, 0, 0);
         this.pnlInstruments.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlInstruments.Location = new System.Drawing.Point(3, 18);
         this.pnlInstruments.Name = "pnlInstruments";
         this.pnlInstruments.RowCount = 3;
         this.pnlInstruments.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlInstruments.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
         this.pnlInstruments.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlInstruments.Size = new System.Drawing.Size(344, 173);
         this.pnlInstruments.TabIndex = 9;
         // 
         // lstInstruments
         // 
         this.pnlInstruments.SetColumnSpan(this.lstInstruments, 2);
         this.lstInstruments.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lstInstruments.Location = new System.Drawing.Point(3, 36);
         this.lstInstruments.Name = "lstInstruments";
         this.lstInstruments.Size = new System.Drawing.Size(338, 103);
         this.lstInstruments.TabIndex = 12;
         this.lstInstruments.SelectedIndexChanged += new System.EventHandler(this.lstInstruments_SelectedIndexChanged);
         // 
         // txtSymbolName
         // 
         this.txtSymbolName.Dock = System.Windows.Forms.DockStyle.Fill;
         this.txtSymbolName.Location = new System.Drawing.Point(3, 3);
         this.txtSymbolName.Name = "txtSymbolName";
         this.txtSymbolName.Size = new System.Drawing.Size(242, 22);
         this.txtSymbolName.TabIndex = 10;
         this.txtSymbolName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtSymbolName_KeyDown);
         // 
         // grbOrderProperties
         // 
         this.pnlMainForm.SetColumnSpan(this.grbOrderProperties, 2);
         this.grbOrderProperties.Controls.Add(this.pnlQtyDuration);
         this.grbOrderProperties.Controls.Add(this.pnlOrdersAndControls);
         this.grbOrderProperties.Controls.Add(this.pnlOrderProps);
         this.grbOrderProperties.Dock = System.Windows.Forms.DockStyle.Fill;
         this.grbOrderProperties.Location = new System.Drawing.Point(3, 289);
         this.grbOrderProperties.Name = "grbOrderProperties";
         this.grbOrderProperties.Padding = new System.Windows.Forms.Padding(8);
         this.grbOrderProperties.Size = new System.Drawing.Size(886, 464);
         this.grbOrderProperties.TabIndex = 30;
         this.grbOrderProperties.TabStop = false;
         this.grbOrderProperties.Text = "Orders";
         // 
         // pnlQtyDuration
         // 
         this.pnlQtyDuration.ColumnCount = 2;
         this.pnlQtyDuration.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 60.8046F));
         this.pnlQtyDuration.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 39.1954F));
         this.pnlQtyDuration.Controls.Add(this.grbDuration, 1, 0);
         this.pnlQtyDuration.Controls.Add(this.pnlQty, 0, 0);
         this.pnlQtyDuration.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlQtyDuration.Location = new System.Drawing.Point(8, 73);
         this.pnlQtyDuration.Name = "pnlQtyDuration";
         this.pnlQtyDuration.RowCount = 1;
         this.pnlQtyDuration.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlQtyDuration.Size = new System.Drawing.Size(870, 60);
         this.pnlQtyDuration.TabIndex = 47;
         // 
         // pnlQty
         // 
         this.pnlQty.ColumnCount = 8;
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
         this.pnlQty.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
         this.pnlQty.Controls.Add(this.btnQuantity100, 7, 0);
         this.pnlQty.Controls.Add(this.btnQuantity20, 5, 0);
         this.pnlQty.Controls.Add(this.btnQuantity50, 6, 0);
         this.pnlQty.Controls.Add(this.btnQuantity10, 4, 0);
         this.pnlQty.Controls.Add(this.btnQuantity5, 3, 0);
         this.pnlQty.Controls.Add(this.nudQuantity, 1, 0);
         this.pnlQty.Controls.Add(this.lblQuantity, 0, 0);
         this.pnlQty.Controls.Add(this.btnQuantity1, 2, 0);
         this.pnlQty.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlQty.Location = new System.Drawing.Point(8, 8);
         this.pnlQty.Margin = new System.Windows.Forms.Padding(8);
         this.pnlQty.Name = "pnlQty";
         this.pnlQty.RowCount = 1;
         this.pnlQty.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlQty.Size = new System.Drawing.Size(513, 48);
         this.pnlQty.TabIndex = 44;
         // 
         // nudQuantity
         // 
         this.nudQuantity.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
         this.nudQuantity.DecimalPlaces = 10;
         this.nudQuantity.Location = new System.Drawing.Point(57, 13);
         this.nudQuantity.Maximum = new decimal(new int[] {
            10000,
            0,
            0,
            0});
         this.nudQuantity.Name = "nudQuantity";
         this.nudQuantity.Size = new System.Drawing.Size(116, 22);
         this.nudQuantity.TabIndex = 49;
         this.nudQuantity.ThousandsSeparator = true;
         this.nudQuantity.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
         // 
         // lblQuantity
         // 
         this.lblQuantity.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
         this.lblQuantity.Location = new System.Drawing.Point(3, 0);
         this.lblQuantity.Name = "lblQuantity";
         this.lblQuantity.Size = new System.Drawing.Size(48, 48);
         this.lblQuantity.TabIndex = 48;
         this.lblQuantity.Text = "QTY:";
         this.lblQuantity.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // pnlOrdersAndControls
         // 
         this.pnlOrdersAndControls.ColumnCount = 2;
         this.pnlOrdersAndControls.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
         this.pnlOrdersAndControls.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlOrdersAndControls.Controls.Add(this.pnlOrderControls, 1, 0);
         this.pnlOrdersAndControls.Controls.Add(this.pnlTabsAndLists, 0, 0);
         this.pnlOrdersAndControls.Dock = System.Windows.Forms.DockStyle.Bottom;
         this.pnlOrdersAndControls.Location = new System.Drawing.Point(8, 133);
         this.pnlOrdersAndControls.Name = "pnlOrdersAndControls";
         this.pnlOrdersAndControls.RowCount = 1;
         this.pnlOrdersAndControls.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
         this.pnlOrdersAndControls.Size = new System.Drawing.Size(870, 323);
         this.pnlOrdersAndControls.TabIndex = 59;
         // 
         // pnlOrderControls
         // 
         this.pnlOrderControls.ColumnCount = 1;
         this.pnlOrderControls.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlOrderControls.Controls.Add(this.btnActivateAll, 0, 4);
         this.pnlOrderControls.Controls.Add(this.btnModify, 0, 0);
         this.pnlOrderControls.Controls.Add(this.btnActivate, 0, 3);
         this.pnlOrderControls.Controls.Add(this.btnCancel, 0, 1);
         this.pnlOrderControls.Controls.Add(this.btnCancelAll, 0, 2);
         this.pnlOrderControls.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlOrderControls.Location = new System.Drawing.Point(773, 50);
         this.pnlOrderControls.Margin = new System.Windows.Forms.Padding(3, 50, 3, 3);
         this.pnlOrderControls.Name = "pnlOrderControls";
         this.pnlOrderControls.RowCount = 5;
         this.pnlOrderControls.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 50F));
         this.pnlOrderControls.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 36F));
         this.pnlOrderControls.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 50F));
         this.pnlOrderControls.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 36F));
         this.pnlOrderControls.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 14F));
         this.pnlOrderControls.Size = new System.Drawing.Size(94, 270);
         this.pnlOrderControls.TabIndex = 63;
         // 
         // pnlTabsAndLists
         // 
         this.pnlTabsAndLists.Controls.Add(this.lsvOrders);
         this.pnlTabsAndLists.Controls.Add(this.lsvManualFills);
         this.pnlTabsAndLists.Controls.Add(this.tabControlOrders);
         this.pnlTabsAndLists.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlTabsAndLists.Location = new System.Drawing.Point(3, 3);
         this.pnlTabsAndLists.Name = "pnlTabsAndLists";
         this.pnlTabsAndLists.Size = new System.Drawing.Size(764, 317);
         this.pnlTabsAndLists.TabIndex = 32;
         // 
         // lsvOrders
         // 
         this.lsvOrders.HideSelection = false;
         this.lsvOrders.Location = new System.Drawing.Point(2, 37);
         this.lsvOrders.Name = "lsvOrders";
         this.lsvOrders.Size = new System.Drawing.Size(755, 273);
         this.lsvOrders.TabIndex = 61;
         this.lsvOrders.UseCompatibleStateImageBehavior = false;
         this.lsvOrders.SelectedIndexChanged += new System.EventHandler(this.lsvOrders_SelectedIndexChanged);
         // 
         // lsvManualFills
         // 
         this.lsvManualFills.HideSelection = false;
         this.lsvManualFills.Location = new System.Drawing.Point(2, 37);
         this.lsvManualFills.Name = "lsvManualFills";
         this.lsvManualFills.Size = new System.Drawing.Size(755, 273);
         this.lsvManualFills.TabIndex = 62;
         this.lsvManualFills.UseCompatibleStateImageBehavior = false;
         this.lsvManualFills.Visible = false;
         this.lsvManualFills.SelectedIndexChanged += new System.EventHandler(this.lsvManualFills_SelectedIndexChanged);
         // 
         // tabControlOrders
         // 
         this.tabControlOrders.Dock = System.Windows.Forms.DockStyle.Fill;
         this.tabControlOrders.Location = new System.Drawing.Point(0, 0);
         this.tabControlOrders.Name = "tabControlOrders";
         this.tabControlOrders.SelectedIndex = 0;
         this.tabControlOrders.Size = new System.Drawing.Size(764, 317);
         this.tabControlOrders.TabIndex = 60;
         this.tabControlOrders.SelectedIndexChanged += new System.EventHandler(this.tabControlOrders_SelectedIndexChanged);
         // 
         // pnlOrderProps
         // 
         this.pnlOrderProps.ColumnCount = 7;
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 26.2536F));
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 26.25361F));
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 17.58992F));
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 17.58992F));
         this.pnlOrderProps.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 12.31294F));
         this.pnlOrderProps.Controls.Add(this.lblOrderType, 0, 0);
         this.pnlOrderProps.Controls.Add(this.chkBracket, 5, 1);
         this.pnlOrderProps.Controls.Add(this.pnlStopPrice, 2, 1);
         this.pnlOrderProps.Controls.Add(this.lblLimitPrice, 1, 0);
         this.pnlOrderProps.Controls.Add(this.cmbOrderTypes, 0, 1);
         this.pnlOrderProps.Controls.Add(this.lblStopPrice, 2, 0);
         this.pnlOrderProps.Controls.Add(this.lblOpenClose, 3, 0);
         this.pnlOrderProps.Controls.Add(this.btnManualFill, 6, 1);
         this.pnlOrderProps.Controls.Add(this.cmbOpenCloseInstruction, 3, 1);
         this.pnlOrderProps.Controls.Add(this.pnlLimitPrice, 1, 1);
         this.pnlOrderProps.Controls.Add(this.chkParked, 4, 1);
         this.pnlOrderProps.Dock = System.Windows.Forms.DockStyle.Top;
         this.pnlOrderProps.Location = new System.Drawing.Point(8, 23);
         this.pnlOrderProps.Name = "pnlOrderProps";
         this.pnlOrderProps.RowCount = 2;
         this.pnlOrderProps.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlOrderProps.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlOrderProps.Size = new System.Drawing.Size(870, 50);
         this.pnlOrderProps.TabIndex = 31;
         // 
         // lblOrderType
         // 
         this.lblOrderType.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.lblOrderType.Location = new System.Drawing.Point(3, 0);
         this.lblOrderType.Name = "lblOrderType";
         this.lblOrderType.Size = new System.Drawing.Size(154, 18);
         this.lblOrderType.TabIndex = 32;
         this.lblOrderType.Text = "Order Type";
         // 
         // chkBracket
         // 
         this.chkBracket.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.chkBracket.Location = new System.Drawing.Point(690, 21);
         this.chkBracket.Name = "chkBracket";
         this.chkBracket.Size = new System.Drawing.Size(101, 28);
         this.chkBracket.TabIndex = 45;
         this.chkBracket.Text = "Bracket";
         this.chkBracket.UseVisualStyleBackColor = true;
         // 
         // pnlStopPrice
         // 
         this.pnlStopPrice.Controls.Add(this.vsbStopPrice);
         this.pnlStopPrice.Controls.Add(this.txtStopPrice);
         this.pnlStopPrice.Location = new System.Drawing.Point(293, 21);
         this.pnlStopPrice.Name = "pnlStopPrice";
         this.pnlStopPrice.Size = new System.Drawing.Size(124, 22);
         this.pnlStopPrice.TabIndex = 39;
         // 
         // vsbStopPrice
         // 
         this.vsbStopPrice.Dock = System.Windows.Forms.DockStyle.Right;
         this.vsbStopPrice.Location = new System.Drawing.Point(105, 0);
         this.vsbStopPrice.Maximum = 100000000;
         this.vsbStopPrice.Minimum = -100000000;
         this.vsbStopPrice.Name = "vsbStopPrice";
         this.vsbStopPrice.Size = new System.Drawing.Size(19, 22);
         this.vsbStopPrice.TabIndex = 41;
         this.vsbStopPrice.TabStop = true;
         this.vsbStopPrice.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vsbStopPrice_Scroll);
         // 
         // txtStopPrice
         // 
         this.txtStopPrice.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.txtStopPrice.Location = new System.Drawing.Point(2, 0);
         this.txtStopPrice.Name = "txtStopPrice";
         this.txtStopPrice.ReadOnly = true;
         this.txtStopPrice.Size = new System.Drawing.Size(104, 22);
         this.txtStopPrice.TabIndex = 40;
         this.txtStopPrice.TabStop = false;
         this.txtStopPrice.Text = "N/A";
         // 
         // lblLimitPrice
         // 
         this.lblLimitPrice.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.lblLimitPrice.Location = new System.Drawing.Point(163, 0);
         this.lblLimitPrice.Name = "lblLimitPrice";
         this.lblLimitPrice.Size = new System.Drawing.Size(124, 18);
         this.lblLimitPrice.TabIndex = 34;
         this.lblLimitPrice.Text = "Limit Price";
         // 
         // lblStopPrice
         // 
         this.lblStopPrice.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.lblStopPrice.Location = new System.Drawing.Point(293, 0);
         this.lblStopPrice.Name = "lblStopPrice";
         this.lblStopPrice.Size = new System.Drawing.Size(124, 18);
         this.lblStopPrice.TabIndex = 38;
         this.lblStopPrice.Text = "Stop Price";
         // 
         // lblOpenClose
         // 
         this.lblOpenClose.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.lblOpenClose.Location = new System.Drawing.Point(423, 0);
         this.lblOpenClose.Name = "lblOpenClose";
         this.lblOpenClose.Size = new System.Drawing.Size(154, 18);
         this.lblOpenClose.TabIndex = 42;
         this.lblOpenClose.Text = "Open/Close Instruction";
         // 
         // btnManualFill
         // 
         this.btnManualFill.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.btnManualFill.Image = global::OrderPlacingSample.Properties.Resources.ico_manual_fills;
         this.btnManualFill.Location = new System.Drawing.Point(835, 21);
         this.btnManualFill.Name = "btnManualFill";
         this.btnManualFill.Size = new System.Drawing.Size(32, 28);
         this.btnManualFill.TabIndex = 46;
         this.btnManualFill.UseVisualStyleBackColor = true;
         this.btnManualFill.Click += new System.EventHandler(this.btnManualFill_Click);
         // 
         // cmbOpenCloseInstruction
         // 
         this.cmbOpenCloseInstruction.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
         this.cmbOpenCloseInstruction.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbOpenCloseInstruction.Location = new System.Drawing.Point(423, 21);
         this.cmbOpenCloseInstruction.Name = "cmbOpenCloseInstruction";
         this.cmbOpenCloseInstruction.Size = new System.Drawing.Size(154, 21);
         this.cmbOpenCloseInstruction.TabIndex = 43;
         // 
         // pnlLimitPrice
         // 
         this.pnlLimitPrice.Controls.Add(this.vsbLimitPrice);
         this.pnlLimitPrice.Controls.Add(this.txtLimitPrice);
         this.pnlLimitPrice.Location = new System.Drawing.Point(163, 21);
         this.pnlLimitPrice.Name = "pnlLimitPrice";
         this.pnlLimitPrice.Size = new System.Drawing.Size(124, 22);
         this.pnlLimitPrice.TabIndex = 35;
         // 
         // vsbLimitPrice
         // 
         this.vsbLimitPrice.Dock = System.Windows.Forms.DockStyle.Right;
         this.vsbLimitPrice.LargeChange = 1;
         this.vsbLimitPrice.Location = new System.Drawing.Point(105, 0);
         this.vsbLimitPrice.Maximum = 100000000;
         this.vsbLimitPrice.Minimum = -10000000;
         this.vsbLimitPrice.Name = "vsbLimitPrice";
         this.vsbLimitPrice.Size = new System.Drawing.Size(19, 22);
         this.vsbLimitPrice.TabIndex = 37;
         this.vsbLimitPrice.TabStop = true;
         this.vsbLimitPrice.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vsbLimitPrice_Scroll);
         // 
         // txtLimitPrice
         // 
         this.txtLimitPrice.Dock = System.Windows.Forms.DockStyle.Fill;
         this.txtLimitPrice.Location = new System.Drawing.Point(0, 0);
         this.txtLimitPrice.Name = "txtLimitPrice";
         this.txtLimitPrice.ReadOnly = true;
         this.txtLimitPrice.Size = new System.Drawing.Size(124, 22);
         this.txtLimitPrice.TabIndex = 36;
         this.txtLimitPrice.TabStop = false;
         this.txtLimitPrice.Text = "N/A";
         // 
         // grbQuotes
         // 
         this.grbQuotes.Controls.Add(this.pnlQuotes);
         this.grbQuotes.Dock = System.Windows.Forms.DockStyle.Fill;
         this.grbQuotes.Location = new System.Drawing.Point(85, 3);
         this.grbQuotes.Name = "grbQuotes";
         this.grbQuotes.Size = new System.Drawing.Size(360, 188);
         this.grbQuotes.TabIndex = 16;
         this.grbQuotes.TabStop = false;
         this.grbQuotes.Text = "Quotes";
         // 
         // pnlQuotes
         // 
         this.pnlQuotes.ColumnCount = 3;
         this.pnlQuotes.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 30F));
         this.pnlQuotes.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 35F));
         this.pnlQuotes.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 35F));
         this.pnlQuotes.Controls.Add(this.lblBidVolume, 2, 3);
         this.pnlQuotes.Controls.Add(this.lblBidPrice, 1, 3);
         this.pnlQuotes.Controls.Add(this.lblTradePrice, 1, 2);
         this.pnlQuotes.Controls.Add(this.lblAskPrice, 1, 1);
         this.pnlQuotes.Controls.Add(this.lblTradeVolume, 2, 2);
         this.pnlQuotes.Controls.Add(this.lblBidName, 0, 3);
         this.pnlQuotes.Controls.Add(this.lblTradeName, 0, 2);
         this.pnlQuotes.Controls.Add(this.lblAskVolume, 2, 1);
         this.pnlQuotes.Controls.Add(this.lblPriceName, 1, 0);
         this.pnlQuotes.Controls.Add(this.lblVolumeName, 2, 0);
         this.pnlQuotes.Controls.Add(this.lblAskName, 0, 1);
         this.pnlQuotes.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlQuotes.Location = new System.Drawing.Point(3, 18);
         this.pnlQuotes.Name = "pnlQuotes";
         this.pnlQuotes.RowCount = 4;
         this.pnlQuotes.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 25F));
         this.pnlQuotes.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 25F));
         this.pnlQuotes.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 25F));
         this.pnlQuotes.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 25F));
         this.pnlQuotes.Size = new System.Drawing.Size(354, 167);
         this.pnlQuotes.TabIndex = 17;
         // 
         // lblBidVolume
         // 
         this.lblBidVolume.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblBidVolume.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblBidVolume.ForeColor = System.Drawing.Color.Green;
         this.lblBidVolume.Location = new System.Drawing.Point(232, 123);
         this.lblBidVolume.Name = "lblBidVolume";
         this.lblBidVolume.Size = new System.Drawing.Size(119, 44);
         this.lblBidVolume.TabIndex = 28;
         this.lblBidVolume.Text = "N/A";
         this.lblBidVolume.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblBidPrice
         // 
         this.lblBidPrice.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblBidPrice.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblBidPrice.ForeColor = System.Drawing.Color.Green;
         this.lblBidPrice.Location = new System.Drawing.Point(109, 123);
         this.lblBidPrice.Name = "lblBidPrice";
         this.lblBidPrice.Size = new System.Drawing.Size(117, 44);
         this.lblBidPrice.TabIndex = 27;
         this.lblBidPrice.Text = "N/A";
         this.lblBidPrice.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblTradePrice
         // 
         this.lblTradePrice.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblTradePrice.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblTradePrice.Location = new System.Drawing.Point(109, 82);
         this.lblTradePrice.Name = "lblTradePrice";
         this.lblTradePrice.Size = new System.Drawing.Size(117, 41);
         this.lblTradePrice.TabIndex = 24;
         this.lblTradePrice.Text = "N/A";
         this.lblTradePrice.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblAskPrice
         // 
         this.lblAskPrice.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblAskPrice.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblAskPrice.ForeColor = System.Drawing.Color.Maroon;
         this.lblAskPrice.Location = new System.Drawing.Point(109, 41);
         this.lblAskPrice.Name = "lblAskPrice";
         this.lblAskPrice.Size = new System.Drawing.Size(117, 41);
         this.lblAskPrice.TabIndex = 21;
         this.lblAskPrice.Text = "N/A";
         this.lblAskPrice.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblTradeVolume
         // 
         this.lblTradeVolume.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblTradeVolume.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblTradeVolume.Location = new System.Drawing.Point(232, 82);
         this.lblTradeVolume.Name = "lblTradeVolume";
         this.lblTradeVolume.Size = new System.Drawing.Size(119, 41);
         this.lblTradeVolume.TabIndex = 25;
         this.lblTradeVolume.Text = "N/A";
         this.lblTradeVolume.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblBidName
         // 
         this.lblBidName.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblBidName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblBidName.ForeColor = System.Drawing.Color.Green;
         this.lblBidName.Location = new System.Drawing.Point(3, 123);
         this.lblBidName.Name = "lblBidName";
         this.lblBidName.Size = new System.Drawing.Size(100, 44);
         this.lblBidName.TabIndex = 26;
         this.lblBidName.Text = "Bid :";
         this.lblBidName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblTradeName
         // 
         this.lblTradeName.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblTradeName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblTradeName.Location = new System.Drawing.Point(3, 82);
         this.lblTradeName.Name = "lblTradeName";
         this.lblTradeName.Size = new System.Drawing.Size(100, 41);
         this.lblTradeName.TabIndex = 23;
         this.lblTradeName.Text = "Trade :";
         this.lblTradeName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblAskVolume
         // 
         this.lblAskVolume.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblAskVolume.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblAskVolume.ForeColor = System.Drawing.Color.Maroon;
         this.lblAskVolume.Location = new System.Drawing.Point(232, 41);
         this.lblAskVolume.Name = "lblAskVolume";
         this.lblAskVolume.Size = new System.Drawing.Size(119, 41);
         this.lblAskVolume.TabIndex = 22;
         this.lblAskVolume.Text = "N/A";
         this.lblAskVolume.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblPriceName
         // 
         this.lblPriceName.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblPriceName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblPriceName.Location = new System.Drawing.Point(109, 0);
         this.lblPriceName.Name = "lblPriceName";
         this.lblPriceName.Size = new System.Drawing.Size(117, 41);
         this.lblPriceName.TabIndex = 18;
         this.lblPriceName.Text = "Price";
         this.lblPriceName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblVolumeName
         // 
         this.lblVolumeName.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblVolumeName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblVolumeName.Location = new System.Drawing.Point(232, 0);
         this.lblVolumeName.Name = "lblVolumeName";
         this.lblVolumeName.Size = new System.Drawing.Size(119, 41);
         this.lblVolumeName.TabIndex = 19;
         this.lblVolumeName.Text = "Volume";
         this.lblVolumeName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblAskName
         // 
         this.lblAskName.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblAskName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         this.lblAskName.ForeColor = System.Drawing.Color.Maroon;
         this.lblAskName.Location = new System.Drawing.Point(3, 41);
         this.lblAskName.Name = "lblAskName";
         this.lblAskName.Size = new System.Drawing.Size(100, 41);
         this.lblAskName.TabIndex = 20;
         this.lblAskName.Text = "Ask :";
         this.lblAskName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Location = new System.Drawing.Point(3, 3);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(350, 29);
         this.lblDataConnection.TabIndex = 2;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // lblGWConnection
         // 
         this.lblGWConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblGWConnection.Dock = System.Windows.Forms.DockStyle.Left;
         this.lblGWConnection.Location = new System.Drawing.Point(0, 0);
         this.lblGWConnection.Name = "lblGWConnection";
         this.lblGWConnection.Size = new System.Drawing.Size(306, 29);
         this.lblGWConnection.TabIndex = 3;
         this.lblGWConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // lblInstrumentDescription
         // 
         this.lblInstrumentDescription.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblInstrumentDescription.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lblInstrumentDescription.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblInstrumentDescription.ForeColor = System.Drawing.SystemColors.ControlText;
         this.lblInstrumentDescription.Location = new System.Drawing.Point(359, 43);
         this.lblInstrumentDescription.Margin = new System.Windows.Forms.Padding(3, 8, 3, 3);
         this.lblInstrumentDescription.Name = "lblInstrumentDescription";
         this.lblInstrumentDescription.Size = new System.Drawing.Size(530, 40);
         this.lblInstrumentDescription.TabIndex = 7;
         this.lblInstrumentDescription.Text = "Instrument Description";
         this.lblInstrumentDescription.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.lblInstrumentDescription.UseMnemonic = false;
         // 
         // lblLineTime
         // 
         this.lblLineTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblLineTime.Dock = System.Windows.Forms.DockStyle.Right;
         this.lblLineTime.Location = new System.Drawing.Point(367, 0);
         this.lblLineTime.Name = "lblLineTime";
         this.lblLineTime.Size = new System.Drawing.Size(163, 29);
         this.lblLineTime.TabIndex = 4;
         this.lblLineTime.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.Color.DarkGray;
         this.llWeb.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.llWeb.Dock = System.Windows.Forms.DockStyle.Top;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
         this.llWeb.Location = new System.Drawing.Point(0, 0);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(892, 28);
         this.llWeb.TabIndex = 0;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.UseCompatibleTextRendering = true;
         this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
         // 
         // pnlBuySellQuotes
         // 
         this.pnlBuySellQuotes.ColumnCount = 3;
         this.pnlBuySellQuotes.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlBuySellQuotes.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
         this.pnlBuySellQuotes.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
         this.pnlBuySellQuotes.Controls.Add(this.grbQuotes, 1, 0);
         this.pnlBuySellQuotes.Controls.Add(this.btnSell, 2, 0);
         this.pnlBuySellQuotes.Controls.Add(this.btnBuy, 0, 0);
         this.pnlBuySellQuotes.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlBuySellQuotes.Location = new System.Drawing.Point(359, 89);
         this.pnlBuySellQuotes.Name = "pnlBuySellQuotes";
         this.pnlBuySellQuotes.RowCount = 1;
         this.pnlBuySellQuotes.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
         this.pnlBuySellQuotes.Size = new System.Drawing.Size(530, 194);
         this.pnlBuySellQuotes.TabIndex = 14;
         // 
         // pnlGWInfo
         // 
         this.pnlGWInfo.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
         this.pnlGWInfo.Controls.Add(this.lblGWConnection);
         this.pnlGWInfo.Controls.Add(this.lblLineTime);
         this.pnlGWInfo.Location = new System.Drawing.Point(359, 3);
         this.pnlGWInfo.Name = "pnlGWInfo";
         this.pnlGWInfo.Size = new System.Drawing.Size(530, 29);
         this.pnlGWInfo.TabIndex = 32;
         // 
         // pnlMainForm
         // 
         this.pnlMainForm.ColumnCount = 2;
         this.pnlMainForm.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 40F));
         this.pnlMainForm.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 60F));
         this.pnlMainForm.Controls.Add(this.lblDataConnection, 0, 0);
         this.pnlMainForm.Controls.Add(this.grbOrderProperties, 0, 3);
         this.pnlMainForm.Controls.Add(this.pnlBuySellQuotes, 1, 2);
         this.pnlMainForm.Controls.Add(this.pnlGWInfo, 1, 0);
         this.pnlMainForm.Controls.Add(this.grbAccounts, 0, 1);
         this.pnlMainForm.Controls.Add(this.grbInstruments, 0, 2);
         this.pnlMainForm.Controls.Add(this.lblInstrumentDescription, 1, 1);
         this.pnlMainForm.Dock = System.Windows.Forms.DockStyle.Fill;
         this.pnlMainForm.Location = new System.Drawing.Point(0, 28);
         this.pnlMainForm.Name = "pnlMainForm";
         this.pnlMainForm.RowCount = 4;
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle());
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
         this.pnlMainForm.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
         this.pnlMainForm.Size = new System.Drawing.Size(892, 756);
         this.pnlMainForm.TabIndex = 1;
         // 
         // frmOrderPlacing
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
         this.ClientSize = new System.Drawing.Size(892, 784);
         this.Controls.Add(this.pnlMainForm);
         this.Controls.Add(this.llWeb);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
         this.MaximizeBox = false;
         this.Name = "frmOrderPlacing";
         this.Text = "Order Placing";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmOrderPlacing_Closing);
         this.Load += new System.EventHandler(this.frmOrderPlacing_Load);
         this.grbAccounts.ResumeLayout(false);
         this.grbDuration.ResumeLayout(false);
         this.grbInstruments.ResumeLayout(false);
         this.pnlInstruments.ResumeLayout(false);
         this.pnlInstruments.PerformLayout();
         this.grbOrderProperties.ResumeLayout(false);
         this.pnlQtyDuration.ResumeLayout(false);
         this.pnlQty.ResumeLayout(false);
         ((System.ComponentModel.ISupportInitialize)(this.nudQuantity)).EndInit();
         this.pnlOrdersAndControls.ResumeLayout(false);
         this.pnlOrderControls.ResumeLayout(false);
         this.pnlTabsAndLists.ResumeLayout(false);
         this.pnlOrderProps.ResumeLayout(false);
         this.pnlStopPrice.ResumeLayout(false);
         this.pnlStopPrice.PerformLayout();
         this.pnlLimitPrice.ResumeLayout(false);
         this.pnlLimitPrice.PerformLayout();
         this.grbQuotes.ResumeLayout(false);
         this.pnlQuotes.ResumeLayout(false);
         this.pnlBuySellQuotes.ResumeLayout(false);
         this.pnlGWInfo.ResumeLayout(false);
         this.pnlMainForm.ResumeLayout(false);
         this.ResumeLayout(false);

      }

      #endregion
   }
}
