// GWLogonDlg.h : header file
//

#pragma once
#include "afxwin.h"

/// \brief CGWLogonDlg dialog. 
/// \brief Used to login to Gateway.
class CGWLogonDlg : public CDialog
{
public:
   /// \brief Constructor
   /// \param pParent - Parent window
   CGWLogonDlg(CWnd* pParent = NULL, bool otpRequired = false);

   /// \enum Dialog Data
	enum { IDD = IDD_GWLOGIN_DIALOG };

   /// \brief Declares that the class defines a message map.
   DECLARE_MESSAGE_MAP()

public:

   /// \brief Returns specified GW username
   ATL::CComBSTR GetUserName() const { return ATL::CComBSTR(m_Username); }

   /// \brief Returns specified GW password
   ATL::CComBSTR GetPassword() const { return ATL::CComBSTR(m_Password); }

   /// \brief Returns specified GW OneTime password
   ATL::CComBSTR GetOTPassword() const { return ATL::CComBSTR(m_OTPassword); }

protected:

   /// \brief Generated message map functions
   virtual void DoDataExchange(CDataExchange* pDX);

private:

   /// \brief Used to store user specified username
   CString m_Username;

   /// \brief Used to store user specified password
   CString m_Password;

   /// \brief Used to store user specified OneTime password
   CString m_OTPassword;

   /// \brief Used to control if OTP filed should be displayad or not
   bool m_otpRequired;
   
   /// \brief Objects control variables, used to hide/show objects and set their data
   CStatic m_lblOTP;
   CStatic m_lblInfo;
   CEdit m_edOTPassword;
};
