using System;
using System.Windows.Forms;
using System.Drawing;
using CQG;

namespace OrderProperties
{
   public class frmOrderProperties : Form
   {

      [STAThread]
      static void Main()
      {
         Application.Run(new frmOrderProperties());
      }

      /// Constant for not valid values
      private const string N_A = "N/A";
      /// Constant for columns widths in Combo
      private const int LIST_ACC_COL_WIDTH = 35;
      /// Constant for column which contains order's number
      private const int ORDER_NUMBER_COLUMN = 7;
      /// CQGCEL object
      private CQGCEL m_CEL;
      /// Current query
      private CQGOrdersQuery m_Query;

      #region " Windows Form Designer generated code "

      public frmOrderProperties()
      {

         //This call is required by the Windows Form Designer.
         InitializeComponent();

         //Add any initialization after the InitializeComponent() call

      }

      //Form overrides dispose to clean up the component list.
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (!(components == null))
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      //Required by the Windows Form Designer
      private System.ComponentModel.Container components = null;

      //NOTE: The following procedure is required by the Windows Form Designer
      //It can be modified using the Windows Form Designer.
      //Do not modify it using the code editor.
      internal System.Windows.Forms.Label lblDataConnection;
      internal System.Windows.Forms.LinkLabel llWeb;
      internal System.Windows.Forms.Label lblGWConnection;
      internal System.Windows.Forms.GroupBox GroupBox2;
      internal System.Windows.Forms.GroupBox GroupBox4;
      internal System.Windows.Forms.GroupBox GroupBox1;
      internal System.Windows.Forms.PictureBox PictureBox1;
      internal System.Windows.Forms.Button btnQuery;
      internal System.Windows.Forms.GroupBox GroupBox6;
      internal System.Windows.Forms.ComboBox cmbInstrument;
      internal System.Windows.Forms.GroupBox GroupBox7;
      internal System.Windows.Forms.ComboBox cmbStatus;
      internal System.Windows.Forms.GroupBox GroupBox8;
      internal System.Windows.Forms.ComboBox cmbSide;
      internal System.Windows.Forms.GroupBox GroupBox9;
      internal System.Windows.Forms.GroupBox gbOrders;
      internal System.Windows.Forms.Label label1;
      internal System.Windows.Forms.Label lblStatus;
      internal System.Windows.Forms.ListView lvOrders;
      internal System.Windows.Forms.ColumnHeader Side_;
      internal System.Windows.Forms.ColumnHeader Symbol_;
      internal System.Windows.Forms.ColumnHeader Type_;
      internal System.Windows.Forms.ColumnHeader PlaceTime;
      internal System.Windows.Forms.ColumnHeader OrderNumber;
      internal System.Windows.Forms.ColumnHeader EmptyColumn;
      internal System.Windows.Forms.GroupBox GroupBox5;
      internal System.Windows.Forms.ColumnHeader ColumnHeader1;
      internal System.Windows.Forms.ColumnHeader Value;
      internal System.Windows.Forms.GroupBox GroupBox10;
      internal System.Windows.Forms.ColumnHeader ColumnHeader2;
      internal System.Windows.Forms.ColumnHeader Leg;
      internal System.Windows.Forms.ColumnHeader ColumnHeader4;
      internal System.Windows.Forms.ColumnHeader ColumnHeader3;
      internal System.Windows.Forms.ColumnHeader ColumnHeader5;
      internal System.Windows.Forms.ColumnHeader ColumnHeader6;
      internal System.Windows.Forms.ColumnHeader ColumnHeader7;
      internal System.Windows.Forms.ColumnHeader ColumnHeader8;
      internal System.Windows.Forms.ColumnHeader ColumnHeader9;
      internal System.Windows.Forms.ColumnHeader ColumnHeader10;
      internal System.Windows.Forms.ColumnHeader ColumnHeader11;
      internal System.Windows.Forms.ColumnHeader ColumnHeader12;
      internal System.Windows.Forms.ColumnHeader ColumnHeader13;
      internal System.Windows.Forms.ColumnHeader Sizee;
      internal System.Windows.Forms.ColumnHeader Name_;
      internal System.Windows.Forms.ListView lvFills;
      internal System.Windows.Forms.ColumnHeader ColumnHeader14;
      internal System.Windows.Forms.ListView lvProperties;
      internal System.Windows.Forms.ColumnHeader ColumnHeader15;
      internal System.Windows.Forms.DateTimePicker dpDate;
      internal System.Windows.Forms.GroupBox GroupBox3;
      internal System.Windows.Forms.GroupBox GroupBox11;
      internal System.Windows.Forms.ComboBox cmbSelectSide;
      internal System.Windows.Forms.GroupBox GroupBox12;
      internal System.Windows.Forms.GroupBox GroupBox13;
      internal System.Windows.Forms.Button btnFilter;
      internal System.Windows.Forms.TextBox txtSelectInstrumentName;
      internal System.Windows.Forms.ComboBox cmbSelectType;
      internal System.Windows.Forms.ComboBox cmbSelectStatus;
      internal System.Windows.Forms.ComboBox cmbAccounts;
      internal System.Windows.Forms.Button btnCancel;
      internal System.Windows.Forms.GroupBox groupBox14;
      internal System.Windows.Forms.ColumnHeader columnHeader16;
      internal System.Windows.Forms.ColumnHeader columnHeader17;
      internal System.Windows.Forms.ColumnHeader columnHeader18;
      internal System.Windows.Forms.ColumnHeader columnHeader19;
      internal System.Windows.Forms.ColumnHeader columnHeader20;
      internal System.Windows.Forms.ColumnHeader columnHeader21;
      internal System.Windows.Forms.ColumnHeader columnHeader22;
      internal System.Windows.Forms.ColumnHeader columnHeader23;
      internal System.Windows.Forms.ColumnHeader columnHeader24;
      internal System.Windows.Forms.ListView lvTransactions;
      internal System.Windows.Forms.Button btnGWLogOnOff;
      internal System.Windows.Forms.Label lblUsername;
      private System.Windows.Forms.CheckBox chbIncludeTransactions;
      [System.Diagnostics.DebuggerStepThrough()]
      private void InitializeComponent()
      {
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.lblGWConnection = new System.Windows.Forms.Label();
         this.GroupBox2 = new System.Windows.Forms.GroupBox();
         this.cmbAccounts = new System.Windows.Forms.ComboBox();
         this.GroupBox4 = new System.Windows.Forms.GroupBox();
         this.GroupBox1 = new System.Windows.Forms.GroupBox();
         this.btnCancel = new System.Windows.Forms.Button();
         this.lblStatus = new System.Windows.Forms.Label();
         this.label1 = new System.Windows.Forms.Label();
         this.GroupBox3 = new System.Windows.Forms.GroupBox();
         this.cmbSelectType = new System.Windows.Forms.ComboBox();
         this.GroupBox11 = new System.Windows.Forms.GroupBox();
         this.cmbSelectSide = new System.Windows.Forms.ComboBox();
         this.GroupBox12 = new System.Windows.Forms.GroupBox();
         this.cmbSelectStatus = new System.Windows.Forms.ComboBox();
         this.GroupBox13 = new System.Windows.Forms.GroupBox();
         this.txtSelectInstrumentName = new System.Windows.Forms.TextBox();
         this.btnFilter = new System.Windows.Forms.Button();
         this.GroupBox9 = new System.Windows.Forms.GroupBox();
         this.dpDate = new System.Windows.Forms.DateTimePicker();
         this.GroupBox8 = new System.Windows.Forms.GroupBox();
         this.cmbSide = new System.Windows.Forms.ComboBox();
         this.GroupBox7 = new System.Windows.Forms.GroupBox();
         this.cmbStatus = new System.Windows.Forms.ComboBox();
         this.GroupBox6 = new System.Windows.Forms.GroupBox();
         this.cmbInstrument = new System.Windows.Forms.ComboBox();
         this.btnQuery = new System.Windows.Forms.Button();
         this.gbOrders = new System.Windows.Forms.GroupBox();
         this.lvOrders = new System.Windows.Forms.ListView();
         this.EmptyColumn = new System.Windows.Forms.ColumnHeader();
         this.Sizee = new System.Windows.Forms.ColumnHeader();
         this.Side_ = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader15 = new System.Windows.Forms.ColumnHeader();
         this.Symbol_ = new System.Windows.Forms.ColumnHeader();
         this.Type_ = new System.Windows.Forms.ColumnHeader();
         this.PlaceTime = new System.Windows.Forms.ColumnHeader();
         this.OrderNumber = new System.Windows.Forms.ColumnHeader();
         this.PictureBox1 = new System.Windows.Forms.PictureBox();
         this.GroupBox5 = new System.Windows.Forms.GroupBox();
         this.lvProperties = new System.Windows.Forms.ListView();
         this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
         this.Name_ = new System.Windows.Forms.ColumnHeader();
         this.Value = new System.Windows.Forms.ColumnHeader();
         this.GroupBox10 = new System.Windows.Forms.GroupBox();
         this.lvFills = new System.Windows.Forms.ListView();
         this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
         this.Leg = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader14 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader4 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader5 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader6 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader7 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader8 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader13 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader10 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader11 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader9 = new System.Windows.Forms.ColumnHeader();
         this.ColumnHeader12 = new System.Windows.Forms.ColumnHeader();
         this.groupBox14 = new System.Windows.Forms.GroupBox();
         this.lvTransactions = new System.Windows.Forms.ListView();
         this.columnHeader16 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader17 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader18 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader19 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader20 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader21 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader22 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader23 = new System.Windows.Forms.ColumnHeader();
         this.columnHeader24 = new System.Windows.Forms.ColumnHeader();
         this.btnGWLogOnOff = new System.Windows.Forms.Button();
         this.lblUsername = new System.Windows.Forms.Label();
         this.chbIncludeTransactions = new System.Windows.Forms.CheckBox();
         this.GroupBox2.SuspendLayout();
         this.GroupBox1.SuspendLayout();
         this.GroupBox3.SuspendLayout();
         this.GroupBox11.SuspendLayout();
         this.GroupBox12.SuspendLayout();
         this.GroupBox13.SuspendLayout();
         this.GroupBox9.SuspendLayout();
         this.GroupBox8.SuspendLayout();
         this.GroupBox7.SuspendLayout();
         this.GroupBox6.SuspendLayout();
         this.gbOrders.SuspendLayout();
         this.GroupBox5.SuspendLayout();
         this.GroupBox10.SuspendLayout();
         this.groupBox14.SuspendLayout();
         this.SuspendLayout();
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblDataConnection.Location = new System.Drawing.Point(40, 8);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
         this.lblDataConnection.TabIndex = 17;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.SystemColors.Control;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 40);
         this.llWeb.Location = new System.Drawing.Point(816, 8);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(336, 16);
         this.llWeb.TabIndex = 22;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
         // 
         // lblGWConnection
         // 
         this.lblGWConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblGWConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblGWConnection.Location = new System.Drawing.Point(312, 8);
         this.lblGWConnection.Name = "lblGWConnection";
         this.lblGWConnection.Size = new System.Drawing.Size(216, 16);
         this.lblGWConnection.TabIndex = 48;
         this.lblGWConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // GroupBox2
         // 
         this.GroupBox2.Controls.Add(this.cmbAccounts);
         this.GroupBox2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox2.Location = new System.Drawing.Point(8, 48);
         this.GroupBox2.Name = "GroupBox2";
         this.GroupBox2.Size = new System.Drawing.Size(1176, 48);
         this.GroupBox2.TabIndex = 51;
         this.GroupBox2.TabStop = false;
         this.GroupBox2.Text = "Accounts";
         // 
         // cmbAccounts
         // 
         this.cmbAccounts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbAccounts.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.cmbAccounts.Location = new System.Drawing.Point(8, 16);
         this.cmbAccounts.Name = "cmbAccounts";
         this.cmbAccounts.Size = new System.Drawing.Size(1160, 24);
         this.cmbAccounts.TabIndex = 2;
         this.cmbAccounts.SelectedIndexChanged += new System.EventHandler(this.cmbAccounts_SelectedIndexChanged);
         // 
         // GroupBox4
         // 
         this.GroupBox4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox4.Location = new System.Drawing.Point(8, 296);
         this.GroupBox4.Name = "GroupBox4";
         this.GroupBox4.Size = new System.Drawing.Size(816, 240);
         this.GroupBox4.TabIndex = 45;
         this.GroupBox4.TabStop = false;
         // 
         // GroupBox1
         // 
         this.GroupBox1.Controls.Add(this.chbIncludeTransactions);
         this.GroupBox1.Controls.Add(this.btnCancel);
         this.GroupBox1.Controls.Add(this.lblStatus);
         this.GroupBox1.Controls.Add(this.label1);
         this.GroupBox1.Controls.Add(this.GroupBox3);
         this.GroupBox1.Controls.Add(this.GroupBox11);
         this.GroupBox1.Controls.Add(this.GroupBox12);
         this.GroupBox1.Controls.Add(this.GroupBox13);
         this.GroupBox1.Controls.Add(this.btnFilter);
         this.GroupBox1.Controls.Add(this.GroupBox9);
         this.GroupBox1.Controls.Add(this.GroupBox8);
         this.GroupBox1.Controls.Add(this.GroupBox7);
         this.GroupBox1.Controls.Add(this.GroupBox6);
         this.GroupBox1.Controls.Add(this.btnQuery);
         this.GroupBox1.Controls.Add(this.gbOrders);
         this.GroupBox1.Font = new System.Drawing.Font("Arial", 9.75F);
         this.GroupBox1.Location = new System.Drawing.Point(8, 104);
         this.GroupBox1.Name = "GroupBox1";
         this.GroupBox1.Size = new System.Drawing.Size(1176, 344);
         this.GroupBox1.TabIndex = 55;
         this.GroupBox1.TabStop = false;
         this.GroupBox1.Text = "QueryOrders";
         // 
         // btnCancel
         // 
         this.btnCancel.Location = new System.Drawing.Point(8, 288);
         this.btnCancel.Name = "btnCancel";
         this.btnCancel.Size = new System.Drawing.Size(160, 32);
         this.btnCancel.TabIndex = 70;
         this.btnCancel.Text = "Cancel Query";
         this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
         // 
         // lblStatus
         // 
         this.lblStatus.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lblStatus.Location = new System.Drawing.Point(88, 320);
         this.lblStatus.Name = "lblStatus";
         this.lblStatus.Size = new System.Drawing.Size(80, 16);
         this.lblStatus.TabIndex = 63;
         this.lblStatus.Text = "Request Status:";
         // 
         // label1
         // 
         this.label1.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.label1.Location = new System.Drawing.Point(8, 320);
         this.label1.Name = "label1";
         this.label1.Size = new System.Drawing.Size(88, 16);
         this.label1.TabIndex = 69;
         this.label1.Text = "Request Status:";
         // 
         // GroupBox3
         // 
         this.GroupBox3.Controls.Add(this.cmbSelectType);
         this.GroupBox3.Location = new System.Drawing.Point(1008, 184);
         this.GroupBox3.Name = "GroupBox3";
         this.GroupBox3.Size = new System.Drawing.Size(160, 48);
         this.GroupBox3.TabIndex = 68;
         this.GroupBox3.TabStop = false;
         this.GroupBox3.Text = "Type";
         // 
         // cmbSelectType
         // 
         this.cmbSelectType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbSelectType.Location = new System.Drawing.Point(8, 16);
         this.cmbSelectType.Name = "cmbSelectType";
         this.cmbSelectType.Size = new System.Drawing.Size(144, 24);
         this.cmbSelectType.TabIndex = 1;
         // 
         // GroupBox11
         // 
         this.GroupBox11.Controls.Add(this.cmbSelectSide);
         this.GroupBox11.Location = new System.Drawing.Point(1008, 128);
         this.GroupBox11.Name = "GroupBox11";
         this.GroupBox11.Size = new System.Drawing.Size(160, 48);
         this.GroupBox11.TabIndex = 67;
         this.GroupBox11.TabStop = false;
         this.GroupBox11.Text = "Side";
         // 
         // cmbSelectSide
         // 
         this.cmbSelectSide.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbSelectSide.Location = new System.Drawing.Point(8, 16);
         this.cmbSelectSide.Name = "cmbSelectSide";
         this.cmbSelectSide.Size = new System.Drawing.Size(144, 24);
         this.cmbSelectSide.TabIndex = 0;
         // 
         // GroupBox12
         // 
         this.GroupBox12.Controls.Add(this.cmbSelectStatus);
         this.GroupBox12.Location = new System.Drawing.Point(1008, 72);
         this.GroupBox12.Name = "GroupBox12";
         this.GroupBox12.Size = new System.Drawing.Size(160, 48);
         this.GroupBox12.TabIndex = 66;
         this.GroupBox12.TabStop = false;
         this.GroupBox12.Text = "Status";
         // 
         // cmbSelectStatus
         // 
         this.cmbSelectStatus.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbSelectStatus.Location = new System.Drawing.Point(8, 16);
         this.cmbSelectStatus.Name = "cmbSelectStatus";
         this.cmbSelectStatus.Size = new System.Drawing.Size(144, 24);
         this.cmbSelectStatus.TabIndex = 0;
         // 
         // GroupBox13
         // 
         this.GroupBox13.Controls.Add(this.txtSelectInstrumentName);
         this.GroupBox13.Location = new System.Drawing.Point(1008, 16);
         this.GroupBox13.Name = "GroupBox13";
         this.GroupBox13.Size = new System.Drawing.Size(160, 48);
         this.GroupBox13.TabIndex = 65;
         this.GroupBox13.TabStop = false;
         this.GroupBox13.Text = "Instrument Name";
         // 
         // txtSelectInstrumentName
         // 
         this.txtSelectInstrumentName.Location = new System.Drawing.Point(8, 18);
         this.txtSelectInstrumentName.Name = "txtSelectInstrumentName";
         this.txtSelectInstrumentName.Size = new System.Drawing.Size(144, 22);
         this.txtSelectInstrumentName.TabIndex = 0;
         this.txtSelectInstrumentName.Text = "";
         // 
         // btnFilter
         // 
         this.btnFilter.Location = new System.Drawing.Point(1008, 256);
         this.btnFilter.Name = "btnFilter";
         this.btnFilter.Size = new System.Drawing.Size(160, 32);
         this.btnFilter.TabIndex = 64;
         this.btnFilter.Text = "Filter";
         this.btnFilter.Click += new System.EventHandler(this.btnFilter_Click);
         // 
         // GroupBox9
         // 
         this.GroupBox9.Controls.Add(this.dpDate);
         this.GroupBox9.Location = new System.Drawing.Point(8, 160);
         this.GroupBox9.Name = "GroupBox9";
         this.GroupBox9.Size = new System.Drawing.Size(160, 48);
         this.GroupBox9.TabIndex = 62;
         this.GroupBox9.TabStop = false;
         this.GroupBox9.Text = "Date";
         // 
         // dpDate
         // 
         this.dpDate.CustomFormat = "dd/MM/yyyy";
         this.dpDate.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
         this.dpDate.Location = new System.Drawing.Point(8, 18);
         this.dpDate.Name = "dpDate";
         this.dpDate.Size = new System.Drawing.Size(144, 22);
         this.dpDate.TabIndex = 0;
         // 
         // GroupBox8
         // 
         this.GroupBox8.Controls.Add(this.cmbSide);
         this.GroupBox8.Location = new System.Drawing.Point(8, 112);
         this.GroupBox8.Name = "GroupBox8";
         this.GroupBox8.Size = new System.Drawing.Size(160, 48);
         this.GroupBox8.TabIndex = 61;
         this.GroupBox8.TabStop = false;
         this.GroupBox8.Text = "Side";
         // 
         // cmbSide
         // 
         this.cmbSide.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbSide.Location = new System.Drawing.Point(8, 16);
         this.cmbSide.Name = "cmbSide";
         this.cmbSide.Size = new System.Drawing.Size(144, 24);
         this.cmbSide.TabIndex = 0;
         // 
         // GroupBox7
         // 
         this.GroupBox7.Controls.Add(this.cmbStatus);
         this.GroupBox7.Location = new System.Drawing.Point(8, 64);
         this.GroupBox7.Name = "GroupBox7";
         this.GroupBox7.Size = new System.Drawing.Size(160, 48);
         this.GroupBox7.TabIndex = 60;
         this.GroupBox7.TabStop = false;
         this.GroupBox7.Text = "Status";
         // 
         // cmbStatus
         // 
         this.cmbStatus.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbStatus.Location = new System.Drawing.Point(8, 16);
         this.cmbStatus.Name = "cmbStatus";
         this.cmbStatus.Size = new System.Drawing.Size(144, 24);
         this.cmbStatus.TabIndex = 0;
         // 
         // GroupBox6
         // 
         this.GroupBox6.Controls.Add(this.cmbInstrument);
         this.GroupBox6.Location = new System.Drawing.Point(8, 16);
         this.GroupBox6.Name = "GroupBox6";
         this.GroupBox6.Size = new System.Drawing.Size(160, 48);
         this.GroupBox6.TabIndex = 59;
         this.GroupBox6.TabStop = false;
         this.GroupBox6.Text = "Instrument";
         // 
         // cmbInstrument
         // 
         this.cmbInstrument.Location = new System.Drawing.Point(8, 16);
         this.cmbInstrument.Name = "cmbInstrument";
         this.cmbInstrument.Size = new System.Drawing.Size(144, 24);
         this.cmbInstrument.TabIndex = 0;
         this.cmbInstrument.KeyDown += new System.Windows.Forms.KeyEventHandler(this.cmbInstrument_KeyDown);
         // 
         // btnQuery
         // 
         this.btnQuery.Location = new System.Drawing.Point(8, 248);
         this.btnQuery.Name = "btnQuery";
         this.btnQuery.Size = new System.Drawing.Size(160, 32);
         this.btnQuery.TabIndex = 57;
         this.btnQuery.Text = "Query Orders >>>";
         this.btnQuery.Click += new System.EventHandler(this.btnQuery_Click);
         // 
         // gbOrders
         // 
         this.gbOrders.Controls.Add(this.lvOrders);
         this.gbOrders.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.gbOrders.Location = new System.Drawing.Point(176, 16);
         this.gbOrders.Name = "gbOrders";
         this.gbOrders.Size = new System.Drawing.Size(824, 320);
         this.gbOrders.TabIndex = 55;
         this.gbOrders.TabStop = false;
         // 
         // lvOrders
         // 
         this.lvOrders.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                     this.EmptyColumn,
                                                                                     this.Sizee,
                                                                                     this.Side_,
                                                                                     this.ColumnHeader15,
                                                                                     this.Symbol_,
                                                                                     this.Type_,
                                                                                     this.PlaceTime,
                                                                                     this.OrderNumber});
         this.lvOrders.FullRowSelect = true;
         this.lvOrders.GridLines = true;
         this.lvOrders.Location = new System.Drawing.Point(8, 16);
         this.lvOrders.MultiSelect = false;
         this.lvOrders.Name = "lvOrders";
         this.lvOrders.Size = new System.Drawing.Size(808, 296);
         this.lvOrders.TabIndex = 65;
         this.lvOrders.View = System.Windows.Forms.View.Details;
         this.lvOrders.SelectedIndexChanged += new System.EventHandler(this.lvOrders_SelectedIndexChanged);
         // 
         // EmptyColumn
         // 
         this.EmptyColumn.Text = "";
         this.EmptyColumn.Width = 0;
         // 
         // Sizee
         // 
         this.Sizee.Text = "Size";
         this.Sizee.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Sizee.Width = 102;
         // 
         // Side_
         // 
         this.Side_.Text = "Side";
         this.Side_.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Side_.Width = 95;
         // 
         // ColumnHeader15
         // 
         this.ColumnHeader15.Text = "Status";
         this.ColumnHeader15.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader15.Width = 102;
         // 
         // Symbol_
         // 
         this.Symbol_.Text = "Symbol";
         this.Symbol_.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Symbol_.Width = 100;
         // 
         // Type_
         // 
         this.Type_.Text = "Type";
         this.Type_.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Type_.Width = 91;
         // 
         // PlaceTime
         // 
         this.PlaceTime.Text = "Place Time";
         this.PlaceTime.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.PlaceTime.Width = 193;
         // 
         // OrderNumber
         // 
         this.OrderNumber.Text = "Order #";
         this.OrderNumber.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.OrderNumber.Width = 97;
         // 
         // PictureBox1
         // 
         this.PictureBox1.BackColor = System.Drawing.Color.Black;
         this.PictureBox1.Location = new System.Drawing.Point(0, 32);
         this.PictureBox1.Name = "PictureBox1";
         this.PictureBox1.Size = new System.Drawing.Size(1208, 8);
         this.PictureBox1.TabIndex = 59;
         this.PictureBox1.TabStop = false;
         // 
         // GroupBox5
         // 
         this.GroupBox5.Controls.Add(this.lvProperties);
         this.GroupBox5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox5.Location = new System.Drawing.Point(8, 448);
         this.GroupBox5.Name = "GroupBox5";
         this.GroupBox5.Size = new System.Drawing.Size(296, 312);
         this.GroupBox5.TabIndex = 60;
         this.GroupBox5.TabStop = false;
         this.GroupBox5.Text = "Selected Order\'s Properties";
         // 
         // lvProperties
         // 
         this.lvProperties.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                         this.ColumnHeader1,
                                                                                         this.Name_,
                                                                                         this.Value});
         this.lvProperties.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lvProperties.FullRowSelect = true;
         this.lvProperties.GridLines = true;
         this.lvProperties.Location = new System.Drawing.Point(8, 24);
         this.lvProperties.MultiSelect = false;
         this.lvProperties.Name = "lvProperties";
         this.lvProperties.Size = new System.Drawing.Size(280, 280);
         this.lvProperties.TabIndex = 65;
         this.lvProperties.View = System.Windows.Forms.View.Details;
         // 
         // ColumnHeader1
         // 
         this.ColumnHeader1.Text = "";
         this.ColumnHeader1.Width = 0;
         // 
         // Name_
         // 
         this.Name_.Text = "Name";
         this.Name_.Width = 93;
         // 
         // Value
         // 
         this.Value.Text = "Value";
         this.Value.Width = 164;
         // 
         // GroupBox10
         // 
         this.GroupBox10.Controls.Add(this.lvFills);
         this.GroupBox10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.GroupBox10.Location = new System.Drawing.Point(312, 592);
         this.GroupBox10.Name = "GroupBox10";
         this.GroupBox10.Size = new System.Drawing.Size(872, 168);
         this.GroupBox10.TabIndex = 61;
         this.GroupBox10.TabStop = false;
         this.GroupBox10.Text = "Selected Order\'s Fills";
         // 
         // lvFills
         // 
         this.lvFills.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                    this.ColumnHeader2,
                                                                                    this.Leg,
                                                                                    this.ColumnHeader14,
                                                                                    this.ColumnHeader4,
                                                                                    this.ColumnHeader3,
                                                                                    this.ColumnHeader5,
                                                                                    this.ColumnHeader6,
                                                                                    this.ColumnHeader7,
                                                                                    this.ColumnHeader8,
                                                                                    this.ColumnHeader13,
                                                                                    this.ColumnHeader10,
                                                                                    this.ColumnHeader11,
                                                                                    this.ColumnHeader9,
                                                                                    this.ColumnHeader12});
         this.lvFills.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lvFills.FullRowSelect = true;
         this.lvFills.GridLines = true;
         this.lvFills.HideSelection = false;
         this.lvFills.ImeMode = System.Windows.Forms.ImeMode.NoControl;
         this.lvFills.Location = new System.Drawing.Point(8, 16);
         this.lvFills.MultiSelect = false;
         this.lvFills.Name = "lvFills";
         this.lvFills.Size = new System.Drawing.Size(856, 144);
         this.lvFills.TabIndex = 65;
         this.lvFills.View = System.Windows.Forms.View.Details;
         // 
         // ColumnHeader2
         // 
         this.ColumnHeader2.Text = "";
         this.ColumnHeader2.Width = 0;
         // 
         // Leg
         // 
         this.Leg.Text = "Leg";
         this.Leg.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Leg.Width = 37;
         // 
         // ColumnHeader14
         // 
         this.ColumnHeader14.Text = "Aggressive";
         this.ColumnHeader14.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader14.Width = 69;
         // 
         // ColumnHeader4
         // 
         this.ColumnHeader4.Text = "Currency";
         this.ColumnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader4.Width = 59;
         // 
         // ColumnHeader3
         // 
         this.ColumnHeader3.Text = "DisplayPrice";
         this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader3.Width = 75;
         // 
         // ColumnHeader5
         // 
         this.ColumnHeader5.Text = "GWTradeID";
         this.ColumnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader5.Width = 72;
         // 
         // ColumnHeader6
         // 
         this.ColumnHeader6.Text = "InstrumentName";
         this.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader6.Width = 91;
         // 
         // ColumnHeader7
         // 
         this.ColumnHeader7.Text = "Price";
         this.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader7.Width = 55;
         // 
         // ColumnHeader8
         // 
         this.ColumnHeader8.Text = "Quantity";
         this.ColumnHeader8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader8.Width = 52;
         // 
         // ColumnHeader13
         // 
         this.ColumnHeader13.Text = "RefFillID";
         this.ColumnHeader13.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader13.Width = 55;
         // 
         // ColumnHeader10
         // 
         this.ColumnHeader10.Text = "Side";
         this.ColumnHeader10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader10.Width = 42;
         // 
         // ColumnHeader11
         // 
         this.ColumnHeader11.Text = "Status";
         this.ColumnHeader11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader11.Width = 48;
         // 
         // ColumnHeader9
         // 
         this.ColumnHeader9.Text = "ServerTimestamp";
         this.ColumnHeader9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader9.Width = 101;
         // 
         // ColumnHeader12
         // 
         this.ColumnHeader12.Text = "Timestamp";
         this.ColumnHeader12.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader12.Width = 95;
         // 
         // groupBox14
         // 
         this.groupBox14.Controls.Add(this.lvTransactions);
         this.groupBox14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.groupBox14.Location = new System.Drawing.Point(312, 448);
         this.groupBox14.Name = "groupBox14";
         this.groupBox14.Size = new System.Drawing.Size(872, 136);
         this.groupBox14.TabIndex = 62;
         this.groupBox14.TabStop = false;
         this.groupBox14.Text = "Selected Order\'s Transactions";
         // 
         // lvTransactions
         // 
         this.lvTransactions.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                           this.columnHeader16,
                                                                                           this.columnHeader17,
                                                                                           this.columnHeader18,
                                                                                           this.columnHeader19,
                                                                                           this.columnHeader20,
                                                                                           this.columnHeader21,
                                                                                           this.columnHeader22,
                                                                                           this.columnHeader23,
                                                                                           this.columnHeader24});
         this.lvTransactions.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.lvTransactions.FullRowSelect = true;
         this.lvTransactions.GridLines = true;
         this.lvTransactions.HideSelection = false;
         this.lvTransactions.Location = new System.Drawing.Point(8, 16);
         this.lvTransactions.MultiSelect = false;
         this.lvTransactions.Name = "lvTransactions";
         this.lvTransactions.Size = new System.Drawing.Size(856, 112);
         this.lvTransactions.TabIndex = 65;
         this.lvTransactions.View = System.Windows.Forms.View.Details;
         // 
         // columnHeader16
         // 
         this.columnHeader16.Text = "";
         this.columnHeader16.Width = 0;
         // 
         // columnHeader17
         // 
         this.columnHeader17.Text = "Timestamp";
         this.columnHeader17.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader17.Width = 120;
         // 
         // columnHeader18
         // 
         this.columnHeader18.Text = "Transaction ID";
         this.columnHeader18.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader18.Width = 85;
         // 
         // columnHeader19
         // 
         this.columnHeader19.Text = "Status";
         this.columnHeader19.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader19.Width = 95;
         // 
         // columnHeader20
         // 
         this.columnHeader20.Text = "Fill ID";
         this.columnHeader20.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader20.Width = 85;
         // 
         // columnHeader21
         // 
         this.columnHeader21.Text = "Reject Reason";
         this.columnHeader21.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader21.Width = 150;
         // 
         // columnHeader22
         // 
         this.columnHeader22.Text = "Property Name";
         this.columnHeader22.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader22.Width = 100;
         // 
         // columnHeader23
         // 
         this.columnHeader23.Text = "Old Value";
         this.columnHeader23.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader23.Width = 100;
         // 
         // columnHeader24
         // 
         this.columnHeader24.Text = "New Value";
         this.columnHeader24.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader24.Width = 100;
         // 
         // btnGWLogOnOff
         // 
         this.btnGWLogOnOff.Location = new System.Drawing.Point(560, 4);
         this.btnGWLogOnOff.Name = "btnGWLogOnOff";
         this.btnGWLogOnOff.TabIndex = 63;
         this.btnGWLogOnOff.Text = "Log In";
         this.btnGWLogOnOff.Click += new System.EventHandler(this.btnGWLogOnOff_Click);
         // 
         // lblUsername
         // 
         this.lblUsername.Location = new System.Drawing.Point(648, 8);
         this.lblUsername.Name = "lblUsername";
         this.lblUsername.Size = new System.Drawing.Size(128, 23);
         this.lblUsername.TabIndex = 64;
         this.lblUsername.Text = "label2";
         // 
         // chbIncludeTransactions
         // 
         this.chbIncludeTransactions.Checked = true;
         this.chbIncludeTransactions.CheckState = System.Windows.Forms.CheckState.Checked;
         this.chbIncludeTransactions.Location = new System.Drawing.Point(16, 216);
         this.chbIncludeTransactions.Name = "chbIncludeTransactions";
         this.chbIncludeTransactions.Size = new System.Drawing.Size(112, 24);
         this.chbIncludeTransactions.TabIndex = 71;
         this.chbIncludeTransactions.Text = "Transactions";
         // 
         // frmOrderProperties
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.BackColor = System.Drawing.SystemColors.Control;
         this.ClientSize = new System.Drawing.Size(1186, 767);
         this.Controls.Add(this.lblUsername);
         this.Controls.Add(this.btnGWLogOnOff);
         this.Controls.Add(this.groupBox14);
         this.Controls.Add(this.GroupBox10);
         this.Controls.Add(this.GroupBox5);
         this.Controls.Add(this.PictureBox1);
         this.Controls.Add(this.GroupBox1);
         this.Controls.Add(this.GroupBox2);
         this.Controls.Add(this.lblGWConnection);
         this.Controls.Add(this.lblDataConnection);
         this.Controls.Add(this.llWeb);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
         this.MaximizeBox = false;
         this.Name = "frmOrderProperties";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "Order Properties";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmOrderProperties_Closing);
         this.Load += new System.EventHandler(this.frmOrderProperties_Load);
         this.GroupBox2.ResumeLayout(false);
         this.GroupBox1.ResumeLayout(false);
         this.GroupBox3.ResumeLayout(false);
         this.GroupBox11.ResumeLayout(false);
         this.GroupBox12.ResumeLayout(false);
         this.GroupBox13.ResumeLayout(false);
         this.GroupBox9.ResumeLayout(false);
         this.GroupBox8.ResumeLayout(false);
         this.GroupBox7.ResumeLayout(false);
         this.GroupBox6.ResumeLayout(false);
         this.gbOrders.ResumeLayout(false);
         this.GroupBox5.ResumeLayout(false);
         this.GroupBox10.ResumeLayout(false);
         this.groupBox14.ResumeLayout(false);
         this.ResumeLayout(false);

      }

      #endregion

      /// <summary>
      /// Creates an CQGCEL object, change its configurations, starts up and initializes all needed controls.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void frmOrderProperties_Load(System.Object sender, System.EventArgs e)
      {
         try
         {
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
            CEL_GWConnectionStatusChanged(eConnectionStatus.csConnectionDown);
            Init();
            InitCEL();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "frmOrderProperties_Load", ex);
         }
      }

      /// <summary>
      /// Initializes CQGCEL and calls its StartUp method.
      /// </summary>
      private void InitCEL()
      {
         m_CEL = new CQGCEL();
         m_CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
         m_CEL.GWConnectionStatusChanged += new CQG._ICQGCELEvents_GWConnectionStatusChangedEventHandler(CEL_GWConnectionStatusChanged);
         m_CEL.AccountChanged += new CQG._ICQGCELEvents_AccountChangedEventHandler(CEL_AccountChanged);
         m_CEL.InstrumentResolved += new CQG._ICQGCELEvents_InstrumentResolvedEventHandler(CEL_InstrumentResolved);
         m_CEL.OnQueryProgress += new CQG._ICQGCELEvents_OnQueryProgressEventHandler(CEL_OnQueryProgress);
         m_CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
         m_CEL.APIConfiguration.CollectionsThrowException = false;
         m_CEL.APIConfiguration.DefPositionSubscriptionLevel = ePositionSubscriptionLevel.pslSnapshotAndUpdates;
         m_CEL.APIConfiguration.FireEventOnChangedPrices = true;
         m_CEL.APIConfiguration.UseOrderSide = true;
         m_CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
         // Set NewInstrumentMode to request only instrument metadata with CreateInstrumentRequest:
         // http://partners.cqg.com/sites/default/files/docs/CQGAPI_4.0R/webframe.html#CQG~CQGAPIConfig~NewInstrumentMode.html
         m_CEL.APIConfiguration.NewInstrumentMode = true;
         m_CEL.Startup();
      }

      /// <summary>
      /// Initializes Side and Status combo boxes and sets the date value for DateTimePicker.
      /// Also initializes SelectSide, SelectType, SelectStatus combos for filtering.
      /// </summary>
      private void Init()
      {
         btnGWLogOnOff.Enabled = false;

         cmbSide.Items.Clear();
         cmbSide.Items.Add(eOrderSide.osdBuy);
         cmbSide.Items.Add(eOrderSide.osdSell);
         cmbSide.Items.Add(eOrderSide.osdUndefined);
         cmbSide.SelectedIndex = 2;

         cmbStatus.Items.Clear();
         cmbStatus.Items.Add(eOrderStatusFilter.osfAll);
         cmbStatus.Items.Add(eOrderStatusFilter.osfNotFinal);
         cmbStatus.Items.Add(eOrderStatusFilter.osfFinal);
         cmbStatus.Items.Add(eOrderStatusFilter.osfFilled);
         cmbStatus.Items.Add(eOrderStatusFilter.osfException);
         cmbStatus.Items.Add(eOrderStatusFilter.osfParked);
         cmbStatus.Items.Add(eOrderStatusFilter.osfCanceled);
         cmbStatus.SelectedIndex = 0;

         dpDate.Value = DateTime.Now;

         /// Filtering components
         cmbSelectSide.Items.Clear();
         cmbSelectSide.Items.Add(eOrderSide.osdBuy);
         cmbSelectSide.Items.Add(eOrderSide.osdSell);
         cmbSelectSide.Items.Add(eOrderSide.osdUndefined);
         cmbSelectSide.SelectedIndex = 2;

         cmbSelectType.Items.Clear();
         cmbSelectType.Items.Add(eOrderType.otMarket);
         cmbSelectType.Items.Add(eOrderType.otLimit);
         cmbSelectType.Items.Add(eOrderType.otStop);
         cmbSelectType.Items.Add(eOrderType.otStopLimit);
         cmbSelectType.Items.Add(eOrderType.otUndefined);
         cmbSelectType.SelectedIndex = 4;

         cmbSelectStatus.Items.Clear();
         cmbSelectStatus.Items.Add("All");
         cmbSelectStatus.Items.Add(eOrderStatus.osNotSent);
         cmbSelectStatus.Items.Add(eOrderStatus.osInClient);
         cmbSelectStatus.Items.Add(eOrderStatus.osInTransit);
         cmbSelectStatus.Items.Add(eOrderStatus.osRejectGW);
         cmbSelectStatus.Items.Add(eOrderStatus.osInOrderBook);
         cmbSelectStatus.Items.Add(eOrderStatus.osInTransitTimeout);
         cmbSelectStatus.Items.Add(eOrderStatus.osRejectFCM);
         cmbSelectStatus.Items.Add(eOrderStatus.osExpired);
         cmbSelectStatus.Items.Add(eOrderStatus.osInCancel);
         cmbSelectStatus.Items.Add(eOrderStatus.osInModify);
         cmbSelectStatus.Items.Add(eOrderStatus.osCanceled);
         cmbSelectStatus.Items.Add(eOrderStatus.osFilled);
         cmbSelectStatus.Items.Add(eOrderStatus.osParked);
         cmbSelectStatus.Items.Add(eOrderStatus.osDisconnected);
         cmbSelectStatus.Items.Add(eOrderStatus.osContingent);
         cmbSelectStatus.Items.Add(eOrderStatus.osBusted);
         cmbSelectStatus.Items.Add(eOrderStatus.osActiveAt);
         cmbSelectStatus.SelectedIndex = 0;
      }

      /// <summary>
      /// Shuts down CQGCEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A CancelEventArgs that contains the event data.
      /// </param>
      private void frmOrderProperties_Closing(object sender, System.ComponentModel.CancelEventArgs e)
      {
         try
         {
            m_CEL.Shutdown();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "frmOrderProperties_Closing", ex);
         }
      }

      /// <summary>
      /// This event is fired, when some changes occur in the connection with the CQG data server.
      /// </summary>
      /// <param name="newStatus">
      /// The current status of the connection with the data server.
      /// </param>
      private void CEL_DataConnectionStatusChanged(eConnectionStatus newStatus)
      {
         try
         {
            Color backCol;

            if (newStatus != eConnectionStatus.csConnectionUp)
            {
               backCol = Color.FromArgb(255, 114, 0);
            }
            else
            {
               backCol = Color.FromArgb(192, 209, 205);
            }

            lblDataConnection.BackColor = backCol;
            lblDataConnection.Text = "DATA Connection is : " + ConnectionStatusToString(newStatus);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "CEL_DataConnectionStatusChanged", ex);
         }
      }

      /// <summary>
      /// This event is fired when the status of the connection with the CQG Gateway is changed.
      /// </summary>
      /// <param name="newStatus">
      /// The current status of the connection with CQG Gateway.
      /// </param>
      private void CEL_GWConnectionStatusChanged(eConnectionStatus newStatus)
      {
         try
         {
            Color backCol;

            if (newStatus != eConnectionStatus.csConnectionUp)
            {
               backCol = Color.FromArgb(255, 114, 0);

               /// Clearing all displayed data, because after the GW connection is up, we will receive all data again.
               cmbAccounts.Items.Clear();
               DisplayOrders(null);
               m_Query = null;

               SetControlsStatuses(false);
            }
            else
            {
               backCol = Color.FromArgb(192, 209, 205);
               m_CEL.AccountSubscriptionLevel = eAccountSubscriptionLevel.aslAccountUpdatesAndOrders;
            }

            lblGWConnection.BackColor = backCol;
            lblGWConnection.Text = "GW Connection is : " + ConnectionStatusToString(newStatus);

            SetGWLogonStatus(newStatus);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "CEL_GWConnectionStatusChanged", ex);
         }
      }

      /// <summary>
      /// This event is fired, when the account or position information is changed.
      /// </summary>
      /// <param name="change">
      /// Account change type, which allows to differentiate the occurred changes.
      /// </param>
      /// <param name="Account">
      /// A CQGAccount object, representing the account to which the current change refers.
      /// </param>
      /// <param name="position">
      /// A CQGPosition object, representing the position to which the current change refers.
      /// </param>
      private void CEL_AccountChanged(eAccountChangeType change, CQGAccount account, CQGPosition position)
      {
         try
         {
            if (change == eAccountChangeType.actAccountsReloaded)
            {
               foreach (CQGAccount acc in m_CEL.Accounts)
               {
                  cmbAccounts.Items.Add(acc.GWAccountID.ToString().PadRight(LIST_ACC_COL_WIDTH) +
                                          acc.GWAccountName.PadRight(LIST_ACC_COL_WIDTH) +
                                          acc.FcmAccountID.PadRight(LIST_ACC_COL_WIDTH) +
                                          acc.FcmID.ToString().PadRight(LIST_ACC_COL_WIDTH));
                  acc.AutoSubscribeInstruments = true;
               }
               cmbAccounts.SelectedIndex = 0;
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "CEL_AccountChanged", ex);
         }
      }
      /// <summary>
      /// This event is fired when a new instrument is resolved and subscribed.
      /// </summary>
      /// <param name="symbl">
      /// The commodity symbol that was requested by the user in the SubscribeNewInstrument method.
      /// </param>
      /// <param name="Instrument">
      /// Resolved CQGInstrument object
      /// </param>
      /// <param name= "cqg_error">
      /// A valid CQGError object if error occured.
      /// </param>
      private void CEL_InstrumentResolved(string symbl, CQGInstrument instrument, CQG.CQGError cqg_error)
      {
         try
         {
            if (m_CEL.IsValid(cqg_error))
            {
               ErrorHandler.HandleError("frmOrderProperties", "CEL_InstrumentResolved", cqg_error);
               return;
            }

            if (cmbInstrument.FindStringExact(instrument.FullName) > -1)
            {
               cmbInstrument.Text = instrument.FullName;
               return;
            }
            cmbInstrument.Items.Add(instrument.FullName);
            if (cmbInstrument.Text.ToUpper() == symbl)
            {
               cmbInstrument.Text = instrument.FullName;
            }
            if (lvOrders.SelectedItems.Count > 0)
            {
               CQGOrder order = m_Query.Orders[lvOrders.SelectedItems[0].SubItems[ORDER_NUMBER_COLUMN].Text];
               if (order.InstrumentName == instrument.FullName)
               {
                  DisplayTransactions(order);
                  DisplayFills(order);
                  DisplayProperties(order);
               }
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "CEL_InstrumentResolved", ex);
         }
      }

      /// <summary>
      /// This event is fired if a query has some progress: either new results arrived or the status is changed.
      /// </summary>
      /// <param name="query">
      /// The CQGQuery object to which the change refers.
      /// This is the same object that was returned by QueryOrders.
      /// </param>
      /// <param name="error">
      /// A CQGError object describing the last error which occurred during this order query, if any.
      /// </param>
      private void CEL_OnQueryProgress(CQGOrdersQuery query, CQGError error)
      {
         try
         {
            if (m_CEL.IsValid(error))
            {
               MessageBox.Show(error.Description, "Query Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
               return;
            }

            m_Query = query;

            if (query.Status != eRequestStatus.rsInProgress)
            {
               SetControlsStatuses(true);
               cmbAccounts.Enabled = true;

               DisplayOrders(query.Orders);
            }
            lblStatus.Text = query.Status.ToString();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "CEL_OnQueryProgress", ex);
         }
      }

      /// <summary>
      /// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
      /// </summary>
      /// <param name="obj">
      /// Object, in which the error occurred.
      /// </param>
      /// <param name="errorDescription">
      /// String, describing the error.
      /// </param>
      private void CEL_DataError(object obj, string errorDescription)
      {
         try
         {
            CQGError cqgErr = obj as CQGError;
            if (m_CEL.IsValid(cqgErr))
            {
               if (cqgErr.Code == 102)
               {
                  errorDescription += " Restart the application.";
               }
               else if (cqgErr.Code == 125)
               {
                  errorDescription += " Turn on CQG Client and restart the application.";
               }
            }

            MessageBox.Show(errorDescription, "OrderProperties", MessageBoxButtons.OK, MessageBoxIcon.Information);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmAccountsAndPositions", "CEL_DataError", ex);
         }
      }

      /// <summary>
      /// Displays received orders for given account, 
      /// also selects the first order to show its fills and properties.
      /// </summary>
      /// <param name="orders">
      /// orders, which data must be shown.
      /// </param>
      private void DisplayOrders(CQGOrders orders)
      {
         if (orders == null)
         {
            lvOrders.Items.Clear();
            lblStatus.Text = "";
            DisplayTransactions(null);
            DisplayFills(null);
            DisplayProperties(null);
            return;
         }
         foreach (CQGOrder order in orders)
         {
            ListViewItem item = lvOrders.Items.Add(new ListViewItem());
            item.SubItems.Add("Size").Text = order.QuantityFractional.ToString();
            item.SubItems.Add("Side").Text = order.Side.ToString();
            item.SubItems.Add("Status").Text = order.GWStatus.ToString();
            item.SubItems.Add("Symbol").Text = order.InstrumentName;
            item.SubItems.Add("Type").Text = order.Type.ToString();
            item.SubItems.Add("PlaceTime").Text = ValToString(order.PlaceTime);
            item.SubItems.Add("OrderNumber").Text = order.GWOrderID;
         }
         if (lvOrders.Items.Count > 0)
         {
            lvOrders.Items[0].Selected = true;
         }
      }

      /// <summary>
      /// Displays fills for given order.
      /// </summary>
      /// <param name="order">
      /// Order, which fills must be shown.
      /// </param>
      private void DisplayFills(CQGOrder order)
      {
         if (order == null)
         {
            lvFills.Items.Clear();
            return;
         }
         int i = 0;
         foreach (CQGFill fill in order.Fills)
         {
            foreach (CQGGWTrade gwTrade in fill.get_GWTrades(0))
            {
               ListViewItem item = lvFills.Items.Add(new ListViewItem());
               item.BackColor = (i % 2 == 0) ? Color.White : Color.FromArgb(230, 230, 230);

               item.SubItems.Add("Leg").Text = gwTrade.Leg.ToString();
               item.SubItems.Add("Aggressive").Text = gwTrade.Aggressive.ToString();
               item.SubItems.Add("Currency").Text = gwTrade.Currency.ToString();
               item.SubItems.Add("DisplayPrice").Text = gwTrade.DisplayPrice;
               item.SubItems.Add("GWTradeID").Text = gwTrade.Id;
               item.SubItems.Add("InstrumentName").Text = gwTrade.InstrumentName;
               item.SubItems.Add("Price").Text = gwTrade.Price.ToString();
               item.SubItems.Add("Quantity").Text = gwTrade.QuantityFractional.ToString();
               item.SubItems.Add("RefFillID").Text = fill.RefFillId;
               item.SubItems.Add("Side").Text = gwTrade.Side.ToString();
               item.SubItems.Add("Status").Text = fill.Status.ToString();
               item.SubItems.Add("ServerTimestamp").Text = ValToString(fill.ServerTimestamp);
               item.SubItems.Add("Timestamp").Text = ValToString(fill.Timestamp);
               i++;
            }
         }
      }

      /// <summary>
      /// Displays transactions for given order.
      /// </summary>
      /// <param name="order">
      /// Order, which transactions must be shown.
      /// </param>
      private void DisplayTransactions(CQGOrder order)
      {
         if (order == null)
         {
            lvTransactions.Items.Clear();
            return;
         }

         Color colorGray = Color.FromArgb(230, 230, 230);
         int i = 0;
         foreach (CQGTransaction trans in order.Transactions)
         {
            ListViewItem item = lvTransactions.Items.Add(new ListViewItem());
            item.BackColor = (i % 2 == 0) ? Color.White : colorGray;

            item.SubItems.AddRange(new string[] {trans.Timestamp.ToString(),
                                                  trans.Id,
                                                  trans.Status.ToString(),
                                                  (trans.Fill != null) ? trans.Fill.Id : N_A,
                                                  trans.RejectReason});

            // Display modified properties of current transaction
            foreach (CQGModifiedProperty prop in trans.Properties)
            {
               item = lvTransactions.Items.Add(new ListViewItem());
               item.BackColor = (i % 2 == 0) ? Color.White : colorGray;

               item.SubItems.AddRange(new string[] {"", "", "", "", "", // Omit several columns
                                                    prop.Name,
                                                    prop.NewValue.ToString(),
                                                    prop.PreviousValue.ToString(),
                                                    });
            }
            i++;
         }
      }

      /// <summary>
      /// Displays properties for the given order.
      /// </summary>
      /// <param name="order">
      /// Order, which properties must be displayed.
      /// </param>
      private void DisplayProperties(CQGOrder order)
      {
         if (order == null)
         {
            lvProperties.Items.Clear();
            return;
         }

         int i = 0;
         string dispValue;
         foreach (CQGOrderProperty prop in order.Properties)
         {
            try
            {
               switch (prop.Type)
               {
                  case eOrderProperty.opOrderType:
                     dispValue = ((eOrderType)prop.Value).ToString();
                     break;
                  case eOrderProperty.opDurationType:
                     dispValue = ((eOrderDuration)prop.Value).ToString();
                     break;
                  case eOrderProperty.opSide:
                     dispValue = ((eOrderSide)prop.Value).ToString();
                     break;
                  case eOrderProperty.opGWStatus:
                     dispValue = ((eOrderStatus)prop.Value).ToString();
                     break;
                  case eOrderProperty.opState:
                     dispValue = ((eOrderLocalState)prop.Value).ToString();
                     break;
                  case eOrderProperty.opLastEvent:
                     dispValue = ((eOrderEvent)prop.Value).ToString();
                     break;
                  default:
                     dispValue = ValToString(prop.Value);
                     break;
               }
               ListViewItem item = lvProperties.Items.Add(new ListViewItem());
               item.SubItems.Add("Name").Text = prop.Name;
               item.SubItems.Add("Value").Text = dispValue;
               i++;
            }
            catch { }
         }
      }

      /// <summary>
      /// Enables/Disables controls if an account is/isn't selected.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void cmbAccounts_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         try
         {
            SetControlsStatuses(GetSelectedGWID() > 0);
            DisplayOrders(null);
            m_Query = null;
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "lstAccounts_SelectedIndexChanged", ex);
         }
      }

      /// <summary>
      /// Open CQG API web page.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A LinkLabelLinkClickedEventArgs that contains the event data.
      /// </param>
      private void llWeb_LinkClicked(System.Object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
      {
         try
         {
            System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "llWeb_LinkClicked", ex);
         }
      }

      /// <summary>
      /// Clears old values and makes a new order query.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnQuery_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            CQGInstrument instrument = GetSelectedInstrument();
            if (instrument == null)
            {
               cmbInstrument.Text = "";
            }

            m_CEL.APIConfiguration.IncludeOrderTransactions = chbIncludeTransactions.Checked;

            m_Query = m_CEL.QueryOrders(m_CEL.Accounts[GetSelectedGWID()],
                                        instrument,
                                        GetStatus(),
                                        dpDate.Value,
                                        GetSide());

            // Clear all previous data
            DisplayOrders(null);

            // Disable controls till query response
            cmbAccounts.Enabled = false;
            SetControlsStatuses(false);

            // Show query status
            lblStatus.Text = m_Query.Status.ToString();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "btnQuery_Click", ex);
         }
      }

      /// <summary>
      /// Cancels current query.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnCancel_Click(object sender, System.EventArgs e)
      {
         try
         {
            m_Query.Cancel();
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "btnCancel_Click", ex);
         }
      }

      /// <summary>
      /// Filters the query's result, if filter params were specified.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnFilter_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            if (m_Query == null)
            {
               return;
            }

            DisplayOrders(null);

            CQGOrders orders = m_Query.Orders.SelectBySide(GetSelectedSide());
            orders = orders.SelectByOrderType(GetSelectedType());
            bool isStatusSelected = false;
            eOrderStatus status = GetSelectedStatus(out isStatusSelected);
            if (isStatusSelected)
            {
               orders = orders.SelectByOrderStatus(status);
            }
            string instrName = txtSelectInstrumentName.Text;
            if (instrName.Length > 0)
            {
               orders = orders.SelectByInstrumentName(instrName.ToUpper());
            }

            DisplayOrders(orders);
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "btnFilter_Click", ex);
         }
      }

      /// <summary>
      /// Logs on/off from the Gateway.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnGWLogOnOff_Click(object sender, System.EventArgs e)
      {
         try
         {
            if ((bool)btnGWLogOnOff.Tag)
            {
               m_CEL.GWLogoff();
            }
            else
            {
               using (frmGatewayLogin gwForm = new frmGatewayLogin())
               {
                  if (gwForm.ShowDialog(this) == DialogResult.OK)
                  {
                     m_CEL.GWLogon(gwForm.txtUsername.Text, gwForm.txtPassword.Text);
                  }
               }
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "btnGWLogOnOff_Click", ex);
         }
      }

      /// <summary>
      /// Displays fills and properties for the selected order.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void lvOrders_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         try
         {
            DisplayTransactions(null);
            DisplayFills(null);
            DisplayProperties(null);
            if (lvOrders.SelectedItems.Count > 0)
            {
               CQGOrder order = m_Query.Orders[lvOrders.SelectedItems[0].SubItems[ORDER_NUMBER_COLUMN].Text];
               DisplayTransactions(order);
               DisplayFills(order);
               DisplayProperties(order);
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "lvOrders_SelectedIndexChanged", ex);
         }
      }

      /// <summary>
      /// Subscribes to a new instrument when the Enter key is pressed.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An KeyEventArgs that contains the event data.
      /// </param>
      private void cmbInstrument_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
      {
         try
         {
            if (e.KeyCode == Keys.Enter)
            {
               CQGInstrumentSubscriptionRequest request = m_CEL.CreateInstrumentRequest();
               request.Symbol = cmbInstrument.Text;

               m_CEL.SubscribeNewInstrument(request);
            }
         }
         catch (Exception ex)
         {
            ErrorHandler.HandleError("frmOrderProperties", "cmbInstrument_KeyDown", ex);
         }
      }

      /// <summary>
      /// Enables/disables GW logon button.
      /// </summary>
      /// <param name="status">Current connection status</param>
      private void SetGWLogonStatus(eConnectionStatus status)
      {
         if (status == eConnectionStatus.csConnectionUp)
         {
            btnGWLogOnOff.Enabled = true;
            btnGWLogOnOff.Text = "Log Off";
            btnGWLogOnOff.Tag = true;

            // Display logged on username
            lblUsername.Text = m_CEL.Environment.GWLogonName;
            cmbAccounts.Enabled = true;
         }
         else if (status == eConnectionStatus.csConnectionNotLoggedOn ||
            status == eConnectionStatus.csConnectionDown)
         {
            btnGWLogOnOff.Enabled = true;
            btnGWLogOnOff.Text = "Log On";
            btnGWLogOnOff.Tag = false;

            lblUsername.Text = "";
         }
         else
         {
            btnGWLogOnOff.Enabled = false;
         }
      }

      /// <summary>
      /// Enables/Disables controls.
      /// </summary>
      /// <param name="status">
      /// New status of controls' enablement.
      /// </param>
      private void SetControlsStatuses(bool status)
      {
         dpDate.Enabled = status;
         cmbInstrument.Enabled = status;
         cmbSide.Enabled = status;
         cmbStatus.Enabled = status;
         btnQuery.Enabled = status;
         if (m_Query == null)
         {
            btnCancel.Enabled = false;
         }
         else
         {
            btnCancel.Enabled = (!status) && (m_Query.Status == eRequestStatus.rsInProgress);
         }

         txtSelectInstrumentName.Enabled = status;
         cmbSelectSide.Enabled = status;
         cmbSelectType.Enabled = status;
         cmbSelectStatus.Enabled = status;
         btnFilter.Enabled = status;
         chbIncludeTransactions.Enabled = status;
      }

      /// <summary>
      /// Returns GWAccountId for the selected account in lstAccounts.
      /// </summary>
      /// <returns>
      /// 0 if there is no selection, otherwise GWAccountId.
      /// </returns>
      private int GetSelectedGWID()
      {
         string gwID = cmbAccounts.Text.Substring(0, LIST_ACC_COL_WIDTH);

         if (gwID.Trim().Length == 0)
         {
            return 0;
         }

         return int.Parse(gwID);
      }

      /// <summary>
      /// Returns the selected side in cmbSide.
      /// </summary>
      /// <returns>
      /// Selected side
      /// </returns>
      private eOrderSide GetSide()
      {
         eOrderSide result;
         object obj = cmbSide.SelectedItem;
         if (obj is eOrderSide)
         {
            result = (eOrderSide)obj;
         }
         else
         {
            result = eOrderSide.osdUndefined;
         }

         return result;
      }

      /// <summary>
      /// Returns the selected status filter in cmbStatus.
      /// </summary>
      /// <returns>
      /// Selected status filter.
      /// </returns>
      private eOrderStatusFilter GetStatus()
      {
         eOrderStatusFilter result;
         object obj = cmbStatus.SelectedItem;
         if (obj is eOrderStatusFilter)
         {
            result = (eOrderStatusFilter)obj;
         }
         else
         {
            result = eOrderStatusFilter.osfAll;
         }

         return result;
      }

      /// <summary>
      /// Returns the selected side in cmbSelectType.
      /// </summary>
      /// <returns>
      /// Selected side
      /// </returns>
      private eOrderType GetSelectedType()
      {
         eOrderType result;
         object obj = cmbSelectType.SelectedItem;
         if (obj is eOrderType)
         {
            result = (eOrderType)obj;
         }
         else
         {
            result = eOrderType.otUndefined;
         }

         return result;
      }

      /// <summary>
      /// Returns the selected status filter in cmbSelectStatus.
      /// </summary>
      /// <param name="isSelected">
      /// Out param, which shows if an item is selected.
      /// Used for "All" item in combo.
      /// </param>
      /// <returns>
      /// Selected status.
      /// </returns>
      private eOrderStatus GetSelectedStatus(out bool isSelected)
      {
         eOrderStatus result = 0;

         isSelected = true;
         object obj = cmbSelectStatus.SelectedItem;
         if (obj is eOrderStatus)
         {
            result = (eOrderStatus)obj;
         }
         else
         {
            isSelected = false;
         }

         return result;
      }

      /// <summary>
      /// Returns the selected side in cmbSelectSide.
      /// </summary>
      /// <returns>
      /// Selected side
      /// </returns>
      private eOrderSide GetSelectedSide()
      {
         eOrderSide result;

         object obj = cmbSelectSide.SelectedItem;
         if (obj is eOrderSide)
         {
            result = (eOrderSide)obj;
         }
         else
         {
            result = eOrderSide.osdUndefined;
         }

         return result;
      }

      /// <summary>
      /// Returns Instrument for the selected fullname in cmbInstrument.
      /// If there is no subscribed instrument with such fullname, returns nothing and deletes cmbInstrument's text.
      /// </summary>
      /// <returns>
      /// Selected instrument, if exists; otherwise nothing.
      /// </returns>
      private CQGInstrument GetSelectedInstrument()
      {
         return m_CEL.Instruments[cmbInstrument.Text];
      }

      /// <summary>
      /// Converts input param to string.
      /// </summary>
      /// <param name="val">
      /// Input param, which must be converted to string, if it isn't nothing and is valid.
      /// </param>
      /// <returns>
      /// "N/A" if input is nothing or is not valid, otherwise input param is converted to string.
      /// </returns>
      private string ValToString(object val)
      {
         string dispVal;
         if ((val != null) && m_CEL.IsValid(val))
         {
            if (val is double)
            {
               double dVal;
               dVal = (double)val;
               dispVal = dVal.ToString("0.00");
            }
            else
            {
               dispVal = val.ToString();
            }
         }
         else
         {
            dispVal = N_A;
         }

         return dispVal;
      }


      /// <summary>
      /// Returns string representation of the specified status.
      /// </summary>
      /// <param name="status">Connection status</param>
      /// <returns>String representation of the status</returns>
      private static string ConnectionStatusToString(eConnectionStatus status)
      {
         switch (status)
         {
            case eConnectionStatus.csConnectionUp:
               return "Up";
            case eConnectionStatus.csConnectionDown:
               return "Down";
            case eConnectionStatus.csConnectionDelayed:
               return "Delayed";
            case eConnectionStatus.csConnectionTrouble:
               return "Trouble";
            case eConnectionStatus.csConnectionNotLoggedOn:
               return "Not logged on";
            default:
               return "Unknown";
         }
      }
   }
}
