using System.Diagnostics;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;

namespace PointAndFigureBars
{
	public class frmPointAndFigureBars : System.Windows.Forms.Form
	{

		[STAThread]
		static void Main()
		{
			Application.Run(new frmPointAndFigureBars());
		}

		// The CQGCEL object, which encapsulates the main functionality of CQG API
		[field: System.CLSCompliant(false)]
		public CQGCEL CEL;

		// The currently selected PointAndFigureBars object in the combo box
		private CQGPointAndFigureBars m_CurPointAndFigureBars;

		// Specifies the not available string
		private const string N_A = "N/A";

		// Specifies the max records count
		private const int MAX_NUMBER_OF_RECORDS = 5;
		private System.Windows.Forms.ColumnHeader columnHeader13;
		private System.Windows.Forms.ColumnHeader columnHeader14;
		private System.Windows.Forms.ColumnHeader columnHeader15;
		private System.Windows.Forms.ColumnHeader columnHeader16;

		// Specifies the max index interval
		private const int MAX_INDEX_INTERVAL = 500;

		#region " Windows Form Designer generated code "

		public frmPointAndFigureBars()
		{

			//This call is required by the Windows Form Designer.
			InitializeComponent();

			//Add any initialization after the InitializeComponent() call

		}

		//Form overrides dispose to clean up the component list.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(components == null))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		//Required by the Windows Form Designer
		private System.ComponentModel.Container components = null;

		//NOTE: The following procedure is required by the Windows Form Designer
		//It can be modified using the Windows Form Designer.
		//Do not modify it using the code editor.
		internal System.Windows.Forms.Label lblDataConnection;
		internal System.Windows.Forms.PictureBox PictureBox1;
		internal System.Windows.Forms.LinkLabel llWeb;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.PictureBox PictureBox2;
		internal System.Windows.Forms.PictureBox PictureBox3;
		internal System.Windows.Forms.GroupBox GroupBox2;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.Label Label18;
		internal System.Windows.Forms.GroupBox GroupBox3;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.GroupBox GroupBox4;
		internal System.Windows.Forms.ComboBox cmbPointAndFigureBars;
		internal System.Windows.Forms.Label lblRPSymbol;
		internal System.Windows.Forms.Label lblRPRangeEnd;
		internal System.Windows.Forms.Label lblRPRangeStart;
		internal System.Windows.Forms.Label lblOEnd;
		internal System.Windows.Forms.Label lblOStart;
		internal System.Windows.Forms.Label lblStatus;
		internal System.Windows.Forms.TextBox txtTagName;
		internal System.Windows.Forms.TextBox txtTagValue;
		internal System.Windows.Forms.Button btnRequest;
		internal System.Windows.Forms.Button btnRemove;
		internal System.Windows.Forms.Button btnRemoveAll;
		internal System.Windows.Forms.GroupBox GroupBox5;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.GroupBox gbIndexInterval;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Button btnShow;
		internal System.Windows.Forms.NumericUpDown nudEnd;
		internal System.Windows.Forms.NumericUpDown nudStart;
		internal System.Windows.Forms.GroupBox GroupBox6;
		internal System.Windows.Forms.Label lblError;
		internal System.Windows.Forms.ColumnHeader ColumnHeader1;
		internal System.Windows.Forms.ColumnHeader ColumnHeader2;
		internal System.Windows.Forms.ColumnHeader ColumnHeader3;
		internal System.Windows.Forms.ColumnHeader ColumnHeader5;
		internal System.Windows.Forms.ColumnHeader ColumnHeader6;
		internal System.Windows.Forms.ColumnHeader ColumnHeader7;
		internal System.Windows.Forms.ListView lvPointAndFigureBars;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label17;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Label Label23;
		internal System.Windows.Forms.Label Label25;
		internal System.Windows.Forms.Label Label27;
		internal System.Windows.Forms.Label Label29;
		internal System.Windows.Forms.Label lblRPSessionFlags;
		internal System.Windows.Forms.Label lblRPIncludeEnd;
		internal System.Windows.Forms.Label lblRPUpdatesEnabled;
		internal System.Windows.Forms.Label lblRPContinuation;
		internal System.Windows.Forms.Label lblRPSessionsFilter;
		internal System.Windows.Forms.Label lblRPDaysBeforeExpiration;
		internal System.Windows.Forms.Label lblRPEqualizeCloses;
		internal System.Windows.Forms.ColumnHeader ColumnHeader4;
		internal System.Windows.Forms.ListView lvShownPointAndFigureBars;
		internal System.Windows.Forms.ColumnHeader ColumnHeader8;
		internal System.Windows.Forms.ColumnHeader ColumnHeader9;
		internal System.Windows.Forms.ColumnHeader ColumnHeader10;
		internal System.Windows.Forms.ColumnHeader ColumnHeader11;
		internal System.Windows.Forms.ColumnHeader ColumnHeader12;
		internal System.Windows.Forms.ColumnHeader ColumnHeader27;
		internal System.Windows.Forms.ColumnHeader ColumnHeader28;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.Label lblRPDataSource;
		internal System.Windows.Forms.Label lblRPReversal;
		internal System.Windows.Forms.Label lblRPBoxSize;
		internal System.Windows.Forms.Label lblRPBoxUnits;
		internal System.Windows.Forms.Label lblRPRecalcPeriod;
		internal System.Windows.Forms.Label label19;
		internal System.Windows.Forms.Label lblRPSubscriptionLevel;
		internal System.Windows.Forms.Label label30;
		[System.Diagnostics.DebuggerStepThrough()]
		private void InitializeComponent()
		{
			this.lblDataConnection = new System.Windows.Forms.Label();
			this.PictureBox1 = new System.Windows.Forms.PictureBox();
			this.llWeb = new System.Windows.Forms.LinkLabel();
			this.cmbPointAndFigureBars = new System.Windows.Forms.ComboBox();
			this.btnRequest = new System.Windows.Forms.Button();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnRemoveAll = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.lblRPRecalcPeriod = new System.Windows.Forms.Label();
			this.label19 = new System.Windows.Forms.Label();
			this.lblRPSubscriptionLevel = new System.Windows.Forms.Label();
			this.label30 = new System.Windows.Forms.Label();
			this.lblRPBoxUnits = new System.Windows.Forms.Label();
			this.Label5 = new System.Windows.Forms.Label();
			this.lblRPBoxSize = new System.Windows.Forms.Label();
			this.Label7 = new System.Windows.Forms.Label();
			this.lblRPDaysBeforeExpiration = new System.Windows.Forms.Label();
			this.Label27 = new System.Windows.Forms.Label();
			this.lblRPEqualizeCloses = new System.Windows.Forms.Label();
			this.Label29 = new System.Windows.Forms.Label();
			this.lblRPContinuation = new System.Windows.Forms.Label();
			this.Label23 = new System.Windows.Forms.Label();
			this.lblRPSessionsFilter = new System.Windows.Forms.Label();
			this.Label25 = new System.Windows.Forms.Label();
			this.lblRPIncludeEnd = new System.Windows.Forms.Label();
			this.Label17 = new System.Windows.Forms.Label();
			this.lblRPUpdatesEnabled = new System.Windows.Forms.Label();
			this.Label21 = new System.Windows.Forms.Label();
			this.lblRPDataSource = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.lblRPReversal = new System.Windows.Forms.Label();
			this.Label13 = new System.Windows.Forms.Label();
			this.lblRPRangeEnd = new System.Windows.Forms.Label();
			this.Label12 = new System.Windows.Forms.Label();
			this.lblRPSessionFlags = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.lblRPRangeStart = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.lblRPSymbol = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.PictureBox2 = new System.Windows.Forms.PictureBox();
			this.PictureBox3 = new System.Windows.Forms.PictureBox();
			this.GroupBox2 = new System.Windows.Forms.GroupBox();
			this.txtTagValue = new System.Windows.Forms.TextBox();
			this.txtTagName = new System.Windows.Forms.TextBox();
			this.Label14 = new System.Windows.Forms.Label();
			this.Label18 = new System.Windows.Forms.Label();
			this.GroupBox3 = new System.Windows.Forms.GroupBox();
			this.lblOEnd = new System.Windows.Forms.Label();
			this.Label16 = new System.Windows.Forms.Label();
			this.lblOStart = new System.Windows.Forms.Label();
			this.Label20 = new System.Windows.Forms.Label();
			this.GroupBox4 = new System.Windows.Forms.GroupBox();
			this.lvPointAndFigureBars = new System.Windows.Forms.ListView();
			this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader7 = new System.Windows.Forms.ColumnHeader();
			this.GroupBox5 = new System.Windows.Forms.GroupBox();
			this.lvShownPointAndFigureBars = new System.Windows.Forms.ListView();
			this.ColumnHeader8 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader9 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader10 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader11 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader12 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader27 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader28 = new System.Windows.Forms.ColumnHeader();
			this.btnShow = new System.Windows.Forms.Button();
			this.gbIndexInterval = new System.Windows.Forms.GroupBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.nudEnd = new System.Windows.Forms.NumericUpDown();
			this.Label2 = new System.Windows.Forms.Label();
			this.nudStart = new System.Windows.Forms.NumericUpDown();
			this.GroupBox6 = new System.Windows.Forms.GroupBox();
			this.lblError = new System.Windows.Forms.Label();
			this.columnHeader13 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader14 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader15 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader16 = new System.Windows.Forms.ColumnHeader();
			this.GroupBox1.SuspendLayout();
			this.GroupBox2.SuspendLayout();
			this.GroupBox3.SuspendLayout();
			this.GroupBox4.SuspendLayout();
			this.GroupBox5.SuspendLayout();
			this.gbIndexInterval.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nudEnd)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStart)).BeginInit();
			this.GroupBox6.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblDataConnection
			// 
			this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
			this.lblDataConnection.Name = "lblDataConnection";
			this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
			this.lblDataConnection.TabIndex = 24;
			this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// PictureBox1
			// 
			this.PictureBox1.BackColor = System.Drawing.Color.Black;
			this.PictureBox1.Location = new System.Drawing.Point(0, 40);
			this.PictureBox1.Name = "PictureBox1";
			this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox1.TabIndex = 23;
			this.PictureBox1.TabStop = false;
			// 
			// llWeb
			// 
			this.llWeb.BackColor = System.Drawing.SystemColors.Control;
			this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
			this.llWeb.Location = new System.Drawing.Point(632, 8);
			this.llWeb.Name = "llWeb";
			this.llWeb.Size = new System.Drawing.Size(408, 16);
			this.llWeb.TabIndex = 25;
			this.llWeb.TabStop = true;
			this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
			this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmbPointAndFigureBars
			// 
			this.cmbPointAndFigureBars.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbPointAndFigureBars.Location = new System.Drawing.Point(16, 56);
			this.cmbPointAndFigureBars.Name = "cmbPointAndFigureBars";
			this.cmbPointAndFigureBars.Size = new System.Drawing.Size(448, 24);
			this.cmbPointAndFigureBars.TabIndex = 0;
			this.cmbPointAndFigureBars.SelectedIndexChanged += new System.EventHandler(this.cmbPointAndFigureBars_SelectedIndexChanged);
			// 
			// btnRequest
			// 
			this.btnRequest.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRequest.Location = new System.Drawing.Point(16, 88);
			this.btnRequest.Name = "btnRequest";
			this.btnRequest.Size = new System.Drawing.Size(96, 40);
			this.btnRequest.TabIndex = 1;
			this.btnRequest.Text = "Request";
			this.btnRequest.Click += new System.EventHandler(this.btnRequest_Click);
			// 
			// btnRemove
			// 
			this.btnRemove.Enabled = false;
			this.btnRemove.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemove.Location = new System.Drawing.Point(120, 88);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.Size = new System.Drawing.Size(96, 40);
			this.btnRemove.TabIndex = 2;
			this.btnRemove.Text = "Remove";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnRemoveAll
			// 
			this.btnRemoveAll.Enabled = false;
			this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemoveAll.Location = new System.Drawing.Point(224, 88);
			this.btnRemoveAll.Name = "btnRemoveAll";
			this.btnRemoveAll.Size = new System.Drawing.Size(96, 40);
			this.btnRemoveAll.TabIndex = 3;
			this.btnRemoveAll.Text = "Remove All";
			this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblStatus.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblStatus.Location = new System.Drawing.Point(8, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(120, 24);
			this.lblStatus.TabIndex = 31;
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.lblRPRecalcPeriod);
			this.GroupBox1.Controls.Add(this.label19);
			this.GroupBox1.Controls.Add(this.lblRPSubscriptionLevel);
			this.GroupBox1.Controls.Add(this.label30);
			this.GroupBox1.Controls.Add(this.lblRPBoxUnits);
			this.GroupBox1.Controls.Add(this.Label5);
			this.GroupBox1.Controls.Add(this.lblRPBoxSize);
			this.GroupBox1.Controls.Add(this.Label7);
			this.GroupBox1.Controls.Add(this.lblRPDaysBeforeExpiration);
			this.GroupBox1.Controls.Add(this.Label27);
			this.GroupBox1.Controls.Add(this.lblRPEqualizeCloses);
			this.GroupBox1.Controls.Add(this.Label29);
			this.GroupBox1.Controls.Add(this.lblRPContinuation);
			this.GroupBox1.Controls.Add(this.Label23);
			this.GroupBox1.Controls.Add(this.lblRPSessionsFilter);
			this.GroupBox1.Controls.Add(this.Label25);
			this.GroupBox1.Controls.Add(this.lblRPIncludeEnd);
			this.GroupBox1.Controls.Add(this.Label17);
			this.GroupBox1.Controls.Add(this.lblRPUpdatesEnabled);
			this.GroupBox1.Controls.Add(this.Label21);
			this.GroupBox1.Controls.Add(this.lblRPDataSource);
			this.GroupBox1.Controls.Add(this.Label9);
			this.GroupBox1.Controls.Add(this.lblRPReversal);
			this.GroupBox1.Controls.Add(this.Label13);
			this.GroupBox1.Controls.Add(this.lblRPRangeEnd);
			this.GroupBox1.Controls.Add(this.Label12);
			this.GroupBox1.Controls.Add(this.lblRPSessionFlags);
			this.GroupBox1.Controls.Add(this.Label10);
			this.GroupBox1.Controls.Add(this.lblRPRangeStart);
			this.GroupBox1.Controls.Add(this.Label8);
			this.GroupBox1.Controls.Add(this.lblRPSymbol);
			this.GroupBox1.Controls.Add(this.Label4);
			this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox1.Location = new System.Drawing.Point(480, 48);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(576, 312);
			this.GroupBox1.TabIndex = 32;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Request Parameters";
			// 
			// lblRPRecalcPeriod
			// 
			this.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRecalcPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRecalcPeriod.Location = new System.Drawing.Point(432, 248);
			this.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod";
			this.lblRPRecalcPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPRecalcPeriod.TabIndex = 72;
			this.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label19
			// 
			this.label19.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label19.Location = new System.Drawing.Point(320, 248);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(104, 24);
			this.label19.TabIndex = 71;
			this.label19.Text = "Recalc Period :";
			this.label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSubscriptionLevel
			// 
			this.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSubscriptionLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSubscriptionLevel.Location = new System.Drawing.Point(144, 248);
			this.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel";
			this.lblRPSubscriptionLevel.Size = new System.Drawing.Size(152, 24);
			this.lblRPSubscriptionLevel.TabIndex = 70;
			this.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label30
			// 
			this.label30.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label30.Location = new System.Drawing.Point(8, 248);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(136, 24);
			this.label30.TabIndex = 69;
			this.label30.Text = "Subscription Level :";
			this.label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPBoxUnits
			// 
			this.lblRPBoxUnits.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPBoxUnits.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPBoxUnits.Location = new System.Drawing.Point(432, 88);
			this.lblRPBoxUnits.Name = "lblRPBoxUnits";
			this.lblRPBoxUnits.Size = new System.Drawing.Size(136, 24);
			this.lblRPBoxUnits.TabIndex = 61;
			this.lblRPBoxUnits.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label5
			// 
			this.Label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label5.Location = new System.Drawing.Point(304, 88);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(120, 24);
			this.Label5.TabIndex = 60;
			this.Label5.Text = "Box Units :";
			this.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPBoxSize
			// 
			this.lblRPBoxSize.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPBoxSize.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPBoxSize.Location = new System.Drawing.Point(144, 88);
			this.lblRPBoxSize.Name = "lblRPBoxSize";
			this.lblRPBoxSize.Size = new System.Drawing.Size(152, 24);
			this.lblRPBoxSize.TabIndex = 59;
			this.lblRPBoxSize.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label7
			// 
			this.Label7.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label7.Location = new System.Drawing.Point(16, 88);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(120, 24);
			this.Label7.TabIndex = 58;
			this.Label7.Text = "Box Size :";
			this.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPDaysBeforeExpiration
			// 
			this.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPDaysBeforeExpiration.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPDaysBeforeExpiration.Location = new System.Drawing.Point(432, 216);
			this.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration";
			this.lblRPDaysBeforeExpiration.Size = new System.Drawing.Size(136, 24);
			this.lblRPDaysBeforeExpiration.TabIndex = 57;
			this.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label27
			// 
			this.Label27.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label27.Location = new System.Drawing.Point(296, 216);
			this.Label27.Name = "Label27";
			this.Label27.Size = new System.Drawing.Size(128, 24);
			this.Label27.TabIndex = 56;
			this.Label27.Text = "Days Before Exp. :";
			this.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPEqualizeCloses
			// 
			this.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPEqualizeCloses.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPEqualizeCloses.Location = new System.Drawing.Point(144, 216);
			this.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses";
			this.lblRPEqualizeCloses.Size = new System.Drawing.Size(152, 24);
			this.lblRPEqualizeCloses.TabIndex = 55;
			this.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label29
			// 
			this.Label29.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label29.Location = new System.Drawing.Point(16, 216);
			this.Label29.Name = "Label29";
			this.Label29.Size = new System.Drawing.Size(120, 24);
			this.Label29.TabIndex = 54;
			this.Label29.Text = "Equalize Closes :";
			this.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPContinuation
			// 
			this.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPContinuation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPContinuation.Location = new System.Drawing.Point(432, 184);
			this.lblRPContinuation.Name = "lblRPContinuation";
			this.lblRPContinuation.Size = new System.Drawing.Size(136, 24);
			this.lblRPContinuation.TabIndex = 53;
			this.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label23
			// 
			this.Label23.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label23.Location = new System.Drawing.Point(328, 184);
			this.Label23.Name = "Label23";
			this.Label23.Size = new System.Drawing.Size(96, 24);
			this.Label23.TabIndex = 52;
			this.Label23.Text = "Continuation :";
			this.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionsFilter
			// 
			this.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionsFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionsFilter.Location = new System.Drawing.Point(144, 280);
			this.lblRPSessionsFilter.Name = "lblRPSessionsFilter";
			this.lblRPSessionsFilter.Size = new System.Drawing.Size(424, 24);
			this.lblRPSessionsFilter.TabIndex = 51;
			this.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label25
			// 
			this.Label25.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label25.Location = new System.Drawing.Point(24, 280);
			this.Label25.Name = "Label25";
			this.Label25.Size = new System.Drawing.Size(112, 24);
			this.Label25.TabIndex = 50;
			this.Label25.Text = "Sessions Filter :";
			this.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIncludeEnd
			// 
			this.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIncludeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIncludeEnd.Location = new System.Drawing.Point(432, 152);
			this.lblRPIncludeEnd.Name = "lblRPIncludeEnd";
			this.lblRPIncludeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPIncludeEnd.TabIndex = 49;
			this.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label17
			// 
			this.Label17.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label17.Location = new System.Drawing.Point(328, 152);
			this.Label17.Name = "Label17";
			this.Label17.Size = new System.Drawing.Size(96, 24);
			this.Label17.TabIndex = 48;
			this.Label17.Text = "Include End :";
			this.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPUpdatesEnabled
			// 
			this.lblRPUpdatesEnabled.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPUpdatesEnabled.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPUpdatesEnabled.Location = new System.Drawing.Point(144, 152);
			this.lblRPUpdatesEnabled.Name = "lblRPUpdatesEnabled";
			this.lblRPUpdatesEnabled.Size = new System.Drawing.Size(152, 24);
			this.lblRPUpdatesEnabled.TabIndex = 47;
			this.lblRPUpdatesEnabled.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label21
			// 
			this.Label21.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label21.Location = new System.Drawing.Point(8, 152);
			this.Label21.Name = "Label21";
			this.Label21.Size = new System.Drawing.Size(124, 24);
			this.Label21.TabIndex = 46;
			this.Label21.Text = "Updates Enabled :";
			this.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPDataSource
			// 
			this.lblRPDataSource.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPDataSource.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPDataSource.Location = new System.Drawing.Point(432, 120);
			this.lblRPDataSource.Name = "lblRPDataSource";
			this.lblRPDataSource.Size = new System.Drawing.Size(136, 24);
			this.lblRPDataSource.TabIndex = 45;
			this.lblRPDataSource.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label9
			// 
			this.Label9.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label9.Location = new System.Drawing.Point(304, 120);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(120, 24);
			this.Label9.TabIndex = 44;
			this.Label9.Text = "Data Source :";
			this.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPReversal
			// 
			this.lblRPReversal.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPReversal.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPReversal.Location = new System.Drawing.Point(144, 120);
			this.lblRPReversal.Name = "lblRPReversal";
			this.lblRPReversal.Size = new System.Drawing.Size(152, 24);
			this.lblRPReversal.TabIndex = 43;
			this.lblRPReversal.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label13
			// 
			this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label13.Location = new System.Drawing.Point(16, 120);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(120, 24);
			this.Label13.TabIndex = 42;
			this.Label13.Text = "Reversal :";
			this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeEnd
			// 
			this.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeEnd.Location = new System.Drawing.Point(432, 56);
			this.lblRPRangeEnd.Name = "lblRPRangeEnd";
			this.lblRPRangeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPRangeEnd.TabIndex = 41;
			this.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label12
			// 
			this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label12.Location = new System.Drawing.Point(336, 56);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(88, 24);
			this.Label12.TabIndex = 40;
			this.Label12.Text = "Range End :";
			this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionFlags
			// 
			this.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionFlags.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionFlags.Location = new System.Drawing.Point(144, 184);
			this.lblRPSessionFlags.Name = "lblRPSessionFlags";
			this.lblRPSessionFlags.Size = new System.Drawing.Size(152, 24);
			this.lblRPSessionFlags.TabIndex = 39;
			this.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label10
			// 
			this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label10.Location = new System.Drawing.Point(24, 184);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(112, 24);
			this.Label10.TabIndex = 38;
			this.Label10.Text = "Session Flags :";
			this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeStart
			// 
			this.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeStart.Location = new System.Drawing.Point(144, 56);
			this.lblRPRangeStart.Name = "lblRPRangeStart";
			this.lblRPRangeStart.Size = new System.Drawing.Size(152, 24);
			this.lblRPRangeStart.TabIndex = 37;
			this.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label8
			// 
			this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label8.Location = new System.Drawing.Point(16, 56);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(120, 24);
			this.Label8.TabIndex = 36;
			this.Label8.Text = "Range Start :";
			this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSymbol
			// 
			this.lblRPSymbol.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSymbol.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSymbol.Location = new System.Drawing.Point(144, 24);
			this.lblRPSymbol.Name = "lblRPSymbol";
			this.lblRPSymbol.Size = new System.Drawing.Size(152, 24);
			this.lblRPSymbol.TabIndex = 33;
			this.lblRPSymbol.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label4
			// 
			this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label4.Location = new System.Drawing.Point(56, 24);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(80, 24);
			this.Label4.TabIndex = 32;
			this.Label4.Text = "Symbol :";
			this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// PictureBox2
			// 
			this.PictureBox2.BackColor = System.Drawing.Color.Black;
			this.PictureBox2.Location = new System.Drawing.Point(-88, 368);
			this.PictureBox2.Name = "PictureBox2";
			this.PictureBox2.Size = new System.Drawing.Size(1272, 1);
			this.PictureBox2.TabIndex = 33;
			this.PictureBox2.TabStop = false;
			// 
			// PictureBox3
			// 
			this.PictureBox3.BackColor = System.Drawing.Color.Black;
			this.PictureBox3.Location = new System.Drawing.Point(-88, 448);
			this.PictureBox3.Name = "PictureBox3";
			this.PictureBox3.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox3.TabIndex = 34;
			this.PictureBox3.TabStop = false;
			// 
			// GroupBox2
			// 
			this.GroupBox2.Controls.Add(this.txtTagValue);
			this.GroupBox2.Controls.Add(this.txtTagName);
			this.GroupBox2.Controls.Add(this.Label14);
			this.GroupBox2.Controls.Add(this.Label18);
			this.GroupBox2.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox2.Location = new System.Drawing.Point(8, 376);
			this.GroupBox2.Name = "GroupBox2";
			this.GroupBox2.Size = new System.Drawing.Size(472, 59);
			this.GroupBox2.TabIndex = 4;
			this.GroupBox2.TabStop = false;
			this.GroupBox2.Text = "Tags";
			// 
			// txtTagValue
			// 
			this.txtTagValue.Location = new System.Drawing.Point(312, 24);
			this.txtTagValue.Name = "txtTagValue";
			this.txtTagValue.Size = new System.Drawing.Size(144, 25);
			this.txtTagValue.TabIndex = 1;
			this.txtTagValue.Text = "";
			this.txtTagValue.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagValue_KeyDown);
			// 
			// txtTagName
			// 
			this.txtTagName.Location = new System.Drawing.Point(72, 24);
			this.txtTagName.Name = "txtTagName";
			this.txtTagName.Size = new System.Drawing.Size(144, 25);
			this.txtTagName.TabIndex = 0;
			this.txtTagName.Text = "";
			this.txtTagName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagName_KeyDown);
			// 
			// Label14
			// 
			this.Label14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label14.Location = new System.Drawing.Point(248, 24);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(56, 24);
			this.Label14.TabIndex = 40;
			this.Label14.Text = "Value :";
			this.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label18
			// 
			this.Label18.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label18.Location = new System.Drawing.Point(8, 24);
			this.Label18.Name = "Label18";
			this.Label18.Size = new System.Drawing.Size(56, 24);
			this.Label18.TabIndex = 36;
			this.Label18.Text = "Name :";
			this.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox3
			// 
			this.GroupBox3.Controls.Add(this.lblOEnd);
			this.GroupBox3.Controls.Add(this.Label16);
			this.GroupBox3.Controls.Add(this.lblOStart);
			this.GroupBox3.Controls.Add(this.Label20);
			this.GroupBox3.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox3.Location = new System.Drawing.Point(488, 376);
			this.GroupBox3.Name = "GroupBox3";
			this.GroupBox3.Size = new System.Drawing.Size(568, 59);
			this.GroupBox3.TabIndex = 42;
			this.GroupBox3.TabStop = false;
			this.GroupBox3.Text = "Output Parameters";
			// 
			// lblOEnd
			// 
			this.lblOEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblOEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblOEnd.Location = new System.Drawing.Point(400, 24);
			this.lblOEnd.Name = "lblOEnd";
			this.lblOEnd.Size = new System.Drawing.Size(136, 24);
			this.lblOEnd.TabIndex = 41;
			this.lblOEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label16
			// 
			this.Label16.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label16.Location = new System.Drawing.Point(320, 24);
			this.Label16.Name = "Label16";
			this.Label16.Size = new System.Drawing.Size(72, 24);
			this.Label16.TabIndex = 40;
			this.Label16.Text = "End :";
			this.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblOStart
			// 
			this.lblOStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblOStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblOStart.Location = new System.Drawing.Point(136, 24);
			this.lblOStart.Name = "lblOStart";
			this.lblOStart.Size = new System.Drawing.Size(128, 24);
			this.lblOStart.TabIndex = 37;
			this.lblOStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label20
			// 
			this.Label20.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label20.Location = new System.Drawing.Point(56, 24);
			this.Label20.Name = "Label20";
			this.Label20.Size = new System.Drawing.Size(72, 24);
			this.Label20.TabIndex = 36;
			this.Label20.Text = "Start :";
			this.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox4
			// 
			this.GroupBox4.Controls.Add(this.lvPointAndFigureBars);
			this.GroupBox4.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox4.Location = new System.Drawing.Point(8, 456);
			this.GroupBox4.Name = "GroupBox4";
			this.GroupBox4.Size = new System.Drawing.Size(472, 216);
			this.GroupBox4.TabIndex = 5;
			this.GroupBox4.TabStop = false;
			this.GroupBox4.Text = "Last 5 Resolved Point And Figure Bars";
			// 
			// lvPointAndFigureBars
			// 
			this.lvPointAndFigureBars.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                               this.ColumnHeader1,
                                                                                               this.ColumnHeader2,
                                                                                               this.ColumnHeader3,
                                                                                               this.ColumnHeader4,
                                                                                               this.ColumnHeader5,
                                                                                               this.ColumnHeader6,
                                                                                               this.ColumnHeader7,
                                                                                               this.columnHeader13,
                                                                                               this.columnHeader14});
			this.lvPointAndFigureBars.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvPointAndFigureBars.FullRowSelect = true;
			this.lvPointAndFigureBars.GridLines = true;
			this.lvPointAndFigureBars.Location = new System.Drawing.Point(8, 20);
			this.lvPointAndFigureBars.MultiSelect = false;
			this.lvPointAndFigureBars.Name = "lvPointAndFigureBars";
			this.lvPointAndFigureBars.Size = new System.Drawing.Size(456, 188);
			this.lvPointAndFigureBars.TabIndex = 7;
			this.lvPointAndFigureBars.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader1
			// 
			this.ColumnHeader1.Text = "";
			this.ColumnHeader1.Width = 0;
			// 
			// ColumnHeader2
			// 
			this.ColumnHeader2.Text = "Index";
			this.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader2.Width = 49;
			// 
			// ColumnHeader3
			// 
			this.ColumnHeader3.Text = "Timestamp";
			this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader3.Width = 162;
			// 
			// ColumnHeader4
			// 
			this.ColumnHeader4.Text = "Mid";
			this.ColumnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader4.Width = 71;
			// 
			// ColumnHeader5
			// 
			this.ColumnHeader5.Text = "High";
			this.ColumnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader5.Width = 70;
			// 
			// ColumnHeader6
			// 
			this.ColumnHeader6.Text = "Low";
			this.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader6.Width = 75;
			// 
			// ColumnHeader7
			// 
			this.ColumnHeader7.Text = "Up";
			this.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader7.Width = 75;
			// 
			// GroupBox5
			// 
			this.GroupBox5.Controls.Add(this.lvShownPointAndFigureBars);
			this.GroupBox5.Controls.Add(this.btnShow);
			this.GroupBox5.Controls.Add(this.gbIndexInterval);
			this.GroupBox5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox5.Location = new System.Drawing.Point(488, 456);
			this.GroupBox5.Name = "GroupBox5";
			this.GroupBox5.Size = new System.Drawing.Size(568, 216);
			this.GroupBox5.TabIndex = 6;
			this.GroupBox5.TabStop = false;
			this.GroupBox5.Text = "Point And Figure Bars Filtered by Index or Time Interval";
			// 
			// lvShownPointAndFigureBars
			// 
			this.lvShownPointAndFigureBars.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                                    this.ColumnHeader8,
                                                                                                    this.ColumnHeader9,
                                                                                                    this.ColumnHeader10,
                                                                                                    this.ColumnHeader11,
                                                                                                    this.ColumnHeader12,
                                                                                                    this.ColumnHeader27,
                                                                                                    this.ColumnHeader28,
                                                                                                    this.columnHeader15,
                                                                                                    this.columnHeader16});
			this.lvShownPointAndFigureBars.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvShownPointAndFigureBars.FullRowSelect = true;
			this.lvShownPointAndFigureBars.GridLines = true;
			this.lvShownPointAndFigureBars.Location = new System.Drawing.Point(8, 80);
			this.lvShownPointAndFigureBars.MultiSelect = false;
			this.lvShownPointAndFigureBars.Name = "lvShownPointAndFigureBars";
			this.lvShownPointAndFigureBars.Size = new System.Drawing.Size(552, 128);
			this.lvShownPointAndFigureBars.TabIndex = 8;
			this.lvShownPointAndFigureBars.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader8
			// 
			this.ColumnHeader8.Text = "";
			this.ColumnHeader8.Width = 0;
			// 
			// ColumnHeader9
			// 
			this.ColumnHeader9.Text = "Index";
			this.ColumnHeader9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader9.Width = 49;
			// 
			// ColumnHeader10
			// 
			this.ColumnHeader10.Text = "Timestamp";
			this.ColumnHeader10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader10.Width = 162;
			// 
			// ColumnHeader11
			// 
			this.ColumnHeader11.Text = "Mid";
			this.ColumnHeader11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader11.Width = 93;
			// 
			// ColumnHeader12
			// 
			this.ColumnHeader12.Text = "High";
			this.ColumnHeader12.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader12.Width = 92;
			// 
			// ColumnHeader27
			// 
			this.ColumnHeader27.Text = "Low";
			this.ColumnHeader27.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader27.Width = 96;
			// 
			// ColumnHeader28
			// 
			this.ColumnHeader28.Text = "Up";
			this.ColumnHeader28.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader28.Width = 90;
			// 
			// btnShow
			// 
			this.btnShow.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnShow.Location = new System.Drawing.Point(464, 48);
			this.btnShow.Name = "btnShow";
			this.btnShow.Size = new System.Drawing.Size(96, 24);
			this.btnShow.TabIndex = 4;
			this.btnShow.Text = "Show";
			this.btnShow.Click += new System.EventHandler(this.btnShow_Click);
			// 
			// gbIndexInterval
			// 
			this.gbIndexInterval.Controls.Add(this.Label3);
			this.gbIndexInterval.Controls.Add(this.nudEnd);
			this.gbIndexInterval.Controls.Add(this.Label2);
			this.gbIndexInterval.Controls.Add(this.nudStart);
			this.gbIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbIndexInterval.Location = new System.Drawing.Point(8, 18);
			this.gbIndexInterval.Name = "gbIndexInterval";
			this.gbIndexInterval.Size = new System.Drawing.Size(440, 56);
			this.gbIndexInterval.TabIndex = 3;
			this.gbIndexInterval.TabStop = false;
			this.gbIndexInterval.Text = "Index Interval";
			// 
			// Label3
			// 
			this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label3.Location = new System.Drawing.Point(232, 24);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(32, 24);
			this.Label3.TabIndex = 74;
			this.Label3.Text = "End: ";
			this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudEnd
			// 
			this.nudEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudEnd.Location = new System.Drawing.Point(272, 24);
			this.nudEnd.Maximum = new System.Decimal(new int[] {
                                                               10000000,
                                                               0,
                                                               0,
                                                               0});
			this.nudEnd.Minimum = new System.Decimal(new int[] {
                                                               1,
                                                               0,
                                                               0,
                                                               0});
			this.nudEnd.Name = "nudEnd";
			this.nudEnd.Size = new System.Drawing.Size(136, 22);
			this.nudEnd.TabIndex = 1;
			this.nudEnd.Value = new System.Decimal(new int[] {
                                                             1,
                                                             0,
                                                             0,
                                                             0});
			// 
			// Label2
			// 
			this.Label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label2.Location = new System.Drawing.Point(8, 24);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(40, 24);
			this.Label2.TabIndex = 70;
			this.Label2.Text = "Start: ";
			this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudStart
			// 
			this.nudStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudStart.Location = new System.Drawing.Point(56, 24);
			this.nudStart.Maximum = new System.Decimal(new int[] {
                                                                 10000000,
                                                                 0,
                                                                 0,
                                                                 0});
			this.nudStart.Minimum = new System.Decimal(new int[] {
                                                                 1,
                                                                 0,
                                                                 0,
                                                                 0});
			this.nudStart.Name = "nudStart";
			this.nudStart.Size = new System.Drawing.Size(136, 22);
			this.nudStart.TabIndex = 0;
			this.nudStart.Value = new System.Decimal(new int[] {
                                                               1,
                                                               0,
                                                               0,
                                                               0});
			// 
			// GroupBox6
			// 
			this.GroupBox6.Controls.Add(this.lblStatus);
			this.GroupBox6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.GroupBox6.Location = new System.Drawing.Point(328, 80);
			this.GroupBox6.Name = "GroupBox6";
			this.GroupBox6.Size = new System.Drawing.Size(136, 48);
			this.GroupBox6.TabIndex = 45;
			this.GroupBox6.TabStop = false;
			this.GroupBox6.Text = "Status";
			// 
			// lblError
			// 
			this.lblError.ForeColor = System.Drawing.Color.Red;
			this.lblError.Location = new System.Drawing.Point(16, 136);
			this.lblError.Name = "lblError";
			this.lblError.Size = new System.Drawing.Size(448, 192);
			this.lblError.TabIndex = 46;
			// 
			// columnHeader13
			// 
			this.columnHeader13.Text = "PFHigh";
			this.columnHeader13.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader13.Width = 75;
			// 
			// columnHeader14
			// 
			this.columnHeader14.Text = "PFLow";
			this.columnHeader14.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader14.Width = 75;
			// 
			// columnHeader15
			// 
			this.columnHeader15.Text = "PFHigh";
			this.columnHeader15.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader15.Width = 75;
			// 
			// columnHeader16
			// 
			this.columnHeader16.Text = "PHLow";
			this.columnHeader16.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader16.Width = 75;
			// 
			// frmPointAndFigureBars
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(1062, 675);
			this.Controls.Add(this.lblError);
			this.Controls.Add(this.GroupBox6);
			this.Controls.Add(this.GroupBox5);
			this.Controls.Add(this.GroupBox4);
			this.Controls.Add(this.GroupBox2);
			this.Controls.Add(this.PictureBox3);
			this.Controls.Add(this.PictureBox2);
			this.Controls.Add(this.GroupBox1);
			this.Controls.Add(this.btnRemoveAll);
			this.Controls.Add(this.btnRemove);
			this.Controls.Add(this.btnRequest);
			this.Controls.Add(this.cmbPointAndFigureBars);
			this.Controls.Add(this.lblDataConnection);
			this.Controls.Add(this.PictureBox1);
			this.Controls.Add(this.llWeb);
			this.Controls.Add(this.GroupBox3);
			this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmPointAndFigureBars";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "PointAndFigureBars";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmPointAndFigureBars_Closing);
			this.Load += new System.EventHandler(this.frmPointAndFigureBars_Load);
			this.GroupBox1.ResumeLayout(false);
			this.GroupBox2.ResumeLayout(false);
			this.GroupBox3.ResumeLayout(false);
			this.GroupBox4.ResumeLayout(false);
			this.GroupBox5.ResumeLayout(false);
			this.gbIndexInterval.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nudEnd)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStart)).EndInit();
			this.GroupBox6.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// Creates a CEL object, changes its configurations, and starts up the created CEL object.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void frmPointAndFigureBars_Load(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Creates the CQGCEL object
				CEL = new CQGCEL();
				CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
				CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
				CEL.PointAndFigureBarsResolved += new CQG._ICQGCELEvents_PointAndFigureBarsResolvedEventHandler(CEL_PointAndFigureBarsResolved);
				CEL.PointAndFigureBarsAdded += new CQG._ICQGCELEvents_PointAndFigureBarsAddedEventHandler(CEL_PointAndFigureBarsAdded);
				CEL.PointAndFigureBarsUpdated += new CQG._ICQGCELEvents_PointAndFigureBarsUpdatedEventHandler(CEL_PointAndFigureBarsUpdated);
				CEL.PointAndFigureBarsInserted += new CQG._ICQGCELEvents_PointAndFigureBarsInsertedEventHandler(CEL_PointAndFigureBarsInserted);
				CEL.PointAndFigureBarsRemoved += new CQG._ICQGCELEvents_PointAndFigureBarsRemovedEventHandler(CEL_PointAndFigureBarsRemoved);
				CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
				CEL.APIConfiguration.CollectionsThrowException = false;
				CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;

				// Disables the controls
				CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
				// Starts up the CQGCEL
				CEL.Startup();

				cmbPointAndFigureBars.Items.Clear();
				cmbPointAndFigureBars.SelectedIndex = -1;

				ClearAllData();

				m_CurPointAndFigureBars = null;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "frmPointAndFigureBars_Load", ex);
				this.Close();
			}
		}

		/// <summary>
		/// Shuts down CEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A CancelEventArgs that contains the event data.
		/// </param>
		private void frmPointAndFigureBars_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (CEL != null)
			{
				CEL.Shutdown();
			}
		}

		/// <summary>
		/// Opens frmPFBReqSettings and with passed values requests PointAndFigureBars.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRequest_Click(System.Object sender, System.EventArgs e)
		{
			frmPFBReqSettings frmPointAndFigureBarsReq;
			CQGPointAndFigureBars PointAndFigureBars;
			CQGPointAndFigureBarsRequest req;

			try
			{
				// Opens the form to fill up request data
				frmPointAndFigureBarsReq = new frmPFBReqSettings();
				req = CEL.CreatePointAndFigureBarsRequest();

				req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

				frmPointAndFigureBarsReq.PointAndFigureBarsRequest = req;
				frmPointAndFigureBarsReq.LineTime = CEL.Environment.LineTime;

				// If the user confirms, request is sent to CQGCEL and added to the requests list
				if (frmPointAndFigureBarsReq.ShowDialog(this) == DialogResult.OK)
				{
					PointAndFigureBars = CEL.RequestPointAndFigureBars(req);

					cmbPointAndFigureBars.Items.Add(PointAndFigureBars.Id);
					cmbPointAndFigureBars.SelectedIndex = cmbPointAndFigureBars.Items.Count - 1;

					ChangeControlsStatuses();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "btnRequest_Click", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected PointAndFigureBars info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbPointAndFigureBars_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				if (cmbPointAndFigureBars.SelectedIndex > -1)
				{
					// Gets the selected PointAndFigureBar object from CQGCEL by it's ID
					m_CurPointAndFigureBars = CEL.AllPointAndFigureBars.get_ItemById(cmbPointAndFigureBars.Text);

					ClearAllData();
					DumpAllData();
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "cmbPointAndFigureBars_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Shows few data from the selected PointAndFigureBars collection.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnShow_Click(System.Object sender, System.EventArgs e)
		{
			int iStart;
			int iEnd;

			try
			{
				lvShownPointAndFigureBars.Items.Clear();

				iStart = System.Convert.ToInt32(nudStart.Value) - 1;
				iEnd = System.Convert.ToInt32(nudEnd.Value) - 1;
				if (iStart > iEnd || iEnd > m_CurPointAndFigureBars.Count - 1 || iEnd - iStart >= MAX_INDEX_INTERVAL)
				{
					MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " records," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					return;
				}

				lvShownPointAndFigureBars.SuspendLayout();
				for (int i = iEnd; i >= iStart; i--)
				{
					DumpRecord(lvShownPointAndFigureBars, m_CurPointAndFigureBars[i], i + 1);
				}
				lvShownPointAndFigureBars.ResumeLayout(false);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "btnShow_Click", ex);
			}
		}

		/// <summary>
		/// Removes the selected PointAndFigureBar from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemove_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Removes PointAndFigureBars from the collection
				CEL.RemovePointAndFigureBars(m_CurPointAndFigureBars);

				// Removes PointAndFigureBars from the combo box
				cmbPointAndFigureBars.Items.RemoveAt(cmbPointAndFigureBars.SelectedIndex);

				cmbPointAndFigureBars.SelectedIndex = cmbPointAndFigureBars.Items.Count - 1;

				if (cmbPointAndFigureBars.Items.Count == 0)
				{
					cmbPointAndFigureBars.SelectedIndex = -1;
					ClearAllData();
					m_CurPointAndFigureBars = null;
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "btnRemove_Click", ex);
			}
		}

		/// <summary>
		/// Removes all PointAndFigureBars from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clears the combo box
				cmbPointAndFigureBars.Items.Clear();
				cmbPointAndFigureBars.SelectedIndex = -1;

				// Removes all PointAndFigureBars from the collection
				CEL.RemoveAllPointAndFigureBars();

				m_CurPointAndFigureBars = null;

				ClearAllData();

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "btnRemoveAll_Click", ex);
			}
		}

		/// <summary>
		/// Shows tag value of the current PointAndFigureBars corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagName_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					object tagValue = m_CurPointAndFigureBars.get_Tag(txtTagName.Text);
					if (tagValue != null)
					{
						txtTagValue.Text = tagValue.ToString();
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "txtTagName_KeyDown", ex);
			}
		}

		/// <summary>
		/// Sets the tag value of the current PointAndFigureBars corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagValue_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					if (txtTagValue.Text.Trim().Length == 0)
					{
						m_CurPointAndFigureBars.set_Tag(txtTagName.Text, null);
					}
					else
					{
						m_CurPointAndFigureBars.set_Tag(txtTagName.Text, txtTagValue.Text);
					}
					txtTagName.Text = "";
					txtTagValue.Text = "";
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "txtTagValue_KeyDown", ex);
			}
		}

		/// <summary>
		/// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
		/// </summary>
		/// <param name="cqg_error">
		/// The object, in which the error has occurred.
		/// </param>
		/// <param name="error_description">
		/// The string, describing the error.
		/// </param>
		private void CEL_DataError(object cqg_error, string error_description)
		{
			try
			{
				CQGError cqgErr = cqg_error as CQGError;
				if (CEL.IsValid(cqgErr))
				{
					if (cqgErr.Code == 102)
					{
						error_description += " Restart the application.";
					}
					else if (cqgErr.Code == 125)
					{
						error_description += " Turn on CQG Client and restart the application.";
					}
				}

				MessageBox.Show(error_description, "PointAndFigureBars", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_DataError", ex);
			}
		}

		/// <summary>
		/// This event is fired, when some changes occur in the connection with CQG data server.
		/// </summary>
		/// <param name="newStatus">
		/// The current status of the connection with the data server.
		/// </param>
		private void CEL_DataConnectionStatusChanged(CQG.eConnectionStatus new_status)
		{
			string sInfo;
			System.Drawing.Color BackCol;

			try
			{
				if (new_status == eConnectionStatus.csConnectionUp)
				{
					BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
					sInfo = "DATA Connection is UP";
				}
				else if (new_status == eConnectionStatus.csConnectionDelayed)
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Delayed";
				}
				else
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Down";
				}

				lblDataConnection.BackColor = BackCol;
				lblDataConnection.Text = sInfo;

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_DataConnectionStatusChanged", ex);
			}
		}

		/// <summary>
		/// Fired when the collection of point and figure bars (CQGPointAndFigureBars) is
		/// resolved or when some error has occurred during the point and figure bars request processing.
		/// </summary>
		/// <param name="cqg_point_and_figure_bars">
		/// Reference to resolved CQGPointAndFigureBars
		/// </param>
		/// <param name="cqg_error">
		/// The CQGError object that describes the last error occurred
		/// while processing the PointAndFigureBars request or
		/// Nothing/Invalid_Error in case of no error.
		/// </param>
		private void CEL_PointAndFigureBarsResolved(CQG.CQGPointAndFigureBars cqg_point_and_figure_bars, CQG.CQGError cqg_error)
		{
			try
			{
				if (cqg_point_and_figure_bars.Id == m_CurPointAndFigureBars.Id)
				{
					ClearAllData();
					DumpAllData();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_PointAndFigureBarsResolved", ex);
			}
		}

		/// <summary>
		/// Fired when the CQGPointAndFigureBar item is added to the end of CQGPointAndFigureBars.
		/// </summary>
		/// <param name="cqg_point_and_figure_bars">
		/// Reference to changed CQGPointAndFigureBars.
		/// </param>
		private void CEL_PointAndFigureBarsAdded(CQG.CQGPointAndFigureBars cqg_point_and_figure_bars)
		{
			try
			{
				if (cqg_point_and_figure_bars.Id == m_CurPointAndFigureBars.Id)
				{
					ShowChangedData(cqg_point_and_figure_bars.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_PointAndFigureBarsAdded", ex);
			}
		}

		/// <summary>
		/// Fired when the CQGPointAndFigureBar item is inserted into CQGPointAndFigureBars.
		/// </summary>
		/// <param name="cqg_point_and_figure_bars">
		/// Reference to changed CQGPointAndFigureBars.
		/// </param>
		/// <param name="index_">
		/// Specifies the changed CQGPointAndFigureBar index.
		/// </param>
		private void CEL_PointAndFigureBarsInserted(CQG.CQGPointAndFigureBars cqg_point_and_figure_bars, int index_)
		{
			try
			{
				if (cqg_point_and_figure_bars.Id == m_CurPointAndFigureBars.Id)
				{
					ShowChangedData(cqg_point_and_figure_bars.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_PointAndFigureBarsInserted", ex);
			}
		}

		/// <summary>
		/// Fired when the CQGPointAndFigureBar item is removed from CQGPointAndFigureBars.
		/// </summary>
		/// <param name="cqg_point_and_figure_bars">
		/// Reference to changed CQGPointAndFigureBars.
		/// </param>
		/// <param name="index_">
		/// Specifies the changed CQGPointAndFigureBar index.
		/// </param>
		private void CEL_PointAndFigureBarsRemoved(CQG.CQGPointAndFigureBars cqg_point_and_figure_bars, int index_)
		{
			try
			{
				if (cqg_point_and_figure_bars.Id == m_CurPointAndFigureBars.Id)
				{
					ShowChangedData(cqg_point_and_figure_bars.Count);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_PointAndFigureBarsRemoved", ex);
			}
		}

		/// <summary>
		/// Fired when the CQGPointAndFigureBar item is updated.
		/// </summary>
		/// <param name="cqg_point_and_figure_bars">
		/// Reference to changed CQGPointAndFigureBars
		/// </param>
		/// <param name="index_">
		/// Specifies the updated CQGPointAndFigureBar index.
		/// </param>
		private void CEL_PointAndFigureBarsUpdated(CQG.CQGPointAndFigureBars cqg_point_and_figure_bars, int index_)
		{
			try
			{
				if (cqg_point_and_figure_bars.Id == m_CurPointAndFigureBars.Id)
				{
					if (index_ > m_CurPointAndFigureBars.Count - MAX_NUMBER_OF_RECORDS)
					{
						UpdateRecord(lvPointAndFigureBars, m_CurPointAndFigureBars[index_], index_ + 1);
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "CEL_PointAndFigureBarsUpdated", ex);
			}
		}

		/// <summary>
		/// Shows the selected request parameters on the listview.
		/// </summary>
		private void DumpRequestParams()
		{
			try
			{
				CQGPointAndFigureBarsRequest req = m_CurPointAndFigureBars.Request;

				lblRPSymbol.Text = req.Symbol;
				lblRPRangeStart.Text = GetValueAsString(req.RangeStart);
				lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd);
				lblRPBoxSize.Text = req.BoxSize.ToString();
				lblRPBoxUnits.Text = req.BoxUnits.ToString();
				lblRPReversal.Text = req.Reversal.ToString();
				lblRPDataSource.Text = req.DataSource.ToString();
				lblRPUpdatesEnabled.Text = req.UpdatesEnabled.ToString();
				lblRPIncludeEnd.Text = req.IncludeEnd.ToString();

				var sessionFilter = req.SessionsFilter.ToString();
				switch (sessionFilter)
				{
					case "0": sessionFilter = "Primary session only (0)"; break;
					case "31": sessionFilter = "All sessions (31)"; break;
				}
				lblRPSessionsFilter.Text = sessionFilter;
				lblRPContinuation.Text = req.Continuation.ToString();
				lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString();
				lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString();
				lblRPSessionFlags.Text = req.SessionFlags.ToString();
				lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString();
				if (req.SubscriptionLevel == eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod)
				{
					lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString();
				}

				if (m_CurPointAndFigureBars.LastError != null)
				{
					lblError.Text = m_CurPointAndFigureBars.LastError.Description;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "DumpRequestParams", ex);
			}
		}

		/// <summary>
		/// Shows the selected request outputs on the listview.
		/// </summary>
		private void DumpOutputParams()
		{
			try
			{
				lblOStart.Text = GetValueAsString(m_CurPointAndFigureBars.StartTimestamp);
				lblOEnd.Text = GetValueAsString(m_CurPointAndFigureBars.EndTimestamp);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "DumpOutputParams", ex);
			}
		}

		/// <summary>
		/// Shows the selected request outputs on the listview after changes
		/// </summary>
		/// <param name="count">
		/// Count of PointAndFigureBars that will be shown.
		/// </param>
		private void ShowChangedData(int count)
		{
			ClearOutputParams();
			DumpOutputParams();

			DumpRecords(count);
		}

		/// <summary>
		/// Shows added PointAndFigureBars for the selected request records on the listview.
		/// </summary>
		/// <param name="addedPointAndFigureBarsCount">
		/// Count of PointAndFigureBars that will be shown.
		/// </param>
		private void DumpRecords(int addedPointAndFigureBarsCount)
		{
			try
			{
				// Clears all records
				ClearRecords();

				if (m_CurPointAndFigureBars.Count == 0)
				{
					return;
				}

				if (addedPointAndFigureBarsCount == m_CurPointAndFigureBars.Count)
				{
					addedPointAndFigureBarsCount = System.Convert.ToInt32(addedPointAndFigureBarsCount >= MAX_NUMBER_OF_RECORDS ? MAX_NUMBER_OF_RECORDS : m_CurPointAndFigureBars.Count);
				}
				for (int i = m_CurPointAndFigureBars.Count - 1; i >= m_CurPointAndFigureBars.Count - addedPointAndFigureBarsCount; i--)
				{
					DumpRecord(lvPointAndFigureBars, m_CurPointAndFigureBars[i], i + 1);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "DumpRecords", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="pointAndFigureBar">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void DumpRecord(ListView lv, CQGPointAndFigureBar pointAndFigureBar, int recordIndex)
		{
			try
			{
				ListViewItem item = lv.Items.Add(new ListViewItem());
				WriteData(item, pointAndFigureBar, recordIndex);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "DumpRecord", ex);
			}
		}

		/// <summary>
		/// Updates one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="pointAndFigureBar">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be updated.
		/// </param>
		private void UpdateRecord(ListView lv, CQGPointAndFigureBar pointAndFigureBar, int recordIndex)
		{
			try
			{
				ListViewItem item = new ListViewItem();
				WriteData(item, pointAndFigureBar, recordIndex);
				lv.Items[m_CurPointAndFigureBars.Count - recordIndex] = item;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "UpdateRecord", ex);
			}
		}

		/// <summary>
		/// Writes one record's values to the listviewitem.
		/// </summary>
		/// <param name="item">
		/// Listview item, in which data must be shown.
		/// </param>
		/// <param name="pointAndFigureBar">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be updated.
		/// </param>
		private void WriteData(ListViewItem item, CQGPointAndFigureBar pointAndFigureBar, int recordIndex)
		{
			item.SubItems.Add("Index").Text = recordIndex.ToString();
			item.SubItems.Add("Timestamp").Text = GetValueAsString(pointAndFigureBar.Timestamp, true);
			item.SubItems.Add("Mid").Text = GetValueAsString(pointAndFigureBar.Mid);
			item.SubItems.Add("High").Text = GetValueAsString(pointAndFigureBar.High);
			item.SubItems.Add("Low").Text = GetValueAsString(pointAndFigureBar.Low);
			item.SubItems.Add("Up").Text = GetValueAsString(pointAndFigureBar.Up);
			item.SubItems.Add("PFHigh").Text = GetValueAsString(pointAndFigureBar.PFHigh);
			item.SubItems.Add("PFLow").Text = GetValueAsString(pointAndFigureBar.PFLow);
		}

		/// <summary>
		/// Dumps all request data (outputs\parameters\records)
		/// </summary>
		private void DumpAllData()
		{
			try
			{
				DumpRequestParams();

				lblStatus.Text = m_CurPointAndFigureBars.Status.ToString();

				if (m_CurPointAndFigureBars.Status == eRequestStatus.rsSuccess)
				{
					DumpOutputParams();
					DumpRecords(m_CurPointAndFigureBars.Count);
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "DumpAllData", ex);
			}
		}

		/// <summary>
		/// Clears all request data.
		/// </summary>
		private void ClearAllData()
		{
			try
			{
				lblStatus.Text = "";

				ClearRequestParams();
				ClearOutputParams();
				ClearTags();
				ClearRecords();

				lvShownPointAndFigureBars.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "ClearAllData", ex);
			}
		}

		/// <summary>
		/// Clears the request parameters from the listview.
		/// </summary>
		private void ClearRequestParams()
		{
			try
			{
				lblRPSymbol.Text = "";
				lblRPRangeStart.Text = "";
				lblRPRangeEnd.Text = "";
				lblRPBoxSize.Text = "";
				lblRPBoxUnits.Text = "";
				lblRPReversal.Text = "";
				lblRPDataSource.Text = "";
				lblRPUpdatesEnabled.Text = "";
				lblRPIncludeEnd.Text = "";
				lblRPSessionsFilter.Text = "";
				lblRPContinuation.Text = "";
				lblRPEqualizeCloses.Text = "";
				lblRPDaysBeforeExpiration.Text = "";
				lblRPSessionFlags.Text = "";
				lblRPSubscriptionLevel.Text = "";
				lblRPRecalcPeriod.Text = "";

				lblError.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "ClearRequestParams", ex);
			}
		}

		/// <summary>
		/// Clears request outputs from the listview.
		/// </summary>
		private void ClearOutputParams()
		{
			try
			{
				lblOStart.Text = "";
				lblOEnd.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "ClearOutputParams", ex);
			}
		}

		/// <summary>
		/// Clears request tags.
		/// </summary>
		private void ClearTags()
		{
			try
			{
				txtTagName.Text = "";
				txtTagValue.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "ClearTags", ex);
			}
		}

		/// <summary>
		/// Clears records from the listview.
		/// </summary>
		private void ClearRecords()
		{
			try
			{
				lvPointAndFigureBars.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "ClearRecords", ex);
			}
		}

		/// <summary>
		/// Enables\disables the controls, based on the connection status.
		/// </summary>
		private void ChangeControlsStatuses()
		{
			bool bIsDataConnectionUp = false;
			bool bIsPointAndFigureBarsSelected;
			bool bIsPointAndFigureBarsSucceded = false;

			try
			{
				if (CEL.IsStarted)
				{
					bIsDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
				}

				btnRequest.Enabled = bIsDataConnectionUp;

				bIsPointAndFigureBarsSelected = m_CurPointAndFigureBars != null;

				btnRemove.Enabled = bIsPointAndFigureBarsSelected && bIsDataConnectionUp;
				btnRemoveAll.Enabled = bIsPointAndFigureBarsSelected && bIsDataConnectionUp;

				txtTagName.Enabled = bIsPointAndFigureBarsSelected;
				txtTagValue.Enabled = bIsPointAndFigureBarsSelected;

				if (bIsPointAndFigureBarsSelected)
				{
					bIsPointAndFigureBarsSucceded = m_CurPointAndFigureBars.Status == eRequestStatus.rsSuccess;
				}

				nudEnd.Enabled = bIsPointAndFigureBarsSucceded;
				nudStart.Enabled = bIsPointAndFigureBarsSucceded;

				btnShow.Enabled = bIsPointAndFigureBarsSucceded;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmPointAndFigureBars", "ChangeControlsStatuses", ex);
			}
		}

		/// <summary>
		/// Validates the specified value and converts it to string.
		/// </summary>
		/// <param name="val">
		/// The value that will be validated and converted
		/// </param>
		/// <param name="includeMilliseconds">
		/// Whether to include seconds and milliseconds to string, valid only for DateTime
		/// </param>
		/// <returns>
		/// Value converted to string or "N/A" if the value is invalid.
		/// </returns>
		private string GetValueAsString(object val, bool includeMilliseconds = false)
		{
			string sResult = "";

			try
			{
				if (CEL.IsValid(val))
				{
					if (val.GetType().FullName == "System.DateTime")
					{
						string format = includeMilliseconds ? "dd/MM/yyyy HH:mm:ss.fff" : "dd/MM/yyyy HH:mm";
						sResult = System.Convert.ToDateTime(val).ToString(format);
					}
					else
					{
						sResult = val.ToString();
					}
				}
				else
				{
					sResult = N_A;
				}
			}
			catch
			{
				sResult = N_A;
			}

			return sResult;
		}

	}

}
