Imports CQG

Module modErrorHandler

    ''' <summary>
    ''' Handles the error and shows a message box.
    ''' </summary>
    ''' <param name="modName">
    ''' Module name, in which the error has occurred.
    ''' </param>
    ''' <param name="funcName">
    ''' Function name, in which the error has occurred.
    ''' </param>
    ''' <param name="ex">
    ''' The exception generated in the described function of the described module.
    ''' </param>
    Public Sub ShowError(ByVal modName As String, _
                         ByVal funcName As String, _
                         ByVal ex As Exception)
        Dim sMsg As String

        sMsg = "Module : " & modName & Environment.NewLine
        sMsg &= "Function : " & funcName & Environment.NewLine
        sMsg &= "Source : " & ex.Source & Environment.NewLine
        sMsg &= "Status : " & ex.GetType().ToString() & Environment.NewLine
        sMsg &= "Description : " & ex.Message

        MessageBox.Show(sMsg, "PointAndFigureBars", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

End Module
