// StrategyOrderPlacingDlg.cpp : implementation file
//

#include "stdafx.h"
#include <stdexcept>
#include <cassert>
#include <ostream>
#include "Common.h"
#include "StrategyOrderPlacing.h"
#include "StrategyOrderPlacingDlg.h"
#include "ModifyDlg.h"
#include "ExecutionPatternDlg.h"
#include "QFormulasDlg.h"
#include "TransactionDlg.h"

const CString CStrategyOrderPlacingDlg::m_N_A = _T("N/A");

const long CStrategyOrderPlacingDlg::m_MIN_QUANTITY = 1;
const long CStrategyOrderPlacingDlg::m_MAX_QUANTITY = 10000;

const double CStrategyOrderPlacingDlg::m_INVALID_DOUBLE = -2147483648.;
const int CStrategyOrderPlacingDlg::m_INVALID_INTEGER = 0x80000000;

const CString CStrategyOrderPlacingDlg::m_SHORT_DATE = _T("dd/MM/yyyy");
const CString CStrategyOrderPlacingDlg::m_SHORT_TIME = _T("HH:mm:ss");

CStrategyOrderPlacingDlg::CStrategyOrderPlacingDlg(
                                 CWnd* pParent/*=NULL*/)
   : CDialog(CStrategyOrderPlacingDlg::IDD, pParent)
{
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStrategyOrderPlacingDlg::DoDataExchange(
                                 CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_LBL_DATA_CONNECTION, m_lblDataConnection);
   DDX_Control(pDX, IDC_LBL_GW_CONNECTION, m_lblGWConnection);
   DDX_Control(pDX, IDC_CMB_ACCOUNTS, m_cmbAccounts);
   DDX_Control(pDX, IDC_LBL_ASK_PRICE, m_lblAskPrice);
   DDX_Control(pDX, IDC_LBL_BID_PRICE, m_lblBidPrice);
   DDX_Control(pDX, IDC_LBL_ASK_VOLUME, m_lblAskVolume);
   DDX_Control(pDX, IDC_LBL_BID_VOLUME, m_lblBidVolume);
   DDX_Control(pDX, IDC_LSV_ORDERS, m_lvOrders);
   DDX_Control(pDX, IDC_CMB_TYPE, m_cmbType);
   DDX_Control(pDX, IDC_CMB_DURATION, m_cmbDuration);
   DDX_Control(pDX, IDC_SPN_LIMIT_PRICE, m_spnLimitPrice);
   DDX_Control(pDX, IDC_SPN_STOP_PRICE, m_spnStopPrice);
   DDX_Control(pDX, IDC_SPN_QUANTITY, m_spnQuantity);
   DDX_Control(pDX, IDC_BTN_MODIFY, m_btnModify);
   DDX_Control(pDX, IDC_BTN_CANCEL, m_btnCancel);
   DDX_Control(pDX, IDC_BTN_CANCEL_ALL, m_btnCancelAll);
   DDX_Control(pDX, IDC_DTP_GTD, m_dtpGTD);
   DDX_Control(pDX, IDC_ED_QUANTITY, m_edQuantity);
   DDX_Control(pDX, IDC_ED_LIMIT_PRICE, m_edLimitPrice);
   DDX_Control(pDX, IDC_ED_STOP_PRICE, m_edStopPrice);
   DDX_Control(pDX, IDC_BTN_SUBSCRIBE, m_btnSubscribe);
   DDX_Control(pDX, IDC_BTN_QFORMULA, m_btnQFormula);
   DDX_Control(pDX, IDC_BTN_BUY, m_btnBuy);
   DDX_Control(pDX, IDC_BTN_SELL, m_btnSell);
   DDX_Control(pDX, IDC_CMB_SPREAD, m_cmbSpreadExpr);
   DDX_Control(pDX, IDC_EDSTATUS, m_edStrategyStatus);
   DDX_Control(pDX, IDC_BTN_DEFINE_STRATEGY, m_btnDefine);
   DDX_Control(pDX, IDC_BTN_PATTERN_MODIFY, m_btnPatternModify);
   DDX_Control(pDX, IDC_BTN_PATTERN_ADD, m_btnPatternAdd);
   DDX_Control(pDX, IDC_CMB_PATTERN, m_cmbPattern);
   DDX_Control(pDX, IDC_EDCLIENT_ID, m_edClientId);
   DDX_Control(pDX, IDC_EDGW_ALIAS, m_edGwAlias);
   DDX_Control(pDX, IDC_LSV_LEG_ORDERS, m_lvLegOrders);
   DDX_Control(pDX, IDC_LBL_LONG_POSITION, m_lblLongPosition);
   DDX_Control(pDX, IDC_LBL_SHORT_POSITION, m_lblShortPosition);
   DDX_Control(pDX, IDC_BTN_TRANSACTIONS, m_btnTransection);
   DDX_Control(pDX, IDC_ED_PATTERN_STRING, m_edPatternString);
   DDX_Control(pDX, IDC_CMB_CANCELATION_TYPE, m_cmbCancelationInstruction);
   DDX_Control(pDX, IDC_SPN_VISIBLE_QUANTITY, m_spnVisibleQuantity);
   DDX_Control(pDX, IDC_ED_VISIBLE_QUANTITY, m_edVisibleQuantity);
   DDX_Control(pDX, IDC_CHECK_ICBG_STRATEGY, m_chkIcebergStrategy);
}

BEGIN_MESSAGE_MAP(CStrategyOrderPlacingDlg, CDialog)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_DESTROY()
   ON_BN_CLICKED(IDC_BTN_SUBSCRIBE, OnBnClickedBtnSubscribe)
   ON_BN_CLICKED(IDC_BTN_QFORMULA, OnBnClickedBtnQFormula)
   ON_BN_CLICKED(IDC_BTN_BUY, OnBnClickedBtnBuy)
   ON_BN_CLICKED(IDC_BTN_SELL, OnBnClickedBtnSell)
   ON_BN_CLICKED(IDC_BTN_MODIFY, OnBnClickedBtnModify)
   ON_BN_CLICKED(IDC_BTN_CANCEL, OnBnClickedBtnCancel)
   ON_BN_CLICKED(IDC_BTN_CANCEL_ALL, OnBnClickedBtnCancelAll)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_STOP_PRICE, OnDeltaposSpStopPrice)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_LIMIT_PRICE, OnDeltaposSpLimitPrice)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_QUANTITY, OnDeltaposSpQuantity)
   ON_NOTIFY(LVN_ITEMCHANGED, IDC_LSV_ORDERS, OnLvnItemChangedLsvOrders)
   ON_EN_KILLFOCUS(IDC_ED_QUANTITY, OnEnKillfocusEdQuantity)
   ON_CBN_SELCHANGE(IDC_CMB_ACCOUNTS, OnCbnSelChangeCmbAccounts)
   ON_CBN_SELCHANGE(IDC_CMB_TYPE, OnCbnSelChangeCmbType)
   ON_CBN_SELCHANGE(IDC_CMB_DURATION, OnCbnSelChangeCmbDuration)
   ON_CBN_SELCHANGE(IDC_CMB_SPREAD, OnCbnSelchangeCmbSpread)
   ON_BN_CLICKED(IDC_BTN_DEFINE_STRATEGY, OnBnClickedBtnDefineStrategy)
   ON_BN_CLICKED(IDC_BTN_PATTERN_MODIFY, OnBnClickedBtnPatternModify)
   ON_BN_CLICKED(IDC_BTN_PATTERN_ADD, OnBnClickedBtnPatternAdd)
   ON_CBN_SELCHANGE(IDC_CMB_PATTERN, OnCbnSelchangeCmbPattern)
   ON_CBN_EDITCHANGE(IDC_CMB_SPREAD, OnCbnEditchangeCmbSpread)
   ON_BN_CLICKED(IDC_BTN_TRANSACTIONS, OnBnClickedBtnTransactions)
   ON_CBN_SELCHANGE(IDC_CMB_CANCELATION_TYPE, OnCbnSelchangeCmbCancelationType)
   ON_BN_CLICKED(IDC_CHECK_ICBG_STRATEGY, OnBnClickedCheck)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_VISIBLE_QUANTITY, OnDeltaposSpnVisibleQuantity)
END_MESSAGE_MAP()

BOOL CStrategyOrderPlacingDlg::OnInitDialog()
{
   try
   {
      CDialog::OnInitDialog();

      // Set the icon for this dialog.  The framework does this automatically
      // when the application's main window is not a dialog
      SetIcon(m_hIcon, TRUE);       // Set big icon
      SetIcon(m_hIcon, FALSE);      // Set small icon

      InitializeBooleans();
      InitializeControls();
      InitializeCQGCEL();
      UpdateDefinitionInfo();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStrategyOrderPlacingDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

HCURSOR CStrategyOrderPlacingDlg::OnQueryDragIcon()
{
   return static_cast<HCURSOR>(m_hIcon);
}

void CStrategyOrderPlacingDlg::OnOK()
{
   // Override to prevent dialog from closing on Enter
}

void CStrategyOrderPlacingDlg::OnDestroy()
{
   try
   {
      if (m_spCQGCEL)
      {
         HRESULT hr = ICQGCELDispEventImpl::DispEventUnadvise(m_spCQGCEL);
         assert(SUCCEEDED(hr));

         hr = m_spCQGCEL->Shutdown();
         AssertCOMError(m_spCQGCEL, hr);
      }
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   CDialog::OnDestroy();
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnSubscribe()
{
   try
   {
      ClearAllInstrumentData();
      
      CString symbol;
      m_cmbSpreadExpr.GetWindowText(symbol);
          
      // Request instrument
      HRESULT hr = m_spCQGCEL->NewInstrument(ATL::CT2W(symbol));
      AssertCOMError(m_spCQGCEL, hr);

      m_btnSubscribe.EnableWindow(FALSE);
      m_btnDefine.EnableWindow(FALSE);
      UpdateDefinitionInfo();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnQFormula()
{
   try
   {
      CQFormulasDlg dlg(m_spCQGCEL, this);
      if (dlg.DoModal() == IDOK)
      {
         // copy qformula name
         const CString qFormulaName = dlg.GetQFormulaName();
         m_cmbSpreadExpr.SetCurSel(LB_ERR);
         m_cmbSpreadExpr.SetWindowText(qFormulaName);

         // copy execution pattern from qformula
         m_cmbPattern.SetCurSel(m_cmbPattern.GetCount()-1);
         m_edPatternString.SetWindowText(dlg.GetExecutionPattern());

         OnCbnEditchangeCmbSpread();
      }
   }
   catch (const std::runtime_error& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()));
   }
}

void CStrategyOrderPlacingDlg::OnCbnSelChangeCmbAccounts()
{
   try
   {
      ShowFilteredOrders();
      ShowPosition();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnModify()
{
   try
   {
      ATL::CComPtr<ICQGOrder> spSelectedOrder = GetSelectedOrder();
      if (spSelectedOrder == NULL)
      {
         // No selected order
         AfxMessageBox(_T("There is no order selected."));
         return;
      }

      VARIANT_BOOL canBeModified;
      GET_PARAM(spSelectedOrder, canBeModified, get_CanBeModified);

      if (!canBeModified)
      {
         // Selected order cannot be modified
         AfxMessageBox(_T("Selected order cannot be modified."));
         return;
      }

      // Get limit price and stop price from selected order
      double limitPrice;
      GET_PARAM(spSelectedOrder, limitPrice, get_LimitPrice);
      
      CString limitDisplayPrice = GetDisplayPrice(spSelectedOrder, limitPrice);

      double stopPrice;
      GET_PARAM(spSelectedOrder, stopPrice, get_StopPrice);
      CString stopDisplayPrice = GetDisplayPrice(spSelectedOrder, stopPrice);

      // Get instrument to get price display format
      ATL::CComBSTR alias;
      GET_PARAM(spSelectedOrder, alias, get_InstrumentName);

      // Get corresponding instrument for order alias
      ATL::CComPtr<ICQGInstrument> spInstrument = GetInstrumentByAlias(alias);

      // Open dialog to modify order
      CModifyDlg dlg(spSelectedOrder, limitDisplayPrice, stopDisplayPrice, spInstrument);
      dlg.DoModal();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnCancel()
{
   try
   {
      ATL::CComPtr<ICQGOrder> spSelectedOrder = GetSelectedOrder();
      if (spSelectedOrder == NULL)
      {
         // No order selected
         AfxMessageBox(_T("There is no order selected."));
         return;
      }

      HRESULT hr = spSelectedOrder->Cancel();
      AssertCOMError(spSelectedOrder, hr);

      UnselectAllOrders();
      EnableControls();
   }
   catch (...)
   {
      AfxMessageBox(_T("Selected order cannot be canceled."));
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnCancelAll()
{
   try
   {
      // Get selected account
      ATL::CComPtr<ICQGAccount> spAccount = GetSelectedAccount();

      // Cancel all account's orders
      HRESULT hr = m_spCQGCEL->CancelAllOrders(spAccount, NULL, VARIANT_FALSE, VARIANT_FALSE, osdUndefined);
      AssertCOMError(m_spCQGCEL, hr);

      UnselectAllOrders();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnDeltaposSpStopPrice(
                                 NMHDR *pNMHDR,
                                 LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      ChangePrice(m_edStopPrice, GetSelectedInstrument(), pNMUpDown->iDelta);
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CStrategyOrderPlacingDlg::OnDeltaposSpLimitPrice(
                                 NMHDR *pNMHDR,
                                 LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      ChangePrice(m_edLimitPrice, GetSelectedInstrument(), pNMUpDown->iDelta);
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
   
   *pResult = 0;
}

void CStrategyOrderPlacingDlg::OnDeltaposSpQuantity(
                                 NMHDR *pNMHDR,
                                 LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

      long quantity = GetQuantity(m_edQuantity);
      quantity -= pNMUpDown->iDelta;

      SetQuantity(m_edQuantity, GetValidQuantity(quantity));
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CStrategyOrderPlacingDlg::OnEnKillfocusEdQuantity()
{
   try
   {
      SetQuantity(m_edQuantity, GetValidQuantity(GetQuantity(m_edQuantity)));
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnSell()
{
   try
   {
      PlaceOrder(osdSell);

      UnselectAllOrders();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnBuy()
{
   try
   {
      PlaceOrder(osdBuy);

      UnselectAllOrders();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnLvnItemChangedLsvOrders(
                                 NMHDR * /*pNMHDR*/,
                                 LRESULT *pResult)
{
   try
   {  
      ATL::CComPtr<ICQGOrder> spSelectedOrder = GetSelectedOrder();

      ShowLegOrders(spSelectedOrder);
      ShowCancelationInstruction(spSelectedOrder);

      EnableControls();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CStrategyOrderPlacingDlg::OnCbnSelChangeCmbType()
{
   try
   {
      // Get selected instrument
      ATL::CComPtr<ICQGInstrument> spInstrument = GetSelectedInstrument();

      if (spInstrument == NULL)
      {
         // No selected instrument
         return;
      }
      
      ShowValidPrice(spInstrument);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnCbnSelChangeCmbDuration()
{
   try
   {
      // Get order duration type
      eOrderDuration orderDuration = static_cast<eOrderDuration>
                                       (m_cmbDuration.GetItemData(m_cmbDuration.GetCurSel()));

      m_GTDEnabled = (orderDuration == odGoodTillDate || orderDuration == odGoodTillTime);
      
      if (orderDuration == odGoodTillDate)
      {
         m_dtpGTD.SetFormat(m_SHORT_DATE);
      }
      else if (orderDuration == odGoodTillTime)
      {
         m_dtpGTD.SetFormat(m_SHORT_TIME);
      }

      EnableControls();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnCbnSelchangeCmbSpread()
{
   try
   {
      // Clear instrument's old data
      ClearAllInstrumentData();
      ClearAllDefinitionData();
      UpdateDefinitionInfo();

      // Get selected instrument
      ATL::CComPtr<ICQGInstrument> spInstrument = GetSelectedInstrument();

      if(spInstrument == NULL)
      {
         // No selected instrument
         m_btnDefine.EnableWindow(FALSE);
         return;
      }

      m_btnDefine.EnableWindow(TRUE);
      ATL::CComPtr<ICQGStrategyDefinition> spDefinition = GetCurrentStrategyDefinition();

      ShowStrategyProperties(spDefinition);
      ShowValidPrice(spInstrument);
      ShowQuotes(spInstrument);
      ShowPosition();
      
      EnableControls();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnDefineStrategy()
{
   try
   {
      ATL::CComPtr<ICQGInstrument> spInstrument = GetSelectedInstrument();

      if (spInstrument == NULL)
      {
         // No instrument selected
         return;
      }

      ATL::CComBSTR fullName;
      GET_PARAM(spInstrument, fullName, get_FullName);

      ATL::CComPtr<ICQGStrategyDefinition> spDefinition;
      HRESULT hr = m_spCQGCEL->DefineStrategyEx(fullName, GetSelectedAccount(), &spDefinition);
      AssertCOMError(m_spCQGCEL, hr);
     
      ATL::CComBSTR id;
      GET_PARAM(spDefinition, id, get_Id);

      // add definition to definitions collection
      m_expressionToGuid.insert(std::make_pair(fullName, id));

      eStrategyRequestStatus status;
      GET_PARAM(spDefinition, status, get_Status);

      m_edStrategyStatus.SetWindowText(StatusToString(status));

      UpdateDefinitionInfo();
      EnableControls();
      ShowValidPrice(spInstrument);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnPatternModify()
{
   try
   {
      ATL::CComPtr<ICQGStrategyDefinition> spDef = GetCurrentStrategyDefinition();
      CString patternName;
      m_cmbPattern.GetWindowText(patternName);

      assert(m_spCurrentPattern != NULL);

      CExecutionPatternDlg dlg(m_spCQGCEL, m_spCurrentPattern, patternName, m_patterns, spDef, this);
      if(dlg.DoModal()== IDOK)
      {
         m_spCurrentPattern = dlg.GetPattern();
         m_patterns[patternName] = m_spCurrentPattern;

         int index = m_cmbPattern.FindString(0, dlg.GetPatternName());
         m_cmbPattern.SetCurSel(index);
         
         OnCbnSelchangeCmbPattern();
      }
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnPatternAdd()
{
   try
   {
      ATL::CComPtr<ICQGStrategyDefinition> spDef = GetCurrentStrategyDefinition();
      
      ATL::CComPtr<ICQGExecutionPattern> spPattern;

      CExecutionPatternDlg dlg(m_spCQGCEL, spPattern, CString(), m_patterns, spDef, this);

      if(dlg.DoModal()== IDOK)
      {
         assert(!dlg.GetPatternName().IsEmpty());

         std::map<CString, CComPtr<ICQGExecutionPattern> >::const_iterator it = m_patterns.find(dlg.GetPatternName());

         assert(it != m_patterns.end());
         m_spCurrentPattern = it->second;

         int index = m_cmbPattern.InsertString(0, dlg.GetPatternName());
         m_cmbPattern.SetCurSel(index);
         
         OnCbnSelchangeCmbPattern();
      }
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnCbnSelchangeCmbPattern()
{
   try
   {
      CString patternName;
      m_cmbPattern.GetWindowText(patternName);

      m_btnPatternModify.EnableWindow(!patternName.IsEmpty());
      m_edPatternString.EnableWindow(patternName.IsEmpty());

      ATL::CComPtr<ICQGExecutionPattern> spPattern;
      std::map<CString, ATL::CComPtr<ICQGExecutionPattern> >::iterator it = m_patterns.find(patternName);
      
      if(it != m_patterns.end())
      {
          m_spCurrentPattern = it->second;

          // Update pattern string
          ATL::CComBSTR patternString;
          GET_PARAM(m_spCurrentPattern, patternString, get_PatternString);
          m_edPatternString.SetWindowText(ATL::CW2T(patternString));
      }
      else
      {
         m_spCurrentPattern = NULL;
      }
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CStrategyOrderPlacingDlg::OnCbnEditchangeCmbSpread()
{
   UpdateDefinitionInfo();
   EnableControls();

   // Clear instrument's old data
   ClearAllInstrumentData();
}

void CStrategyOrderPlacingDlg::OnBnClickedBtnTransactions()
{
   ATL::CComPtr<ICQGOrder> spSelectedOrder = GetSelectedOrder();
   if (spSelectedOrder == NULL)
   {
      // No order selected
      AfxMessageBox(_T("There is no order selected."));
      return;
   }

   CTransactionDlg dlg(m_spCQGCEL, spSelectedOrder, this);
   dlg.DoModal();
}
void CStrategyOrderPlacingDlg::OnCbnSelchangeCmbCancelationType()
{
   ATL::CComPtr<ICQGOrder> spSelectedOrder = GetSelectedOrder();
   if (spSelectedOrder == NULL)
   {
      return;
   }

   eOrderCancelationType cancelation_type = static_cast<eOrderCancelationType>(
      m_cmbCancelationInstruction.GetItemData(m_cmbCancelationInstruction.GetCurSel()));
   spSelectedOrder->put_CancelationInstruction(cancelation_type);
}

void CStrategyOrderPlacingDlg::OnBnClickedCheck()
{
   m_cmbType.SetCurSel(m_cmbType.FindString(0, _T("Limit")));
   ShowValidPrice(GetSelectedInstrument());
}

void CStrategyOrderPlacingDlg::OnDeltaposSpnVisibleQuantity(NMHDR *pNMHDR, LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

      long quantity = GetQuantity(m_edVisibleQuantity);
      quantity -= pNMUpDown->iDelta;

      SetQuantity(m_edVisibleQuantity, GetValidQuantity(quantity));
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}