using System;
using System.Windows.Forms;
using CQG;

namespace StrategyOrderPlacing
{
    /// <summary>
    /// This form is used to modify specified order properties.
    /// </summary>
    public class frmModify : Form
    {
        #region GUI Control-fields

        private Button btnCancel;
        private Button btnOK;
        private GroupBox grbOrderProperties;
        private Label lblLimitPrice;
        private Label lblQuantity;
        private Label lblStopPrice;
        private TextBox txtLimitPrice;
        private TextBox txtStopPrice;
        private VScrollBar vsbLimitPrice;
        private VScrollBar vsbStopPrice;
        private NumericUpDown nudQuantity;

        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.nudQuantity = new System.Windows.Forms.NumericUpDown();
            this.btnOK = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.vsbStopPrice = new System.Windows.Forms.VScrollBar();
            this.txtStopPrice = new System.Windows.Forms.TextBox();
            this.vsbLimitPrice = new System.Windows.Forms.VScrollBar();
            this.txtLimitPrice = new System.Windows.Forms.TextBox();
            this.lblLimitPrice = new System.Windows.Forms.Label();
            this.lblStopPrice = new System.Windows.Forms.Label();
            this.lblQuantity = new System.Windows.Forms.Label();
            this.grbOrderProperties = new System.Windows.Forms.GroupBox();
            ((System.ComponentModel.ISupportInitialize)(this.nudQuantity)).BeginInit();
            this.grbOrderProperties.SuspendLayout();
            this.SuspendLayout();
            // 
            // nudQuantity
            // 
            this.nudQuantity.Location = new System.Drawing.Point(16, 88);
            this.nudQuantity.Maximum = new System.Decimal(new int[] {
                                                                        10000,
                                                                        0,
                                                                        0,
                                                                        0});
            this.nudQuantity.Minimum = new System.Decimal(new int[] {
                                                                        1,
                                                                        0,
                                                                        0,
                                                                        0});
            this.nudQuantity.Name = "nudQuantity";
            this.nudQuantity.ReadOnly = true;
            this.nudQuantity.Size = new System.Drawing.Size(104, 20);
            this.nudQuantity.TabIndex = 17;
            this.nudQuantity.ThousandsSeparator = true;
            this.nudQuantity.Value = new System.Decimal(new int[] {
                                                                      1,
                                                                      0,
                                                                      0,
                                                                      0});
            // 
            // btnOK
            // 
            this.btnOK.Location = new System.Drawing.Point(96, 136);
            this.btnOK.Name = "btnOK";
            this.btnOK.Size = new System.Drawing.Size(72, 23);
            this.btnOK.TabIndex = 26;
            this.btnOK.Text = "OK";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Location = new System.Drawing.Point(176, 136);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(72, 23);
            this.btnCancel.TabIndex = 27;
            this.btnCancel.Text = "Cancel";
            // 
            // vsbStopPrice
            // 
            this.vsbStopPrice.Location = new System.Drawing.Point(216, 41);
            this.vsbStopPrice.Maximum = 100000000;
            this.vsbStopPrice.Minimum = -100000000;
            this.vsbStopPrice.Name = "vsbStopPrice";
            this.vsbStopPrice.Size = new System.Drawing.Size(16, 18);
            this.vsbStopPrice.TabIndex = 41;
            this.vsbStopPrice.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vsbStopPrice_Scroll);
            // 
            // txtStopPrice
            // 
            this.txtStopPrice.Location = new System.Drawing.Point(128, 40);
            this.txtStopPrice.Name = "txtStopPrice";
            this.txtStopPrice.ReadOnly = true;
            this.txtStopPrice.Size = new System.Drawing.Size(104, 20);
            this.txtStopPrice.TabIndex = 40;
            this.txtStopPrice.Text = "N/A";
            // 
            // vsbLimitPrice
            // 
            this.vsbLimitPrice.LargeChange = 1;
            this.vsbLimitPrice.Location = new System.Drawing.Point(104, 41);
            this.vsbLimitPrice.Maximum = 100000000;
            this.vsbLimitPrice.Minimum = -10000000;
            this.vsbLimitPrice.Name = "vsbLimitPrice";
            this.vsbLimitPrice.Size = new System.Drawing.Size(16, 18);
            this.vsbLimitPrice.TabIndex = 42;
            this.vsbLimitPrice.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vsbLimitPrice_Scroll);
            // 
            // txtLimitPrice
            // 
            this.txtLimitPrice.Location = new System.Drawing.Point(16, 40);
            this.txtLimitPrice.Name = "txtLimitPrice";
            this.txtLimitPrice.ReadOnly = true;
            this.txtLimitPrice.Size = new System.Drawing.Size(104, 20);
            this.txtLimitPrice.TabIndex = 39;
            this.txtLimitPrice.Text = "N/A";
            // 
            // lblLimitPrice
            // 
            this.lblLimitPrice.Location = new System.Drawing.Point(16, 24);
            this.lblLimitPrice.Name = "lblLimitPrice";
            this.lblLimitPrice.Size = new System.Drawing.Size(88, 16);
            this.lblLimitPrice.TabIndex = 38;
            this.lblLimitPrice.Text = "Limit Price";
            // 
            // lblStopPrice
            // 
            this.lblStopPrice.Location = new System.Drawing.Point(128, 24);
            this.lblStopPrice.Name = "lblStopPrice";
            this.lblStopPrice.Size = new System.Drawing.Size(88, 16);
            this.lblStopPrice.TabIndex = 37;
            this.lblStopPrice.Text = "Stop Price";
            // 
            // lblQuantity
            // 
            this.lblQuantity.Location = new System.Drawing.Point(16, 72);
            this.lblQuantity.Name = "lblQuantity";
            this.lblQuantity.Size = new System.Drawing.Size(88, 16);
            this.lblQuantity.TabIndex = 37;
            this.lblQuantity.Text = "Quantity";
            // 
            // grbOrderProperties
            // 
            this.grbOrderProperties.Controls.Add(this.nudQuantity);
            this.grbOrderProperties.Controls.Add(this.vsbStopPrice);
            this.grbOrderProperties.Controls.Add(this.txtStopPrice);
            this.grbOrderProperties.Controls.Add(this.vsbLimitPrice);
            this.grbOrderProperties.Controls.Add(this.txtLimitPrice);
            this.grbOrderProperties.Controls.Add(this.lblLimitPrice);
            this.grbOrderProperties.Controls.Add(this.lblStopPrice);
            this.grbOrderProperties.Controls.Add(this.lblQuantity);
            this.grbOrderProperties.Location = new System.Drawing.Point(8, 8);
            this.grbOrderProperties.Name = "grbOrderProperties";
            this.grbOrderProperties.Size = new System.Drawing.Size(240, 120);
            this.grbOrderProperties.TabIndex = 43;
            this.grbOrderProperties.TabStop = false;
            this.grbOrderProperties.Text = "Order Properties";
            // 
            // frmModify
            // 
            this.AcceptButton = this.btnOK;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.btnCancel;
            this.ClientSize = new System.Drawing.Size(258, 167);
            this.Controls.Add(this.grbOrderProperties);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnOK);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "frmModify";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Modify Order";
            ((System.ComponentModel.ISupportInitialize)(this.nudQuantity)).EndInit();
            this.grbOrderProperties.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion
        
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        /// <summary>
        /// CQGCEL object.
        /// </summary>
        private CQGCEL m_CEL;

        /// <summary>
        /// CQGOrder object to modify.
        /// </summary>
        private CQGOrder m_Order;

        /// <summary>
        /// Instrument of the order.
        /// </summary>
        CQGInstrument m_Instrument;

        /// <summary>
        /// CQGOrderModify object used to modify order's parameters.
        /// </summary>
        private CQGOrderModify m_OrderModify;
        
        /// <summary>
        /// Initializes modify controls.
        /// </summary>
        /// <param name="cel">CQGCEL object.</param>
        /// <param name="order">CQGOrder object to be modified.</param>
        public frmModify(CQGCEL cel, CQGOrder order, CQGInstrument instrument)
        {
            try
            {
                // Required for Windows Form Designer support
                InitializeComponent();

                this.Text = "Modify order : " + order.GWOrderID;

                m_CEL = cel;
                m_Order = order;
                m_Instrument = instrument;
                m_OrderModify = order.PrepareModify();

                InitializePricesModify();
                InitializeQuantityModify();
            }
            catch (Exception ex)
            {
                throw new TypeInitializationException("frmModify", ex);
            }
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if(components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }


        #region Auxiliary methods

        /// <summary>
        /// Initializes controls used to modify order's quantity.
        /// </summary>
        private void InitializeQuantityModify()
        {
            nudQuantity.Value = Math.Abs(m_Order.Quantity);
            nudQuantity.Enabled = (m_OrderModify.Properties[eOrderProperty.opQuantity] != null);
        }

        /// <summary>
        /// Initializes controls used to modify order's prices.
        /// </summary>
        private void InitializePricesModify()
        {
            txtLimitPrice.Text = frmStrategyOrderPlacing.N_A;
            txtLimitPrice.Enabled = false;
            vsbLimitPrice.Enabled = false;

            txtStopPrice.Text = frmStrategyOrderPlacing.N_A;
            txtStopPrice.Enabled = false;
            vsbStopPrice.Enabled = false;

            if (m_Instrument != null)
            {
                if (m_OrderModify.Properties[eOrderProperty.opLimitPrice] != null)
                {
                    txtLimitPrice.Text = m_Instrument.ToDisplayPrice(m_Order.LimitPrice);
                    txtLimitPrice.Enabled = true;
                    vsbLimitPrice.Enabled = true;
                }

                if (m_OrderModify.Properties[eOrderProperty.opStopPrice] != null)
                {
                    txtStopPrice.Text = m_Instrument.ToDisplayPrice(m_Order.StopPrice);
                    txtStopPrice.Enabled = true;
                    vsbStopPrice.Enabled = true;
                }
            }
        }

        #endregion

        #region Form controls event handlers

        /// <summary>
        /// Gathers modified values and modifies order.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">An EventArgs that contains the event data.</param>
        private void btnOK_Click(object sender, EventArgs e)
        {
            try
            {
                bool isModified = false;

                // Change quantity if allowed
                CQGOrderProperty property = m_OrderModify.Properties[eOrderProperty.opQuantity];
                if (property != null)
                {
                    int quantity = Decimal.ToInt32(nudQuantity.Value);
                    // Checking order side by the order's quantity sign
                    quantity *= Math.Sign(m_Order.Quantity);
                    if (quantity != m_Order.Quantity)
                    {
                        property.Value = quantity;
                        isModified = true;
                    }
                }

                // Change limit price if allowed
                property = m_OrderModify.Properties[eOrderProperty.opLimitPrice];
                if (property != null && txtLimitPrice.Text != frmStrategyOrderPlacing.N_A)
                {
                    double limitPrice = m_Instrument.FromDisplayPrice(txtLimitPrice.Text);
                    if (limitPrice != m_Order.LimitPrice)
                    {
                        property.Value = limitPrice;
                        isModified = true;
                    }
                }

                // Change stop price if allowed
                property = m_OrderModify.Properties[eOrderProperty.opStopPrice];
                if (property != null && txtStopPrice.Text != frmStrategyOrderPlacing.N_A)
                {
                    double stopPrice = m_Instrument.FromDisplayPrice(txtStopPrice.Text);
                    if (stopPrice != m_Order.StopPrice)
                    {
                        property.Value = stopPrice;
                        isModified = true;
                    }
                }

                // Modify order if needed
                if (isModified)
                {
                    m_Order.Modify(m_OrderModify);
                }
            }
            catch (Exception ex)
            {
                ErrorHandler.HandleError("frmModify", "btnOK_Click", ex);
            }
            finally
            {
                this.Close();
            }
        }

        /// <summary>
        /// Increments/Decrements limit price.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">A ScrollEventArgs that contains the event data. </param>
        private void vsbLimitPrice_Scroll(object sender, ScrollEventArgs e)
        {
            try
            {
                frmStrategyOrderPlacing.UpDownPrice(m_Instrument, txtLimitPrice, e);	
            }
            catch (Exception ex)
            {
                ErrorHandler.HandleError("frmModify", "vsbLimitPrice_Scroll", ex);
            }
        }

        /// <summary>
        /// Increments/Decrements stop price.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">A ScrollEventArgs that contains the event data. </param>
        private void vsbStopPrice_Scroll(object sender, ScrollEventArgs e)
        {
            try
            {
                frmStrategyOrderPlacing.UpDownPrice(m_Instrument, txtStopPrice, e);
            }
            catch (Exception ex)
            {
                ErrorHandler.HandleError("frmModify", "vsbStopPrice_Scroll", ex);
            }
        }

        #endregion
    }
}
