#pragma once

/// \brief This dialog is used to select 
/// \brief what type of instruments to request
class CInstrumentTypesDlg : public CDialog
{

public:
   CInstrumentTypesDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
   enum { IDD = IDD_INSTRUMENTTYPES_DIALOG };

protected:
   virtual void DoDataExchange(
                     CDataExchange* pDX);    // DDX/DDV support
   virtual BOOL OnInitDialog();

   DECLARE_MESSAGE_MAP()
private:
   /// \brief Call Options instruments type checkbox control
   BOOL m_CallOptionsChecked;

   /// \brief Put options instruments type checkbox control
   BOOL m_PutOptionsChecked;

   /// \brief Futures instruments type checkbox control
   BOOL m_FuturesChecked;

   /// \brief Stocks instruments type checkbox control
   BOOL m_StocksChecked;

   /// \brief Treasuries instruments type checkbox control
   BOOL m_TreasuriesChecked;

   /// \brief Other instruments checkbox control
   BOOL m_OtherChecked;

   /// \brief Only tradable instruments checkbox control
   BOOL m_OnlyTradableChecked;

   /// \brief Ok button control
   CButton m_btnOk;

public:
   /// \brief Selects all instrument types' checkboxes on the form
   afx_msg void OnBnClickedBtnSelectAll();
   
   /// \brief Selects all options types' checkboxes on the form
   afx_msg void OnBnClickedBtnSelectOptions();
   
   /// \brief Closes dialog with IDCANCEL result
   afx_msg void OnCheckBoxClick();

   /// \brief Returns bit mask with all selected types
   /// \param instrumentTypes [out] - Selected types
   /// \param tradeableOnly [out] - Specifies does user want to request only tradables
   void GetTypes(
               long& instrumentTypes, 
               VARIANT_BOOL& tradeableOnly) const;
};
