// TFlowBarsDlg.cpp : implementation file
//

#include "stdafx.h"
#include <cassert>
#include "Common.h"
#include "Helper.h"
#include "TFlowBars.h"
#include "TFlowBarsDlg.h"
#include "TFlowBarsReqDlg.h"

const long CTFlowBarsDlg::m_ShowCount = 5;
const long CTFlowBarsDlg::m_MaxIdInterval = 500;

CTFlowBarsDlg::CTFlowBarsDlg(CWnd* pParent /*=NULL*/)
                           : CDialog(CTFlowBarsDlg::IDD, pParent)
{
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTFlowBarsDlg::DoDataExchange(
                           CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_LBL_DATA_CONNECTION, m_lblDataConnection);

   DDX_Control(pDX, IDC_CMB_TFLOW_BARS, m_cmbTFlowBars);

   DDX_Control(pDX, IDC_BTN_REQUEST, m_btnRequest);
   DDX_Control(pDX, IDC_BTN_REMOVE, m_btnRemove);
   DDX_Control(pDX, IDC_BTN_REMOVE_ALL, m_btnRemoveAll);

   DDX_Control(pDX, IDC_LBL_STATUS, m_lblStatus);

   DDX_Text(pDX, IDC_LBL_SYMBOL, m_Symbol);
   DDX_Text(pDX, IDC_LBL_RANGE_START, m_RangeStart);
   DDX_Text(pDX, IDC_LBL_RANGE_END, m_RangeEnd);
   DDX_Text(pDX, IDC_LBL_AGGREGATION_LEVEL, m_AggregationLevel);
   DDX_Text(pDX, IDC_LBL_AGGREGATION, m_Aggregation);
   DDX_Text(pDX, IDC_LBL_DOM_ASK_LEVEL, m_DomAskVolLevel);
   DDX_Text(pDX, IDC_LBL_DOM_BID_LEVEL, m_DomBidVolLevel);
   DDX_Text(pDX, IDC_LBL_UPDATES_ENABLED, m_UpdatesEnabled);
   DDX_Text(pDX, IDC_LBL_INCLUDE_END, m_IncludeEnd);
   DDX_Text(pDX, IDC_LBL_SESSIONS_FILTER, m_SessionsFilter);
   DDX_Text(pDX, IDC_LBL_CONTINUATION, m_Continuation);
   DDX_Text(pDX, IDC_LBL_EQUALIZE_CLOSES, m_EqualizeCloses);
   DDX_Text(pDX, IDC_LBL_DAYS_BEFORE_EXPIRATION, m_DaysBeforeExpiration);
   DDX_Text(pDX, IDC_LBL_SESSION_FLAGS, m_SessionFlags);
   DDX_Text(pDX, IDC_LBL_SUBSCRIPTION_LEVEL, m_SubscriptionLevel);
   DDX_Text(pDX, IDC_LBL_RECALC_PERIOD, m_RecalcPeriod);

   DDX_Text(pDX, IDC_LBL_OUTPUT_START, m_OutputStart);
   DDX_Text(pDX, IDC_LBL_OUTPUT_END, m_OutputEnd);

   DDX_Control(pDX, IDC_LBL_ERROR, m_lblError);

   DDX_Control(pDX, IDC_LSV_LAST_TFLOW_BARS, m_lvLastTFlowBars);
   DDX_Control(pDX, IDC_LSV_TFLOW_BARS, m_lvTFlowBars);

   DDX_Control(pDX, IDC_ED_TAG_NAME, m_edTagName);
   DDX_Control(pDX, IDC_ED_TAG_VALUE, m_edTagValue);

   DDX_Control(pDX, IDC_ED_FILTER_START_INDEX, m_edStart);
   DDX_Control(pDX, IDC_SPN_FILTER_START_INDEX, m_spnStart);
   DDX_Control(pDX, IDC_ED_FILTER_END_INDEX, m_edEnd);
   DDX_Control(pDX, IDC_SPN_FILTER_END_INDEX, m_spnEnd);

   DDX_Control(pDX, IDC_BTN_SHOW, m_btnShow);

   DDX_Control(pDX, IDC_LBL_RECS_COUNT, m_lblFltrRecsCount);
   DDX_Control(pDX, IDC_LBL_ALL_RECS_COUNT, m_lblAllRecsCount);
}

BEGIN_MESSAGE_MAP(CTFlowBarsDlg, CDialog)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_DESTROY()
   ON_BN_CLICKED(IDC_BTN_REMOVE, OnBnClickedBtnRemove)
   ON_BN_CLICKED(IDC_BTN_REMOVE_ALL, OnBnClickedBtnRemoveAll)
   ON_BN_CLICKED(IDC_BTN_REQUEST, OnBnClickedBtnRequest)
   ON_BN_CLICKED(IDC_BTN_SHOW, OnBnClickedBtnShow)
   ON_CBN_SELCHANGE(IDC_CMB_TFLOW_BARS, OnCbnSelChangeCmbTFlowBars)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_START_INDEX, OnDeltaposSpnStart)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_END_INDEX, OnDeltaposSpnEnd)
END_MESSAGE_MAP()

BOOL CTFlowBarsDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon

   try
   {
      InitializeControls();
      InitializeCQGCEL();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTFlowBarsDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

HCURSOR CTFlowBarsDlg::OnQueryDragIcon()
{
   return static_cast<HCURSOR>(m_hIcon);
}

void CTFlowBarsDlg::OnOK()
{
   // If enter clicked when one of the tag edit boxes is active
   // then call corresponding function
   CWnd* pWnd = GetFocus();

   if (pWnd == &m_edTagName)
   {
      OnEnterEdTagName();
   }
   else if (pWnd == &m_edTagValue)
   {
      OnEnterEdTagValue();
   }
}

void CTFlowBarsDlg::OnDestroy()
{
   try
   {
      if (m_spCQGCEL)
      {
         HRESULT hr = ICQGCELDispEventImpl::DispEventUnadvise(m_spCQGCEL);
         assert(SUCCEEDED(hr));

         hr = m_spCQGCEL->Shutdown();
         Common::ThrowOnCOMError(m_spCQGCEL, hr);
      }
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   CDialog::OnDestroy();
}

void CTFlowBarsDlg::OnBnClickedBtnRemove()
{
   try
   {
      // Remove selected tflow bars from the collection
      HRESULT hr = m_spCQGCEL->RemoveTFlowBars(m_spTFlowBars);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      // Remove item from combo box
      int row = m_cmbTFlowBars.GetCurSel();
      int count = m_cmbTFlowBars.DeleteString(row);

      if (count == 0)
      {
         ClearAllData();
         m_spTFlowBars = NULL;

         // Clear combo box
         m_cmbTFlowBars.ResetContent();
      }
      else
      {
         m_cmbTFlowBars.SetCurSel((row >= count ? (count - 1) : row));
         OnCbnSelChangeCmbTFlowBars();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTFlowBarsDlg::OnBnClickedBtnRemoveAll()
{
   try
   {
      // Clear combo box
      m_cmbTFlowBars.ResetContent();

      // Remove all tflow bars from CQGCEL
      HRESULT hr = m_spCQGCEL->RemoveAllTFlowBars();
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      m_spTFlowBars = NULL;

      ClearAllData();

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTFlowBarsDlg::OnCbnSelChangeCmbTFlowBars()
{
   try
   {
      ClearAllData();

      if (m_cmbTFlowBars.GetCount() > 0)
      {
         // Get GUID from combo box
         CString id;
         m_cmbTFlowBars.GetWindowText(id);

         // Get item from CQGCEL by GUID
         ATL::CComPtr<ICQGTFlowBarsCollection> spAllTFlowBars;
         HRESULT hr = m_spCQGCEL->get_AllTFlowBars(&spAllTFlowBars);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         m_spTFlowBars.Release();
         hr = spAllTFlowBars->get_ItemById(ATL::CT2W(id), &m_spTFlowBars);
         Common::ThrowOnCOMError(spAllTFlowBars, hr);

         // Show corresponding items all data
         ShowAllData();

         // Initialize parameters for filtering
         FillIndices();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTFlowBarsDlg::OnBnClickedBtnRequest()
{
   try
   {
      // Create empty request
      ATL::CComPtr<ICQGTFlowBarsRequest> spRequest;
      HRESULT hr = m_spCQGCEL->CreateTFlowBarsRequest(&spRequest);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      spRequest->put_SessionsFilter(ATL::CComVariant(31));  // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

      // Get line time from CQGCEL->Environment
      ATL::CComPtr<ICQGEnvironment> spEnvironment;
      hr = m_spCQGCEL->get_Environment(&spEnvironment);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      DATE lineTime;
      hr = spEnvironment->get_LineTime(&lineTime);
      Common::ThrowOnCOMError(spEnvironment, hr);

      // Open form to fill up request data
      CTFlowBarsReqDlg dlg(spRequest, lineTime);
      if (dlg.DoModal() == IDOK)
      {
         // Send request to CQGCEL
         ATL::CComPtr<ICQGTFlowBars> spTFlowBars;
         hr = m_spCQGCEL->RequestTFlowBars(spRequest, &spTFlowBars);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         // Add ID to the requests combo box
         ATL::CComBSTR tFlowBarsID;
         hr = spTFlowBars->get_Id(&tFlowBarsID);
         Common::ThrowOnCOMError(spTFlowBars, hr);

         int row = m_cmbTFlowBars.AddString(ATL::CW2T(tFlowBarsID));
         m_cmbTFlowBars.SetCurSel(row);
         OnCbnSelChangeCmbTFlowBars();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTFlowBarsDlg::OnBnClickedBtnShow()
{
   try
   {
      // Clear records and records count
      ClearRecords(m_lvTFlowBars);
      m_lblFltrRecsCount.SetWindowText(_T(""));

      long startIndex;
      long endIndex;

      UpdateData();

      // Show filtered records and its' count when range is valid
      if (GetIndices(startIndex, endIndex))
      {
         m_lblFltrRecsCount.SetWindowText(GetValueAsString(endIndex - startIndex + 1));
         ShowRecords(startIndex, endIndex, m_lvTFlowBars);
      }
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

bool CTFlowBarsDlg::GetIndices(
                           long& startIndex,
                           long& endIndex)
{
   startIndex = m_edStart.GetValue();
   endIndex = m_edEnd.GetValue();

   // Check for valid indices
   if (endIndex < startIndex)
   {
      AfxMessageBox(_T("Start index must be smaller than end index."), MB_ICONWARNING);
      return false;
   }

   if (startIndex < 1)
   {
      AfxMessageBox(_T("Start index must be greater than zero."), MB_ICONWARNING);
      return false;
   }

   long count;
   HRESULT hr = m_spTFlowBars->get_Count(&count);
   Common::ThrowOnCOMError<ICQGTFlowBars>(m_spTFlowBars, hr);

   if (endIndex > count)
   {
      AfxMessageBox(_T("End index must be smaller than records count."), MB_ICONWARNING);
      return false;
   }

   if (endIndex - startIndex >= m_MaxIdInterval)
   {
      CString msgText;
      msgText.Format(_T("Range must indicate to no more than %d records."), m_MaxIdInterval);
      AfxMessageBox(msgText, MB_ICONWARNING);
      return false;
   }

   return true;
}

void CTFlowBarsDlg::OnDeltaposSpnStart(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edStart.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CTFlowBarsDlg::OnDeltaposSpnEnd(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edEnd.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CTFlowBarsDlg::OnEnterEdTagName()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty()) 
      {
         return;
      }

      ATL::CComVariant tagValue;
      HRESULT hr = m_spTFlowBars->get_Tag(ATL::CT2W(tagName), &tagValue);
      Common::ThrowOnCOMError(m_spTFlowBars, hr);

      // If there is no tag with specified tag name, tag value will be VT_EMPTY
      m_edTagValue.SetWindowText((tagValue.vt != VT_EMPTY) ? GetValueAsString(tagValue) : _T(""));
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTFlowBarsDlg::OnEnterEdTagValue()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty())
      {
         return;
      }

      CString tagValue;
      m_edTagValue.GetWindowText(tagValue);

      // If there is no tag value specified, then remove tag with specified tag name
      HRESULT hr = m_spTFlowBars->put_Tag(ATL::CT2W(tagName), 
         tagValue.IsEmpty() ? ATL::CComVariant() : ATL::CComVariant(tagValue));
      Common::ThrowOnCOMError(m_spTFlowBars, hr);

      m_edTagName.SetWindowText(_T(""));
      m_edTagValue.SetWindowText(_T(""));

      m_edTagName.SetFocus();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}