using System.Diagnostics;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;

namespace TFlowBars
{
   public class frmTFlowBars : System.Windows.Forms.Form
   {

      [STAThread]
      static void Main()
      {
         Application.Run(new frmTFlowBars());
      }

      // The CQGCEL object, which encapsulates the main functionality of CQG API
      [field: System.CLSCompliant(false)]
      public CQGCEL CEL;

      // The currently selected TFlowBars object in the combo box
      private CQGTFlowBars m_CurTFlowBars;

      // Specifies the not available string
      private const string N_A = "N/A";

      // Specifies the max records count
      private const int MAX_NUMBER_OF_RECORDS = 5;
      private ColumnHeader columnHeader13;
      private ColumnHeader columnHeader14;
      private ColumnHeader columnHeader15;
      private ColumnHeader columnHeader16;

      // Specifies the max index interval
      private const int MAX_INDEX_INTERVAL = 500;

      #region " Windows Form Designer generated code "

      public frmTFlowBars()
      {

         //This call is required by the Windows Form Designer.
         InitializeComponent();

         //Add any initialization after the InitializeComponent() call

      }

      //Form overrides dispose to clean up the component list.
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (!(components == null))
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      //Required by the Windows Form Designer
      private System.ComponentModel.Container components = null;

      //NOTE: The following procedure is required by the Windows Form Designer
      //It can be modified using the Windows Form Designer.
      //Do not modify it using the code editor.
      internal System.Windows.Forms.Label lblDataConnection;
      internal System.Windows.Forms.PictureBox PictureBox1;
      internal System.Windows.Forms.LinkLabel llWeb;
      internal System.Windows.Forms.GroupBox GroupBox1;
      internal System.Windows.Forms.Label Label4;
      internal System.Windows.Forms.Label Label8;
      internal System.Windows.Forms.Label Label10;
      internal System.Windows.Forms.Label Label12;
      internal System.Windows.Forms.PictureBox PictureBox2;
      internal System.Windows.Forms.PictureBox PictureBox3;
      internal System.Windows.Forms.GroupBox GroupBox2;
      internal System.Windows.Forms.Label Label14;
      internal System.Windows.Forms.Label Label18;
      internal System.Windows.Forms.GroupBox GroupBox3;
      internal System.Windows.Forms.Label Label16;
      internal System.Windows.Forms.Label Label20;
      internal System.Windows.Forms.GroupBox GroupBox4;
      internal System.Windows.Forms.ComboBox cmbTFlowBars;
      internal System.Windows.Forms.Label lblRPSymbol;
      internal System.Windows.Forms.Label lblRPRangeEnd;
      internal System.Windows.Forms.Label lblRPRangeStart;
      internal System.Windows.Forms.Label lblOEnd;
      internal System.Windows.Forms.Label lblOStart;
      internal System.Windows.Forms.Label lblStatus;
      internal System.Windows.Forms.TextBox txtTagName;
      internal System.Windows.Forms.TextBox txtTagValue;
      internal System.Windows.Forms.Button btnRequest;
      internal System.Windows.Forms.Button btnRemove;
      internal System.Windows.Forms.Button btnRemoveAll;
      internal System.Windows.Forms.GroupBox GroupBox5;
      internal System.Windows.Forms.Label Label2;
      internal System.Windows.Forms.GroupBox gbIndexInterval;
      internal System.Windows.Forms.Label Label3;
      internal System.Windows.Forms.Button btnShow;
      internal System.Windows.Forms.NumericUpDown nudEnd;
      internal System.Windows.Forms.NumericUpDown nudStart;
      internal System.Windows.Forms.GroupBox GroupBox6;
      internal System.Windows.Forms.Label lblError;
      internal System.Windows.Forms.ColumnHeader ColumnHeader1;
      internal System.Windows.Forms.ColumnHeader ColumnHeader2;
      internal System.Windows.Forms.ColumnHeader ColumnHeader3;
      internal System.Windows.Forms.ColumnHeader ColumnHeader4;
      internal System.Windows.Forms.ColumnHeader ColumnHeader5;
      internal System.Windows.Forms.ColumnHeader ColumnHeader6;
      internal System.Windows.Forms.ColumnHeader ColumnHeader7;
      internal System.Windows.Forms.ColumnHeader ColumnHeader8;
      internal System.Windows.Forms.ColumnHeader ColumnHeader9;
      internal System.Windows.Forms.ColumnHeader ColumnHeader10;
      internal System.Windows.Forms.ColumnHeader ColumnHeader11;
      internal System.Windows.Forms.ColumnHeader ColumnHeader12;
      internal System.Windows.Forms.ColumnHeader ColumnHeader27;
      internal System.Windows.Forms.ColumnHeader ColumnHeader28;
      internal System.Windows.Forms.ListView lvTFlowBars;
      internal System.Windows.Forms.Label Label1;
      internal System.Windows.Forms.Label Label6;
      internal System.Windows.Forms.Label Label9;
      internal System.Windows.Forms.Label Label13;
      internal System.Windows.Forms.Label Label17;
      internal System.Windows.Forms.Label Label21;
      internal System.Windows.Forms.Label Label23;
      internal System.Windows.Forms.Label Label25;
      internal System.Windows.Forms.Label Label27;
      internal System.Windows.Forms.Label Label29;
      internal System.Windows.Forms.Label lblRPSessionFlags;
      internal System.Windows.Forms.Label lblRPIncludeEnd;
      internal System.Windows.Forms.Label lblRPUpdatesEnabled;
      internal System.Windows.Forms.Label lblRPContinuation;
      internal System.Windows.Forms.Label lblRPSessionsFilter;
      internal System.Windows.Forms.Label lblRPDaysBeforeExpiration;
      internal System.Windows.Forms.Label lblRPEqualizeCloses;
      internal System.Windows.Forms.Label lblRPAggregationLevel;
      internal System.Windows.Forms.Label lblRPAggregation;
      internal System.Windows.Forms.Label lblRPDomBidVolumeLevel;
      internal System.Windows.Forms.Label lblRPDomAskVolumeLevel;
      internal System.Windows.Forms.ColumnHeader ColumnHeader29;
      internal System.Windows.Forms.ColumnHeader ColumnHeader30;
      internal System.Windows.Forms.ColumnHeader ColumnHeader31;
      internal System.Windows.Forms.ListView lvShownTFlowBars;
      internal System.Windows.Forms.ColumnHeader ColumnHeader32;
      internal System.Windows.Forms.ColumnHeader ColumnHeader33;
      internal System.Windows.Forms.ColumnHeader ColumnHeader34;
      internal System.Windows.Forms.ColumnHeader ColumnHeader35;
      internal System.Windows.Forms.ColumnHeader ColumnHeader36;
      internal System.Windows.Forms.ColumnHeader ColumnHeader37;
      internal System.Windows.Forms.ColumnHeader ColumnHeader38;
      internal System.Windows.Forms.ColumnHeader ColumnHeader39;
      internal System.Windows.Forms.ColumnHeader ColumnHeader40;
      internal System.Windows.Forms.ColumnHeader ColumnHeader41;
      internal System.Windows.Forms.ColumnHeader ColumnHeader42;
      internal System.Windows.Forms.ColumnHeader ColumnHeader43;
      internal System.Windows.Forms.ColumnHeader ColumnHeader44;
      internal System.Windows.Forms.ColumnHeader ColumnHeader45;
      internal System.Windows.Forms.ColumnHeader ColumnHeader46;
      internal System.Windows.Forms.ColumnHeader ColumnHeader47;
      internal System.Windows.Forms.ColumnHeader ColumnHeader48;
      internal System.Windows.Forms.Label lblRPRecalcPeriod;
      internal System.Windows.Forms.Label label19;
      internal System.Windows.Forms.Label lblRPSubscriptionLevel;
      internal System.Windows.Forms.Label label30;
      [System.Diagnostics.DebuggerStepThrough()]
      private void InitializeComponent()
      {
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.PictureBox1 = new System.Windows.Forms.PictureBox();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.cmbTFlowBars = new System.Windows.Forms.ComboBox();
         this.btnRequest = new System.Windows.Forms.Button();
         this.btnRemove = new System.Windows.Forms.Button();
         this.btnRemoveAll = new System.Windows.Forms.Button();
         this.lblStatus = new System.Windows.Forms.Label();
         this.GroupBox1 = new System.Windows.Forms.GroupBox();
         this.lblRPRecalcPeriod = new System.Windows.Forms.Label();
         this.label19 = new System.Windows.Forms.Label();
         this.lblRPSubscriptionLevel = new System.Windows.Forms.Label();
         this.label30 = new System.Windows.Forms.Label();
         this.lblRPDaysBeforeExpiration = new System.Windows.Forms.Label();
         this.Label27 = new System.Windows.Forms.Label();
         this.lblRPEqualizeCloses = new System.Windows.Forms.Label();
         this.Label29 = new System.Windows.Forms.Label();
         this.lblRPContinuation = new System.Windows.Forms.Label();
         this.Label23 = new System.Windows.Forms.Label();
         this.lblRPSessionsFilter = new System.Windows.Forms.Label();
         this.Label25 = new System.Windows.Forms.Label();
         this.lblRPIncludeEnd = new System.Windows.Forms.Label();
         this.Label17 = new System.Windows.Forms.Label();
         this.lblRPUpdatesEnabled = new System.Windows.Forms.Label();
         this.Label21 = new System.Windows.Forms.Label();
         this.lblRPAggregationLevel = new System.Windows.Forms.Label();
         this.Label9 = new System.Windows.Forms.Label();
         this.lblRPAggregation = new System.Windows.Forms.Label();
         this.Label13 = new System.Windows.Forms.Label();
         this.lblRPRangeEnd = new System.Windows.Forms.Label();
         this.Label12 = new System.Windows.Forms.Label();
         this.lblRPSessionFlags = new System.Windows.Forms.Label();
         this.Label10 = new System.Windows.Forms.Label();
         this.lblRPRangeStart = new System.Windows.Forms.Label();
         this.Label8 = new System.Windows.Forms.Label();
         this.lblRPSymbol = new System.Windows.Forms.Label();
         this.Label4 = new System.Windows.Forms.Label();
         this.lblRPDomBidVolumeLevel = new System.Windows.Forms.Label();
         this.lblRPDomAskVolumeLevel = new System.Windows.Forms.Label();
         this.Label6 = new System.Windows.Forms.Label();
         this.Label1 = new System.Windows.Forms.Label();
         this.PictureBox2 = new System.Windows.Forms.PictureBox();
         this.PictureBox3 = new System.Windows.Forms.PictureBox();
         this.GroupBox2 = new System.Windows.Forms.GroupBox();
         this.txtTagValue = new System.Windows.Forms.TextBox();
         this.txtTagName = new System.Windows.Forms.TextBox();
         this.Label14 = new System.Windows.Forms.Label();
         this.Label18 = new System.Windows.Forms.Label();
         this.GroupBox3 = new System.Windows.Forms.GroupBox();
         this.lblOEnd = new System.Windows.Forms.Label();
         this.Label16 = new System.Windows.Forms.Label();
         this.lblOStart = new System.Windows.Forms.Label();
         this.Label20 = new System.Windows.Forms.Label();
         this.GroupBox4 = new System.Windows.Forms.GroupBox();
         this.lvTFlowBars = new System.Windows.Forms.ListView();
         this.ColumnHeader1 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader2 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader3 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader4 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader5 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader6 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader7 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader8 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader9 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader10 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader11 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader12 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader27 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader28 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader29 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader30 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader31 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.GroupBox5 = new System.Windows.Forms.GroupBox();
         this.lvShownTFlowBars = new System.Windows.Forms.ListView();
         this.ColumnHeader32 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader33 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader34 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader35 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader36 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader37 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader38 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader39 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader40 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader41 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader42 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader43 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader44 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader45 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader46 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader47 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader48 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.btnShow = new System.Windows.Forms.Button();
         this.gbIndexInterval = new System.Windows.Forms.GroupBox();
         this.Label3 = new System.Windows.Forms.Label();
         this.nudEnd = new System.Windows.Forms.NumericUpDown();
         this.Label2 = new System.Windows.Forms.Label();
         this.nudStart = new System.Windows.Forms.NumericUpDown();
         this.GroupBox6 = new System.Windows.Forms.GroupBox();
         this.lblError = new System.Windows.Forms.Label();
         this.columnHeader13 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.columnHeader14 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.columnHeader15 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.columnHeader16 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox1)).BeginInit();
         this.GroupBox1.SuspendLayout();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox2)).BeginInit();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox3)).BeginInit();
         this.GroupBox2.SuspendLayout();
         this.GroupBox3.SuspendLayout();
         this.GroupBox4.SuspendLayout();
         this.GroupBox5.SuspendLayout();
         this.gbIndexInterval.SuspendLayout();
         ((System.ComponentModel.ISupportInitialize)(this.nudEnd)).BeginInit();
         ((System.ComponentModel.ISupportInitialize)(this.nudStart)).BeginInit();
         this.GroupBox6.SuspendLayout();
         this.SuspendLayout();
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
         this.lblDataConnection.TabIndex = 24;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // PictureBox1
         // 
         this.PictureBox1.BackColor = System.Drawing.Color.Black;
         this.PictureBox1.Location = new System.Drawing.Point(0, 40);
         this.PictureBox1.Name = "PictureBox1";
         this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
         this.PictureBox1.TabIndex = 23;
         this.PictureBox1.TabStop = false;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.SystemColors.Control;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
         this.llWeb.Location = new System.Drawing.Point(632, 8);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(408, 16);
         this.llWeb.TabIndex = 25;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.UseCompatibleTextRendering = true;
         // 
         // cmbTFlowBars
         // 
         this.cmbTFlowBars.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbTFlowBars.Location = new System.Drawing.Point(16, 56);
         this.cmbTFlowBars.Name = "cmbTFlowBars";
         this.cmbTFlowBars.Size = new System.Drawing.Size(448, 24);
         this.cmbTFlowBars.TabIndex = 0;
         this.cmbTFlowBars.SelectedIndexChanged += new System.EventHandler(this.cmbTFlowBars_SelectedIndexChanged);
         // 
         // btnRequest
         // 
         this.btnRequest.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnRequest.Location = new System.Drawing.Point(16, 88);
         this.btnRequest.Name = "btnRequest";
         this.btnRequest.Size = new System.Drawing.Size(96, 40);
         this.btnRequest.TabIndex = 1;
         this.btnRequest.Text = "Request";
         this.btnRequest.Click += new System.EventHandler(this.btnRequest_Click);
         // 
         // btnRemove
         // 
         this.btnRemove.Enabled = false;
         this.btnRemove.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnRemove.Location = new System.Drawing.Point(120, 88);
         this.btnRemove.Name = "btnRemove";
         this.btnRemove.Size = new System.Drawing.Size(96, 40);
         this.btnRemove.TabIndex = 2;
         this.btnRemove.Text = "Remove";
         this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
         // 
         // btnRemoveAll
         // 
         this.btnRemoveAll.Enabled = false;
         this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnRemoveAll.Location = new System.Drawing.Point(224, 88);
         this.btnRemoveAll.Name = "btnRemoveAll";
         this.btnRemoveAll.Size = new System.Drawing.Size(96, 40);
         this.btnRemoveAll.TabIndex = 3;
         this.btnRemoveAll.Text = "Remove All";
         this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
         // 
         // lblStatus
         // 
         this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblStatus.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblStatus.Location = new System.Drawing.Point(8, 16);
         this.lblStatus.Name = "lblStatus";
         this.lblStatus.Size = new System.Drawing.Size(120, 24);
         this.lblStatus.TabIndex = 31;
         this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // GroupBox1
         // 
         this.GroupBox1.Controls.Add(this.lblRPRecalcPeriod);
         this.GroupBox1.Controls.Add(this.label19);
         this.GroupBox1.Controls.Add(this.lblRPSubscriptionLevel);
         this.GroupBox1.Controls.Add(this.label30);
         this.GroupBox1.Controls.Add(this.lblRPDaysBeforeExpiration);
         this.GroupBox1.Controls.Add(this.Label27);
         this.GroupBox1.Controls.Add(this.lblRPEqualizeCloses);
         this.GroupBox1.Controls.Add(this.Label29);
         this.GroupBox1.Controls.Add(this.lblRPContinuation);
         this.GroupBox1.Controls.Add(this.Label23);
         this.GroupBox1.Controls.Add(this.lblRPSessionsFilter);
         this.GroupBox1.Controls.Add(this.Label25);
         this.GroupBox1.Controls.Add(this.lblRPIncludeEnd);
         this.GroupBox1.Controls.Add(this.Label17);
         this.GroupBox1.Controls.Add(this.lblRPUpdatesEnabled);
         this.GroupBox1.Controls.Add(this.Label21);
         this.GroupBox1.Controls.Add(this.lblRPAggregationLevel);
         this.GroupBox1.Controls.Add(this.Label9);
         this.GroupBox1.Controls.Add(this.lblRPAggregation);
         this.GroupBox1.Controls.Add(this.Label13);
         this.GroupBox1.Controls.Add(this.lblRPRangeEnd);
         this.GroupBox1.Controls.Add(this.Label12);
         this.GroupBox1.Controls.Add(this.lblRPSessionFlags);
         this.GroupBox1.Controls.Add(this.Label10);
         this.GroupBox1.Controls.Add(this.lblRPRangeStart);
         this.GroupBox1.Controls.Add(this.Label8);
         this.GroupBox1.Controls.Add(this.lblRPSymbol);
         this.GroupBox1.Controls.Add(this.Label4);
         this.GroupBox1.Controls.Add(this.lblRPDomBidVolumeLevel);
         this.GroupBox1.Controls.Add(this.lblRPDomAskVolumeLevel);
         this.GroupBox1.Controls.Add(this.Label6);
         this.GroupBox1.Controls.Add(this.Label1);
         this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox1.Location = new System.Drawing.Point(480, 48);
         this.GroupBox1.Name = "GroupBox1";
         this.GroupBox1.Size = new System.Drawing.Size(584, 312);
         this.GroupBox1.TabIndex = 32;
         this.GroupBox1.TabStop = false;
         this.GroupBox1.Text = "Request Parameters";
         // 
         // lblRPRecalcPeriod
         // 
         this.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPRecalcPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPRecalcPeriod.Location = new System.Drawing.Point(440, 216);
         this.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod";
         this.lblRPRecalcPeriod.Size = new System.Drawing.Size(136, 24);
         this.lblRPRecalcPeriod.TabIndex = 76;
         this.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // label19
         // 
         this.label19.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.label19.Location = new System.Drawing.Point(328, 216);
         this.label19.Name = "label19";
         this.label19.Size = new System.Drawing.Size(104, 24);
         this.label19.TabIndex = 75;
         this.label19.Text = "Recalc Period :";
         this.label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPSubscriptionLevel
         // 
         this.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPSubscriptionLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPSubscriptionLevel.Location = new System.Drawing.Point(152, 216);
         this.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel";
         this.lblRPSubscriptionLevel.Size = new System.Drawing.Size(152, 24);
         this.lblRPSubscriptionLevel.TabIndex = 74;
         this.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // label30
         // 
         this.label30.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.label30.Location = new System.Drawing.Point(8, 216);
         this.label30.Name = "label30";
         this.label30.Size = new System.Drawing.Size(136, 24);
         this.label30.TabIndex = 73;
         this.label30.Text = "Subscription Level :";
         this.label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPDaysBeforeExpiration
         // 
         this.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPDaysBeforeExpiration.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPDaysBeforeExpiration.Location = new System.Drawing.Point(440, 184);
         this.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration";
         this.lblRPDaysBeforeExpiration.Size = new System.Drawing.Size(136, 24);
         this.lblRPDaysBeforeExpiration.TabIndex = 57;
         this.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label27
         // 
         this.Label27.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label27.Location = new System.Drawing.Point(304, 184);
         this.Label27.Name = "Label27";
         this.Label27.Size = new System.Drawing.Size(128, 24);
         this.Label27.TabIndex = 56;
         this.Label27.Text = "Days Before Exp. :";
         this.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPEqualizeCloses
         // 
         this.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPEqualizeCloses.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPEqualizeCloses.Location = new System.Drawing.Point(152, 184);
         this.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses";
         this.lblRPEqualizeCloses.Size = new System.Drawing.Size(152, 24);
         this.lblRPEqualizeCloses.TabIndex = 55;
         this.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label29
         // 
         this.Label29.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label29.Location = new System.Drawing.Point(24, 184);
         this.Label29.Name = "Label29";
         this.Label29.Size = new System.Drawing.Size(120, 24);
         this.Label29.TabIndex = 54;
         this.Label29.Text = "Equalize Closes :";
         this.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPContinuation
         // 
         this.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPContinuation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPContinuation.Location = new System.Drawing.Point(440, 152);
         this.lblRPContinuation.Name = "lblRPContinuation";
         this.lblRPContinuation.Size = new System.Drawing.Size(136, 24);
         this.lblRPContinuation.TabIndex = 53;
         this.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label23
         // 
         this.Label23.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label23.Location = new System.Drawing.Point(336, 152);
         this.Label23.Name = "Label23";
         this.Label23.Size = new System.Drawing.Size(96, 24);
         this.Label23.TabIndex = 52;
         this.Label23.Text = "Continuation :";
         this.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPSessionsFilter
         // 
         this.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPSessionsFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPSessionsFilter.Location = new System.Drawing.Point(152, 248);
         this.lblRPSessionsFilter.Name = "lblRPSessionsFilter";
         this.lblRPSessionsFilter.Size = new System.Drawing.Size(152, 24);
         this.lblRPSessionsFilter.TabIndex = 51;
         this.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label25
         // 
         this.Label25.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label25.Location = new System.Drawing.Point(32, 248);
         this.Label25.Name = "Label25";
         this.Label25.Size = new System.Drawing.Size(112, 24);
         this.Label25.TabIndex = 50;
         this.Label25.Text = "Sessions Filter :";
         this.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPIncludeEnd
         // 
         this.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPIncludeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPIncludeEnd.Location = new System.Drawing.Point(440, 120);
         this.lblRPIncludeEnd.Name = "lblRPIncludeEnd";
         this.lblRPIncludeEnd.Size = new System.Drawing.Size(136, 24);
         this.lblRPIncludeEnd.TabIndex = 49;
         this.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label17
         // 
         this.Label17.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label17.Location = new System.Drawing.Point(336, 120);
         this.Label17.Name = "Label17";
         this.Label17.Size = new System.Drawing.Size(96, 24);
         this.Label17.TabIndex = 48;
         this.Label17.Text = "Include End :";
         this.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPUpdatesEnabled
         // 
         this.lblRPUpdatesEnabled.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPUpdatesEnabled.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPUpdatesEnabled.Location = new System.Drawing.Point(152, 120);
         this.lblRPUpdatesEnabled.Name = "lblRPUpdatesEnabled";
         this.lblRPUpdatesEnabled.Size = new System.Drawing.Size(152, 24);
         this.lblRPUpdatesEnabled.TabIndex = 47;
         this.lblRPUpdatesEnabled.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label21
         // 
         this.Label21.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label21.Location = new System.Drawing.Point(24, 120);
         this.Label21.Name = "Label21";
         this.Label21.Size = new System.Drawing.Size(124, 24);
         this.Label21.TabIndex = 46;
         this.Label21.Text = "Updates Enabled :";
         this.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPAggregationLevel
         // 
         this.lblRPAggregationLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPAggregationLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPAggregationLevel.Location = new System.Drawing.Point(440, 88);
         this.lblRPAggregationLevel.Name = "lblRPAggregationLevel";
         this.lblRPAggregationLevel.Size = new System.Drawing.Size(136, 24);
         this.lblRPAggregationLevel.TabIndex = 45;
         this.lblRPAggregationLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label9
         // 
         this.Label9.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label9.Location = new System.Drawing.Point(304, 88);
         this.Label9.Name = "Label9";
         this.Label9.Size = new System.Drawing.Size(132, 24);
         this.Label9.TabIndex = 44;
         this.Label9.Text = "Aggregation Level :";
         this.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPAggregation
         // 
         this.lblRPAggregation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPAggregation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPAggregation.Location = new System.Drawing.Point(152, 88);
         this.lblRPAggregation.Name = "lblRPAggregation";
         this.lblRPAggregation.Size = new System.Drawing.Size(152, 24);
         this.lblRPAggregation.TabIndex = 43;
         this.lblRPAggregation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label13
         // 
         this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label13.Location = new System.Drawing.Point(24, 88);
         this.Label13.Name = "Label13";
         this.Label13.Size = new System.Drawing.Size(120, 24);
         this.Label13.TabIndex = 42;
         this.Label13.Text = "Aggregation :";
         this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPRangeEnd
         // 
         this.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPRangeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPRangeEnd.Location = new System.Drawing.Point(440, 56);
         this.lblRPRangeEnd.Name = "lblRPRangeEnd";
         this.lblRPRangeEnd.Size = new System.Drawing.Size(136, 24);
         this.lblRPRangeEnd.TabIndex = 41;
         this.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label12
         // 
         this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label12.Location = new System.Drawing.Point(344, 56);
         this.Label12.Name = "Label12";
         this.Label12.Size = new System.Drawing.Size(88, 24);
         this.Label12.TabIndex = 40;
         this.Label12.Text = "Range End :";
         this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPSessionFlags
         // 
         this.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPSessionFlags.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPSessionFlags.Location = new System.Drawing.Point(152, 152);
         this.lblRPSessionFlags.Name = "lblRPSessionFlags";
         this.lblRPSessionFlags.Size = new System.Drawing.Size(152, 24);
         this.lblRPSessionFlags.TabIndex = 39;
         this.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label10
         // 
         this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label10.Location = new System.Drawing.Point(32, 152);
         this.Label10.Name = "Label10";
         this.Label10.Size = new System.Drawing.Size(112, 24);
         this.Label10.TabIndex = 38;
         this.Label10.Text = "Session Flags :";
         this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPRangeStart
         // 
         this.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPRangeStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPRangeStart.Location = new System.Drawing.Point(152, 56);
         this.lblRPRangeStart.Name = "lblRPRangeStart";
         this.lblRPRangeStart.Size = new System.Drawing.Size(152, 24);
         this.lblRPRangeStart.TabIndex = 37;
         this.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label8
         // 
         this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label8.Location = new System.Drawing.Point(24, 56);
         this.Label8.Name = "Label8";
         this.Label8.Size = new System.Drawing.Size(120, 24);
         this.Label8.TabIndex = 36;
         this.Label8.Text = "Range Start :";
         this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPSymbol
         // 
         this.lblRPSymbol.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPSymbol.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPSymbol.Location = new System.Drawing.Point(152, 24);
         this.lblRPSymbol.Name = "lblRPSymbol";
         this.lblRPSymbol.Size = new System.Drawing.Size(152, 24);
         this.lblRPSymbol.TabIndex = 33;
         this.lblRPSymbol.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label4
         // 
         this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label4.Location = new System.Drawing.Point(64, 24);
         this.Label4.Name = "Label4";
         this.Label4.Size = new System.Drawing.Size(80, 24);
         this.Label4.TabIndex = 32;
         this.Label4.Text = "Symbol :";
         this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPDomBidVolumeLevel
         // 
         this.lblRPDomBidVolumeLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPDomBidVolumeLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPDomBidVolumeLevel.Location = new System.Drawing.Point(152, 280);
         this.lblRPDomBidVolumeLevel.Name = "lblRPDomBidVolumeLevel";
         this.lblRPDomBidVolumeLevel.Size = new System.Drawing.Size(152, 24);
         this.lblRPDomBidVolumeLevel.TabIndex = 51;
         this.lblRPDomBidVolumeLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // lblRPDomAskVolumeLevel
         // 
         this.lblRPDomAskVolumeLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPDomAskVolumeLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPDomAskVolumeLevel.Location = new System.Drawing.Point(440, 280);
         this.lblRPDomAskVolumeLevel.Name = "lblRPDomAskVolumeLevel";
         this.lblRPDomAskVolumeLevel.Size = new System.Drawing.Size(136, 24);
         this.lblRPDomAskVolumeLevel.TabIndex = 76;
         this.lblRPDomAskVolumeLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label6
         // 
         this.Label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label6.Location = new System.Drawing.Point(288, 264);
         this.Label6.Name = "Label6";
         this.Label6.Size = new System.Drawing.Size(144, 40);
         this.Label6.TabIndex = 75;
         this.Label6.Text = "DomAskVolume level:";
         this.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // Label1
         // 
         this.Label1.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label1.Location = new System.Drawing.Point(16, 272);
         this.Label1.Name = "Label1";
         this.Label1.Size = new System.Drawing.Size(128, 32);
         this.Label1.TabIndex = 50;
         this.Label1.Text = "DomBidVolume level:";
         this.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // PictureBox2
         // 
         this.PictureBox2.BackColor = System.Drawing.Color.Black;
         this.PictureBox2.Location = new System.Drawing.Point(-96, 368);
         this.PictureBox2.Name = "PictureBox2";
         this.PictureBox2.Size = new System.Drawing.Size(1272, 1);
         this.PictureBox2.TabIndex = 33;
         this.PictureBox2.TabStop = false;
         // 
         // PictureBox3
         // 
         this.PictureBox3.BackColor = System.Drawing.Color.Black;
         this.PictureBox3.Location = new System.Drawing.Point(-96, 448);
         this.PictureBox3.Name = "PictureBox3";
         this.PictureBox3.Size = new System.Drawing.Size(1272, 3);
         this.PictureBox3.TabIndex = 34;
         this.PictureBox3.TabStop = false;
         // 
         // GroupBox2
         // 
         this.GroupBox2.Controls.Add(this.txtTagValue);
         this.GroupBox2.Controls.Add(this.txtTagName);
         this.GroupBox2.Controls.Add(this.Label14);
         this.GroupBox2.Controls.Add(this.Label18);
         this.GroupBox2.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox2.Location = new System.Drawing.Point(8, 376);
         this.GroupBox2.Name = "GroupBox2";
         this.GroupBox2.Size = new System.Drawing.Size(472, 59);
         this.GroupBox2.TabIndex = 4;
         this.GroupBox2.TabStop = false;
         this.GroupBox2.Text = "Tags";
         // 
         // txtTagValue
         // 
         this.txtTagValue.Location = new System.Drawing.Point(312, 24);
         this.txtTagValue.Name = "txtTagValue";
         this.txtTagValue.Size = new System.Drawing.Size(144, 25);
         this.txtTagValue.TabIndex = 1;
         this.txtTagValue.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagValue_KeyDown);
         // 
         // txtTagName
         // 
         this.txtTagName.Location = new System.Drawing.Point(72, 24);
         this.txtTagName.Name = "txtTagName";
         this.txtTagName.Size = new System.Drawing.Size(144, 25);
         this.txtTagName.TabIndex = 0;
         this.txtTagName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagName_KeyDown);
         // 
         // Label14
         // 
         this.Label14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label14.Location = new System.Drawing.Point(248, 24);
         this.Label14.Name = "Label14";
         this.Label14.Size = new System.Drawing.Size(56, 24);
         this.Label14.TabIndex = 40;
         this.Label14.Text = "Value :";
         this.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // Label18
         // 
         this.Label18.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label18.Location = new System.Drawing.Point(8, 24);
         this.Label18.Name = "Label18";
         this.Label18.Size = new System.Drawing.Size(56, 24);
         this.Label18.TabIndex = 36;
         this.Label18.Text = "Name :";
         this.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // GroupBox3
         // 
         this.GroupBox3.Controls.Add(this.lblOEnd);
         this.GroupBox3.Controls.Add(this.Label16);
         this.GroupBox3.Controls.Add(this.lblOStart);
         this.GroupBox3.Controls.Add(this.Label20);
         this.GroupBox3.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox3.Location = new System.Drawing.Point(488, 376);
         this.GroupBox3.Name = "GroupBox3";
         this.GroupBox3.Size = new System.Drawing.Size(576, 59);
         this.GroupBox3.TabIndex = 42;
         this.GroupBox3.TabStop = false;
         this.GroupBox3.Text = "Output Parameters";
         // 
         // lblOEnd
         // 
         this.lblOEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblOEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblOEnd.Location = new System.Drawing.Point(400, 24);
         this.lblOEnd.Name = "lblOEnd";
         this.lblOEnd.Size = new System.Drawing.Size(136, 24);
         this.lblOEnd.TabIndex = 41;
         this.lblOEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label16
         // 
         this.Label16.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label16.Location = new System.Drawing.Point(320, 24);
         this.Label16.Name = "Label16";
         this.Label16.Size = new System.Drawing.Size(72, 24);
         this.Label16.TabIndex = 40;
         this.Label16.Text = "End :";
         this.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblOStart
         // 
         this.lblOStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblOStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblOStart.Location = new System.Drawing.Point(136, 24);
         this.lblOStart.Name = "lblOStart";
         this.lblOStart.Size = new System.Drawing.Size(128, 24);
         this.lblOStart.TabIndex = 37;
         this.lblOStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label20
         // 
         this.Label20.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label20.Location = new System.Drawing.Point(56, 24);
         this.Label20.Name = "Label20";
         this.Label20.Size = new System.Drawing.Size(72, 24);
         this.Label20.TabIndex = 36;
         this.Label20.Text = "Start :";
         this.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // GroupBox4
         // 
         this.GroupBox4.Controls.Add(this.lvTFlowBars);
         this.GroupBox4.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox4.Location = new System.Drawing.Point(8, 456);
         this.GroupBox4.Name = "GroupBox4";
         this.GroupBox4.Size = new System.Drawing.Size(1056, 136);
         this.GroupBox4.TabIndex = 5;
         this.GroupBox4.TabStop = false;
         this.GroupBox4.Text = "Last 5 Resolved TFlowBars";
         // 
         // lvTFlowBars
         // 
         this.lvTFlowBars.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.ColumnHeader1,
            this.ColumnHeader2,
            this.ColumnHeader3,
            this.ColumnHeader4,
            this.ColumnHeader5,
            this.ColumnHeader6,
            this.ColumnHeader7,
            this.ColumnHeader8,
            this.ColumnHeader9,
            this.ColumnHeader10,
            this.ColumnHeader11,
            this.ColumnHeader12,
            this.ColumnHeader27,
            this.ColumnHeader28,
            this.ColumnHeader29,
            this.ColumnHeader30,
            this.ColumnHeader31,
            this.columnHeader13,
            this.columnHeader14,
            this.columnHeader15,
            this.columnHeader16});
         this.lvTFlowBars.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lvTFlowBars.FullRowSelect = true;
         this.lvTFlowBars.GridLines = true;
         this.lvTFlowBars.Location = new System.Drawing.Point(8, 20);
         this.lvTFlowBars.MultiSelect = false;
         this.lvTFlowBars.Name = "lvTFlowBars";
         this.lvTFlowBars.Size = new System.Drawing.Size(1040, 108);
         this.lvTFlowBars.TabIndex = 7;
         this.lvTFlowBars.UseCompatibleStateImageBehavior = false;
         this.lvTFlowBars.View = System.Windows.Forms.View.Details;
         // 
         // ColumnHeader1
         // 
         this.ColumnHeader1.Text = "";
         this.ColumnHeader1.Width = 0;
         // 
         // ColumnHeader2
         // 
         this.ColumnHeader2.Text = "Index";
         this.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader2.Width = 49;
         // 
         // ColumnHeader3
         // 
         this.ColumnHeader3.Text = "Timestamp";
         this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader3.Width = 162;
         // 
         // ColumnHeader4
         // 
         this.ColumnHeader4.Text = "Open";
         this.ColumnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader4.Width = 62;
         // 
         // ColumnHeader5
         // 
         this.ColumnHeader5.Text = "High";
         this.ColumnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader5.Width = 64;
         // 
         // ColumnHeader6
         // 
         this.ColumnHeader6.Text = "Low";
         this.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader6.Width = 63;
         // 
         // ColumnHeader7
         // 
         this.ColumnHeader7.Text = "Close";
         this.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader7.Width = 66;
         // 
         // ColumnHeader8
         // 
         this.ColumnHeader8.Text = "Mid";
         this.ColumnHeader8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader8.Width = 66;
         // 
         // ColumnHeader9
         // 
         this.ColumnHeader9.Text = "TrueHigh";
         this.ColumnHeader9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader9.Width = 66;
         // 
         // ColumnHeader10
         // 
         this.ColumnHeader10.Text = "TrueLow";
         this.ColumnHeader10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader10.Width = 65;
         // 
         // ColumnHeader11
         // 
         this.ColumnHeader11.Text = "TrueMid";
         this.ColumnHeader11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader11.Width = 66;
         // 
         // ColumnHeader12
         // 
         this.ColumnHeader12.Text = "AskVolume";
         this.ColumnHeader12.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader12.Width = 79;
         // 
         // ColumnHeader27
         // 
         this.ColumnHeader27.Text = "BidVolume";
         this.ColumnHeader27.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader27.Width = 75;
         // 
         // ColumnHeader28
         // 
         this.ColumnHeader28.Text = "BestAskPrice";
         this.ColumnHeader28.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader28.Width = 100;
         // 
         // ColumnHeader29
         // 
         this.ColumnHeader29.Text = "BestBidPrice";
         this.ColumnHeader29.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader29.Width = 100;
         // 
         // ColumnHeader30
         // 
         this.ColumnHeader30.Text = "DomBidVolume";
         this.ColumnHeader30.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader30.Width = 100;
         // 
         // ColumnHeader31
         // 
         this.ColumnHeader31.Text = "DomAskVolume";
         this.ColumnHeader31.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader31.Width = 100;
         // 
         // GroupBox5
         // 
         this.GroupBox5.Controls.Add(this.lvShownTFlowBars);
         this.GroupBox5.Controls.Add(this.btnShow);
         this.GroupBox5.Controls.Add(this.gbIndexInterval);
         this.GroupBox5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox5.Location = new System.Drawing.Point(8, 592);
         this.GroupBox5.Name = "GroupBox5";
         this.GroupBox5.Size = new System.Drawing.Size(1056, 216);
         this.GroupBox5.TabIndex = 6;
         this.GroupBox5.TabStop = false;
         this.GroupBox5.Text = "TFlowBars Filtered by Index";
         // 
         // lvShownTFlowBars
         // 
         this.lvShownTFlowBars.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.ColumnHeader32,
            this.ColumnHeader33,
            this.ColumnHeader34,
            this.ColumnHeader35,
            this.ColumnHeader36,
            this.ColumnHeader37,
            this.ColumnHeader38,
            this.ColumnHeader39,
            this.ColumnHeader40,
            this.ColumnHeader41,
            this.ColumnHeader42,
            this.ColumnHeader43,
            this.ColumnHeader44,
            this.ColumnHeader45,
            this.ColumnHeader46,
            this.ColumnHeader47,
            this.ColumnHeader48});
         this.lvShownTFlowBars.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lvShownTFlowBars.FullRowSelect = true;
         this.lvShownTFlowBars.GridLines = true;
         this.lvShownTFlowBars.Location = new System.Drawing.Point(8, 80);
         this.lvShownTFlowBars.MultiSelect = false;
         this.lvShownTFlowBars.Name = "lvShownTFlowBars";
         this.lvShownTFlowBars.Size = new System.Drawing.Size(1040, 128);
         this.lvShownTFlowBars.TabIndex = 8;
         this.lvShownTFlowBars.UseCompatibleStateImageBehavior = false;
         this.lvShownTFlowBars.View = System.Windows.Forms.View.Details;
         // 
         // ColumnHeader32
         // 
         this.ColumnHeader32.Text = "";
         this.ColumnHeader32.Width = 0;
         // 
         // ColumnHeader33
         // 
         this.ColumnHeader33.Text = "Index";
         this.ColumnHeader33.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader33.Width = 49;
         // 
         // ColumnHeader34
         // 
         this.ColumnHeader34.Text = "Timestamp";
         this.ColumnHeader34.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader34.Width = 162;
         // 
         // ColumnHeader35
         // 
         this.ColumnHeader35.Text = "Open";
         this.ColumnHeader35.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader35.Width = 62;
         // 
         // ColumnHeader36
         // 
         this.ColumnHeader36.Text = "High";
         this.ColumnHeader36.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader36.Width = 64;
         // 
         // ColumnHeader37
         // 
         this.ColumnHeader37.Text = "Low";
         this.ColumnHeader37.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader37.Width = 63;
         // 
         // ColumnHeader38
         // 
         this.ColumnHeader38.Text = "Close";
         this.ColumnHeader38.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader38.Width = 66;
         // 
         // ColumnHeader39
         // 
         this.ColumnHeader39.Text = "Mid";
         this.ColumnHeader39.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader39.Width = 66;
         // 
         // ColumnHeader40
         // 
         this.ColumnHeader40.Text = "TrueHigh";
         this.ColumnHeader40.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader40.Width = 66;
         // 
         // ColumnHeader41
         // 
         this.ColumnHeader41.Text = "TrueLow";
         this.ColumnHeader41.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader41.Width = 65;
         // 
         // ColumnHeader42
         // 
         this.ColumnHeader42.Text = "TrueMid";
         this.ColumnHeader42.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader42.Width = 66;
         // 
         // ColumnHeader43
         // 
         this.ColumnHeader43.Text = "AskVolume";
         this.ColumnHeader43.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader43.Width = 79;
         // 
         // ColumnHeader44
         // 
         this.ColumnHeader44.Text = "BidVolume";
         this.ColumnHeader44.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader44.Width = 75;
         // 
         // ColumnHeader45
         // 
         this.ColumnHeader45.Text = "BestAskPrice";
         this.ColumnHeader45.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader45.Width = 100;
         // 
         // ColumnHeader46
         // 
         this.ColumnHeader46.Text = "BestBidPrice";
         this.ColumnHeader46.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader46.Width = 100;
         // 
         // ColumnHeader47
         // 
         this.ColumnHeader47.Text = "DomBidVolume";
         this.ColumnHeader47.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader47.Width = 100;
         // 
         // ColumnHeader48
         // 
         this.ColumnHeader48.Text = "DomAskVolume";
         this.ColumnHeader48.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader48.Width = 100;
         // 
         // btnShow
         // 
         this.btnShow.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnShow.Location = new System.Drawing.Point(696, 48);
         this.btnShow.Name = "btnShow";
         this.btnShow.Size = new System.Drawing.Size(96, 24);
         this.btnShow.TabIndex = 4;
         this.btnShow.Text = "Show";
         this.btnShow.Click += new System.EventHandler(this.btnShow_Click);
         // 
         // gbIndexInterval
         // 
         this.gbIndexInterval.Controls.Add(this.Label3);
         this.gbIndexInterval.Controls.Add(this.nudEnd);
         this.gbIndexInterval.Controls.Add(this.Label2);
         this.gbIndexInterval.Controls.Add(this.nudStart);
         this.gbIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbIndexInterval.Location = new System.Drawing.Point(288, 16);
         this.gbIndexInterval.Name = "gbIndexInterval";
         this.gbIndexInterval.Size = new System.Drawing.Size(400, 56);
         this.gbIndexInterval.TabIndex = 3;
         this.gbIndexInterval.TabStop = false;
         this.gbIndexInterval.Text = "Index Interval";
         // 
         // Label3
         // 
         this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label3.Location = new System.Drawing.Point(200, 24);
         this.Label3.Name = "Label3";
         this.Label3.Size = new System.Drawing.Size(48, 24);
         this.Label3.TabIndex = 74;
         this.Label3.Text = "End: ";
         this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // nudEnd
         // 
         this.nudEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.nudEnd.Location = new System.Drawing.Point(256, 24);
         this.nudEnd.Maximum = new decimal(new int[] {
            10000000,
            0,
            0,
            0});
         this.nudEnd.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
         this.nudEnd.Name = "nudEnd";
         this.nudEnd.Size = new System.Drawing.Size(128, 22);
         this.nudEnd.TabIndex = 1;
         this.nudEnd.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
         // 
         // Label2
         // 
         this.Label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label2.Location = new System.Drawing.Point(8, 24);
         this.Label2.Name = "Label2";
         this.Label2.Size = new System.Drawing.Size(48, 24);
         this.Label2.TabIndex = 70;
         this.Label2.Text = "Start: ";
         this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // nudStart
         // 
         this.nudStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.nudStart.Location = new System.Drawing.Point(64, 24);
         this.nudStart.Maximum = new decimal(new int[] {
            10000000,
            0,
            0,
            0});
         this.nudStart.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
         this.nudStart.Name = "nudStart";
         this.nudStart.Size = new System.Drawing.Size(128, 22);
         this.nudStart.TabIndex = 0;
         this.nudStart.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
         // 
         // GroupBox6
         // 
         this.GroupBox6.Controls.Add(this.lblStatus);
         this.GroupBox6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
         this.GroupBox6.Location = new System.Drawing.Point(328, 80);
         this.GroupBox6.Name = "GroupBox6";
         this.GroupBox6.Size = new System.Drawing.Size(136, 48);
         this.GroupBox6.TabIndex = 45;
         this.GroupBox6.TabStop = false;
         this.GroupBox6.Text = "Status";
         // 
         // lblError
         // 
         this.lblError.ForeColor = System.Drawing.Color.Red;
         this.lblError.Location = new System.Drawing.Point(16, 136);
         this.lblError.Name = "lblError";
         this.lblError.Size = new System.Drawing.Size(448, 192);
         this.lblError.TabIndex = 46;
         // 
         // columnHeader13
         // 
         this.columnHeader13.Text = "AskVolumeFractional";
         this.columnHeader13.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader13.Width = 120;
         // 
         // columnHeader14
         // 
         this.columnHeader14.Text = "BidVolumeFractional";
         this.columnHeader14.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader14.Width = 120;
         // 
         // columnHeader15
         // 
         this.columnHeader15.Text = "DomAskVolumeFractional";
         this.columnHeader15.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader15.Width = 120;
         // 
         // columnHeader16
         // 
         this.columnHeader16.Text = "DomBidVolumeFractional";
         this.columnHeader16.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.columnHeader16.Width = 120;
         // 
         // frmTFlowBars
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
         this.ClientSize = new System.Drawing.Size(1070, 812);
         this.Controls.Add(this.GroupBox1);
         this.Controls.Add(this.lblError);
         this.Controls.Add(this.GroupBox6);
         this.Controls.Add(this.GroupBox5);
         this.Controls.Add(this.GroupBox4);
         this.Controls.Add(this.GroupBox2);
         this.Controls.Add(this.PictureBox3);
         this.Controls.Add(this.PictureBox2);
         this.Controls.Add(this.btnRemoveAll);
         this.Controls.Add(this.btnRemove);
         this.Controls.Add(this.btnRequest);
         this.Controls.Add(this.cmbTFlowBars);
         this.Controls.Add(this.lblDataConnection);
         this.Controls.Add(this.PictureBox1);
         this.Controls.Add(this.llWeb);
         this.Controls.Add(this.GroupBox3);
         this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
         this.MaximizeBox = false;
         this.Name = "frmTFlowBars";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "TFlowBars";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmTFlowBars_Closing);
         this.Load += new System.EventHandler(this.frmTFlowBars_Load);
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox1)).EndInit();
         this.GroupBox1.ResumeLayout(false);
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox2)).EndInit();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox3)).EndInit();
         this.GroupBox2.ResumeLayout(false);
         this.GroupBox2.PerformLayout();
         this.GroupBox3.ResumeLayout(false);
         this.GroupBox4.ResumeLayout(false);
         this.GroupBox5.ResumeLayout(false);
         this.gbIndexInterval.ResumeLayout(false);
         ((System.ComponentModel.ISupportInitialize)(this.nudEnd)).EndInit();
         ((System.ComponentModel.ISupportInitialize)(this.nudStart)).EndInit();
         this.GroupBox6.ResumeLayout(false);
         this.ResumeLayout(false);

      }

      #endregion

      /// <summary>
      /// Creates a CEL object, changes its configurations, and starts up the created CEL object.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void frmTFlowBars_Load(System.Object sender, System.EventArgs e)
      {
         try
         {
            // Creates the CQGCEL object
            CEL = new CQGCEL();
            CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
            CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
            CEL.TFlowBarsResolved += new CQG._ICQGCELEvents_TFlowBarsResolvedEventHandler(CEL_TFlowBarsResolved);
            CEL.TFlowBarsAdded += new CQG._ICQGCELEvents_TFlowBarsAddedEventHandler(CEL_TFlowBarsAdded);
            CEL.TFlowBarsUpdated += new CQG._ICQGCELEvents_TFlowBarsUpdatedEventHandler(CEL_TFlowBarsUpdated);
            CEL.TFlowBarsInserted += new CQG._ICQGCELEvents_TFlowBarsInsertedEventHandler(CEL_TFlowBarsInserted);
            CEL.TFlowBarsRemoved += new CQG._ICQGCELEvents_TFlowBarsRemovedEventHandler(CEL_TFlowBarsRemoved);
            CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
            CEL.APIConfiguration.CollectionsThrowException = false;
            CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;

            // Disables the controls
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
            // Starts up the CQGCEL
            CEL.Startup();

            cmbTFlowBars.Items.Clear();
            cmbTFlowBars.SelectedIndex = -1;

            ClearAllData();

            m_CurTFlowBars = null;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "frmTFlowBars_Load", ex);
            this.Close();
         }
      }

      /// <summary>
      /// Shuts down CEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A CancelEventArgs that contains the event data.
      /// </param>
      private void frmTFlowBars_Closing(object sender, System.ComponentModel.CancelEventArgs e)
      {
         if (CEL != null)
         {
            CEL.Shutdown();
         }
      }

      /// <summary>
      /// Opens frmTFBRequestSettings and with passed values requests TFlowBars.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRequest_Click(System.Object sender, System.EventArgs e)
      {
         frmTFBRequestSettings frmTFlowBarsReq;
         CQGTFlowBars TFlowBars;
         CQGTFlowBarsRequest req;

         try
         {
            // Opens the form to fill up request data
            frmTFlowBarsReq = new frmTFBRequestSettings();
            req = CEL.CreateTFlowBarsRequest();
            req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

            frmTFlowBarsReq.TFlowBarsRequest = req;
            frmTFlowBarsReq.LineTime = CEL.Environment.LineTime;

            // If the user confirms, request is sent to CQGCEL and added to the requests list
            if (frmTFlowBarsReq.ShowDialog(this) == DialogResult.OK)
            {
               TFlowBars = CEL.RequestTFlowBars(req);

               cmbTFlowBars.Items.Add(TFlowBars.Id);
               cmbTFlowBars.SelectedIndex = cmbTFlowBars.Items.Count - 1;

               ChangeControlsStatuses();
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "btnRequest_Click", ex);
         }
      }

      /// <summary>
      /// Changes to show the selected TFlowBars info.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data
      /// </param>
      private void cmbTFlowBars_SelectedIndexChanged(System.Object sender, System.EventArgs e)
      {
         try
         {
            if (cmbTFlowBars.SelectedIndex > -1)
            {
               // Gets the selected TFlowBar object from CQGCEL by it's ID
               m_CurTFlowBars = CEL.AllTFlowBars.get_ItemById(cmbTFlowBars.Text);

               ClearAllData();
               DumpAllData();

               DumpFilterInfo();
            }

            ChangeControlsStatuses();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "cmbTFlowBars_SelectedIndexChanged", ex);
         }
      }

      /// <summary>
      /// Shows few data from the selected TFlowBars collection.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnShow_Click(System.Object sender, System.EventArgs e)
      {
         int iStart;
         int iEnd;

         try
         {
            lvShownTFlowBars.Items.Clear();

            iStart = System.Convert.ToInt32(nudStart.Value) - 1;
            iEnd = System.Convert.ToInt32(nudEnd.Value) - 1;
            if (iStart > iEnd || iEnd > m_CurTFlowBars.Count - 1 || iEnd - iStart >= MAX_INDEX_INTERVAL)
            {
               MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " records," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
               return;
            }

            lvShownTFlowBars.SuspendLayout();
            for (int i = iEnd; i >= iStart; i--)
            {
               DumpRecord(lvShownTFlowBars, m_CurTFlowBars[i], i + 1);
            }
            lvShownTFlowBars.ResumeLayout(false);
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "btnShow_Click", ex);
         }
      }

      /// <summary>
      /// Removes the selected TFlowBar from the list and the CQGCEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRemove_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            // Removes TFlowBars from the collection
            CEL.RemoveTFlowBars(m_CurTFlowBars);

            // Removes TFlowBars from the combo box
            cmbTFlowBars.Items.RemoveAt(cmbTFlowBars.SelectedIndex);

            cmbTFlowBars.SelectedIndex = cmbTFlowBars.Items.Count - 1;

            if (cmbTFlowBars.Items.Count == 0)
            {
               cmbTFlowBars.SelectedIndex = -1;
               ClearAllData();
               m_CurTFlowBars = null;
            }

            ChangeControlsStatuses();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "btnRemove_Click", ex);
         }
      }

      /// <summary>
      /// Removes all TFlowBars from the list and the CQGCEL.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// An EventArgs that contains the event data.
      /// </param>
      private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
      {
         try
         {
            // Clears the combo box
            cmbTFlowBars.Items.Clear();
            cmbTFlowBars.SelectedIndex = -1;

            // Removes all TFlowBars from the collection
            CEL.RemoveAllTFlowBars();

            m_CurTFlowBars = null;

            ClearAllData();

            ChangeControlsStatuses();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "btnRemoveAll_Click", ex);
         }
      }

      /// <summary>
      /// Shows tag value of the current TFlowBars corresponding to the entered name.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A KeyEventArgs that contains the event data.
      /// </param>
      private void txtTagName_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
      {
         try
         {
            if (txtTagName.Text.Trim().Length == 0)
            {
               return;
            }

            if (e.KeyCode == Keys.Return)
            {
               object tagValue = m_CurTFlowBars.get_Tag(txtTagName.Text);
               if (tagValue != null)
               {
                  txtTagValue.Text = tagValue.ToString();
               }
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "txtTagName_KeyDown", ex);
         }
      }

      /// <summary>
      /// Sets the tag value of the current TFlowBars corresponding to the entered name.
      /// </summary>
      /// <param name="sender">
      /// The source of the event.
      /// </param>
      /// <param name="e">
      /// A KeyEventArgs that contains the event data.
      /// </param>
      private void txtTagValue_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
      {
         try
         {
            if (txtTagName.Text.Trim().Length == 0)
            {
               return;
            }

            if (e.KeyCode == Keys.Return)
            {
               if (txtTagValue.Text.Trim().Length == 0)
               {
                  m_CurTFlowBars.set_Tag(txtTagName.Text, null);
               }
               else
               {
                  m_CurTFlowBars.set_Tag(txtTagName.Text, txtTagValue.Text);
               }
               txtTagName.Text = "";
               txtTagValue.Text = "";
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "txtTagValue_KeyDown", ex);
         }
      }

      /// <summary>
      /// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
      /// </summary>
      /// <param name="cqg_error">
      /// The object, in which the error has occurred.
      /// </param>
      /// <param name="error_description">
      /// The string, describing the error.
      /// </param>
      private void CEL_DataError(object cqg_error, string error_description)
      {
         try
         {
            CQGError cqgErr = cqg_error as CQGError;
            if (CEL.IsValid(cqgErr))
            {
               if (cqgErr.Code == 102)
               {
                  error_description += " Restart the application.";
               }
               else if (cqgErr.Code == 125)
               {
                  error_description += " Turn on CQG Client and restart the application.";
               }
            }

            MessageBox.Show(error_description, "TFlowBars", MessageBoxButtons.OK, MessageBoxIcon.Information);
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_DataError", ex);
         }
      }

      /// <summary>
      /// This event is fired, when some changes occur in the connection with CQG data server.
      /// </summary>
      /// <param name="newStatus">
      /// The current status of the connection with the data server.
      /// </param>
      private void CEL_DataConnectionStatusChanged(CQG.eConnectionStatus new_status)
      {
         string sInfo;
         System.Drawing.Color BackCol;

         try
         {
            if (new_status == eConnectionStatus.csConnectionUp)
            {
               BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
               sInfo = "DATA Connection is UP";
            }
            else if (new_status == eConnectionStatus.csConnectionDelayed)
            {
               BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
               sInfo = "DATA Connection is Delayed";
            }
            else
            {
               BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
               sInfo = "DATA Connection is Down";
            }

            lblDataConnection.BackColor = BackCol;
            lblDataConnection.Text = sInfo;

            ChangeControlsStatuses();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_DataConnectionStatusChanged", ex);
         }
      }

      /// <summary>
      /// Fired when the collection of trade flow bars (CQGTFlowBars) is resolved or
      /// when some error occured during trade flow bars request processing.
      /// </summary>
      /// <param name="cqg_trade_flow_bars">
      /// Reference to resolved CQGTFlowBars
      /// </param>
      /// <param name="cqg_error">
      /// The CQGError object that describes the last error occurred
      /// while processing the TFlowBars request or
      /// Nothing/Invalid_Error in case of no error.
      /// </param>
      private void CEL_TFlowBarsResolved(CQG.CQGTFlowBars cqg_trade_flow_bars, CQG.CQGError cqg_error)
      {
         try
         {
            if (cqg_trade_flow_bars.Id == m_CurTFlowBars.Id)
            {
               ClearAllData();
               DumpAllData();
               DumpFilterInfo();
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_TFlowBarsResolved", ex);
         }
      }

      /// <summary>
      /// Fired when CQGTFlowBar item is added to the end of CQGTFlowBars.
      /// </summary>
      /// <param name="cqg_trade_flow_bars">
      /// Reference to changed CQGTFlowBars.
      /// </param>
      private void CEL_TFlowBarsAdded(CQG.CQGTFlowBars cqg_trade_flow_bars)
      {
         try
         {
            if (cqg_trade_flow_bars.Id == m_CurTFlowBars.Id)
            {
               ShowChangedData(cqg_trade_flow_bars.Count);
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_TFlowBarsAdded", ex);
         }
      }

      /// <summary>
      /// Fired when CQGTFlowBar item is inserted into CQGTFlowBars.
      /// </summary>
      /// <param name="cqg_trade_flow_bars">
      /// Reference to changed CQGTFlowBars.
      /// </param>
      /// <param name="index_">
      /// Specifies the changed CQGTFlowBar index
      /// </param>
      private void CEL_TFlowBarsInserted(CQG.CQGTFlowBars cqg_trade_flow_bars, int index_)
      {
         try
         {
            if (cqg_trade_flow_bars.Id == m_CurTFlowBars.Id)
            {
               ShowChangedData(cqg_trade_flow_bars.Count);
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_TFlowBarsInserted", ex);
         }
      }

      /// <summary>
      /// Fired when CQGTFlowBar item is removed from CQGTFlowBars.
      /// </summary>
      /// <param name="cqg_trade_flow_bars">
      /// Reference to changed CQGTFlowBars.
      /// </param>
      /// <param name="index_">
      /// Specifies the changed CQGTFlowBar index
      /// </param>
      private void CEL_TFlowBarsRemoved(CQG.CQGTFlowBars cqg_trade_flow_bars, int index_)
      {
         try
         {
            if (cqg_trade_flow_bars.Id == m_CurTFlowBars.Id)
            {
               ShowChangedData(cqg_trade_flow_bars.Count);
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_TFlowBarsRemoved", ex);
         }
      }

      /// <summary>
      /// Fired when CQGTFlowBar item is updated.
      /// </summary>
      /// <param name="cqg_trade_flow_bars">
      /// Reference to changed CQGTFlowBars
      /// </param>
      /// <param name="index_">
      /// Specifies the updated CQGTFlowBar index.
      /// </param>
      private void CEL_TFlowBarsUpdated(CQG.CQGTFlowBars cqg_trade_flow_bars, int index_)
      {
         try
         {
            if (cqg_trade_flow_bars.Id == m_CurTFlowBars.Id)
            {
               if (index_ > m_CurTFlowBars.Count - MAX_NUMBER_OF_RECORDS)
               {
                  UpdateRecord(lvTFlowBars, m_CurTFlowBars[index_], index_ + 1);
               }
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "CEL_TFlowBarsUpdated", ex);
         }
      }

      /// <summary>
      /// Shows the selected request parameters on the listview.
      /// </summary>
      private void DumpRequestParams()
      {
         try
         {
            CQGTFlowBarsRequest req = m_CurTFlowBars.Request;

            lblRPSymbol.Text = req.Symbol;
            lblRPRangeStart.Text = GetValueAsString(req.RangeStart);
            lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd);
            lblRPAggregation.Text = req.Aggregation.ToString();
            lblRPAggregationLevel.Text = req.AggregationLevel.ToString();
            lblRPUpdatesEnabled.Text = req.UpdatesEnabled.ToString();
            lblRPIncludeEnd.Text = req.IncludeEnd.ToString();

            var sessionFilter = req.SessionsFilter.ToString();
            switch (sessionFilter)
            {
               case "0": sessionFilter = "Primary session only (0)"; break;
               case "31": sessionFilter = "All sessions (31)"; break;
            }
            lblRPSessionsFilter.Text = sessionFilter;
            lblRPContinuation.Text = req.Continuation.ToString();
            lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString();
            lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString();
            lblRPSessionFlags.Text = req.SessionFlags.ToString();
            lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString();
            if (req.SubscriptionLevel == eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod)
            {
               lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString();
            }
            lblRPDomAskVolumeLevel.Text = req.DomAskVolumeLevel.ToString();
            lblRPDomBidVolumeLevel.Text = req.DomBidVolumeLevel.ToString();

            if (m_CurTFlowBars.LastError != null)
            {
               lblError.Text = m_CurTFlowBars.LastError.Description;
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "DumpRequestParams", ex);
         }
      }

      /// <summary>
      /// Shows the selected request outputs on the listview.
      /// </summary>
      private void DumpOutputParams()
      {
         try
         {
            lblOStart.Text = GetValueAsString(m_CurTFlowBars.StartTimestamp);
            lblOEnd.Text = GetValueAsString(m_CurTFlowBars.EndTimestamp);
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "DumpOutputParams", ex);
         }
      }

      /// <summary>
      /// Shows the selected request outputs on the listview after changes.
      /// </summary>
      /// <param name="count">
      /// Count of TFlowBars that will be shown.
      /// </param>
      private void ShowChangedData(int count)
      {
         ClearOutputParams();
         DumpOutputParams();

         DumpRecords(count);
      }

      /// <summary>
      /// Shows added TFlowBars for the selected request records on the listview.
      /// </summary>
      /// <param name="addedTFlowBarsCount">
      /// Count of TFlowBars that will be shown.
      /// </param>
      private void DumpRecords(int addedTFlowBarsCount)
      {
         try
         {
            // Clears all records
            ClearRecords();

            if (m_CurTFlowBars.Count == 0)
            {
               return;
            }

            if (addedTFlowBarsCount == m_CurTFlowBars.Count)
            {
               addedTFlowBarsCount = System.Convert.ToInt32(addedTFlowBarsCount >= MAX_NUMBER_OF_RECORDS ? MAX_NUMBER_OF_RECORDS : m_CurTFlowBars.Count);
            }

            for (int i = m_CurTFlowBars.Count - 1; i >= m_CurTFlowBars.Count - addedTFlowBarsCount; i--)
            {
               DumpRecord(lvTFlowBars, m_CurTFlowBars[i], i + 1);
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "DumpRecords", ex);
         }
      }

      /// <summary>
      /// Dumps one record's values to the listview.
      /// </summary>
      /// <param name="lv">
      /// Listview, in which data must be shown.
      /// </param>
      /// <param name="tFlowBar">
      /// Record, which values must be shown.
      /// </param>
      /// <param name="recordIndex">
      /// Index of record, which values must be shown.
      /// </param>
      private void DumpRecord(ListView lv, CQGTFlowBar tFlowBar, long recordIndex)
      {
         try
         {
            ListViewItem item = lv.Items.Add(new ListViewItem());
            item.SubItems.Add("Index").Text = recordIndex.ToString();
            item.SubItems.Add("Timestamp").Text = GetValueAsString(tFlowBar.Timestamp, true);
            item.SubItems.Add("Open").Text = GetValueAsString(tFlowBar.Open);
            item.SubItems.Add("High").Text = GetValueAsString(tFlowBar.High);
            item.SubItems.Add("Low").Text = GetValueAsString(tFlowBar.Low);
            item.SubItems.Add("Close").Text = GetValueAsString(tFlowBar.Close);
            item.SubItems.Add("Mid").Text = GetValueAsString(tFlowBar.Mid);
            item.SubItems.Add("TrueHigh").Text = GetValueAsString(tFlowBar.TrueHigh);
            item.SubItems.Add("TrueLow").Text = GetValueAsString(tFlowBar.TrueLow);
            item.SubItems.Add("TrueMid").Text = GetValueAsString(tFlowBar.TrueMid);
            item.SubItems.Add("AskVolume").Text = GetValueAsString(tFlowBar.AskVolume);
            item.SubItems.Add("BidVolume").Text = GetValueAsString(tFlowBar.BidVolume);
            item.SubItems.Add("BestAskPrice").Text = GetValueAsString(tFlowBar.BestAskPrice);
            item.SubItems.Add("BestBidPrice").Text = GetValueAsString(tFlowBar.BestBidPrice);

            string temp_string_ask = "";
            string temp_string_bid = "";
            GetValuesForDoms(tFlowBar, ref temp_string_ask, ref temp_string_bid);
            item.SubItems.Add("DomAskVolume").Text = temp_string_ask;
            item.SubItems.Add("DomBidVolume").Text = temp_string_bid;

            item.SubItems.Add("AskVolumeFractional").Text = GetValueAsString(tFlowBar.AskVolumeFractional);
            item.SubItems.Add("BidVolumeFractional").Text = GetValueAsString(tFlowBar.BidVolumeFractional);

            string temp_string_ask_fractional = "";
            string temp_string_bid_fractional = "";
            GetFractionalValuesForDoms(tFlowBar, ref temp_string_ask_fractional, ref temp_string_bid_fractional);
            item.SubItems.Add("DomAskVolumeFractional").Text = temp_string_ask_fractional;
            item.SubItems.Add("DomBidVolumeFractional").Text = temp_string_bid_fractional;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "DumpRecord", ex);
         }
      }

      /// <summary>
      /// Updates one record's values to the listview.
      /// </summary>
      /// <param name="lv">
      /// Listview, in which data must be shown.
      /// </param>
      /// <param name="tFlowBar">
      /// Record, which values must be shown.
      /// </param>
      /// <param name="recordIndex">
      /// Index of record, which values must be updated.
      /// </param>
      private void UpdateRecord(ListView lv, CQGTFlowBar tFlowBar, int recordIndex)
      {
         try
         {
            ListViewItem item = new ListViewItem();
            item.SubItems.Add("Index").Text = recordIndex.ToString();
            item.SubItems.Add("Timestamp").Text = GetValueAsString(tFlowBar.Timestamp, true);
            item.SubItems.Add("Open").Text = GetValueAsString(tFlowBar.Open);
            item.SubItems.Add("High").Text = GetValueAsString(tFlowBar.High);
            item.SubItems.Add("Low").Text = GetValueAsString(tFlowBar.Low);
            item.SubItems.Add("Close").Text = GetValueAsString(tFlowBar.Close);
            item.SubItems.Add("Mid").Text = GetValueAsString(tFlowBar.Mid);
            item.SubItems.Add("TrueHigh").Text = GetValueAsString(tFlowBar.TrueHigh);
            item.SubItems.Add("TrueLow").Text = GetValueAsString(tFlowBar.TrueLow);
            item.SubItems.Add("TrueMid").Text = GetValueAsString(tFlowBar.TrueMid);
            item.SubItems.Add("AskVolume").Text = GetValueAsString(tFlowBar.AskVolume);
            item.SubItems.Add("BidVolume").Text = GetValueAsString(tFlowBar.BidVolume);
            item.SubItems.Add("BestAskPrice").Text = GetValueAsString(tFlowBar.BestAskPrice);
            item.SubItems.Add("BestBidPrice").Text = GetValueAsString(tFlowBar.BestBidPrice);

            string temp_string_ask = "";
            string temp_string_bid = "";
            GetValuesForDoms(tFlowBar, ref temp_string_ask, ref temp_string_bid);

            if (temp_string_ask != "")
            {
               item.SubItems.Add("DomAskVolume").Text = temp_string_ask;
            }
            if (temp_string_bid != "")
            {
               item.SubItems.Add("DomBidVolume").Text = temp_string_bid;
            }

            item.SubItems.Add("AskVolumeFractional").Text = GetValueAsString(tFlowBar.AskVolumeFractional);
            item.SubItems.Add("BidVolumeFractional").Text = GetValueAsString(tFlowBar.BidVolumeFractional);

            string temp_string_ask_fractional = "";
            string temp_string_bid_fractional = "";
            GetFractionalValuesForDoms(tFlowBar, ref temp_string_ask_fractional, ref temp_string_bid_fractional);

            if (temp_string_ask_fractional != "")
            {
               item.SubItems.Add("DomAskVolumeFractional").Text = temp_string_ask;
            }
            if (temp_string_bid_fractional != "")
            {
               item.SubItems.Add("DomBidVolumeFractional").Text = temp_string_bid;
            }


            lv.Items[m_CurTFlowBars.Count - recordIndex] = item;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "UpdateRecord", ex);
         }
      }

      /// <summary>
      /// Dumps all request data (outputs\parameters\records)
      /// </summary>
      private void DumpAllData()
      {
         try
         {
            DumpRequestParams();

            lblStatus.Text = m_CurTFlowBars.Status.ToString();

            if (m_CurTFlowBars.Status == eRequestStatus.rsSuccess)
            {
               DumpOutputParams();
               DumpRecords(m_CurTFlowBars.Count);
            }

            ChangeControlsStatuses();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "DumpAllData", ex);
         }
      }

      /// <summary>
      /// Initializes the filter-related controls.
      /// </summary>
      private void DumpFilterInfo()
      {
         try
         {
            nudStart.Value = 1;
            nudEnd.Value = 1;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "DumpFilterInfo", ex);
         }
      }

      /// <summary>
      /// Clears all request data.
      /// </summary>
      private void ClearAllData()
      {
         try
         {
            lblStatus.Text = "";

            ClearRequestParams();
            ClearOutputParams();
            ClearTags();
            ClearRecords();

            lvShownTFlowBars.Items.Clear();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "ClearAllData", ex);
         }
      }

      /// <summary>
      /// Clears the request parameters from the listview.
      /// </summary>
      private void ClearRequestParams()
      {
         try
         {
            lblRPSymbol.Text = "";
            lblRPRangeStart.Text = "";
            lblRPRangeEnd.Text = "";
            lblRPAggregation.Text = "";
            lblRPAggregationLevel.Text = "";
            lblRPUpdatesEnabled.Text = "";
            lblRPIncludeEnd.Text = "";
            lblRPSessionsFilter.Text = "";
            lblRPContinuation.Text = "";
            lblRPEqualizeCloses.Text = "";
            lblRPDaysBeforeExpiration.Text = "";
            lblRPSessionFlags.Text = "";
            lblRPSubscriptionLevel.Text = "";
            lblRPRecalcPeriod.Text = "";
            lblRPDomAskVolumeLevel.Text = "";
            lblRPDomBidVolumeLevel.Text = "";

            lblError.Text = "";
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "ClearRequestParams", ex);
         }
      }

      /// <summary>
      /// Clears request outputs from the listview.
      /// </summary>
      private void ClearOutputParams()
      {
         try
         {
            lblOStart.Text = "";
            lblOEnd.Text = "";
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "ClearOutputParams", ex);
         }
      }

      /// <summary>
      /// Clears request tags.
      /// </summary>
      private void ClearTags()
      {
         try
         {
            txtTagName.Text = "";
            txtTagValue.Text = "";
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "ClearTags", ex);
         }
      }

      /// <summary>
      /// Clears records from the listview.
      /// </summary>
      private void ClearRecords()
      {
         try
         {
            lvTFlowBars.Items.Clear();
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "ClearRecords", ex);
         }
      }

      /// <summary>
      /// Enables\disables the controls, based on the connection status.
      /// </summary>
      private void ChangeControlsStatuses()
      {
         bool bIsDataConnectionUp = false;
         bool bIsTFlowBarsSelected;
         bool bIsTFlowBarsSucceded = false;

         try
         {
            if (CEL.IsStarted)
            {
               bIsDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
            }

            btnRequest.Enabled = bIsDataConnectionUp;

            bIsTFlowBarsSelected = m_CurTFlowBars != null;

            btnRemove.Enabled = bIsTFlowBarsSelected && bIsDataConnectionUp;
            btnRemoveAll.Enabled = bIsTFlowBarsSelected && bIsDataConnectionUp;

            txtTagName.Enabled = bIsTFlowBarsSelected;
            txtTagValue.Enabled = bIsTFlowBarsSelected;

            if (bIsTFlowBarsSelected)
            {
               bIsTFlowBarsSucceded = m_CurTFlowBars.Status == eRequestStatus.rsSuccess;
            }

            nudEnd.Enabled = bIsTFlowBarsSucceded;
            nudStart.Enabled = bIsTFlowBarsSucceded;

            btnShow.Enabled = bIsTFlowBarsSucceded;
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "ChangeControlsStatuses", ex);
         }
      }

      /// <summary>
      /// Validates the specified value and converts it to string.
      /// </summary>
      /// <param name="val">
      /// The value that will be validated and converted
      /// </param>
      /// <param name="includeMilliseconds">
      /// Whether to include seconds and milliseconds to string, valid only for DateTime
      /// </param>
      /// <returns>
      /// Value converted to string or "N/A" if the value is invalid.
      /// </returns>
      private string GetValueAsString(object val, bool includeMilliseconds = false)
      {
         string sResult = "";

         try
         {
            if (CEL.IsValid(val))
            {
               if (val.GetType().FullName == "System.DateTime")
               {
                  string format = includeMilliseconds ? "dd/MM/yyyy HH:mm:ss.fff" : "dd/MM/yyyy HH:mm";
                  sResult = System.Convert.ToDateTime(val).ToString(format);
               }
               else
               {
                  sResult = val.ToString();
               }
            }
            else
            {
               sResult = N_A;
            }
         }
         catch
         {
            sResult = N_A;
         }

         return sResult;
      }

      /// <summary>
      /// Makes string for DOM values
      /// </summary>
      /// <param name="tFlowBar">
      /// TFlowBar for which doms will be analized.
      /// </param>
      /// <param name="itemAsk">
      /// Return string which will contain asks.
      /// </param>
      /// <param name="itemBid">
      /// Return string which will contain bids.
      /// </param>
      private void GetValuesForDoms(CQGTFlowBar tFlowBar, ref string itemAsk, ref string itemBid)
      {
         string volString;
         int j;
         try
         {
            if (tFlowBar.DomBidCount > 0)
            {
               volString = " | ";
               for (j = 0; j <= tFlowBar.DomBidCount - 1; j++)
               {
                  volString += GetValueAsString(tFlowBar.get_DomBidVolume(j)) + " | ";
               }

               itemBid = volString;
            }
            else
            {
               itemBid = N_A;
            }

            if (tFlowBar.DomAskCount > 0)
            {
               volString = " | ";
               for (j = 0; j <= tFlowBar.DomAskCount - 1; j++)
               {
                  volString += GetValueAsString(tFlowBar.get_DomAskVolume(j)) + " | ";
               }

               itemAsk = volString;
            }
            else
            {
               itemAsk = N_A;
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "GetValuesForDoms", ex);
         }
      }

      /// <summary>
      /// Makes string for DOM fractional values
      /// </summary>
      /// <param name="tFlowBar">
      /// TFlowBar for which doms will be analized.
      /// </param>
      /// <param name="itemAsk">
      /// Return string which will contain asks.
      /// </param>
      /// <param name="itemBid">
      /// Return string which will contain bids.
      /// </param>
      private void GetFractionalValuesForDoms(CQGTFlowBar tFlowBar, ref string itemAsk, ref string itemBid)
      {
         string volString;
         int j;
         try
         {
            if (tFlowBar.DomBidCount > 0)
            {
               volString = " | ";
               for (j = 0; j <= tFlowBar.DomBidCount - 1; j++)
               {
                  volString += GetValueAsString(tFlowBar.get_DomBidVolumeFractional(j)) + " | ";
               }

               itemBid = volString;
            }
            else
            {
               itemBid = N_A;
            }

            if (tFlowBar.DomAskCount > 0)
            {
               volString = " | ";
               for (j = 0; j <= tFlowBar.DomAskCount - 1; j++)
               {
                  volString += GetValueAsString(tFlowBar.get_DomAskVolumeFractional(j)) + " | ";
               }

               itemAsk = volString;
            }
            else
            {
               itemAsk = N_A;
            }
         }
         catch (Exception ex)
         {
            modErrorHandler.ShowError("frmTFlowBars", "GetValuesForDoms", ex);
         }
      }

   }

}
