using System.Diagnostics;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;

namespace Ticks
{
    public class frmTicks : System.Windows.Forms.Form
    {

        [STAThread]
        static void Main()
        {
            Application.Run(new frmTicks());
        }

        // The CQGCEL object, which encapsulates the main functionality of CQG API
        [field: System.CLSCompliant(false)]
        public CQGCEL CEL;

        // The currently selected ticks object in the combo box
        private CQGTicks m_CurTicks;

        // Specifies the not available string
        private const string N_A = "N/A";

        // Specifies the max index interval
        private const int MAX_INDEX_INTERVAL = 500;
      private ColumnHeader VolumeFractional;
      private ColumnHeader columnHeader13;

      // Specifies the max time interval
      private const int MAX_TIME_INTERVAL = 3;

        #region " Windows Form Designer generated code "

        public frmTicks()
        {

            //This call is required by the Windows Form Designer.
            InitializeComponent();

            //Add any initialization after the InitializeComponent() call

        }

        //Form overrides dispose to clean up the component list.
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (!(components == null))
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        //Required by the Windows Form Designer
        private System.ComponentModel.Container components = null;

        //NOTE: The following procedure is required by the Windows Form Designer
        //It can be modified using the Windows Form Designer.
        //Do not modify it using the code editor.
        internal System.Windows.Forms.Label lblDataConnection;
        internal System.Windows.Forms.PictureBox PictureBox1;
        internal System.Windows.Forms.LinkLabel llWeb;
        internal System.Windows.Forms.GroupBox GroupBox1;
        internal System.Windows.Forms.Label Label4;
        internal System.Windows.Forms.Label Label6;
        internal System.Windows.Forms.Label Label8;
        internal System.Windows.Forms.Label Label10;
        internal System.Windows.Forms.Label Label12;
        internal System.Windows.Forms.Label Label13;
        internal System.Windows.Forms.PictureBox PictureBox2;
        internal System.Windows.Forms.PictureBox PictureBox3;
        internal System.Windows.Forms.GroupBox GroupBox2;
        internal System.Windows.Forms.Label Label14;
        internal System.Windows.Forms.Label Label18;
        internal System.Windows.Forms.GroupBox GroupBox3;
        internal System.Windows.Forms.Label Label16;
        internal System.Windows.Forms.Label Label20;
        internal System.Windows.Forms.GroupBox GroupBoxTicks;
        internal System.Windows.Forms.ComboBox cmbTicks;
        internal System.Windows.Forms.Label lblRPSymbol;
        internal System.Windows.Forms.Label lblRPType;
        internal System.Windows.Forms.Label lblRPRangeEnd;
        internal System.Windows.Forms.Label lblRPRangeStart;
        internal System.Windows.Forms.Label lblRPSessionsFilter;
        internal System.Windows.Forms.Label lblRPLimit;
        internal System.Windows.Forms.Label labelLimit;
        internal System.Windows.Forms.Label lblRPTicksFilter;
        internal System.Windows.Forms.Label lblOEnd;
        internal System.Windows.Forms.Label lblOStart;
        internal System.Windows.Forms.ColumnHeader EmptyColumn;
        internal System.Windows.Forms.ListView lvTicks;
        internal System.Windows.Forms.ColumnHeader Timestamp;
        internal System.Windows.Forms.ColumnHeader Price;
        internal System.Windows.Forms.ColumnHeader Volume;
        internal System.Windows.Forms.ColumnHeader PriceType;
        internal System.Windows.Forms.ColumnHeader CorrectionType;
        internal System.Windows.Forms.ColumnHeader SalesConditionLabel;
        internal System.Windows.Forms.ColumnHeader SalesConditionCode;
        internal System.Windows.Forms.ColumnHeader ContributorId;
        internal System.Windows.Forms.ColumnHeader ContributorIdCode;
        internal System.Windows.Forms.ColumnHeader MarketState;
        internal System.Windows.Forms.Label lblStatus;
        internal System.Windows.Forms.TextBox txtTagName;
        internal System.Windows.Forms.TextBox txtTagValue;
        internal System.Windows.Forms.Button btnRequest;
        internal System.Windows.Forms.Button btnRemove;
        internal System.Windows.Forms.Button btnRemoveAll;
        internal System.Windows.Forms.GroupBox GroupBox5;
        internal System.Windows.Forms.ColumnHeader ColumnHeader1;
        internal System.Windows.Forms.ColumnHeader ColumnHeader2;
        internal System.Windows.Forms.ColumnHeader ColumnHeader3;
        internal System.Windows.Forms.ColumnHeader ColumnHeader4;
        internal System.Windows.Forms.ColumnHeader ColumnHeader5;
        internal System.Windows.Forms.ColumnHeader ColumnHeader6;
        internal System.Windows.Forms.ColumnHeader ColumnHeader7;
        internal System.Windows.Forms.ColumnHeader ColumnHeader8;
        internal System.Windows.Forms.ColumnHeader ColumnHeader9;
        internal System.Windows.Forms.ColumnHeader ColumnHeader10;
        internal System.Windows.Forms.ColumnHeader ColumnHeader11;
        internal System.Windows.Forms.ColumnHeader ColumnHeader12;
        internal System.Windows.Forms.Label Label2;
        internal System.Windows.Forms.GroupBox gbIndexInterval;
        internal System.Windows.Forms.GroupBox gbTimeInterval;
        internal System.Windows.Forms.DateTimePicker dtpStartRange;
        internal System.Windows.Forms.Label Label5;
        internal System.Windows.Forms.Label Label7;
        internal System.Windows.Forms.Label Label3;
        internal System.Windows.Forms.Button btnShow;
        internal System.Windows.Forms.RadioButton optTimeInterval;
        internal System.Windows.Forms.RadioButton optIndexInterval;
        internal System.Windows.Forms.ListView lvShownTicks;
        internal System.Windows.Forms.NumericUpDown nudEnd;
        internal System.Windows.Forms.NumericUpDown nudStart;
        internal System.Windows.Forms.GroupBox GroupBox6;
        internal System.Windows.Forms.DateTimePicker dtpEndRange;
        internal System.Windows.Forms.Label lblError;
        [System.Diagnostics.DebuggerStepThrough()]
        private void InitializeComponent()
        {
         this.lblDataConnection = new System.Windows.Forms.Label();
         this.PictureBox1 = new System.Windows.Forms.PictureBox();
         this.llWeb = new System.Windows.Forms.LinkLabel();
         this.cmbTicks = new System.Windows.Forms.ComboBox();
         this.btnRequest = new System.Windows.Forms.Button();
         this.btnRemove = new System.Windows.Forms.Button();
         this.btnRemoveAll = new System.Windows.Forms.Button();
         this.lblStatus = new System.Windows.Forms.Label();
         this.GroupBox1 = new System.Windows.Forms.GroupBox();
         this.lblRPTicksFilter = new System.Windows.Forms.Label();
         this.Label13 = new System.Windows.Forms.Label();
         this.lblRPRangeEnd = new System.Windows.Forms.Label();
         this.Label12 = new System.Windows.Forms.Label();
         this.lblRPSessionsFilter = new System.Windows.Forms.Label();
         this.Label10 = new System.Windows.Forms.Label();
         this.lblRPRangeStart = new System.Windows.Forms.Label();
         this.Label8 = new System.Windows.Forms.Label();
         this.lblRPLimit = new System.Windows.Forms.Label();
         this.labelLimit = new System.Windows.Forms.Label();
         this.lblRPType = new System.Windows.Forms.Label();
         this.Label6 = new System.Windows.Forms.Label();
         this.lblRPSymbol = new System.Windows.Forms.Label();
         this.Label4 = new System.Windows.Forms.Label();
         this.PictureBox2 = new System.Windows.Forms.PictureBox();
         this.PictureBox3 = new System.Windows.Forms.PictureBox();
         this.GroupBox2 = new System.Windows.Forms.GroupBox();
         this.txtTagValue = new System.Windows.Forms.TextBox();
         this.txtTagName = new System.Windows.Forms.TextBox();
         this.Label14 = new System.Windows.Forms.Label();
         this.Label18 = new System.Windows.Forms.Label();
         this.GroupBox3 = new System.Windows.Forms.GroupBox();
         this.lblOEnd = new System.Windows.Forms.Label();
         this.Label16 = new System.Windows.Forms.Label();
         this.lblOStart = new System.Windows.Forms.Label();
         this.Label20 = new System.Windows.Forms.Label();
         this.GroupBoxTicks = new System.Windows.Forms.GroupBox();
         this.lvTicks = new System.Windows.Forms.ListView();
         this.EmptyColumn = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.Timestamp = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.Price = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.Volume = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.VolumeFractional = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.PriceType = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.CorrectionType = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.SalesConditionLabel = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.SalesConditionCode = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ContributorId = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ContributorIdCode = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.MarketState = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.GroupBox5 = new System.Windows.Forms.GroupBox();
         this.btnShow = new System.Windows.Forms.Button();
         this.gbIndexInterval = new System.Windows.Forms.GroupBox();
         this.Label3 = new System.Windows.Forms.Label();
         this.nudEnd = new System.Windows.Forms.NumericUpDown();
         this.Label2 = new System.Windows.Forms.Label();
         this.nudStart = new System.Windows.Forms.NumericUpDown();
         this.optTimeInterval = new System.Windows.Forms.RadioButton();
         this.optIndexInterval = new System.Windows.Forms.RadioButton();
         this.lvShownTicks = new System.Windows.Forms.ListView();
         this.ColumnHeader1 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader2 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader3 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader4 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader5 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.columnHeader13 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader6 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader7 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader8 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader9 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader10 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader11 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.ColumnHeader12 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
         this.gbTimeInterval = new System.Windows.Forms.GroupBox();
         this.Label7 = new System.Windows.Forms.Label();
         this.dtpEndRange = new System.Windows.Forms.DateTimePicker();
         this.Label5 = new System.Windows.Forms.Label();
         this.dtpStartRange = new System.Windows.Forms.DateTimePicker();
         this.GroupBox6 = new System.Windows.Forms.GroupBox();
         this.lblError = new System.Windows.Forms.Label();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox1)).BeginInit();
         this.GroupBox1.SuspendLayout();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox2)).BeginInit();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox3)).BeginInit();
         this.GroupBox2.SuspendLayout();
         this.GroupBox3.SuspendLayout();
         this.GroupBoxTicks.SuspendLayout();
         this.GroupBox5.SuspendLayout();
         this.gbIndexInterval.SuspendLayout();
         ((System.ComponentModel.ISupportInitialize)(this.nudEnd)).BeginInit();
         ((System.ComponentModel.ISupportInitialize)(this.nudStart)).BeginInit();
         this.gbTimeInterval.SuspendLayout();
         this.GroupBox6.SuspendLayout();
         this.SuspendLayout();
         // 
         // lblDataConnection
         // 
         this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
         this.lblDataConnection.Name = "lblDataConnection";
         this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
         this.lblDataConnection.TabIndex = 24;
         this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         // 
         // PictureBox1
         // 
         this.PictureBox1.BackColor = System.Drawing.Color.Black;
         this.PictureBox1.Location = new System.Drawing.Point(0, 40);
         this.PictureBox1.Name = "PictureBox1";
         this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
         this.PictureBox1.TabIndex = 23;
         this.PictureBox1.TabStop = false;
         // 
         // llWeb
         // 
         this.llWeb.BackColor = System.Drawing.SystemColors.Control;
         this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
         this.llWeb.Location = new System.Drawing.Point(632, 8);
         this.llWeb.Name = "llWeb";
         this.llWeb.Size = new System.Drawing.Size(408, 16);
         this.llWeb.TabIndex = 25;
         this.llWeb.TabStop = true;
         this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
         this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
         this.llWeb.UseCompatibleTextRendering = true;
         // 
         // cmbTicks
         // 
         this.cmbTicks.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
         this.cmbTicks.Location = new System.Drawing.Point(24, 56);
         this.cmbTicks.Name = "cmbTicks";
         this.cmbTicks.Size = new System.Drawing.Size(488, 24);
         this.cmbTicks.TabIndex = 0;
         this.cmbTicks.SelectedIndexChanged += new System.EventHandler(this.cmbTicks_SelectedIndexChanged);
         // 
         // btnRequest
         // 
         this.btnRequest.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnRequest.Location = new System.Drawing.Point(24, 88);
         this.btnRequest.Name = "btnRequest";
         this.btnRequest.Size = new System.Drawing.Size(104, 40);
         this.btnRequest.TabIndex = 1;
         this.btnRequest.Text = "Request";
         this.btnRequest.Click += new System.EventHandler(this.btnRequest_Click);
         // 
         // btnRemove
         // 
         this.btnRemove.Enabled = false;
         this.btnRemove.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnRemove.Location = new System.Drawing.Point(144, 88);
         this.btnRemove.Name = "btnRemove";
         this.btnRemove.Size = new System.Drawing.Size(104, 40);
         this.btnRemove.TabIndex = 2;
         this.btnRemove.Text = "Remove";
         this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
         // 
         // btnRemoveAll
         // 
         this.btnRemoveAll.Enabled = false;
         this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnRemoveAll.Location = new System.Drawing.Point(264, 88);
         this.btnRemoveAll.Name = "btnRemoveAll";
         this.btnRemoveAll.Size = new System.Drawing.Size(104, 40);
         this.btnRemoveAll.TabIndex = 3;
         this.btnRemoveAll.Text = "Remove All";
         this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
         // 
         // lblStatus
         // 
         this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblStatus.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblStatus.Location = new System.Drawing.Point(8, 16);
         this.lblStatus.Name = "lblStatus";
         this.lblStatus.Size = new System.Drawing.Size(120, 24);
         this.lblStatus.TabIndex = 31;
         this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // GroupBox1
         // 
         this.GroupBox1.Controls.Add(this.lblRPTicksFilter);
         this.GroupBox1.Controls.Add(this.Label13);
         this.GroupBox1.Controls.Add(this.lblRPRangeEnd);
         this.GroupBox1.Controls.Add(this.Label12);
         this.GroupBox1.Controls.Add(this.lblRPSessionsFilter);
         this.GroupBox1.Controls.Add(this.Label10);
         this.GroupBox1.Controls.Add(this.lblRPRangeStart);
         this.GroupBox1.Controls.Add(this.Label8);
         this.GroupBox1.Controls.Add(this.lblRPLimit);
         this.GroupBox1.Controls.Add(this.labelLimit);
         this.GroupBox1.Controls.Add(this.lblRPType);
         this.GroupBox1.Controls.Add(this.Label6);
         this.GroupBox1.Controls.Add(this.lblRPSymbol);
         this.GroupBox1.Controls.Add(this.Label4);
         this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox1.Location = new System.Drawing.Point(541, 48);
         this.GroupBox1.Name = "GroupBox1";
         this.GroupBox1.Size = new System.Drawing.Size(499, 166);
         this.GroupBox1.TabIndex = 32;
         this.GroupBox1.TabStop = false;
         this.GroupBox1.Text = "Request Parameters";
         // 
         // lblRPTicksFilter
         // 
         this.lblRPTicksFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPTicksFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPTicksFilter.Location = new System.Drawing.Point(361, 120);
         this.lblRPTicksFilter.Name = "lblRPTicksFilter";
         this.lblRPTicksFilter.Size = new System.Drawing.Size(128, 24);
         this.lblRPTicksFilter.TabIndex = 43;
         this.lblRPTicksFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label13
         // 
         this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label13.Location = new System.Drawing.Point(265, 120);
         this.Label13.Name = "Label13";
         this.Label13.Size = new System.Drawing.Size(88, 24);
         this.Label13.TabIndex = 42;
         this.Label13.Text = "Ticks Filter :";
         this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPRangeEnd
         // 
         this.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPRangeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPRangeEnd.Location = new System.Drawing.Point(361, 88);
         this.lblRPRangeEnd.Name = "lblRPRangeEnd";
         this.lblRPRangeEnd.Size = new System.Drawing.Size(128, 24);
         this.lblRPRangeEnd.TabIndex = 41;
         this.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label12
         // 
         this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label12.Location = new System.Drawing.Point(265, 88);
         this.Label12.Name = "Label12";
         this.Label12.Size = new System.Drawing.Size(88, 24);
         this.Label12.TabIndex = 40;
         this.Label12.Text = "Range End :";
         this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPSessionsFilter
         // 
         this.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPSessionsFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPSessionsFilter.Location = new System.Drawing.Point(129, 120);
         this.lblRPSessionsFilter.Name = "lblRPSessionsFilter";
         this.lblRPSessionsFilter.Size = new System.Drawing.Size(120, 24);
         this.lblRPSessionsFilter.TabIndex = 39;
         this.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label10
         // 
         this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label10.Location = new System.Drawing.Point(9, 120);
         this.Label10.Name = "Label10";
         this.Label10.Size = new System.Drawing.Size(112, 24);
         this.Label10.TabIndex = 38;
         this.Label10.Text = "Sessions Filter :";
         this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPRangeStart
         // 
         this.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPRangeStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPRangeStart.Location = new System.Drawing.Point(129, 88);
         this.lblRPRangeStart.Name = "lblRPRangeStart";
         this.lblRPRangeStart.Size = new System.Drawing.Size(120, 24);
         this.lblRPRangeStart.TabIndex = 37;
         this.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label8
         // 
         this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label8.Location = new System.Drawing.Point(17, 88);
         this.Label8.Name = "Label8";
         this.Label8.Size = new System.Drawing.Size(104, 24);
         this.Label8.TabIndex = 36;
         this.Label8.Text = "Range Start :";
         this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPLimit
         // 
         this.lblRPLimit.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPLimit.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPLimit.Location = new System.Drawing.Point(361, 56);
         this.lblRPLimit.Name = "lblRPLimit";
         this.lblRPLimit.Size = new System.Drawing.Size(128, 24);
         this.lblRPLimit.TabIndex = 35;
         this.lblRPLimit.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // labelLimit
         // 
         this.labelLimit.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.labelLimit.Location = new System.Drawing.Point(268, 56);
         this.labelLimit.Name = "labelLimit";
         this.labelLimit.Size = new System.Drawing.Size(85, 24);
         this.labelLimit.TabIndex = 34;
         this.labelLimit.Text = "Ticks Limit :";
         this.labelLimit.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPType
         // 
         this.lblRPType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPType.Location = new System.Drawing.Point(129, 56);
         this.lblRPType.Name = "lblRPType";
         this.lblRPType.Size = new System.Drawing.Size(120, 24);
         this.lblRPType.TabIndex = 35;
         this.lblRPType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label6
         // 
         this.Label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label6.Location = new System.Drawing.Point(65, 56);
         this.Label6.Name = "Label6";
         this.Label6.Size = new System.Drawing.Size(56, 24);
         this.Label6.TabIndex = 34;
         this.Label6.Text = "Type :";
         this.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblRPSymbol
         // 
         this.lblRPSymbol.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblRPSymbol.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblRPSymbol.Location = new System.Drawing.Point(129, 24);
         this.lblRPSymbol.Name = "lblRPSymbol";
         this.lblRPSymbol.Size = new System.Drawing.Size(120, 24);
         this.lblRPSymbol.TabIndex = 33;
         this.lblRPSymbol.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label4
         // 
         this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label4.Location = new System.Drawing.Point(41, 24);
         this.Label4.Name = "Label4";
         this.Label4.Size = new System.Drawing.Size(80, 24);
         this.Label4.TabIndex = 32;
         this.Label4.Text = "Symbol :";
         this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // PictureBox2
         // 
         this.PictureBox2.BackColor = System.Drawing.Color.Black;
         this.PictureBox2.Location = new System.Drawing.Point(-96, 220);
         this.PictureBox2.Name = "PictureBox2";
         this.PictureBox2.Size = new System.Drawing.Size(1272, 1);
         this.PictureBox2.TabIndex = 33;
         this.PictureBox2.TabStop = false;
         // 
         // PictureBox3
         // 
         this.PictureBox3.BackColor = System.Drawing.Color.Black;
         this.PictureBox3.Location = new System.Drawing.Point(-96, 300);
         this.PictureBox3.Name = "PictureBox3";
         this.PictureBox3.Size = new System.Drawing.Size(1272, 3);
         this.PictureBox3.TabIndex = 34;
         this.PictureBox3.TabStop = false;
         // 
         // GroupBox2
         // 
         this.GroupBox2.Controls.Add(this.txtTagValue);
         this.GroupBox2.Controls.Add(this.txtTagName);
         this.GroupBox2.Controls.Add(this.Label14);
         this.GroupBox2.Controls.Add(this.Label18);
         this.GroupBox2.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox2.Location = new System.Drawing.Point(8, 229);
         this.GroupBox2.Name = "GroupBox2";
         this.GroupBox2.Size = new System.Drawing.Size(504, 59);
         this.GroupBox2.TabIndex = 4;
         this.GroupBox2.TabStop = false;
         this.GroupBox2.Text = "Tags";
         // 
         // txtTagValue
         // 
         this.txtTagValue.Location = new System.Drawing.Point(352, 24);
         this.txtTagValue.Name = "txtTagValue";
         this.txtTagValue.Size = new System.Drawing.Size(144, 25);
         this.txtTagValue.TabIndex = 1;
         this.txtTagValue.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagValue_KeyDown);
         // 
         // txtTagName
         // 
         this.txtTagName.Location = new System.Drawing.Point(72, 24);
         this.txtTagName.Name = "txtTagName";
         this.txtTagName.Size = new System.Drawing.Size(144, 25);
         this.txtTagName.TabIndex = 0;
         this.txtTagName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagName_KeyDown);
         // 
         // Label14
         // 
         this.Label14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label14.Location = new System.Drawing.Point(288, 24);
         this.Label14.Name = "Label14";
         this.Label14.Size = new System.Drawing.Size(56, 24);
         this.Label14.TabIndex = 40;
         this.Label14.Text = "Value :";
         this.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // Label18
         // 
         this.Label18.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label18.Location = new System.Drawing.Point(8, 24);
         this.Label18.Name = "Label18";
         this.Label18.Size = new System.Drawing.Size(56, 24);
         this.Label18.TabIndex = 36;
         this.Label18.Text = "Name :";
         this.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // GroupBox3
         // 
         this.GroupBox3.Controls.Add(this.lblOEnd);
         this.GroupBox3.Controls.Add(this.Label16);
         this.GroupBox3.Controls.Add(this.lblOStart);
         this.GroupBox3.Controls.Add(this.Label20);
         this.GroupBox3.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox3.Location = new System.Drawing.Point(541, 228);
         this.GroupBox3.Name = "GroupBox3";
         this.GroupBox3.Size = new System.Drawing.Size(499, 59);
         this.GroupBox3.TabIndex = 42;
         this.GroupBox3.TabStop = false;
         this.GroupBox3.Text = "Output Parameters";
         // 
         // lblOEnd
         // 
         this.lblOEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblOEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblOEnd.Location = new System.Drawing.Point(361, 24);
         this.lblOEnd.Name = "lblOEnd";
         this.lblOEnd.Size = new System.Drawing.Size(128, 24);
         this.lblOEnd.TabIndex = 41;
         this.lblOEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label16
         // 
         this.Label16.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label16.Location = new System.Drawing.Point(281, 24);
         this.Label16.Name = "Label16";
         this.Label16.Size = new System.Drawing.Size(72, 24);
         this.Label16.TabIndex = 40;
         this.Label16.Text = "End :";
         this.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // lblOStart
         // 
         this.lblOStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
         this.lblOStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lblOStart.Location = new System.Drawing.Point(129, 24);
         this.lblOStart.Name = "lblOStart";
         this.lblOStart.Size = new System.Drawing.Size(120, 24);
         this.lblOStart.TabIndex = 37;
         this.lblOStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
         // 
         // Label20
         // 
         this.Label20.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label20.Location = new System.Drawing.Point(49, 25);
         this.Label20.Name = "Label20";
         this.Label20.Size = new System.Drawing.Size(72, 24);
         this.Label20.TabIndex = 36;
         this.Label20.Text = "Start :";
         this.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // GroupBoxTicks
         // 
         this.GroupBoxTicks.Controls.Add(this.lvTicks);
         this.GroupBoxTicks.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBoxTicks.Location = new System.Drawing.Point(8, 308);
         this.GroupBoxTicks.Name = "GroupBoxTicks";
         this.GroupBoxTicks.Size = new System.Drawing.Size(1032, 296);
         this.GroupBoxTicks.TabIndex = 5;
         this.GroupBoxTicks.TabStop = false;
         this.GroupBoxTicks.Text = "Resolved Ticks";
         // 
         // lvTicks
         // 
         this.lvTicks.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.EmptyColumn,
            this.Timestamp,
            this.Price,
            this.Volume,
            this.VolumeFractional,
            this.PriceType,
            this.CorrectionType,
            this.SalesConditionLabel,
            this.SalesConditionCode,
            this.ContributorId,
            this.ContributorIdCode,
            this.MarketState});
         this.lvTicks.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lvTicks.FullRowSelect = true;
         this.lvTicks.GridLines = true;
         this.lvTicks.Location = new System.Drawing.Point(8, 24);
         this.lvTicks.MultiSelect = false;
         this.lvTicks.Name = "lvTicks";
         this.lvTicks.Size = new System.Drawing.Size(1016, 266);
         this.lvTicks.TabIndex = 0;
         this.lvTicks.UseCompatibleStateImageBehavior = false;
         this.lvTicks.View = System.Windows.Forms.View.Details;
         // 
         // EmptyColumn
         // 
         this.EmptyColumn.Text = "";
         this.EmptyColumn.Width = 0;
         // 
         // Timestamp
         // 
         this.Timestamp.Text = "Timestamp";
         this.Timestamp.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Timestamp.Width = 162;
         // 
         // Price
         // 
         this.Price.Text = "Price";
         this.Price.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Price.Width = 63;
         // 
         // Volume
         // 
         this.Volume.Text = "Volume";
         this.Volume.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.Volume.Width = 56;
         // 
         // VolumeFractional
         // 
         this.VolumeFractional.Text = "VolumeFractional";
         this.VolumeFractional.Width = 120;
         // 
         // PriceType
         // 
         this.PriceType.Text = "Type";
         this.PriceType.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.PriceType.Width = 62;
         // 
         // CorrectionType
         // 
         this.CorrectionType.Text = "CorrectionType";
         this.CorrectionType.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.CorrectionType.Width = 101;
         // 
         // SalesConditionLabel
         // 
         this.SalesConditionLabel.Text = "SalesConditionLabel";
         this.SalesConditionLabel.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.SalesConditionLabel.Width = 130;
         // 
         // SalesConditionCode
         // 
         this.SalesConditionCode.Text = "SalesConditionCode";
         this.SalesConditionCode.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.SalesConditionCode.Width = 129;
         // 
         // ContributorId
         // 
         this.ContributorId.Text = "ContributorId";
         this.ContributorId.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ContributorId.Width = 86;
         // 
         // ContributorIdCode
         // 
         this.ContributorIdCode.Text = "ContributorIdCode";
         this.ContributorIdCode.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ContributorIdCode.Width = 118;
         // 
         // MarketState
         // 
         this.MarketState.Text = "MarketState";
         this.MarketState.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.MarketState.Width = 104;
         // 
         // GroupBox5
         // 
         this.GroupBox5.Controls.Add(this.btnShow);
         this.GroupBox5.Controls.Add(this.gbIndexInterval);
         this.GroupBox5.Controls.Add(this.optTimeInterval);
         this.GroupBox5.Controls.Add(this.optIndexInterval);
         this.GroupBox5.Controls.Add(this.lvShownTicks);
         this.GroupBox5.Controls.Add(this.gbTimeInterval);
         this.GroupBox5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.GroupBox5.Location = new System.Drawing.Point(8, 610);
         this.GroupBox5.Name = "GroupBox5";
         this.GroupBox5.Size = new System.Drawing.Size(1032, 288);
         this.GroupBox5.TabIndex = 6;
         this.GroupBox5.TabStop = false;
         this.GroupBox5.Text = "Ticks Filtered by Index or Time Interval";
         // 
         // btnShow
         // 
         this.btnShow.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.btnShow.Location = new System.Drawing.Point(760, 48);
         this.btnShow.Name = "btnShow";
         this.btnShow.Size = new System.Drawing.Size(96, 24);
         this.btnShow.TabIndex = 4;
         this.btnShow.Text = "Show";
         this.btnShow.Click += new System.EventHandler(this.btnShow_Click);
         // 
         // gbIndexInterval
         // 
         this.gbIndexInterval.Controls.Add(this.Label3);
         this.gbIndexInterval.Controls.Add(this.nudEnd);
         this.gbIndexInterval.Controls.Add(this.Label2);
         this.gbIndexInterval.Controls.Add(this.nudStart);
         this.gbIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbIndexInterval.Location = new System.Drawing.Point(352, 16);
         this.gbIndexInterval.Name = "gbIndexInterval";
         this.gbIndexInterval.Size = new System.Drawing.Size(400, 56);
         this.gbIndexInterval.TabIndex = 3;
         this.gbIndexInterval.TabStop = false;
         this.gbIndexInterval.Text = "Index Interval";
         // 
         // Label3
         // 
         this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label3.Location = new System.Drawing.Point(200, 24);
         this.Label3.Name = "Label3";
         this.Label3.Size = new System.Drawing.Size(48, 24);
         this.Label3.TabIndex = 74;
         this.Label3.Text = "End: ";
         this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // nudEnd
         // 
         this.nudEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.nudEnd.Location = new System.Drawing.Point(256, 24);
         this.nudEnd.Maximum = new decimal(new int[] {
            10000000,
            0,
            0,
            0});
         this.nudEnd.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
         this.nudEnd.Name = "nudEnd";
         this.nudEnd.Size = new System.Drawing.Size(128, 22);
         this.nudEnd.TabIndex = 1;
         this.nudEnd.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
         // 
         // Label2
         // 
         this.Label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label2.Location = new System.Drawing.Point(8, 24);
         this.Label2.Name = "Label2";
         this.Label2.Size = new System.Drawing.Size(48, 24);
         this.Label2.TabIndex = 70;
         this.Label2.Text = "Start: ";
         this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // nudStart
         // 
         this.nudStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.nudStart.Location = new System.Drawing.Point(64, 24);
         this.nudStart.Maximum = new decimal(new int[] {
            10000000,
            0,
            0,
            0});
         this.nudStart.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
         this.nudStart.Name = "nudStart";
         this.nudStart.Size = new System.Drawing.Size(128, 22);
         this.nudStart.TabIndex = 0;
         this.nudStart.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
         // 
         // optTimeInterval
         // 
         this.optTimeInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.optTimeInterval.Location = new System.Drawing.Point(200, 48);
         this.optTimeInterval.Name = "optTimeInterval";
         this.optTimeInterval.Size = new System.Drawing.Size(168, 24);
         this.optTimeInterval.TabIndex = 1;
         this.optTimeInterval.TabStop = true;
         this.optTimeInterval.Text = "Show by Time Interval";
         this.optTimeInterval.CheckedChanged += new System.EventHandler(this.optIndexOrTimeInterval_CheckedChanged);
         // 
         // optIndexInterval
         // 
         this.optIndexInterval.Checked = true;
         this.optIndexInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.optIndexInterval.Location = new System.Drawing.Point(200, 24);
         this.optIndexInterval.Name = "optIndexInterval";
         this.optIndexInterval.Size = new System.Drawing.Size(168, 24);
         this.optIndexInterval.TabIndex = 0;
         this.optIndexInterval.TabStop = true;
         this.optIndexInterval.Text = "Show by Index Interval";
         this.optIndexInterval.CheckedChanged += new System.EventHandler(this.optIndexOrTimeInterval_CheckedChanged);
         // 
         // lvShownTicks
         // 
         this.lvShownTicks.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.ColumnHeader1,
            this.ColumnHeader2,
            this.ColumnHeader3,
            this.ColumnHeader4,
            this.ColumnHeader5,
            this.columnHeader13,
            this.ColumnHeader6,
            this.ColumnHeader7,
            this.ColumnHeader8,
            this.ColumnHeader9,
            this.ColumnHeader10,
            this.ColumnHeader11,
            this.ColumnHeader12});
         this.lvShownTicks.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.lvShownTicks.FullRowSelect = true;
         this.lvShownTicks.GridLines = true;
         this.lvShownTicks.Location = new System.Drawing.Point(8, 80);
         this.lvShownTicks.MultiSelect = false;
         this.lvShownTicks.Name = "lvShownTicks";
         this.lvShownTicks.Size = new System.Drawing.Size(1016, 200);
         this.lvShownTicks.TabIndex = 5;
         this.lvShownTicks.UseCompatibleStateImageBehavior = false;
         this.lvShownTicks.View = System.Windows.Forms.View.Details;
         // 
         // ColumnHeader1
         // 
         this.ColumnHeader1.Text = "";
         this.ColumnHeader1.Width = 0;
         // 
         // ColumnHeader2
         // 
         this.ColumnHeader2.Text = "Index";
         this.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader2.Width = 49;
         // 
         // ColumnHeader3
         // 
         this.ColumnHeader3.Text = "Timestamp";
         this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader3.Width = 162;
         // 
         // ColumnHeader4
         // 
         this.ColumnHeader4.Text = "Price";
         this.ColumnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader4.Width = 63;
         // 
         // ColumnHeader5
         // 
         this.ColumnHeader5.Text = "Volume";
         this.ColumnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader5.Width = 56;
         // 
         // columnHeader13
         // 
         this.columnHeader13.Text = "VolumeFractional";
         this.columnHeader13.Width = 120;
         // 
         // ColumnHeader6
         // 
         this.ColumnHeader6.Text = "Type";
         this.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader6.Width = 62;
         // 
         // ColumnHeader7
         // 
         this.ColumnHeader7.Text = "CorrectionType";
         this.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader7.Width = 101;
         // 
         // ColumnHeader8
         // 
         this.ColumnHeader8.Text = "SalesConditionLabel";
         this.ColumnHeader8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader8.Width = 130;
         // 
         // ColumnHeader9
         // 
         this.ColumnHeader9.Text = "SalesConditionCode";
         this.ColumnHeader9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader9.Width = 129;
         // 
         // ColumnHeader10
         // 
         this.ColumnHeader10.Text = "ContributorId";
         this.ColumnHeader10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader10.Width = 86;
         // 
         // ColumnHeader11
         // 
         this.ColumnHeader11.Text = "ContributorIdCode";
         this.ColumnHeader11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader11.Width = 118;
         // 
         // ColumnHeader12
         // 
         this.ColumnHeader12.Text = "MarketState";
         this.ColumnHeader12.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
         this.ColumnHeader12.Width = 87;
         // 
         // gbTimeInterval
         // 
         this.gbTimeInterval.Controls.Add(this.Label7);
         this.gbTimeInterval.Controls.Add(this.dtpEndRange);
         this.gbTimeInterval.Controls.Add(this.Label5);
         this.gbTimeInterval.Controls.Add(this.dtpStartRange);
         this.gbTimeInterval.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.gbTimeInterval.Location = new System.Drawing.Point(352, 16);
         this.gbTimeInterval.Name = "gbTimeInterval";
         this.gbTimeInterval.Size = new System.Drawing.Size(400, 56);
         this.gbTimeInterval.TabIndex = 2;
         this.gbTimeInterval.TabStop = false;
         this.gbTimeInterval.Text = "Time Interval";
         // 
         // Label7
         // 
         this.Label7.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label7.Location = new System.Drawing.Point(200, 24);
         this.Label7.Name = "Label7";
         this.Label7.Size = new System.Drawing.Size(48, 24);
         this.Label7.TabIndex = 73;
         this.Label7.Text = "End: ";
         this.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // dtpEndRange
         // 
         this.dtpEndRange.CustomFormat = "dd/MM/yyyy HH:mm";
         this.dtpEndRange.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.dtpEndRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
         this.dtpEndRange.Location = new System.Drawing.Point(256, 24);
         this.dtpEndRange.Name = "dtpEndRange";
         this.dtpEndRange.Size = new System.Drawing.Size(128, 22);
         this.dtpEndRange.TabIndex = 1;
         // 
         // Label5
         // 
         this.Label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.Label5.Location = new System.Drawing.Point(8, 24);
         this.Label5.Name = "Label5";
         this.Label5.Size = new System.Drawing.Size(48, 24);
         this.Label5.TabIndex = 71;
         this.Label5.Text = "Start: ";
         this.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // dtpStartRange
         // 
         this.dtpStartRange.CustomFormat = "dd/MM/yyyy HH:mm";
         this.dtpStartRange.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.dtpStartRange.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
         this.dtpStartRange.Location = new System.Drawing.Point(64, 24);
         this.dtpStartRange.Name = "dtpStartRange";
         this.dtpStartRange.Size = new System.Drawing.Size(128, 22);
         this.dtpStartRange.TabIndex = 0;
         // 
         // GroupBox6
         // 
         this.GroupBox6.Controls.Add(this.lblStatus);
         this.GroupBox6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
         this.GroupBox6.Location = new System.Drawing.Point(376, 80);
         this.GroupBox6.Name = "GroupBox6";
         this.GroupBox6.Size = new System.Drawing.Size(136, 48);
         this.GroupBox6.TabIndex = 45;
         this.GroupBox6.TabStop = false;
         this.GroupBox6.Text = "Status";
         // 
         // lblError
         // 
         this.lblError.ForeColor = System.Drawing.Color.Red;
         this.lblError.Location = new System.Drawing.Point(24, 136);
         this.lblError.Name = "lblError";
         this.lblError.Size = new System.Drawing.Size(511, 78);
         this.lblError.TabIndex = 46;
         // 
         // frmTicks
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
         this.ClientSize = new System.Drawing.Size(1048, 904);
         this.Controls.Add(this.lblError);
         this.Controls.Add(this.GroupBox6);
         this.Controls.Add(this.GroupBox5);
         this.Controls.Add(this.GroupBoxTicks);
         this.Controls.Add(this.GroupBox2);
         this.Controls.Add(this.PictureBox3);
         this.Controls.Add(this.PictureBox2);
         this.Controls.Add(this.GroupBox1);
         this.Controls.Add(this.btnRemoveAll);
         this.Controls.Add(this.btnRemove);
         this.Controls.Add(this.btnRequest);
         this.Controls.Add(this.cmbTicks);
         this.Controls.Add(this.lblDataConnection);
         this.Controls.Add(this.PictureBox1);
         this.Controls.Add(this.llWeb);
         this.Controls.Add(this.GroupBox3);
         this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
         this.MaximizeBox = false;
         this.Name = "frmTicks";
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
         this.Text = "Ticks";
         this.Closing += new System.ComponentModel.CancelEventHandler(this.frmTicks_Closing);
         this.Load += new System.EventHandler(this.frmTicks_Load);
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox1)).EndInit();
         this.GroupBox1.ResumeLayout(false);
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox2)).EndInit();
         ((System.ComponentModel.ISupportInitialize)(this.PictureBox3)).EndInit();
         this.GroupBox2.ResumeLayout(false);
         this.GroupBox2.PerformLayout();
         this.GroupBox3.ResumeLayout(false);
         this.GroupBoxTicks.ResumeLayout(false);
         this.GroupBox5.ResumeLayout(false);
         this.gbIndexInterval.ResumeLayout(false);
         ((System.ComponentModel.ISupportInitialize)(this.nudEnd)).EndInit();
         ((System.ComponentModel.ISupportInitialize)(this.nudStart)).EndInit();
         this.gbTimeInterval.ResumeLayout(false);
         this.GroupBox6.ResumeLayout(false);
         this.ResumeLayout(false);

        }

        #endregion

        /// <summary>
        /// Creates a CEL object, changes its configurations, and starts up the created CEL object.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data.
        /// </param>
        private void frmTicks_Load(System.Object sender, System.EventArgs e)
        {
            try
            {
                // Creates the CQGCEL object
                CEL = new CQGCEL();
                CEL.DataError += CEL_DataError;
                CEL.DataConnectionStatusChanged += CEL_DataConnectionStatusChanged;
                CEL.TicksResolved += CEL_TicksResolved;
                CEL.TicksAdded += CEL_TicksAdded;
                CEL.TicksRemoved += CEL_TicksRemoved;
                CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
                CEL.APIConfiguration.CollectionsThrowException = false;
                CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;
                // Disables the controls
                CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);

                // Starts up the CQGCEL
                CEL.Startup();

                cmbTicks.Items.Clear();
                cmbTicks.SelectedIndex = -1;

                ClearAllData();

                m_CurTicks = null;
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "frmTicks_Load", ex);
                this.Close();
            }
        }

        /// <summary>
        /// Shuts down CEL.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// A CancelEventArgs that contains the event data.
        /// </param>
        private void frmTicks_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (CEL != null)
            {
                CEL.Shutdown();
            }
        }

        /// <summary>
        /// Opens frmTicksRequestSettings and with passed values requests ticks.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data.
        /// </param>
        private void btnRequest_Click(System.Object sender, System.EventArgs e)
        {
            frmTicksRequestSettings frmTicksReq;
            CQGTicks ticks;
            CQGTicksRequest req;

            try
            {
                // Opens the form to fill up request data
                frmTicksReq = new frmTicksRequestSettings();
                req = CEL.CreateTicksRequest();
                req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

                frmTicksReq.TicksRequest = req;
                frmTicksReq.LineTime = CEL.Environment.LineTime;

                // If the user confirms, request is sent to CQGCEL and added to the requests list
                if (frmTicksReq.ShowDialog(this) == DialogResult.OK)
                {
                    ticks = CEL.RequestTicks(req);

                    cmbTicks.Items.Add(ticks.Id);
                    cmbTicks.SelectedIndex = cmbTicks.Items.Count - 1;

                    ChangeControlsStatuses();
                }
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "btnRequest_Click", ex);
            }
        }

        /// <summary>
        /// Changes to show the selected ticks info.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data
        /// </param>
        private void cmbTicks_SelectedIndexChanged(System.Object sender, System.EventArgs e)
        {
            try
            {
                if (cmbTicks.SelectedIndex > -1)
                {
                    // Gets the selected tick object from CQGCEL by it's ID
                    m_CurTicks = CEL.AllTicks.get_ItemById(cmbTicks.Text);

                    ClearAllData();
                    DumpAllData();

                    DumpFilterInfo();
                }

                ChangeControlsStatuses();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "cmbTicks_SelectedIndexChanged", ex);
            }
        }

        /// <summary>
        /// Changes the visibility of groupboxes.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data.
        /// </param>
        private void optIndexOrTimeInterval_CheckedChanged(System.Object sender, System.EventArgs e)
        {
            try
            {
                gbIndexInterval.Visible = optIndexInterval.Checked;
                gbTimeInterval.Visible = optTimeInterval.Checked;
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "optIndexOrTimeInterval_CheckedChanged", ex);
            }
        }

        /// <summary>
        /// Shows few data from the selected ticks collection.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data.
        /// </param>
        private void btnShow_Click(System.Object sender, System.EventArgs e)
        {
            int iStart;
            int iEnd;
            DateTime dStart;
            DateTime dEnd;

            try
            {
                lvShownTicks.Items.Clear();

                if (optIndexInterval.Checked)
                {
                    iStart = System.Convert.ToInt32(nudStart.Value) - 1;
                    iEnd = System.Convert.ToInt32(nudEnd.Value) - 1;
                    if (iStart > iEnd || iEnd > m_CurTicks.Count - 1 || iEnd - iStart >= MAX_INDEX_INTERVAL)
                    {
                        MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " messages," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                }
                else
                {
                    // To get time with 00 seconds
                    dStart = dtpStartRange.Value.AddSeconds(-dtpStartRange.Value.Second);
                    dEnd = dtpEndRange.Value.AddSeconds(-dtpEndRange.Value.Second);
                    double dDiffInMins = dEnd.Subtract(dStart).TotalMinutes;
                    if (dDiffInMins < 0 || dDiffInMins >= MAX_TIME_INTERVAL)
                    {
                        MessageBox.Show("The start time must be earlier than the end time and their" + Environment.NewLine + "time range must indicate to no more than " + MAX_TIME_INTERVAL + " minutes.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    // Requesting index range for given time range
                    m_CurTicks.IndicesForDates(dStart, dEnd.AddMinutes(1), out iStart, out iEnd);
                    if (!(CEL.IsValid(iStart) && CEL.IsValid(iEnd)))
                    {
                        MessageBox.Show("There is no data to be shown for the given interval.", "No data to be shown", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        return;
                    }
                }

                lvShownTicks.SuspendLayout();
                for (int i = iStart; i <= iEnd; i++)
                {
                    DumpRecord(lvShownTicks, m_CurTicks[i], i + 1);
                }
                lvShownTicks.ResumeLayout(false);
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "btnShow_Click", ex);
            }
        }

        /// <summary>
        /// Removes the selected tick from the list and the CQGCEL.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data.
        /// </param>
        private void btnRemove_Click(System.Object sender, System.EventArgs e)
        {
            try
            {
                // Removes ticks from the collection
                CEL.RemoveTicks(m_CurTicks);

                // Removes ticks from the combo box
                cmbTicks.Items.RemoveAt(cmbTicks.SelectedIndex);

                cmbTicks.SelectedIndex = cmbTicks.Items.Count - 1;

                if (cmbTicks.Items.Count == 0)
                {
                    cmbTicks.SelectedIndex = -1;
                    ClearAllData();
                    m_CurTicks = null;
                }

                ChangeControlsStatuses();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "btnRemove_Click", ex);
            }
        }

        /// <summary>
        /// Removes all ticks from the list and the CQGCEL.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// An EventArgs that contains the event data.
        /// </param>
        private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
        {
            try
            {
                // Clears the combo box
                cmbTicks.Items.Clear();
                cmbTicks.SelectedIndex = -1;

                // Removes all ticks from the collection
                CEL.RemoveAllTicks();

                m_CurTicks = null;

                ClearAllData();

                ChangeControlsStatuses();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "btnRemoveAll_Click", ex);
            }
        }

        /// <summary>
        /// Shows tag value of the current ticks corresponding to the entered name.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// A KeyEventArgs that contains the event data.
        /// </param>
        private void txtTagName_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            try
            {
                if (txtTagName.Text.Trim().Length == 0)
                {
                    return;
                }

                if (e.KeyCode == Keys.Return)
                {
                    object tagValue = m_CurTicks.get_Tag(txtTagName.Text);
                    if (tagValue != null)
                    {
                        txtTagValue.Text = tagValue.ToString();
                    }
                }
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "txtTagName_KeyDown", ex);
            }
        }

        /// <summary>
        /// Sets the tag value of the current ticks corresponding to the entered name.
        /// </summary>
        /// <param name="sender">
        /// The source of the event.
        /// </param>
        /// <param name="e">
        /// A KeyEventArgs that contains the event data.
        /// </param>
        private void txtTagValue_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            try
            {
                if (txtTagName.Text.Trim().Length == 0)
                {
                    return;
                }

                if (e.KeyCode == Keys.Return)
                {
                    if (txtTagValue.Text.Trim().Length == 0)
                    {
                        m_CurTicks.set_Tag(txtTagName.Text, null);
                    }
                    else
                    {
                        m_CurTicks.set_Tag(txtTagName.Text, txtTagValue.Text);
                    }
                    txtTagName.Text = "";
                    txtTagValue.Text = "";
                }
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "txtTagValue_KeyDown", ex);
            }
        }

        /// <summary>
        /// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
        /// </summary>
        /// <param name="cqg_error">
        /// The object, in which the error has occurred.
        /// </param>
        /// <param name="error_description">
        /// The string, describing the error.
        /// </param>
        private void CEL_DataError(object cqg_error, string error_description)
        {
            try
            {
                CQGError cqgErr = cqg_error as CQGError;
                if (CEL.IsValid(cqgErr))
                {
                    if (cqgErr.Code == 102)
                    {
                        error_description += " Restart the application.";
                    }
                    else if (cqgErr.Code == 125)
                    {
                        error_description += " Turn on CQG Client and restart the application.";
                    }
                }

                MessageBox.Show(error_description, "Ticks", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "CEL_DataError", ex);
            }
        }

        /// <summary>
        /// This event is fired, when some changes occur in the connection with CQG data server.
        /// </summary>
        /// <param name="newStatus">
        /// The current status of the connection with the data server.
        /// </param>
        private void CEL_DataConnectionStatusChanged(CQG.eConnectionStatus new_status)
        {
            try
            {
                string sInfo;
                System.Drawing.Color BackCol;

                if (new_status == eConnectionStatus.csConnectionUp)
                {
                    BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
                    sInfo = "DATA Connection is UP";
                }
                else if (new_status == eConnectionStatus.csConnectionDelayed)
                {
                    BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
                    sInfo = "DATA Connection is Delayed";
                }
                else
                {
                    BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
                    sInfo = "DATA Connection is Down";
                }

                lblDataConnection.BackColor = BackCol;
                lblDataConnection.Text = sInfo;

                ChangeControlsStatuses();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "CEL_DataConnectionStatusChanged", ex);
            }
        }

        /// <summary>
        /// Fired when the collection of ticks (CQGTicks) is resolved or
        /// when some error has occurred during ticks request processing.
        /// </summary>
        /// <param name="cqg_ticks">
        /// Reference to resolved CQGTicks
        /// </param>
        /// <param name="cqg_error">
        /// The CQGError object that describes the last error occurred
        /// while processing the ticks request or
        /// Nothing/Invalid_Error in case of no error.
        /// </param>
        private void CEL_TicksResolved(CQG.CQGTicks cqg_ticks, CQG.CQGError cqg_error)
        {
            try
            {
                if (cqg_ticks.Id == m_CurTicks.Id)
                {
                    ClearAllData();
                    DumpAllData();
                    DumpFilterInfo();
                }
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "CEL_TicksResolved", ex);
            }
        }

        /// <summary>
        /// This event is fired when CQGTick items are added to the ticks collection.
        /// </summary>
        /// <param name="cqg_ticks">
        /// Reference to changed CQGTicks
        /// </param>
        /// <param name="added_ticks_count">
        /// Specifies the number of added ticks towards the end of CQGTicks
        /// </param>
        private void CEL_TicksAdded(CQG.CQGTicks cqg_ticks, int added_ticks_count)
        {
            try
            {
                if (cqg_ticks.Id != m_CurTicks.Id)
                {
                    return;
                }

                DumpRecords(added_ticks_count);

                DumpOutputParams();

            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "CEL_TicksAdded", ex);
            }
        }

        /// <summary>
        /// This event is fired when CQGTick items are removed from the ticks collection.
        /// </summary>
        /// <param name="cqg_ticks">
        /// Reference to changed CQGTicks.
        /// </param>
        /// <param name="added_ticks_count">
        /// Specifies the index of removed tick.
        /// </param>
        private void CEL_TicksRemoved(CQG.CQGTicks cqg_ticks, int index)
        {
            try
            {
                if (cqg_ticks.Id != m_CurTicks.Id)
                {
                    return;
                }

                lvTicks.Items.RemoveAt(lvTicks.Items.Count - index - 1);
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "CEL_TicksRemoved", ex);
            }
        }

        /// <summary>
        /// Shows the selected request parameters on the listview.
        /// </summary>
        private void DumpRequestParams()
        {
            CQGTicksRequest req;

            try
            {
                req = m_CurTicks.Request;

                lblRPSymbol.Text = req.Symbol;
                lblRPType.Text = req.Type.ToString();
                lblRPRangeStart.Text = GetValueAsString(req.RangeStart);
                lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd);

                var sessionFilter = req.SessionsFilter.ToString();
                switch (sessionFilter)
                {
                    case "0": sessionFilter = "Primary session only (0)"; break;
                    case "31": sessionFilter = "All sessions (31)"; break;
                }
                lblRPSessionsFilter.Text = sessionFilter;
                lblRPTicksFilter.Text = req.TickFilter.ToString();

                if (m_CurTicks.LastError != null)
                {
                    lblError.Text = m_CurTicks.LastError.Description;
                }

                try
                {
                    lblRPLimit.Text = req.Limit.ToString();
                }
                catch (Exception)
                {
                    lblRPLimit.Text = "Unlimited";
                }
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "DumpRequestParams", ex);
            }
        }

        /// <summary>
        /// Shows the selected request outputs on the listview.
        /// </summary>
        private void DumpOutputParams()
        {
            try
            {
                lblOStart.Text = GetValueAsString(m_CurTicks.StartTimestamp);
                lblOEnd.Text = GetValueAsString(m_CurTicks.EndTimestamp);
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "DumpOutputParams", ex);
            }
        }

        /// <summary>
        /// Shows added ticks for the selected request records on the listview.
        /// </summary>
        /// <param name="addedTicksCount">
        /// Count of ticks that will be shown.
        /// </param>
        private void DumpRecords(int addedTicksCount)
        {
            try
            {
                if (m_CurTicks.Count == 0)
                {
                    return;
                }

                for (int i = m_CurTicks.Count - addedTicksCount; i < m_CurTicks.Count; i++)
                {
                    DumpRecord(lvTicks, m_CurTicks[i], i + 1);
                }
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "DumpRecords", ex);
            }
        }

        /// <summary>
        /// Dumps one record's values to the listview.
        /// </summary>
        /// <param name="lv">
        /// Listview, in which data must be shown.
        /// </param>
        /// <param name="tick">
        /// Record, which values must be shown.
        /// </param>
        /// <param name="recordIndex">
        /// Index of record, which values must be shown.
        /// </param>
        private void DumpRecord(ListView lv, CQGTick tick, long recordIndex)
        {
            try
            {
                ListViewItem item = lv.Items.Insert(0, new ListViewItem());
                item.SubItems.Add("Timestamp").Text = GetValueAsString(tick.Timestamp, true);
                item.SubItems.Add("Price").Text = GetValueAsString(tick.Price);
                item.SubItems.Add("Volume").Text = GetValueAsString(tick.Volume);
                item.SubItems.Add("VolumeFractional").Text = GetValueAsString(tick.VolumeFractional);
                item.SubItems.Add("PriceType").Text = tick.PriceType.ToString();
                item.SubItems.Add("CorrectionType").Text = tick.CorrectionType.ToString();
                item.SubItems.Add("SalesConditionLabel").Text = tick.SalesConditionLabel;
                item.SubItems.Add("SalesConditionCode").Text = tick.SalesConditionCode.ToString();
                item.SubItems.Add("ContributorId").Text = tick.ContributorId;
                item.SubItems.Add("ContributorIdCode").Text = tick.ContributorIdCode.ToString();
                item.SubItems.Add("MarketState").Text = tick.MarketState.ToString();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "DumpRecord", ex);
            }
        }

        /// <summary>
        /// Dumps all request data (outputs\parameters\records)
        /// </summary>
        private void DumpAllData()
        {
            try
            {
                DumpRequestParams();

                lblStatus.Text = m_CurTicks.Status.ToString();

                if (m_CurTicks.Status == eRequestStatus.rsSuccess)
                {
                    DumpOutputParams();
                    DumpRecords(m_CurTicks.Count);
                }

                ChangeControlsStatuses();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "DumpAllData", ex);
            }
        }

        /// <summary>
        /// Initializes the filter-related controls.
        /// </summary>
        private void DumpFilterInfo()
        {
            try
            {
                if (m_CurTicks != null && m_CurTicks.Status == eRequestStatus.rsSuccess)
                {
                    dtpStartRange.Value = m_CurTicks.StartTimestamp;
                    dtpEndRange.Value = m_CurTicks.EndTimestamp;
                }
                else
                {
                    dtpStartRange.Value = DateTime.Now;
                    dtpEndRange.Value = DateTime.Now;
                }
                nudStart.Value = 1;
                nudEnd.Value = 1;
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "DumpFilterInfo", ex);
            }
        }

        /// <summary>
        /// Clears all request data.
        /// </summary>
        private void ClearAllData()
        {
            try
            {
                lblStatus.Text = "";

                ClearRequestParams();
                ClearOutputParams();
                ClearTags();
                ClearRecords();

                lvShownTicks.Items.Clear();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "ClearAllData", ex);
            }
        }

        /// <summary>
        /// Clears the request parameters from the listview.
        /// </summary>
        private void ClearRequestParams()
        {
            try
            {
                lblRPSymbol.Text = "";
                lblRPType.Text = "";
                lblRPRangeStart.Text = "";
                lblRPRangeEnd.Text = "";
                lblRPSessionsFilter.Text = "";
                lblRPTicksFilter.Text = "";
                lblRPLimit.Text = "";

                lblError.Text = "";
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "ClearRequestParams", ex);
            }
        }

        /// <summary>
        /// Clears request outputs from the listview.
        /// </summary>
        private void ClearOutputParams()
        {
            try
            {
                lblOStart.Text = "";
                lblOEnd.Text = "";
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "ClearOutputParams", ex);
            }
        }

        /// <summary>
        /// Clears request tags.
        /// </summary>
        private void ClearTags()
        {
            try
            {
                txtTagName.Text = "";
                txtTagValue.Text = "";
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "ClearTags", ex);
            }
        }

        /// <summary>
        /// Clears records from the listview.
        /// </summary>
        private void ClearRecords()
        {
            try
            {
                lvTicks.Items.Clear();
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "ClearRecords", ex);
            }
        }

        /// <summary>
        /// Enables\disables the controls, based on the connection status.
        /// </summary>
        private void ChangeControlsStatuses()
        {
            bool bIsDataConnectionUp = false;
            bool bIsTicksSelected;
            bool bIsTicksSucceded = false;

            try
            {
                if (CEL.IsStarted)
                {
                    bIsDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
                }

                btnRequest.Enabled = bIsDataConnectionUp;

                bIsTicksSelected = m_CurTicks != null;

                btnRemove.Enabled = bIsTicksSelected && bIsDataConnectionUp;
                btnRemoveAll.Enabled = bIsTicksSelected && bIsDataConnectionUp;

                txtTagName.Enabled = bIsTicksSelected;
                txtTagValue.Enabled = bIsTicksSelected;

                if (bIsTicksSelected)
                {
                    bIsTicksSucceded = m_CurTicks.Status == eRequestStatus.rsSuccess;
                }

                dtpEndRange.Enabled = bIsTicksSucceded;
                dtpStartRange.Enabled = bIsTicksSucceded;

                nudEnd.Enabled = bIsTicksSucceded;
                nudStart.Enabled = bIsTicksSucceded;

                optIndexInterval.Enabled = bIsTicksSucceded;
                optTimeInterval.Enabled = bIsTicksSucceded;

                btnShow.Enabled = bIsTicksSucceded;
            }
            catch (Exception ex)
            {
                modErrorHandler.ShowError("frmTicks", "ChangeControlsStatuses", ex);
            }
        }

        /// <summary>
        /// Validates the specified value and converts it to string.
        /// </summary>
        /// <param name="val">
        /// The value that will be validated and converted
        /// </param>
        /// <param name="includeMilliseconds">
        /// The time part presence in the string presentation of the date value
        /// </param>
        /// <returns>
        /// Value converted to string or "N/A" if the value is invalid.
        /// </returns>
        private string GetValueAsString(object val, bool includeMilliseconds = false)
        {
            string sResult = "";

            try
            {
                if (CEL.IsValid(val))
                {
                    if (val.GetType().FullName == "System.DateTime")
                    {
                        string format = includeMilliseconds ? "dd/MM/yyyy HH:mm:ss.fff" : "dd/MM/yyyy HH:mm";
                        sResult = System.Convert.ToDateTime(val).ToString(format);
                    }
                    else
                    {
                        sResult = val.ToString();
                    }
                }
                else
                {
                    sResult = N_A;
                }
            }
            catch
            {
                sResult = N_A;
            }

            return sResult;
        }

    }

}
