using System;
using System.Windows.Forms;

namespace TradableInstruments
{
    sealed class ErrorHandler
    {
        /// <summary>
        /// Handles the error and shows a message box.
        /// </summary>
        /// <param name="modName">
        /// Module name, in which the error has occurred.
        /// </param>
        /// <param name="funcName">
        /// Function name, in which the error has occurred.
        /// </param>
        /// <param name="ex">
        /// Exception generated in the described function, of the described module.
        /// </param>
        public static void HandleError(string modName, string funcName, Exception ex)
        {
            string sMsg;

            sMsg = "Module : " + modName + Environment.NewLine;
            sMsg += "Function : " + funcName + Environment.NewLine;
            sMsg += "Error Source : " + ex.Source + Environment.NewLine;
            sMsg += "Error Description : " + ex.Message;

            MessageBox.Show(sMsg, "Tradable Symbols", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}