Imports System.Windows.Forms

Module ErrorHandler

   ''' <summary>
   ''' Handles the error and shows a message box.
   ''' </summary>
   ''' <param name="modName">
   ''' Module name, in which the error has occurred.
   ''' </param>
   ''' <param name="funcName">
   ''' Function name, in which the error has occurred.
   ''' </param>
   ''' <param name="ex">
   ''' Exception generated in the described function, of the described module.
   ''' </param>
   Public Sub HandleError(ByVal modName As String, _
                          ByVal funcName As String, _
                          ByVal ex As Exception)
      Dim sMsg As String

      sMsg = "Module : " & modName & Environment.NewLine
      sMsg &= "Function : " & funcName & Environment.NewLine
      sMsg &= "Error Source : " & ex.Source & Environment.NewLine
      sMsg &= "Error Description : " & ex.Message

      MessageBox.Show(sMsg, "TradableInstruments", MessageBoxButtons.OK, MessageBoxIcon.Error)
   End Sub

End Module