Imports CQG
Public Class frmTradingSystem
    Inherits System.Windows.Forms.Form

    ' The CQGCEL object, which encapsulates the main functionality of CQG API
    Public WithEvents CEL As CQGCEL

    ' Currently selected trading system object in the combo box
    Private m_CurTradingSystem As CQGTradingSystem

    ' Currently requested TradingSystem definitions object
    Private m_CurTradingSystemDefs As CQGTradingSystemDefinitions

    ' Specifies the not available string
    Private Const N_A As String = "N/A"

    ' Specifies the header of index column
    Private Const INDEX_HEADER As String = "Index"

    ' Specifies the header of timestamp column
    Private Const TIMESTAMP_HEADER As String = "Timestamp"

    ' Specifies the header of timestamp offset column
    Private Const TIMESTAMP_OFFSET_HEADER As String = "Offset"

    ' Specifies the header of signaled column
    Private Const SIGNALED_HEADER As String = "Signaled"

    ' Specifies the header of exit column
    Private Const EXIT_HEADER As String = " - Exit"

    ' Specifies the header of entry column
    Private Const ENTRY_HEADER As String = " - Entry"

    ' Specifies the header of is active column
    Private Const ISACTIVE_HEADER As String = "IsActive"

    ' Specifies the header of signal column
    Private Const SIGNAL_HEADER As String = "Signal"

    ' Specifies the header of price column
    Private Const PRICE_HEADER As String = "Price"

    ' Specifies the header of quantity column
    Private Const QUANTITY_HEADER As String = "Quantity"

    ' Specifies the header of StopLimitPrice column
    Private Const STOP_LIMIT_PRICE_HEADER As String = "StopLimitPrice"

    ' Specifies the header of related item names column
    Private Const RELATED_ITEM_NAME_HEADER As String = "Name"

    ' Specifies the trade name and exit name splitter
    Private Const NAME_SPLITTER As String = " - "

    ' Specifies the max records count
    Private Const MAX_NUMBER_OF_RECORDS As Integer = 10

    ' Specifies the max index interval
    Private Const MAX_INDEX_INTERVAL As Integer = 500

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblDataConnection As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents llWeb As System.Windows.Forms.LinkLabel
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents Label21 As System.Windows.Forms.Label
    Friend WithEvents Label23 As System.Windows.Forms.Label
    Friend WithEvents Label25 As System.Windows.Forms.Label
    Friend WithEvents Label27 As System.Windows.Forms.Label
    Friend WithEvents Label29 As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents tcTradingSystem As System.Windows.Forms.TabControl
    Friend WithEvents tpTradingSystem As System.Windows.Forms.TabPage
    Friend WithEvents tpTrades As System.Windows.Forms.TabPage
    Friend WithEvents tpStatistics As System.Windows.Forms.TabPage
    Friend WithEvents GroupBox7 As System.Windows.Forms.GroupBox
    Friend WithEvents cmbDefinition As System.Windows.Forms.ComboBox
    Friend WithEvents btnReqTradingSystemDefinitions As System.Windows.Forms.Button
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents cmbParameter As System.Windows.Forms.ComboBox
    Friend WithEvents lblParameterComment As System.Windows.Forms.Label
    Friend WithEvents Label28 As System.Windows.Forms.Label
    Friend WithEvents Label24 As System.Windows.Forms.Label
    Friend WithEvents lblParameterDefaultValue As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents lblParameterType As System.Windows.Forms.Label
    Friend WithEvents Label22 As System.Windows.Forms.Label
    Friend WithEvents lblAbbreviation As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents lblCommissionType As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents lblCommission As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents cmbTrade As System.Windows.Forms.ComboBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents lblTradeSide As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents cmbExit As System.Windows.Forms.ComboBox
    Friend WithEvents lblExitOrderType As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents lblExitAllowMoreThanOnce As System.Windows.Forms.Label
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents lblExitAllowExitOnEntry As System.Windows.Forms.Label
    Friend WithEvents Label19 As System.Windows.Forms.Label
    Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label20 As System.Windows.Forms.Label
    Friend WithEvents Label30 As System.Windows.Forms.Label
    Friend WithEvents lblEntryOrderType As System.Windows.Forms.Label
    Friend WithEvents lblEntryAllowPyramids As System.Windows.Forms.Label
    Friend WithEvents lblEntryAllowEntryOnExit As System.Windows.Forms.Label
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents txtTradingSystemName As System.Windows.Forms.TextBox
    Friend WithEvents lblError As System.Windows.Forms.Label
    Friend WithEvents GroupBox6 As System.Windows.Forms.GroupBox
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents GroupBox5 As System.Windows.Forms.GroupBox
    Friend WithEvents txtTagValue As System.Windows.Forms.TextBox
    Friend WithEvents txtTagName As System.Windows.Forms.TextBox
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label18 As System.Windows.Forms.Label
    Friend WithEvents PictureBox3 As System.Windows.Forms.PictureBox
    Friend WithEvents GroupBox8 As System.Windows.Forms.GroupBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label26 As System.Windows.Forms.Label
    Friend WithEvents Label32 As System.Windows.Forms.Label
    Friend WithEvents Label34 As System.Windows.Forms.Label
    Friend WithEvents Label36 As System.Windows.Forms.Label
    Friend WithEvents Label38 As System.Windows.Forms.Label
    Friend WithEvents Label40 As System.Windows.Forms.Label
    Friend WithEvents Label44 As System.Windows.Forms.Label
    Friend WithEvents Label46 As System.Windows.Forms.Label
    Friend WithEvents lblRPRangeEnd As System.Windows.Forms.Label
    Friend WithEvents Label47 As System.Windows.Forms.Label
    Friend WithEvents Label49 As System.Windows.Forms.Label
    Friend WithEvents lblRPRangeStart As System.Windows.Forms.Label
    Friend WithEvents Label50 As System.Windows.Forms.Label
    Friend WithEvents Label52 As System.Windows.Forms.Label
    Friend WithEvents btnRemoveAll As System.Windows.Forms.Button
    Friend WithEvents btnRemove As System.Windows.Forms.Button
    Friend WithEvents btnRequest As System.Windows.Forms.Button
    Friend WithEvents cmbTradingSystem As System.Windows.Forms.ComboBox
    Friend WithEvents lblRPIntradayPeriod As System.Windows.Forms.Label
    Friend WithEvents lblRPEqualizeCloses As System.Windows.Forms.Label
    Friend WithEvents lstRPParameters As System.Windows.Forms.ListBox
    Friend WithEvents lblRPTradingSystemDefinitionName As System.Windows.Forms.Label
    Friend WithEvents lblRPDaysBeforeExpiration As System.Windows.Forms.Label
    Friend WithEvents lblRPContinuation As System.Windows.Forms.Label
    Friend WithEvents lblRPIncludeEnd As System.Windows.Forms.Label
    Friend WithEvents lblRPHistoricalPeriod As System.Windows.Forms.Label
    Friend WithEvents lblRPBaseExpression As System.Windows.Forms.Label
    Friend WithEvents lblRPSessionsFilter As System.Windows.Forms.Label
    Friend WithEvents lblRPSessionFlags As System.Windows.Forms.Label
    Friend WithEvents GroupBox9 As System.Windows.Forms.GroupBox
    Friend WithEvents lvShownStatistics As System.Windows.Forms.ListView
    Friend WithEvents Label31 As System.Windows.Forms.Label
    Friend WithEvents Label33 As System.Windows.Forms.Label
    Friend WithEvents Label35 As System.Windows.Forms.Label
    Friend WithEvents Label37 As System.Windows.Forms.Label
    Friend WithEvents ColumnHeader9 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader10 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader11 As System.Windows.Forms.ColumnHeader
    Friend WithEvents GroupBox10 As System.Windows.Forms.GroupBox
    Friend WithEvents lvStatistics As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader13 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader14 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader15 As System.Windows.Forms.ColumnHeader
    Friend WithEvents btnShowStatistics As System.Windows.Forms.Button
    Friend WithEvents gbTimeIntervalStatistics As System.Windows.Forms.GroupBox
    Friend WithEvents dtpEndRangeStatistics As System.Windows.Forms.DateTimePicker
    Friend WithEvents dtpStartRangeStatistics As System.Windows.Forms.DateTimePicker
    Friend WithEvents gbIndexIntervalStatistics As System.Windows.Forms.GroupBox
    Friend WithEvents nudEndStatistics As System.Windows.Forms.NumericUpDown
    Friend WithEvents nudStartStatistics As System.Windows.Forms.NumericUpDown
    Friend WithEvents optTimeIntervalStatistics As System.Windows.Forms.RadioButton
    Friend WithEvents optIndexIntervalStatistics As System.Windows.Forms.RadioButton
    Friend WithEvents GroupBox11 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox13 As System.Windows.Forms.GroupBox
    Friend WithEvents Label42 As System.Windows.Forms.Label
    Friend WithEvents Label43 As System.Windows.Forms.Label
    Friend WithEvents ColumnHeader1 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader2 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader3 As System.Windows.Forms.ColumnHeader
    Friend WithEvents GroupBox14 As System.Windows.Forms.GroupBox
    Friend WithEvents lvTrades As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader4 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader5 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader6 As System.Windows.Forms.ColumnHeader
    Friend WithEvents cmbTradesNames As System.Windows.Forms.ComboBox
    Friend WithEvents Label45 As System.Windows.Forms.Label
    Friend WithEvents ColumnHeader7 As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvShownTrades As System.Windows.Forms.ListView
    Friend WithEvents btnShowTrades As System.Windows.Forms.Button
    Friend WithEvents nudEndTrades As System.Windows.Forms.NumericUpDown
    Friend WithEvents nudStartTrades As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label41 As System.Windows.Forms.Label
    Friend WithEvents Label51 As System.Windows.Forms.Label
    Friend WithEvents lblRPRecalcPeriod As System.Windows.Forms.Label
    Friend WithEvents lblRPSubscriptionLevel As System.Windows.Forms.Label
    Friend WithEvents cmbTradeItems As System.Windows.Forms.ComboBox
    Friend WithEvents cmbShownTradeItems As System.Windows.Forms.ComboBox
    Friend WithEvents ColumnHeader12 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader16 As System.Windows.Forms.ColumnHeader
    Friend WithEvents gbRelations As System.Windows.Forms.GroupBox
    Friend WithEvents gbShownRelations As System.Windows.Forms.GroupBox
    Friend WithEvents lvTradesRelations As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader8 As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvShownTradesRelations As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader17 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader18 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader19 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader20 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader21 As System.Windows.Forms.ColumnHeader
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lblDataConnection = New System.Windows.Forms.Label
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        Me.llWeb = New System.Windows.Forms.LinkLabel
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label6 = New System.Windows.Forms.Label
        Me.Label27 = New System.Windows.Forms.Label
        Me.Label29 = New System.Windows.Forms.Label
        Me.Label23 = New System.Windows.Forms.Label
        Me.Label25 = New System.Windows.Forms.Label
        Me.Label17 = New System.Windows.Forms.Label
        Me.Label21 = New System.Windows.Forms.Label
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label13 = New System.Windows.Forms.Label
        Me.tcTradingSystem = New System.Windows.Forms.TabControl
        Me.tpTradingSystem = New System.Windows.Forms.TabPage
        Me.txtTradingSystemName = New System.Windows.Forms.TextBox
        Me.lblError = New System.Windows.Forms.Label
        Me.GroupBox6 = New System.Windows.Forms.GroupBox
        Me.lblStatus = New System.Windows.Forms.Label
        Me.GroupBox5 = New System.Windows.Forms.GroupBox
        Me.txtTagValue = New System.Windows.Forms.TextBox
        Me.txtTagName = New System.Windows.Forms.TextBox
        Me.Label14 = New System.Windows.Forms.Label
        Me.Label18 = New System.Windows.Forms.Label
        Me.PictureBox3 = New System.Windows.Forms.PictureBox
        Me.GroupBox8 = New System.Windows.Forms.GroupBox
        Me.lblRPRecalcPeriod = New System.Windows.Forms.Label
        Me.Label41 = New System.Windows.Forms.Label
        Me.lblRPSubscriptionLevel = New System.Windows.Forms.Label
        Me.Label51 = New System.Windows.Forms.Label
        Me.lstRPParameters = New System.Windows.Forms.ListBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.lblRPTradingSystemDefinitionName = New System.Windows.Forms.Label
        Me.Label26 = New System.Windows.Forms.Label
        Me.lblRPDaysBeforeExpiration = New System.Windows.Forms.Label
        Me.Label32 = New System.Windows.Forms.Label
        Me.lblRPEqualizeCloses = New System.Windows.Forms.Label
        Me.Label34 = New System.Windows.Forms.Label
        Me.lblRPContinuation = New System.Windows.Forms.Label
        Me.Label36 = New System.Windows.Forms.Label
        Me.lblRPSessionsFilter = New System.Windows.Forms.Label
        Me.Label38 = New System.Windows.Forms.Label
        Me.lblRPIncludeEnd = New System.Windows.Forms.Label
        Me.Label40 = New System.Windows.Forms.Label
        Me.lblRPHistoricalPeriod = New System.Windows.Forms.Label
        Me.Label44 = New System.Windows.Forms.Label
        Me.lblRPIntradayPeriod = New System.Windows.Forms.Label
        Me.Label46 = New System.Windows.Forms.Label
        Me.lblRPRangeEnd = New System.Windows.Forms.Label
        Me.Label47 = New System.Windows.Forms.Label
        Me.lblRPSessionFlags = New System.Windows.Forms.Label
        Me.Label49 = New System.Windows.Forms.Label
        Me.lblRPRangeStart = New System.Windows.Forms.Label
        Me.Label50 = New System.Windows.Forms.Label
        Me.lblRPBaseExpression = New System.Windows.Forms.Label
        Me.Label52 = New System.Windows.Forms.Label
        Me.btnRemoveAll = New System.Windows.Forms.Button
        Me.btnRemove = New System.Windows.Forms.Button
        Me.btnRequest = New System.Windows.Forms.Button
        Me.cmbTradingSystem = New System.Windows.Forms.ComboBox
        Me.PictureBox2 = New System.Windows.Forms.PictureBox
        Me.GroupBox7 = New System.Windows.Forms.GroupBox
        Me.lblCommission = New System.Windows.Forms.Label
        Me.Label7 = New System.Windows.Forms.Label
        Me.lblCommissionType = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.lblAbbreviation = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.cmbParameter = New System.Windows.Forms.ComboBox
        Me.lblParameterComment = New System.Windows.Forms.Label
        Me.Label28 = New System.Windows.Forms.Label
        Me.Label24 = New System.Windows.Forms.Label
        Me.lblParameterDefaultValue = New System.Windows.Forms.Label
        Me.Label15 = New System.Windows.Forms.Label
        Me.lblParameterType = New System.Windows.Forms.Label
        Me.Label22 = New System.Windows.Forms.Label
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.GroupBox4 = New System.Windows.Forms.GroupBox
        Me.lblEntryOrderType = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.lblEntryAllowPyramids = New System.Windows.Forms.Label
        Me.Label20 = New System.Windows.Forms.Label
        Me.lblEntryAllowEntryOnExit = New System.Windows.Forms.Label
        Me.Label30 = New System.Windows.Forms.Label
        Me.GroupBox3 = New System.Windows.Forms.GroupBox
        Me.cmbExit = New System.Windows.Forms.ComboBox
        Me.lblExitOrderType = New System.Windows.Forms.Label
        Me.Label10 = New System.Windows.Forms.Label
        Me.Label12 = New System.Windows.Forms.Label
        Me.lblExitAllowMoreThanOnce = New System.Windows.Forms.Label
        Me.Label16 = New System.Windows.Forms.Label
        Me.lblExitAllowExitOnEntry = New System.Windows.Forms.Label
        Me.Label19 = New System.Windows.Forms.Label
        Me.cmbTrade = New System.Windows.Forms.ComboBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.lblTradeSide = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.cmbDefinition = New System.Windows.Forms.ComboBox
        Me.btnReqTradingSystemDefinitions = New System.Windows.Forms.Button
        Me.tpTrades = New System.Windows.Forms.TabPage
        Me.cmbTradesNames = New System.Windows.Forms.ComboBox
        Me.Label45 = New System.Windows.Forms.Label
        Me.GroupBox11 = New System.Windows.Forms.GroupBox
        Me.gbShownRelations = New System.Windows.Forms.GroupBox
        Me.lvShownTradesRelations = New System.Windows.Forms.ListView
        Me.ColumnHeader17 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader18 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader19 = New System.Windows.Forms.ColumnHeader
        Me.cmbShownTradeItems = New System.Windows.Forms.ComboBox
        Me.lvShownTrades = New System.Windows.Forms.ListView
        Me.ColumnHeader1 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader2 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader3 = New System.Windows.Forms.ColumnHeader
        Me.btnShowTrades = New System.Windows.Forms.Button
        Me.GroupBox13 = New System.Windows.Forms.GroupBox
        Me.Label42 = New System.Windows.Forms.Label
        Me.nudEndTrades = New System.Windows.Forms.NumericUpDown
        Me.Label43 = New System.Windows.Forms.Label
        Me.nudStartTrades = New System.Windows.Forms.NumericUpDown
        Me.GroupBox14 = New System.Windows.Forms.GroupBox
        Me.gbRelations = New System.Windows.Forms.GroupBox
        Me.lvTradesRelations = New System.Windows.Forms.ListView
        Me.ColumnHeader12 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader16 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader8 = New System.Windows.Forms.ColumnHeader
        Me.cmbTradeItems = New System.Windows.Forms.ComboBox
        Me.lvTrades = New System.Windows.Forms.ListView
        Me.ColumnHeader4 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader5 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader6 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader7 = New System.Windows.Forms.ColumnHeader
        Me.tpStatistics = New System.Windows.Forms.TabPage
        Me.GroupBox9 = New System.Windows.Forms.GroupBox
        Me.lvShownStatistics = New System.Windows.Forms.ListView
        Me.ColumnHeader9 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader10 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader11 = New System.Windows.Forms.ColumnHeader
        Me.btnShowStatistics = New System.Windows.Forms.Button
        Me.gbTimeIntervalStatistics = New System.Windows.Forms.GroupBox
        Me.Label31 = New System.Windows.Forms.Label
        Me.dtpEndRangeStatistics = New System.Windows.Forms.DateTimePicker
        Me.Label33 = New System.Windows.Forms.Label
        Me.dtpStartRangeStatistics = New System.Windows.Forms.DateTimePicker
        Me.gbIndexIntervalStatistics = New System.Windows.Forms.GroupBox
        Me.Label35 = New System.Windows.Forms.Label
        Me.nudEndStatistics = New System.Windows.Forms.NumericUpDown
        Me.Label37 = New System.Windows.Forms.Label
        Me.nudStartStatistics = New System.Windows.Forms.NumericUpDown
        Me.optTimeIntervalStatistics = New System.Windows.Forms.RadioButton
        Me.optIndexIntervalStatistics = New System.Windows.Forms.RadioButton
        Me.GroupBox10 = New System.Windows.Forms.GroupBox
        Me.lvStatistics = New System.Windows.Forms.ListView
        Me.ColumnHeader13 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader14 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader15 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader20 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader21 = New System.Windows.Forms.ColumnHeader
        Me.tcTradingSystem.SuspendLayout()
        Me.tpTradingSystem.SuspendLayout()
        Me.GroupBox6.SuspendLayout()
        Me.GroupBox5.SuspendLayout()
        Me.GroupBox8.SuspendLayout()
        Me.GroupBox7.SuspendLayout()
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.GroupBox4.SuspendLayout()
        Me.GroupBox3.SuspendLayout()
        Me.tpTrades.SuspendLayout()
        Me.GroupBox11.SuspendLayout()
        Me.gbShownRelations.SuspendLayout()
        Me.GroupBox13.SuspendLayout()
        CType(Me.nudEndTrades, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudStartTrades, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.GroupBox14.SuspendLayout()
        Me.gbRelations.SuspendLayout()
        Me.tpStatistics.SuspendLayout()
        Me.GroupBox9.SuspendLayout()
        Me.gbTimeIntervalStatistics.SuspendLayout()
        Me.gbIndexIntervalStatistics.SuspendLayout()
        CType(Me.nudEndStatistics, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudStartStatistics, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.GroupBox10.SuspendLayout()
        Me.SuspendLayout()
        '
        'lblDataConnection
        '
        Me.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblDataConnection.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblDataConnection.Location = New System.Drawing.Point(8, 8)
        Me.lblDataConnection.Name = "lblDataConnection"
        Me.lblDataConnection.Size = New System.Drawing.Size(216, 16)
        Me.lblDataConnection.TabIndex = 2
        Me.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'PictureBox1
        '
        Me.PictureBox1.BackColor = System.Drawing.Color.Black
        Me.PictureBox1.Location = New System.Drawing.Point(0, 40)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(1272, 3)
        Me.PictureBox1.TabIndex = 23
        Me.PictureBox1.TabStop = False
        '
        'llWeb
        '
        Me.llWeb.BackColor = System.Drawing.SystemColors.Control
        Me.llWeb.LinkArea = New System.Windows.Forms.LinkArea(18, 58)
        Me.llWeb.Location = New System.Drawing.Point(632, 8)
        Me.llWeb.Name = "llWeb"
        Me.llWeb.Size = New System.Drawing.Size(408, 16)
        Me.llWeb.TabIndex = 1
        Me.llWeb.TabStop = True
        Me.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx"
        Me.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label11
        '
        Me.Label11.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label11.Location = New System.Drawing.Point(280, 24)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(120, 24)
        Me.Label11.TabIndex = 60
        Me.Label11.Text = "Parameters :"
        Me.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label6
        '
        Me.Label6.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label6.Location = New System.Drawing.Point(16, 24)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(120, 24)
        Me.Label6.TabIndex = 58
        Me.Label6.Text = "Definition Name :"
        Me.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label27
        '
        Me.Label27.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label27.Location = New System.Drawing.Point(272, 216)
        Me.Label27.Name = "Label27"
        Me.Label27.Size = New System.Drawing.Size(128, 24)
        Me.Label27.TabIndex = 56
        Me.Label27.Text = "Days Before Exp. :"
        Me.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label29
        '
        Me.Label29.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label29.Location = New System.Drawing.Point(16, 216)
        Me.Label29.Name = "Label29"
        Me.Label29.Size = New System.Drawing.Size(120, 24)
        Me.Label29.TabIndex = 54
        Me.Label29.Text = "Equalize Closes :"
        Me.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label23
        '
        Me.Label23.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label23.Location = New System.Drawing.Point(304, 184)
        Me.Label23.Name = "Label23"
        Me.Label23.Size = New System.Drawing.Size(96, 24)
        Me.Label23.TabIndex = 52
        Me.Label23.Text = "Continuation :"
        Me.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label25
        '
        Me.Label25.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label25.Location = New System.Drawing.Point(24, 248)
        Me.Label25.Name = "Label25"
        Me.Label25.Size = New System.Drawing.Size(112, 24)
        Me.Label25.TabIndex = 50
        Me.Label25.Text = "Sessions Filter :"
        Me.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label17
        '
        Me.Label17.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label17.Location = New System.Drawing.Point(304, 152)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(96, 24)
        Me.Label17.TabIndex = 48
        Me.Label17.Text = "Include End :"
        Me.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label21
        '
        Me.Label21.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label21.Location = New System.Drawing.Point(8, 152)
        Me.Label21.Name = "Label21"
        Me.Label21.Size = New System.Drawing.Size(124, 24)
        Me.Label21.TabIndex = 46
        Me.Label21.Text = "Updates Enabled :"
        Me.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label9
        '
        Me.Label9.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label9.Location = New System.Drawing.Point(280, 120)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(120, 24)
        Me.Label9.TabIndex = 44
        Me.Label9.Text = "Historical Period :"
        Me.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label13
        '
        Me.Label13.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label13.Location = New System.Drawing.Point(16, 120)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(120, 24)
        Me.Label13.TabIndex = 42
        Me.Label13.Text = "Intraday Period :"
        Me.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'tcTradingSystem
        '
        Me.tcTradingSystem.Alignment = System.Windows.Forms.TabAlignment.Bottom
        Me.tcTradingSystem.Controls.Add(Me.tpTradingSystem)
        Me.tcTradingSystem.Controls.Add(Me.tpTrades)
        Me.tcTradingSystem.Controls.Add(Me.tpStatistics)
        Me.tcTradingSystem.Location = New System.Drawing.Point(0, 48)
        Me.tcTradingSystem.Name = "tcTradingSystem"
        Me.tcTradingSystem.SelectedIndex = 0
        Me.tcTradingSystem.Size = New System.Drawing.Size(1080, 784)
        Me.tcTradingSystem.TabIndex = 2
        '
        'tpTradingSystem
        '
        Me.tpTradingSystem.Controls.Add(Me.txtTradingSystemName)
        Me.tpTradingSystem.Controls.Add(Me.lblError)
        Me.tpTradingSystem.Controls.Add(Me.GroupBox6)
        Me.tpTradingSystem.Controls.Add(Me.GroupBox5)
        Me.tpTradingSystem.Controls.Add(Me.PictureBox3)
        Me.tpTradingSystem.Controls.Add(Me.GroupBox8)
        Me.tpTradingSystem.Controls.Add(Me.btnRemoveAll)
        Me.tpTradingSystem.Controls.Add(Me.btnRemove)
        Me.tpTradingSystem.Controls.Add(Me.btnRequest)
        Me.tpTradingSystem.Controls.Add(Me.cmbTradingSystem)
        Me.tpTradingSystem.Controls.Add(Me.PictureBox2)
        Me.tpTradingSystem.Controls.Add(Me.GroupBox7)
        Me.tpTradingSystem.Location = New System.Drawing.Point(4, 4)
        Me.tpTradingSystem.Name = "tpTradingSystem"
        Me.tpTradingSystem.Size = New System.Drawing.Size(1072, 755)
        Me.tpTradingSystem.TabIndex = 0
        Me.tpTradingSystem.Text = "TradingSystem"
        '
        'txtTradingSystemName
        '
        Me.txtTradingSystemName.Location = New System.Drawing.Point(16, 368)
        Me.txtTradingSystemName.Name = "txtTradingSystemName"
        Me.txtTradingSystemName.Size = New System.Drawing.Size(448, 22)
        Me.txtTradingSystemName.TabIndex = 1
        Me.txtTradingSystemName.Text = ""
        '
        'lblError
        '
        Me.lblError.ForeColor = System.Drawing.Color.Red
        Me.lblError.Location = New System.Drawing.Point(16, 488)
        Me.lblError.Name = "lblError"
        Me.lblError.Size = New System.Drawing.Size(448, 152)
        Me.lblError.TabIndex = 57
        '
        'GroupBox6
        '
        Me.GroupBox6.Controls.Add(Me.lblStatus)
        Me.GroupBox6.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold)
        Me.GroupBox6.Location = New System.Drawing.Point(328, 424)
        Me.GroupBox6.Name = "GroupBox6"
        Me.GroupBox6.Size = New System.Drawing.Size(136, 48)
        Me.GroupBox6.TabIndex = 56
        Me.GroupBox6.TabStop = False
        Me.GroupBox6.Text = "Status"
        '
        'lblStatus
        '
        Me.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblStatus.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblStatus.Location = New System.Drawing.Point(8, 16)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(120, 24)
        Me.lblStatus.TabIndex = 31
        Me.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'GroupBox5
        '
        Me.GroupBox5.Controls.Add(Me.txtTagValue)
        Me.GroupBox5.Controls.Add(Me.txtTagName)
        Me.GroupBox5.Controls.Add(Me.Label14)
        Me.GroupBox5.Controls.Add(Me.Label18)
        Me.GroupBox5.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox5.Location = New System.Drawing.Point(488, 688)
        Me.GroupBox5.Name = "GroupBox5"
        Me.GroupBox5.Size = New System.Drawing.Size(576, 59)
        Me.GroupBox5.TabIndex = 7
        Me.GroupBox5.TabStop = False
        Me.GroupBox5.Text = "Tags"
        '
        'txtTagValue
        '
        Me.txtTagValue.Location = New System.Drawing.Point(352, 24)
        Me.txtTagValue.Name = "txtTagValue"
        Me.txtTagValue.Size = New System.Drawing.Size(184, 25)
        Me.txtTagValue.TabIndex = 1
        Me.txtTagValue.Text = ""
        '
        'txtTagName
        '
        Me.txtTagName.Location = New System.Drawing.Point(72, 24)
        Me.txtTagName.Name = "txtTagName"
        Me.txtTagName.Size = New System.Drawing.Size(184, 25)
        Me.txtTagName.TabIndex = 0
        Me.txtTagName.Text = ""
        '
        'Label14
        '
        Me.Label14.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label14.Location = New System.Drawing.Point(288, 24)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(56, 24)
        Me.Label14.TabIndex = 40
        Me.Label14.Text = "Value :"
        Me.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label18
        '
        Me.Label18.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label18.Location = New System.Drawing.Point(8, 24)
        Me.Label18.Name = "Label18"
        Me.Label18.Size = New System.Drawing.Size(56, 24)
        Me.Label18.TabIndex = 36
        Me.Label18.Text = "Name :"
        Me.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'PictureBox3
        '
        Me.PictureBox3.BackColor = System.Drawing.Color.Black
        Me.PictureBox3.Location = New System.Drawing.Point(-80, 680)
        Me.PictureBox3.Name = "PictureBox3"
        Me.PictureBox3.Size = New System.Drawing.Size(1272, 1)
        Me.PictureBox3.TabIndex = 55
        Me.PictureBox3.TabStop = False
        '
        'GroupBox8
        '
        Me.GroupBox8.Controls.Add(Me.lblRPRecalcPeriod)
        Me.GroupBox8.Controls.Add(Me.Label41)
        Me.GroupBox8.Controls.Add(Me.lblRPSubscriptionLevel)
        Me.GroupBox8.Controls.Add(Me.Label51)
        Me.GroupBox8.Controls.Add(Me.lstRPParameters)
        Me.GroupBox8.Controls.Add(Me.Label3)
        Me.GroupBox8.Controls.Add(Me.lblRPTradingSystemDefinitionName)
        Me.GroupBox8.Controls.Add(Me.Label26)
        Me.GroupBox8.Controls.Add(Me.lblRPDaysBeforeExpiration)
        Me.GroupBox8.Controls.Add(Me.Label32)
        Me.GroupBox8.Controls.Add(Me.lblRPEqualizeCloses)
        Me.GroupBox8.Controls.Add(Me.Label34)
        Me.GroupBox8.Controls.Add(Me.lblRPContinuation)
        Me.GroupBox8.Controls.Add(Me.Label36)
        Me.GroupBox8.Controls.Add(Me.lblRPSessionsFilter)
        Me.GroupBox8.Controls.Add(Me.Label38)
        Me.GroupBox8.Controls.Add(Me.lblRPIncludeEnd)
        Me.GroupBox8.Controls.Add(Me.Label40)
        Me.GroupBox8.Controls.Add(Me.lblRPHistoricalPeriod)
        Me.GroupBox8.Controls.Add(Me.Label44)
        Me.GroupBox8.Controls.Add(Me.lblRPIntradayPeriod)
        Me.GroupBox8.Controls.Add(Me.Label46)
        Me.GroupBox8.Controls.Add(Me.lblRPRangeEnd)
        Me.GroupBox8.Controls.Add(Me.Label47)
        Me.GroupBox8.Controls.Add(Me.lblRPSessionFlags)
        Me.GroupBox8.Controls.Add(Me.Label49)
        Me.GroupBox8.Controls.Add(Me.lblRPRangeStart)
        Me.GroupBox8.Controls.Add(Me.Label50)
        Me.GroupBox8.Controls.Add(Me.lblRPBaseExpression)
        Me.GroupBox8.Controls.Add(Me.Label52)
        Me.GroupBox8.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox8.Location = New System.Drawing.Point(480, 360)
        Me.GroupBox8.Name = "GroupBox8"
        Me.GroupBox8.Size = New System.Drawing.Size(584, 312)
        Me.GroupBox8.TabIndex = 6
        Me.GroupBox8.TabStop = False
        Me.GroupBox8.Text = "Request Parameters"
        '
        'lblRPRecalcPeriod
        '
        Me.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPRecalcPeriod.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPRecalcPeriod.Location = New System.Drawing.Point(440, 248)
        Me.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod"
        Me.lblRPRecalcPeriod.Size = New System.Drawing.Size(136, 24)
        Me.lblRPRecalcPeriod.TabIndex = 64
        Me.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label41
        '
        Me.Label41.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label41.Location = New System.Drawing.Point(328, 248)
        Me.Label41.Name = "Label41"
        Me.Label41.Size = New System.Drawing.Size(104, 24)
        Me.Label41.TabIndex = 63
        Me.Label41.Text = "Recalc Period :"
        Me.Label41.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPSubscriptionLevel
        '
        Me.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPSubscriptionLevel.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPSubscriptionLevel.Location = New System.Drawing.Point(152, 248)
        Me.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel"
        Me.lblRPSubscriptionLevel.Size = New System.Drawing.Size(152, 24)
        Me.lblRPSubscriptionLevel.TabIndex = 62
        Me.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label51
        '
        Me.Label51.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label51.Location = New System.Drawing.Point(8, 248)
        Me.Label51.Name = "Label51"
        Me.Label51.Size = New System.Drawing.Size(136, 24)
        Me.Label51.TabIndex = 61
        Me.Label51.Text = "Subscription Level :"
        Me.Label51.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lstRPParameters
        '
        Me.lstRPParameters.BackColor = System.Drawing.SystemColors.Control
        Me.lstRPParameters.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lstRPParameters.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lstRPParameters.ItemHeight = 15
        Me.lstRPParameters.Location = New System.Drawing.Point(440, 56)
        Me.lstRPParameters.Name = "lstRPParameters"
        Me.lstRPParameters.Size = New System.Drawing.Size(136, 62)
        Me.lstRPParameters.TabIndex = 0
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label3.Location = New System.Drawing.Point(344, 56)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(88, 24)
        Me.Label3.TabIndex = 60
        Me.Label3.Text = "Parameters :"
        Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPTradingSystemDefinitionName
        '
        Me.lblRPTradingSystemDefinitionName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPTradingSystemDefinitionName.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPTradingSystemDefinitionName.Location = New System.Drawing.Point(152, 24)
        Me.lblRPTradingSystemDefinitionName.Name = "lblRPTradingSystemDefinitionName"
        Me.lblRPTradingSystemDefinitionName.Size = New System.Drawing.Size(424, 24)
        Me.lblRPTradingSystemDefinitionName.TabIndex = 59
        Me.lblRPTradingSystemDefinitionName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label26
        '
        Me.Label26.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label26.Location = New System.Drawing.Point(16, 24)
        Me.Label26.Name = "Label26"
        Me.Label26.Size = New System.Drawing.Size(128, 24)
        Me.Label26.TabIndex = 58
        Me.Label26.Text = "Definition Name :"
        Me.Label26.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPDaysBeforeExpiration
        '
        Me.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPDaysBeforeExpiration.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPDaysBeforeExpiration.Location = New System.Drawing.Point(440, 216)
        Me.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration"
        Me.lblRPDaysBeforeExpiration.Size = New System.Drawing.Size(136, 24)
        Me.lblRPDaysBeforeExpiration.TabIndex = 57
        Me.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label32
        '
        Me.Label32.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label32.Location = New System.Drawing.Point(304, 216)
        Me.Label32.Name = "Label32"
        Me.Label32.Size = New System.Drawing.Size(128, 24)
        Me.Label32.TabIndex = 56
        Me.Label32.Text = "Days Before Exp. :"
        Me.Label32.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPEqualizeCloses
        '
        Me.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPEqualizeCloses.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPEqualizeCloses.Location = New System.Drawing.Point(152, 216)
        Me.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses"
        Me.lblRPEqualizeCloses.Size = New System.Drawing.Size(152, 24)
        Me.lblRPEqualizeCloses.TabIndex = 55
        Me.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label34
        '
        Me.Label34.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label34.Location = New System.Drawing.Point(16, 216)
        Me.Label34.Name = "Label34"
        Me.Label34.Size = New System.Drawing.Size(128, 24)
        Me.Label34.TabIndex = 54
        Me.Label34.Text = "Equalize Closes :"
        Me.Label34.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPContinuation
        '
        Me.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPContinuation.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPContinuation.Location = New System.Drawing.Point(440, 184)
        Me.lblRPContinuation.Name = "lblRPContinuation"
        Me.lblRPContinuation.Size = New System.Drawing.Size(136, 24)
        Me.lblRPContinuation.TabIndex = 53
        Me.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label36
        '
        Me.Label36.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label36.Location = New System.Drawing.Point(336, 184)
        Me.Label36.Name = "Label36"
        Me.Label36.Size = New System.Drawing.Size(96, 24)
        Me.Label36.TabIndex = 52
        Me.Label36.Text = "Continuation :"
        Me.Label36.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPSessionsFilter
        '
        Me.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPSessionsFilter.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPSessionsFilter.Location = New System.Drawing.Point(152, 280)
        Me.lblRPSessionsFilter.Name = "lblRPSessionsFilter"
        Me.lblRPSessionsFilter.Size = New System.Drawing.Size(424, 24)
        Me.lblRPSessionsFilter.TabIndex = 51
        Me.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label38
        '
        Me.Label38.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label38.Location = New System.Drawing.Point(24, 280)
        Me.Label38.Name = "Label38"
        Me.Label38.Size = New System.Drawing.Size(120, 24)
        Me.Label38.TabIndex = 50
        Me.Label38.Text = "Sessions Filter :"
        Me.Label38.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPIncludeEnd
        '
        Me.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPIncludeEnd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPIncludeEnd.Location = New System.Drawing.Point(440, 120)
        Me.lblRPIncludeEnd.Name = "lblRPIncludeEnd"
        Me.lblRPIncludeEnd.Size = New System.Drawing.Size(136, 24)
        Me.lblRPIncludeEnd.TabIndex = 49
        Me.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label40
        '
        Me.Label40.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label40.Location = New System.Drawing.Point(336, 120)
        Me.Label40.Name = "Label40"
        Me.Label40.Size = New System.Drawing.Size(96, 24)
        Me.Label40.TabIndex = 48
        Me.Label40.Text = "Include End :"
        Me.Label40.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPHistoricalPeriod
        '
        Me.lblRPHistoricalPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPHistoricalPeriod.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPHistoricalPeriod.Location = New System.Drawing.Point(440, 152)
        Me.lblRPHistoricalPeriod.Name = "lblRPHistoricalPeriod"
        Me.lblRPHistoricalPeriod.Size = New System.Drawing.Size(136, 24)
        Me.lblRPHistoricalPeriod.TabIndex = 45
        Me.lblRPHistoricalPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label44
        '
        Me.Label44.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label44.Location = New System.Drawing.Point(312, 152)
        Me.Label44.Name = "Label44"
        Me.Label44.Size = New System.Drawing.Size(120, 24)
        Me.Label44.TabIndex = 44
        Me.Label44.Text = "Historical Period :"
        Me.Label44.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPIntradayPeriod
        '
        Me.lblRPIntradayPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPIntradayPeriod.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPIntradayPeriod.Location = New System.Drawing.Point(152, 152)
        Me.lblRPIntradayPeriod.Name = "lblRPIntradayPeriod"
        Me.lblRPIntradayPeriod.Size = New System.Drawing.Size(152, 24)
        Me.lblRPIntradayPeriod.TabIndex = 43
        Me.lblRPIntradayPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label46
        '
        Me.Label46.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label46.Location = New System.Drawing.Point(16, 152)
        Me.Label46.Name = "Label46"
        Me.Label46.Size = New System.Drawing.Size(128, 24)
        Me.Label46.TabIndex = 42
        Me.Label46.Text = "Intraday Period :"
        Me.Label46.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPRangeEnd
        '
        Me.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPRangeEnd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPRangeEnd.Location = New System.Drawing.Point(152, 120)
        Me.lblRPRangeEnd.Name = "lblRPRangeEnd"
        Me.lblRPRangeEnd.Size = New System.Drawing.Size(152, 24)
        Me.lblRPRangeEnd.TabIndex = 41
        Me.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label47
        '
        Me.Label47.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label47.Location = New System.Drawing.Point(48, 120)
        Me.Label47.Name = "Label47"
        Me.Label47.Size = New System.Drawing.Size(96, 24)
        Me.Label47.TabIndex = 40
        Me.Label47.Text = "Range End :"
        Me.Label47.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPSessionFlags
        '
        Me.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPSessionFlags.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPSessionFlags.Location = New System.Drawing.Point(152, 184)
        Me.lblRPSessionFlags.Name = "lblRPSessionFlags"
        Me.lblRPSessionFlags.Size = New System.Drawing.Size(152, 24)
        Me.lblRPSessionFlags.TabIndex = 39
        Me.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label49
        '
        Me.Label49.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label49.Location = New System.Drawing.Point(24, 184)
        Me.Label49.Name = "Label49"
        Me.Label49.Size = New System.Drawing.Size(120, 24)
        Me.Label49.TabIndex = 38
        Me.Label49.Text = "Session Flags :"
        Me.Label49.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPRangeStart
        '
        Me.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPRangeStart.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPRangeStart.Location = New System.Drawing.Point(152, 88)
        Me.lblRPRangeStart.Name = "lblRPRangeStart"
        Me.lblRPRangeStart.Size = New System.Drawing.Size(152, 24)
        Me.lblRPRangeStart.TabIndex = 37
        Me.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label50
        '
        Me.Label50.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label50.Location = New System.Drawing.Point(16, 88)
        Me.Label50.Name = "Label50"
        Me.Label50.Size = New System.Drawing.Size(128, 24)
        Me.Label50.TabIndex = 36
        Me.Label50.Text = "Range Start :"
        Me.Label50.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblRPBaseExpression
        '
        Me.lblRPBaseExpression.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblRPBaseExpression.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblRPBaseExpression.Location = New System.Drawing.Point(152, 56)
        Me.lblRPBaseExpression.Name = "lblRPBaseExpression"
        Me.lblRPBaseExpression.Size = New System.Drawing.Size(152, 24)
        Me.lblRPBaseExpression.TabIndex = 33
        Me.lblRPBaseExpression.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label52
        '
        Me.Label52.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label52.Location = New System.Drawing.Point(8, 56)
        Me.Label52.Name = "Label52"
        Me.Label52.Size = New System.Drawing.Size(136, 24)
        Me.Label52.TabIndex = 32
        Me.Label52.Text = "Base Expression :"
        Me.Label52.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnRemoveAll
        '
        Me.btnRemoveAll.Enabled = False
        Me.btnRemoveAll.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.btnRemoveAll.Location = New System.Drawing.Point(224, 432)
        Me.btnRemoveAll.Name = "btnRemoveAll"
        Me.btnRemoveAll.Size = New System.Drawing.Size(96, 40)
        Me.btnRemoveAll.TabIndex = 5
        Me.btnRemoveAll.Text = "Remove All"
        '
        'btnRemove
        '
        Me.btnRemove.Enabled = False
        Me.btnRemove.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.btnRemove.Location = New System.Drawing.Point(120, 432)
        Me.btnRemove.Name = "btnRemove"
        Me.btnRemove.Size = New System.Drawing.Size(96, 40)
        Me.btnRemove.TabIndex = 4
        Me.btnRemove.Text = "Remove"
        '
        'btnRequest
        '
        Me.btnRequest.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.btnRequest.Location = New System.Drawing.Point(16, 432)
        Me.btnRequest.Name = "btnRequest"
        Me.btnRequest.Size = New System.Drawing.Size(96, 40)
        Me.btnRequest.TabIndex = 3
        Me.btnRequest.Text = "Request"
        '
        'cmbTradingSystem
        '
        Me.cmbTradingSystem.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbTradingSystem.Location = New System.Drawing.Point(16, 400)
        Me.cmbTradingSystem.Name = "cmbTradingSystem"
        Me.cmbTradingSystem.Size = New System.Drawing.Size(448, 24)
        Me.cmbTradingSystem.TabIndex = 2
        '
        'PictureBox2
        '
        Me.PictureBox2.BackColor = System.Drawing.Color.Black
        Me.PictureBox2.Location = New System.Drawing.Point(8, 352)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(1056, 3)
        Me.PictureBox2.TabIndex = 24
        Me.PictureBox2.TabStop = False
        '
        'GroupBox7
        '
        Me.GroupBox7.Controls.Add(Me.lblCommission)
        Me.GroupBox7.Controls.Add(Me.Label7)
        Me.GroupBox7.Controls.Add(Me.lblCommissionType)
        Me.GroupBox7.Controls.Add(Me.Label4)
        Me.GroupBox7.Controls.Add(Me.lblAbbreviation)
        Me.GroupBox7.Controls.Add(Me.Label2)
        Me.GroupBox7.Controls.Add(Me.GroupBox1)
        Me.GroupBox7.Controls.Add(Me.GroupBox2)
        Me.GroupBox7.Controls.Add(Me.cmbDefinition)
        Me.GroupBox7.Controls.Add(Me.btnReqTradingSystemDefinitions)
        Me.GroupBox7.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox7.Location = New System.Drawing.Point(8, 8)
        Me.GroupBox7.Name = "GroupBox7"
        Me.GroupBox7.Size = New System.Drawing.Size(1056, 336)
        Me.GroupBox7.TabIndex = 0
        Me.GroupBox7.TabStop = False
        Me.GroupBox7.Text = "Trading System Definitions"
        '
        'lblCommission
        '
        Me.lblCommission.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblCommission.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblCommission.Location = New System.Drawing.Point(616, 88)
        Me.lblCommission.Name = "lblCommission"
        Me.lblCommission.Size = New System.Drawing.Size(280, 24)
        Me.lblCommission.TabIndex = 55
        Me.lblCommission.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label7
        '
        Me.Label7.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label7.Location = New System.Drawing.Point(496, 88)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(112, 24)
        Me.Label7.TabIndex = 54
        Me.Label7.Text = "Commission :"
        Me.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblCommissionType
        '
        Me.lblCommissionType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblCommissionType.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblCommissionType.Location = New System.Drawing.Point(616, 56)
        Me.lblCommissionType.Name = "lblCommissionType"
        Me.lblCommissionType.Size = New System.Drawing.Size(280, 24)
        Me.lblCommissionType.TabIndex = 53
        Me.lblCommissionType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label4.Location = New System.Drawing.Point(480, 56)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(128, 24)
        Me.Label4.TabIndex = 52
        Me.Label4.Text = "Commission Type :"
        Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblAbbreviation
        '
        Me.lblAbbreviation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblAbbreviation.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblAbbreviation.Location = New System.Drawing.Point(616, 24)
        Me.lblAbbreviation.Name = "lblAbbreviation"
        Me.lblAbbreviation.Size = New System.Drawing.Size(280, 24)
        Me.lblAbbreviation.TabIndex = 51
        Me.lblAbbreviation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label2.Location = New System.Drawing.Point(496, 24)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(112, 24)
        Me.Label2.TabIndex = 50
        Me.Label2.Text = "Abbreviation :"
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'GroupBox1
        '
        Me.GroupBox1.Controls.Add(Me.cmbParameter)
        Me.GroupBox1.Controls.Add(Me.lblParameterComment)
        Me.GroupBox1.Controls.Add(Me.Label28)
        Me.GroupBox1.Controls.Add(Me.Label24)
        Me.GroupBox1.Controls.Add(Me.lblParameterDefaultValue)
        Me.GroupBox1.Controls.Add(Me.Label15)
        Me.GroupBox1.Controls.Add(Me.lblParameterType)
        Me.GroupBox1.Controls.Add(Me.Label22)
        Me.GroupBox1.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox1.Location = New System.Drawing.Point(648, 120)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(400, 208)
        Me.GroupBox1.TabIndex = 3
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Parameters"
        '
        'cmbParameter
        '
        Me.cmbParameter.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbParameter.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.cmbParameter.Location = New System.Drawing.Point(128, 16)
        Me.cmbParameter.Name = "cmbParameter"
        Me.cmbParameter.Size = New System.Drawing.Size(264, 25)
        Me.cmbParameter.TabIndex = 0
        '
        'lblParameterComment
        '
        Me.lblParameterComment.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblParameterComment.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblParameterComment.Location = New System.Drawing.Point(128, 48)
        Me.lblParameterComment.Name = "lblParameterComment"
        Me.lblParameterComment.Size = New System.Drawing.Size(264, 88)
        Me.lblParameterComment.TabIndex = 54
        '
        'Label28
        '
        Me.Label28.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label28.Location = New System.Drawing.Point(32, 48)
        Me.Label28.Name = "Label28"
        Me.Label28.Size = New System.Drawing.Size(88, 24)
        Me.Label28.TabIndex = 53
        Me.Label28.Text = "Comment :"
        Me.Label28.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label24
        '
        Me.Label24.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label24.Location = New System.Drawing.Point(40, 16)
        Me.Label24.Name = "Label24"
        Me.Label24.Size = New System.Drawing.Size(80, 24)
        Me.Label24.TabIndex = 52
        Me.Label24.Text = "Parameter :"
        Me.Label24.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblParameterDefaultValue
        '
        Me.lblParameterDefaultValue.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblParameterDefaultValue.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblParameterDefaultValue.Location = New System.Drawing.Point(128, 176)
        Me.lblParameterDefaultValue.Name = "lblParameterDefaultValue"
        Me.lblParameterDefaultValue.Size = New System.Drawing.Size(264, 24)
        Me.lblParameterDefaultValue.TabIndex = 51
        Me.lblParameterDefaultValue.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label15
        '
        Me.Label15.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label15.Location = New System.Drawing.Point(8, 176)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(112, 24)
        Me.Label15.TabIndex = 50
        Me.Label15.Text = "Default Value :"
        Me.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblParameterType
        '
        Me.lblParameterType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblParameterType.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblParameterType.Location = New System.Drawing.Point(128, 144)
        Me.lblParameterType.Name = "lblParameterType"
        Me.lblParameterType.Size = New System.Drawing.Size(264, 24)
        Me.lblParameterType.TabIndex = 49
        Me.lblParameterType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label22
        '
        Me.Label22.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label22.Location = New System.Drawing.Point(48, 144)
        Me.Label22.Name = "Label22"
        Me.Label22.Size = New System.Drawing.Size(72, 24)
        Me.Label22.TabIndex = 48
        Me.Label22.Text = "Type :"
        Me.Label22.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'GroupBox2
        '
        Me.GroupBox2.Controls.Add(Me.GroupBox4)
        Me.GroupBox2.Controls.Add(Me.GroupBox3)
        Me.GroupBox2.Controls.Add(Me.cmbTrade)
        Me.GroupBox2.Controls.Add(Me.Label1)
        Me.GroupBox2.Controls.Add(Me.lblTradeSide)
        Me.GroupBox2.Controls.Add(Me.Label5)
        Me.GroupBox2.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox2.Location = New System.Drawing.Point(8, 120)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(632, 208)
        Me.GroupBox2.TabIndex = 2
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "Trades"
        '
        'GroupBox4
        '
        Me.GroupBox4.Controls.Add(Me.lblEntryOrderType)
        Me.GroupBox4.Controls.Add(Me.Label8)
        Me.GroupBox4.Controls.Add(Me.lblEntryAllowPyramids)
        Me.GroupBox4.Controls.Add(Me.Label20)
        Me.GroupBox4.Controls.Add(Me.lblEntryAllowEntryOnExit)
        Me.GroupBox4.Controls.Add(Me.Label30)
        Me.GroupBox4.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox4.Location = New System.Drawing.Point(8, 56)
        Me.GroupBox4.Name = "GroupBox4"
        Me.GroupBox4.Size = New System.Drawing.Size(296, 144)
        Me.GroupBox4.TabIndex = 58
        Me.GroupBox4.TabStop = False
        Me.GroupBox4.Text = "Entry"
        '
        'lblEntryOrderType
        '
        Me.lblEntryOrderType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblEntryOrderType.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblEntryOrderType.Location = New System.Drawing.Point(160, 32)
        Me.lblEntryOrderType.Name = "lblEntryOrderType"
        Me.lblEntryOrderType.Size = New System.Drawing.Size(128, 24)
        Me.lblEntryOrderType.TabIndex = 54
        Me.lblEntryOrderType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label8
        '
        Me.Label8.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label8.Location = New System.Drawing.Point(64, 32)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(88, 24)
        Me.Label8.TabIndex = 53
        Me.Label8.Text = "Order Type :"
        Me.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblEntryAllowPyramids
        '
        Me.lblEntryAllowPyramids.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblEntryAllowPyramids.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblEntryAllowPyramids.Location = New System.Drawing.Point(160, 96)
        Me.lblEntryAllowPyramids.Name = "lblEntryAllowPyramids"
        Me.lblEntryAllowPyramids.Size = New System.Drawing.Size(128, 24)
        Me.lblEntryAllowPyramids.TabIndex = 51
        Me.lblEntryAllowPyramids.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label20
        '
        Me.Label20.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label20.Location = New System.Drawing.Point(32, 96)
        Me.Label20.Name = "Label20"
        Me.Label20.Size = New System.Drawing.Size(120, 24)
        Me.Label20.TabIndex = 50
        Me.Label20.Text = "Allow Pyramids :"
        Me.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblEntryAllowEntryOnExit
        '
        Me.lblEntryAllowEntryOnExit.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblEntryAllowEntryOnExit.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblEntryAllowEntryOnExit.Location = New System.Drawing.Point(160, 64)
        Me.lblEntryAllowEntryOnExit.Name = "lblEntryAllowEntryOnExit"
        Me.lblEntryAllowEntryOnExit.Size = New System.Drawing.Size(128, 24)
        Me.lblEntryAllowEntryOnExit.TabIndex = 49
        Me.lblEntryAllowEntryOnExit.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label30
        '
        Me.Label30.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label30.Location = New System.Drawing.Point(8, 64)
        Me.Label30.Name = "Label30"
        Me.Label30.Size = New System.Drawing.Size(144, 24)
        Me.Label30.TabIndex = 48
        Me.Label30.Text = "Allow Entry On Exit :"
        Me.Label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'GroupBox3
        '
        Me.GroupBox3.Controls.Add(Me.cmbExit)
        Me.GroupBox3.Controls.Add(Me.lblExitOrderType)
        Me.GroupBox3.Controls.Add(Me.Label10)
        Me.GroupBox3.Controls.Add(Me.Label12)
        Me.GroupBox3.Controls.Add(Me.lblExitAllowMoreThanOnce)
        Me.GroupBox3.Controls.Add(Me.Label16)
        Me.GroupBox3.Controls.Add(Me.lblExitAllowExitOnEntry)
        Me.GroupBox3.Controls.Add(Me.Label19)
        Me.GroupBox3.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox3.Location = New System.Drawing.Point(312, 56)
        Me.GroupBox3.Name = "GroupBox3"
        Me.GroupBox3.Size = New System.Drawing.Size(312, 144)
        Me.GroupBox3.TabIndex = 1
        Me.GroupBox3.TabStop = False
        Me.GroupBox3.Text = "Exits"
        '
        'cmbExit
        '
        Me.cmbExit.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbExit.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.cmbExit.Location = New System.Drawing.Point(176, 16)
        Me.cmbExit.Name = "cmbExit"
        Me.cmbExit.Size = New System.Drawing.Size(128, 25)
        Me.cmbExit.TabIndex = 0
        '
        'lblExitOrderType
        '
        Me.lblExitOrderType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblExitOrderType.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblExitOrderType.Location = New System.Drawing.Point(176, 48)
        Me.lblExitOrderType.Name = "lblExitOrderType"
        Me.lblExitOrderType.Size = New System.Drawing.Size(128, 24)
        Me.lblExitOrderType.TabIndex = 54
        Me.lblExitOrderType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label10
        '
        Me.Label10.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label10.Location = New System.Drawing.Point(80, 48)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(88, 24)
        Me.Label10.TabIndex = 53
        Me.Label10.Text = "Order Type :"
        Me.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label12
        '
        Me.Label12.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label12.Location = New System.Drawing.Point(88, 16)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(80, 24)
        Me.Label12.TabIndex = 52
        Me.Label12.Text = "Exit :"
        Me.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblExitAllowMoreThanOnce
        '
        Me.lblExitAllowMoreThanOnce.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblExitAllowMoreThanOnce.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblExitAllowMoreThanOnce.Location = New System.Drawing.Point(176, 112)
        Me.lblExitAllowMoreThanOnce.Name = "lblExitAllowMoreThanOnce"
        Me.lblExitAllowMoreThanOnce.Size = New System.Drawing.Size(128, 24)
        Me.lblExitAllowMoreThanOnce.TabIndex = 51
        Me.lblExitAllowMoreThanOnce.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label16
        '
        Me.Label16.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label16.Location = New System.Drawing.Point(8, 112)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(160, 24)
        Me.Label16.TabIndex = 50
        Me.Label16.Text = "Allow More Than Once :"
        Me.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblExitAllowExitOnEntry
        '
        Me.lblExitAllowExitOnEntry.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblExitAllowExitOnEntry.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblExitAllowExitOnEntry.Location = New System.Drawing.Point(176, 80)
        Me.lblExitAllowExitOnEntry.Name = "lblExitAllowExitOnEntry"
        Me.lblExitAllowExitOnEntry.Size = New System.Drawing.Size(128, 24)
        Me.lblExitAllowExitOnEntry.TabIndex = 49
        Me.lblExitAllowExitOnEntry.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label19
        '
        Me.Label19.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label19.Location = New System.Drawing.Point(24, 80)
        Me.Label19.Name = "Label19"
        Me.Label19.Size = New System.Drawing.Size(144, 24)
        Me.Label19.TabIndex = 48
        Me.Label19.Text = "Allow Exit On Entry :"
        Me.Label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'cmbTrade
        '
        Me.cmbTrade.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbTrade.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.cmbTrade.Location = New System.Drawing.Point(72, 24)
        Me.cmbTrade.Name = "cmbTrade"
        Me.cmbTrade.Size = New System.Drawing.Size(280, 25)
        Me.cmbTrade.TabIndex = 0
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label1.Location = New System.Drawing.Point(8, 24)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(56, 24)
        Me.Label1.TabIndex = 56
        Me.Label1.Text = "Trade :"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblTradeSide
        '
        Me.lblTradeSide.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblTradeSide.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lblTradeSide.Location = New System.Drawing.Point(440, 24)
        Me.lblTradeSide.Name = "lblTradeSide"
        Me.lblTradeSide.Size = New System.Drawing.Size(120, 24)
        Me.lblTradeSide.TabIndex = 55
        Me.lblTradeSide.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label5
        '
        Me.Label5.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label5.Location = New System.Drawing.Point(384, 24)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(48, 24)
        Me.Label5.TabIndex = 54
        Me.Label5.Text = "Side :"
        Me.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'cmbDefinition
        '
        Me.cmbDefinition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbDefinition.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.cmbDefinition.Location = New System.Drawing.Point(112, 24)
        Me.cmbDefinition.Name = "cmbDefinition"
        Me.cmbDefinition.Size = New System.Drawing.Size(352, 25)
        Me.cmbDefinition.TabIndex = 1
        '
        'btnReqTradingSystemDefinitions
        '
        Me.btnReqTradingSystemDefinitions.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.btnReqTradingSystemDefinitions.Location = New System.Drawing.Point(8, 24)
        Me.btnReqTradingSystemDefinitions.Name = "btnReqTradingSystemDefinitions"
        Me.btnReqTradingSystemDefinitions.Size = New System.Drawing.Size(96, 26)
        Me.btnReqTradingSystemDefinitions.TabIndex = 0
        Me.btnReqTradingSystemDefinitions.Text = "Request"
        '
        'tpTrades
        '
        Me.tpTrades.Controls.Add(Me.cmbTradesNames)
        Me.tpTrades.Controls.Add(Me.Label45)
        Me.tpTrades.Controls.Add(Me.GroupBox11)
        Me.tpTrades.Controls.Add(Me.GroupBox14)
        Me.tpTrades.Location = New System.Drawing.Point(4, 4)
        Me.tpTrades.Name = "tpTrades"
        Me.tpTrades.Size = New System.Drawing.Size(1072, 755)
        Me.tpTrades.TabIndex = 1
        Me.tpTrades.Text = "Trades"
        '
        'cmbTradesNames
        '
        Me.cmbTradesNames.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbTradesNames.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.cmbTradesNames.Location = New System.Drawing.Point(96, 8)
        Me.cmbTradesNames.Name = "cmbTradesNames"
        Me.cmbTradesNames.Size = New System.Drawing.Size(280, 25)
        Me.cmbTradesNames.TabIndex = 0
        '
        'Label45
        '
        Me.Label45.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label45.Location = New System.Drawing.Point(24, 8)
        Me.Label45.Name = "Label45"
        Me.Label45.Size = New System.Drawing.Size(64, 24)
        Me.Label45.TabIndex = 60
        Me.Label45.Text = "Trades :"
        Me.Label45.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'GroupBox11
        '
        Me.GroupBox11.Controls.Add(Me.gbShownRelations)
        Me.GroupBox11.Controls.Add(Me.lvShownTrades)
        Me.GroupBox11.Controls.Add(Me.btnShowTrades)
        Me.GroupBox11.Controls.Add(Me.GroupBox13)
        Me.GroupBox11.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox11.Location = New System.Drawing.Point(0, 344)
        Me.GroupBox11.Name = "GroupBox11"
        Me.GroupBox11.Size = New System.Drawing.Size(1032, 375)
        Me.GroupBox11.TabIndex = 2
        Me.GroupBox11.TabStop = False
        Me.GroupBox11.Text = "Trades Filtered by Index"
        '
        'gbShownRelations
        '
        Me.gbShownRelations.Controls.Add(Me.lvShownTradesRelations)
        Me.gbShownRelations.Controls.Add(Me.cmbShownTradeItems)
        Me.gbShownRelations.Location = New System.Drawing.Point(672, 72)
        Me.gbShownRelations.Name = "gbShownRelations"
        Me.gbShownRelations.Size = New System.Drawing.Size(352, 296)
        Me.gbShownRelations.TabIndex = 3
        Me.gbShownRelations.TabStop = False
        Me.gbShownRelations.Text = "Relations"
        '
        'lvShownTradesRelations
        '
        Me.lvShownTradesRelations.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader17, Me.ColumnHeader18, Me.ColumnHeader21, Me.ColumnHeader19})
        Me.lvShownTradesRelations.Font = New System.Drawing.Font("Arial", 9.5!)
        Me.lvShownTradesRelations.FullRowSelect = True
        Me.lvShownTradesRelations.GridLines = True
        Me.lvShownTradesRelations.Location = New System.Drawing.Point(8, 64)
        Me.lvShownTradesRelations.MultiSelect = False
        Me.lvShownTradesRelations.Name = "lvShownTradesRelations"
        Me.lvShownTradesRelations.Size = New System.Drawing.Size(336, 224)
        Me.lvShownTradesRelations.TabIndex = 3
        Me.lvShownTradesRelations.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader17
        '
        Me.ColumnHeader17.Text = ""
        Me.ColumnHeader17.Width = 0
        '
        'ColumnHeader18
        '
        Me.ColumnHeader18.Text = "Timestamp"
        Me.ColumnHeader18.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader18.Width = 162
        '
        'ColumnHeader19
        '
        Me.ColumnHeader19.Text = "Name"
        Me.ColumnHeader19.Width = 158
        '
        'cmbShownTradeItems
        '
        Me.cmbShownTradeItems.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbShownTradeItems.Location = New System.Drawing.Point(8, 24)
        Me.cmbShownTradeItems.Name = "cmbShownTradeItems"
        Me.cmbShownTradeItems.Size = New System.Drawing.Size(200, 26)
        Me.cmbShownTradeItems.TabIndex = 1
        '
        'lvShownTrades
        '
        Me.lvShownTrades.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader1, Me.ColumnHeader2, Me.ColumnHeader3})
        Me.lvShownTrades.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lvShownTrades.FullRowSelect = True
        Me.lvShownTrades.GridLines = True
        Me.lvShownTrades.Location = New System.Drawing.Point(8, 80)
        Me.lvShownTrades.MultiSelect = False
        Me.lvShownTrades.Name = "lvShownTrades"
        Me.lvShownTrades.Size = New System.Drawing.Size(656, 288)
        Me.lvShownTrades.TabIndex = 2
        Me.lvShownTrades.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader1
        '
        Me.ColumnHeader1.Text = ""
        Me.ColumnHeader1.Width = 0
        '
        'ColumnHeader2
        '
        Me.ColumnHeader2.Text = "Index"
        Me.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader2.Width = 49
        '
        'ColumnHeader3
        '
        Me.ColumnHeader3.Text = "Timestamp"
        Me.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader3.Width = 162
        '
        'btnShowTrades
        '
        Me.btnShowTrades.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.btnShowTrades.Location = New System.Drawing.Point(424, 48)
        Me.btnShowTrades.Name = "btnShowTrades"
        Me.btnShowTrades.Size = New System.Drawing.Size(96, 24)
        Me.btnShowTrades.TabIndex = 1
        Me.btnShowTrades.Text = "Show"
        '
        'GroupBox13
        '
        Me.GroupBox13.Controls.Add(Me.Label42)
        Me.GroupBox13.Controls.Add(Me.nudEndTrades)
        Me.GroupBox13.Controls.Add(Me.Label43)
        Me.GroupBox13.Controls.Add(Me.nudStartTrades)
        Me.GroupBox13.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox13.Location = New System.Drawing.Point(16, 16)
        Me.GroupBox13.Name = "GroupBox13"
        Me.GroupBox13.Size = New System.Drawing.Size(400, 56)
        Me.GroupBox13.TabIndex = 0
        Me.GroupBox13.TabStop = False
        Me.GroupBox13.Text = "Index Interval"
        '
        'Label42
        '
        Me.Label42.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label42.Location = New System.Drawing.Point(200, 24)
        Me.Label42.Name = "Label42"
        Me.Label42.Size = New System.Drawing.Size(48, 24)
        Me.Label42.TabIndex = 74
        Me.Label42.Text = "End: "
        Me.Label42.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'nudEndTrades
        '
        Me.nudEndTrades.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.nudEndTrades.Location = New System.Drawing.Point(256, 24)
        Me.nudEndTrades.Maximum = New Decimal(New Integer() {10000000, 0, 0, 0})
        Me.nudEndTrades.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudEndTrades.Name = "nudEndTrades"
        Me.nudEndTrades.Size = New System.Drawing.Size(128, 22)
        Me.nudEndTrades.TabIndex = 1
        Me.nudEndTrades.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'Label43
        '
        Me.Label43.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label43.Location = New System.Drawing.Point(8, 24)
        Me.Label43.Name = "Label43"
        Me.Label43.Size = New System.Drawing.Size(48, 24)
        Me.Label43.TabIndex = 70
        Me.Label43.Text = "Start: "
        Me.Label43.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'nudStartTrades
        '
        Me.nudStartTrades.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.nudStartTrades.Location = New System.Drawing.Point(64, 24)
        Me.nudStartTrades.Maximum = New Decimal(New Integer() {10000000, 0, 0, 0})
        Me.nudStartTrades.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudStartTrades.Name = "nudStartTrades"
        Me.nudStartTrades.Size = New System.Drawing.Size(128, 22)
        Me.nudStartTrades.TabIndex = 0
        Me.nudStartTrades.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'GroupBox14
        '
        Me.GroupBox14.Controls.Add(Me.gbRelations)
        Me.GroupBox14.Controls.Add(Me.lvTrades)
        Me.GroupBox14.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox14.Location = New System.Drawing.Point(0, 40)
        Me.GroupBox14.Name = "GroupBox14"
        Me.GroupBox14.Size = New System.Drawing.Size(1032, 296)
        Me.GroupBox14.TabIndex = 1
        Me.GroupBox14.TabStop = False
        Me.GroupBox14.Text = "Last 10 Resolved Trades"
        '
        'gbRelations
        '
        Me.gbRelations.Controls.Add(Me.lvTradesRelations)
        Me.gbRelations.Controls.Add(Me.cmbTradeItems)
        Me.gbRelations.Location = New System.Drawing.Point(672, 16)
        Me.gbRelations.Name = "gbRelations"
        Me.gbRelations.Size = New System.Drawing.Size(352, 272)
        Me.gbRelations.TabIndex = 1
        Me.gbRelations.TabStop = False
        Me.gbRelations.Text = "Relations"
        '
        'lvTradesRelations
        '
        Me.lvTradesRelations.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader12, Me.ColumnHeader16, Me.ColumnHeader20, Me.ColumnHeader8})
        Me.lvTradesRelations.Font = New System.Drawing.Font("Arial", 9.5!)
        Me.lvTradesRelations.FullRowSelect = True
        Me.lvTradesRelations.GridLines = True
        Me.lvTradesRelations.Location = New System.Drawing.Point(8, 64)
        Me.lvTradesRelations.MultiSelect = False
        Me.lvTradesRelations.Name = "lvTradesRelations"
        Me.lvTradesRelations.Size = New System.Drawing.Size(336, 200)
        Me.lvTradesRelations.TabIndex = 2
        Me.lvTradesRelations.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader12
        '
        Me.ColumnHeader12.Text = ""
        Me.ColumnHeader12.Width = 0
        '
        'ColumnHeader16
        '
        Me.ColumnHeader16.Text = "Timestamp"
        Me.ColumnHeader16.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader16.Width = 162
        '
        'ColumnHeader8
        '
        Me.ColumnHeader8.Text = "Name"
        Me.ColumnHeader8.Width = 158
        '
        'cmbTradeItems
        '
        Me.cmbTradeItems.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbTradeItems.Location = New System.Drawing.Point(8, 24)
        Me.cmbTradeItems.Name = "cmbTradeItems"
        Me.cmbTradeItems.Size = New System.Drawing.Size(200, 26)
        Me.cmbTradeItems.TabIndex = 1
        '
        'lvTrades
        '
        Me.lvTrades.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader4, Me.ColumnHeader5, Me.ColumnHeader6, Me.ColumnHeader7})
        Me.lvTrades.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lvTrades.FullRowSelect = True
        Me.lvTrades.GridLines = True
        Me.lvTrades.Location = New System.Drawing.Point(8, 24)
        Me.lvTrades.MultiSelect = False
        Me.lvTrades.Name = "lvTrades"
        Me.lvTrades.Size = New System.Drawing.Size(656, 264)
        Me.lvTrades.TabIndex = 0
        Me.lvTrades.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader4
        '
        Me.ColumnHeader4.Text = ""
        Me.ColumnHeader4.Width = 0
        '
        'ColumnHeader5
        '
        Me.ColumnHeader5.Text = "Index"
        Me.ColumnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader5.Width = 49
        '
        'ColumnHeader6
        '
        Me.ColumnHeader6.Text = "Timestamp"
        Me.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader6.Width = 162
        '
        'ColumnHeader7
        '
        Me.ColumnHeader7.Text = "Signaled"
        Me.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader7.Width = 65
        '
        'tpStatistics
        '
        Me.tpStatistics.Controls.Add(Me.GroupBox9)
        Me.tpStatistics.Controls.Add(Me.GroupBox10)
        Me.tpStatistics.Location = New System.Drawing.Point(4, 4)
        Me.tpStatistics.Name = "tpStatistics"
        Me.tpStatistics.Size = New System.Drawing.Size(1072, 758)
        Me.tpStatistics.TabIndex = 2
        Me.tpStatistics.Text = "Statistics"
        '
        'GroupBox9
        '
        Me.GroupBox9.Controls.Add(Me.lvShownStatistics)
        Me.GroupBox9.Controls.Add(Me.btnShowStatistics)
        Me.GroupBox9.Controls.Add(Me.gbTimeIntervalStatistics)
        Me.GroupBox9.Controls.Add(Me.gbIndexIntervalStatistics)
        Me.GroupBox9.Controls.Add(Me.optTimeIntervalStatistics)
        Me.GroupBox9.Controls.Add(Me.optIndexIntervalStatistics)
        Me.GroupBox9.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox9.Location = New System.Drawing.Point(8, 288)
        Me.GroupBox9.Name = "GroupBox9"
        Me.GroupBox9.Size = New System.Drawing.Size(1032, 424)
        Me.GroupBox9.TabIndex = 1
        Me.GroupBox9.TabStop = False
        Me.GroupBox9.Text = "Statistics Filtered by Index or Time Interval"
        '
        'lvShownStatistics
        '
        Me.lvShownStatistics.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader9, Me.ColumnHeader10, Me.ColumnHeader11})
        Me.lvShownStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lvShownStatistics.FullRowSelect = True
        Me.lvShownStatistics.GridLines = True
        Me.lvShownStatistics.Location = New System.Drawing.Point(8, 80)
        Me.lvShownStatistics.MultiSelect = False
        Me.lvShownStatistics.Name = "lvShownStatistics"
        Me.lvShownStatistics.Size = New System.Drawing.Size(1016, 336)
        Me.lvShownStatistics.TabIndex = 4
        Me.lvShownStatistics.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader9
        '
        Me.ColumnHeader9.Text = ""
        Me.ColumnHeader9.Width = 0
        '
        'ColumnHeader10
        '
        Me.ColumnHeader10.Text = "Index"
        Me.ColumnHeader10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader10.Width = 49
        '
        'ColumnHeader11
        '
        Me.ColumnHeader11.Text = "Timestamp"
        Me.ColumnHeader11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader11.Width = 162
        '
        'btnShowStatistics
        '
        Me.btnShowStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.btnShowStatistics.Location = New System.Drawing.Point(760, 48)
        Me.btnShowStatistics.Name = "btnShowStatistics"
        Me.btnShowStatistics.Size = New System.Drawing.Size(96, 24)
        Me.btnShowStatistics.TabIndex = 3
        Me.btnShowStatistics.Text = "Show"
        '
        'gbTimeIntervalStatistics
        '
        Me.gbTimeIntervalStatistics.Controls.Add(Me.Label31)
        Me.gbTimeIntervalStatistics.Controls.Add(Me.dtpEndRangeStatistics)
        Me.gbTimeIntervalStatistics.Controls.Add(Me.Label33)
        Me.gbTimeIntervalStatistics.Controls.Add(Me.dtpStartRangeStatistics)
        Me.gbTimeIntervalStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.gbTimeIntervalStatistics.Location = New System.Drawing.Point(352, 16)
        Me.gbTimeIntervalStatistics.Name = "gbTimeIntervalStatistics"
        Me.gbTimeIntervalStatistics.Size = New System.Drawing.Size(400, 56)
        Me.gbTimeIntervalStatistics.TabIndex = 2
        Me.gbTimeIntervalStatistics.TabStop = False
        Me.gbTimeIntervalStatistics.Text = "Time Interval"
        '
        'Label31
        '
        Me.Label31.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label31.Location = New System.Drawing.Point(200, 24)
        Me.Label31.Name = "Label31"
        Me.Label31.Size = New System.Drawing.Size(48, 24)
        Me.Label31.TabIndex = 73
        Me.Label31.Text = "End: "
        Me.Label31.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'dtpEndRangeStatistics
        '
        Me.dtpEndRangeStatistics.CustomFormat = "dd/MM/yyyy HH:mm"
        Me.dtpEndRangeStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.dtpEndRangeStatistics.Format = System.Windows.Forms.DateTimePickerFormat.Custom
        Me.dtpEndRangeStatistics.Location = New System.Drawing.Point(256, 24)
        Me.dtpEndRangeStatistics.Name = "dtpEndRangeStatistics"
        Me.dtpEndRangeStatistics.Size = New System.Drawing.Size(128, 22)
        Me.dtpEndRangeStatistics.TabIndex = 1
        '
        'Label33
        '
        Me.Label33.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label33.Location = New System.Drawing.Point(8, 24)
        Me.Label33.Name = "Label33"
        Me.Label33.Size = New System.Drawing.Size(48, 24)
        Me.Label33.TabIndex = 71
        Me.Label33.Text = "Start: "
        Me.Label33.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'dtpStartRangeStatistics
        '
        Me.dtpStartRangeStatistics.CustomFormat = "dd/MM/yyyy HH:mm"
        Me.dtpStartRangeStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.dtpStartRangeStatistics.Format = System.Windows.Forms.DateTimePickerFormat.Custom
        Me.dtpStartRangeStatistics.Location = New System.Drawing.Point(64, 24)
        Me.dtpStartRangeStatistics.Name = "dtpStartRangeStatistics"
        Me.dtpStartRangeStatistics.Size = New System.Drawing.Size(128, 22)
        Me.dtpStartRangeStatistics.TabIndex = 0
        '
        'gbIndexIntervalStatistics
        '
        Me.gbIndexIntervalStatistics.Controls.Add(Me.Label35)
        Me.gbIndexIntervalStatistics.Controls.Add(Me.nudEndStatistics)
        Me.gbIndexIntervalStatistics.Controls.Add(Me.Label37)
        Me.gbIndexIntervalStatistics.Controls.Add(Me.nudStartStatistics)
        Me.gbIndexIntervalStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.gbIndexIntervalStatistics.Location = New System.Drawing.Point(352, 16)
        Me.gbIndexIntervalStatistics.Name = "gbIndexIntervalStatistics"
        Me.gbIndexIntervalStatistics.Size = New System.Drawing.Size(400, 56)
        Me.gbIndexIntervalStatistics.TabIndex = 3
        Me.gbIndexIntervalStatistics.TabStop = False
        Me.gbIndexIntervalStatistics.Text = "Index Interval"
        '
        'Label35
        '
        Me.Label35.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label35.Location = New System.Drawing.Point(200, 24)
        Me.Label35.Name = "Label35"
        Me.Label35.Size = New System.Drawing.Size(48, 24)
        Me.Label35.TabIndex = 74
        Me.Label35.Text = "End: "
        Me.Label35.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'nudEndStatistics
        '
        Me.nudEndStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.nudEndStatistics.Location = New System.Drawing.Point(256, 24)
        Me.nudEndStatistics.Maximum = New Decimal(New Integer() {10000000, 0, 0, 0})
        Me.nudEndStatistics.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudEndStatistics.Name = "nudEndStatistics"
        Me.nudEndStatistics.Size = New System.Drawing.Size(128, 22)
        Me.nudEndStatistics.TabIndex = 1
        Me.nudEndStatistics.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'Label37
        '
        Me.Label37.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label37.Location = New System.Drawing.Point(8, 24)
        Me.Label37.Name = "Label37"
        Me.Label37.Size = New System.Drawing.Size(48, 24)
        Me.Label37.TabIndex = 70
        Me.Label37.Text = "Start: "
        Me.Label37.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'nudStartStatistics
        '
        Me.nudStartStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.nudStartStatistics.Location = New System.Drawing.Point(64, 24)
        Me.nudStartStatistics.Maximum = New Decimal(New Integer() {10000000, 0, 0, 0})
        Me.nudStartStatistics.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudStartStatistics.Name = "nudStartStatistics"
        Me.nudStartStatistics.Size = New System.Drawing.Size(128, 22)
        Me.nudStartStatistics.TabIndex = 0
        Me.nudStartStatistics.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'optTimeIntervalStatistics
        '
        Me.optTimeIntervalStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.optTimeIntervalStatistics.Location = New System.Drawing.Point(200, 48)
        Me.optTimeIntervalStatistics.Name = "optTimeIntervalStatistics"
        Me.optTimeIntervalStatistics.Size = New System.Drawing.Size(168, 24)
        Me.optTimeIntervalStatistics.TabIndex = 1
        Me.optTimeIntervalStatistics.TabStop = True
        Me.optTimeIntervalStatistics.Text = "Show by Time Interval"
        '
        'optIndexIntervalStatistics
        '
        Me.optIndexIntervalStatistics.Checked = True
        Me.optIndexIntervalStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.optIndexIntervalStatistics.Location = New System.Drawing.Point(200, 24)
        Me.optIndexIntervalStatistics.Name = "optIndexIntervalStatistics"
        Me.optIndexIntervalStatistics.Size = New System.Drawing.Size(168, 24)
        Me.optIndexIntervalStatistics.TabIndex = 0
        Me.optIndexIntervalStatistics.TabStop = True
        Me.optIndexIntervalStatistics.Text = "Show by Index Interval"
        '
        'GroupBox10
        '
        Me.GroupBox10.Controls.Add(Me.lvStatistics)
        Me.GroupBox10.Font = New System.Drawing.Font("Arial", 11.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.GroupBox10.Location = New System.Drawing.Point(8, 8)
        Me.GroupBox10.Name = "GroupBox10"
        Me.GroupBox10.Size = New System.Drawing.Size(1032, 272)
        Me.GroupBox10.TabIndex = 0
        Me.GroupBox10.TabStop = False
        Me.GroupBox10.Text = "Last 10 Resolved Statistics"
        '
        'lvStatistics
        '
        Me.lvStatistics.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader13, Me.ColumnHeader14, Me.ColumnHeader15})
        Me.lvStatistics.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.lvStatistics.FullRowSelect = True
        Me.lvStatistics.GridLines = True
        Me.lvStatistics.Location = New System.Drawing.Point(8, 20)
        Me.lvStatistics.MultiSelect = False
        Me.lvStatistics.Name = "lvStatistics"
        Me.lvStatistics.Size = New System.Drawing.Size(1016, 244)
        Me.lvStatistics.TabIndex = 0
        Me.lvStatistics.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader13
        '
        Me.ColumnHeader13.Text = ""
        Me.ColumnHeader13.Width = 0
        '
        'ColumnHeader14
        '
        Me.ColumnHeader14.Text = "Index"
        Me.ColumnHeader14.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader14.Width = 49
        '
        'ColumnHeader15
        '
        Me.ColumnHeader15.Text = "Timestamp"
        Me.ColumnHeader15.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader15.Width = 162
        '
        'ColumnHeader20
        '
        Me.ColumnHeader20.Text = "Offset"
        Me.ColumnHeader20.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader20.Width = 49
        '
        'ColumnHeader21
        '
        Me.ColumnHeader21.Text = "Offset"
        Me.ColumnHeader21.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.ColumnHeader21.Width = 49
        '
        'frmTradingSystem
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(1078, 835)
        Me.Controls.Add(Me.tcTradingSystem)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.lblDataConnection)
        Me.Controls.Add(Me.llWeb)
        Me.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.MaximizeBox = False
        Me.Name = "frmTradingSystem"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "TradingSystem"
        Me.tcTradingSystem.ResumeLayout(False)
        Me.tpTradingSystem.ResumeLayout(False)
        Me.GroupBox6.ResumeLayout(False)
        Me.GroupBox5.ResumeLayout(False)
        Me.GroupBox8.ResumeLayout(False)
        Me.GroupBox7.ResumeLayout(False)
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        Me.GroupBox4.ResumeLayout(False)
        Me.GroupBox3.ResumeLayout(False)
        Me.tpTrades.ResumeLayout(False)
        Me.GroupBox11.ResumeLayout(False)
        Me.gbShownRelations.ResumeLayout(False)
        Me.GroupBox13.ResumeLayout(False)
        CType(Me.nudEndTrades, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudStartTrades, System.ComponentModel.ISupportInitialize).EndInit()
        Me.GroupBox14.ResumeLayout(False)
        Me.gbRelations.ResumeLayout(False)
        Me.tpStatistics.ResumeLayout(False)
        Me.GroupBox9.ResumeLayout(False)
        Me.gbTimeIntervalStatistics.ResumeLayout(False)
        Me.gbIndexIntervalStatistics.ResumeLayout(False)
        CType(Me.nudEndStatistics, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudStartStatistics, System.ComponentModel.ISupportInitialize).EndInit()
        Me.GroupBox10.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    ''' <summary>
    ''' Creates a CEL object, changes its configurations, and starts up the created CEL object.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub frmTradingSystem_Load(ByVal sender As System.Object, _
                           ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            ' Creates the CQGCEL object
            CEL = New CQGCEL
            CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff
            CEL.APIConfiguration.CollectionsThrowException = False
            CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral
            CEL.APIConfiguration.GatewayEnabled = False


            ' Disables the controls
            CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown)
            ' Starts up the CQGCEL
            CEL.Startup()

            cmbTradingSystem.Items.Clear()
            cmbTradingSystem.SelectedIndex = -1

            ClearDefinitionData()
            ClearAllData()

            m_CurTradingSystem = Nothing
            m_CurTradingSystemDefs = Nothing
        Catch ex As Exception
            ShowError("frmTradingSystem", "frmTradingSystem_Load", ex)
            Me.Close()
        End Try
    End Sub

    ''' <summary>
    ''' Shuts down CEL.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A CancelEventArgs that contains the event data.
    ''' </param>
    Private Sub frmTradingSystem_Closing(ByVal sender As Object, _
                             ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If Not CEL Is Nothing Then
            CEL.Shutdown()
        End If
    End Sub

    ''' <summary>
    ''' Clears all old info regarding to old TradingSystemDefinitions and requests new TradingSystemDefinitions. 
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnReqTradingSystemDefinitions_Click(ByVal sender As System.Object, _
                                         ByVal e As System.EventArgs) Handles btnReqTradingSystemDefinitions.Click
        Try
            CEL.RequestTradingSystemDefinitions()
            ClearDefinitionData()
        Catch ex As Exception
            ShowError("frmTradingSystem", "btnReqTradingSystemDefinitions_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected Definition info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbDefinition_SelectedIndexChanged(ByVal sender As System.Object, _
                                        ByVal e As System.EventArgs) Handles cmbDefinition.SelectedIndexChanged
        Try
            ' Clearing definition data
            ClearDefinitionData()
            Dim tradeSysDef As CQGTradingSystemDefinition = m_CurTradingSystemDefs.ItemByName(cmbDefinition.Text)

            If tradeSysDef Is Nothing Then
                Exit Sub
            End If

            lblAbbreviation.Text = tradeSysDef.Abbreviation
            lblCommission.Text = GetValueAsString(tradeSysDef.Commission)
            lblCommissionType.Text = tradeSysDef.CommissionType.ToString()


            ' Fill parameters to the combo list of the current definition
            With cmbParameter
                .Items.Clear()
                For Each paramDef As CQGParameterDefinition In tradeSysDef.ParameterDefinitions
                    .Items.Add(paramDef.Name)
                Next

                If .Items.Count > 0 Then
                    .SelectedIndex = 0
                Else
                    ClearParameterData()
                End If
            End With

            ' Fill trade definitions to the combo list of the current definition
            With cmbTrade
                .Items.Clear()
                For Each tradeDef As CQGTradingSystemTradeDefinition In tradeSysDef.TradeDefinitions
                    .Items.Add(tradeDef.Name)
                Next

                If .Items.Count > 0 Then
                    .SelectedIndex = 0
                Else
                    ClearTradesDefinitionData()
                End If
            End With


            txtTradingSystemName.Text = cmbDefinition.Text
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbDefinition_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected Parameter info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbParameter_SelectedIndexChanged(ByVal sender As System.Object, _
                                       ByVal e As System.EventArgs) Handles cmbParameter.SelectedIndexChanged
        Try
            ' Clearing parameter data
            ClearParameterData()

            If cmbParameter.SelectedIndex > -1 Then
                Dim tradeDef As CQGTradingSystemDefinition = m_CurTradingSystemDefs.ItemByName(cmbDefinition.Text)
                Dim param As CQGParameterDefinition = tradeDef.ParameterDefinitions.ItemByName(cmbParameter.Text)

                lblParameterComment.Text = param.Comment
                lblParameterType.Text = param.Type.ToString()
                lblParameterDefaultValue.Text = param.DefaultValue.ToString()
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbParameter_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected Trade info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbTrade_SelectedIndexChanged(ByVal sender As System.Object, _
                                    ByVal e As System.EventArgs) Handles cmbTrade.SelectedIndexChanged
        Try
            ' Clearing trades data
            ClearTradesDefinitionData()

            If cmbTrade.SelectedIndex > -1 Then
                Dim tradeSysDef As CQGTradingSystemDefinition = m_CurTradingSystemDefs.ItemByName(cmbDefinition.Text)
                Dim tradeDef As CQGTradingSystemTradeDefinition = tradeSysDef.TradeDefinitions.ItemByName(cmbTrade.Text)

                lblTradeSide.Text = tradeDef.Side.ToString()

                ' Fill trade entry definition
                lblEntryOrderType.Text = tradeDef.Entry.OrderType.ToString()
                lblEntryAllowEntryOnExit.Text = tradeDef.Entry.AllowEntryOnExit.ToString()
                lblEntryAllowPyramids.Text = tradeDef.Entry.AllowPyramids.ToString()

                ' Fill trade exits definitions
                With cmbExit
                    For Each exitDef As CQGTradeExitDefinition In tradeDef.Exits
                        .Items.Add(exitDef.Name)
                    Next

                    If .Items.Count > 0 Then
                        .SelectedIndex = 0
                    End If
                End With
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbTrade_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Updates values connected with the selected trade.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbTradesNames_SelectedIndexChanged(ByVal sender As System.Object, _
                                        ByVal e As System.EventArgs) Handles cmbTradesNames.SelectedIndexChanged
        Try
            If cmbTradesNames.SelectedIndex = -1 Then
                Exit Sub
            End If

            DumpTradeItemsNames(cmbTradeItems)
            DumpTradeItemsNames(cmbShownTradeItems)

            DumpHeadersTrades(lvTrades)
            DumpHeadersTrades(lvShownTrades)

            ClearRecords(lvShownTrades)
            DumpRecordsTrades(m_CurTradingSystem.TradesRows.Count())
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbTradesNames_SelectedIndexChanged", ex)
        End Try
    End Sub


    ''' <summary>
    ''' Changes to show the selected Exit info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbExit_SelectedIndexChanged(ByVal sender As System.Object, _
                                   ByVal e As System.EventArgs) Handles cmbExit.SelectedIndexChanged
        Try
            ' Clearing exit data
            ClearExitDefinitionData()

            If cmbExit.SelectedIndex > -1 Then
                ' Dumping exit data
                Dim tradeSysDef As CQGTradingSystemDefinition = m_CurTradingSystemDefs.ItemByName(cmbDefinition.Text)
                Dim tradeDef As CQGTradingSystemTradeDefinition = tradeSysDef.TradeDefinitions.ItemByName(cmbTrade.Text)
                Dim exitDef As CQGTradeExitDefinition = tradeDef.Exits.ItemByName(cmbExit.Text)

                lblExitOrderType.Text = exitDef.OrderType.ToString()
                lblExitAllowExitOnEntry.Text = exitDef.AllowExitOnEntry.ToString()
                lblExitAllowMoreThanOnce.Text = exitDef.AllowMoreThanOnce.ToString()
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbTrade_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows selected row trades relations
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub lvTrades_SelectedIndexChanged(ByVal sender As System.Object, _
                                    ByVal e As System.EventArgs) Handles lvTrades.SelectedIndexChanged
        DumpTradeItemRelations(lvTrades, lvTradesRelations, cmbTradeItems)
    End Sub

    ''' <summary>
    ''' Shows selected row trades relations
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub lvShownTrades_SelectedIndexChanged(ByVal sender As System.Object, _
                                        ByVal e As System.EventArgs) Handles lvShownTrades.SelectedIndexChanged
        DumpTradeItemRelations(lvShownTrades, lvShownTradesRelations, cmbShownTradeItems)
    End Sub

    ''' <summary>
    ''' Opens frmTradingSystemRequestSettings and with passed values requests TradingSystem.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnRequest_Click(ByVal sender As System.Object, _
                          ByVal e As System.EventArgs) Handles btnRequest.Click
        Dim tradingSystem As CQGTradingSystem

        Try
            ' Opens the form to fill up request data
            Dim frmTradingSystemReq As frmTradingSystemRequestSettings = New frmTradingSystemRequestSettings
            Dim req As CQGTradingSystemRequest = CEL.CreateTradingSystemRequest(txtTradingSystemName.Text)

            req.SessionsFilter = 31 ' In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

            frmTradingSystemReq.TradingSystemRequest = req
            frmTradingSystemReq.LineTime = CEL.Environment.LineTime

            ' If the user confirms, request is sent to CQGCEL and added to the requests list
            If frmTradingSystemReq.ShowDialog(Me) = DialogResult.OK Then
                tradingSystem = CEL.RequestTradingSystem(req)

                cmbTradingSystem.Items.Add(tradingSystem.Id)
                cmbTradingSystem.SelectedIndex = cmbTradingSystem.Items.Count - 1

                ChangeControlsStatuses()
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "btnRequest_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Removes the selected trading system from the list and the CQGCEL.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnRemove_Click(ByVal sender As System.Object, _
                         ByVal e As System.EventArgs) Handles btnRemove.Click
        Try
            ' Removes trading system from the collection
            CEL.RemoveTradingSystem(m_CurTradingSystem)

            With cmbTradingSystem
                ' Removes TradingSystem from the combo box
                .Items.RemoveAt(.SelectedIndex)

                .SelectedIndex = .Items.Count - 1

                If .Items.Count = 0 Then
                    .SelectedIndex = -1
                    ClearAllData()
                    m_CurTradingSystem = Nothing
                End If
            End With

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmTradingSystem", "btnRemove_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Removes all trading system from the list and the CQGCEL.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnRemoveAll_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnRemoveAll.Click
        Try
            ' Clears the combo box
            cmbTradingSystem.Items.Clear()
            cmbTradingSystem.SelectedIndex = -1

            ' Removes all TradingSystem from the collection
            CEL.RemoveAllTradingSystems()

            m_CurTradingSystem = Nothing

            ClearAllData()

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmTradingSystem", "btnRemoveAll_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected TradingSystem info.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbTradingSystem_SelectedIndexChanged(ByVal sender As System.Object, _
                                          ByVal e As System.EventArgs) Handles cmbTradingSystem.SelectedIndexChanged
        Try
            With cmbTradingSystem
                If .SelectedIndex > -1 Then
                    ' Gets the selected Trading System object from CQGCEL by it's ID
                    m_CurTradingSystem = CEL.AllTradingSystems.ItemById(.Text)

                    ClearAllData()
                    DumpAllData()

                    DumpFilterInfoStatistics()
                    DumpFilterInfoTrades()
                End If
            End With

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbTradingSystem_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected entry/exit relations.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbTradeItems_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTradeItems.SelectedIndexChanged
        Try
            If (cmbTradeItems.SelectedIndex > -1) Then
                DumpTradeItemRelations(lvTrades, lvTradesRelations, cmbTradeItems)
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "cmbTradeItems_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Changes to show the selected entry/exit relations.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data
    ''' </param>
    Private Sub cmbShownTradeItems_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbShownTradeItems.SelectedIndexChanged
        Try
            If (cmbTradeItems.SelectedIndex > -1) Then
                DumpTradeItemRelations(lvShownTrades, lvShownTradesRelations, cmbShownTradeItems)
            End If
        Catch ex As Exception
            modErrorHandler.ShowError("frmTradingSystem", "cmbShownTradeItems_SelectedIndexChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows tag value of the current TradingSystem corresponding to the entered name.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A KeyEventArgs that contains the event data.
    ''' </param>
    Private Sub txtTagName_KeyDown(ByVal sender As System.Object, _
                            ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtTagName.KeyDown
        Try
            If txtTagName.Text.Trim.Length = 0 Then
                Exit Sub
            End If

            If e.KeyCode = Keys.Return Then
                txtTagValue.Text = CStr(m_CurTradingSystem.Tag(txtTagName.Text))
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "txtTagName_KeyDown", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Sets the tag value of the current TradingSystem corresponding to the entered name.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A KeyEventArgs that contains the event data.
    ''' </param>
    Private Sub txtTagValue_KeyDown(ByVal sender As System.Object, _
                            ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtTagValue.KeyDown
        Try
            If txtTagName.Text.Trim.Length = 0 Then
                Exit Sub
            End If

            If e.KeyCode = Keys.Return Then
                If Len(Trim(txtTagValue.Text)) = 0 Then
                    m_CurTradingSystem.Tag(txtTagName.Text) = Nothing
                Else
                    m_CurTradingSystem.Tag(txtTagName.Text) = txtTagValue.Text
                End If
                txtTagName.Text = ""
                txtTagValue.Text = ""
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "txtTagValue_KeyDown", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Opens CQG API web page.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' A LinkLabelLinkClickedEventArgs that contains the event data.
    ''' </param>
    Private Sub llWeb_LinkClicked(ByVal sender As System.Object, _
                           ByVal e As LinkLabelLinkClickedEventArgs) Handles llWeb.LinkClicked
        Try
            System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx")
        Catch ex As Exception
            ShowError("frmTradingSystem", "llWeb_LinkClicked", ex)
        End Try
    End Sub

    ''' <summary>
    ''' This event is fired, when some changes occur in the connection with CQG data server.
    ''' </summary>
    ''' <param name="new_status">
    ''' The current status of the connection with the data server.
    ''' </param>
    Private Sub CEL_DataConnectionStatusChanged(ByVal new_status As eConnectionStatus) Handles CEL.DataConnectionStatusChanged
        Dim sInfo As String
        Dim BackCol As System.Drawing.Color

        Try
            If new_status = eConnectionStatus.csConnectionUp Then
                BackCol = System.Drawing.Color.FromArgb(192, 209, 205)
                sInfo = "DATA Connection is UP"
            ElseIf new_status = eConnectionStatus.csConnectionDelayed Then
                BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
                sInfo = "DATA Connection is Delayed"
            Else
                BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
                sInfo = "DATA Connection is Down"
            End If

            lblDataConnection.BackColor = BackCol
            lblDataConnection.Text = sInfo

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_DataConnectionStatusChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
    ''' </summary>
    ''' <param name="cqg_error">
    ''' The object, in which the error has occurred.
    ''' </param>
    ''' <param name="error_description">
    ''' The string, describing the error.
    ''' </param>
    Private Sub CEL_DataError(ByVal cqg_error As Object, _
                        ByVal error_description As String) Handles CEL.DataError
        Try
            Dim cqgErr As CQGError = TryCast(cqg_error, CQGError)
            If CEL.IsValid(cqgErr) Then
                If cqgErr.Code = 102 Then
                    error_description &= " Restart the application."
                ElseIf cqgErr.Code = 125 Then
                    error_description &= " Turn on CQG Client and restart the application."
                End If
            End If

            MessageBox.Show(error_description, "TradingSystem", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_DataError", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Occurs when the requested trading system definitions are resolved.
    ''' </summary>
    ''' <param name="cqg_trading_system_definitions">
    ''' Collection of trading system definitions.
    ''' </param>
    ''' <param name="cqg_error">
    ''' CQGError object describing last error occurred
    ''' during processing request or Nothing in case of no error.
    ''' </param>
    Private Sub CEL_TradingSystemDefinitionsResolved(ByVal cqg_trading_system_definitions As CQGTradingSystemDefinitions, _
                                         ByVal cqg_error As CQGError) Handles CEL.TradingSystemDefinitionsResolved
        Try
            m_CurTradingSystemDefs = cqg_trading_system_definitions

            If CEL.IsValid(cqg_error) Then
                MessageBox.Show(cqg_error.Description, "TradingSystem", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            ' Fill up new data
            With cmbDefinition
                .Items.Clear()
                For Each tradeSysDef As CQGTradingSystemDefinition In cqg_trading_system_definitions
                    .Items.Add(tradeSysDef.Name)
                Next

                If .Items.Count > 0 Then
                    .SelectedIndex = 0
                End If
            End With
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_TradingSystemDefinitionsResolved", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Occurs when the requested trading system is resolved.
    ''' </summary>
    ''' <param name="cqg_trading_system">
    ''' The resolved CQGTradingSystem object.
    ''' </param>
    ''' <param name="cqg_error">
    ''' CQGError object describing last error occurred
    ''' during processing trading system request or Nothing
    ''' in case of no error.
    ''' </param>
    Private Sub CEL_TradingSystemResolved(ByVal cqg_trading_system As CQGTradingSystem, _
                                 ByVal cqg_error As CQGError) Handles CEL.TradingSystemResolved
        Try
            If cqg_trading_system.Id = m_CurTradingSystem.Id Then
                ClearAllData()
                DumpAllData()

                DumpFilterInfoStatistics()
                DumpFilterInfoTrades()
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_TradingSystemResolved", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows added Trades and Statistics for the selected request records on the appropriate listview controls.
    ''' </summary>
    ''' <param name="cqg_trading_system">
    ''' The resolved CQGTradingSystem object.
    ''' </param>
    Private Sub DumpTradesAndStatisticsRecords(ByVal cqg_trading_system As CQGTradingSystem)
        If cqg_trading_system.Id = m_CurTradingSystem.Id Then
            DumpRecordsTrades(m_CurTradingSystem.TradesRows.Count)
            DumpRecordsStatistics(m_CurTradingSystem.Statistics.Count)
        End If
    End Sub

    ''' <summary>
    ''' Occurs when the new trading system row is added.
    ''' </summary>
    ''' <param name="cqg_trading_system">
    ''' The resolved CQGTradingSystem object.
    ''' </param>
    ''' <param name="cqg_trading_system_add_info">
    ''' CQGTradingSystemAddInfo object containing 
    ''' additional info about added rows.
    ''' </param>
    Private Sub CEL_TradingSystemAddNotification(ByVal cqg_trading_system As CQGTradingSystem, _
                                      ByVal cqg_trading_system_add_info As CQGTradingSystemAddInfo) Handles CEL.TradingSystemAddNotification
        Try
            DumpTradesAndStatisticsRecords(cqg_trading_system)
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_TradingSystemAddNotification", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Occurs when the new trading system row is updated.
    ''' </summary>
    ''' <param name="cqg_trading_system">
    ''' The resolved CQGTradingSystem object.
    ''' </param>
    ''' <param name="cqg_trading_system_update_info">
    ''' CQGTradingSystemUpdateInfo object containing 
    ''' additional info about updated rows.
    ''' </param>
    Private Sub CEL_TradingSystemUpdateNotification(ByVal cqg_trading_system As CQGTradingSystem, _
                                        ByVal cqg_trading_system_update_info As CQGTradingSystemUpdateInfo) Handles CEL.TradingSystemUpdateNotification
        Try
            Dim index As Integer
            If cqg_trading_system.Id = m_CurTradingSystem.Id Then
                index = cqg_trading_system_update_info.Index
                If index >= m_CurTradingSystem.TradesRows.Count - MAX_NUMBER_OF_RECORDS Then
                    UpdateRecordTrades(lvTrades, m_CurTradingSystem.TradesRows(index), _
                                                     cqg_trading_system_update_info, index + 1)
                    If m_CurTradingSystem.Statistics.Count <> 0 Then
                        UpdateRecordStatistics(lvStatistics, m_CurTradingSystem.Statistics(index), _
                                                      cqg_trading_system_update_info, index + 1)
                    End If
                End If
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_TradingSystemUpdateNotification", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Occurs when the trading system row is inserted.
    ''' </summary>
    ''' <param name="cqg_trading_system">
    ''' The resolved CQGTradingSystem object.
    ''' </param>
    ''' <param name="cqg_trading_system_insert_info">
    ''' CQGTradingSystemInsertInfo object containing 
    ''' additional info about inserted rows.
    ''' </param>
    Private Sub CEL_TradingSystemInsertNotification(ByVal cqg_trading_system As CQGTradingSystem, _
                                        ByVal cqg_trading_system_insert_info As CQGTradingSystemInsertInfo) Handles CEL.TradingSystemInsertNotification
        Try
            DumpTradesAndStatisticsRecords(cqg_trading_system)
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_TradingSystemInsertNotification", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Occurs when the trading system row is removed.
    ''' </summary>
    ''' <param name="cqg_trading_system">
    ''' The resolved CQGTradingSystem object.
    ''' </param>
    ''' <param name="cqg_trading_system_remove_info">
    ''' CQGTradingSystemRemoveInfo object containing 
    ''' additional info about removed rows.
    ''' </param>
    Private Sub CEL_TradingSystemRemoveNotification(ByVal cqg_trading_system As CQGTradingSystem, _
                                        ByVal cqg_trading_system_remove_info As CQGTradingSystemRemoveInfo) Handles CEL.TradingSystemRemoveNotification
        Try
            DumpTradesAndStatisticsRecords(cqg_trading_system)
        Catch ex As Exception
            ShowError("frmTradingSystem", "CEL_TradingSystemRemoveNotification", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Enables\disables the controls, based on the connection status.
    ''' </summary>
    Private Sub ChangeControlsStatuses()
        Dim bIsDataConnectionUp As Boolean = False
        Dim bIsTradingSystemSelected As Boolean
        Dim bIsTradingSystemSucceded As Boolean = False

        Try
            If CEL.IsStarted Then
                bIsDataConnectionUp = (CEL.Environment.DataConnectionStatus = eConnectionStatus.csConnectionUp)
            End If

            btnReqTradingSystemDefinitions.Enabled = bIsDataConnectionUp
            btnRequest.Enabled = bIsDataConnectionUp

            bIsTradingSystemSelected = (Not m_CurTradingSystem Is Nothing)

            btnRemove.Enabled = bIsTradingSystemSelected And bIsDataConnectionUp
            btnRemoveAll.Enabled = bIsTradingSystemSelected And bIsDataConnectionUp

            txtTagName.Enabled = bIsTradingSystemSelected
            txtTagValue.Enabled = bIsTradingSystemSelected

            If bIsTradingSystemSelected Then
                bIsTradingSystemSucceded = (m_CurTradingSystem.Status = eRequestStatus.rsSuccess)
            End If

            dtpEndRangeStatistics.Enabled = bIsTradingSystemSucceded
            dtpStartRangeStatistics.Enabled = bIsTradingSystemSucceded
            nudEndStatistics.Enabled = bIsTradingSystemSucceded
            nudStartStatistics.Enabled = bIsTradingSystemSucceded
            optIndexIntervalStatistics.Enabled = bIsTradingSystemSucceded
            optTimeIntervalStatistics.Enabled = bIsTradingSystemSucceded
            btnShowStatistics.Enabled = bIsTradingSystemSucceded

            nudEndTrades.Enabled = bIsTradingSystemSucceded
            nudStartTrades.Enabled = bIsTradingSystemSucceded
            btnShowTrades.Enabled = bIsTradingSystemSucceded

            optIndexOrTimeIntervalStatistics_CheckedChanged(Nothing, Nothing)
        Catch ex As Exception
            ShowError("frmTradingSystem", "ChangeControlsStatuses", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows the selected request parameters on the listview.
    ''' </summary>
    Private Sub DumpRequestParams()
        Dim parameterDefinitionName As String
        Try
            Dim req As CQGTradingSystemRequest = m_CurTradingSystem.Request

            lblRPTradingSystemDefinitionName.Text = req.Definition.Name

            ' Adding parameters to the corresponding combo list
            For i As Integer = 0 To req.Definition.ParameterDefinitions.Count - 1
                parameterDefinitionName = req.Definition.ParameterDefinitions.Item(i).Name
                lstRPParameters.Items.Add(parameterDefinitionName & " - " & _
                                     req.Parameter(parameterDefinitionName).ToString())
            Next

            lblRPBaseExpression.Text = req.BaseExpression
            lblRPRangeStart.Text = GetValueAsString(req.RangeStart)
            lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd)
            lblRPIntradayPeriod.Text = req.IntradayPeriod.ToString()
            lblRPHistoricalPeriod.Text = req.HistoricalPeriod.ToString()
            lblRPIncludeEnd.Text = req.IncludeEnd.ToString()

            Dim sessionsFilter As String
            sessionsFilter = req.SessionsFilter.ToString()
            Select Case sessionsFilter
                Case "0"
                    sessionsFilter = "Primary session only (0)"
                Case "31"
                    sessionsFilter = "All sessions (31)"
            End Select

            lblRPSessionsFilter.Text = sessionsFilter
            lblRPContinuation.Text = req.Continuation.ToString()
            lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString()
            lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString()
            lblRPSessionFlags.Text = req.SessionFlags.ToString()
            lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString()
            If req.SubscriptionLevel = eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod Then
                lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString()
            End If

            If Not m_CurTradingSystem.LastError Is Nothing Then
                lblError.Text = m_CurTradingSystem.LastError.Description
            End If
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpRequestParams", ex)
        End Try
    End Sub

    ''' <summary>
    '''  Clears all data connected to TradingSystem definitions.
    ''' </summary>
    Private Sub ClearDefinitionData()
        Try
            ' Clear definition data
            lblAbbreviation.Text = ""
            lblCommission.Text = ""
            lblCommissionType.Text = ""

            ' Clear parameters
            cmbParameter.Items.Clear()
            cmbParameter.SelectedIndex = -1
            ClearParameterData()

            ' Clear trades
            cmbTrade.Items.Clear()
            cmbTrade.SelectedIndex = -1
            ClearTradesDefinitionData()

            ' Clear request input name
            txtTradingSystemName.Text = ""
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearDefinitionData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears all data connected to parameters.
    ''' </summary>
    Private Sub ClearParameterData()
        Try
            lblParameterComment.Text = ""
            lblParameterType.Text = ""
            lblParameterDefaultValue.Text = ""
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearParameterData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears all data connected to trades definitions.
    ''' </summary>
    Private Sub ClearTradesDefinitionData()
        Try
            lblTradeSide.Text = ""

            lblEntryOrderType.Text = ""
            lblEntryAllowEntryOnExit.Text = ""
            lblEntryAllowPyramids.Text = ""

            cmbExit.Items.Clear()
            cmbExit.SelectedIndex = -1
            ClearExitDefinitionData()
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearTradesDefinitionData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears all data connected to trades exits definitions.
    ''' </summary>
    Private Sub ClearExitDefinitionData()
        Try
            lblExitOrderType.Text = ""
            lblExitAllowExitOnEntry.Text = ""
            lblExitAllowMoreThanOnce.Text = ""
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearExitDefinitionData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears the request parameters from the sheet.
    ''' </summary>
    Private Sub ClearRequestParams()
        Try
            lblRPTradingSystemDefinitionName.Text = ""

            lstRPParameters.Items.Clear()

            lblRPBaseExpression.Text = ""
            lblRPRangeStart.Text = ""
            lblRPRangeEnd.Text = ""
            lblRPIntradayPeriod.Text = ""
            lblRPHistoricalPeriod.Text = ""
            lblRPIncludeEnd.Text = ""
            lblRPSessionsFilter.Text = ""
            lblRPContinuation.Text = ""
            lblRPEqualizeCloses.Text = ""
            lblRPDaysBeforeExpiration.Text = ""
            lblRPSessionFlags.Text = ""
            lblRPSubscriptionLevel.Text = ""
            lblRPRecalcPeriod.Text = ""

            lblError.Text = ""
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearRequestParams", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears request tags.
    ''' </summary>
    Private Sub ClearTags()
        Try
            txtTagName.Text = ""
            txtTagValue.Text = ""
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearTags", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears all data connected to trading systems.
    ''' </summary>
    Private Sub ClearAllData()
        Try
            lblStatus.Text = ""

            ClearRequestParams()
            ClearTags()

            'Statistics
            ClearHeadersStatistics(lvStatistics)
            ClearHeadersStatistics(lvShownStatistics)
            ClearRecords(lvStatistics)
            ClearRecords(lvShownStatistics)

            'Trades
            ClearTradesNames()
            ClearHeadersTrades(lvTrades)
            ClearHeadersTrades(lvShownTrades)
            ClearRecords(lvTrades)
            ClearRecords(lvShownTrades)
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearAllData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears trades items names combo list.
    ''' </summary>
    Private Sub ClearTradesItemsNames(ByVal cmbItemNames As ComboBox)
        Try
            cmbItemNames.Items.Clear()
            cmbItemNames.SelectedIndex = -1
        Catch ex As Exception
            modErrorHandler.ShowError("frmTradingSystem", "ClearTradesItemsNames", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears trades names combo list.
    ''' </summary>
    Private Sub ClearTradesNames()
        Try
            cmbTradesNames.Items.Clear()
            cmbTradesNames.SelectedIndex = -1

            ClearTradesItemsNames(cmbTradeItems)
            ClearTradesItemsNames(cmbShownTradeItems)
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearTradesNames", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears headers from the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview which headers must be cleared.
    ''' </param>
    Private Sub ClearHeadersStatistics(ByVal lv As ListView)
        Try
            lv.Columns.Clear()
            lv.Columns.Add("ID", 0, HorizontalAlignment.Center)
            lv.Columns.Add(INDEX_HEADER, 49, HorizontalAlignment.Center)
            lv.Columns.Add(TIMESTAMP_HEADER, 162, HorizontalAlignment.Center)
            lv.Columns.Add(TIMESTAMP_OFFSET_HEADER, 49, HorizontalAlignment.Center)
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearHeadersStatistics", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears headers from the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview which headers must be cleared.
    ''' </param>
    Private Sub ClearHeadersTrades(ByVal lv As ListView)
        Try
            lv.Columns.Clear()
            lv.Columns.Add("ID", 0, HorizontalAlignment.Center)
            lv.Columns.Add(INDEX_HEADER, 49, HorizontalAlignment.Center)
            lv.Columns.Add(TIMESTAMP_HEADER, 162, HorizontalAlignment.Center)
            lv.Columns.Add(TIMESTAMP_OFFSET_HEADER, 49, HorizontalAlignment.Center)
            lv.Columns.Add(SIGNALED_HEADER, 65, HorizontalAlignment.Center)

        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearHeadersTrades", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Clears records from the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview which records must be cleared.
    ''' </param>
    Private Sub ClearRecords(ByVal lv As ListView)
        Try
            lv.Items.Clear()
        Catch ex As Exception
            ShowError("frmTradingSystem", "ClearRecords", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Dumps all request data.
    ''' </summary>
    Private Sub DumpAllData()
        Try
            DumpRequestParams()

            lblStatus.Text = m_CurTradingSystem.Status.ToString()

            If m_CurTradingSystem.Status = eRequestStatus.rsSuccess Then
                ' Statistics
                DumpHeadersStatistics(lvStatistics)
                DumpHeadersStatistics(lvShownStatistics)
                ClearRecords(lvShownStatistics)
                DumpRecordsStatistics(m_CurTradingSystem.Statistics.Count)

                'Trades
                DumpTradesNames()
                DumpHeadersTrades(lvTrades)
                DumpHeadersTrades(lvShownTrades)
                ClearRecords(lvShownTrades)
                DumpRecordsTrades(m_CurTradingSystem.TradesRows.Count)
            End If

            ChangeControlsStatuses()
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpAllData", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows relations of the selected trade entry/exit.
    ''' </summary>
    ''' <param name="lvTradesRows">
    ''' ListView control which row is selected
    ''' </param>
    ''' <param name="lvRelations">
    ''' ListView control where relations should be dumped
    ''' </param>
    ''' <param name="cmbItemNames">
    ''' ComboBox control which item is selected
    ''' </param>
    Private Sub DumpTradeItemRelations(ByVal lvTradesRows As ListView, _
                               ByVal lvRelations As ListView, _
                               ByVal cmbItemNames As ComboBox)
        Try
            lvRelations.Items.Clear()

            If lvTradesRows.SelectedIndices.Count = 0 Then
                Exit Sub
            End If

            ' Retrieve currently selected trade row
            Dim tradeRow As Integer = CInt(lvTradesRows.SelectedItems(0).SubItems(1).Text) - 1
            Dim tsTradesRow As CQGTradingSystemTradesRow = m_CurTradingSystem.TradesRows(tradeRow)

            If tsTradesRow Is Nothing Then
                ' It is possible that the selected row is already removed,
                ' because the filtered list is not updated
                Exit Sub
            End If

            ' Retrieve currently selected trade object from the row
            Dim tsTrade As CQGTradingSystemTrade = tsTradesRow.ItemByName(cmbTradesNames.Text)
            If tsTrade Is Nothing Then
                Exit Sub
            End If

            ' Retrieve currently selected trade entry/exit
            Dim splitterIndex As Integer = cmbItemNames.Text.IndexOf(NAME_SPLITTER)

            If splitterIndex = -1 Then
                Dim tsTradeEntry As CQGTradeEntry = tsTrade.TradeEntry
                Dim item As ListViewItem

                For Each tradeExit As CQGTradeExit In tsTradeEntry.RelatedExits
                    item = lvRelations.Items.Add(New ListViewItem)
                    item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tradeExit.Trade.Timestamp, True)
                    item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tradeExit.Trade.TimestampOffset)
                    item.SubItems.Add(RELATED_ITEM_NAME_HEADER).Text = GetValueAsString(tradeExit.Trade.Definition.Name + NAME_SPLITTER + tradeExit.Definition.Name)
                Next
            Else
                Dim exitName As String = cmbItemNames.Text.Substring(splitterIndex + NAME_SPLITTER.Length)
                Dim tsTradeExit As CQGTradeExit = tsTrade.TradeExits.ItemByName(exitName)
                Dim item As ListViewItem

                For Each entry As CQGTradeEntry In tsTradeExit.RelatedEntries
                    item = lvRelations.Items.Add(New ListViewItem)
                    item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(entry.Trade.Timestamp, True)
                    item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(entry.Trade.TimestampOffset)
                    item.SubItems.Add(RELATED_ITEM_NAME_HEADER).Text = GetValueAsString(entry.Trade.Definition.Name)
                Next
            End If
        Catch ex As Exception
            modErrorHandler.ShowError("frmTradingSystem", "DumpTradeItemRelations", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows names of the selected TS trade entry/exits.
    ''' </summary>
    ''' <param name="cmbItemNames">
    ''' ComboBox to dump the entry/exits names
    ''' </param>
    Private Sub DumpTradeItemsNames(ByVal cmbItemNames As ComboBox)
        Try
            cmbItemNames.Items.Clear()

            Dim tsTradeDef As CQGTradingSystemTradeDefinition = m_CurTradingSystem.Definition.TradeDefinitions.ItemByName(cmbTradesNames.Text)

            Dim tradeName As String = tsTradeDef.Name
            cmbItemNames.Items.Add(tradeName)
            For Each exitDef As CQGTradeExitDefinition In tsTradeDef.Exits
                cmbItemNames.Items.Add(tradeName + NAME_SPLITTER + exitDef.Name)
            Next

            If cmbItemNames.Items.Count > 0 Then
                cmbItemNames.SelectedIndex = 0
            End If
        Catch ex As Exception
            modErrorHandler.ShowError("frmTradingSystem", "DumpTradeItemsNames", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows names of the selected TS trades.
    ''' </summary>
    Private Sub DumpTradesNames()
        Try
            With cmbTradesNames
                .Items.Clear()

                For Each tsTradeDef As CQGTradingSystemTradeDefinition In m_CurTradingSystem.Definition.TradeDefinitions
                    .Items.Add(tsTradeDef.Name)
                Next

                If .Items.Count > 0 Then
                    .SelectedIndex = 0
                End If
            End With
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpTradesNames", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows headers for the requested TS. (Statistics)
    ''' </summary>
    ''' <param name="lv">
    ''' Listview which headers must be dumped.
    ''' </param>
    Private Sub DumpHeadersStatistics(ByVal lv As ListView)
        Try
            With m_CurTradingSystem.Request
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageDuration) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssAverageDuration.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageLoss) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssAverageLoss.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageProfit) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssAverageProfit.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageWin) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssAverageWin.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssClosedNetProfit) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssClosedNetProfit.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecLosses) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssCurConsecLosses.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecWins) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssCurConsecWins.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurDrawDown) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssCurDrawDown.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssLinearRegression) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssLinearRegression.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxClosedDraw) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaxClosedDraw.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecLosses) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaxConsecLosses.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecWins) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaxConsecWins.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawAmount) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaxDrawAmount.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawDuration) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaxDrawDuration.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaximumLoss) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaximumLoss.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaximumWin) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssMaximumWin.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssOpenPosition) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssOpenPosition.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssPercentLong) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssPercentLong.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssPercentWinners) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssPercentWinners.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssProfitLossRatio) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssProfitLossRatio.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssProfitToMaxDraw) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssProfitToMaxDraw.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssRemoveToNeutral) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssRemoveToNeutral.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssReturnRetracement) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssReturnRetracement.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTimePercentage) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssTimePercentage.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTotalNetProfit) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssTotalNetProfit.ToString(), 120, HorizontalAlignment.Center)
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTotalTradeCount) Then
                    lv.Columns.Add(eTradingSystemStatistic.tssTotalTradeCount.ToString(), 120, HorizontalAlignment.Center)
                End If
            End With
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpHeadersStatistics", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows headers for the requested TS. (Trades)
    ''' Number of exits can vary between trades.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview which headers must be dumped.
    ''' </param>
    Private Sub DumpHeadersTrades(ByVal lv As ListView)
        Dim sTempExitName As String
        Try
            ClearHeadersTrades(lv)

            ' Dump trade entry
            lv.Columns.Add(ISACTIVE_HEADER, 120, HorizontalAlignment.Center)
            lv.Columns.Add(SIGNAL_HEADER & ENTRY_HEADER, 120, HorizontalAlignment.Center)
            lv.Columns.Add(PRICE_HEADER & ENTRY_HEADER, 120, HorizontalAlignment.Center)
            lv.Columns.Add(QUANTITY_HEADER & ENTRY_HEADER, 120, HorizontalAlignment.Center)
            lv.Columns.Add(STOP_LIMIT_PRICE_HEADER & ENTRY_HEADER, 120, HorizontalAlignment.Center)

            Dim tradeName As String = cmbTradesNames.Text
            If tradeName <> "" Then
                ' Dump trade exits
                Dim tsTradeDef As CQGTradingSystemTradeDefinition = _
                            m_CurTradingSystem.Definition.TradeDefinitions.ItemByName(tradeName)
                For i As Integer = 0 To tsTradeDef.Exits.Count - 1
                    sTempExitName = EXIT_HEADER & " (" & tsTradeDef.Exits(i).Name & ")"
                    lv.Columns.Add(SIGNAL_HEADER & sTempExitName, 120, HorizontalAlignment.Center)
                    lv.Columns.Add(PRICE_HEADER & sTempExitName, 120, HorizontalAlignment.Center)
                    lv.Columns.Add(QUANTITY_HEADER & sTempExitName, 120, HorizontalAlignment.Center)
                    lv.Columns.Add(STOP_LIMIT_PRICE_HEADER & sTempExitName, 120, HorizontalAlignment.Center)

                Next
            End If

        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpHeadersTrades", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows added Statistics for the selected request records on the listview.
    ''' </summary>
    ''' <param name="addedStatisticsCount">
    ''' Count of Statistics that will be shown.
    ''' </param>
    Private Sub DumpRecordsStatistics(ByVal addedStatisticsCount As Integer)
        Try
            ' Clears all records
            ClearRecords(lvStatistics)

            Dim tsStatistics As CQGTradingSystemStatisticsCollection = m_CurTradingSystem.Statistics

            If tsStatistics.Count = 0 Then
                Exit Sub
            End If

            If addedStatisticsCount = tsStatistics.Count Then
                addedStatisticsCount = CInt(IIf(addedStatisticsCount >= MAX_NUMBER_OF_RECORDS, MAX_NUMBER_OF_RECORDS, tsStatistics.Count))
            End If
            For i As Integer = tsStatistics.Count - 1 To tsStatistics.Count - addedStatisticsCount Step -1
                DumpRecordStatistics(lvStatistics, tsStatistics(i), i + 1)
            Next
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpRecordsStatistics", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows added Trades for the selected request records on the listview.
    ''' </summary>
    ''' <param name="addedTradesCount">
    ''' Count of Trades that will be shown.
    ''' </param>
    Private Sub DumpRecordsTrades(ByVal addedTradesCount As Integer)
        Try
            ' Clears all records
            ClearRecords(lvTrades)

            Dim tsTradesRows As CQGTradingSystemTradesRows = m_CurTradingSystem.TradesRows

            If tsTradesRows.Count = 0 Then
                Exit Sub
            End If

            If addedTradesCount = tsTradesRows.Count Then
                addedTradesCount = CInt(IIf(addedTradesCount >= MAX_NUMBER_OF_RECORDS, MAX_NUMBER_OF_RECORDS, tsTradesRows.Count))
            End If
            For i As Integer = tsTradesRows.Count - 1 To tsTradesRows.Count - addedTradesCount Step -1
                DumpRecordTrades(lvTrades, tsTradesRows(i), i + 1)
            Next

            DumpTradeItemRelations(lvTrades, lvTradesRelations, cmbTradeItems)
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpRecordsTrades", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Initializes the filter-related controls.
    ''' </summary>
    Private Sub DumpFilterInfoStatistics()
        Try
            If Not m_CurTradingSystem Is Nothing And m_CurTradingSystem.Status = eRequestStatus.rsSuccess _
               And m_CurTradingSystem.Statistics.Count > 0 Then
                dtpStartRangeStatistics.Value = m_CurTradingSystem.Statistics(0).Timestamp
                dtpEndRangeStatistics.Value = m_CurTradingSystem.Statistics(m_CurTradingSystem.Statistics.Count - 1).Timestamp
            Else
                dtpStartRangeStatistics.Value = Now
                dtpEndRangeStatistics.Value = Now
            End If
            nudStartStatistics.Value = 1
            nudEndStatistics.Value = 10
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpFilterInfoStatistics", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Initializes the filter-related controls.
    ''' </summary>
    Private Sub DumpFilterInfoTrades()
        Try
            nudStartTrades.Value = 1
            nudEndTrades.Value = 10
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpFilterInfoTrades", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Dumps one record's values to the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview, in which data must be shown.
    ''' </param>
    ''' <param name="tsStatistics">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be shown.
    ''' </param>
    Private Sub DumpRecordStatistics(ByVal lv As ListView, _
                             ByVal tsStatistics As CQGTradingSystemStatistics, _
                             ByVal recordIndex As Long)
        Try
            Dim item As ListViewItem = lv.Items.Add(New ListViewItem)
            item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString()
            item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tsStatistics.Timestamp, True)
            item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tsStatistics.TimestampOffset)
            With m_CurTradingSystem.Request
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageDuration) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageDuration.ToString()).Text = _
                          GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageDuration))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageLoss) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageLoss.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageLoss))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageProfit) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageProfit.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageProfit))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageWin) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageWin.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageWin))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssClosedNetProfit) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssClosedNetProfit.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssClosedNetProfit))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecLosses) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssCurConsecLosses.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssCurConsecLosses))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecWins) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssCurConsecWins.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssCurConsecWins))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurDrawDown) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssCurDrawDown.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssCurDrawDown))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssLinearRegression) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssLinearRegression.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssLinearRegression))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxClosedDraw) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxClosedDraw.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxClosedDraw))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecLosses) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecLosses.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxConsecLosses))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecWins) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecWins.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxConsecWins))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawAmount) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawAmount.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxDrawAmount))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawDuration) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawDuration.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxDrawDuration))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaximumLoss) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaximumLoss.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaximumLoss))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaximumWin) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaximumWin.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaximumWin))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssOpenPosition) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssOpenPosition.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssOpenPosition))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssPercentLong) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssPercentLong.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssPercentLong))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssPercentWinners) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssPercentWinners.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssPercentWinners))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssProfitLossRatio) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssProfitLossRatio.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssProfitLossRatio))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssProfitToMaxDraw) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssProfitToMaxDraw.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssProfitToMaxDraw))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssRemoveToNeutral) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssRemoveToNeutral.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssRemoveToNeutral))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssReturnRetracement) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssReturnRetracement.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssReturnRetracement))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTimePercentage) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssTimePercentage.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssTimePercentage))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTotalNetProfit) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssTotalNetProfit.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssTotalNetProfit))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTotalTradeCount) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssTotalTradeCount.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssTotalTradeCount))
                End If
            End With
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpRecordStatistics", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Dumps one record's values to the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview, in which data must be shown.
    ''' </param>
    ''' <param name="tsTradesRow">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be shown.
    ''' </param>
    Private Sub DumpRecordTrades(ByVal lv As ListView, _
                          ByVal tsTradesRow As CQGTradingSystemTradesRow, _
                          ByVal recordIndex As Long)
        Try
            Dim item As ListViewItem = CreateListViewItem(tsTradesRow, cmbTradesNames.Text, recordIndex)
            lv.Items.Add(item)
        Catch ex As Exception
            ShowError("frmTradingSystem", "DumpRecordTrades", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Dumps one record's values to the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview, in which data must be shown.
    ''' </param>
    ''' <param name="tsStatistics">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="tsUpdateInfo">
    ''' CQGTradingSystemUpdateInfo object containing 
    ''' additional info about updated rows.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be shown.
    ''' </param>
    Private Sub UpdateRecordStatistics(ByVal lv As ListView, _
                               ByVal tsStatistics As CQGTradingSystemStatistics, _
                               ByVal tsUpdateInfo As ICQGTradingSystemUpdateInfo, _
                               ByVal recordIndex As Integer)
        Try
            Dim item As ListViewItem = New ListViewItem
            item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString()
            item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tsStatistics.Timestamp, True)
            item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tsStatistics.TimestampOffset)
            ' tsUpdateInfo - can be used to get only changed statistics.
            With m_CurTradingSystem.Request
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageDuration) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageDuration.ToString()).Text = _
                          GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageDuration))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageLoss) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageLoss.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageLoss))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageProfit) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageProfit.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageProfit))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssAverageWin) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssAverageWin.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssAverageWin))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssClosedNetProfit) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssClosedNetProfit.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssClosedNetProfit))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecLosses) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssCurConsecLosses.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssCurConsecLosses))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecWins) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssCurConsecWins.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssCurConsecWins))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssCurDrawDown) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssCurDrawDown.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssCurDrawDown))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssLinearRegression) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssLinearRegression.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssLinearRegression))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxClosedDraw) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxClosedDraw.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxClosedDraw))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecLosses) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecLosses.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxConsecLosses))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecWins) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecWins.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxConsecWins))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawAmount) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawAmount.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxDrawAmount))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawDuration) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawDuration.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaxDrawDuration))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaximumLoss) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaximumLoss.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaximumLoss))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssMaximumWin) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssMaximumWin.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssMaximumWin))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssOpenPosition) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssOpenPosition.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssOpenPosition))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssPercentLong) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssPercentLong.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssPercentLong))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssPercentWinners) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssPercentWinners.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssPercentWinners))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssProfitLossRatio) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssProfitLossRatio.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssProfitLossRatio))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssProfitToMaxDraw) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssProfitToMaxDraw.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssProfitToMaxDraw))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssRemoveToNeutral) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssRemoveToNeutral.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssRemoveToNeutral))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssReturnRetracement) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssReturnRetracement.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssReturnRetracement))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTimePercentage) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssTimePercentage.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssTimePercentage))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTotalNetProfit) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssTotalNetProfit.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssTotalNetProfit))
                End If
                If .IsStatisticIncluded(eTradingSystemStatistic.tssTotalTradeCount) Then
                    item.SubItems.Add(eTradingSystemStatistic.tssTotalTradeCount.ToString()).Text = _
                             GetValueAsString(tsStatistics.Value(eTradingSystemStatistic.tssTotalTradeCount))
                End If
                lv.Items(m_CurTradingSystem.Statistics.Count - recordIndex) = item
            End With
        Catch ex As Exception
            ShowError("frmTradingSystem", "UpdateRecordStatistics", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Creates list view item and dumps trades row values.
    ''' </summary>
    ''' <param name="tsTradesRow">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="tradeName">
    ''' Trade name, which values must be shown.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be shown.
    ''' </param>
    Private Function CreateListViewItem(ByVal tsTradesRow As CQGTradingSystemTradesRow, _
                               ByVal tradeName As String, _
                               ByVal recordIndex As Long) As ListViewItem
        Dim item As ListViewItem = New ListViewItem
        item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString()
        item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tsTradesRow.Timestamp, True)
        item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tsTradesRow.TimestampOffset)

        ' Retrieve currently selected trade object from the row
        Dim tsTrade As CQGTradingSystemTrade = tsTradesRow.ItemByName(tradeName)
        If tsTrade Is Nothing Then
            Return item
        End If

        item.SubItems.Add(SIGNALED_HEADER).Text = HasSignaledEntryExitByTrade(tsTrade)

        ' Dump trade entry
        Dim tsTradeEntry As CQGTradeEntry = tsTrade.TradeEntry

        item.SubItems.Add(ISACTIVE_HEADER).Text = GetValueAsString(tsTrade.IsActive)
        item.SubItems.Add(SIGNAL_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.Signal)
        item.SubItems.Add(PRICE_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.Price)
        item.SubItems.Add(QUANTITY_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.Quantity)
        item.SubItems.Add(STOP_LIMIT_PRICE_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.StopLimitPrice)

        ' Dump trade exits
        Dim tsTradeExitsDef As CQGTradeExitDefinitions = tsTrade.Definition.Exits
        Dim tsTradeExit As CQGTradeExit
        Dim sTempExitName As String
        For i As Integer = 0 To tsTradeExitsDef.Count - 1
            tsTradeExit = tsTrade.TradeExits.ItemByName(tsTradeExitsDef(i).Name)

            sTempExitName = EXIT_HEADER & " (" & tsTradeExitsDef(i).Name & ")"
            item.SubItems.Add(SIGNAL_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.Signal)
            item.SubItems.Add(PRICE_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.Price)
            item.SubItems.Add(QUANTITY_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.Quantity)
            item.SubItems.Add(STOP_LIMIT_PRICE_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.StopLimitPrice)
        Next

        Return item
    End Function

    ''' <summary>
    ''' Dumps one record's values to the listview.
    ''' </summary>
    ''' <param name="lv">
    ''' Listview, in which data must be shown.
    ''' </param>
    ''' <param name="tsTradesRow">
    ''' Record, which values must be shown.
    ''' </param>
    ''' <param name="tsUpdateInfo">
    ''' CQGTradingSystemUpdateInfo object containing 
    ''' additional info about updated rows.
    ''' </param>
    ''' <param name="recordIndex">
    ''' Index of record, which values must be shown.
    ''' </param>
    Private Sub UpdateRecordTrades(ByVal lv As ListView, _
                            ByVal tsTradesRow As CQGTradingSystemTradesRow, _
                            ByVal tsUpdateInfo As ICQGTradingSystemUpdateInfo, _
                            ByVal recordIndex As Integer)
        Try
            Dim item As ListViewItem = CreateListViewItem(tsTradesRow, cmbTradesNames.Text, recordIndex)
            lv.Items(m_CurTradingSystem.TradesRows.Count - recordIndex) = item
        Catch ex As Exception
            ShowError("frmTradingSystem", "UpdateRecordTrades", ex)
        End Try
    End Sub


    ''' <summary>
    ''' Changes the visibility of groupboxes.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub optIndexOrTimeIntervalStatistics_CheckedChanged(ByVal sender As System.Object, _
                                                 ByVal e As System.EventArgs) Handles optIndexIntervalStatistics.CheckedChanged
        Try
            gbIndexIntervalStatistics.Visible = optIndexIntervalStatistics.Checked
            gbTimeIntervalStatistics.Visible = optTimeIntervalStatistics.Checked
        Catch ex As Exception
            ShowError("frmTradingSystem", "optIndexOrTimeInterval_CheckedChanged", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows few data from the selected Statistics collection.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnShowStatistics_Click(ByVal sender As System.Object, _
                               ByVal e As System.EventArgs) Handles btnShowStatistics.Click
        Dim iStart As Integer
        Dim iEnd As Integer
        Dim dStart As Date
        Dim dEnd As Date

        Try
            lvShownStatistics.Items.Clear()

            If optIndexIntervalStatistics.Checked Then
                iStart = CInt(nudStartStatistics.Value) - 1
                iEnd = CInt(nudEndStatistics.Value) - 1
                If iStart > iEnd Or iEnd > m_CurTradingSystem.Statistics.Count - 1 Or _
                   iEnd - iStart >= MAX_INDEX_INTERVAL Then
                    MessageBox.Show("The start index must be smaller than the end index," & Environment.NewLine & _
                                "their range must indicate to no more than " & MAX_INDEX_INTERVAL & " records," & Environment.NewLine & _
                                "and no more than the returned records count.", _
                                "Incorrect range", _
                                MessageBoxButtons.OK, _
                                MessageBoxIcon.Exclamation)
                    Exit Sub
                End If
            Else
                ' To get time with 00 seconds
                dStart = dtpStartRangeStatistics.Value.AddSeconds(-dtpStartRangeStatistics.Value.Second)
                dEnd = dtpEndRangeStatistics.Value.AddSeconds(-dtpEndRangeStatistics.Value.Second)
                iStart = m_CurTradingSystem.Statistics.IndexForDate(dStart)
                iEnd = m_CurTradingSystem.Statistics.IndexForDate(dEnd)
                If CEL.IsValid(iStart) And CEL.IsValid(iEnd) Then
                    If dStart > dEnd Or iEnd - iStart >= MAX_INDEX_INTERVAL Then
                        MessageBox.Show("The start time must be earlier than the end time and their" & Environment.NewLine & _
                                    "range must indicate to no more than " & MAX_INDEX_INTERVAL & " records.", _
                                    "Incorrect range", _
                                    MessageBoxButtons.OK, _
                                    MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Else
                    MessageBox.Show("The start time must be earlier than the end time and their" & Environment.NewLine & _
                                "range must indicate to no more than " & MAX_INDEX_INTERVAL & " records.", _
                                "Incorrect range", _
                                MessageBoxButtons.OK, _
                                MessageBoxIcon.Exclamation)
                    Exit Sub
                End If
            End If

            lvShownStatistics.SuspendLayout()
            For i As Integer = iEnd To iStart Step -1
                DumpRecordStatistics(lvShownStatistics, m_CurTradingSystem.Statistics(i), i + 1)
            Next
            lvShownStatistics.ResumeLayout(False)
        Catch ex As Exception
            ShowError("frmTradingSystem", "btnShowStatistics_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Shows few data from the selected Trades collection.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub btnShowTrades_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnShowTrades.Click
        Try
            lvShownTrades.Items.Clear()

            Dim iStart As Integer = CInt(nudStartTrades.Value) - 1
            Dim iEnd As Integer = CInt(nudEndTrades.Value) - 1
            If iStart > iEnd Or iEnd > m_CurTradingSystem.TradesRows.Count - 1 Or _
               iEnd - iStart >= MAX_INDEX_INTERVAL Then
                MessageBox.Show("The start index must be smaller than the end index," & Environment.NewLine & _
                            "their range must indicate to no more than " & MAX_INDEX_INTERVAL & " records," & Environment.NewLine & _
                            "and no more than the returned records count.", _
                            "Incorrect range", _
                            MessageBoxButtons.OK, _
                            MessageBoxIcon.Exclamation)
                Exit Sub
            End If


            lvShownTrades.SuspendLayout()
            For i As Integer = iEnd To iStart Step -1
                DumpRecordTrades(lvShownTrades, m_CurTradingSystem.TradesRows(i), i + 1)
            Next
            lvShownTrades.ResumeLayout(False)
        Catch ex As Exception
            ShowError("frmTradingSystem", "btnShowTrades_Click", ex)
        End Try
    End Sub

    ''' <summary>
    ''' Returns flag indicating whether any of the entry\exits was signaled by trade.
    ''' </summary>
    ''' <param name="tsTrade">
    ''' CQGTradingSystemTrade object reference.
    ''' </param>
    ''' <returns>
    ''' "Yes" if there was a signaled entry or exit, "No" otherwise.
    ''' </returns>
    Private Function HasSignaledEntryExitByTrade(ByVal tsTrade As CQGTradingSystemTrade) As String
        Dim sResult As String = "No"

        If tsTrade.TradeEntry.Signal Then
            sResult = "Yes"
        Else
            For i As Integer = 0 To tsTrade.TradeExits.Count - 1
                If tsTrade.TradeExits.Item(i).Signal Then
                    sResult = "Yes"
                    Exit For
                End If
            Next
        End If

        Return sResult
    End Function

    ''' <summary>
    ''' Validates the specified value and converts it to string.
    ''' </summary>
    ''' <param name="val">
    ''' The value that will be validated and converted
    ''' </param>
    ''' <param name="includeMilliseconds">
    ''' Whether to include seconds and milliseconds to string, valid only for DateTime
    ''' </param>
    ''' <returns>
    ''' Value converted to string or "N/A" if the value is invalid.
    ''' </returns>
    Private Function GetValueAsString(ByVal val As Object,
                                      Optional ByVal includeMilliseconds As Boolean = False) As String
        Dim sResult As String = ""

        Try
            If CEL.IsValid(val) Then
                If val.GetType().FullName = "System.DateTime" Then
                    Dim format As String = If(includeMilliseconds, "dd/MM/yyyy HH:mm:ss.fff", "dd/MM/yyyy HH:mm")
                    sResult = CDate(val).ToString(format)
                ElseIf val.GetType().FullName = "System.Double" Then
                    sResult = Math.Round(CDbl(val), 2).ToString()
                Else
                    sResult = val.ToString()
                End If
            Else
                sResult = N_A
            End If
        Catch
            sResult = N_A
        End Try

        Return sResult
    End Function

End Class
