using System.Diagnostics;
using Microsoft.VisualBasic;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using CQG;

namespace TradingSystem
{
	public class frmTradingSystem : System.Windows.Forms.Form
	{

		[STAThread]
		static void Main()
		{
			Application.Run(new frmTradingSystem());
		}

		// The CQGCEL object, which encapsulates the main functionality of CQG API
		[field: System.CLSCompliant(false)]
		public CQGCEL CEL;

		// Currently selected trading system object in the combo box
		private CQGTradingSystem m_CurTradingSystem;

		// Currently requested TradingSystem definitions object
		private CQGTradingSystemDefinitions m_CurTradingSystemDefs;

		// Specifies the not available string
		private const string N_A = "N/A";

		// Specifies the header of index column
		private const string INDEX_HEADER = "Index";

		// Specifies the header of timestamp column
		private const string TIMESTAMP_HEADER = "Timestamp";

		// Specifies the header of timestamp offset column
		private const string TIMESTAMP_OFFSET_HEADER = "Offset";

		// Specifies the header of signaled column
		private const string SIGNALED_HEADER = "Signaled";

		// Specifies the header of exit column
		private const string EXIT_HEADER = " - Exit";

		// Specifies the header of entry column
		private const string ENTRY_HEADER = " - Entry";

		// Specifies the header of signal column
		private const string SIGNAL_HEADER = "Signal";

		//Specifies the header of CanPlaceOrderSignal column
		private const string CAN_PLACE_ORDER_SIGNAL = "CanPlaceOrderSignal";

		// Specifies the header of is active column
		private const string ISACTIVE_HEADER = "IsActive";

		// Specifies the header of price column
		private const string PRICE_HEADER = "Price";

		// Specifies the header of quantity column
		private const string QUANTITY_HEADER = "Quantity";

		// Specifies the header of StopLimitPrice column
		private const string STOP_LIMIT_PRICE_HEADER = "StopLimitPrice";

		// Specifies the header of related item names column
		private const string RELATED_ITEM_NAME_HEADER = "Name";

		// Specifies the trade name and exit name splitter
		private const string NAME_SPLITTER = " - ";

		// Specifies the max records count
		private const int MAX_NUMBER_OF_RECORDS = 10;

		// Specifies the max index interval
		private const int MAX_INDEX_INTERVAL = 500;

		#region " Windows Form Designer generated code "

		public frmTradingSystem()
		{

			//This call is required by the Windows Form Designer.
			InitializeComponent();

			//Add any initialization after the InitializeComponent() call

		}

		//Form overrides dispose to clean up the component list.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(components == null))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		//Required by the Windows Form Designer
		private System.ComponentModel.Container components = null;

		//NOTE: The following procedure is required by the Windows Form Designer
		//It can be modified using the Windows Form Designer.
		//Do not modify it using the code editor.
		internal System.Windows.Forms.Label lblDataConnection;
		internal System.Windows.Forms.PictureBox PictureBox1;
		internal System.Windows.Forms.LinkLabel llWeb;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label17;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Label Label23;
		internal System.Windows.Forms.Label Label25;
		internal System.Windows.Forms.Label Label27;
		internal System.Windows.Forms.Label Label29;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.TabControl tcTradingSystem;
		internal System.Windows.Forms.TabPage tpTradingSystem;
		internal System.Windows.Forms.TabPage tpTrades;
		internal System.Windows.Forms.TabPage tpStatistics;
		internal System.Windows.Forms.GroupBox GroupBox7;
		internal System.Windows.Forms.ComboBox cmbDefinition;
		internal System.Windows.Forms.Button btnReqTradingSystemDefinitions;
		internal System.Windows.Forms.GroupBox GroupBox2;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.ComboBox cmbParameter;
		internal System.Windows.Forms.Label lblParameterComment;
		internal System.Windows.Forms.Label Label28;
		internal System.Windows.Forms.Label Label24;
		internal System.Windows.Forms.Label lblParameterDefaultValue;
		internal System.Windows.Forms.Label Label15;
		internal System.Windows.Forms.Label lblParameterType;
		internal System.Windows.Forms.Label Label22;
		internal System.Windows.Forms.Label lblAbbreviation;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label lblCommissionType;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label lblCommission;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.ComboBox cmbTrade;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Label lblTradeSide;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.GroupBox GroupBox3;
		internal System.Windows.Forms.ComboBox cmbExit;
		internal System.Windows.Forms.Label lblExitOrderType;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.Label lblExitAllowMoreThanOnce;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.Label lblExitAllowExitOnEntry;
		internal System.Windows.Forms.Label Label19;
		internal System.Windows.Forms.GroupBox GroupBox4;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.Label Label30;
		internal System.Windows.Forms.Label lblEntryOrderType;
		internal System.Windows.Forms.Label lblEntryAllowPyramids;
		internal System.Windows.Forms.Label lblEntryAllowEntryOnExit;
		internal System.Windows.Forms.PictureBox PictureBox2;
		internal System.Windows.Forms.TextBox txtTradingSystemName;
		internal System.Windows.Forms.Label lblError;
		internal System.Windows.Forms.GroupBox GroupBox6;
		internal System.Windows.Forms.Label lblStatus;
		internal System.Windows.Forms.GroupBox GroupBox5;
		internal System.Windows.Forms.TextBox txtTagValue;
		internal System.Windows.Forms.TextBox txtTagName;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.Label Label18;
		internal System.Windows.Forms.PictureBox PictureBox3;
		internal System.Windows.Forms.GroupBox GroupBox8;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Label Label26;
		internal System.Windows.Forms.Label Label32;
		internal System.Windows.Forms.Label Label34;
		internal System.Windows.Forms.Label Label36;
		internal System.Windows.Forms.Label Label38;
		internal System.Windows.Forms.Label Label40;
		internal System.Windows.Forms.Label Label44;
		internal System.Windows.Forms.Label Label46;
		internal System.Windows.Forms.Label lblRPRangeEnd;
		internal System.Windows.Forms.Label Label47;
		internal System.Windows.Forms.Label Label49;
		internal System.Windows.Forms.Label lblRPRangeStart;
		internal System.Windows.Forms.Label Label50;
		internal System.Windows.Forms.Label Label52;
		internal System.Windows.Forms.Button btnRemoveAll;
		internal System.Windows.Forms.Button btnRemove;
		internal System.Windows.Forms.Button btnRequest;
		internal System.Windows.Forms.ComboBox cmbTradingSystem;
		internal System.Windows.Forms.Label lblRPIntradayPeriod;
		internal System.Windows.Forms.Label lblRPEqualizeCloses;
		internal System.Windows.Forms.ListBox lstRPParameters;
		internal System.Windows.Forms.Label lblRPTradingSystemDefinitionName;
		internal System.Windows.Forms.Label lblRPDaysBeforeExpiration;
		internal System.Windows.Forms.Label lblRPContinuation;
		internal System.Windows.Forms.Label lblRPIncludeEnd;
		internal System.Windows.Forms.Label lblRPHistoricalPeriod;
		internal System.Windows.Forms.Label lblRPBaseExpression;
		internal System.Windows.Forms.Label lblRPSessionsFilter;
		internal System.Windows.Forms.Label lblRPSessionFlags;
		internal System.Windows.Forms.GroupBox GroupBox9;
		internal System.Windows.Forms.ListView lvShownStatistics;
		internal System.Windows.Forms.Label Label31;
		internal System.Windows.Forms.Label Label33;
		internal System.Windows.Forms.Label Label35;
		internal System.Windows.Forms.Label Label37;
		internal System.Windows.Forms.ColumnHeader ColumnHeader9;
		internal System.Windows.Forms.ColumnHeader ColumnHeader10;
		internal System.Windows.Forms.ColumnHeader ColumnHeader11;
		internal System.Windows.Forms.GroupBox GroupBox10;
		internal System.Windows.Forms.ListView lvStatistics;
		internal System.Windows.Forms.ColumnHeader ColumnHeader13;
		internal System.Windows.Forms.ColumnHeader ColumnHeader14;
		internal System.Windows.Forms.ColumnHeader ColumnHeader15;
		internal System.Windows.Forms.Button btnShowStatistics;
		internal System.Windows.Forms.GroupBox gbTimeIntervalStatistics;
		internal System.Windows.Forms.DateTimePicker dtpEndRangeStatistics;
		internal System.Windows.Forms.DateTimePicker dtpStartRangeStatistics;
		internal System.Windows.Forms.GroupBox gbIndexIntervalStatistics;
		internal System.Windows.Forms.NumericUpDown nudEndStatistics;
		internal System.Windows.Forms.NumericUpDown nudStartStatistics;
		internal System.Windows.Forms.RadioButton optTimeIntervalStatistics;
		internal System.Windows.Forms.RadioButton optIndexIntervalStatistics;
		internal System.Windows.Forms.GroupBox GroupBox11;
		internal System.Windows.Forms.GroupBox GroupBox13;
		internal System.Windows.Forms.Label Label42;
		internal System.Windows.Forms.Label Label43;
		internal System.Windows.Forms.ColumnHeader ColumnHeader1;
		internal System.Windows.Forms.ColumnHeader ColumnHeader2;
		internal System.Windows.Forms.ColumnHeader ColumnHeader3;
		internal System.Windows.Forms.GroupBox GroupBox14;
		internal System.Windows.Forms.ListView lvTrades;
		internal System.Windows.Forms.ColumnHeader ColumnHeader4;
		internal System.Windows.Forms.ColumnHeader ColumnHeader5;
		internal System.Windows.Forms.ColumnHeader ColumnHeader6;
		internal System.Windows.Forms.ComboBox cmbTradesNames;
		internal System.Windows.Forms.Label Label45;
		internal System.Windows.Forms.ColumnHeader ColumnHeader7;
		internal System.Windows.Forms.ListView lvShownTrades;
		internal System.Windows.Forms.Button btnShowTrades;
		internal System.Windows.Forms.NumericUpDown nudEndTrades;
		internal System.Windows.Forms.NumericUpDown nudStartTrades;
		internal System.Windows.Forms.Label lblRPRecalcPeriod;
		internal System.Windows.Forms.Label label39;
		internal System.Windows.Forms.Label lblRPSubscriptionLevel;
		internal System.Windows.Forms.Label label41;
		internal System.Windows.Forms.ComboBox cmbTradeItems;
		internal System.Windows.Forms.ColumnHeader columnHeader16;
		internal System.Windows.Forms.GroupBox groupBox12;
		internal System.Windows.Forms.ColumnHeader columnHeader8;
		internal System.Windows.Forms.ColumnHeader columnHeader12;
		internal System.Windows.Forms.ListView lvTradesRelations;
		internal System.Windows.Forms.ColumnHeader columnHeader17;
		internal System.Windows.Forms.ColumnHeader columnHeader18;
		internal System.Windows.Forms.ColumnHeader columnHeader19;
		internal System.Windows.Forms.GroupBox groupBox15;
		internal System.Windows.Forms.ComboBox cmbShownTradeItems;
		internal System.Windows.Forms.ListView lvShownTradesRelations;
		internal System.Windows.Forms.ColumnHeader columnHeader20;
		internal System.Windows.Forms.ColumnHeader columnHeader21;
		[System.Diagnostics.DebuggerStepThrough()]
		private void InitializeComponent()
		{
			this.lblDataConnection = new System.Windows.Forms.Label();
			this.PictureBox1 = new System.Windows.Forms.PictureBox();
			this.llWeb = new System.Windows.Forms.LinkLabel();
			this.Label11 = new System.Windows.Forms.Label();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label27 = new System.Windows.Forms.Label();
			this.Label29 = new System.Windows.Forms.Label();
			this.Label23 = new System.Windows.Forms.Label();
			this.Label25 = new System.Windows.Forms.Label();
			this.Label17 = new System.Windows.Forms.Label();
			this.Label21 = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.Label13 = new System.Windows.Forms.Label();
			this.tcTradingSystem = new System.Windows.Forms.TabControl();
			this.tpTradingSystem = new System.Windows.Forms.TabPage();
			this.txtTradingSystemName = new System.Windows.Forms.TextBox();
			this.lblError = new System.Windows.Forms.Label();
			this.GroupBox6 = new System.Windows.Forms.GroupBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.GroupBox5 = new System.Windows.Forms.GroupBox();
			this.txtTagValue = new System.Windows.Forms.TextBox();
			this.txtTagName = new System.Windows.Forms.TextBox();
			this.Label14 = new System.Windows.Forms.Label();
			this.Label18 = new System.Windows.Forms.Label();
			this.PictureBox3 = new System.Windows.Forms.PictureBox();
			this.GroupBox8 = new System.Windows.Forms.GroupBox();
			this.lblRPRecalcPeriod = new System.Windows.Forms.Label();
			this.label39 = new System.Windows.Forms.Label();
			this.lblRPSubscriptionLevel = new System.Windows.Forms.Label();
			this.label41 = new System.Windows.Forms.Label();
			this.lstRPParameters = new System.Windows.Forms.ListBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.lblRPTradingSystemDefinitionName = new System.Windows.Forms.Label();
			this.Label26 = new System.Windows.Forms.Label();
			this.lblRPDaysBeforeExpiration = new System.Windows.Forms.Label();
			this.Label32 = new System.Windows.Forms.Label();
			this.lblRPEqualizeCloses = new System.Windows.Forms.Label();
			this.Label34 = new System.Windows.Forms.Label();
			this.lblRPContinuation = new System.Windows.Forms.Label();
			this.Label36 = new System.Windows.Forms.Label();
			this.lblRPSessionsFilter = new System.Windows.Forms.Label();
			this.Label38 = new System.Windows.Forms.Label();
			this.lblRPIncludeEnd = new System.Windows.Forms.Label();
			this.Label40 = new System.Windows.Forms.Label();
			this.lblRPHistoricalPeriod = new System.Windows.Forms.Label();
			this.Label44 = new System.Windows.Forms.Label();
			this.lblRPIntradayPeriod = new System.Windows.Forms.Label();
			this.Label46 = new System.Windows.Forms.Label();
			this.lblRPRangeEnd = new System.Windows.Forms.Label();
			this.Label47 = new System.Windows.Forms.Label();
			this.lblRPSessionFlags = new System.Windows.Forms.Label();
			this.Label49 = new System.Windows.Forms.Label();
			this.lblRPRangeStart = new System.Windows.Forms.Label();
			this.Label50 = new System.Windows.Forms.Label();
			this.lblRPBaseExpression = new System.Windows.Forms.Label();
			this.Label52 = new System.Windows.Forms.Label();
			this.btnRemoveAll = new System.Windows.Forms.Button();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnRequest = new System.Windows.Forms.Button();
			this.cmbTradingSystem = new System.Windows.Forms.ComboBox();
			this.PictureBox2 = new System.Windows.Forms.PictureBox();
			this.GroupBox7 = new System.Windows.Forms.GroupBox();
			this.lblCommission = new System.Windows.Forms.Label();
			this.Label7 = new System.Windows.Forms.Label();
			this.lblCommissionType = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.lblAbbreviation = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.cmbParameter = new System.Windows.Forms.ComboBox();
			this.lblParameterComment = new System.Windows.Forms.Label();
			this.Label28 = new System.Windows.Forms.Label();
			this.Label24 = new System.Windows.Forms.Label();
			this.lblParameterDefaultValue = new System.Windows.Forms.Label();
			this.Label15 = new System.Windows.Forms.Label();
			this.lblParameterType = new System.Windows.Forms.Label();
			this.Label22 = new System.Windows.Forms.Label();
			this.GroupBox2 = new System.Windows.Forms.GroupBox();
			this.GroupBox4 = new System.Windows.Forms.GroupBox();
			this.lblEntryOrderType = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.lblEntryAllowPyramids = new System.Windows.Forms.Label();
			this.Label20 = new System.Windows.Forms.Label();
			this.lblEntryAllowEntryOnExit = new System.Windows.Forms.Label();
			this.Label30 = new System.Windows.Forms.Label();
			this.GroupBox3 = new System.Windows.Forms.GroupBox();
			this.cmbExit = new System.Windows.Forms.ComboBox();
			this.lblExitOrderType = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.Label12 = new System.Windows.Forms.Label();
			this.lblExitAllowMoreThanOnce = new System.Windows.Forms.Label();
			this.Label16 = new System.Windows.Forms.Label();
			this.lblExitAllowExitOnEntry = new System.Windows.Forms.Label();
			this.Label19 = new System.Windows.Forms.Label();
			this.cmbTrade = new System.Windows.Forms.ComboBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.lblTradeSide = new System.Windows.Forms.Label();
			this.Label5 = new System.Windows.Forms.Label();
			this.cmbDefinition = new System.Windows.Forms.ComboBox();
			this.btnReqTradingSystemDefinitions = new System.Windows.Forms.Button();
			this.tpTrades = new System.Windows.Forms.TabPage();
			this.cmbTradesNames = new System.Windows.Forms.ComboBox();
			this.Label45 = new System.Windows.Forms.Label();
			this.GroupBox11 = new System.Windows.Forms.GroupBox();
			this.groupBox15 = new System.Windows.Forms.GroupBox();
			this.cmbShownTradeItems = new System.Windows.Forms.ComboBox();
			this.lvShownTradesRelations = new System.Windows.Forms.ListView();
			this.columnHeader17 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader18 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader19 = new System.Windows.Forms.ColumnHeader();
			this.lvShownTrades = new System.Windows.Forms.ListView();
			this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.btnShowTrades = new System.Windows.Forms.Button();
			this.GroupBox13 = new System.Windows.Forms.GroupBox();
			this.Label42 = new System.Windows.Forms.Label();
			this.nudEndTrades = new System.Windows.Forms.NumericUpDown();
			this.Label43 = new System.Windows.Forms.Label();
			this.nudStartTrades = new System.Windows.Forms.NumericUpDown();
			this.GroupBox14 = new System.Windows.Forms.GroupBox();
			this.groupBox12 = new System.Windows.Forms.GroupBox();
			this.cmbTradeItems = new System.Windows.Forms.ComboBox();
			this.lvTradesRelations = new System.Windows.Forms.ListView();
			this.columnHeader12 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader16 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader8 = new System.Windows.Forms.ColumnHeader();
			this.lvTrades = new System.Windows.Forms.ListView();
			this.ColumnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader7 = new System.Windows.Forms.ColumnHeader();
			this.tpStatistics = new System.Windows.Forms.TabPage();
			this.GroupBox9 = new System.Windows.Forms.GroupBox();
			this.lvShownStatistics = new System.Windows.Forms.ListView();
			this.ColumnHeader9 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader10 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader11 = new System.Windows.Forms.ColumnHeader();
			this.btnShowStatistics = new System.Windows.Forms.Button();
			this.gbTimeIntervalStatistics = new System.Windows.Forms.GroupBox();
			this.Label31 = new System.Windows.Forms.Label();
			this.dtpEndRangeStatistics = new System.Windows.Forms.DateTimePicker();
			this.Label33 = new System.Windows.Forms.Label();
			this.dtpStartRangeStatistics = new System.Windows.Forms.DateTimePicker();
			this.gbIndexIntervalStatistics = new System.Windows.Forms.GroupBox();
			this.Label35 = new System.Windows.Forms.Label();
			this.nudEndStatistics = new System.Windows.Forms.NumericUpDown();
			this.Label37 = new System.Windows.Forms.Label();
			this.nudStartStatistics = new System.Windows.Forms.NumericUpDown();
			this.optTimeIntervalStatistics = new System.Windows.Forms.RadioButton();
			this.optIndexIntervalStatistics = new System.Windows.Forms.RadioButton();
			this.GroupBox10 = new System.Windows.Forms.GroupBox();
			this.lvStatistics = new System.Windows.Forms.ListView();
			this.ColumnHeader13 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader14 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader15 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader20 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader21 = new System.Windows.Forms.ColumnHeader();
			this.tcTradingSystem.SuspendLayout();
			this.tpTradingSystem.SuspendLayout();
			this.GroupBox6.SuspendLayout();
			this.GroupBox5.SuspendLayout();
			this.GroupBox8.SuspendLayout();
			this.GroupBox7.SuspendLayout();
			this.GroupBox1.SuspendLayout();
			this.GroupBox2.SuspendLayout();
			this.GroupBox4.SuspendLayout();
			this.GroupBox3.SuspendLayout();
			this.tpTrades.SuspendLayout();
			this.GroupBox11.SuspendLayout();
			this.groupBox15.SuspendLayout();
			this.GroupBox13.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nudEndTrades)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStartTrades)).BeginInit();
			this.GroupBox14.SuspendLayout();
			this.groupBox12.SuspendLayout();
			this.tpStatistics.SuspendLayout();
			this.GroupBox9.SuspendLayout();
			this.gbTimeIntervalStatistics.SuspendLayout();
			this.gbIndexIntervalStatistics.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nudEndStatistics)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStartStatistics)).BeginInit();
			this.GroupBox10.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblDataConnection
			// 
			this.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblDataConnection.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDataConnection.Location = new System.Drawing.Point(8, 8);
			this.lblDataConnection.Name = "lblDataConnection";
			this.lblDataConnection.Size = new System.Drawing.Size(216, 16);
			this.lblDataConnection.TabIndex = 2;
			this.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// PictureBox1
			// 
			this.PictureBox1.BackColor = System.Drawing.Color.Black;
			this.PictureBox1.Location = new System.Drawing.Point(0, 40);
			this.PictureBox1.Name = "PictureBox1";
			this.PictureBox1.Size = new System.Drawing.Size(1272, 3);
			this.PictureBox1.TabIndex = 23;
			this.PictureBox1.TabStop = false;
			// 
			// llWeb
			// 
			this.llWeb.BackColor = System.Drawing.SystemColors.Control;
			this.llWeb.LinkArea = new System.Windows.Forms.LinkArea(18, 58);
			this.llWeb.Location = new System.Drawing.Point(632, 8);
			this.llWeb.Name = "llWeb";
			this.llWeb.Size = new System.Drawing.Size(408, 16);
			this.llWeb.TabIndex = 1;
			this.llWeb.TabStop = true;
			this.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx";
			this.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.llWeb.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.llWeb_LinkClicked);
			// 
			// Label11
			// 
			this.Label11.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label11.Location = new System.Drawing.Point(280, 24);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(120, 24);
			this.Label11.TabIndex = 60;
			this.Label11.Text = "Parameters :";
			this.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label6
			// 
			this.Label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label6.Location = new System.Drawing.Point(16, 24);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(120, 24);
			this.Label6.TabIndex = 58;
			this.Label6.Text = "Definition Name :";
			this.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label27
			// 
			this.Label27.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label27.Location = new System.Drawing.Point(272, 216);
			this.Label27.Name = "Label27";
			this.Label27.Size = new System.Drawing.Size(128, 24);
			this.Label27.TabIndex = 56;
			this.Label27.Text = "Days Before Exp. :";
			this.Label27.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label29
			// 
			this.Label29.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label29.Location = new System.Drawing.Point(16, 216);
			this.Label29.Name = "Label29";
			this.Label29.Size = new System.Drawing.Size(120, 24);
			this.Label29.TabIndex = 54;
			this.Label29.Text = "Equalize Closes :";
			this.Label29.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label23
			// 
			this.Label23.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label23.Location = new System.Drawing.Point(304, 184);
			this.Label23.Name = "Label23";
			this.Label23.Size = new System.Drawing.Size(96, 24);
			this.Label23.TabIndex = 52;
			this.Label23.Text = "Continuation :";
			this.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label25
			// 
			this.Label25.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label25.Location = new System.Drawing.Point(24, 248);
			this.Label25.Name = "Label25";
			this.Label25.Size = new System.Drawing.Size(112, 24);
			this.Label25.TabIndex = 50;
			this.Label25.Text = "Sessions Filter :";
			this.Label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label17
			// 
			this.Label17.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label17.Location = new System.Drawing.Point(304, 152);
			this.Label17.Name = "Label17";
			this.Label17.Size = new System.Drawing.Size(96, 24);
			this.Label17.TabIndex = 48;
			this.Label17.Text = "Include End :";
			this.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label21
			// 
			this.Label21.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label21.Location = new System.Drawing.Point(8, 152);
			this.Label21.Name = "Label21";
			this.Label21.Size = new System.Drawing.Size(124, 24);
			this.Label21.TabIndex = 46;
			this.Label21.Text = "Updates Enabled :";
			this.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label9
			// 
			this.Label9.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label9.Location = new System.Drawing.Point(280, 120);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(120, 24);
			this.Label9.TabIndex = 44;
			this.Label9.Text = "Historical Period :";
			this.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label13
			// 
			this.Label13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label13.Location = new System.Drawing.Point(16, 120);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(120, 24);
			this.Label13.TabIndex = 42;
			this.Label13.Text = "Intraday Period :";
			this.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tcTradingSystem
			// 
			this.tcTradingSystem.Alignment = System.Windows.Forms.TabAlignment.Bottom;
			this.tcTradingSystem.Controls.Add(this.tpTradingSystem);
			this.tcTradingSystem.Controls.Add(this.tpTrades);
			this.tcTradingSystem.Controls.Add(this.tpStatistics);
			this.tcTradingSystem.Location = new System.Drawing.Point(0, 48);
			this.tcTradingSystem.Name = "tcTradingSystem";
			this.tcTradingSystem.SelectedIndex = 0;
			this.tcTradingSystem.Size = new System.Drawing.Size(1080, 784);
			this.tcTradingSystem.TabIndex = 2;
			// 
			// tpTradingSystem
			// 
			this.tpTradingSystem.Controls.Add(this.txtTradingSystemName);
			this.tpTradingSystem.Controls.Add(this.lblError);
			this.tpTradingSystem.Controls.Add(this.GroupBox6);
			this.tpTradingSystem.Controls.Add(this.GroupBox5);
			this.tpTradingSystem.Controls.Add(this.PictureBox3);
			this.tpTradingSystem.Controls.Add(this.GroupBox8);
			this.tpTradingSystem.Controls.Add(this.btnRemoveAll);
			this.tpTradingSystem.Controls.Add(this.btnRemove);
			this.tpTradingSystem.Controls.Add(this.btnRequest);
			this.tpTradingSystem.Controls.Add(this.cmbTradingSystem);
			this.tpTradingSystem.Controls.Add(this.PictureBox2);
			this.tpTradingSystem.Controls.Add(this.GroupBox7);
			this.tpTradingSystem.Location = new System.Drawing.Point(4, 4);
			this.tpTradingSystem.Name = "tpTradingSystem";
			this.tpTradingSystem.Size = new System.Drawing.Size(1072, 755);
			this.tpTradingSystem.TabIndex = 0;
			this.tpTradingSystem.Text = "TradingSystem";
			// 
			// txtTradingSystemName
			// 
			this.txtTradingSystemName.Location = new System.Drawing.Point(16, 368);
			this.txtTradingSystemName.Name = "txtTradingSystemName";
			this.txtTradingSystemName.Size = new System.Drawing.Size(448, 22);
			this.txtTradingSystemName.TabIndex = 1;
			this.txtTradingSystemName.Text = "";
			// 
			// lblError
			// 
			this.lblError.ForeColor = System.Drawing.Color.Red;
			this.lblError.Location = new System.Drawing.Point(16, 488);
			this.lblError.Name = "lblError";
			this.lblError.Size = new System.Drawing.Size(448, 152);
			this.lblError.TabIndex = 57;
			// 
			// GroupBox6
			// 
			this.GroupBox6.Controls.Add(this.lblStatus);
			this.GroupBox6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.GroupBox6.Location = new System.Drawing.Point(328, 424);
			this.GroupBox6.Name = "GroupBox6";
			this.GroupBox6.Size = new System.Drawing.Size(136, 48);
			this.GroupBox6.TabIndex = 56;
			this.GroupBox6.TabStop = false;
			this.GroupBox6.Text = "Status";
			// 
			// lblStatus
			// 
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblStatus.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblStatus.Location = new System.Drawing.Point(8, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(120, 24);
			this.lblStatus.TabIndex = 31;
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// GroupBox5
			// 
			this.GroupBox5.Controls.Add(this.txtTagValue);
			this.GroupBox5.Controls.Add(this.txtTagName);
			this.GroupBox5.Controls.Add(this.Label14);
			this.GroupBox5.Controls.Add(this.Label18);
			this.GroupBox5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox5.Location = new System.Drawing.Point(488, 688);
			this.GroupBox5.Name = "GroupBox5";
			this.GroupBox5.Size = new System.Drawing.Size(576, 59);
			this.GroupBox5.TabIndex = 7;
			this.GroupBox5.TabStop = false;
			this.GroupBox5.Text = "Tags";
			// 
			// txtTagValue
			// 
			this.txtTagValue.Location = new System.Drawing.Point(352, 24);
			this.txtTagValue.Name = "txtTagValue";
			this.txtTagValue.Size = new System.Drawing.Size(184, 25);
			this.txtTagValue.TabIndex = 1;
			this.txtTagValue.Text = "";
			this.txtTagValue.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagValue_KeyDown);
			// 
			// txtTagName
			// 
			this.txtTagName.Location = new System.Drawing.Point(72, 24);
			this.txtTagName.Name = "txtTagName";
			this.txtTagName.Size = new System.Drawing.Size(184, 25);
			this.txtTagName.TabIndex = 0;
			this.txtTagName.Text = "";
			this.txtTagName.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTagName_KeyDown);
			// 
			// Label14
			// 
			this.Label14.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label14.Location = new System.Drawing.Point(288, 24);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(56, 24);
			this.Label14.TabIndex = 40;
			this.Label14.Text = "Value :";
			this.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label18
			// 
			this.Label18.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label18.Location = new System.Drawing.Point(8, 24);
			this.Label18.Name = "Label18";
			this.Label18.Size = new System.Drawing.Size(56, 24);
			this.Label18.TabIndex = 36;
			this.Label18.Text = "Name :";
			this.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// PictureBox3
			// 
			this.PictureBox3.BackColor = System.Drawing.Color.Black;
			this.PictureBox3.Location = new System.Drawing.Point(-80, 680);
			this.PictureBox3.Name = "PictureBox3";
			this.PictureBox3.Size = new System.Drawing.Size(1272, 1);
			this.PictureBox3.TabIndex = 55;
			this.PictureBox3.TabStop = false;
			// 
			// GroupBox8
			// 
			this.GroupBox8.Controls.Add(this.lblRPRecalcPeriod);
			this.GroupBox8.Controls.Add(this.label39);
			this.GroupBox8.Controls.Add(this.lblRPSubscriptionLevel);
			this.GroupBox8.Controls.Add(this.label41);
			this.GroupBox8.Controls.Add(this.lstRPParameters);
			this.GroupBox8.Controls.Add(this.Label3);
			this.GroupBox8.Controls.Add(this.lblRPTradingSystemDefinitionName);
			this.GroupBox8.Controls.Add(this.Label26);
			this.GroupBox8.Controls.Add(this.lblRPDaysBeforeExpiration);
			this.GroupBox8.Controls.Add(this.Label32);
			this.GroupBox8.Controls.Add(this.lblRPEqualizeCloses);
			this.GroupBox8.Controls.Add(this.Label34);
			this.GroupBox8.Controls.Add(this.lblRPContinuation);
			this.GroupBox8.Controls.Add(this.Label36);
			this.GroupBox8.Controls.Add(this.lblRPSessionsFilter);
			this.GroupBox8.Controls.Add(this.Label38);
			this.GroupBox8.Controls.Add(this.lblRPIncludeEnd);
			this.GroupBox8.Controls.Add(this.Label40);
			this.GroupBox8.Controls.Add(this.lblRPHistoricalPeriod);
			this.GroupBox8.Controls.Add(this.Label44);
			this.GroupBox8.Controls.Add(this.lblRPIntradayPeriod);
			this.GroupBox8.Controls.Add(this.Label46);
			this.GroupBox8.Controls.Add(this.lblRPRangeEnd);
			this.GroupBox8.Controls.Add(this.Label47);
			this.GroupBox8.Controls.Add(this.lblRPSessionFlags);
			this.GroupBox8.Controls.Add(this.Label49);
			this.GroupBox8.Controls.Add(this.lblRPRangeStart);
			this.GroupBox8.Controls.Add(this.Label50);
			this.GroupBox8.Controls.Add(this.lblRPBaseExpression);
			this.GroupBox8.Controls.Add(this.Label52);
			this.GroupBox8.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox8.Location = new System.Drawing.Point(480, 360);
			this.GroupBox8.Name = "GroupBox8";
			this.GroupBox8.Size = new System.Drawing.Size(584, 312);
			this.GroupBox8.TabIndex = 6;
			this.GroupBox8.TabStop = false;
			this.GroupBox8.Text = "Request Parameters";
			// 
			// lblRPRecalcPeriod
			// 
			this.lblRPRecalcPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRecalcPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRecalcPeriod.Location = new System.Drawing.Point(440, 248);
			this.lblRPRecalcPeriod.Name = "lblRPRecalcPeriod";
			this.lblRPRecalcPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPRecalcPeriod.TabIndex = 80;
			this.lblRPRecalcPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label39
			// 
			this.label39.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label39.Location = new System.Drawing.Point(328, 248);
			this.label39.Name = "label39";
			this.label39.Size = new System.Drawing.Size(104, 24);
			this.label39.TabIndex = 79;
			this.label39.Text = "Recalc Period :";
			this.label39.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSubscriptionLevel
			// 
			this.lblRPSubscriptionLevel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSubscriptionLevel.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSubscriptionLevel.Location = new System.Drawing.Point(152, 248);
			this.lblRPSubscriptionLevel.Name = "lblRPSubscriptionLevel";
			this.lblRPSubscriptionLevel.Size = new System.Drawing.Size(152, 24);
			this.lblRPSubscriptionLevel.TabIndex = 78;
			this.lblRPSubscriptionLevel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label41
			// 
			this.label41.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label41.Location = new System.Drawing.Point(8, 248);
			this.label41.Name = "label41";
			this.label41.Size = new System.Drawing.Size(136, 24);
			this.label41.TabIndex = 77;
			this.label41.Text = "Subscription Level :";
			this.label41.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lstRPParameters
			// 
			this.lstRPParameters.BackColor = System.Drawing.SystemColors.Control;
			this.lstRPParameters.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lstRPParameters.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lstRPParameters.ItemHeight = 15;
			this.lstRPParameters.Location = new System.Drawing.Point(440, 56);
			this.lstRPParameters.Name = "lstRPParameters";
			this.lstRPParameters.Size = new System.Drawing.Size(136, 62);
			this.lstRPParameters.TabIndex = 0;
			// 
			// Label3
			// 
			this.Label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label3.Location = new System.Drawing.Point(344, 56);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(88, 24);
			this.Label3.TabIndex = 60;
			this.Label3.Text = "Parameters :";
			this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPTradingSystemDefinitionName
			// 
			this.lblRPTradingSystemDefinitionName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPTradingSystemDefinitionName.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPTradingSystemDefinitionName.Location = new System.Drawing.Point(152, 24);
			this.lblRPTradingSystemDefinitionName.Name = "lblRPTradingSystemDefinitionName";
			this.lblRPTradingSystemDefinitionName.Size = new System.Drawing.Size(424, 24);
			this.lblRPTradingSystemDefinitionName.TabIndex = 59;
			this.lblRPTradingSystemDefinitionName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label26
			// 
			this.Label26.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label26.Location = new System.Drawing.Point(24, 24);
			this.Label26.Name = "Label26";
			this.Label26.Size = new System.Drawing.Size(120, 24);
			this.Label26.TabIndex = 58;
			this.Label26.Text = "Definition Name :";
			this.Label26.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPDaysBeforeExpiration
			// 
			this.lblRPDaysBeforeExpiration.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPDaysBeforeExpiration.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPDaysBeforeExpiration.Location = new System.Drawing.Point(440, 216);
			this.lblRPDaysBeforeExpiration.Name = "lblRPDaysBeforeExpiration";
			this.lblRPDaysBeforeExpiration.Size = new System.Drawing.Size(136, 24);
			this.lblRPDaysBeforeExpiration.TabIndex = 57;
			this.lblRPDaysBeforeExpiration.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label32
			// 
			this.Label32.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label32.Location = new System.Drawing.Point(304, 216);
			this.Label32.Name = "Label32";
			this.Label32.Size = new System.Drawing.Size(128, 24);
			this.Label32.TabIndex = 56;
			this.Label32.Text = "Days Before Exp. :";
			this.Label32.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPEqualizeCloses
			// 
			this.lblRPEqualizeCloses.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPEqualizeCloses.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPEqualizeCloses.Location = new System.Drawing.Point(152, 216);
			this.lblRPEqualizeCloses.Name = "lblRPEqualizeCloses";
			this.lblRPEqualizeCloses.Size = new System.Drawing.Size(152, 24);
			this.lblRPEqualizeCloses.TabIndex = 55;
			this.lblRPEqualizeCloses.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label34
			// 
			this.Label34.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label34.Location = new System.Drawing.Point(24, 216);
			this.Label34.Name = "Label34";
			this.Label34.Size = new System.Drawing.Size(120, 24);
			this.Label34.TabIndex = 54;
			this.Label34.Text = "Equalize Closes :";
			this.Label34.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPContinuation
			// 
			this.lblRPContinuation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPContinuation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPContinuation.Location = new System.Drawing.Point(440, 184);
			this.lblRPContinuation.Name = "lblRPContinuation";
			this.lblRPContinuation.Size = new System.Drawing.Size(136, 24);
			this.lblRPContinuation.TabIndex = 53;
			this.lblRPContinuation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label36
			// 
			this.Label36.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label36.Location = new System.Drawing.Point(336, 184);
			this.Label36.Name = "Label36";
			this.Label36.Size = new System.Drawing.Size(96, 24);
			this.Label36.TabIndex = 52;
			this.Label36.Text = "Continuation :";
			this.Label36.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionsFilter
			// 
			this.lblRPSessionsFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionsFilter.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionsFilter.Location = new System.Drawing.Point(152, 280);
			this.lblRPSessionsFilter.Name = "lblRPSessionsFilter";
			this.lblRPSessionsFilter.Size = new System.Drawing.Size(424, 24);
			this.lblRPSessionsFilter.TabIndex = 51;
			this.lblRPSessionsFilter.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label38
			// 
			this.Label38.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label38.Location = new System.Drawing.Point(32, 280);
			this.Label38.Name = "Label38";
			this.Label38.Size = new System.Drawing.Size(112, 24);
			this.Label38.TabIndex = 50;
			this.Label38.Text = "Sessions Filter :";
			this.Label38.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIncludeEnd
			// 
			this.lblRPIncludeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIncludeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIncludeEnd.Location = new System.Drawing.Point(440, 120);
			this.lblRPIncludeEnd.Name = "lblRPIncludeEnd";
			this.lblRPIncludeEnd.Size = new System.Drawing.Size(136, 24);
			this.lblRPIncludeEnd.TabIndex = 49;
			this.lblRPIncludeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label40
			// 
			this.Label40.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label40.Location = new System.Drawing.Point(336, 120);
			this.Label40.Name = "Label40";
			this.Label40.Size = new System.Drawing.Size(96, 24);
			this.Label40.TabIndex = 48;
			this.Label40.Text = "Include End :";
			this.Label40.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPHistoricalPeriod
			// 
			this.lblRPHistoricalPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPHistoricalPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPHistoricalPeriod.Location = new System.Drawing.Point(440, 152);
			this.lblRPHistoricalPeriod.Name = "lblRPHistoricalPeriod";
			this.lblRPHistoricalPeriod.Size = new System.Drawing.Size(136, 24);
			this.lblRPHistoricalPeriod.TabIndex = 45;
			this.lblRPHistoricalPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label44
			// 
			this.Label44.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label44.Location = new System.Drawing.Point(312, 152);
			this.Label44.Name = "Label44";
			this.Label44.Size = new System.Drawing.Size(120, 24);
			this.Label44.TabIndex = 44;
			this.Label44.Text = "Historical Period :";
			this.Label44.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPIntradayPeriod
			// 
			this.lblRPIntradayPeriod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPIntradayPeriod.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPIntradayPeriod.Location = new System.Drawing.Point(152, 152);
			this.lblRPIntradayPeriod.Name = "lblRPIntradayPeriod";
			this.lblRPIntradayPeriod.Size = new System.Drawing.Size(152, 24);
			this.lblRPIntradayPeriod.TabIndex = 43;
			this.lblRPIntradayPeriod.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label46
			// 
			this.Label46.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label46.Location = new System.Drawing.Point(24, 152);
			this.Label46.Name = "Label46";
			this.Label46.Size = new System.Drawing.Size(120, 24);
			this.Label46.TabIndex = 42;
			this.Label46.Text = "Intraday Period :";
			this.Label46.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeEnd
			// 
			this.lblRPRangeEnd.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeEnd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeEnd.Location = new System.Drawing.Point(152, 120);
			this.lblRPRangeEnd.Name = "lblRPRangeEnd";
			this.lblRPRangeEnd.Size = new System.Drawing.Size(152, 24);
			this.lblRPRangeEnd.TabIndex = 41;
			this.lblRPRangeEnd.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label47
			// 
			this.Label47.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label47.Location = new System.Drawing.Point(56, 120);
			this.Label47.Name = "Label47";
			this.Label47.Size = new System.Drawing.Size(88, 24);
			this.Label47.TabIndex = 40;
			this.Label47.Text = "Range End :";
			this.Label47.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPSessionFlags
			// 
			this.lblRPSessionFlags.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPSessionFlags.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPSessionFlags.Location = new System.Drawing.Point(152, 184);
			this.lblRPSessionFlags.Name = "lblRPSessionFlags";
			this.lblRPSessionFlags.Size = new System.Drawing.Size(152, 24);
			this.lblRPSessionFlags.TabIndex = 39;
			this.lblRPSessionFlags.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label49
			// 
			this.Label49.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label49.Location = new System.Drawing.Point(32, 184);
			this.Label49.Name = "Label49";
			this.Label49.Size = new System.Drawing.Size(112, 24);
			this.Label49.TabIndex = 38;
			this.Label49.Text = "Session Flags :";
			this.Label49.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPRangeStart
			// 
			this.lblRPRangeStart.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPRangeStart.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPRangeStart.Location = new System.Drawing.Point(152, 88);
			this.lblRPRangeStart.Name = "lblRPRangeStart";
			this.lblRPRangeStart.Size = new System.Drawing.Size(152, 24);
			this.lblRPRangeStart.TabIndex = 37;
			this.lblRPRangeStart.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label50
			// 
			this.Label50.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label50.Location = new System.Drawing.Point(24, 88);
			this.Label50.Name = "Label50";
			this.Label50.Size = new System.Drawing.Size(120, 24);
			this.Label50.TabIndex = 36;
			this.Label50.Text = "Range Start :";
			this.Label50.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblRPBaseExpression
			// 
			this.lblRPBaseExpression.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblRPBaseExpression.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblRPBaseExpression.Location = new System.Drawing.Point(152, 56);
			this.lblRPBaseExpression.Name = "lblRPBaseExpression";
			this.lblRPBaseExpression.Size = new System.Drawing.Size(152, 24);
			this.lblRPBaseExpression.TabIndex = 33;
			this.lblRPBaseExpression.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label52
			// 
			this.Label52.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label52.Location = new System.Drawing.Point(16, 56);
			this.Label52.Name = "Label52";
			this.Label52.Size = new System.Drawing.Size(128, 24);
			this.Label52.TabIndex = 32;
			this.Label52.Text = "Base Expression :";
			this.Label52.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// btnRemoveAll
			// 
			this.btnRemoveAll.Enabled = false;
			this.btnRemoveAll.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemoveAll.Location = new System.Drawing.Point(224, 432);
			this.btnRemoveAll.Name = "btnRemoveAll";
			this.btnRemoveAll.Size = new System.Drawing.Size(96, 40);
			this.btnRemoveAll.TabIndex = 5;
			this.btnRemoveAll.Text = "Remove All";
			this.btnRemoveAll.Click += new System.EventHandler(this.btnRemoveAll_Click);
			// 
			// btnRemove
			// 
			this.btnRemove.Enabled = false;
			this.btnRemove.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRemove.Location = new System.Drawing.Point(120, 432);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.Size = new System.Drawing.Size(96, 40);
			this.btnRemove.TabIndex = 4;
			this.btnRemove.Text = "Remove";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnRequest
			// 
			this.btnRequest.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnRequest.Location = new System.Drawing.Point(16, 432);
			this.btnRequest.Name = "btnRequest";
			this.btnRequest.Size = new System.Drawing.Size(96, 40);
			this.btnRequest.TabIndex = 3;
			this.btnRequest.Text = "Request";
			this.btnRequest.Click += new System.EventHandler(this.btnRequest_Click);
			// 
			// cmbTradingSystem
			// 
			this.cmbTradingSystem.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbTradingSystem.Location = new System.Drawing.Point(16, 400);
			this.cmbTradingSystem.Name = "cmbTradingSystem";
			this.cmbTradingSystem.Size = new System.Drawing.Size(448, 24);
			this.cmbTradingSystem.TabIndex = 2;
			this.cmbTradingSystem.SelectedIndexChanged += new System.EventHandler(this.cmbTradingSystem_SelectedIndexChanged);
			// 
			// PictureBox2
			// 
			this.PictureBox2.BackColor = System.Drawing.Color.Black;
			this.PictureBox2.Location = new System.Drawing.Point(8, 352);
			this.PictureBox2.Name = "PictureBox2";
			this.PictureBox2.Size = new System.Drawing.Size(1056, 3);
			this.PictureBox2.TabIndex = 24;
			this.PictureBox2.TabStop = false;
			// 
			// GroupBox7
			// 
			this.GroupBox7.Controls.Add(this.lblCommission);
			this.GroupBox7.Controls.Add(this.Label7);
			this.GroupBox7.Controls.Add(this.lblCommissionType);
			this.GroupBox7.Controls.Add(this.Label4);
			this.GroupBox7.Controls.Add(this.lblAbbreviation);
			this.GroupBox7.Controls.Add(this.Label2);
			this.GroupBox7.Controls.Add(this.GroupBox1);
			this.GroupBox7.Controls.Add(this.GroupBox2);
			this.GroupBox7.Controls.Add(this.cmbDefinition);
			this.GroupBox7.Controls.Add(this.btnReqTradingSystemDefinitions);
			this.GroupBox7.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox7.Location = new System.Drawing.Point(8, 8);
			this.GroupBox7.Name = "GroupBox7";
			this.GroupBox7.Size = new System.Drawing.Size(1056, 336);
			this.GroupBox7.TabIndex = 0;
			this.GroupBox7.TabStop = false;
			this.GroupBox7.Text = "Trading System Definitions";
			// 
			// lblCommission
			// 
			this.lblCommission.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblCommission.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblCommission.Location = new System.Drawing.Point(616, 88);
			this.lblCommission.Name = "lblCommission";
			this.lblCommission.Size = new System.Drawing.Size(280, 24);
			this.lblCommission.TabIndex = 55;
			this.lblCommission.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label7
			// 
			this.Label7.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label7.Location = new System.Drawing.Point(496, 88);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(112, 24);
			this.Label7.TabIndex = 54;
			this.Label7.Text = "Commission :";
			this.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblCommissionType
			// 
			this.lblCommissionType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblCommissionType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblCommissionType.Location = new System.Drawing.Point(616, 56);
			this.lblCommissionType.Name = "lblCommissionType";
			this.lblCommissionType.Size = new System.Drawing.Size(280, 24);
			this.lblCommissionType.TabIndex = 53;
			this.lblCommissionType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label4
			// 
			this.Label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label4.Location = new System.Drawing.Point(480, 56);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(128, 24);
			this.Label4.TabIndex = 52;
			this.Label4.Text = "Commission Type :";
			this.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblAbbreviation
			// 
			this.lblAbbreviation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblAbbreviation.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblAbbreviation.Location = new System.Drawing.Point(616, 24);
			this.lblAbbreviation.Name = "lblAbbreviation";
			this.lblAbbreviation.Size = new System.Drawing.Size(280, 24);
			this.lblAbbreviation.TabIndex = 51;
			this.lblAbbreviation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label2
			// 
			this.Label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label2.Location = new System.Drawing.Point(496, 24);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(112, 24);
			this.Label2.TabIndex = 50;
			this.Label2.Text = "Abbreviation :";
			this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.cmbParameter);
			this.GroupBox1.Controls.Add(this.lblParameterComment);
			this.GroupBox1.Controls.Add(this.Label28);
			this.GroupBox1.Controls.Add(this.Label24);
			this.GroupBox1.Controls.Add(this.lblParameterDefaultValue);
			this.GroupBox1.Controls.Add(this.Label15);
			this.GroupBox1.Controls.Add(this.lblParameterType);
			this.GroupBox1.Controls.Add(this.Label22);
			this.GroupBox1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox1.Location = new System.Drawing.Point(648, 120);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(400, 208);
			this.GroupBox1.TabIndex = 3;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Parameters";
			// 
			// cmbParameter
			// 
			this.cmbParameter.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbParameter.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbParameter.Location = new System.Drawing.Point(136, 16);
			this.cmbParameter.Name = "cmbParameter";
			this.cmbParameter.Size = new System.Drawing.Size(240, 25);
			this.cmbParameter.TabIndex = 0;
			this.cmbParameter.SelectedIndexChanged += new System.EventHandler(this.cmbParameter_SelectedIndexChanged);
			// 
			// lblParameterComment
			// 
			this.lblParameterComment.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblParameterComment.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblParameterComment.Location = new System.Drawing.Point(136, 48);
			this.lblParameterComment.Name = "lblParameterComment";
			this.lblParameterComment.Size = new System.Drawing.Size(240, 88);
			this.lblParameterComment.TabIndex = 54;
			// 
			// Label28
			// 
			this.Label28.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label28.Location = new System.Drawing.Point(40, 48);
			this.Label28.Name = "Label28";
			this.Label28.Size = new System.Drawing.Size(88, 24);
			this.Label28.TabIndex = 53;
			this.Label28.Text = "Comment :";
			this.Label28.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label24
			// 
			this.Label24.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label24.Location = new System.Drawing.Point(48, 16);
			this.Label24.Name = "Label24";
			this.Label24.Size = new System.Drawing.Size(80, 24);
			this.Label24.TabIndex = 52;
			this.Label24.Text = "Parameter :";
			this.Label24.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblParameterDefaultValue
			// 
			this.lblParameterDefaultValue.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblParameterDefaultValue.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblParameterDefaultValue.Location = new System.Drawing.Point(136, 176);
			this.lblParameterDefaultValue.Name = "lblParameterDefaultValue";
			this.lblParameterDefaultValue.Size = new System.Drawing.Size(240, 24);
			this.lblParameterDefaultValue.TabIndex = 51;
			this.lblParameterDefaultValue.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label15
			// 
			this.Label15.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label15.Location = new System.Drawing.Point(16, 176);
			this.Label15.Name = "Label15";
			this.Label15.Size = new System.Drawing.Size(112, 24);
			this.Label15.TabIndex = 50;
			this.Label15.Text = "Default Value :";
			this.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblParameterType
			// 
			this.lblParameterType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblParameterType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblParameterType.Location = new System.Drawing.Point(136, 144);
			this.lblParameterType.Name = "lblParameterType";
			this.lblParameterType.Size = new System.Drawing.Size(240, 24);
			this.lblParameterType.TabIndex = 49;
			this.lblParameterType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label22
			// 
			this.Label22.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label22.Location = new System.Drawing.Point(56, 144);
			this.Label22.Name = "Label22";
			this.Label22.Size = new System.Drawing.Size(72, 24);
			this.Label22.TabIndex = 48;
			this.Label22.Text = "Type :";
			this.Label22.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox2
			// 
			this.GroupBox2.Controls.Add(this.GroupBox4);
			this.GroupBox2.Controls.Add(this.GroupBox3);
			this.GroupBox2.Controls.Add(this.cmbTrade);
			this.GroupBox2.Controls.Add(this.Label1);
			this.GroupBox2.Controls.Add(this.lblTradeSide);
			this.GroupBox2.Controls.Add(this.Label5);
			this.GroupBox2.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox2.Location = new System.Drawing.Point(8, 120);
			this.GroupBox2.Name = "GroupBox2";
			this.GroupBox2.Size = new System.Drawing.Size(632, 208);
			this.GroupBox2.TabIndex = 2;
			this.GroupBox2.TabStop = false;
			this.GroupBox2.Text = "Trades";
			// 
			// GroupBox4
			// 
			this.GroupBox4.Controls.Add(this.lblEntryOrderType);
			this.GroupBox4.Controls.Add(this.Label8);
			this.GroupBox4.Controls.Add(this.lblEntryAllowPyramids);
			this.GroupBox4.Controls.Add(this.Label20);
			this.GroupBox4.Controls.Add(this.lblEntryAllowEntryOnExit);
			this.GroupBox4.Controls.Add(this.Label30);
			this.GroupBox4.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox4.Location = new System.Drawing.Point(8, 56);
			this.GroupBox4.Name = "GroupBox4";
			this.GroupBox4.Size = new System.Drawing.Size(296, 144);
			this.GroupBox4.TabIndex = 58;
			this.GroupBox4.TabStop = false;
			this.GroupBox4.Text = "Entry";
			// 
			// lblEntryOrderType
			// 
			this.lblEntryOrderType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblEntryOrderType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblEntryOrderType.Location = new System.Drawing.Point(160, 32);
			this.lblEntryOrderType.Name = "lblEntryOrderType";
			this.lblEntryOrderType.Size = new System.Drawing.Size(128, 24);
			this.lblEntryOrderType.TabIndex = 54;
			this.lblEntryOrderType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label8
			// 
			this.Label8.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label8.Location = new System.Drawing.Point(64, 32);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(88, 24);
			this.Label8.TabIndex = 53;
			this.Label8.Text = "Order Type :";
			this.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblEntryAllowPyramids
			// 
			this.lblEntryAllowPyramids.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblEntryAllowPyramids.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblEntryAllowPyramids.Location = new System.Drawing.Point(160, 96);
			this.lblEntryAllowPyramids.Name = "lblEntryAllowPyramids";
			this.lblEntryAllowPyramids.Size = new System.Drawing.Size(128, 24);
			this.lblEntryAllowPyramids.TabIndex = 51;
			this.lblEntryAllowPyramids.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label20
			// 
			this.Label20.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label20.Location = new System.Drawing.Point(32, 96);
			this.Label20.Name = "Label20";
			this.Label20.Size = new System.Drawing.Size(120, 24);
			this.Label20.TabIndex = 50;
			this.Label20.Text = "Allow Pyramids :";
			this.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblEntryAllowEntryOnExit
			// 
			this.lblEntryAllowEntryOnExit.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblEntryAllowEntryOnExit.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblEntryAllowEntryOnExit.Location = new System.Drawing.Point(160, 64);
			this.lblEntryAllowEntryOnExit.Name = "lblEntryAllowEntryOnExit";
			this.lblEntryAllowEntryOnExit.Size = new System.Drawing.Size(128, 24);
			this.lblEntryAllowEntryOnExit.TabIndex = 49;
			this.lblEntryAllowEntryOnExit.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label30
			// 
			this.Label30.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label30.Location = new System.Drawing.Point(8, 64);
			this.Label30.Name = "Label30";
			this.Label30.Size = new System.Drawing.Size(144, 24);
			this.Label30.TabIndex = 48;
			this.Label30.Text = "Allow Entry On Exit :";
			this.Label30.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox3
			// 
			this.GroupBox3.Controls.Add(this.cmbExit);
			this.GroupBox3.Controls.Add(this.lblExitOrderType);
			this.GroupBox3.Controls.Add(this.Label10);
			this.GroupBox3.Controls.Add(this.Label12);
			this.GroupBox3.Controls.Add(this.lblExitAllowMoreThanOnce);
			this.GroupBox3.Controls.Add(this.Label16);
			this.GroupBox3.Controls.Add(this.lblExitAllowExitOnEntry);
			this.GroupBox3.Controls.Add(this.Label19);
			this.GroupBox3.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox3.Location = new System.Drawing.Point(312, 56);
			this.GroupBox3.Name = "GroupBox3";
			this.GroupBox3.Size = new System.Drawing.Size(312, 144);
			this.GroupBox3.TabIndex = 1;
			this.GroupBox3.TabStop = false;
			this.GroupBox3.Text = "Exits";
			// 
			// cmbExit
			// 
			this.cmbExit.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbExit.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbExit.Location = new System.Drawing.Point(176, 16);
			this.cmbExit.Name = "cmbExit";
			this.cmbExit.Size = new System.Drawing.Size(128, 25);
			this.cmbExit.TabIndex = 0;
			this.cmbExit.SelectedIndexChanged += new System.EventHandler(this.cmbExit_SelectedIndexChanged);
			// 
			// lblExitOrderType
			// 
			this.lblExitOrderType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblExitOrderType.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblExitOrderType.Location = new System.Drawing.Point(176, 48);
			this.lblExitOrderType.Name = "lblExitOrderType";
			this.lblExitOrderType.Size = new System.Drawing.Size(128, 24);
			this.lblExitOrderType.TabIndex = 54;
			this.lblExitOrderType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label10
			// 
			this.Label10.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label10.Location = new System.Drawing.Point(80, 48);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(88, 24);
			this.Label10.TabIndex = 53;
			this.Label10.Text = "Order Type :";
			this.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Label12
			// 
			this.Label12.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label12.Location = new System.Drawing.Point(88, 16);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(80, 24);
			this.Label12.TabIndex = 52;
			this.Label12.Text = "Exit :";
			this.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblExitAllowMoreThanOnce
			// 
			this.lblExitAllowMoreThanOnce.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblExitAllowMoreThanOnce.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblExitAllowMoreThanOnce.Location = new System.Drawing.Point(176, 112);
			this.lblExitAllowMoreThanOnce.Name = "lblExitAllowMoreThanOnce";
			this.lblExitAllowMoreThanOnce.Size = new System.Drawing.Size(128, 24);
			this.lblExitAllowMoreThanOnce.TabIndex = 51;
			this.lblExitAllowMoreThanOnce.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label16
			// 
			this.Label16.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label16.Location = new System.Drawing.Point(8, 112);
			this.Label16.Name = "Label16";
			this.Label16.Size = new System.Drawing.Size(160, 24);
			this.Label16.TabIndex = 50;
			this.Label16.Text = "Allow More Than Once :";
			this.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblExitAllowExitOnEntry
			// 
			this.lblExitAllowExitOnEntry.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblExitAllowExitOnEntry.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblExitAllowExitOnEntry.Location = new System.Drawing.Point(176, 80);
			this.lblExitAllowExitOnEntry.Name = "lblExitAllowExitOnEntry";
			this.lblExitAllowExitOnEntry.Size = new System.Drawing.Size(128, 24);
			this.lblExitAllowExitOnEntry.TabIndex = 49;
			this.lblExitAllowExitOnEntry.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label19
			// 
			this.Label19.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label19.Location = new System.Drawing.Point(24, 80);
			this.Label19.Name = "Label19";
			this.Label19.Size = new System.Drawing.Size(144, 24);
			this.Label19.TabIndex = 48;
			this.Label19.Text = "Allow Exit On Entry :";
			this.Label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmbTrade
			// 
			this.cmbTrade.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbTrade.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbTrade.Location = new System.Drawing.Point(72, 24);
			this.cmbTrade.Name = "cmbTrade";
			this.cmbTrade.Size = new System.Drawing.Size(280, 25);
			this.cmbTrade.TabIndex = 0;
			this.cmbTrade.SelectedIndexChanged += new System.EventHandler(this.cmbTrade_SelectedIndexChanged);
			// 
			// Label1
			// 
			this.Label1.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label1.Location = new System.Drawing.Point(8, 24);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(56, 24);
			this.Label1.TabIndex = 56;
			this.Label1.Text = "Trade :";
			this.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblTradeSide
			// 
			this.lblTradeSide.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblTradeSide.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblTradeSide.Location = new System.Drawing.Point(440, 24);
			this.lblTradeSide.Name = "lblTradeSide";
			this.lblTradeSide.Size = new System.Drawing.Size(120, 24);
			this.lblTradeSide.TabIndex = 55;
			this.lblTradeSide.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label5
			// 
			this.Label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label5.Location = new System.Drawing.Point(384, 24);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(48, 24);
			this.Label5.TabIndex = 54;
			this.Label5.Text = "Side :";
			this.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmbDefinition
			// 
			this.cmbDefinition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbDefinition.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbDefinition.Location = new System.Drawing.Point(112, 24);
			this.cmbDefinition.Name = "cmbDefinition";
			this.cmbDefinition.Size = new System.Drawing.Size(352, 25);
			this.cmbDefinition.TabIndex = 1;
			this.cmbDefinition.SelectedIndexChanged += new System.EventHandler(this.cmbDefinition_SelectedIndexChanged);
			// 
			// btnReqTradingSystemDefinitions
			// 
			this.btnReqTradingSystemDefinitions.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnReqTradingSystemDefinitions.Location = new System.Drawing.Point(8, 24);
			this.btnReqTradingSystemDefinitions.Name = "btnReqTradingSystemDefinitions";
			this.btnReqTradingSystemDefinitions.Size = new System.Drawing.Size(96, 26);
			this.btnReqTradingSystemDefinitions.TabIndex = 0;
			this.btnReqTradingSystemDefinitions.Text = "Request";
			this.btnReqTradingSystemDefinitions.Click += new System.EventHandler(this.btnReqTradingSystemDefinitions_Click);
			// 
			// tpTrades
			// 
			this.tpTrades.Controls.Add(this.cmbTradesNames);
			this.tpTrades.Controls.Add(this.Label45);
			this.tpTrades.Controls.Add(this.GroupBox11);
			this.tpTrades.Controls.Add(this.GroupBox14);
			this.tpTrades.Location = new System.Drawing.Point(4, 4);
			this.tpTrades.Name = "tpTrades";
			this.tpTrades.Size = new System.Drawing.Size(1072, 755);
			this.tpTrades.TabIndex = 1;
			this.tpTrades.Text = "Trades";
			// 
			// cmbTradesNames
			// 
			this.cmbTradesNames.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbTradesNames.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cmbTradesNames.Location = new System.Drawing.Point(96, 8);
			this.cmbTradesNames.Name = "cmbTradesNames";
			this.cmbTradesNames.Size = new System.Drawing.Size(280, 25);
			this.cmbTradesNames.TabIndex = 0;
			this.cmbTradesNames.SelectedIndexChanged += new System.EventHandler(this.cmbTradesNames_SelectedIndexChanged);
			// 
			// Label45
			// 
			this.Label45.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label45.Location = new System.Drawing.Point(24, 8);
			this.Label45.Name = "Label45";
			this.Label45.Size = new System.Drawing.Size(64, 24);
			this.Label45.TabIndex = 60;
			this.Label45.Text = "Trades :";
			this.Label45.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// GroupBox11
			// 
			this.GroupBox11.Controls.Add(this.groupBox15);
			this.GroupBox11.Controls.Add(this.lvShownTrades);
			this.GroupBox11.Controls.Add(this.btnShowTrades);
			this.GroupBox11.Controls.Add(this.GroupBox13);
			this.GroupBox11.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox11.Location = new System.Drawing.Point(8, 344);
			this.GroupBox11.Name = "GroupBox11";
			this.GroupBox11.Size = new System.Drawing.Size(1056, 375);
			this.GroupBox11.TabIndex = 2;
			this.GroupBox11.TabStop = false;
			this.GroupBox11.Text = "Trades Filtered by Index";
			// 
			// groupBox15
			// 
			this.groupBox15.Controls.Add(this.cmbShownTradeItems);
			this.groupBox15.Controls.Add(this.lvShownTradesRelations);
			this.groupBox15.Location = new System.Drawing.Point(672, 72);
			this.groupBox15.Name = "groupBox15";
			this.groupBox15.Size = new System.Drawing.Size(376, 296);
			this.groupBox15.TabIndex = 4;
			this.groupBox15.TabStop = false;
			this.groupBox15.Text = "Relations";
			// 
			// cmbShownTradeItems
			// 
			this.cmbShownTradeItems.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbShownTradeItems.Location = new System.Drawing.Point(8, 24);
			this.cmbShownTradeItems.Name = "cmbShownTradeItems";
			this.cmbShownTradeItems.Size = new System.Drawing.Size(200, 26);
			this.cmbShownTradeItems.TabIndex = 1;
			this.cmbShownTradeItems.SelectedIndexChanged += new System.EventHandler(this.cmbShownTradeItems_SelectedIndexChanged);
			// 
			// lvShownTradesRelations
			// 
			this.lvShownTradesRelations.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                                 this.columnHeader17,
                                                                                                 this.columnHeader18,
                                                                                                 this.columnHeader21,
                                                                                                 this.columnHeader19});
			this.lvShownTradesRelations.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvShownTradesRelations.FullRowSelect = true;
			this.lvShownTradesRelations.GridLines = true;
			this.lvShownTradesRelations.Location = new System.Drawing.Point(8, 64);
			this.lvShownTradesRelations.MultiSelect = false;
			this.lvShownTradesRelations.Name = "lvShownTradesRelations";
			this.lvShownTradesRelations.Size = new System.Drawing.Size(360, 224);
			this.lvShownTradesRelations.TabIndex = 2;
			this.lvShownTradesRelations.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader17
			// 
			this.columnHeader17.Width = 0;
			// 
			// columnHeader18
			// 
			this.columnHeader18.Text = "Timestamp";
			this.columnHeader18.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader18.Width = 162;
			// 
			// columnHeader19
			// 
			this.columnHeader19.Text = "Name";
			this.columnHeader19.Width = 181;
			// 
			// lvShownTrades
			// 
			this.lvShownTrades.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                        this.ColumnHeader1,
                                                                                        this.ColumnHeader2,
                                                                                        this.ColumnHeader3});
			this.lvShownTrades.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvShownTrades.FullRowSelect = true;
			this.lvShownTrades.GridLines = true;
			this.lvShownTrades.Location = new System.Drawing.Point(8, 80);
			this.lvShownTrades.MultiSelect = false;
			this.lvShownTrades.Name = "lvShownTrades";
			this.lvShownTrades.Size = new System.Drawing.Size(656, 288);
			this.lvShownTrades.TabIndex = 2;
			this.lvShownTrades.View = System.Windows.Forms.View.Details;
			this.lvShownTrades.SelectedIndexChanged += new System.EventHandler(this.lvShownTrades_SelectedIndexChanged);
			// 
			// ColumnHeader1
			// 
			this.ColumnHeader1.Text = "";
			this.ColumnHeader1.Width = 0;
			// 
			// ColumnHeader2
			// 
			this.ColumnHeader2.Text = "Index";
			this.ColumnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader2.Width = 49;
			// 
			// ColumnHeader3
			// 
			this.ColumnHeader3.Text = "Timestamp";
			this.ColumnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader3.Width = 162;
			// 
			// btnShowTrades
			// 
			this.btnShowTrades.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnShowTrades.Location = new System.Drawing.Point(424, 48);
			this.btnShowTrades.Name = "btnShowTrades";
			this.btnShowTrades.Size = new System.Drawing.Size(96, 24);
			this.btnShowTrades.TabIndex = 1;
			this.btnShowTrades.Text = "Show";
			this.btnShowTrades.Click += new System.EventHandler(this.btnShowTrades_Click);
			// 
			// GroupBox13
			// 
			this.GroupBox13.Controls.Add(this.Label42);
			this.GroupBox13.Controls.Add(this.nudEndTrades);
			this.GroupBox13.Controls.Add(this.Label43);
			this.GroupBox13.Controls.Add(this.nudStartTrades);
			this.GroupBox13.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox13.Location = new System.Drawing.Point(16, 16);
			this.GroupBox13.Name = "GroupBox13";
			this.GroupBox13.Size = new System.Drawing.Size(400, 56);
			this.GroupBox13.TabIndex = 0;
			this.GroupBox13.TabStop = false;
			this.GroupBox13.Text = "Index Interval";
			// 
			// Label42
			// 
			this.Label42.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label42.Location = new System.Drawing.Point(200, 24);
			this.Label42.Name = "Label42";
			this.Label42.Size = new System.Drawing.Size(48, 24);
			this.Label42.TabIndex = 74;
			this.Label42.Text = "End: ";
			this.Label42.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudEndTrades
			// 
			this.nudEndTrades.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudEndTrades.Location = new System.Drawing.Point(256, 24);
			this.nudEndTrades.Maximum = new System.Decimal(new int[] {
                                                                     10000000,
                                                                     0,
                                                                     0,
                                                                     0});
			this.nudEndTrades.Minimum = new System.Decimal(new int[] {
                                                                     1,
                                                                     0,
                                                                     0,
                                                                     0});
			this.nudEndTrades.Name = "nudEndTrades";
			this.nudEndTrades.Size = new System.Drawing.Size(128, 22);
			this.nudEndTrades.TabIndex = 1;
			this.nudEndTrades.Value = new System.Decimal(new int[] {
                                                                   1,
                                                                   0,
                                                                   0,
                                                                   0});
			// 
			// Label43
			// 
			this.Label43.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label43.Location = new System.Drawing.Point(8, 24);
			this.Label43.Name = "Label43";
			this.Label43.Size = new System.Drawing.Size(48, 24);
			this.Label43.TabIndex = 70;
			this.Label43.Text = "Start: ";
			this.Label43.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudStartTrades
			// 
			this.nudStartTrades.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudStartTrades.Location = new System.Drawing.Point(64, 24);
			this.nudStartTrades.Maximum = new System.Decimal(new int[] {
                                                                       10000000,
                                                                       0,
                                                                       0,
                                                                       0});
			this.nudStartTrades.Minimum = new System.Decimal(new int[] {
                                                                       1,
                                                                       0,
                                                                       0,
                                                                       0});
			this.nudStartTrades.Name = "nudStartTrades";
			this.nudStartTrades.Size = new System.Drawing.Size(128, 22);
			this.nudStartTrades.TabIndex = 0;
			this.nudStartTrades.Value = new System.Decimal(new int[] {
                                                                     1,
                                                                     0,
                                                                     0,
                                                                     0});
			// 
			// GroupBox14
			// 
			this.GroupBox14.Controls.Add(this.groupBox12);
			this.GroupBox14.Controls.Add(this.lvTrades);
			this.GroupBox14.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox14.Location = new System.Drawing.Point(8, 40);
			this.GroupBox14.Name = "GroupBox14";
			this.GroupBox14.Size = new System.Drawing.Size(1056, 296);
			this.GroupBox14.TabIndex = 1;
			this.GroupBox14.TabStop = false;
			this.GroupBox14.Text = "Last 10 Resolved Trades";
			// 
			// groupBox12
			// 
			this.groupBox12.Controls.Add(this.cmbTradeItems);
			this.groupBox12.Controls.Add(this.lvTradesRelations);
			this.groupBox12.Location = new System.Drawing.Point(672, 16);
			this.groupBox12.Name = "groupBox12";
			this.groupBox12.Size = new System.Drawing.Size(376, 272);
			this.groupBox12.TabIndex = 3;
			this.groupBox12.TabStop = false;
			this.groupBox12.Text = "Relations";
			// 
			// cmbTradeItems
			// 
			this.cmbTradeItems.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbTradeItems.Location = new System.Drawing.Point(8, 24);
			this.cmbTradeItems.Name = "cmbTradeItems";
			this.cmbTradeItems.Size = new System.Drawing.Size(200, 26);
			this.cmbTradeItems.TabIndex = 1;
			this.cmbTradeItems.SelectedIndexChanged += new System.EventHandler(this.cmbTradeItems_SelectedIndexChanged);
			// 
			// lvTradesRelations
			// 
			this.lvTradesRelations.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                            this.columnHeader12,
                                                                                            this.columnHeader16,
                                                                                            this.columnHeader20,
                                                                                            this.columnHeader8});
			this.lvTradesRelations.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvTradesRelations.FullRowSelect = true;
			this.lvTradesRelations.GridLines = true;
			this.lvTradesRelations.Location = new System.Drawing.Point(8, 64);
			this.lvTradesRelations.MultiSelect = false;
			this.lvTradesRelations.Name = "lvTradesRelations";
			this.lvTradesRelations.Size = new System.Drawing.Size(360, 200);
			this.lvTradesRelations.TabIndex = 2;
			this.lvTradesRelations.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader12
			// 
			this.columnHeader12.Width = 0;
			// 
			// columnHeader16
			// 
			this.columnHeader16.Text = "Timestamp";
			this.columnHeader16.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader16.Width = 162;
			// 
			// columnHeader8
			// 
			this.columnHeader8.Text = "Name";
			this.columnHeader8.Width = 180;
			// 
			// lvTrades
			// 
			this.lvTrades.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                   this.ColumnHeader4,
                                                                                   this.ColumnHeader5,
                                                                                   this.ColumnHeader6,
                                                                                   this.ColumnHeader7});
			this.lvTrades.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvTrades.FullRowSelect = true;
			this.lvTrades.GridLines = true;
			this.lvTrades.Location = new System.Drawing.Point(8, 24);
			this.lvTrades.MultiSelect = false;
			this.lvTrades.Name = "lvTrades";
			this.lvTrades.Size = new System.Drawing.Size(656, 264);
			this.lvTrades.TabIndex = 0;
			this.lvTrades.View = System.Windows.Forms.View.Details;
			this.lvTrades.SelectedIndexChanged += new System.EventHandler(this.lvTrades_SelectedIndexChanged);
			// 
			// ColumnHeader4
			// 
			this.ColumnHeader4.Text = "";
			this.ColumnHeader4.Width = 0;
			// 
			// ColumnHeader5
			// 
			this.ColumnHeader5.Text = "Index";
			this.ColumnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader5.Width = 49;
			// 
			// ColumnHeader6
			// 
			this.ColumnHeader6.Text = "Timestamp";
			this.ColumnHeader6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader6.Width = 162;
			// 
			// ColumnHeader7
			// 
			this.ColumnHeader7.Text = "Signaled";
			this.ColumnHeader7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader7.Width = 65;
			// 
			// tpStatistics
			// 
			this.tpStatistics.Controls.Add(this.GroupBox9);
			this.tpStatistics.Controls.Add(this.GroupBox10);
			this.tpStatistics.Location = new System.Drawing.Point(4, 4);
			this.tpStatistics.Name = "tpStatistics";
			this.tpStatistics.Size = new System.Drawing.Size(1072, 755);
			this.tpStatistics.TabIndex = 2;
			this.tpStatistics.Text = "Statistics";
			// 
			// GroupBox9
			// 
			this.GroupBox9.Controls.Add(this.lvShownStatistics);
			this.GroupBox9.Controls.Add(this.btnShowStatistics);
			this.GroupBox9.Controls.Add(this.gbTimeIntervalStatistics);
			this.GroupBox9.Controls.Add(this.gbIndexIntervalStatistics);
			this.GroupBox9.Controls.Add(this.optTimeIntervalStatistics);
			this.GroupBox9.Controls.Add(this.optIndexIntervalStatistics);
			this.GroupBox9.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox9.Location = new System.Drawing.Point(8, 288);
			this.GroupBox9.Name = "GroupBox9";
			this.GroupBox9.Size = new System.Drawing.Size(1056, 424);
			this.GroupBox9.TabIndex = 1;
			this.GroupBox9.TabStop = false;
			this.GroupBox9.Text = "Statistics Filtered by Index or Time Interval";
			// 
			// lvShownStatistics
			// 
			this.lvShownStatistics.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                            this.ColumnHeader9,
                                                                                            this.ColumnHeader10,
                                                                                            this.ColumnHeader11});
			this.lvShownStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvShownStatistics.FullRowSelect = true;
			this.lvShownStatistics.GridLines = true;
			this.lvShownStatistics.Location = new System.Drawing.Point(8, 80);
			this.lvShownStatistics.MultiSelect = false;
			this.lvShownStatistics.Name = "lvShownStatistics";
			this.lvShownStatistics.Size = new System.Drawing.Size(1040, 336);
			this.lvShownStatistics.TabIndex = 4;
			this.lvShownStatistics.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader9
			// 
			this.ColumnHeader9.Text = "";
			this.ColumnHeader9.Width = 0;
			// 
			// ColumnHeader10
			// 
			this.ColumnHeader10.Text = "Index";
			this.ColumnHeader10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader10.Width = 49;
			// 
			// ColumnHeader11
			// 
			this.ColumnHeader11.Text = "Timestamp";
			this.ColumnHeader11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader11.Width = 162;
			// 
			// btnShowStatistics
			// 
			this.btnShowStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnShowStatistics.Location = new System.Drawing.Point(760, 48);
			this.btnShowStatistics.Name = "btnShowStatistics";
			this.btnShowStatistics.Size = new System.Drawing.Size(96, 24);
			this.btnShowStatistics.TabIndex = 3;
			this.btnShowStatistics.Text = "Show";
			this.btnShowStatistics.Click += new System.EventHandler(this.btnShowStatistics_Click);
			// 
			// gbTimeIntervalStatistics
			// 
			this.gbTimeIntervalStatistics.Controls.Add(this.Label31);
			this.gbTimeIntervalStatistics.Controls.Add(this.dtpEndRangeStatistics);
			this.gbTimeIntervalStatistics.Controls.Add(this.Label33);
			this.gbTimeIntervalStatistics.Controls.Add(this.dtpStartRangeStatistics);
			this.gbTimeIntervalStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbTimeIntervalStatistics.Location = new System.Drawing.Point(352, 16);
			this.gbTimeIntervalStatistics.Name = "gbTimeIntervalStatistics";
			this.gbTimeIntervalStatistics.Size = new System.Drawing.Size(400, 56);
			this.gbTimeIntervalStatistics.TabIndex = 2;
			this.gbTimeIntervalStatistics.TabStop = false;
			this.gbTimeIntervalStatistics.Text = "Time Interval";
			// 
			// Label31
			// 
			this.Label31.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label31.Location = new System.Drawing.Point(200, 24);
			this.Label31.Name = "Label31";
			this.Label31.Size = new System.Drawing.Size(48, 24);
			this.Label31.TabIndex = 73;
			this.Label31.Text = "End: ";
			this.Label31.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dtpEndRangeStatistics
			// 
			this.dtpEndRangeStatistics.CustomFormat = "dd/MM/yyyy HH:mm";
			this.dtpEndRangeStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.dtpEndRangeStatistics.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpEndRangeStatistics.Location = new System.Drawing.Point(256, 24);
			this.dtpEndRangeStatistics.Name = "dtpEndRangeStatistics";
			this.dtpEndRangeStatistics.Size = new System.Drawing.Size(128, 22);
			this.dtpEndRangeStatistics.TabIndex = 1;
			// 
			// Label33
			// 
			this.Label33.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label33.Location = new System.Drawing.Point(8, 24);
			this.Label33.Name = "Label33";
			this.Label33.Size = new System.Drawing.Size(48, 24);
			this.Label33.TabIndex = 71;
			this.Label33.Text = "Start: ";
			this.Label33.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// dtpStartRangeStatistics
			// 
			this.dtpStartRangeStatistics.CustomFormat = "dd/MM/yyyy HH:mm";
			this.dtpStartRangeStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.dtpStartRangeStatistics.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpStartRangeStatistics.Location = new System.Drawing.Point(64, 24);
			this.dtpStartRangeStatistics.Name = "dtpStartRangeStatistics";
			this.dtpStartRangeStatistics.Size = new System.Drawing.Size(128, 22);
			this.dtpStartRangeStatistics.TabIndex = 0;
			// 
			// gbIndexIntervalStatistics
			// 
			this.gbIndexIntervalStatistics.Controls.Add(this.Label35);
			this.gbIndexIntervalStatistics.Controls.Add(this.nudEndStatistics);
			this.gbIndexIntervalStatistics.Controls.Add(this.Label37);
			this.gbIndexIntervalStatistics.Controls.Add(this.nudStartStatistics);
			this.gbIndexIntervalStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.gbIndexIntervalStatistics.Location = new System.Drawing.Point(352, 16);
			this.gbIndexIntervalStatistics.Name = "gbIndexIntervalStatistics";
			this.gbIndexIntervalStatistics.Size = new System.Drawing.Size(400, 56);
			this.gbIndexIntervalStatistics.TabIndex = 3;
			this.gbIndexIntervalStatistics.TabStop = false;
			this.gbIndexIntervalStatistics.Text = "Index Interval";
			// 
			// Label35
			// 
			this.Label35.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label35.Location = new System.Drawing.Point(200, 24);
			this.Label35.Name = "Label35";
			this.Label35.Size = new System.Drawing.Size(48, 24);
			this.Label35.TabIndex = 74;
			this.Label35.Text = "End: ";
			this.Label35.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudEndStatistics
			// 
			this.nudEndStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudEndStatistics.Location = new System.Drawing.Point(256, 24);
			this.nudEndStatistics.Maximum = new System.Decimal(new int[] {
                                                                         10000000,
                                                                         0,
                                                                         0,
                                                                         0});
			this.nudEndStatistics.Minimum = new System.Decimal(new int[] {
                                                                         1,
                                                                         0,
                                                                         0,
                                                                         0});
			this.nudEndStatistics.Name = "nudEndStatistics";
			this.nudEndStatistics.Size = new System.Drawing.Size(128, 22);
			this.nudEndStatistics.TabIndex = 1;
			this.nudEndStatistics.Value = new System.Decimal(new int[] {
                                                                       1,
                                                                       0,
                                                                       0,
                                                                       0});
			// 
			// Label37
			// 
			this.Label37.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.Label37.Location = new System.Drawing.Point(8, 24);
			this.Label37.Name = "Label37";
			this.Label37.Size = new System.Drawing.Size(48, 24);
			this.Label37.TabIndex = 70;
			this.Label37.Text = "Start: ";
			this.Label37.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// nudStartStatistics
			// 
			this.nudStartStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.nudStartStatistics.Location = new System.Drawing.Point(64, 24);
			this.nudStartStatistics.Maximum = new System.Decimal(new int[] {
                                                                           10000000,
                                                                           0,
                                                                           0,
                                                                           0});
			this.nudStartStatistics.Minimum = new System.Decimal(new int[] {
                                                                           1,
                                                                           0,
                                                                           0,
                                                                           0});
			this.nudStartStatistics.Name = "nudStartStatistics";
			this.nudStartStatistics.Size = new System.Drawing.Size(128, 22);
			this.nudStartStatistics.TabIndex = 0;
			this.nudStartStatistics.Value = new System.Decimal(new int[] {
                                                                         1,
                                                                         0,
                                                                         0,
                                                                         0});
			// 
			// optTimeIntervalStatistics
			// 
			this.optTimeIntervalStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.optTimeIntervalStatistics.Location = new System.Drawing.Point(200, 48);
			this.optTimeIntervalStatistics.Name = "optTimeIntervalStatistics";
			this.optTimeIntervalStatistics.Size = new System.Drawing.Size(168, 24);
			this.optTimeIntervalStatistics.TabIndex = 1;
			this.optTimeIntervalStatistics.Text = "Show by Time Interval";
			// 
			// optIndexIntervalStatistics
			// 
			this.optIndexIntervalStatistics.Checked = true;
			this.optIndexIntervalStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.optIndexIntervalStatistics.Location = new System.Drawing.Point(200, 24);
			this.optIndexIntervalStatistics.Name = "optIndexIntervalStatistics";
			this.optIndexIntervalStatistics.Size = new System.Drawing.Size(168, 24);
			this.optIndexIntervalStatistics.TabIndex = 0;
			this.optIndexIntervalStatistics.TabStop = true;
			this.optIndexIntervalStatistics.Text = "Show by Index Interval";
			this.optIndexIntervalStatistics.CheckedChanged += new System.EventHandler(this.optIndexOrTimeIntervalStatistics_CheckedChanged);
			// 
			// GroupBox10
			// 
			this.GroupBox10.Controls.Add(this.lvStatistics);
			this.GroupBox10.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.GroupBox10.Location = new System.Drawing.Point(8, 8);
			this.GroupBox10.Name = "GroupBox10";
			this.GroupBox10.Size = new System.Drawing.Size(1056, 272);
			this.GroupBox10.TabIndex = 0;
			this.GroupBox10.TabStop = false;
			this.GroupBox10.Text = "Last 10 Resolved Statistics";
			// 
			// lvStatistics
			// 
			this.lvStatistics.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                       this.ColumnHeader13,
                                                                                       this.ColumnHeader14,
                                                                                       this.ColumnHeader15});
			this.lvStatistics.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lvStatistics.FullRowSelect = true;
			this.lvStatistics.GridLines = true;
			this.lvStatistics.Location = new System.Drawing.Point(8, 20);
			this.lvStatistics.MultiSelect = false;
			this.lvStatistics.Name = "lvStatistics";
			this.lvStatistics.Size = new System.Drawing.Size(1040, 244);
			this.lvStatistics.TabIndex = 0;
			this.lvStatistics.View = System.Windows.Forms.View.Details;
			// 
			// ColumnHeader13
			// 
			this.ColumnHeader13.Text = "";
			this.ColumnHeader13.Width = 0;
			// 
			// ColumnHeader14
			// 
			this.ColumnHeader14.Text = "Index";
			this.ColumnHeader14.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader14.Width = 49;
			// 
			// ColumnHeader15
			// 
			this.ColumnHeader15.Text = "Timestamp";
			this.ColumnHeader15.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.ColumnHeader15.Width = 162;
			// 
			// columnHeader20
			// 
			this.columnHeader20.Text = "Offset";
			this.columnHeader20.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader20.Width = 49;
			// 
			// columnHeader21
			// 
			this.columnHeader21.Text = "Offset";
			this.columnHeader21.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.columnHeader21.Width = 49;
			// 
			// frmTradingSystem
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(1078, 835);
			this.Controls.Add(this.tcTradingSystem);
			this.Controls.Add(this.PictureBox1);
			this.Controls.Add(this.lblDataConnection);
			this.Controls.Add(this.llWeb);
			this.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmTradingSystem";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TradingSystem";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmTradingSystem_Closing);
			this.Load += new System.EventHandler(this.frmTradingSystem_Load);
			this.tcTradingSystem.ResumeLayout(false);
			this.tpTradingSystem.ResumeLayout(false);
			this.GroupBox6.ResumeLayout(false);
			this.GroupBox5.ResumeLayout(false);
			this.GroupBox8.ResumeLayout(false);
			this.GroupBox7.ResumeLayout(false);
			this.GroupBox1.ResumeLayout(false);
			this.GroupBox2.ResumeLayout(false);
			this.GroupBox4.ResumeLayout(false);
			this.GroupBox3.ResumeLayout(false);
			this.tpTrades.ResumeLayout(false);
			this.GroupBox11.ResumeLayout(false);
			this.groupBox15.ResumeLayout(false);
			this.GroupBox13.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nudEndTrades)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStartTrades)).EndInit();
			this.GroupBox14.ResumeLayout(false);
			this.groupBox12.ResumeLayout(false);
			this.tpStatistics.ResumeLayout(false);
			this.GroupBox9.ResumeLayout(false);
			this.gbTimeIntervalStatistics.ResumeLayout(false);
			this.gbIndexIntervalStatistics.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nudEndStatistics)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudStartStatistics)).EndInit();
			this.GroupBox10.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// Creates a CEL object, changes its configurations, and starts up the created CEL object.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void frmTradingSystem_Load(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Creates the CQGCEL object
				CEL = new CQGCEL();
				CEL.DataConnectionStatusChanged += new CQG._ICQGCELEvents_DataConnectionStatusChangedEventHandler(CEL_DataConnectionStatusChanged);
				CEL.DataError += new CQG._ICQGCELEvents_DataErrorEventHandler(CEL_DataError);
				CEL.TradingSystemDefinitionsResolved += new CQG._ICQGCELEvents_TradingSystemDefinitionsResolvedEventHandler(CEL_TradingSystemDefinitionsResolved);
				CEL.TradingSystemResolved += new CQG._ICQGCELEvents_TradingSystemResolvedEventHandler(CEL_TradingSystemResolved);
				CEL.TradingSystemAddNotification += new CQG._ICQGCELEvents_TradingSystemAddNotificationEventHandler(CEL_TradingSystemAddNotification);
				CEL.TradingSystemUpdateNotification += new CQG._ICQGCELEvents_TradingSystemUpdateNotificationEventHandler(CEL_TradingSystemUpdateNotification);
				CEL.TradingSystemInsertNotification += new CQG._ICQGCELEvents_TradingSystemInsertNotificationEventHandler(CEL_TradingSystemInsertNotification);
				CEL.TradingSystemRemoveNotification += new CQG._ICQGCELEvents_TradingSystemRemoveNotificationEventHandler(CEL_TradingSystemRemoveNotification);
				CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff;
				CEL.APIConfiguration.CollectionsThrowException = false;
				CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral;
				CEL.APIConfiguration.GatewayEnabled = false;

				// Disables the controls
				CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown);
				// Starts up the CQGCEL
				CEL.Startup();

				cmbTradingSystem.Items.Clear();
				cmbTradingSystem.SelectedIndex = -1;

				ClearDefinitionData();
				ClearAllData();

				m_CurTradingSystem = null;
				m_CurTradingSystemDefs = null;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "frmTradingSystem_Load", ex);
				this.Close();
			}
		}

		/// <summary>
		/// Shuts down CEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A CancelEventArgs that contains the event data.
		/// </param>
		private void frmTradingSystem_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (CEL != null)
			{
				CEL.Shutdown();
			}
		}

		/// <summary>
		/// Clears all old info regarding to old TradingSystemDefinitions and requests new TradingSystemDefinitions.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnReqTradingSystemDefinitions_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				CEL.RequestTradingSystemDefinitions();
				ClearDefinitionData();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "btnReqTradingSystemDefinitions_Click", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Definition info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbDefinition_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clearing definition data
				ClearDefinitionData();
				CQGTradingSystemDefinition tradeSysDef = m_CurTradingSystemDefs.get_ItemByName(cmbDefinition.Text);

				if (tradeSysDef == null)
				{
					return;
				}

				lblAbbreviation.Text = tradeSysDef.Abbreviation;
				lblCommission.Text = GetValueAsString(tradeSysDef.Commission);
				lblCommissionType.Text = tradeSysDef.CommissionType.ToString();


				// Fill parameters to the combo list of the current definition
				cmbParameter.Items.Clear();
				foreach (CQGParameterDefinition paramDef in tradeSysDef.ParameterDefinitions)
				{
					cmbParameter.Items.Add(paramDef.Name);
				}

				if (cmbParameter.Items.Count > 0)
				{
					cmbParameter.SelectedIndex = 0;
				}
				else
				{
					ClearParameterData();
				}

				// Fill trade definitions to the combo list of the current definition
				cmbTrade.Items.Clear();
				foreach (CQGTradingSystemTradeDefinition tradeDef in tradeSysDef.TradeDefinitions)
				{
					cmbTrade.Items.Add(tradeDef.Name);
				}

				if (cmbTrade.Items.Count > 0)
				{
					cmbTrade.SelectedIndex = 0;
				}
				else
				{
					ClearTradesDefinitionData();
				}


				txtTradingSystemName.Text = cmbDefinition.Text;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbDefinition_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Parameter info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbParameter_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clearing parameter data
				ClearParameterData();

				if (cmbParameter.SelectedIndex > -1)
				{
					CQGTradingSystemDefinition tradeDef = m_CurTradingSystemDefs.get_ItemByName(cmbDefinition.Text);
					CQGParameterDefinition param = tradeDef.ParameterDefinitions.get_ItemByName(cmbParameter.Text);

					lblParameterComment.Text = param.Comment;
					lblParameterType.Text = param.Type.ToString();
					lblParameterDefaultValue.Text = param.DefaultValue.ToString();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbParameter_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Trade info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbTrade_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clearing trades data
				ClearTradesDefinitionData();

				if (cmbTrade.SelectedIndex > -1)
				{
					CQGTradingSystemDefinition tradeSysDef = m_CurTradingSystemDefs.get_ItemByName(cmbDefinition.Text);
					CQGTradingSystemTradeDefinition tradeDef = tradeSysDef.TradeDefinitions.get_ItemByName(cmbTrade.Text);

					lblTradeSide.Text = tradeDef.Side.ToString();

					// Fill trade entry definition
					lblEntryOrderType.Text = tradeDef.Entry.OrderType.ToString();
					lblEntryAllowEntryOnExit.Text = tradeDef.Entry.AllowEntryOnExit.ToString();
					lblEntryAllowPyramids.Text = tradeDef.Entry.AllowPyramids.ToString();

					// Fill trade exits definitions
					foreach (CQGTradeExitDefinition exitDef in tradeDef.Exits)
					{
						cmbExit.Items.Add(exitDef.Name);
					}

					if (cmbExit.Items.Count > 0)
					{
						cmbExit.SelectedIndex = 0;
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbTrade_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Updates values connected with the selected trade.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbTradesNames_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				if (cmbTradesNames.SelectedIndex == -1)
				{
					return;
				}

				DumpTradeItemsNames(cmbTradeItems);
				DumpTradeItemsNames(cmbShownTradeItems);

				DumpHeadersTrades(lvTrades);
				DumpHeadersTrades(lvShownTrades);

				ClearRecords(lvShownTrades);
				DumpRecordsTrades(m_CurTradingSystem.TradesRows.Count);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbTradesNames_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected Exit info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbExit_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clearing exit data
				ClearExitDefinitionData();

				if (cmbExit.SelectedIndex > -1)
				{
					// Dumping exit data
					CQGTradingSystemDefinition tradeSysDef = m_CurTradingSystemDefs.get_ItemByName(cmbDefinition.Text);
					CQGTradingSystemTradeDefinition tradeDef = tradeSysDef.TradeDefinitions.get_ItemByName(cmbTrade.Text);
					CQGTradeExitDefinition exitDef = tradeDef.Exits.get_ItemByName(cmbExit.Text);

					lblExitOrderType.Text = exitDef.OrderType.ToString();
					lblExitAllowExitOnEntry.Text = exitDef.AllowExitOnEntry.ToString();
					lblExitAllowMoreThanOnce.Text = exitDef.AllowMoreThanOnce.ToString();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbTrade_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Shows selected row trades relations
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void lvTrades_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DumpTradeItemRelations(lvTrades, lvTradesRelations, cmbTradeItems);
		}

		/// <summary>
		/// Shows selected row trades relations
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void lvShownTrades_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DumpTradeItemRelations(lvShownTrades, lvShownTradesRelations, cmbShownTradeItems);
		}

		/// <summary>
		/// Opens frmTradingSystemRequestSettings and with passed values requests TradingSystem.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRequest_Click(System.Object sender, System.EventArgs e)
		{
			CQGTradingSystem tradingSystem;

			try
			{
				// Opens the form to fill up request data
				frmTradingSystemRequestSettings frmTradingSystemReq = new frmTradingSystemRequestSettings();
				CQGTradingSystemRequest req = CEL.CreateTradingSystemRequest(txtTradingSystemName.Text);
				req.SessionsFilter = 31; // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

				frmTradingSystemReq.TradingSystemRequest = req;
				frmTradingSystemReq.LineTime = CEL.Environment.LineTime;

				// If the user confirms, request is sent to CQGCEL and added to the requests list
				if (frmTradingSystemReq.ShowDialog(this) == DialogResult.OK)
				{
					tradingSystem = CEL.RequestTradingSystem(req);

					cmbTradingSystem.Items.Add(tradingSystem.Id);
					cmbTradingSystem.SelectedIndex = cmbTradingSystem.Items.Count - 1;

					ChangeControlsStatuses();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "btnRequest_Click", ex);
			}
		}

		/// <summary>
		/// Removes the selected trading system from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemove_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Removes trading system from the collection
				CEL.RemoveTradingSystem(m_CurTradingSystem);

				// Removes TradingSystem from the combo box
				cmbTradingSystem.Items.RemoveAt(cmbTradingSystem.SelectedIndex);

				cmbTradingSystem.SelectedIndex = cmbTradingSystem.Items.Count - 1;

				if (cmbTradingSystem.Items.Count == 0)
				{
					cmbTradingSystem.SelectedIndex = -1;
					ClearAllData();
					m_CurTradingSystem = null;
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "btnRemove_Click", ex);
			}
		}

		/// <summary>
		/// Removes all trading system from the list and the CQGCEL.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnRemoveAll_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				// Clears the combo box
				cmbTradingSystem.Items.Clear();
				cmbTradingSystem.SelectedIndex = -1;

				// Removes all TradingSystem from the collection
				CEL.RemoveAllTradingSystems();

				m_CurTradingSystem = null;

				ClearAllData();

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "btnRemoveAll_Click", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected TradingSystem info.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbTradingSystem_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				if (cmbTradingSystem.SelectedIndex > -1)
				{
					// Gets the selected Trading System object from CQGCEL by it's ID
					m_CurTradingSystem = CEL.AllTradingSystems.get_ItemById(cmbTradingSystem.Text);

					ClearAllData();
					DumpAllData();

					DumpFilterInfoStatistics();
					DumpFilterInfoTrades();
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbTradingSystem_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected entry/exit relations.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbTradeItems_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				if (cmbTradeItems.SelectedIndex > -1)
				{
					DumpTradeItemRelations(lvTrades, lvTradesRelations, cmbTradeItems);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbTradeItems_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Changes to show the selected entry/exit relations.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data
		/// </param>
		private void cmbShownTradeItems_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				if (cmbShownTradeItems.SelectedIndex > -1)
				{
					DumpTradeItemRelations(lvShownTrades, lvShownTradesRelations, cmbShownTradeItems);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "cmbShownTradeItems_SelectedIndexChanged", ex);
			}
		}

		/// <summary>
		/// Shows tag value of the current TradingSystem corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagName_KeyDown(System.Object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					object tagValue = m_CurTradingSystem.get_Tag(txtTagName.Text);
					if (tagValue != null)
					{
						txtTagValue.Text = tagValue.ToString();
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "txtTagName_KeyDown", ex);
			}
		}

		/// <summary>
		/// Sets the tag value of the current TradingSystem corresponding to the entered name.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A KeyEventArgs that contains the event data.
		/// </param>
		private void txtTagValue_KeyDown(System.Object sender, System.Windows.Forms.KeyEventArgs e)
		{
			try
			{
				if (txtTagName.Text.Trim().Length == 0)
				{
					return;
				}

				if (e.KeyCode == Keys.Return)
				{
					if (txtTagName.Text.Trim().Length == 0)
					{
						return;
					}

					if (e.KeyCode == Keys.Return)
					{
						if (txtTagValue.Text.Trim().Length == 0)
						{
							m_CurTradingSystem.set_Tag(txtTagName.Text, null);
						}
						else
						{
							m_CurTradingSystem.set_Tag(txtTagName.Text, txtTagValue.Text);
						}
						txtTagName.Text = "";
						txtTagValue.Text = "";
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "txtTagValue_KeyDown", ex);
			}
		}

		/// <summary>
		/// Opens CQG API web page.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// A LinkLabelLinkClickedEventArgs that contains the event data.
		/// </param>
		private void llWeb_LinkClicked(System.Object sender, LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx");
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "llWeb_LinkClicked", ex);
			}
		}

		/// <summary>
		/// This event is fired, when some changes occur in the connection with CQG data server.
		/// </summary>
		/// <param name="newStatus">
		/// The current status of the connection with the data server.
		/// </param>
		private void CEL_DataConnectionStatusChanged(eConnectionStatus new_status)
		{
			string sInfo;
			System.Drawing.Color BackCol;

			try
			{
				if (new_status == eConnectionStatus.csConnectionUp)
				{
					BackCol = System.Drawing.Color.FromArgb(192, 209, 205);
					sInfo = "DATA Connection is UP";
				}
				else if (new_status == eConnectionStatus.csConnectionDelayed)
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Delayed";
				}
				else
				{
					BackCol = System.Drawing.Color.FromArgb(255, 114, 0);
					sInfo = "DATA Connection is Down";
				}

				lblDataConnection.BackColor = BackCol;
				lblDataConnection.Text = sInfo;

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_DataConnectionStatusChanged", ex);
			}
		}

		/// <summary>
		/// This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
		/// </summary>
		/// <param name="cqg_error">
		/// The object, in which the error has occurred.
		/// </param>
		/// <param name="error_description">
		/// The string, describing the error.
		/// </param>
		private void CEL_DataError(object cqg_error, string error_description)
		{
			try
			{
				CQGError cqgErr = cqg_error as CQGError;
				if (CEL.IsValid(cqgErr))
				{
					if (cqgErr.Code == 102)
					{
						error_description += " Restart the application.";
					}
					else if (cqgErr.Code == 125)
					{
						error_description += " Turn on CQG Client and restart the application.";
					}
				}

				MessageBox.Show(error_description, "TradingSystem", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_DataError", ex);
			}
		}

		/// <summary>
		/// Occurs when the requested trading system definitions are resolved.
		/// </summary>
		/// <param name="cqg_trading_system_definitions">
		/// Collection of trading system definitions.
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object describing last error occurred
		/// during processing request or Nothing in case of no error.
		/// </param>
		private void CEL_TradingSystemDefinitionsResolved(CQGTradingSystemDefinitions cqg_trading_system_definitions, CQGError cqg_error)
		{
			try
			{
				m_CurTradingSystemDefs = cqg_trading_system_definitions;

				if (CEL.IsValid(cqg_error))
				{
					MessageBox.Show(cqg_error.Description, "TradingSystem", MessageBoxButtons.OK, MessageBoxIcon.Information);
					return;
				}

				// Fill up new data
				cmbDefinition.Items.Clear();
				foreach (CQGTradingSystemDefinition tradeSysDef in cqg_trading_system_definitions)
				{
					cmbDefinition.Items.Add(tradeSysDef.Name);
				}

				if (cmbDefinition.Items.Count > 0)
				{
					cmbDefinition.SelectedIndex = 0;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_TradingSystemDefinitionsResolved", ex);
			}
		}

		/// <summary>
		/// Occurs when the requested trading system is resolved.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_error">
		/// CQGError object describing last error occurred
		/// during processing trading system request or Nothing
		/// in case of no error.
		/// </param>
		private void CEL_TradingSystemResolved(CQGTradingSystem cqg_trading_system, CQGError cqg_error)
		{
			try
			{
				if (cqg_trading_system.Id == m_CurTradingSystem.Id)
				{
					ClearAllData();
					DumpAllData();

					DumpFilterInfoStatistics();
					DumpFilterInfoTrades();
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_TradingSystemResolved", ex);
			}
		}

		/// <summary>
		/// Shows added Trades and Statistics for the selected request records on the appropriate listview controls.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		private void DumpTradesAndStatisticsRecords(CQGTradingSystem cqg_trading_system)
		{
			if (cqg_trading_system.Id == m_CurTradingSystem.Id)
			{
				DumpRecordsTrades(m_CurTradingSystem.TradesRows.Count);
				DumpRecordsStatistics(m_CurTradingSystem.Statistics.Count);
			}
		}

		/// <summary>
		/// Occurs when the new trading system row is added.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_trading_system_add_info">
		/// CQGTradingSystemAddInfo object containing
		/// additional info about added rows.
		/// </param>
		private void CEL_TradingSystemAddNotification(CQGTradingSystem cqg_trading_system, CQGTradingSystemAddInfo cqg_trading_system_add_info)
		{
			try
			{
				DumpTradesAndStatisticsRecords(cqg_trading_system);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_TradingSystemAddNotification", ex);
			}
		}

		/// <summary>
		/// Occurs when the trading system row is updated.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_trading_system_update_info">
		/// CQGTradingSystemUpdateInfo object containing
		/// additional info about updated rows.
		/// </param>
		private void CEL_TradingSystemUpdateNotification(CQGTradingSystem cqg_trading_system, CQGTradingSystemUpdateInfo cqg_trading_system_update_info)
		{
			try
			{
				int index;
				if (cqg_trading_system.Id == m_CurTradingSystem.Id)
				{
					index = cqg_trading_system_update_info.Index;
					if (index >= m_CurTradingSystem.TradesRows.Count - MAX_NUMBER_OF_RECORDS)
					{
						UpdateRecordTrades(lvTrades, m_CurTradingSystem.TradesRows[index], cqg_trading_system_update_info, index + 1);
						if (m_CurTradingSystem.Statistics.Count != 0)
						{
							UpdateRecordStatistics(lvStatistics, m_CurTradingSystem.Statistics[index], cqg_trading_system_update_info, index + 1);
						}
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_TradingSystemUpdateNotification", ex);
			}
		}

		/// <summary>
		/// Occurs when the trading system row is inserted.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_trading_system_insert_info">
		/// CQGTradingSystemInsertInfo object containing
		/// additional info about inserted rows.
		/// </param>
		private void CEL_TradingSystemInsertNotification(CQGTradingSystem cqg_trading_system, CQGTradingSystemInsertInfo cqg_trading_system_insert_info)
		{
			try
			{
				DumpTradesAndStatisticsRecords(cqg_trading_system);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_TradingSystemInsertNotification", ex);
			}
		}

		/// <summary>
		/// Occurs when the trading system row is removed.
		/// </summary>
		/// <param name="cqg_trading_system">
		/// The resolved CQGTradingSystem object.
		/// </param>
		/// <param name="cqg_trading_system_insert_info">
		/// CQGTradingSystemRemoveInfo object containing
		/// additional info about removed rows.
		/// </param>
		private void CEL_TradingSystemRemoveNotification(CQGTradingSystem cqg_trading_system, CQGTradingSystemRemoveInfo cqg_trading_system_remove_info)
		{
			try
			{
				DumpTradesAndStatisticsRecords(cqg_trading_system);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "CEL_TradingSystemRemoveNotification", ex);
			}
		}

		/// <summary>
		/// Enables\disables the controls, based on the connection status.
		/// </summary>
		private void ChangeControlsStatuses()
		{
			bool bIsDataConnectionUp = false;
			bool bIsTradingSystemSelected;
			bool bIsTradingSystemSucceded = false;

			try
			{
				if (CEL.IsStarted)
				{
					bIsDataConnectionUp = CEL.Environment.DataConnectionStatus == eConnectionStatus.csConnectionUp;
				}

				btnReqTradingSystemDefinitions.Enabled = bIsDataConnectionUp;
				btnRequest.Enabled = bIsDataConnectionUp;

				bIsTradingSystemSelected = m_CurTradingSystem != null;

				btnRemove.Enabled = bIsTradingSystemSelected && bIsDataConnectionUp;
				btnRemoveAll.Enabled = bIsTradingSystemSelected && bIsDataConnectionUp;

				txtTagName.Enabled = bIsTradingSystemSelected;
				txtTagValue.Enabled = bIsTradingSystemSelected;

				if (bIsTradingSystemSelected)
				{
					bIsTradingSystemSucceded = m_CurTradingSystem.Status == eRequestStatus.rsSuccess;
				}

				dtpEndRangeStatistics.Enabled = bIsTradingSystemSucceded;
				dtpStartRangeStatistics.Enabled = bIsTradingSystemSucceded;
				nudEndStatistics.Enabled = bIsTradingSystemSucceded;
				nudStartStatistics.Enabled = bIsTradingSystemSucceded;
				optIndexIntervalStatistics.Enabled = bIsTradingSystemSucceded;
				optTimeIntervalStatistics.Enabled = bIsTradingSystemSucceded;
				btnShowStatistics.Enabled = bIsTradingSystemSucceded;

				nudEndTrades.Enabled = bIsTradingSystemSucceded;
				nudStartTrades.Enabled = bIsTradingSystemSucceded;
				btnShowTrades.Enabled = bIsTradingSystemSucceded;

				optIndexOrTimeIntervalStatistics_CheckedChanged(null, null);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ChangeControlsStatuses", ex);
			}
		}

		/// <summary>
		/// Shows the selected request parameters on the listview.
		/// </summary>
		private void DumpRequestParams()
		{
			string parameterDefinitionName;
			try
			{
				CQGTradingSystemRequest req = m_CurTradingSystem.Request;

				lblRPTradingSystemDefinitionName.Text = req.Definition.Name;

				// Adding parameters to the corresponding combo list
				for (int i = 0; i <= req.Definition.ParameterDefinitions.Count - 1; i++)
				{
					parameterDefinitionName = req.Definition.ParameterDefinitions[i].Name;
					lstRPParameters.Items.Add(parameterDefinitionName + " - " + req.get_Parameter(parameterDefinitionName).ToString());
				}

				lblRPBaseExpression.Text = req.BaseExpression;
				lblRPRangeStart.Text = GetValueAsString(req.RangeStart);
				lblRPRangeEnd.Text = GetValueAsString(req.RangeEnd);
				lblRPIntradayPeriod.Text = req.IntradayPeriod.ToString();
				lblRPHistoricalPeriod.Text = req.HistoricalPeriod.ToString();
				lblRPIncludeEnd.Text = req.IncludeEnd.ToString();

				var sessionFilter = req.SessionsFilter.ToString();
				switch (sessionFilter)
				{
					case "0": sessionFilter = "Primary session only (0)"; break;
					case "31": sessionFilter = "All sessions (31)"; break;
				}
				lblRPSessionsFilter.Text = sessionFilter;
				lblRPContinuation.Text = req.Continuation.ToString();
				lblRPEqualizeCloses.Text = req.EqualizeCloses.ToString();
				lblRPDaysBeforeExpiration.Text = req.DaysBeforeExpiration.ToString();
				lblRPSessionFlags.Text = req.SessionFlags.ToString();
				lblRPSubscriptionLevel.Text = req.SubscriptionLevel.ToString();
				if (req.SubscriptionLevel == eTimeSeriesSubscriptionLevel.tslEndOfBarAndPeriod)
				{
					lblRPRecalcPeriod.Text = req.RecalcPeriod.ToString();
				}
				if (m_CurTradingSystem.LastError != null)
				{
					lblError.Text = m_CurTradingSystem.LastError.Description;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpRequestParams", ex);
			}
		}

		/// <summary>
		///  Clears all data connected to TradingSystem definitions.
		/// </summary>
		private void ClearDefinitionData()
		{
			try
			{
				// Clear definition data
				lblAbbreviation.Text = "";
				lblCommission.Text = "";
				lblCommissionType.Text = "";

				// Clear parameters
				cmbParameter.Items.Clear();
				cmbParameter.SelectedIndex = -1;
				ClearParameterData();

				// Clear trades
				cmbTrade.Items.Clear();
				cmbTrade.SelectedIndex = -1;
				ClearTradesDefinitionData();

				// Clear request input name
				txtTradingSystemName.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearDefinitionData", ex);
			}
		}

		/// <summary>
		/// Clears all data connected to parameters.
		/// </summary>
		private void ClearParameterData()
		{
			try
			{
				lblParameterComment.Text = "";
				lblParameterType.Text = "";
				lblParameterDefaultValue.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearParameterData", ex);
			}
		}

		/// <summary>
		/// Clears all data connected to trades definitions.
		/// </summary>
		private void ClearTradesDefinitionData()
		{
			try
			{
				lblTradeSide.Text = "";

				lblEntryOrderType.Text = "";
				lblEntryAllowEntryOnExit.Text = "";
				lblEntryAllowPyramids.Text = "";

				cmbExit.Items.Clear();
				cmbExit.SelectedIndex = -1;
				ClearExitDefinitionData();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearTradesDefinitionData", ex);
			}
		}

		/// <summary>
		/// Clears all data connected to trades exits definitions.
		/// </summary>
		private void ClearExitDefinitionData()
		{
			try
			{
				lblExitOrderType.Text = "";
				lblExitAllowExitOnEntry.Text = "";
				lblExitAllowMoreThanOnce.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearExitDefinitionData", ex);
			}
		}

		/// <summary>
		/// Clears the request parameters from the sheet.
		/// </summary>
		private void ClearRequestParams()
		{
			try
			{
				lblRPTradingSystemDefinitionName.Text = "";

				lstRPParameters.Items.Clear();

				lblRPBaseExpression.Text = "";
				lblRPRangeStart.Text = "";
				lblRPRangeEnd.Text = "";
				lblRPIntradayPeriod.Text = "";
				lblRPHistoricalPeriod.Text = "";
				lblRPIncludeEnd.Text = "";
				lblRPSessionsFilter.Text = "";
				lblRPContinuation.Text = "";
				lblRPEqualizeCloses.Text = "";
				lblRPDaysBeforeExpiration.Text = "";
				lblRPSessionFlags.Text = "";
				lblRPSubscriptionLevel.Text = "";
				lblRPRecalcPeriod.Text = "";

				lblError.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearRequestParams", ex);
			}
		}

		/// <summary>
		/// Clears request tags.
		/// </summary>
		private void ClearTags()
		{
			try
			{
				txtTagName.Text = "";
				txtTagValue.Text = "";
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearTags", ex);
			}
		}

		/// <summary>
		/// Clears all data connected to trading systems.
		/// </summary>
		private void ClearAllData()
		{
			try
			{
				lblStatus.Text = "";

				ClearRequestParams();
				ClearTags();

				//Statistics
				ClearHeadersStatistics(lvStatistics);
				ClearHeadersStatistics(lvShownStatistics);
				ClearRecords(lvStatistics);
				ClearRecords(lvShownStatistics);

				//Trades
				ClearTradesNames();
				ClearHeadersTrades(lvTrades);
				ClearHeadersTrades(lvShownTrades);
				ClearRecords(lvTrades);
				ClearRecords(lvShownTrades);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearAllData", ex);
			}
		}

		/// <summary>
		/// Clears trades items names combo list.
		/// </summary>
		private void ClearTradesItemsNames(ComboBox cmbItemNames)
		{
			try
			{
				cmbItemNames.Items.Clear();
				cmbItemNames.SelectedIndex = -1;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearTradesItemsNames", ex);
			}
		}

		/// <summary>
		/// Clears trades names combo list.
		/// </summary>
		private void ClearTradesNames()
		{
			try
			{
				cmbTradesNames.Items.Clear();
				cmbTradesNames.SelectedIndex = -1;

				ClearTradesItemsNames(cmbTradeItems);
				ClearTradesItemsNames(cmbShownTradeItems);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearTradesNames", ex);
			}
		}

		/// <summary>
		/// Clears headers from the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be cleared.
		/// </param>
		private void ClearHeadersStatistics(ListView lv)
		{
			try
			{
				lv.Columns.Clear();
				lv.Columns.Add("ID", 0, HorizontalAlignment.Center);
				lv.Columns.Add(INDEX_HEADER, 49, HorizontalAlignment.Center);
				lv.Columns.Add(TIMESTAMP_HEADER, 162, HorizontalAlignment.Center);
				lv.Columns.Add(TIMESTAMP_OFFSET_HEADER, 49, HorizontalAlignment.Center);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearHeadersStatistics", ex);
			}
		}

		/// <summary>
		/// Clears headers from the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be cleared.
		/// </param>
		private void ClearHeadersTrades(ListView lv)
		{
			try
			{
				lv.Columns.Clear();
				lv.Columns.Add("ID", 0, HorizontalAlignment.Center);
				lv.Columns.Add(INDEX_HEADER, 49, HorizontalAlignment.Center);
				lv.Columns.Add(TIMESTAMP_HEADER, 162, HorizontalAlignment.Center);
				lv.Columns.Add(TIMESTAMP_OFFSET_HEADER, 49, HorizontalAlignment.Center);
				lv.Columns.Add(SIGNALED_HEADER, 65, HorizontalAlignment.Center);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearHeadersTrades", ex);
			}
		}

		/// <summary>
		/// Clears records from the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview which records must be cleared.
		/// </param>
		private void ClearRecords(ListView lv)
		{
			try
			{
				lv.Items.Clear();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "ClearRecords", ex);
			}
		}

		/// <summary>
		/// Dumps all request data.
		/// </summary>
		private void DumpAllData()
		{
			try
			{
				DumpRequestParams();

				lblStatus.Text = m_CurTradingSystem.Status.ToString();

				if (m_CurTradingSystem.Status == eRequestStatus.rsSuccess)
				{
					// Statistics
					DumpHeadersStatistics(lvStatistics);
					DumpHeadersStatistics(lvShownStatistics);
					ClearRecords(lvShownStatistics);
					DumpRecordsStatistics(m_CurTradingSystem.Statistics.Count);

					//Trades
					DumpTradesNames();
					DumpHeadersTrades(lvTrades);
					DumpHeadersTrades(lvShownTrades);
					ClearRecords(lvShownTrades);
					DumpRecordsTrades(m_CurTradingSystem.TradesRows.Count);
				}

				ChangeControlsStatuses();
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpAllData", ex);
			}
		}

		/// <summary>
		/// Shows relations of the selected trade entry/exit.
		/// </summary>
		/// <param name="lvTradesRows">ListView control which row is selected</param>
		/// <param name="lvRelations">ListView control where relations should be dumped</param>
		/// <param name="cmbItemNames">ComboBox control which item is selected</param>
		private void DumpTradeItemRelations(ListView lvTradesRows, ListView lvRelations, ComboBox cmbItemNames)
		{
			try
			{
				lvRelations.Items.Clear();

				if (lvTradesRows.SelectedIndices.Count == 0)
				{
					return;
				}

				// Retrieve currently selected trade row
				int tradeRow = Int32.Parse(lvTradesRows.SelectedItems[0].SubItems[1].Text) - 1;
				CQGTradingSystemTradesRow tsTradesRow = m_CurTradingSystem.TradesRows[tradeRow];

				if (tsTradesRow == null)
				{
					// It is possible that the selected row is already removed,
					// because the filtered list is not updated
					return;
				}

				// Retrieve currently selected trade object from the row
				CQGTradingSystemTrade tsTrade = tsTradesRow.get_ItemByName(cmbTradesNames.Text);
				if (tsTrade == null)
				{
					return;
				}

				// Retrieve currently selected trade entry/exit
				int splitterIndex = cmbItemNames.Text.IndexOf(NAME_SPLITTER);

				if (splitterIndex == -1)
				{
					CQGTradeEntry tsTradeEntry = tsTrade.TradeEntry;

					foreach (CQGTradeExit exit in tsTradeEntry.RelatedExits)
					{
						ListViewItem item = lvRelations.Items.Add(new ListViewItem());
						item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(exit.Trade.Timestamp, true);
						item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(exit.Trade.TimestampOffset);
						item.SubItems.Add(RELATED_ITEM_NAME_HEADER).Text = GetValueAsString(exit.Trade.Definition.Name + NAME_SPLITTER + exit.Definition.Name);
					}
				}
				else
				{
					string exitName = cmbItemNames.Text.Substring(splitterIndex + NAME_SPLITTER.Length);
					CQGTradeExit tsTradeExit = tsTrade.TradeExits.get_ItemByName(exitName);

					foreach (CQGTradeEntry entry in tsTradeExit.RelatedEntries)
					{
						ListViewItem item = lvRelations.Items.Add(new ListViewItem());
						item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(entry.Trade.Timestamp, true);
						item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(entry.Trade.TimestampOffset);
						item.SubItems.Add(RELATED_ITEM_NAME_HEADER).Text = GetValueAsString(entry.Trade.Definition.Name);
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpTradeItemRelations", ex);
			}
		}

		/// <summary>
		/// Shows names of the selected TS trade entry/exits.
		/// </summary>
		/// <param name="cmbItemNames">ComboBox to dump the entry/exits names</param>
		private void DumpTradeItemsNames(ComboBox cmbItemNames)
		{
			try
			{
				cmbItemNames.Items.Clear();

				CQGTradingSystemTradeDefinition tsTradeDef = m_CurTradingSystem.Definition.TradeDefinitions.get_ItemByName(cmbTradesNames.Text);

				string tradeName = tsTradeDef.Name;
				cmbItemNames.Items.Add(tradeName);
				foreach (CQGTradeExitDefinition exitDef in tsTradeDef.Exits)
				{
					cmbItemNames.Items.Add(tradeName + NAME_SPLITTER + exitDef.Name);
				}

				if (cmbItemNames.Items.Count > 0)
				{
					cmbItemNames.SelectedIndex = 0;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpTradeItemsNames", ex);
			}
		}

		/// <summary>
		/// Shows names of the selected TS trades.
		/// </summary>
		private void DumpTradesNames()
		{
			try
			{
				cmbTradesNames.Items.Clear();

				foreach (CQGTradingSystemTradeDefinition tsTradeDef in m_CurTradingSystem.Definition.TradeDefinitions)
				{
					cmbTradesNames.Items.Add(tsTradeDef.Name);
				}

				if (cmbTradesNames.Items.Count > 0)
				{
					cmbTradesNames.SelectedIndex = 0;
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpTradesNames", ex);
			}
		}

		/// <summary>
		/// Shows headers for the requested TS. (Statistics)
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be dumped.
		/// </param>
		private void DumpHeadersStatistics(ListView lv)
		{
			try
			{
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageDuration))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssAverageDuration.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageLoss))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssAverageLoss.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageProfit))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssAverageProfit.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageWin))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssAverageWin.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssClosedNetProfit))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssClosedNetProfit.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecLosses))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssCurConsecLosses.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecWins))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssCurConsecWins.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurDrawDown))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssCurDrawDown.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssLinearRegression))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssLinearRegression.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxClosedDraw))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaxClosedDraw.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecLosses))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaxConsecLosses.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecWins))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaxConsecWins.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawAmount))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaxDrawAmount.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawDuration))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaxDrawDuration.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaximumLoss))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaximumLoss.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaximumWin))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssMaximumWin.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssOpenPosition))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssOpenPosition.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssPercentLong))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssPercentLong.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssPercentWinners))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssPercentWinners.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssProfitLossRatio))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssProfitLossRatio.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssProfitToMaxDraw))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssProfitToMaxDraw.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssRemoveToNeutral))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssRemoveToNeutral.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssReturnRetracement))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssReturnRetracement.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTimePercentage))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssTimePercentage.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTotalNetProfit))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssTotalNetProfit.ToString(), 120, HorizontalAlignment.Center);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTotalTradeCount))
				{
					lv.Columns.Add(eTradingSystemStatistic.tssTotalTradeCount.ToString(), 120, HorizontalAlignment.Center);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpHeadersStatistics", ex);
			}
		}

		/// <summary>
		/// Shows headers for the requested TS. (Trades)
		/// Number of exits can vary between trades.
		/// </summary>
		/// <param name="lv">
		/// Listview which headers must be dumped.
		/// </param>
		private void DumpHeadersTrades(ListView lv)
		{
			string sTempExitName;
			try
			{
				ClearHeadersTrades(lv);

				// Dump trade entry
				lv.Columns.Add(ISACTIVE_HEADER, 120, HorizontalAlignment.Center);
				lv.Columns.Add(SIGNAL_HEADER + ENTRY_HEADER, 120, HorizontalAlignment.Center);
				lv.Columns.Add(CAN_PLACE_ORDER_SIGNAL + ENTRY_HEADER, 120, HorizontalAlignment.Center);
				lv.Columns.Add(PRICE_HEADER + ENTRY_HEADER, 120, HorizontalAlignment.Center);
				lv.Columns.Add(QUANTITY_HEADER + ENTRY_HEADER, 120, HorizontalAlignment.Center);
				lv.Columns.Add(STOP_LIMIT_PRICE_HEADER + ENTRY_HEADER, 120, HorizontalAlignment.Center);

				// Dump trade exits
				CQGTradingSystemTradeDefinition tsTradeDef = m_CurTradingSystem.Definition.TradeDefinitions.get_ItemByName(cmbTradesNames.Text);
				if (tsTradeDef != null)
				{
					for (int i = 0; i <= tsTradeDef.Exits.Count - 1; i++)
					{
						sTempExitName = EXIT_HEADER + " (" + tsTradeDef.Exits[i].Name + ")";
						lv.Columns.Add(SIGNAL_HEADER + sTempExitName, 120, HorizontalAlignment.Center);
						lv.Columns.Add(CAN_PLACE_ORDER_SIGNAL + sTempExitName, 120, HorizontalAlignment.Center);
						lv.Columns.Add(PRICE_HEADER + sTempExitName, 120, HorizontalAlignment.Center);
						lv.Columns.Add(QUANTITY_HEADER + sTempExitName, 120, HorizontalAlignment.Center);
						lv.Columns.Add(STOP_LIMIT_PRICE_HEADER + sTempExitName, 120, HorizontalAlignment.Center);
					}
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpHeadersTrades", ex);
			}
		}

		/// <summary>
		/// Shows added Statistics for the selected request records on the listview.
		/// </summary>
		/// <param name="addedStatisticsCount">
		/// Count of Statistics that will be shown.
		/// </param>
		private void DumpRecordsStatistics(int addedStatisticsCount)
		{
			try
			{
				// Clears all records
				ClearRecords(lvStatistics);

				CQGTradingSystemStatisticsCollection tsStatistics = m_CurTradingSystem.Statistics;

				if (tsStatistics.Count == 0)
				{
					return;
				}

				if (addedStatisticsCount == tsStatistics.Count)
				{
					addedStatisticsCount = System.Convert.ToInt32(addedStatisticsCount >= MAX_NUMBER_OF_RECORDS ? MAX_NUMBER_OF_RECORDS : tsStatistics.Count);
				}
				for (int i = tsStatistics.Count - 1; i >= tsStatistics.Count - addedStatisticsCount; i--)
				{
					DumpRecordStatistics(lvStatistics, tsStatistics[i], i + 1);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpRecordsStatistics", ex);
			}
		}

		/// <summary>
		/// Shows added Trades for the selected request records on the listview.
		/// </summary>
		/// <param name="addedTradesCount">
		/// Count of Trades that will be shown.
		/// </param>
		private void DumpRecordsTrades(int addedTradesCount)
		{
			try
			{
				// Clears all records
				ClearRecords(lvTrades);

				CQGTradingSystemTradesRows tsTradesRows = m_CurTradingSystem.TradesRows;

				if (tsTradesRows.Count == 0)
				{
					return;
				}

				if (addedTradesCount == tsTradesRows.Count)
				{
					addedTradesCount = System.Convert.ToInt32(addedTradesCount >= MAX_NUMBER_OF_RECORDS ? MAX_NUMBER_OF_RECORDS : tsTradesRows.Count);
				}
				for (int i = tsTradesRows.Count - 1; i >= tsTradesRows.Count - addedTradesCount; i--)
				{
					DumpRecordTrades(lvTrades, tsTradesRows[i], i + 1);
				}

				DumpTradeItemRelations(lvTrades, lvTradesRelations, cmbTradeItems);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpRecordsTrades", ex);
			}
		}

		/// <summary>
		/// Initializes the filter-related controls.
		/// </summary>
		private void DumpFilterInfoStatistics()
		{
			try
			{
				if (m_CurTradingSystem != null && m_CurTradingSystem.Status == eRequestStatus.rsSuccess &&
				   m_CurTradingSystem.Statistics.Count > 0)
				{
					dtpStartRangeStatistics.Value = m_CurTradingSystem.Statistics[0].Timestamp;
					dtpEndRangeStatistics.Value = m_CurTradingSystem.Statistics[m_CurTradingSystem.Statistics.Count - 1].Timestamp;
				}
				else
				{
					dtpStartRangeStatistics.Value = DateTime.Now;
					dtpEndRangeStatistics.Value = DateTime.Now;
				}
				nudStartStatistics.Value = 1;
				nudEndStatistics.Value = 10;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpFilterInfoStatistics", ex);
			}
		}

		/// <summary>
		/// Initializes the filter-related controls.
		/// </summary>
		private void DumpFilterInfoTrades()
		{
			try
			{
				nudStartTrades.Value = 1;
				nudEndTrades.Value = 10;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpFilterInfoTrades", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="tsStatistics">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void DumpRecordStatistics(ListView lv, CQGTradingSystemStatistics tsStatistics, long recordIndex)
		{
			try
			{
				ListViewItem item = lv.Items.Add(new ListViewItem());
				item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString();
				item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tsStatistics.Timestamp, true);
				item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tsStatistics.TimestampOffset);
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageDuration))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageDuration.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageDuration]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageLoss))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageLoss.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageLoss]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageProfit))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageProfit.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageProfit]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageWin))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageWin.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageWin]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssClosedNetProfit))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssClosedNetProfit.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssClosedNetProfit]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecLosses))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssCurConsecLosses.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssCurConsecLosses]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecWins))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssCurConsecWins.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssCurConsecWins]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurDrawDown))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssCurDrawDown.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssCurDrawDown]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssLinearRegression))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssLinearRegression.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssLinearRegression]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxClosedDraw))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxClosedDraw.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxClosedDraw]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecLosses))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecLosses.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxConsecLosses]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecWins))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecWins.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxConsecWins]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawAmount))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawAmount.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxDrawAmount]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawDuration))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawDuration.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxDrawDuration]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaximumLoss))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaximumLoss.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaximumLoss]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaximumWin))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaximumWin.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaximumWin]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssOpenPosition))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssOpenPosition.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssOpenPosition]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssPercentLong))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssPercentLong.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssPercentLong]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssPercentWinners))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssPercentWinners.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssPercentWinners]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssProfitLossRatio))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssProfitLossRatio.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssProfitLossRatio]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssProfitToMaxDraw))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssProfitToMaxDraw.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssProfitToMaxDraw]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssRemoveToNeutral))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssRemoveToNeutral.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssRemoveToNeutral]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssReturnRetracement))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssReturnRetracement.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssReturnRetracement]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTimePercentage))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssTimePercentage.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssTimePercentage]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTotalNetProfit))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssTotalNetProfit.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssTotalNetProfit]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTotalTradeCount))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssTotalTradeCount.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssTotalTradeCount]);
				}
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpRecordStatistics", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="tsTradesRow">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void DumpRecordTrades(ListView lv, CQGTradingSystemTradesRow tsTradesRow, long recordIndex)
		{
			try
			{
				ListViewItem item = CreateListViewItem(tsTradesRow, cmbTradesNames.Text, recordIndex);
				lv.Items.Add(item);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "DumpRecordTrades", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="tsStatistics">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="tsUpdateInfo">
		/// CQGTradingSystemUpdateInfo object containing
		/// additional info about updated rows.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void UpdateRecordStatistics(ListView lv, CQGTradingSystemStatistics tsStatistics, ICQGTradingSystemUpdateInfo tsUpdateInfo, int recordIndex)
		{
			try
			{
				ListViewItem item = new ListViewItem();
				item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString();
				item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tsStatistics.Timestamp, true);
				item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tsStatistics.TimestampOffset);
				// tsUpdateInfo - can be used to get only changed statistics.
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageDuration))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageDuration.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageDuration]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageLoss))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageLoss.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageLoss]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageProfit))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageProfit.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageProfit]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssAverageWin))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssAverageWin.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssAverageWin]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssClosedNetProfit))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssClosedNetProfit.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssClosedNetProfit]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecLosses))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssCurConsecLosses.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssCurConsecLosses]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurConsecWins))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssCurConsecWins.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssCurConsecWins]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssCurDrawDown))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssCurDrawDown.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssCurDrawDown]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssLinearRegression))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssLinearRegression.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssLinearRegression]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxClosedDraw))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxClosedDraw.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxClosedDraw]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecLosses))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecLosses.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxConsecLosses]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxConsecWins))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxConsecWins.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxConsecWins]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawAmount))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawAmount.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxDrawAmount]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaxDrawDuration))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaxDrawDuration.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaxDrawDuration]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaximumLoss))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaximumLoss.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaximumLoss]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssMaximumWin))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssMaximumWin.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssMaximumWin]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssOpenPosition))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssOpenPosition.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssOpenPosition]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssPercentLong))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssPercentLong.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssPercentLong]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssPercentWinners))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssPercentWinners.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssPercentWinners]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssProfitLossRatio))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssProfitLossRatio.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssProfitLossRatio]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssProfitToMaxDraw))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssProfitToMaxDraw.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssProfitToMaxDraw]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssRemoveToNeutral))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssRemoveToNeutral.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssRemoveToNeutral]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssReturnRetracement))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssReturnRetracement.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssReturnRetracement]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTimePercentage))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssTimePercentage.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssTimePercentage]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTotalNetProfit))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssTotalNetProfit.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssTotalNetProfit]);
				}
				if (m_CurTradingSystem.Request.IsStatisticIncluded(eTradingSystemStatistic.tssTotalTradeCount))
				{
					item.SubItems.Add(eTradingSystemStatistic.tssTotalTradeCount.ToString()).Text = GetValueAsString(tsStatistics[eTradingSystemStatistic.tssTotalTradeCount]);
				}
				lv.Items[m_CurTradingSystem.Statistics.Count - recordIndex] = item;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "UpdateRecordStatistics", ex);
			}
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="tsTradesRow">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="tradeName">
		/// Trade name, which values must be shown.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private ListViewItem CreateListViewItem(CQGTradingSystemTradesRow tsTradesRow, string tradeName, long recordIndex)
		{
			ListViewItem item = new ListViewItem();
			item.SubItems.Add(INDEX_HEADER).Text = recordIndex.ToString();
			item.SubItems.Add(TIMESTAMP_HEADER).Text = GetValueAsString(tsTradesRow.Timestamp, true);
			item.SubItems.Add(TIMESTAMP_OFFSET_HEADER).Text = GetValueAsString(tsTradesRow.TimestampOffset);

			// Retrieve currently selected trade object from the row
			CQGTradingSystemTrade tsTrade = tsTradesRow.get_ItemByName(tradeName);
			if (tsTrade == null)
			{
				return item;
			}

			item.SubItems.Add(SIGNALED_HEADER).Text = HasSignaledEntryExitByTrade(tsTrade);

			// Dump trade entry
			CQGTradeEntry tsTradeEntry = tsTrade.TradeEntry;

			item.SubItems.Add(ISACTIVE_HEADER).Text = GetValueAsString(tsTrade.IsActive);
			item.SubItems.Add(SIGNAL_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.Signal);
			item.SubItems.Add(CAN_PLACE_ORDER_SIGNAL + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.CanPlaceOrderSignal);
			item.SubItems.Add(PRICE_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.Price);
			item.SubItems.Add(QUANTITY_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.Quantity);
			item.SubItems.Add(STOP_LIMIT_PRICE_HEADER + ENTRY_HEADER).Text = GetValueAsString(tsTradeEntry.StopLimitPrice);

			// Dump trade exits
			CQGTradeExitDefinitions tsTradeExitsDef = tsTrade.Definition.Exits;
			for (int i = 0; i <= tsTradeExitsDef.Count - 1; i++)
			{
				CQGTradeExit tsTradeExit = tsTrade.TradeExits.get_ItemByName(tsTradeExitsDef[i].Name);

				string sTempExitName = EXIT_HEADER + " (" + tsTradeExitsDef[i].Name + ")";
				item.SubItems.Add(SIGNAL_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.Signal);
				item.SubItems.Add(CAN_PLACE_ORDER_SIGNAL + sTempExitName).Text = GetValueAsString(tsTradeExit.CanPlaceOrderSignal);
				item.SubItems.Add(PRICE_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.Price);
				item.SubItems.Add(QUANTITY_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.Quantity);
				item.SubItems.Add(STOP_LIMIT_PRICE_HEADER + sTempExitName).Text = GetValueAsString(tsTradeExit.StopLimitPrice);
			}

			return item;
		}

		/// <summary>
		/// Dumps one record's values to the listview.
		/// </summary>
		/// <param name="lv">
		/// Listview, in which data must be shown.
		/// </param>
		/// <param name="tsTradesRow">
		/// Record, which values must be shown.
		/// </param>
		/// <param name="tsUpdateInfo">
		/// CQGTradingSystemUpdateInfo object containing
		/// additional info about updated rows.
		/// </param>
		/// <param name="recordIndex">
		/// Index of record, which values must be shown.
		/// </param>
		private void UpdateRecordTrades(ListView lv, CQGTradingSystemTradesRow tsTradesRow, ICQGTradingSystemUpdateInfo tsUpdateInfo, int recordIndex)
		{
			try
			{
				ListViewItem item = CreateListViewItem(tsTradesRow, cmbTradesNames.Text, recordIndex);

				lv.Items[m_CurTradingSystem.TradesRows.Count - recordIndex] = item;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "UpdateRecordTrades", ex);
			}
		}

		/// <summary>
		/// Changes the visibility of groupboxes.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void optIndexOrTimeIntervalStatistics_CheckedChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				gbIndexIntervalStatistics.Visible = optIndexIntervalStatistics.Checked;
				gbTimeIntervalStatistics.Visible = optTimeIntervalStatistics.Checked;
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "optIndexOrTimeInterval_CheckedChanged", ex);
			}
		}

		/// <summary>
		/// Shows few data from the selected Statistics collection.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnShowStatistics_Click(System.Object sender, System.EventArgs e)
		{
			int iStart;
			int iEnd;
			DateTime dStart;
			DateTime dEnd;

			try
			{
				lvShownStatistics.Items.Clear();

				if (optIndexIntervalStatistics.Checked)
				{
					iStart = System.Convert.ToInt32(nudStartStatistics.Value) - 1;
					iEnd = System.Convert.ToInt32(nudEndStatistics.Value) - 1;
					if (iStart > iEnd || iEnd > m_CurTradingSystem.Statistics.Count - 1 || iEnd - iStart >= MAX_INDEX_INTERVAL)
					{
						MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " records," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						return;
					}
				}
				else
				{
					// To get time with 00 seconds
					dStart = dtpStartRangeStatistics.Value.AddSeconds(-dtpStartRangeStatistics.Value.Second);
					dEnd = dtpEndRangeStatistics.Value.AddSeconds(-dtpEndRangeStatistics.Value.Second);
					iStart = m_CurTradingSystem.Statistics.IndexForDate(dStart);
					iEnd = m_CurTradingSystem.Statistics.IndexForDate(dEnd);
					if (!(CEL.IsValid(iStart) && CEL.IsValid(iEnd)) || dStart > dEnd || iEnd - iStart >= MAX_INDEX_INTERVAL)
					{
						MessageBox.Show("The start time must be earlier than the end time and their" + Environment.NewLine + "range must indicate to no more than " + MAX_INDEX_INTERVAL + " records.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						return;
					}
				}

				lvShownStatistics.SuspendLayout();
				for (int i = iEnd; i >= iStart; i--)
				{
					DumpRecordStatistics(lvShownStatistics, m_CurTradingSystem.Statistics[i], i + 1);
				}
				lvShownStatistics.ResumeLayout(false);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "btnShowStatistics_Click", ex);
			}
		}

		/// <summary>
		/// Shows few data from the selected Trades collection.
		/// </summary>
		/// <param name="sender">
		/// The source of the event.
		/// </param>
		/// <param name="e">
		/// An EventArgs that contains the event data.
		/// </param>
		private void btnShowTrades_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				lvShownTrades.Items.Clear();

				int iStart = System.Convert.ToInt32(nudStartTrades.Value) - 1;
				int iEnd = System.Convert.ToInt32(nudEndTrades.Value) - 1;
				if (iStart > iEnd || iEnd > m_CurTradingSystem.TradesRows.Count - 1 || iEnd - iStart >= MAX_INDEX_INTERVAL)
				{
					MessageBox.Show("The start index must be smaller than the end index," + Environment.NewLine + "their range must indicate to no more than " + MAX_INDEX_INTERVAL + " records," + Environment.NewLine + "and no more than the returned records count.", "Incorrect range", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					return;
				}


				lvShownTrades.SuspendLayout();
				for (int i = iEnd; i >= iStart; i--)
				{
					DumpRecordTrades(lvShownTrades, m_CurTradingSystem.TradesRows[i], i + 1);
				}
				lvShownTrades.ResumeLayout(false);
			}
			catch (Exception ex)
			{
				modErrorHandler.ShowError("frmTradingSystem", "btnShowTrades_Click", ex);
			}
		}

		/// <summary>
		/// Returns flag indicating whether any of the entry\exits was signaled by trade.
		/// </summary>
		/// <param name="tsTrade">
		/// CQGTradingSystemTrade object reference.
		/// </param>
		/// <returns>
		/// "Yes" if there was a signaled entry or exit, "No" otherwise.
		/// </returns>
		private string HasSignaledEntryExitByTrade(CQGTradingSystemTrade tsTrade)
		{
			string sResult = "No";

			if (tsTrade.TradeEntry.Signal)
			{
				sResult = "Yes";
			}
			else
			{
				for (int i = 0; i <= tsTrade.TradeExits.Count - 1; i++)
				{
					if (tsTrade.TradeExits[i].Signal)
					{
						sResult = "Yes";
						break;
					}
				}
			}

			return sResult;
		}

		/// <summary>
		/// Validates the specified value and converts it to string.
		/// </summary>
		/// <param name="val">
		/// The value that will be validated and converted
		/// </param>
		/// <param name="includeMilliseconds">
		/// Whether to include seconds and milliseconds to string, valid only for DateTime
		/// </param>
		/// <returns>
		/// Value converted to string or "N/A" if the value is invalid.
		/// </returns>
		private string GetValueAsString(object val, bool includeMilliseconds = false)
		{
			string sResult = "";

			try
			{
				if (CEL.IsValid(val))
				{
					if (val.GetType().FullName == "System.DateTime")
					{
						string format = includeMilliseconds ? "dd/MM/yyyy HH:mm:ss.fff" : "dd/MM/yyyy HH:mm";
						sResult = System.Convert.ToDateTime(val).ToString(format);
					}
					else if (val.GetType().FullName == "System.Double")
					{
						sResult = Math.Round(System.Convert.ToDouble(val), 2).ToString();
					}
					else
					{
						sResult = val.ToString();
					}
				}
				else
				{
					sResult = N_A;
				}
			}
			catch
			{
				sResult = N_A;
			}

			return sResult;
		}
	}
}
